package autovote.jdpa;

import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.sun.jdi.ReferenceType;
import com.sun.jdi.VirtualMachine;
import com.sun.jdi.event.ClassPrepareEvent;
import com.sun.jdi.event.Event;
import com.sun.jdi.event.EventQueue;
import com.sun.jdi.event.EventSet;
import com.sun.jdi.event.VMDeathEvent;
import com.sun.jdi.event.VMDisconnectEvent;
import com.sun.jdi.request.ClassPrepareRequest;
import com.sun.jdi.request.EventRequestManager;

public class Injector {

	Map<String, String> injections;
	{
		injections = new HashMap<String, String>();
		injections.put("com.scytl.pnyx.client.state.automaton.UnauthenticatedState",
				"./UnauthenticatedState.class");
		injections.put("com.scytl.pnyx.client.state.automaton.HasBallotState",
				"./HasBallotState.class");
		injections.put("com.scytl.pnyx.client.communication.application.MessagesProtocol",
				"./MessagesProtocol.class");
	}

	public void run() throws Exception {
		VirtualMachine vm = new VMAcquirer().connect(6666);
		System.out.println("Connected.");
		for (String clazz : injections.keySet()) {
			List<ReferenceType> referenceTypes = vm.classesByName(clazz);
			for (ReferenceType refType : referenceTypes) {
				hotcodeReplace(vm, refType, loadBytecode(injections.get(clazz)));
			}
			addClassWatch(vm, clazz);
		}
		vm.resume();
		EventQueue eventQueue = vm.eventQueue();
		while (true) {
			EventSet evSet = eventQueue.remove();
			for (Event ev : evSet) {
				if (ev instanceof ClassPrepareEvent) {
					ClassPrepareEvent classPrepEvent = (ClassPrepareEvent) ev;
					ReferenceType refType = classPrepEvent.referenceType();
					hotcodeReplace(vm, refType,
							loadBytecode(injections.get(refType.name())));
				} else if (ev instanceof VMDeathEvent
						|| ev instanceof VMDisconnectEvent) {
					return;
				}
			}
			evSet.resume();
		}
	}

	private static void hotcodeReplace(VirtualMachine vm,
			ReferenceType refType, byte[] bytecode) throws IOException {
		Map<ReferenceType, byte[]> hotcodeReplace = new HashMap<ReferenceType, byte[]>();
		hotcodeReplace.put(refType, bytecode);
		vm.redefineClasses(hotcodeReplace);
		System.out.println("Injected " + refType.name());
	}

	private static void addClassWatch(VirtualMachine vm, String className) {
		EventRequestManager erm = vm.eventRequestManager();
		ClassPrepareRequest classPrepareRequest = erm
				.createClassPrepareRequest();
		classPrepareRequest.addClassFilter(className);
		classPrepareRequest.setEnabled(true);
	}

	private byte[] loadBytecode(String bytecodeFile) throws IOException {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		InputStream in = getClass().getResourceAsStream(bytecodeFile);
		if (in == null)
			in = new FileInputStream("bin2/" + bytecodeFile);
		byte[] buf = new byte[1024];
		while (true) {
			int len = in.read(buf);
			if (len == -1)
				break;
			out.write(buf, 0, len);
		}
		in.close();
		out.close();
		return out.toByteArray();
	}
}
