package autovote.jdpa;

import java.io.IOException;
import java.util.Map;

import com.sun.jdi.Bootstrap;
import com.sun.jdi.VirtualMachine;
import com.sun.jdi.VirtualMachineManager;
import com.sun.jdi.connect.AttachingConnector;
import com.sun.jdi.connect.Connector;
import com.sun.jdi.connect.IllegalConnectorArgumentsException;

public class VMAcquirer {

	public VirtualMachine connect(int port) throws IOException,
			IllegalConnectorArgumentsException {
		String strPort = Integer.toString(port);
		AttachingConnector connector = getConnector();
		VirtualMachine vm = connect(connector, strPort);
		return vm;
	}

	private AttachingConnector getConnector() {
		VirtualMachineManager vmManager = Bootstrap.virtualMachineManager();
		for (Connector connector : vmManager.attachingConnectors()) {
			System.out.println(connector.name());
			if ("com.sun.jdi.SocketAttach".equals(connector.name())) {
				return (AttachingConnector) connector;
			}
		}
		throw new IllegalStateException();
	}

	private VirtualMachine connect(AttachingConnector connector, String port)
			throws IllegalConnectorArgumentsException, IOException {
		Map<String, Connector.Argument> args = connector.defaultArguments();
		Connector.Argument arg = args.get("port");
		if (arg == null)
			throw new IllegalStateException();
		arg.setValue(port);
		return connector.attach(args);
	}

}