/*     */ package com.scytl;
/*     */ 
/*     */ import java.applet.Applet;
/*     */ import java.awt.Component;
/*     */ import java.awt.Dimension;
/*     */ import java.awt.GraphicsEnvironment;
/*     */ import java.awt.Image;
/*     */ import java.awt.Point;
/*     */ import java.awt.Toolkit;
/*     */ import java.io.IOException;
/*     */ import java.util.HashMap;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.ResourceBundle;
/*     */ import javax.swing.JFrame;
/*     */ import javax.swing.SwingUtilities;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.slf4j.LoggerFactory;
/*     */ import thinlet.Thinlet;
/*     */ 
/*     */ public abstract class ExtendedThinlet<A extends Applet> extends Thinlet
/*     */   implements ComponentMonitor
/*     */ {
/*     */   public static final String WIDGET_TEXT_AREA = "textarea";
/*     */   public static final String WIDGET_TEXT_FIELD = "textfield";
/*     */   public static final String WIDGET_PASSWORD_FIELD = "passwordfield";
/*     */   public static final String WIDGET_LABEL = "label";
/*     */   public static final String WIDGET_CHOICE = "choice";
/*     */   public static final String WIDGET_TAB = "tab";
/*     */   public static final String WIDGET_COMBOBOX = "combobox";
/*     */   public static final String WIDGET_TABBEDPANE = "tabbedpane";
/*     */   public static final String PROPERTY_TEXT = "text";
/*     */   public static final String PROPERTY_NAME = "name";
/*     */   public static final String PROPERTY_SELECTED = "selected";
/*     */   public static final String PROPERTY_VISIBLE = "visible";
/*     */   public static final String PROPERTY_ENABLED = "enabled";
/*     */   public static final String PROPERTY_START = "start";
/*     */   public static final String PROPERTY_END = "end";
/*     */   public static final String PROPERTY_WIDTH = "width";
/*     */   protected A _applet;
/* 144 */   private static ComponentMonitor _logger$54f09f98 = LoggerFactory.getLogger$4ecaad6a(ExtendedThinlet.class);
/*     */   private ResourceBundle _resourceBundle;
/*     */   private JFrame _frame;
/*     */   private Image _image;
/*     */   public static final String APPLICATION_NAME = "application.name";
/*     */ 
/*     */   public ExtendedThinlet(A applet)
/*     */   {
/* 161 */     this._applet = applet;
/*     */   }
/*     */ 
/*     */   public void displayError(String errorMessage)
/*     */   {
/* 178 */     _logger$54f09f98.error(errorMessage);
/* 179 */     setString(find("errorMessage"), "text", errorMessage);
/*     */   }
/*     */ 
/*     */   public void displayError(String errorMessage, Throwable t)
/*     */   {
/* 196 */     displayError(errorMessage);
/* 197 */     _logger$54f09f98.error(errorMessage, t);
/*     */   }
/*     */ 
/*     */   public void clearError()
/*     */   {
/* 212 */     setString(find("errorMessage"), "text", " ");
/*     */   }
/*     */ 
/*     */   public void displayWarning(String warningMessage)
/*     */   {
/* 229 */     _logger$54f09f98.debug(warningMessage);
/*     */     Object warningField;
/* 231 */     if ((
/* 231 */       warningField = find("warningMessage")) != null)
/*     */     {
/* 232 */       setBoolean(warningField, "visible", true);
/* 233 */       setString(warningField, "text", warningMessage);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void displayWarning(String warningMessage, Throwable t)
/*     */   {
/* 252 */     displayWarning(warningMessage);
/* 253 */     _logger$54f09f98.debug(warningMessage, t);
/*     */   }
/*     */ 
/*     */   public void clearWarning()
/*     */   {
/*     */     Object warningField;
/* 269 */     if ((
/* 269 */       warningField = find("warningMessage")) != null)
/*     */     {
/* 270 */       setBoolean(warningField, "visible", false);
/* 271 */       setString(warningField, "text", " ");
/*     */     }
/*     */   }
/*     */ 
/*     */   public void renderView()
/*     */   {
/* 282 */     this._frame.add(this);
/* 283 */     this._frame.setResizable(false);
/* 284 */     this._frame.pack();
/* 285 */     JFrame localJFrame = this._frame; Object localObject = this; Point localPoint = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint(); localObject = ((ExtendedThinlet)localObject).getSize(); localObject = new Point(localPoint.x - (int)((Dimension)localObject).getWidth() / 2, localPoint.y - (int)((Dimension)localObject).getHeight() / 2); localJFrame.setLocation((Point)localObject);
/* 286 */     this._frame.setVisible(true);
/*     */   }
/*     */ 
/*     */   public void setResourceBundle(ResourceBundle resourceBundle)
/*     */   {
/* 293 */     super.setResourceBundle(resourceBundle);
/* 294 */     this._resourceBundle = resourceBundle;
/*     */   }
/*     */ 
/*     */   public Locale getLocale()
/*     */   {
/* 299 */     return this._applet.getLocale();
/*     */   }
/*     */ 
/*     */   public void setLocale(Locale locale)
/*     */   {
/* 304 */     this._applet.setLocale(locale);
/*     */   }
/*     */ 
/*     */   public void setImage(Image image) {
/* 308 */     this._image = image;
/*     */   }
/*     */ 
/*     */   protected void init()
/*     */   {
/* 317 */     setResourceBundle(this._resourceBundle);
/*     */ 
/* 326 */     this._frame = new JFrame(this._resourceBundle.getString("application.name"));
/* 327 */     this._frame.setDefaultCloseOperation(0);
/*     */ 
/* 329 */     if (this._image != null)
/* 330 */       this._frame.setIconImage(this._image);
/*     */     try
/*     */     {
/* 333 */       add(parse(getCurrentView()));
/*     */     } catch (IOException localIOException) {
/* 335 */       _logger$54f09f98.error("View could not be parsed" + getCurrentView(), localIOException);
/*     */     }
/*     */ 
/* 339 */     setInitialFocus();
/*     */   }
/*     */ 
/*     */   protected boolean setInitialFocus()
/*     */   {
/* 349 */     return false;
/*     */   }
/*     */ 
/*     */   public void dispose()
/*     */   {
/* 372 */     removeAll();
/*     */ 
/* 377 */     if (this._frame != null)
/* 378 */       this._frame.dispose();
/*     */   }
/*     */ 
/*     */   public void show(String key, Object value)
/*     */   {
/* 383 */     show(new HashMap(key, value)
/*     */     {
/*     */     });
/*     */   }
/*     */ 
/*     */   public void show(Map<String, ? extends Object> data)
/*     */   {
/* 397 */     SwingUtilities.invokeLater(new Runnable(data) {
/*     */       public final void run() {
/* 399 */         ExtendedThinlet.this.dispose();
/* 400 */         ExtendedThinlet.this.init();
/* 401 */         ExtendedThinlet.this.mergeAttributes(this.val$data);
/* 402 */         ExtendedThinlet.this.renderView();
/*     */       } } );
/*     */   }
/*     */ 
/*     */   public void refresh() {
/* 408 */     SwingUtilities.invokeLater(new Runnable() {
/*     */       public final void run() {
/* 410 */         ExtendedThinlet.this.dispose();
/* 411 */         Map data = ExtendedThinlet.access$000(ExtendedThinlet.this);
/* 412 */         ExtendedThinlet.this.init();
/* 413 */         ExtendedThinlet.this.mergeStringAttributes(data);
/* 414 */         ExtendedThinlet.this.renderView();
/*     */       }
/*     */     });
/*     */   }
/*     */ 
/*     */   public boolean getCapsLockState()
/*     */   {
/* 427 */     this = 0;
/*     */     try
/*     */     {
/*     */       boolean state;
/*     */       Toolkit tk;
/* 430 */       this = (
/* 430 */         tk = Toolkit.getDefaultToolkit())
/* 430 */         .getLockingKeyState(20);
/*     */     }
/*     */     catch (UnsupportedOperationException localUnsupportedOperationException1)
/*     */     {
/*     */       UnsupportedOperationException uoe;
/* 432 */       _logger$54f09f98.warn("The host system doesn't allow getting the state of caps lock programmatically");
/*     */     }
/*     */ 
/* 435 */     return this;
/*     */   }
/*     */ 
/*     */   protected final ResourceBundle getResourceBundle()
/*     */   {
/* 447 */     return this._resourceBundle;
/*     */   }
/*     */ 
/*     */   protected abstract String getCurrentView();
/*     */ 
/*     */   protected String[] getUserInputData()
/*     */   {
/* 464 */     return new String[0];
/*     */   }
/*     */ 
/*     */   public Object find(String name)
/*     */   {
/*     */     String name;
/* 475 */     if ((
/* 475 */       component = super.find(name)) == null)
/*     */     {
/* 476 */       _logger$54f09f98.debug("Cannot find a field with name : " + name);
/* 477 */       return null;
/*     */     }
/* 479 */     return component;
/*     */   }
/*     */ 
/*     */   public Dimension getSize()
/*     */   {
/* 484 */     return getPreferredSize();
/*     */   }
/*     */ 
/*     */   public boolean isTextInputField(Object paramObject)
/*     */   {
/* 498 */     return ((
/* 498 */       this = getClass(paramObject)) != null) && 
/* 498 */       (("textfield".equals(this)) || ("textarea".equals(this)) || ("passwordfield".equals(this)));
/*     */   }
/*     */ 
/*     */   public boolean isLabel(Object paramObject)
/*     */   {
/* 506 */     if ((
/* 506 */       this = getClass(paramObject)) == null)
/* 506 */       return false; return "label".equals(this);
/*     */   }
/*     */ 
/*     */   public boolean isSingleChoice(Object paramObject)
/*     */   {
/* 512 */     return ((
/* 512 */       this = getClass(paramObject)) != null) && 
/* 512 */       ((equals("combobox")) || (equals("tabbedpane")));
/*     */   }
/*     */ 
/*     */   public String readInputText(String textFieldName)
/*     */   {
/*     */     Object textField;
/* 532 */     if (((
/* 532 */       textField = find(textFieldName)) != null) && 
/* 532 */       (isTextInputField(textFieldName))) {
/* 533 */       return getString(textFieldName, "text");
/*     */     }
/* 535 */     return null;
/*     */   }
/*     */ 
/*     */   public String readSelectedName(String sincleChoiceFieldName)
/*     */   {
/*     */     Object sincleChoiceField;
/* 541 */     if (((
/* 541 */       sincleChoiceField = find(sincleChoiceFieldName)) != null) && 
/* 541 */       (isSingleChoice(sincleChoiceFieldName)))
/*     */     {
/*     */       Object selected;
/* 543 */       if ((
/* 543 */         selected = getSelectedItem(sincleChoiceFieldName)) != null)
/*     */       {
/* 544 */         return getString(sincleChoiceFieldName, "name");
/*     */       }
/*     */     }
/* 547 */     return null;
/*     */   }
/*     */ 
/*     */   public void checkFieldLength(Object field)
/*     */   {
/* 557 */     int maxLength = getInteger(field, "width");
/* 558 */     if ((field != null) && (isTextInputField(field)))
/*     */     {
/*     */       String text;
/* 560 */       if ((
/* 560 */         text = getString(field, "text"))
/* 560 */         .length() > maxLength)
/* 561 */         setString(field, "text", text.substring(0, maxLength));
/*     */     }
/*     */   }
/*     */ 
/*     */   protected void mergeAttributes(Map<String, ? extends Object> paramMap)
/*     */   {
/* 575 */     if (paramMap == null) {
/* 576 */       return;
/*     */     }
/* 578 */     HashMap localHashMap = new HashMap();
/*     */ 
/* 580 */     for (Map.Entry localEntry : paramMap.entrySet())
/*     */     {
/* 582 */       localHashMap.put(localEntry.getKey(), localEntry.getValue() == null ? null : localEntry.getValue().toString());
/*     */     }
/*     */ 
/* 586 */     mergeStringAttributes(localHashMap);
/*     */   }
/*     */ 
/*     */   private void mergeStringAttributes(Map<String, String> paramMap)
/*     */   {
/* 591 */     if (paramMap == null) {
/* 592 */       return;
/*     */     }
/* 594 */     for (Object localObject1 : paramMap.entrySet())
/*     */     {
/*     */       Object localObject2;
/* 596 */       if ((
/* 596 */         localObject2 = find((String)((Map.Entry)localObject1).getKey())) != null)
/*     */       {
/* 597 */         if ((isLabel(localObject2)) || (isTextInputField(localObject2)))
/*     */         {
/* 600 */           setString(localObject2, "text", (String)((Map.Entry)localObject1).getValue()); continue;
/*     */         }
/* 602 */         if (isSingleChoice(localObject2)) {
/* 603 */           String str = (String)((Map.Entry)localObject1).getValue(); localObject2 = (String)((Map.Entry)localObject1).getKey(); localObject1 = this; if (((localObject2 = find((String)localObject2)) != null) && (((ExtendedThinlet)localObject1).isSingleChoice(localObject2))) { Object[] arrayOfObject = ((ExtendedThinlet)localObject1).getItems(localObject2); int i = 0; int j = (arrayOfObject = arrayOfObject).length; for (int k = 0; k < j; k++)
/*     */             {
/* 603 */               Object localObject4;
/* 603 */               if ((((localObject4 = getClass(localObject4 = localObject3 = arrayOfObject[k])) != null) && ((((String)localObject4).equals("tab")) || (((String)localObject4).equals("choice"))) ? 1 : 0) == 0) continue; Object localObject3 = ((ExtendedThinlet)localObject1).getString(localObject3, "name"); if (str.equals(localObject3)) { ((ExtendedThinlet)localObject1).setInteger(localObject2, "selected", i); break label280; } i++;
/*     */             } } continue;
/*     */         }
/* 605 */         setBoolean(localObject2, "visible", Boolean.valueOf((String)((Map.Entry)localObject1).getValue()).booleanValue());
/*     */       }
/*     */     }
/*     */ 
/* 609 */     label280:
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.ExtendedThinlet
 * JD-Core Version:    0.6.0
 */