/*     */ package com.scytl;
/*     */ 
/*     */ import com.scytl.i18n.MessageSourceResourceBundle;
/*     */ import com.scytl.privilegedactions.PrivilegedActionInputStream;
/*     */ import com.scytl.voting.applet.KeystoreHolder;
/*     */ import com.scytl.voting.applet.PnyxClientApplet;
/*     */ import java.awt.Color;
/*     */ import java.awt.Image;
/*     */ import java.awt.MediaTracker;
/*     */ import java.awt.Toolkit;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.security.AccessController;
/*     */ import java.security.ProviderException;
/*     */ import java.text.MessageFormat;
/*     */ import java.util.ResourceBundle;
/*     */ import org.apache.commons.io.IOUtils;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.bouncycastle.asn1.util.ASN1Dump;
/*     */ 
/*     */ public abstract class VotingAppletThinlet extends ExtendedThinlet<PnyxClientApplet>
/*     */ {
/*  40 */   private static final Log LOGGER = LogFactory.getLog(VotingAppletThinlet.class);
/*     */   private final String _customer;
/*     */   private final ASN1Dump _messageSource$6b7050de;
/*     */   private final ResourceCustomizer _resourceCustomizer;
/*     */   public static final String BUNDLE_STRING = "com.scytl.voting.applet.view.thinlet.i18n.clientText";
/*     */ 
/*     */   public VotingAppletThinlet(PnyxClientApplet paramPnyxClientApplet)
/*     */   {
/*  65 */     super(paramPnyxClientApplet);
/*     */ 
/*  67 */     this._customer = paramPnyxClientApplet.getParameter("customer");
/*     */ 
/*  69 */     this._messageSource$6b7050de = new ASN1Dump(new String[] { this._customer, "pnyx_client_messages", "com.scytl.voting.applet.view.thinlet.i18n.clientText" });
/*     */ 
/*  73 */     this._resourceCustomizer = new ResourceCustomizer(this._customer);
/*     */ 
/*  75 */     paramPnyxClientApplet = (InputStream)AccessController.doPrivileged(new PrivilegedActionInputStream(this._resourceCustomizer.getPathToUse("/images/favicon.gif")));
/*     */     try
/*     */     {
/*  82 */       setImage(Toolkit.getDefaultToolkit().createImage(IOUtils.toByteArray(paramPnyxClientApplet)));
/*     */     }
/*     */     catch (IOException localIOException) {
/*  85 */       LOGGER.debug("Image icon not found.");
/*     */     }
/*     */ 
/*  88 */     paramPnyxClientApplet = new ThinletProperties(this._resourceCustomizer.getPathToUse("/thinlet.properties"));
/*     */ 
/*  92 */     super.setColors(paramPnyxClientApplet.getBackgroundColor().getRGB(), paramPnyxClientApplet.getTextColor().getRGB(), paramPnyxClientApplet.getTextBackgroundColor().getRGB(), paramPnyxClientApplet.getBorderColor().getRGB(), paramPnyxClientApplet.getDisabledColor().getRGB(), paramPnyxClientApplet.getHoverColor().getRGB(), paramPnyxClientApplet.getPressColor().getRGB(), paramPnyxClientApplet.getFocusColor().getRGB(), paramPnyxClientApplet.getSelectColor().getRGB());
/*     */ 
/*  99 */     ExtendedThinlet.setFocusVisible(Boolean.parseBoolean((this = paramPnyxClientApplet).getProperty("focus.visible")));
/*     */   }
/*     */ 
/*     */   protected final void handleException(Throwable paramThrowable)
/*     */   {
/* 107 */     super.handleException(paramThrowable);
/* 108 */     if (((paramThrowable instanceof NoClassDefFoundError)) || ((paramThrowable instanceof UnsupportedClassVersionError)))
/*     */     {
/* 110 */       String str1 = System.getProperty("java.version");
/* 111 */       String str2 = System.getProperty("java.vendor");
/* 112 */       displayError(MessageFormat.format(getResourceBundle().getString("java.version"), new Object[] { str2 + " " + str1 }), paramThrowable);
/*     */ 
/* 116 */       return; } if ((paramThrowable instanceof ProviderException)) {
/* 117 */       KeystoreHolder.getInstance().resetKeystore();
/* 118 */       KeystoreHolder.getInstance().loadKeyStore();
/*     */       try {
/* 120 */         retryUserActionCause(paramThrowable);
/*     */ 
/* 127 */         return;
/*     */       }
/*     */       catch (IllegalArgumentException localIllegalArgumentException)
/*     */       {
/* 122 */         LOGGER.error("Error retrying action", localIllegalArgumentException);
/*     */ 
/* 127 */         return;
/*     */       }
/*     */       catch (IllegalAccessException localIllegalAccessException)
/*     */       {
/* 124 */         LOGGER.error("Error retrying action", localIllegalAccessException);
/*     */ 
/* 127 */         return;
/*     */       }
/*     */       catch (InvocationTargetException localInvocationTargetException)
/*     */       {
/* 126 */         LOGGER.error("Error retrying action", localInvocationTargetException);
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   private void retryUserActionCause(Throwable paramThrowable)
/*     */     throws IllegalArgumentException, IllegalAccessException, InvocationTargetException
/*     */   {
/* 142 */     for (Object localObject : paramThrowable.getStackTrace())
/*     */       try
/*     */       {
/* 145 */         if (localObject.getClassName().startsWith(getClass().getPackage().getName()))
/*     */         {
/*     */           Class localClass;
/* 148 */           if ((
/* 148 */             localClass = Class.forName(localObject.getClassName()))
/* 148 */             .isAssignableFrom(getClass()))
/*     */             try {
/* 150 */               if (!localObject.getMethodName().equals("processEvent"))
/*     */               {
/* 152 */                 localClass.getMethod(localObject.getMethodName(), new Class[0]).invoke(this, new Object[0]);
/*     */               }
/*     */             }
/*     */             catch (SecurityException localSecurityException) {
/* 156 */               LOGGER.error("Error getting the method to retry", localSecurityException);
/*     */             } catch (NoSuchMethodException localNoSuchMethodException) {
/* 158 */               LOGGER.error("Error getting the method to retry", localNoSuchMethodException);
/*     */             }
/*     */         }
/*     */       }
/*     */       catch (ClassNotFoundException localClassNotFoundException) {
/* 163 */         LOGGER.error("Error getting the class to retry", localClassNotFoundException);
/*     */       }
/*     */   }
/*     */ 
/*     */   protected final void init()
/*     */   {
/* 173 */     setResourceBundle(new MessageSourceResourceBundle(this._messageSource$6b7050de, getLocale()));
/*     */ 
/* 175 */     super.init();
/*     */   }
/*     */ 
/*     */   public Object parse(String path, Object handler)
/*     */     throws IOException
/*     */   {
/* 186 */     return super.parse(getInputStream(path), handler);
/*     */   }
/*     */ 
/*     */   private InputStream getInputStream(String path) {
/* 190 */     return (InputStream)AccessController.doPrivileged(new PrivilegedActionInputStream(this._resourceCustomizer.getPathToUse(path)));
/*     */   }
/*     */ 
/*     */   public Image getIcon(String path, boolean preload)
/*     */   {
/* 202 */     return getIcon(getInputStream(path), preload);
/*     */   }
/*     */ 
/*     */   private Image getIcon(InputStream paramInputStream, boolean paramBoolean)
/*     */   {
/* 220 */     Image localImage = null;
/* 221 */     if (paramInputStream != null) {
/*     */       try {
/* 223 */         localImage = getToolkit().createImage(IOUtils.toByteArray(paramInputStream));
/*     */       }
/*     */       catch (IOException localIOException) {
/* 226 */         if (LOGGER.isDebugEnabled())
/* 227 */           LOGGER.debug("Error creating image: " + localIOException.getMessage());
/*     */       }
/*     */       finally
/*     */       {
/* 231 */         IOUtils.closeQuietly(paramInputStream);
/*     */       }
/* 233 */       if ((paramBoolean) && (localImage != null))
/*     */       {
/*     */         MediaTracker localMediaTracker;
/* 234 */         (
/* 235 */           localMediaTracker = new MediaTracker(this))
/* 235 */           .addImage(localImage, 1);
/*     */         try {
/* 237 */           localMediaTracker.waitForID(1, 5000L);
/*     */         } catch (InterruptedException this) {
/* 239 */           if (LOGGER.isDebugEnabled()) {
/* 240 */             LOGGER.debug("Interrupted while adding image: " + getMessage());
/*     */           }
/*     */         }
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 247 */     return localImage;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.VotingAppletThinlet
 * JD-Core Version:    0.6.0
 */