/*     */ package com.scytl.common.messages;
/*     */ 
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.ballot.TextQuestionAnswer;
/*     */ import com.scytl.common.domain.election.ballot.ValuedMultipleChoiceQuestionAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Answer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.DelegationChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.ListAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.OpenTextQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.common.domain.hibernate.entity.election.TextAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.WriteInAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import java.util.ResourceBundle;
/*     */ import java.util.Set;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class LocalizedBallotSummary
/*     */ {
/*     */   private final Ballot _ballot;
/*     */   public static final String LINE_BREAK = "\n";
/*     */   public static final String QUESTION_SEPARATOR = "------------------";
/*     */   public static final String INDENT = "    ";
/*     */ 
/*     */   public LocalizedBallotSummary(Ballot ballot)
/*     */   {
/*  61 */     this._ballot = ballot;
/*     */   }
/*     */ 
/*     */   public String getSummary(Locale locale)
/*     */   {
/*  72 */     StringBuffer result = new StringBuffer();
/*     */ 
/*  74 */     for (Question question : this._ballot.getBallotQuestions())
/*     */     {
/*  76 */       createQuestionReceiptText(this._ballot, locale, result, question);
/*     */     }
/*     */ 
/*  81 */     return result.toString();
/*     */   }
/*     */ 
/*     */   protected void createQuestionReceiptText(Ballot paramBallot, Locale paramLocale, StringBuffer paramStringBuffer, Question paramQuestion)
/*     */   {
/*  93 */     paramStringBuffer.append(paramQuestion.getTitle().getLocalizedMessage(paramLocale));
/*  94 */     paramStringBuffer.append("\n");
/*  95 */     paramStringBuffer.append(paramQuestion.getText().getLocalizedMessage(paramLocale));
/*  96 */     paramStringBuffer.append("\n");
/*  97 */     paramStringBuffer.append("\n");
/*     */ 
/*  99 */     if ((paramQuestion instanceof MultipleChoiceQuestion))
/*     */     {
/* 101 */       createMultipleChoiceQuestionReceiptText(paramBallot, paramLocale, paramStringBuffer, (MultipleChoiceQuestion)paramQuestion);
/*     */     }
/* 104 */     else if ((paramQuestion instanceof OpenTextQuestion)) {
/* 105 */       Locale localLocale = paramLocale; paramQuestion = (OpenTextQuestion)paramQuestion; paramLocale = paramStringBuffer; paramBallot = paramBallot; this = this; if ((this = (TextQuestionAnswer)paramBallot.getBallotAnswers().get(paramQuestion.getId())) == null) this = ""; else this = getText(); if ((this == null) || (length() == 0)) this = getNoVote(localLocale, paramQuestion); this = this; (paramBallot = new StringBuffer()).append("    "); paramBallot.append(this); paramBallot.append("\n"); paramLocale.append(paramBallot.toString());
/*     */     }
/* 107 */     else if ((paramQuestion instanceof DelegationChoiceQuestion)) {
/* 108 */       createDelegationChoiceQuestionReceiptText(paramBallot, paramLocale, paramStringBuffer, (DelegationChoiceQuestion)paramQuestion);
/*     */     }
/*     */ 
/* 111 */     paramStringBuffer.append("\n");
/*     */   }
/*     */ 
/*     */   private static void createDelegationChoiceQuestionReceiptText(Ballot paramBallot, Locale paramLocale, StringBuffer paramStringBuffer, DelegationChoiceQuestion paramDelegationChoiceQuestion)
/*     */   {
/* 125 */     paramBallot = (ValuedMultipleChoiceQuestionAnswer)paramBallot.getBallotAnswers().get(paramDelegationChoiceQuestion.getId());
/*     */ 
/* 128 */     String str = null;
/* 129 */     for (Object localObject = paramDelegationChoiceQuestion.getBoardMembers().iterator(); ((Iterator)localObject).hasNext(); ) { TextAnswer localTextAnswer = (TextAnswer)((Iterator)localObject).next();
/* 130 */       if (paramBallot.getNotNullAnswerIdValues().containsKey(localTextAnswer.getId()))
/*     */       {
/* 132 */         str = "    ";
/* 133 */         str = str + localTextAnswer.getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 135 */         break;
/*     */       }
/*     */     }
/* 138 */     if (str == null) {
/* 139 */       str = "    ";
/* 140 */       str = str + paramDelegationChoiceQuestion.getDelegateId().getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 143 */       str = str + "    ";
/* 144 */       str = str + (String)paramBallot.getAnswerIdValues().get(paramDelegationChoiceQuestion.getDelegateId().getId());
/*     */ 
/* 147 */       str = str + "\n";
/* 148 */       str = str + "    ";
/* 149 */       str = str + paramDelegationChoiceQuestion.getDelegateName().getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 152 */       str = str + "    ";
/* 153 */       str = str + (String)paramBallot.getAnswerIdValues().get(paramDelegationChoiceQuestion.getDelegateName().getId());
/*     */ 
/* 156 */       if (paramBallot.getNotNullAnswerIdValues().containsKey(paramDelegationChoiceQuestion.getDelegatePhone().getId()))
/*     */       {
/* 158 */         str = str + "\n";
/* 159 */         str = str + "    ";
/* 160 */         str = str + paramDelegationChoiceQuestion.getDelegatePhone().getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 163 */         str = str + "    ";
/* 164 */         str = str + (String)paramBallot.getAnswerIdValues().get(paramDelegationChoiceQuestion.getDelegatePhone().getId());
/*     */       }
/*     */ 
/* 168 */       if (paramBallot.getNotNullAnswerIdValues().containsKey(paramDelegationChoiceQuestion.getDelegateMail().getId()))
/*     */       {
/* 170 */         str = str + "\n";
/* 171 */         str = str + "    ";
/* 172 */         str = str + paramDelegationChoiceQuestion.getDelegateMail().getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 175 */         str = str + "    ";
/* 176 */         str = str + (String)paramBallot.getAnswerIdValues().get(paramDelegationChoiceQuestion.getDelegateMail().getId());
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 181 */     paramStringBuffer.append(str);
/* 182 */     paramStringBuffer.append("\n");
/*     */ 
/* 184 */     localObject = "";
/* 185 */     if (paramBallot.getNotNullAnswerIdValues().containsKey(paramDelegationChoiceQuestion.getObservations().getId()))
/*     */     {
/* 187 */       localObject = (String)localObject + "\n";
/* 188 */       localObject = (String)localObject + "    ";
/* 189 */       localObject = (String)localObject + paramDelegationChoiceQuestion.getObservations().getText().getLocalizedMessage(paramLocale);
/*     */ 
/* 192 */       localObject = (String)localObject + "\n";
/* 193 */       localObject = (String)localObject + "    ";
/* 194 */       localObject = (String)localObject + "    ";
/* 195 */       localObject = (String)localObject + (String)paramBallot.getAnswerIdValues().get(paramDelegationChoiceQuestion.getObservations().getId());
/*     */ 
/* 198 */       paramStringBuffer.append((String)localObject);
/* 199 */       paramStringBuffer.append("\n");
/*     */     }
/*     */   }
/*     */ 
/*     */   protected void createMultipleChoiceQuestionReceiptText(Ballot paramBallot, Locale paramLocale, StringBuffer paramStringBuffer, MultipleChoiceQuestion paramMultipleChoiceQuestion)
/*     */   {
/* 236 */     Object localObject1 = paramMultipleChoiceQuestion.getAnswers();
/* 237 */     ValuedMultipleChoiceQuestionAnswer localValuedMultipleChoiceQuestionAnswer = (ValuedMultipleChoiceQuestionAnswer)paramBallot.getBallotAnswers().get(paramMultipleChoiceQuestion.getId());
/*     */ 
/* 241 */     Object localObject5 = paramBallot; Object localObject3 = paramMultipleChoiceQuestion; Object localObject6 = new ArrayList(); Object localObject7 = ((MultipleChoiceQuestion)localObject3).getAnswers(); if ((localObject2 = (ValuedMultipleChoiceQuestionAnswer)((Ballot)localObject5).getBallotAnswers().get(((MultipleChoiceQuestion)localObject3).getId())).hasBeenFilled()) for (localObject3 = ((List)localObject7).iterator(); ((Iterator)localObject3).hasNext(); ((List)localObject6).add(((Answer)localObject5).getId())) if ((!(localObject5 = (Answer)((Iterator)localObject3).next()).isNuller()) || (null == ((ValuedMultipleChoiceQuestionAnswer)localObject2).getAnswerIdValues().get(((Answer)localObject5).getId())));
/*     */     int i;
/* 244 */     if ((
/* 244 */       i = !(
/* 242 */       localObject2 = localObject6)
/* 242 */       .isEmpty() ? 1 : 0) != 0)
/*     */     {
/* 246 */       for (localObject1 = ((List)localObject2).iterator(); ((Iterator)localObject1).hasNext(); ) { localObject2 = (String)((Iterator)localObject1).next();
/* 247 */         paramStringBuffer.append("    ");
/* 248 */         paramStringBuffer.append(getNullVote(paramLocale));
/*     */ 
/* 251 */         if (((
/* 251 */           this = paramMultipleChoiceQuestion.getAnswer((String)localObject2)) instanceof WriteInAnswer))
/*     */         {
/* 257 */           if ((
/* 257 */             this = (String)localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(getId())) != null)
/*     */           {
/* 258 */             paramStringBuffer.append("    ");
/* 259 */             paramStringBuffer.append(": ");
/* 260 */             paramStringBuffer.append(this);
/* 261 */             paramStringBuffer.append("\n");
/*     */           }
/*     */         }
/*     */ 
/* 265 */         paramStringBuffer.append("\n"); }
/* 266 */       return;
/*     */     }
/*     */ 
/* 270 */     if (!localValuedMultipleChoiceQuestionAnswer.hasBeenFilled()) {
/* 271 */       paramStringBuffer.append("    ");
/* 272 */       paramStringBuffer.append(getNoVote(paramLocale, paramMultipleChoiceQuestion));
/* 273 */       paramStringBuffer.append("\n");
/*     */     } else {
/* 275 */       for (localObject1 = ((List)localObject1).iterator(); ((Iterator)localObject1).hasNext(); )
/* 276 */         if ((
/* 276 */           localObject2 = (Answer)((Iterator)localObject1).next())
/* 276 */           .isBlank()) {
/* 277 */           if (null != localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId()))
/*     */           {
/* 279 */             paramStringBuffer.append("    ");
/* 280 */             localObject4 = paramLocale; paramStringBuffer.append((localObject5 = ResourceBundle.getBundle("com.scytl.common.messages.common_pnyx_messages", (Locale)localObject4)).getString("ballot.summary.blankVote"));
/*     */ 
/* 282 */             if (!"1".equalsIgnoreCase((String)localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId())))
/*     */             {
/* 284 */               paramStringBuffer.append(": ").append((String)localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId()));
/*     */             }
/*     */ 
/* 288 */             paramStringBuffer.append("\n"); continue;
/*     */           }
/* 290 */         } else if (((Answer)localObject2).isNuller()) {
/* 291 */           if (null != localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId()))
/*     */           {
/* 293 */             paramStringBuffer.append("    ");
/* 294 */             paramStringBuffer.append(getNullVote(paramLocale));
/*     */ 
/* 296 */             if (!"1".equalsIgnoreCase((String)localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId())))
/*     */             {
/* 298 */               paramStringBuffer.append(": ").append((String)localValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject2).getId()));
/*     */             }
/*     */ 
/* 302 */             paramStringBuffer.append("\n"); continue;
/*     */           }
/*     */         } else {
/* 304 */           if ((localObject2 instanceof TextAnswer)) {
/* 305 */             appendShallowMCQResponse(localValuedMultipleChoiceQuestionAnswer, (Answer)localObject2, paramStringBuffer, paramLocale, paramMultipleChoiceQuestion.isPreferential(), paramMultipleChoiceQuestion.isCumulative()); continue;
/*     */           }
/*     */ 
/* 308 */           if ((localObject2 instanceof ListAnswer)) {
/* 309 */             appendDeepMCQResponse(localValuedMultipleChoiceQuestionAnswer, (ListAnswer)localObject2, paramStringBuffer, paramLocale); continue;
/*     */           }
/* 311 */           if ((localObject2 instanceof WriteInAnswer)) {
/* 312 */             localObject7 = paramLocale; localObject6 = paramStringBuffer; localObject5 = (WriteInAnswer)localObject2; if ((localObject2 = (String)(localObject4 = localValuedMultipleChoiceQuestionAnswer).getAnswerIdValues().get(((WriteInAnswer)localObject5).getId())) != null) { ((StringBuffer)localObject6).append("    "); ((StringBuffer)localObject6).append((localObject4 = localObject5).getText().getLocalizedMessage((Locale)localObject7)); ((StringBuffer)localObject6).append(": "); ((StringBuffer)localObject6).append((String)localObject2); ((StringBuffer)localObject6).append("\n");
/*     */             }
/*     */           }
/*     */         }
/*     */     }
/*     */     Object localObject4;
/* 319 */     localObject1 = paramBallot.getBallotErrors().keySet();
/* 320 */     paramStringBuffer.append("\n");
/* 321 */     for (Object localObject2 = ((Set)localObject1).iterator(); ((Iterator)localObject2).hasNext(); )
/*     */     {
/* 323 */       if ((
/* 323 */         this = (String)((Iterator)localObject2).next())
/* 323 */         .equals(paramMultipleChoiceQuestion.getId()))
/*     */       {
/* 327 */         for (this = (
/* 327 */           this = (Set)paramBallot.getBallotErrors().get(this))
/* 327 */           .iterator(); hasNext(); ) { localObject1 = (String)next();
/* 328 */           localObject5 = localObject1; localObject4 = paramLocale; localObject6 = ResourceBundle.getBundle("com.scytl.common.messages.common_pnyx_messages", (Locale)localObject4); localObject7 = ""; localObject7 = "voting.overVoteConfirmationMessageWarning"; localObject7 = "voting.underVoteConfirmationMessageWarning"; localObject7 = "voting.overVoteListConfirmationMessageWarning"; localObject7 = "voting.underVoteListConfirmationMessageWarning"; paramStringBuffer.append(((String)localObject5).equals("ballot.inner_not_enough_answers") ? ((ResourceBundle)localObject6).getString((String)localObject7) : ((String)localObject5).equals("ballot.inner_too_many_answers") ? ((ResourceBundle)localObject6).getString((String)localObject7) : ((String)localObject5).equals("ballot.not_enough_answers") ? ((ResourceBundle)localObject6).getString((String)localObject7) : ((String)localObject5).equals("ballot.too_many_answers") ? ((ResourceBundle)localObject6).getString((String)localObject7) : (String)localObject7);
/* 329 */           paramStringBuffer.append("\n");
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   protected void appendShallowMCQResponse(ValuedMultipleChoiceQuestionAnswer paramValuedMultipleChoiceQuestionAnswer, Answer paramAnswer, StringBuffer paramStringBuffer, Locale paramLocale, boolean paramBoolean1, boolean paramBoolean2)
/*     */   {
/* 429 */     if ((paramValuedMultipleChoiceQuestionAnswer.hasBeenFilled()) && (paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(paramAnswer.getId()) != null))
/*     */     {
/* 431 */       paramStringBuffer.append("    ");
/* 432 */       paramStringBuffer.append((this = paramAnswer).getText().getLocalizedMessage(paramLocale));
/*     */ 
/* 434 */       if ((!"1".equalsIgnoreCase((String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(paramAnswer.getId()))) || (paramBoolean1) || (paramBoolean2))
/*     */       {
/* 436 */         paramStringBuffer.append(": ").append((String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(paramAnswer.getId()));
/*     */       }
/*     */ 
/* 441 */       paramStringBuffer.append("\n");
/*     */     }
/*     */   }
/*     */ 
/*     */   protected void appendDeepMCQResponse(ValuedMultipleChoiceQuestionAnswer paramValuedMultipleChoiceQuestionAnswer, ListAnswer paramListAnswer, StringBuffer paramStringBuffer, Locale paramLocale)
/*     */   {
/* 449 */     HashSet localHashSet = new HashSet();
/*     */     Iterator localIterator;
/* 450 */     if (paramListAnswer != null)
/* 451 */       for (localIterator = paramListAnswer.getAnswers().iterator(); localIterator.hasNext(); ) { localObject = (Answer)localIterator.next();
/* 452 */         localHashSet.add(((Answer)localObject).getId());
/*     */       }
/*     */     Object localObject;
/* 455 */     appendShallowMCQResponse(paramValuedMultipleChoiceQuestionAnswer, paramListAnswer, paramStringBuffer, paramLocale, false, false);
/*     */ 
/* 457 */     if (paramValuedMultipleChoiceQuestionAnswer != null)
/* 458 */       for (localIterator = paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().keySet().iterator(); localIterator.hasNext(); ) { localObject = (String)localIterator.next();
/*     */ 
/* 460 */         if (localHashSet.contains(localObject)) {
/* 461 */           paramStringBuffer.append("    ");
/* 462 */           paramStringBuffer.append((this = paramListAnswer.getAnswer((String)localObject)).getText().getLocalizedMessage(paramLocale));
/*     */ 
/* 464 */           if (!"1".equalsIgnoreCase((String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(localObject)))
/*     */           {
/* 466 */             paramStringBuffer.append(": ").append((String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(localObject));
/*     */           }
/*     */ 
/* 470 */           paramStringBuffer.append("\n");
/*     */         }
/*     */       }
/*     */   }
/*     */ 
/*     */   private static String getNoVote(Locale locale, Question question)
/*     */   {
/*     */     Question question;
/* 477 */     if (question.hasCustomBlankVoteMessage()) {
/* 478 */       return question.getCustomBlankVoteMessage().getLocalizedMessage(locale);
/*     */     }
/*     */ 
/* 483 */     return (
/* 483 */       rb = ResourceBundle.getBundle("com.scytl.common.messages.common_pnyx_messages", locale))
/* 483 */       .getString("ballot.summary.noVote");
/*     */   }
/*     */ 
/*     */   private static String getNullVote(Locale locale)
/*     */   {
/*     */     ResourceBundle rb;
/* 496 */     return (
/* 496 */       rb = ResourceBundle.getBundle("com.scytl.common.messages.common_pnyx_messages", locale))
/* 496 */       .getString("ballot.summary.nullVote");
/*     */   }
/*     */ 
/*     */   static
/*     */   {
/*  53 */     LogFactory.getLog(LocalizedBallotSummary.class);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.messages.LocalizedBallotSummary
 * JD-Core Version:    0.6.0
 */