/*     */ package com.scytl.common.messages;
/*     */ 
/*     */ import com.scytl.common.domain.token.TokenJCE;
/*     */ import com.scytl.common.utils.EncodingHelper;
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.security.PublicKey;
/*     */ import java.security.cert.Certificate;
/*     */ import java.security.cert.CertificateException;
/*     */ import java.security.cert.CertificateFactory;
/*     */ import java.util.Date;
/*     */ import javax.xml.xpath.XPathException;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ public class SecureMessageServer extends MessageServer
/*     */ {
/*  35 */   public static final ComponentMonitor LOGGER$54f09f98 = LoggerFactory.getLogger$4ecaad6a(SecureMessageServer.class);
/*     */   private CertificateFactory _cf;
/*     */ 
/*     */   public SecureMessageServer(CertificateFactory cf)
/*     */   {
/* 100 */     this();
/* 101 */     this._cf = cf;
/*     */   }
/*     */ 
/*     */   public SecureMessageServer()
/*     */   {
/* 106 */     this._cf = null;
/* 107 */     addQNameCheckAttributes("area");
/* 108 */     addQNameCheckAttributes("canDecrypt");
/* 109 */     addQNameCheckAttributes("signed");
/* 110 */     add("/message/body/signed/signature");
/* 111 */     add("/message/body/signed/x509_certificate");
/* 112 */     add("/message/body/signed/@by");
/* 113 */     add("/message/body/signed/data/vrr/env_id");
/* 114 */     add("/message/body/signed/data/vrr/timestamp");
/* 115 */     add("/message/body/signed/data/vrr/signed/data/auth_token/x509_fingerprint");
/* 116 */     add("/message/body/signed/data/vrr/public_data");
/* 117 */     add("/message/body/signed/data/vrr/hashed_ballot_id");
/* 118 */     add("/message/body/signed/data/vrr/signed/signature");
/* 119 */     add("/message/body/signed/data/vrr/signed/data/auth_token/login");
/* 120 */     add("/message/body/signed/data/vrr/signed/data/auth_token/timestamp");
/* 121 */     add("/message/body/signed/data/vrr/signed/data/auth_token/timeout");
/* 122 */     add("/message/body/signed/data/vrr/signed/data/auth_token/token_id");
/* 123 */     add("/message/body/signed/data/vrr/signed/data/auth_token/election_id");
/* 124 */     add("/message/body/signed/data/vrr/signed/data/auth_token/context/role");
/* 125 */     add("/message/body/signed/data/vrr/signed/data/auth_token/context/canDecrypt/@value");
/* 126 */     add("/message/body/signed/data/vrr/signed/data/auth_token/context/area/@id");
/* 127 */     add("/message/body/envelope/enc_key");
/* 128 */     add("/message/body/envelope/enc_data");
/*     */   }
/*     */ 
/*     */   public String getVoterLogin()
/*     */     throws XPathException
/*     */   {
/* 137 */     return getString("/message/body/signed/@by");
/*     */   }
/*     */ 
/*     */   public String getAuthLogin() throws XPathException {
/* 141 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/login");
/*     */   }
/*     */ 
/*     */   public String getPublicData() throws XPathException {
/* 145 */     return getString("/message/body/signed/data/vrr/public_data");
/*     */   }
/*     */ 
/*     */   public String getEncryptedKey() throws XPathException {
/* 149 */     return getString("/message/body/envelope/enc_key");
/*     */   }
/*     */ 
/*     */   public String getEncryptedData() throws XPathException {
/* 153 */     return getString("/message/body/envelope/enc_data");
/*     */   }
/*     */ 
/*     */   public String getUserX509Certificate() throws XPathException {
/* 157 */     return getString("/message/body/signed/x509_certificate");
/*     */   }
/*     */ 
/*     */   public String getVrrDataAsString(CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XPathException
/*     */   {
/*     */     StringBuffer localStringBuffer;
/* 172 */     (
/* 174 */       localStringBuffer = new StringBuffer())
/* 174 */       .append(getString("/message/body/signed/@by"));
/* 175 */     localStringBuffer.append(";");
/*     */ 
/* 177 */     localStringBuffer.append(getString("/message/body/signed/x509_certificate"));
/* 178 */     localStringBuffer.append(";");
/*     */ 
/* 180 */     localStringBuffer.append(getString("/message/body/signed/data/vrr/env_id"));
/* 181 */     localStringBuffer.append(";");
/*     */ 
/* 183 */     localStringBuffer.append(getString("/message/body/signed/data/vrr/timestamp"));
/* 184 */     localStringBuffer.append(";");
/*     */ 
/* 186 */     localStringBuffer.append(getString("/message/body/signed/data/vrr/hashed_ballot_id"));
/* 187 */     localStringBuffer.append(";");
/*     */ 
/* 189 */     localStringBuffer.append(getString("/message/body/signed/data/vrr/public_data"));
/* 190 */     localStringBuffer.append(";");
/*     */ 
/* 192 */     localStringBuffer.append(getToken(paramCryptographicAlgorithms).getSignedInfo());
/*     */ 
/* 194 */     return localStringBuffer.toString();
/*     */   }
/*     */ 
/*     */   public boolean checkFingerPrint(CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XPathException
/*     */   {
/* 206 */     paramCryptographicAlgorithms = getUserX509Certificate();
/* 207 */     this = this; this = getString("/message/body/signed/data/vrr/signed/data/auth_token/x509_fingerprint");
/*     */ 
/* 209 */     boolean bool = false;
/*     */ 
/* 211 */     if ((paramCryptographicAlgorithms != null) && (this != null)) {
/* 212 */       bool = new String(Base64.encodeBase64(CryptographicAlgorithms.hash(Base64.decodeBase64(paramCryptographicAlgorithms)))).equals(this);
/*     */     }
/*     */ 
/* 217 */     if (!bool) {
/* 218 */       LOGGER$54f09f98.info("USER_CERTIFICATE :: '" + paramCryptographicAlgorithms + "' FINGERPRINT :: '" + this + "'");
/*     */     }
/*     */ 
/* 221 */     return bool;
/*     */   }
/*     */ 
/*     */   public TokenJCE getToken(CryptographicAlgorithms ca)
/*     */     throws XPathException
/*     */   {
/*     */     TokenJCE token;
/* 226 */     (
/* 227 */       token = new TokenJCE(ca))
/* 227 */       .setUsername(getString("/message/body/signed/data/vrr/signed/data/auth_token/login"));
/* 228 */     ca.setCreationDateTime(getString("/message/body/signed/data/vrr/signed/data/auth_token/timestamp"));
/* 229 */     ca.setTimeout(getString("/message/body/signed/data/vrr/signed/data/auth_token/timeout"));
/* 230 */     ca.setId(getString("/message/body/signed/data/vrr/signed/data/auth_token/token_id"));
/* 231 */     ca.setElectionId(getString("/message/body/signed/data/vrr/signed/data/auth_token/election_id"));
/* 232 */     ca.setX509Fingerprint(getString("/message/body/signed/data/vrr/signed/data/auth_token/x509_fingerprint"));
/* 233 */     ca.setUserRole(getString("/message/body/signed/data/vrr/signed/data/auth_token/context/role"));
/* 234 */     ca.setCanDecrypt(getString("/message/body/signed/data/vrr/signed/data/auth_token/context/canDecrypt/@value"));
/* 235 */     ca.setAreaId(getString("/message/body/signed/data/vrr/signed/data/auth_token/context/area/@id"));
/* 236 */     ca.setAuthTokenSignatureString(getString("/message/body/signed/data/vrr/signed/signature"));
/* 237 */     ca.setAuthTokenSignature(Base64.decodeBase64(getString("/message/body/signed/data/vrr/signed/signature")));
/*     */ 
/* 239 */     return ca;
/*     */   }
/*     */ 
/*     */   public boolean checkVoteCastDuringValidityOfTheToken(Date paramDate)
/*     */     throws NumberFormatException, XPathException
/*     */   {
/*     */     long l1;
/* 245 */     long l2 = (
/* 245 */       l1 = Long.parseLong(getString("/message/body/signed/data/vrr/signed/data/auth_token/timestamp"))) + 
/* 245 */       Long.parseLong(getString("/message/body/signed/data/vrr/signed/data/auth_token/timeout"));
/* 246 */     return (!paramDate.before(new Date(l1))) && (!paramDate.after(new Date(l2)));
/*     */   }
/*     */ 
/*     */   public boolean checkEnvelopeID(CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XPathException
/*     */   {
/* 260 */     (
/* 262 */       paramCryptographicAlgorithms = new StringBuffer())
/* 262 */       .append(getString("/message/body/envelope/enc_key"));
/* 263 */     paramCryptographicAlgorithms.append(getString("/message/body/envelope/enc_data"));
/* 264 */     paramCryptographicAlgorithms.append(getString("/message/body/signed/data/vrr/signed/data/auth_token/election_id"));
/*     */ 
/* 266 */     this = getString("/message/body/signed/data/vrr/env_id");
/*     */ 
/* 272 */     return (
/* 272 */       paramCryptographicAlgorithms = EncodingHelper.getString(Base64.encodeBase64(CryptographicAlgorithms.hash(EncodingHelper.getBytes(paramCryptographicAlgorithms.toString())))))
/* 272 */       .equals(this);
/*     */   }
/*     */ 
/*     */   public Certificate readUserCertificate()
/*     */     throws CertificateException, XPathException
/*     */   {
/* 278 */     return this._cf.generateCertificate(new ByteArrayInputStream(Base64.decodeBase64(getUserX509Certificate())));
/*     */   }
/*     */ 
/*     */   public boolean checkVRRSignature(CryptographicAlgorithms paramCryptographicAlgorithms, PublicKey paramPublicKey)
/*     */     throws XPathException
/*     */   {
/* 294 */     this = this; return CryptographicAlgorithms.verify(EncodingHelper.getBytes(getVrrDataAsString(paramCryptographicAlgorithms)), Base64.decodeBase64(EncodingHelper.getBytes(getString("/message/body/signed/signature"))), paramPublicKey);
/*     */   }
/*     */ 
/*     */   public boolean checkHashedBallotId(String paramString, CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XPathException
/*     */   {
/* 314 */     this = paramCryptographicAlgorithms; this = paramString; return (
/* 314 */       this = getHashedBallotId())
/* 314 */       .equals(new String(Base64.encodeBase64(CryptographicAlgorithms.hash(getBytes()))));
/*     */   }
/*     */ 
/*     */   public String getHashedBallotId()
/*     */     throws XPathException
/*     */   {
/* 325 */     return getString("/message/body/signed/data/vrr/hashed_ballot_id");
/*     */   }
/*     */ 
/*     */   public String getElection() throws XPathException {
/* 329 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/election_id");
/*     */   }
/*     */ 
/*     */   public boolean checkAuthLogin(String login) throws XPathException
/*     */   {
/* 334 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/login").equals(login);
/*     */   }
/*     */ 
/*     */   public boolean checkVoterLogin(String login) throws XPathException
/*     */   {
/* 339 */     return getString("/message/body/signed/@by").equals(login);
/*     */   }
/*     */ 
/*     */   public boolean checkElection(String election) throws XPathException
/*     */   {
/* 344 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/election_id").equals(election);
/*     */   }
/*     */ 
/*     */   public String getSignature()
/*     */     throws XPathException
/*     */   {
/* 352 */     return getString("/message/body/signed/signature");
/*     */   }
/*     */ 
/*     */   public String getContextDecrypt()
/*     */     throws XPathException
/*     */   {
/* 360 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/context/canDecrypt/@value");
/*     */   }
/*     */ 
/*     */   public String getAreaId()
/*     */     throws XPathException
/*     */   {
/* 367 */     return getString("/message/body/signed/data/vrr/signed/data/auth_token/context/area/@id");
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.messages.SecureMessageServer
 * JD-Core Version:    0.6.0
 */