/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import com.scytl.ExtendedThinlet;
/*     */ import com.scytl.JavaScriptSupportApplet;
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ElectoralScope;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.vote.UrlEncodedVote;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import com.scytl.common.messages.LocalizedBallotSummary;
/*     */ import com.scytl.common.url.UrlHelper;
/*     */ import com.scytl.internationalization.ConfigurationProperties;
/*     */ import com.scytl.internationalization.LocaleProvider;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.ApplicationProtocolException;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import com.scytl.pnyx.client.state.automaton.PnyxClientStateMachine;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessageFormatter;
/*     */ import com.scytl.pnyx.client.validator.ValidatorException;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import com.scytl.voting.applet.view.swing.SwingConfirmVote;
/*     */ import com.scytl.voting.applet.view.swing.SwingLogin;
/*     */ import com.scytl.voting.applet.view.swing.SwingVoteReceipt;
/*     */ import java.awt.Container;
/*     */ import java.io.IOException;
/*     */ import java.net.URL;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import java.util.logging.LogManager;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.bouncycastle.asn1.util.ASN1Dump;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class PnyxClientApplet extends JavaScriptSupportApplet
/*     */ {
/*  62 */   private static Log _logger = LogFactory.getLog(PnyxClientApplet.class);
/*     */   protected VotingAppletContext _context;
/*     */   public static final String LOGIN_VIEW = "login";
/*     */   public static final String VOTE_CONFIRMATION_VIEW = "confirmVote";
/*     */   public static final String DELEGATION_CONFIRMATION_VIEW = "confirmDelegation";
/*     */   public static final String RECEIPT_VIEW = "receipt";
/*     */   public static final String ALTERNATE_RECEIPT_VIEW = "alternate_receipt";
/*     */   public static final String VOTE_VALIDATION_VIEW = "voteValidation";
/*     */   public static final String DELEGATION_VALIDATION_VIEW = "delegationValidation";
/*     */   public static final String ACCESSIBILITY_FLAG = "accessible";
/*     */   private transient Map<String, String> _pnyxParameters;
/*     */   private transient URL _parentURL;
/*     */   private transient ElectoralScope _electoralScope;
/*     */   private HelperThread _helperThread;
/*     */   private Ballot _ballot;
/*     */ 
/*     */   public void init()
/*     */   {
/*     */     try
/*     */     {
/* 123 */       LogManager.getLogManager().readConfiguration(Thread.currentThread().getContextClassLoader().getResourceAsStream("jdk-logging.properties")); } catch (IOException localIOException) { try { LogManager.getLogManager().readConfiguration(); } catch (IOException this) { throw new RuntimeException(this); } }
/* 124 */     _logger.info("Init called");
/* 125 */     super.init();
/* 126 */     PnyxClientApplet localPnyxClientApplet = this; this._parentURL = UrlHelper.encodeURL(UrlHelper.urlDecode(localPnyxClientApplet.getParameter("parenturl")), null); localPnyxClientApplet._pnyxParameters = UrlHelper.decodeParameters(localPnyxClientApplet._parentURL.getQuery());
/* 127 */     localPnyxClientApplet = this; if (this._context == null) { localPnyxClientApplet._context = new VotingAppletContext(localPnyxClientApplet); localPnyxClientApplet._context.init(); }
/* 128 */     _logger.info("Creating helper thread");
/* 129 */     this._helperThread = new HelperThread();
/* 130 */     this._helperThread.start();
/*     */ 
/* 132 */     _logger.info("Init completed");
/*     */   }
/*     */ 
/*     */   public void start()
/*     */   {
/* 164 */     _logger.info("Start called");
/* 165 */     if (getAppletProperties().isRecognizedCertificateAllowed())
/*     */     {
/* 167 */       KeystoreHolder.getInstance().loadKeyStore();
/*     */     }
/* 169 */     super.start();
/* 170 */     Object localObject1 = this; Object localObject2 = null;
/*     */     try { localObject2 = new Locale((String)((PnyxClientApplet)localObject1)._pnyxParameters.get("siteLanguage")); } catch (NullPointerException localNullPointerException) { _logger.info("No locale configured from parameter."); } ((PnyxClientApplet)localObject1).setLocale((Locale)localObject2);
/*     */ 
/* 172 */     localObject1 = this; localObject2 = (String)this._pnyxParameters.get("electionId"); String str = (String)((PnyxClientApplet)localObject1)._pnyxParameters.get("institutionId"); localObject1 = (String)((PnyxClientApplet)localObject1)._pnyxParameters.get("electionEventId"); this._electoralScope = new ElectoralScope(str, (String)localObject2, (String)localObject1);
/*     */ 
/* 174 */     doScript("applet", "stopWaiting", new String[0]);
/* 175 */     _logger.info("Start completed");
/*     */   }
/*     */ 
/*     */   public String getCertTab()
/*     */   {
/* 194 */     String tabs = null;
/*     */     try {
/* 196 */       tabs = (String)this._pnyxParameters.get("certTab");
/*     */     } catch (NullPointerException localNullPointerException) {
/* 198 */       _logger.info("No tabs configured from parameter.");
/*     */     }
/* 200 */     return tabs;
/*     */   }
/*     */ 
/*     */   public String getLangOptions()
/*     */   {
/* 209 */     String langOptions = null;
/*     */     try {
/* 211 */       langOptions = (String)this._pnyxParameters.get("langOptions");
/*     */     } catch (NullPointerException localNullPointerException) {
/* 213 */       _logger.info("No langOptions configured from parameter.");
/*     */     }
/* 215 */     return langOptions;
/*     */   }
/*     */ 
/*     */   public String[][] getParameterInfo()
/*     */   {
/* 220 */     return new String[][] { { "parenturl", String.class.getName(), "The url with wich the user reached the parent frame. It contains all the parameters: electionId, institutionId, siteLanguage, password, pin and username" } };
/*     */   }
/*     */ 
/*     */   public void setLocale(Locale paramLocale)
/*     */   {
/* 240 */     if (this._context == null)
/*     */     {
/* 242 */       paramLocale = paramLocale;
/*     */     }
/* 244 */     else paramLocale = this._context.getLocaleProvider().provide(paramLocale);
/*     */ 
/* 246 */     super.setLocale(paramLocale);
/*     */   }
/*     */ 
/*     */   public ElectoralScope getElectoralScope()
/*     */   {
/* 256 */     return this._electoralScope;
/*     */   }
/*     */ 
/*     */   public Map<String, String> getPnyxParameters() {
/* 260 */     return this._pnyxParameters;
/*     */   }
/*     */ 
/*     */   public void pickElection(String electionId, String language)
/*     */   {
/* 277 */     _logger.info("THREAD: accessing to pickElection");
/* 278 */     this._helperThread.pickElection(electionId, language);
/*     */   }
/*     */ 
/*     */   protected final void pickElection(String electionId, String language, MessageType messageType)
/*     */   {
/* 284 */     _logger.info("THREAD: accessing pickElection");
/* 285 */     this._helperThread.pickElection(electionId, null, messageType);
/*     */   }
/*     */ 
/*     */   public void login(LoginData loginData)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 303 */     _logger.info("THREAD: accessing login");
/* 304 */     this._helperThread.login(loginData);
/*     */   }
/*     */ 
/*     */   public void validateVote(String paramString)
/*     */     throws PnyxProtocolException
/*     */   {
/* 316 */     AccessController.doPrivileged(new PrivilegedAction(paramString)
/*     */     {
/*     */       public Boolean run()
/*     */       {
/*     */         try {
/* 321 */           if (PnyxClientApplet.this._context.getShowingView() != null) {
/* 322 */             PnyxClientApplet.this._context.getShowingView().requestFocus();
/* 323 */             PnyxClientApplet._logger.debug("The Applet should be closed. Skipping validation.");
/*     */           }
/*     */           else
/*     */           {
/*     */             try {
/* 328 */               PnyxClientApplet.this._context.getPnyxClient().validateVote(UrlEncodedVote.decode(this.val$voteRequest, PnyxClientApplet.this._ballot));
/*     */             }
/*     */             catch (ValidatorException ve)
/*     */             {
/* 332 */               String view = "voteValidation";
/* 333 */               if (PnyxClientApplet.this._ballot.isDelegation()) {
/* 334 */                 view = "delegationValidation";
/*     */               }
/* 336 */               PnyxClientApplet.this.showView(view, "voteValidationText", ErrorMessageFormatter.formatErrors$461a1953(ve, PnyxClientApplet.this.getMessageSource$3561bc63(), PnyxClientApplet.this.getLocale()));
/*     */             }
/*     */ 
/*     */           }
/*     */ 
/*     */         }
/*     */         catch (PnyxProtocolException ppe)
/*     */         {
/* 344 */           PnyxClientApplet._logger.error("Pnyx protocol exception:", ppe);
/* 345 */           ((AppletWithNewPortalCallback)PnyxClientApplet.this._context.getPostCallback()).displayFriendlyException$75168644(ppe, PnyxClientApplet.this.getMessageSource$3561bc63(), PnyxClientApplet.this.getLocale());
/*     */         }
/*     */         catch (Exception localException1)
/*     */         {
/*     */           Exception e;
/* 348 */           (
/* 349 */             e = 
/* 351 */             localException1).printStackTrace();
/* 350 */           PnyxClientApplet._logger.error("Pnyx protocol exception:", e);
/*     */         }
/*     */ 
/* 353 */         return Boolean.valueOf(true);
/*     */       }
/*     */     });
/*     */   }
/*     */ 
/*     */   public void discardVote() {
/*     */     try {
/* 361 */       this._context.getPnyxClient().discardVote();
/*     */ 
/* 364 */       return;
/*     */     }
/*     */     catch (PnyxProtocolException this)
/*     */     {
/* 363 */       _logger.error("Error while discarding the vote.", this);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void discardElection() throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/* 369 */     _logger.info("THREAD: accessing discard election");
/* 370 */     this._helperThread.discardElection();
/*     */   }
/*     */ 
/*     */   public void confirmVote(Ballot paramBallot)
/*     */   {
/* 375 */     String str = "confirmVote";
/* 376 */     if (paramBallot.isDelegation())
/* 377 */       str = "confirmDelegation";
/*     */     HashMap localHashMap;
/* 379 */     (
/* 380 */       localHashMap = new HashMap())
/* 380 */       .put("voteText", getAppletProperties().getLocalizedBallotSummary(paramBallot).getSummary(getLocale()));
/*     */ 
/* 383 */     localHashMap.put("electionName", paramBallot.getElectionName().getLocalizedMessage(getLocale()));
/*     */ 
/* 386 */     if (isAccessible()) {
/* 387 */       new SwingConfirmVote(this).show(localHashMap); return;
/*     */     }
/* 389 */     showView(str, localHashMap);
/*     */   }
/*     */ 
/*     */   public void vote()
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 401 */     this._context.getPnyxClient().castVote();
/*     */   }
/*     */ 
/*     */   public void showReceipt(VoteReceipt paramVoteReceipt) {
/* 405 */     if (paramVoteReceipt.getShowReceipt()) {
/* 406 */       if (isAccessible()) {
/* 407 */         new SwingVoteReceipt(this).show("voteReceipt", paramVoteReceipt); return;
/*     */       }
/*     */ 
/* 410 */       showView("receipt", "voteReceipt", paramVoteReceipt); return;
/*     */     }
/*     */ 
/* 414 */     showView("alternate_receipt", "voteReceipt", paramVoteReceipt);
/*     */   }
/*     */ 
/*     */   public void nextElection()
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/* 427 */     this._context.getPnyxClient().nextElection();
/*     */   }
/*     */ 
/*     */   public void logout()
/*     */     throws PnyxProtocolException
/*     */   {
/* 436 */     this._context.getPnyxClient().logout();
/*     */   }
/*     */ 
/*     */   public void showLogin() {
/* 440 */     if (isAccessible()) {
/* 441 */       new SwingLogin(this).show(getPnyxParameters()); return;
/*     */     }
/* 443 */     showView("login", getPnyxParameters());
/*     */   }
/*     */ 
/*     */   protected final void showView(String viewName, String key, Object value)
/*     */   {
/* 449 */     this._context.resolveView$7e748853(viewName).show(key, value);
/*     */   }
/*     */ 
/*     */   protected final void showView(String viewName, Map<String, ? extends Object> attributes)
/*     */   {
/* 454 */     this._context.resolveView$7e748853(viewName).show(attributes);
/*     */   }
/*     */ 
/*     */   public void stop()
/*     */   {
/* 459 */     _logger.info("Stop called");
/* 460 */     super.stop();
/* 461 */     KeystoreHolder.getInstance().resetKeystore();
/* 462 */     _logger.info("Stop finished");
/*     */   }
/*     */ 
/*     */   public void destroy()
/*     */   {
/* 472 */     _logger.info("Destroy called");
/* 473 */     super.destroy();
/* 474 */     KeystoreHolder.getInstance().resetKeystore();
/* 475 */     getContentPane().removeAll();
/* 476 */     this._context.destroy();
/* 477 */     this._context = null;
/*     */ 
/* 479 */     this._helperThread.interrupt();
/* 480 */     _logger.info("Destroy finished");
/*     */   }
/*     */ 
/*     */   public List<Locale> getAvailableLocales() {
/* 484 */     return this._context.getLocaleProvider().getConfigurationProperties().getSupportedLocales();
/*     */   }
/*     */ 
/*     */   public AppletProperties getAppletProperties()
/*     */   {
/* 489 */     return this._context.getAppletProperties();
/*     */   }
/*     */ 
/*     */   public ASN1Dump getMessageSource$3561bc63() {
/* 493 */     return this._context.getMessageSource$3561bc63();
/*     */   }
/*     */ 
/*     */   public void setBallot(Ballot ballot)
/*     */   {
/* 501 */     this._ballot = ballot;
/*     */   }
/*     */ 
/*     */   public URL getParentURL()
/*     */   {
/* 510 */     return this._parentURL;
/*     */   }
/*     */ 
/*     */   private boolean isAccessible()
/*     */   {
/* 516 */     return ((
/* 516 */       this = (String)this._pnyxParameters.get("accessible")) != null) && 
/* 516 */       (Boolean.valueOf(this).booleanValue());
/*     */   }
/*     */ 
/*     */   class HelperThread extends Thread
/*     */   {
/*     */     HelperThread()
/*     */     {
/*     */     }
/*     */ 
/*     */     public void run()
/*     */     {
/*     */       try
/*     */       {
/*     */         while (true)
/* 540 */           Thread.sleep(5000L);
/*     */       }
/*     */       catch (InterruptedException localInterruptedException1)
/*     */       {
/*     */         InterruptedException e;
/* 541 */         (
/* 543 */           e = 
/* 545 */           localInterruptedException1).printStackTrace();
/*     */       }
/*     */     }
/*     */ 
/*     */     public void discardElection()
/*     */       throws PnyxProtocolException, ApplicationProtocolException
/*     */     {
/* 556 */       AccessController.doPrivileged(new PrivilegedAction()
/*     */       {
/*     */         public Boolean run()
/*     */         {
/*     */           try {
/* 561 */             PnyxClientApplet.this._context.getPnyxClient().discardElection();
/*     */           }
/*     */           catch (PnyxProtocolException e)
/*     */           {
/*     */             PnyxProtocolException e;
/* 563 */             PnyxClientApplet._logger.error("Error discarding election: " + getCause());
/*     */ 
/* 566 */             printStackTrace();
/*     */           }
/*     */           catch (ApplicationProtocolException e)
/*     */           {
/*     */             ApplicationProtocolException e;
/* 568 */             PnyxClientApplet._logger.error("Error discarding election: " + getCause());
/*     */ 
/* 571 */             printStackTrace();
/*     */           }
/* 573 */           return Boolean.valueOf(true);
/*     */         }
/*     */       });
/*     */     }
/*     */ 
/*     */     public void chooseElection(String paramString1, String paramString2, String paramString3, MessageType paramMessageType)
/*     */       throws ApplicationProtocolException, PnyxProtocolException
/*     */     {
/* 592 */       (
/* 593 */         this = PnyxClientApplet.this._context.getPnyxClient())
/* 593 */         .pickElection(new ElectoralScope(paramString1, paramString2, paramString3));
/*     */ 
/* 595 */       produceBallot(paramMessageType);
/*     */     }
/*     */ 
/*     */     public void pickElection(String electionId, String language)
/*     */     {
/* 605 */       pickElection(electionId, language, MessageType.VOTE);
/*     */     }
/*     */ 
/*     */     public void login(LoginData paramLoginData)
/*     */       throws ApplicationProtocolException, PnyxProtocolException
/*     */     {
/* 616 */       PnyxClientStateMachine localPnyxClientStateMachine = PnyxClientApplet.this._context.getPnyxClient();
/*     */       ElectoralScope localElectoralScope;
/* 618 */       if ((
/* 618 */         localElectoralScope = PnyxClientApplet.this.getElectoralScope())
/* 618 */         .knowsTheElection()) {
/* 619 */         localPnyxClientStateMachine.login(paramLoginData, localElectoralScope);
/* 620 */         pickElection(localElectoralScope.getElectionId(), PnyxClientApplet.this.getLocale().getLanguage()); return;
/*     */       }
/*     */ 
/* 623 */       localPnyxClientStateMachine.login(paramLoginData, localElectoralScope);
/*     */     }
/*     */ 
/*     */     public void pickElection(String paramString1, String paramString2, MessageType paramMessageType)
/*     */     {
/* 636 */       AccessController.doPrivileged(new PrivilegedAction(paramString2, paramString1, paramMessageType)
/*     */       {
/*     */         public Boolean run()
/*     */         {
/* 641 */           PnyxClientApplet._logger.info("THREAD: Running pick election with prileges");
/*     */ 
/* 643 */           if (this.val$language != null)
/* 644 */             PnyxClientApplet.this.setLocale(new Locale(this.val$language));
/*     */           try
/*     */           {
/* 647 */             PnyxClientApplet.HelperThread.this.chooseElection(null, this.val$electionId, null, this.val$messageType);
/*     */           }
/*     */           catch (ApplicationProtocolException ape) {
/* 650 */             PnyxClientApplet._logger.error("Application protocol exception: ", ape);
/*     */ 
/* 652 */             ((AppletWithNewPortalCallback)PnyxClientApplet.this._context.getPostCallback()).displayFriendlyException$75168644(ape, PnyxClientApplet.this.getMessageSource$3561bc63(), PnyxClientApplet.this.getLocale());
/*     */           }
/*     */           catch (PnyxProtocolException ppe)
/*     */           {
/* 657 */             PnyxClientApplet._logger.error("Pnyx protocol exception:", ppe);
/* 658 */             ((AppletWithNewPortalCallback)PnyxClientApplet.this._context.getPostCallback()).displayFriendlyException$75168644(ppe, PnyxClientApplet.this.getMessageSource$3561bc63(), PnyxClientApplet.this.getLocale());
/*     */           }
/*     */ 
/* 663 */           return Boolean.valueOf(true);
/*     */         }
/*     */       });
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.PnyxClientApplet
 * JD-Core Version:    0.6.0
 */