/*     */ package com.scytl.voting.applet.view.thinlet;
/*     */ 
/*     */ import com.scytl.AbstractLocalizableException;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.ApplicationProtocolException;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import com.scytl.print.PrintManager;
/*     */ import com.scytl.voting.applet.PnyxClientApplet;
/*     */ import com.scytl.voting.applet.view.printable.PrintableReceiptFactory;
/*     */ import java.awt.print.PrinterException;
/*     */ import java.io.IOException;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public abstract class AbstractReceipt extends RestartablePnyxClientAppletView
/*     */ {
/*     */   public static final int RECEIPT_LINE_WIDTH = 105;
/*     */   public static final String ELECTION_NAME_TEXT_AREA_NAME = "electionName";
/*     */   public static final String NEXT_ELECTION_BUTTON_NAME = "nextElectionButton";
/*     */   public static final String VOTE_RECEIPT_NAME = "voteReceipt";
/*  51 */   private static Log _logger = LogFactory.getLog(AbstractReceipt.class);
/*     */   private VoteReceipt _voteReceipt;
/*     */ 
/*     */   public AbstractReceipt(PnyxClientApplet applet)
/*     */   {
/*  61 */     super(applet);
/*     */   }
/*     */ 
/*     */   public void print()
/*     */   {
/*  68 */     _logger.debug("PRINT action");
/*     */     try { PrintManager.printWithDialog(PrintableReceiptFactory.createPrintableReceipt(getResourceBundle(), this._voteReceipt));
/*     */ 
/*  76 */       _logger.debug("PRINT action... done.");
/*     */ 
/*  84 */       return;
/*     */     }
/*     */     catch (IOException localIOException)
/*     */     {
/*  78 */       _logger.error("The printing couldn't access a necessary resource!", localIOException);
/*     */ 
/*  80 */       displayError("error.printing.failed");
/*     */ 
/*  84 */       return;
/*     */     }
/*     */     catch (PrinterException localPrinterException)
/*     */     {
/*  82 */       _logger.error("An error has occurred while printing!", localPrinterException);
/*  83 */       displayError("error.printing.failed");
/*     */     }
/*     */   }
/*     */ 
/*     */   public void nextElection() {
/*  88 */     _logger.debug("NEXT ELECTION action");
/*     */     try {
/*  90 */       ((PnyxClientApplet)this._applet).nextElection();
/*  91 */       dispose();
/*     */ 
/*  94 */       return;
/*     */     }
/*     */     catch (AbstractLocalizableException localAbstractLocalizableException)
/*     */     {
/*  93 */       displayError(localAbstractLocalizableException.getLocalizedMessage(getResourceBundle()), localAbstractLocalizableException);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void exit() {
/*  98 */     _logger.debug("EXIT action");
/*     */     try {
/* 100 */       ((PnyxClientApplet)this._applet).discardElection();
/* 101 */       dispose();
/*     */ 
/* 106 */       return;
/*     */     }
/*     */     catch (PnyxProtocolException localPnyxProtocolException)
/*     */     {
/* 103 */       displayError(localPnyxProtocolException.getLocalizedMessage(getResourceBundle()), localPnyxProtocolException);
/*     */ 
/* 106 */       return;
/*     */     }
/*     */     catch (ApplicationProtocolException localApplicationProtocolException)
/*     */     {
/* 105 */       displayError(localApplicationProtocolException.getLocalizedMessage(getResourceBundle()), localApplicationProtocolException);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void logout() {
/* 110 */     _logger.debug("LOGOUT action");
/*     */     try {
/* 112 */       ((PnyxClientApplet)this._applet).logout();
/* 113 */       dispose();
/*     */ 
/* 116 */       return;
/*     */     }
/*     */     catch (PnyxProtocolException localPnyxProtocolException)
/*     */     {
/* 115 */       displayError(localPnyxProtocolException.getLocalizedMessage(getResourceBundle()), localPnyxProtocolException);
/*     */     }
/*     */   }
/*     */ 
/*     */   protected final void setVoteReceipt(VoteReceipt voteReceipt)
/*     */   {
/* 124 */     this._voteReceipt = voteReceipt;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.view.thinlet.AbstractReceipt
 * JD-Core Version:    0.6.0
 */