/*     */ package com.scytl.xml.marshalling.eml.model;
/*     */ 
/*     */ import B;
/*     */ import com.scytl.common.domain.OverVoteTypes;
/*     */ import com.scytl.common.domain.UnderVoteTypes;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Answer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Area;
/*     */ import com.scytl.common.domain.hibernate.entity.election.DelegationChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.GroupQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.OpenTextQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.common.domain.hibernate.entity.election.TextAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.WriteInAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import com.scytl.xml.marshalling.eml.EmlUtils;
/*     */ import com.scytl.xml.marshalling.eml.ScytlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlValues.MessageTypes;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import javax.xml.namespace.QName;
/*     */ import org.apache.commons.codec.binary.BaseNCodec;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class ContestBuilder
/*     */ {
/*  65 */   private static final Log LOGGER = LogFactory.getLog(ContestBuilder.class);
/*     */ 
/*  68 */   private Integer _maxVotes = null;
/*     */ 
/*  70 */   private Integer _minVotes = Integer.valueOf(1);
/*     */   private Integer _maxWriteIn;
/*     */   private Integer _displayOrder;
/*     */   private final Set<Area> _areas;
/*  79 */   private final Map<ScytlValues.MessageTypes, Message> _messages = new HashMap();
/*     */   private String _questionType;
/*     */   private Integer _status;
/*     */   private Boolean _pageBreak;
/*     */   private String _viewType;
/*     */   private String _styleName;
/*     */   private Integer _numberOfLines;
/*     */   private Integer _minWriteIn;
/*     */   private String _id;
/*     */   private final List<Answer> _answers;
/*     */   private Integer _defaultAnswerIndex;
/* 104 */   private VotingMethodType _votingMethod = VotingMethodType.other;
/*     */ 
/* 106 */   private UnderVoteTypes _undervotetype = null;
/*     */ 
/* 110 */   private OverVoteTypes _overvotetype = null;
/*     */   private byte[] _image;
/*     */   private String _imageType;
/*     */   private byte[] _additionalImage;
/*     */   private String _additionalImageType;
/* 155 */   private Integer _listsHeaderHeight = null;
/*     */ 
/* 160 */   private Integer _listsHeight = null;
/*     */ 
/* 165 */   private Integer _listsWidth = null;
/*     */ 
/*     */   public final void setUndervotetype(UnderVoteTypes undervotetype)
/*     */   {
/*  54 */     this._undervotetype = undervotetype;
/*     */   }
/*     */ 
/*     */   public final void setOvervotetype(OverVoteTypes overvotetype)
/*     */   {
/*  62 */     this._overvotetype = overvotetype;
/*     */   }
/*     */ 
/*     */   public final void setAdditionalImage(byte[] paramArrayOfByte)
/*     */   {
/* 132 */     this._additionalImage = cloneByteArray(paramArrayOfByte);
/*     */   }
/*     */ 
/*     */   public final void setAdditionalImageType(String additionalImageType)
/*     */   {
/* 147 */     this._additionalImageType = additionalImageType;
/*     */   }
/*     */ 
/*     */   public ContestBuilder()
/*     */   {
/* 168 */     this._areas = new HashSet();
/* 169 */     this._answers = new LinkedList();
/*     */   }
/*     */ 
/*     */   public final Question buildQuestion()
/*     */   {
/*     */     Object localObject1;
/*     */     Object localObject3;
/* 173 */     if (this._questionType.equalsIgnoreCase("FreeText"))
/*     */     {
/* 176 */       localObject2 = (OpenTextQuestion)BaseNCodec.createQuestion(OpenTextQuestion.class); localObject1 = this; ((OpenTextQuestion)localObject2).setMinAnswerCharacters(((ContestBuilder)localObject1)._minWriteIn); ((OpenTextQuestion)localObject2).setMaxAnswerCharacters(((ContestBuilder)localObject1)._maxWriteIn); localObject1 = localObject2;
/*     */     }
/* 179 */     else if (this._questionType.equalsIgnoreCase("GroupQuestion"))
/*     */     {
/* 181 */       localObject1 = BaseNCodec.createQuestion(GroupQuestion.class);
/* 182 */     } else if (this._questionType.equalsIgnoreCase("DelegationChoice"))
/*     */     {
/* 184 */       localObject2 = (DelegationChoiceQuestion)BaseNCodec.createQuestion(DelegationChoiceQuestion.class); localObject1 = this; localObject3 = new ArrayList(); for (localObject1 = ((ContestBuilder)localObject1)._answers.iterator(); ((Iterator)localObject1).hasNext(); )
/*     */       {
/* 184 */         Object localObject4;
/* 184 */         if (((localObject4 = (Answer)((Iterator)localObject1).next()) instanceof TextAnswer)) { ((List)localObject3).add((TextAnswer)localObject4); continue; } if ((localObject4 instanceof WriteInAnswer)) { localObject4 = (WriteInAnswer)localObject4; if (ScytlQName.CORPORATE_DELEGATE_ID.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegateId((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_NAME.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegateName((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_EMAIL.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegateMail((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_PHONE.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegatePhone((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_EXTRA1.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegateExtra1((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_EXTRA2.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) { ((DelegationChoiceQuestion)localObject2).setDelegateExtra2((WriteInAnswer)localObject4); continue; } if (ScytlQName.CORPORATE_DELEGATE_OBSERVATIONS.getLocalPart().equalsIgnoreCase(((WriteInAnswer)localObject4).getDelegateAnswerType())) ((DelegationChoiceQuestion)localObject2).setObservations((WriteInAnswer)localObject4);  } 
/*     */       }
/* 184 */       ((DelegationChoiceQuestion)localObject2).setBoardMembers((List)localObject3); localObject1 = localObject2;
/*     */     }
/*     */     else
/*     */     {
/* 188 */       localObject2 = (MultipleChoiceQuestion)BaseNCodec.createQuestion(MultipleChoiceQuestion.class); localObject1 = this; if (this._votingMethod != null) switch (ContestBuilder.1.$SwitchMap$com$scytl$xml$marshalling$eml$model$VotingMethodType[localObject1._votingMethod.ordinal()]) { case 1:
/* 188 */           ((MultipleChoiceQuestion)localObject2).setPreferential(true); break;
/*     */         case 2:
/* 188 */           ((MultipleChoiceQuestion)localObject2).setCumulativePoints(((ContestBuilder)localObject1)._maxVotes.intValue()); } ((MultipleChoiceQuestion)localObject2).setMinAnswers(((ContestBuilder)localObject1)._minVotes); if ((((ContestBuilder)localObject1)._votingMethod != null) && (!((ContestBuilder)localObject1)._votingMethod.equals(VotingMethodType.cumulative))) ((MultipleChoiceQuestion)localObject2).setMaxAnswers(((ContestBuilder)localObject1)._maxVotes); ((MultipleChoiceQuestion)localObject2).setAnswers(((ContestBuilder)localObject1)._answers); ((MultipleChoiceQuestion)localObject2).setOvervoteType(((ContestBuilder)localObject1)._overvotetype); localObject1 = localObject2;
/*     */     }
/*     */ 
/* 193 */     ((Question)localObject1).setId(this._id);
/*     */ 
/* 195 */     Object localObject2 = (
/* 195 */       localObject2 = (Message)this._messages.get(ScytlValues.MessageTypes.TITLE)) == null
/* 195 */        ? null : localObject2;
/* 196 */     ((Question)localObject1).setTitle((Message)localObject2);
/* 197 */     ((Question)localObject1).setText((Message)this._messages.get(ScytlValues.MessageTypes.TEXT));
/* 198 */     ((Question)localObject1).setDescription((Message)this._messages.get(ScytlValues.MessageTypes.DESCRIPTION));
/* 199 */     if (this._messages.get(ScytlValues.MessageTypes.ADDITIONAL_INFORMATION) != null) {
/* 200 */       ((Question)localObject1).setAdditionalInformation((Message)this._messages.get(ScytlValues.MessageTypes.ADDITIONAL_INFORMATION));
/*     */     }
/*     */     else {
/* 203 */       ((Question)localObject1).setAdditionalInformation(null);
/*     */     }
/* 205 */     if (this._messages.get(ScytlValues.MessageTypes.CUSTOM_BLANK_VOTE_MESSAGE) != null) {
/* 206 */       ((Question)localObject1).setCustomBlankVoteMessage((Message)this._messages.get(ScytlValues.MessageTypes.CUSTOM_BLANK_VOTE_MESSAGE));
/*     */     }
/*     */     else {
/* 209 */       ((Question)localObject1).setCustomBlankVoteMessage(null);
/*     */     }
/* 211 */     (
/* 215 */       localObject2 = new EmlUtils(this._displayOrder))
/* 215 */       .getOrderInPage();
/* 216 */     ((EmlUtils)localObject2).getPage();
/* 217 */     ((Question)localObject1).setImage(this._image);
/*     */ 
/* 221 */     ((Question)localObject1).setImage(this._additionalImage);
/*     */ 
/* 224 */     for (this = this._areas.iterator(); hasNext(); )
/*     */     {
/* 227 */       if ((
/* 227 */         localObject2 = (Area)next())
/* 227 */         .getId() == null) {
/* 228 */         localObject3 = localObject2; LOGGER.warn("AREA :: " + null + " has no ID");
/*     */       }
/* 230 */       ((Question)localObject1).addArea((Area)localObject2);
/*     */     }
/*     */ 
/* 234 */     return (Question)(Question)(Question)(Question)localObject1;
/*     */   }
/*     */ 
/*     */   public final void setMinWriteIn(Integer minWriteIn)
/*     */   {
/* 323 */     this._minWriteIn = minWriteIn;
/*     */   }
/*     */ 
/*     */   public final void setNumberOfLines(String numberOfLines) {
/* 327 */     this._numberOfLines = Integer.valueOf(numberOfLines);
/*     */   }
/*     */ 
/*     */   public final void setStyleName(String styleName) {
/* 331 */     this._styleName = styleName;
/*     */   }
/*     */ 
/*     */   public final void setViewType(String viewType) {
/* 335 */     this._viewType = viewType;
/*     */   }
/*     */ 
/*     */   public final void setPageBreak(String pageBreak) {
/* 339 */     this._pageBreak = Boolean.valueOf(pageBreak);
/*     */   }
/*     */ 
/*     */   public final void setId(String id) {
/* 343 */     this._id = id;
/*     */   }
/*     */ 
/*     */   public final void setStatus(String status) {
/* 347 */     this._status = Integer.valueOf(status);
/*     */   }
/*     */ 
/*     */   public final void setQuestionType(String questionType) {
/* 351 */     this._questionType = questionType;
/*     */   }
/*     */ 
/*     */   public final Area getArea(String areaId)
/*     */   {
/* 359 */     this = areaId; this = this; return null;
/*     */   }
/*     */ 
/*     */   public final void setDisplayOrder(String displayOrder)
/*     */   {
/* 379 */     this._displayOrder = Integer.valueOf(displayOrder);
/*     */   }
/*     */ 
/*     */   public final void setMaxWriteIn(String maxWriteIn) {
/* 383 */     this._maxWriteIn = Integer.valueOf(maxWriteIn);
/*     */   }
/*     */ 
/*     */   public final void setMaxVotes(String maxVotes) {
/* 387 */     this._maxVotes = Integer.valueOf(maxVotes);
/*     */   }
/*     */ 
/*     */   public final void setMinVotes(String minVotes) {
/* 391 */     this._minVotes = Integer.valueOf(minVotes);
/*     */   }
/*     */ 
/*     */   public final void addAnswers(List<Answer> paramList)
/*     */   {
/* 405 */     this._answers.addAll(paramList);
/*     */   }
/*     */ 
/*     */   public final void addMessages(Map<ScytlValues.MessageTypes, Message> msgs)
/*     */   {
/* 415 */     this._messages.putAll(msgs);
/*     */   }
/*     */ 
/*     */   public final void setDefaultAnswerIndex(String answerIndex) {
/* 419 */     this._defaultAnswerIndex = Integer.valueOf(answerIndex);
/*     */   }
/*     */ 
/*     */   public final void setVotingMethod(String votingMethod)
/*     */   {
/* 426 */     this._votingMethod = VotingMethodType.valueOf(votingMethod);
/*     */   }
/*     */ 
/*     */   public final void setImage(byte[] paramArrayOfByte)
/*     */   {
/* 444 */     this._image = cloneByteArray(paramArrayOfByte);
/*     */   }
/*     */ 
/*     */   public final void setImageType(String imageType) {
/* 448 */     this._imageType = imageType;
/*     */   }
/*     */ 
/*     */   public final void setListsHeaderHeight(Integer listsHeaderHeight)
/*     */   {
/* 463 */     this._listsHeaderHeight = listsHeaderHeight;
/*     */   }
/*     */ 
/*     */   public final void setListsHeight(Integer listsHeight)
/*     */   {
/* 478 */     this._listsHeight = listsHeight;
/*     */   }
/*     */ 
/*     */   public final void setListsWidth(Integer listsWidth)
/*     */   {
/* 493 */     this._listsWidth = listsWidth;
/*     */   }
/*     */ 
/*     */   private static byte[] cloneByteArray(byte[] input) {
/* 497 */     byte[] result = null;
/* 498 */     if (input != null) {
/* 499 */       result = (byte[])input.clone();
/*     */     }
/* 501 */     return result;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.eml.model.ContestBuilder
 * JD-Core Version:    0.6.0
 */