/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlValues.StatusTypes;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.exception.UnsupportedValueException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*     */ import com.scytl.xml.marshalling.stax.scytl.model.AnswerOthers;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public abstract class StaxItEmlAbstractAnswer<A> extends StaxItElementDeserializer<A>
/*     */ {
/*  33 */   private static final Log LOGGER = LogFactory.getLog(StaxItEmlAbstractAnswer.class);
/*     */ 
/*     */   protected final void consumeDisplayOrder(QName answerType, StaxItDeserializationContext ctx)
/*     */     throws DeserializationException, NumberFormatException, XMLStreamException
/*     */   {
/*     */     StaxItDeserializationContext ctx;
/*  47 */     this = requireElementAttribute(answerType, EmlQName.ATTRIB__DISPLAY_ORDER, ctx);
/*     */ 
/*  50 */     if (LOGGER.isDebugEnabled())
/*     */     {
/*  52 */       LOGGER.debug("Display order for " + answerType + " is: " + displayOrder + " but it will be ignored.");
/*     */     }
/*     */   }
/*     */ 
/*     */   private static int translateStatus(String statusValue)
/*     */     throws DeserializationException
/*     */   {
/*     */     try
/*     */     {
/*  76 */       return ScytlValues.StatusTypes.parse(statusValue).intValue();
/*     */     }
/*     */     catch (UnsupportedValueException statusValue)
/*     */     {
/*     */     }
/*     */     UnsupportedValueException e;
/*  78 */     throw new DeserializationException("Invalid value for tag scytl:Status.", statusValue);
/*     */   }
/*     */ 
/*     */   protected final void deserializeCommonOther(AnswerOthers paramAnswerOthers, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  89 */     if ((
/*  89 */       str1 = getElementValue(ScytlQName.MIN_WRITE_IN, paramStaxItDeserializationContext)) != null)
/*     */     {
/*  90 */       paramAnswerOthers.setMinWriteIn(Integer.valueOf(str1));
/*     */     }
/*     */ 
/*  95 */     if ((
/*  95 */       str1 = getElementValue(ScytlQName.MAX_WRITE_IN, paramStaxItDeserializationContext)) != null)
/*     */     {
/*  96 */       paramAnswerOthers.setMaxWriteIn(Integer.valueOf(str1));
/*     */     }
/*     */ 
/* 100 */     String str1 = getElementValue(ScytlQName.VIEW_TYPE, paramStaxItDeserializationContext);
/* 101 */     paramAnswerOthers.setViewType(str1);
/*     */ 
/* 105 */     if ((
/* 105 */       str1 = getElementValue(ScytlQName.NUMBER_OF_LINES, paramStaxItDeserializationContext)) != null)
/*     */     {
/* 106 */       paramAnswerOthers.setNumberOfLines(Integer.decode(str1));
/*     */     }
/*     */ 
/* 114 */     int i = translateStatus(str1 = requireElementValue(ScytlQName.ANSWER_STATUS, paramStaxItDeserializationContext));
/*     */ 
/* 115 */     paramAnswerOthers.setStatus(i);
/*     */     String str2;
/* 118 */     if ((
/* 118 */       str2 = getElementValue(ScytlQName.STYLE_NAME, paramStaxItDeserializationContext)) != null)
/*     */     {
/* 119 */       paramAnswerOthers.setStyleName(str2);
/*     */     }
/*     */ 
/* 123 */     if ((
/* 123 */       str2 = getElementValue(ScytlQName.BLANK, paramStaxItDeserializationContext)) != null)
/*     */     {
/* 124 */       paramAnswerOthers.setBlank(Boolean.parseBoolean(str2));
/*     */     }
/*     */ 
/* 128 */     if ((
/* 128 */       str2 = getElementValue(ScytlQName.NULLER, paramStaxItDeserializationContext)) != null)
/*     */     {
/* 129 */       paramAnswerOthers.setNuller(Boolean.parseBoolean(str2));
/*     */     }
/*     */ 
/* 132 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_ID, paramStaxItDeserializationContext)) {
/* 133 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_ID.getLocalPart());
/*     */ 
/* 135 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_ID, paramStaxItDeserializationContext);
/*     */     }
/* 137 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_NAME, paramStaxItDeserializationContext)) {
/* 138 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_NAME.getLocalPart());
/*     */ 
/* 141 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_NAME, paramStaxItDeserializationContext);
/*     */     }
/* 143 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_EMAIL, paramStaxItDeserializationContext)) {
/* 144 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_EMAIL.getLocalPart());
/*     */ 
/* 147 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_EMAIL, paramStaxItDeserializationContext);
/*     */     }
/* 149 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_PHONE, paramStaxItDeserializationContext)) {
/* 150 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_PHONE.getLocalPart());
/*     */ 
/* 153 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_PHONE, paramStaxItDeserializationContext);
/*     */     }
/* 155 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_EXTRA1, paramStaxItDeserializationContext)) {
/* 156 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_EXTRA1.getLocalPart());
/*     */ 
/* 159 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_EXTRA1, paramStaxItDeserializationContext);
/*     */     }
/*     */ 
/* 162 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_EXTRA2, paramStaxItDeserializationContext)) {
/* 163 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_EXTRA2.getLocalPart());
/*     */ 
/* 166 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_EXTRA2, paramStaxItDeserializationContext);
/*     */     }
/* 168 */     if (nextEqualsQName(ScytlQName.CORPORATE_DELEGATE_OBSERVATIONS, paramStaxItDeserializationContext))
/*     */     {
/* 170 */       paramAnswerOthers.setDelegateAnswerType(ScytlQName.CORPORATE_DELEGATE_OBSERVATIONS.getLocalPart());
/*     */ 
/* 173 */       ignoreUntilEndTag(ScytlQName.CORPORATE_DELEGATE_OBSERVATIONS, paramStaxItDeserializationContext);
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlAbstractAnswer
 * JD-Core Version:    0.6.0
 */