/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.common.domain.auth.data.Address;
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.XalQName;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ 
/*     */ public final class StaxItEmlAddressDetails extends StaxItElementDeserializer<Address>
/*     */ {
/*  34 */   private static final StaxItEmlAddressDetails MAILING_ADDRESS = new StaxItEmlAddressDetails(EmlQName.MAILING_ADDRESS);
/*     */ 
/*  37 */   private static final StaxItEmlAddressDetails QUALIFYING_ADDRESS = new StaxItEmlAddressDetails(EmlQName.QUALIFYING_ADDRESS);
/*     */   private final QName _enclosingTagQName;
/*     */ 
/*     */   private StaxItEmlAddressDetails(QName enclosingTagQName)
/*     */   {
/*  45 */     this._enclosingTagQName = enclosingTagQName;
/*     */   }
/*     */ 
/*     */   public static StaxItEmlAddressDetails getMailingAddressInstance() {
/*  49 */     return MAILING_ADDRESS;
/*     */   }
/*     */ 
/*     */   public static StaxItEmlAddressDetails getQualifyingAddressInstance() {
/*  53 */     return QUALIFYING_ADDRESS;
/*     */   }
/*     */ 
/*     */   public final void deserialize(Address paramAddress, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  61 */     requireElement(this._enclosingTagQName, paramStaxItDeserializationContext);
/*  62 */     if (nextEqualsQName(XalQName.COUNTRY, paramStaxItDeserializationContext)) {
/*  63 */       requireElement(XalQName.COUNTRY, paramStaxItDeserializationContext);
/*     */ 
/*  66 */       paramAddress.setStreet(getValueConditionally(XalQName.ADDRESS_LINE, XalQName.ATTRIB__TYPE, "Street", paramStaxItDeserializationContext));
/*     */ 
/*  70 */       if (nextEqualsQName(XalQName.COUNTRY_NAME, paramStaxItDeserializationContext)) {
/*  71 */         requireOptionalValue(XalQName.COUNTRY_NAME, paramStaxItDeserializationContext, false);
/*     */       }
/*     */ 
/*  75 */       if (nextEqualsQName(XalQName.ADMINISTRATIVE_AREA, paramStaxItDeserializationContext)) {
/*  76 */         requireElement(XalQName.ADMINISTRATIVE_AREA, paramStaxItDeserializationContext);
/*  77 */         requireOptionalValue(XalQName.ADMINISTRATIVE_AREA_NAME, paramStaxItDeserializationContext, false);
/*     */       }
/*     */ 
/*  82 */       if (nextEqualsQName(XalQName.SUB_ADMINISTRATIVE_AREA, paramStaxItDeserializationContext)) {
/*  83 */         requireElement(XalQName.SUB_ADMINISTRATIVE_AREA, paramStaxItDeserializationContext);
/*  84 */         requireOptionalValue(XalQName.SUB_ADMINISTRATIVE_AREA_NAME, paramStaxItDeserializationContext, false);
/*     */ 
/*  86 */         ignoreUntilEndTag(XalQName.SUB_ADMINISTRATIVE_AREA, paramStaxItDeserializationContext);
/*     */       }
/*     */ 
/*  90 */       if (nextEqualsQName(XalQName.LOCALITY, paramStaxItDeserializationContext)) {
/*  91 */         requireElement(XalQName.LOCALITY, paramStaxItDeserializationContext);
/*  92 */         requireOptionalValue(XalQName.LOCALITY_NAME, paramStaxItDeserializationContext, false);
/*     */       }
/*     */ 
/*  97 */       if (nextEqualsQName(XalQName.POST_BOX, paramStaxItDeserializationContext)) {
/*  98 */         requireElement(XalQName.POST_BOX, paramStaxItDeserializationContext);
/*  99 */         requireOptionalValue(XalQName.POST_BOX_NUMBER, paramStaxItDeserializationContext, false);
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 107 */     ignoreUntilEndTag(this._enclosingTagQName, paramStaxItDeserializationContext);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlAddressDetails
 * JD-Core Version:    0.6.0
 */