package org.bouncycastle.asn1.pkcs;

import org.bouncycastle.asn1.ASN1ObjectIdentifier;

public abstract interface PKCSObjectIdentifiers
{
  public static final ASN1ObjectIdentifier pkcs_1;
  public static final ASN1ObjectIdentifier pkcs_3;
  public static final ASN1ObjectIdentifier pkcs_5;
  public static final ASN1ObjectIdentifier encryptionAlgorithm;
  public static final ASN1ObjectIdentifier digestAlgorithm;
  public static final ASN1ObjectIdentifier pkcs_9;
  public static final ASN1ObjectIdentifier pkcs_9_at_emailAddress;
  public static final ASN1ObjectIdentifier pkcs_9_at_unstructuredName;
  public static final ASN1ObjectIdentifier pkcs_9_at_unstructuredAddress;
  public static final ASN1ObjectIdentifier certTypes;
  public static final ASN1ObjectIdentifier crlTypes;
  public static final ASN1ObjectIdentifier id_ct;
  public static final ASN1ObjectIdentifier id_cti;
  public static final ASN1ObjectIdentifier id_aa;
  public static final ASN1ObjectIdentifier id_aa_ets_sigPolicyId;
  public static final ASN1ObjectIdentifier id_aa_ets_commitmentType;
  public static final ASN1ObjectIdentifier id_aa_ets_signerLocation;
  public static final ASN1ObjectIdentifier id_aa_ets_otherSigCert;
  public static final ASN1ObjectIdentifier pkcs_12;
  public static final ASN1ObjectIdentifier bagtypes;
  public static final ASN1ObjectIdentifier pkcs_12PbeIds;

  static
  {
    (PKCSObjectIdentifiers.pkcs_1 = new ASN1ObjectIdentifier("1.2.840.113549.1.1")).branch("1");
    pkcs_1.branch("2");
    pkcs_1.branch("3");
    pkcs_1.branch("4");
    pkcs_1.branch("5");
    pkcs_1.branch("6");
    pkcs_1.branch("7");
    pkcs_1.branch("8");
    pkcs_1.branch("9");
    pkcs_1.branch("10");
    pkcs_1.branch("11");
    pkcs_1.branch("12");
    pkcs_1.branch("13");
    pkcs_1.branch("14");
    (PKCSObjectIdentifiers.pkcs_3 = new ASN1ObjectIdentifier("1.2.840.113549.1.3")).branch("1");
    (PKCSObjectIdentifiers.pkcs_5 = new ASN1ObjectIdentifier("1.2.840.113549.1.5")).branch("1");
    pkcs_5.branch("4");
    pkcs_5.branch("3");
    pkcs_5.branch("6");
    pkcs_5.branch("10");
    pkcs_5.branch("11");
    pkcs_5.branch("13");
    pkcs_5.branch("12");
    (PKCSObjectIdentifiers.encryptionAlgorithm = new ASN1ObjectIdentifier("1.2.840.113549.3")).branch("7");
    encryptionAlgorithm.branch("2");
    (PKCSObjectIdentifiers.digestAlgorithm = new ASN1ObjectIdentifier("1.2.840.113549.2")).branch("2");
    digestAlgorithm.branch("4");
    digestAlgorithm.branch("5");
    digestAlgorithm.branch("7");
    digestAlgorithm.branch("8");
    digestAlgorithm.branch("9");
    digestAlgorithm.branch("10");
    digestAlgorithm.branch("11");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.1");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.2");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.3");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.4");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.5");
    new ASN1ObjectIdentifier("1.2.840.113549.1.7.6");
    pkcs_9_at_emailAddress = (PKCSObjectIdentifiers.pkcs_9 = new ASN1ObjectIdentifier("1.2.840.113549.1.9")).branch("1");
    pkcs_9_at_unstructuredName = pkcs_9.branch("2");
    pkcs_9.branch("3");
    pkcs_9.branch("4");
    pkcs_9.branch("5");
    pkcs_9.branch("6");
    pkcs_9.branch("7");
    pkcs_9_at_unstructuredAddress = pkcs_9.branch("8");
    pkcs_9.branch("9");
    pkcs_9.branch("13");
    pkcs_9.branch("14");
    pkcs_9.branch("15");
    pkcs_9.branch("20");
    pkcs_9.branch("21");
    pkcs_9.branch("22.1");
    (PKCSObjectIdentifiers.certTypes = pkcs_9.branch("22")).branch("1");
    certTypes.branch("2");
    (PKCSObjectIdentifiers.crlTypes = pkcs_9.branch("23")).branch("1");
    pkcs_9.branch("16.3.9");
    pkcs_9.branch("15.1");
    pkcs_9.branch("15.2");
    pkcs_9.branch("15.3");
    (PKCSObjectIdentifiers.id_ct = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.1")).branch("2");
    id_ct.branch("4");
    id_ct.branch("9");
    id_ct.branch("23");
    id_ct.branch("31");
    (PKCSObjectIdentifiers.id_cti = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.6")).branch("1");
    id_cti.branch("2");
    id_cti.branch("3");
    id_cti.branch("4");
    id_cti.branch("5");
    id_cti.branch("6");
    (PKCSObjectIdentifiers.id_aa = new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.2")).branch("1");
    id_aa.branch("4");
    id_aa.branch("5");
    id_aa.branch("10");
    id_aa.branch("11");
    id_aa.branch("12");
    id_aa.branch("47");
    id_aa.branch("7");
    id_aa.branch("14");
    id_aa_ets_sigPolicyId = id_aa.branch("15");
    id_aa_ets_commitmentType = id_aa.branch("16");
    id_aa_ets_signerLocation = id_aa.branch("17");
    id_aa.branch("18");
    id_aa_ets_otherSigCert = id_aa.branch("19");
    id_aa.branch("20");
    id_aa.branch("21");
    id_aa.branch("22");
    id_aa.branch("23");
    id_aa.branch("24");
    id_aa.branch("25");
    id_aa.branch("26");
    id_aa.branch("27");
    new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.5.1");
    new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.5.2");
    (PKCSObjectIdentifiers.bagtypes = (PKCSObjectIdentifiers.pkcs_12 = new ASN1ObjectIdentifier("1.2.840.113549.1.12")).branch("10.1")).branch("1");
    bagtypes.branch("2");
    bagtypes.branch("3");
    bagtypes.branch("4");
    bagtypes.branch("5");
    bagtypes.branch("6");
    (PKCSObjectIdentifiers.pkcs_12PbeIds = pkcs_12.branch("1")).branch("1");
    pkcs_12PbeIds.branch("2");
    pkcs_12PbeIds.branch("3");
    pkcs_12PbeIds.branch("4");
    pkcs_12PbeIds.branch("5");
    pkcs_12PbeIds.branch("6");
    new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.3.6");
    new ASN1ObjectIdentifier("1.2.840.113549.1.9.16.3.7");
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.pkcs.PKCSObjectIdentifiers
 * JD-Core Version:    0.6.0
 */