/*    */ package com.scytl.common.certpath;
/*    */ 
/*    */ import java.security.InvalidAlgorithmParameterException;
/*    */ import java.security.NoSuchAlgorithmException;
/*    */ import java.security.cert.CertPath;
/*    */ import java.security.cert.CertPathBuilder;
/*    */ import java.security.cert.CertPathBuilderException;
/*    */ import java.security.cert.CertPathBuilderResult;
/*    */ import java.security.cert.CertSelector;
/*    */ import java.security.cert.CertStore;
/*    */ import java.security.cert.Certificate;
/*    */ import java.security.cert.CollectionCertStoreParameters;
/*    */ import java.security.cert.PKIXBuilderParameters;
/*    */ import java.security.cert.TrustAnchor;
/*    */ import java.security.cert.X509CertSelector;
/*    */ import java.security.cert.X509Certificate;
/*    */ import java.util.Arrays;
/*    */ import java.util.Set;
/*    */ 
/*    */ public class CertPathHelper
/*    */ {
/*    */   private String oid;
/*    */   private int index;
/*    */ 
/*    */   private CertPathHelper()
/*    */   {
/*    */   }
/*    */ 
/*    */   public static CertPath buildCertPath(Set<TrustAnchor> paramSet, Certificate[] paramArrayOfCertificate)
/*    */     throws CertPathBuilderException
/*    */   {
/*    */     X509CertSelector localX509CertSelector;
/* 57 */     (
/* 58 */       localX509CertSelector = new X509CertSelector())
/* 58 */       .setCertificate((X509Certificate)paramArrayOfCertificate[0]);
/*    */     try
/*    */     {
/* 62 */       paramArrayOfCertificate = CertStore.getInstance("Collection", new CollectionCertStoreParameters(Arrays.asList(paramArrayOfCertificate)));
/*    */     }
/*    */     catch (InvalidAlgorithmParameterException paramSet)
/*    */     {
/* 67 */       throw new RuntimeException(paramSet);
/*    */     } catch (NoSuchAlgorithmException paramSet) {
/* 69 */       throw new RuntimeException(paramSet);
/*    */     }
/* 71 */     return buildCertPath(paramSet, paramArrayOfCertificate, localX509CertSelector);
/*    */   }
/*    */ 
/*    */   public static CertPath buildCertPath(Set<TrustAnchor> paramSet, CertStore paramCertStore, CertSelector paramCertSelector)
/*    */     throws CertPathBuilderException
/*    */   {
/*    */     try
/*    */     {
/* 80 */       CertPathBuilder localCertPathBuilder = CertPathBuilder.getInstance("PKIX");
/*    */ 
/* 83 */       (
/* 85 */         paramSet = new PKIXBuilderParameters(paramSet, paramCertSelector))
/* 85 */         .addCertStore(paramCertStore);
/*    */ 
/* 87 */       paramSet.setRevocationEnabled(false);
/* 88 */       return localCertPathBuilder.build(paramSet).getCertPath();
/*    */     }
/*    */     catch (InvalidAlgorithmParameterException localInvalidAlgorithmParameterException) {
/* 91 */       throw new RuntimeException(localInvalidAlgorithmParameterException); } catch (NoSuchAlgorithmException localNoSuchAlgorithmException) {
/*    */     }
/* 93 */     throw new RuntimeException(localNoSuchAlgorithmException);
/*    */   }
/*    */ 
/*    */   public CertPathHelper(String paramString)
/*    */   {
/*    */     this.oid = paramString;
/*    */     this.index = 0;
/*    */   }
/*    */ 
/*    */   public boolean hasMoreTokens()
/*    */   {
/*    */     return this.index != -1;
/*    */   }
/*    */ 
/*    */   public String nextToken()
/*    */   {
/*    */     if (this.index == -1)
/*    */       return null;
/*    */     int i;
/*    */     if ((i = this.oid.indexOf('.', this.index)) == -1)
/*    */     {
/*    */       str = this.oid.substring(this.index);
/*    */       this.index = -1;
/*    */       return str;
/*    */     }
/*    */     String str = this.oid.substring(this.index, i);
/*    */     this.index = (i + 1);
/*    */     return str;
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.certpath.CertPathHelper
 * JD-Core Version:    0.6.0
 */