/*     */ package com.scytl.common.certpath;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.security.cert.CertPathValidatorException;
/*     */ import java.security.cert.Certificate;
/*     */ import java.security.cert.PKIXCertPathChecker;
/*     */ import java.security.cert.X509Certificate;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.HashSet;
/*     */ import java.util.Set;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.bouncycastle.asn1.ASN1InputStream;
/*     */ import org.bouncycastle.asn1.ASN1ObjectIdentifier;
/*     */ import org.bouncycastle.asn1.ASN1OctetString;
/*     */ import org.bouncycastle.asn1.util.ASN1Dump;
/*     */ import org.bouncycastle.asn1.x509.X509Extensions;
/*     */ 
/*     */ public class LogAndAllowExtendedKeyUsages extends PKIXCertPathChecker
/*     */ {
/*  34 */   private static Log _logger = LogFactory.getLog(LogAndAllowExtendedKeyUsages.class);
/*     */ 
/*  38 */   private final String _extendedKeyUsageOID = X509Extensions.ExtendedKeyUsage.getId();
/*     */   private Set<String> _supportedExtensions;
/*     */ 
/*     */   public void check(Certificate paramCertificate, Collection<String> paramCollection)
/*     */     throws CertPathValidatorException
/*     */   {
/*     */     Object localObject;
/*  54 */     if (((
/*  54 */       localObject = (
/*  52 */       paramCertificate = (X509Certificate)paramCertificate)
/*  52 */       .getCriticalExtensionOIDs()) != null) && 
/*  54 */       (((Set)localObject).contains(this._extendedKeyUsageOID)))
/*     */     {
/*  56 */       paramCertificate = new ASN1InputStream(paramCertificate.getExtensionValue(this._extendedKeyUsageOID));
/*     */       try
/*     */       {
/*  60 */         localObject = (ASN1OctetString)paramCertificate.readObject();
/*     */ 
/*  62 */         _logger.info("Extended key usage :: " + ASN1Dump.dumpAsString(localObject));
/*     */       }
/*     */       catch (IOException localIOException3) {
/*  65 */         _logger.info("Error reading extended key usage extension", localIOException2);
/*     */       }
/*     */       finally {
/*     */         try {
/*  69 */           paramCertificate.close();
/*     */         } catch (IOException paramCertificate) {
/*  71 */           _logger.error("Error closing ASN1 stream", paramCertificate);
/*     */         }
/*     */       }
/*  74 */       paramCollection.remove(this._extendedKeyUsageOID);
/*     */     }
/*     */   }
/*     */ 
/*     */   public Set<String> getSupportedExtensions()
/*     */   {
/*  83 */     return this._supportedExtensions;
/*     */   }
/*     */ 
/*     */   public void init(boolean paramBoolean)
/*     */     throws CertPathValidatorException
/*     */   {
/*  92 */     (
/*  93 */       paramBoolean = new HashSet())
/*  93 */       .add(this._extendedKeyUsageOID);
/*  94 */     this._supportedExtensions = Collections.unmodifiableSet(paramBoolean);
/*     */   }
/*     */ 
/*     */   public boolean isForwardCheckingSupported()
/*     */   {
/* 103 */     return true;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.certpath.LogAndAllowExtendedKeyUsages
 * JD-Core Version:    0.6.0
 */