/*     */ package com.scytl.common.client.certificatevalidator;
/*     */ 
/*     */ import com.scytl.common.certpath.CertPathHelper;
/*     */ import com.scytl.common.dao.CAValidationService;
/*     */ import com.scytl.crypto.CryptographicFormats;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.cert.CertStore;
/*     */ import java.security.cert.Certificate;
/*     */ import java.security.cert.CertificateException;
/*     */ import java.security.cert.TrustAnchor;
/*     */ import java.security.cert.X509CertSelector;
/*     */ import java.security.cert.X509Certificate;
/*     */ import java.util.HashSet;
/*     */ import java.util.Set;
/*     */ import javax.security.auth.x500.X500Principal;
/*     */ 
/*     */ public class ScytlServerCertificatesValidator
/*     */ {
/*     */   private Certificate _authServerCertificate;
/*     */   private Certificate _messageServerCertificate;
/*     */   private Certificate _pnyxApplicationCertificate;
/*     */   private final Set<TrustAnchor> _trustAnchors;
/*     */   private final TrustAnchor _scytlTrustAnchor;
/*  73 */   private final CAValidationService _certificateValidationService = new CAValidationService();
/*     */   private final CryptographicFormats _cryptographicFormats;
/*     */ 
/*     */   public ScytlServerCertificatesValidator(CryptographicFormats paramCryptographicFormats)
/*     */     throws CertificateException
/*     */   {
/*  81 */     this._cryptographicFormats = paramCryptographicFormats;
/*  82 */     this._scytlTrustAnchor = new TrustAnchor((X509Certificate)readCertificate("/server-certificates/pnyx.application.pem"), null);
/*     */ 
/*  85 */     this._trustAnchors = new HashSet();
/*  86 */     this._trustAnchors.add(this._scytlTrustAnchor);
/*  87 */     this._certificateValidationService.setTrustAnchors(this._trustAnchors);
/*     */   }
/*     */ 
/*     */   public ScytlServerCertificatesValidator() throws GeneralSecurityException
/*     */   {
/*  92 */     this(new CryptographicFormats());
/*     */   }
/*     */ 
/*     */   public final void validateServerCertificates() {
/*  96 */     Certificate localCertificate1 = null;
/*  97 */     Certificate localCertificate2 = null;
/*  98 */     Certificate localCertificate3 = null;
/*     */     try { localCertificate1 = readCertificate("/server-certificates/auth.server.pem");
/* 101 */       localCertificate2 = readCertificate("/server-certificates/message.server.pem");
/* 102 */       localCertificate3 = readCertificate("/server-certificates/pnyx.application.pem");
/* 103 */       validateCertificate(localCertificate1);
/* 104 */       validateCertificate(localCertificate2);
/*     */       return; } catch (GeneralSecurityException localGeneralSecurityException) { throw new RuntimeException("The server certificates can not be successfully validated.", localGeneralSecurityException);
/*     */     }
/*     */     finally
/*     */     {
/* 110 */       this._authServerCertificate = localCertificate1;
/* 111 */       this._messageServerCertificate = localCertificate2;
/* 112 */       this._pnyxApplicationCertificate = localCertificate3; } throw localObject;
/*     */   }
/*     */ 
/*     */   private void validateCertificate(Certificate paramCertificate)
/*     */     throws GeneralSecurityException
/*     */   {
/* 119 */     paramCertificate = new Certificate[] { paramCertificate };
/*     */ 
/* 121 */     paramCertificate = CertPathHelper.buildCertPath(this._trustAnchors, paramCertificate);
/*     */ 
/* 123 */     paramCertificate = paramCertificate; (this = this._certificateValidationService).validate(null, paramCertificate);
/*     */   }
/*     */ 
/*     */   protected final void validateElectionCertificate(CertStore paramCertStore, X500Principal paramX500Principal)
/*     */     throws GeneralSecurityException
/*     */   {
/*     */     X509CertSelector localX509CertSelector;
/* 131 */     (
/* 132 */       localX509CertSelector = new X509CertSelector())
/* 132 */       .setSubject(paramX500Principal);
/* 133 */     paramCertStore = CertPathHelper.buildCertPath(this._trustAnchors, paramCertStore, localX509CertSelector);
/*     */ 
/* 136 */     paramCertStore = paramCertStore; (this = this._certificateValidationService).validate(null, paramCertStore);
/*     */   }
/*     */ 
/*     */   private Certificate readCertificate(String paramString)
/*     */     throws CertificateException
/*     */   {
/* 143 */     return CryptographicFormats.readCertificate(getClass().getResourceAsStream(paramString));
/*     */   }
/*     */ 
/*     */   public final Certificate getAuthServerCertificate()
/*     */   {
/* 151 */     return this._authServerCertificate;
/*     */   }
/*     */ 
/*     */   public final Certificate getMessageServerCertificate()
/*     */   {
/* 158 */     return this._messageServerCertificate;
/*     */   }
/*     */ 
/*     */   public final Certificate getPnyxApplicationCertificate()
/*     */   {
/* 165 */     return this._pnyxApplicationCertificate;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.client.certificatevalidator.ScytlServerCertificatesValidator
 * JD-Core Version:    0.6.0
 */