/*     */ package com.scytl.common.dao;
/*     */ 
/*     */ import com.scytl.common.certpath.LogAndAllowExtendedKeyUsages;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.security.cert.CertPath;
/*     */ import java.security.cert.CertPathValidator;
/*     */ import java.security.cert.CertPathValidatorException;
/*     */ import java.security.cert.PKIXBuilderParameters;
/*     */ import java.security.cert.TrustAnchor;
/*     */ import java.security.cert.X509CertSelector;
/*     */ import java.util.Collections;
/*     */ import java.util.Date;
/*     */ import java.util.Set;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public final class CAValidationService extends AbstractTimedValidationService
/*     */   implements ComponentMonitor
/*     */ {
/*     */   private Set<TrustAnchor> _trustAnchors;
/*     */   private boolean _nativeRevocationEnabled;
/*     */   private boolean _nativeOcspEnabled;
/*     */ 
/*     */   public CAValidationService()
/*     */   {
/* 105 */     AccessController.doPrivileged(new PrivilegedAction()
/*     */     {
/*     */     });
/*     */   }
/*     */ 
/*     */   public final boolean validate(Date paramDate, CertPath paramCertPath)
/*     */     throws CertPathValidatorException
/*     */   {
/*     */     try
/*     */     {
/* 139 */       paramDate = CertPathValidator.getInstance("PKIX");
/*     */       PKIXBuilderParameters localPKIXBuilderParameters;
/* 145 */       (
/* 148 */         localPKIXBuilderParameters = new PKIXBuilderParameters(this._trustAnchors, new X509CertSelector()))
/* 148 */         .setRevocationEnabled(this._nativeRevocationEnabled);
/* 149 */       localPKIXBuilderParameters.addCertPathChecker(new LogAndAllowExtendedKeyUsages());
/*     */ 
/* 151 */       paramDate.validate(paramCertPath, localPKIXBuilderParameters);
/*     */     }
/*     */     catch (java.security.InvalidAlgorithmParameterException paramDate)
/*     */     {
/* 163 */       throw new RuntimeException(paramDate);
/*     */     } catch (java.security.NoSuchAlgorithmException paramDate) {
/* 165 */       throw new RuntimeException(paramDate);
/*     */     }
/* 167 */     return true;
/*     */   }
/*     */ 
/*     */   public final void setTrustAnchors(Set<TrustAnchor> trustAnchors)
/*     */   {
/* 183 */     this._trustAnchors = Collections.unmodifiableSet(trustAnchors);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.dao.CAValidationService
 * JD-Core Version:    0.6.0
 */