/*     */ package com.scytl.common.domain.election.ballot;
/*     */ 
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.hibernate.entity.election.DelegationChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.GroupQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.OpenTextQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.common.domain.hibernate.entity.election.TextAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import java.net.MalformedURLException;
/*     */ import java.net.URL;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class Ballot
/*     */   implements Cloneable
/*     */ {
/*  48 */   private static Log _logger = LogFactory.getLog(Ballot.class);
/*     */   private BallotChannel _channel;
/*  71 */   private List<Question> _ballotQuestions = new ArrayList();
/*     */ 
/*  75 */   private Map<String, Set<String>> _ballotErrors = new HashMap();
/*     */ 
/* 116 */   private Map<String, QuestionAnswer> _ballotAnswers = new HashMap();
/*     */   private String _nextElectionId;
/*     */   private Boolean _showReceipt;
/*     */   private Message _alternateReceiptMessage;
/*     */   private String _redirectExitURL;
/*     */   private String _institutionId;
/*     */   private String _electionEventId;
/*     */   private Message _electionName;
/*     */ 
/*     */   public final void addBallotErros(String paramString, Set<String> paramSet)
/*     */   {
/* 102 */     if (this._ballotErrors.containsKey(paramString)) {
/* 103 */       for (this = ((Set)this._ballotErrors.get(paramString)).iterator(); hasNext(); ) { paramString = (String)next();
/* 104 */         paramSet.add(paramString); } return;
/*     */     }
/*     */ 
/* 107 */     this._ballotErrors.put(paramString, paramSet);
/*     */   }
/*     */ 
/*     */   public final String getInstitutionId()
/*     */   {
/* 154 */     return this._institutionId;
/*     */   }
/*     */ 
/*     */   public final void setInstitutionId(String institutionId)
/*     */   {
/* 162 */     this._institutionId = institutionId;
/*     */   }
/*     */ 
/*     */   public final String getElectionEventId()
/*     */   {
/* 169 */     return this._electionEventId;
/*     */   }
/*     */ 
/*     */   public final void setElectionEventId(String electionEventId)
/*     */   {
/* 177 */     this._electionEventId = electionEventId;
/*     */   }
/*     */ 
/*     */   public final BallotChannel getChannel() {
/* 181 */     return this._channel;
/*     */   }
/*     */ 
/*     */   public final void setChannel(BallotChannel channel) {
/* 185 */     this._channel = channel;
/*     */   }
/*     */ 
/*     */   public final void addQuestion(Question paramQuestion)
/*     */   {
/* 200 */     this._ballotQuestions.add(paramQuestion);
/* 201 */     addDefaultQuestionAnswer(paramQuestion);
/*     */   }
/*     */ 
/*     */   private void addDefaultQuestionAnswer(Question paramQuestion)
/*     */   {
/* 212 */     Object localObject = null;
/* 213 */     if ((paramQuestion instanceof OpenTextQuestion)) {
/* 214 */       localObject = new TextQuestionAnswer();
/* 215 */     } else if ((paramQuestion instanceof MultipleChoiceQuestion)) {
/* 216 */       localObject = (MultipleChoiceQuestion)paramQuestion;
/*     */ 
/* 220 */       localObject = new ValuedMultipleChoiceQuestionAnswer(((MultipleChoiceQuestion)localObject).getActiveAnswers());
/*     */     }
/* 224 */     else if ((paramQuestion instanceof DelegationChoiceQuestion)) {
/* 225 */       localObject = (DelegationChoiceQuestion)paramQuestion;
/*     */ 
/* 227 */       ArrayList localArrayList = new ArrayList();
/* 228 */       for (TextAnswer localTextAnswer : ((DelegationChoiceQuestion)localObject).getBoardMembers()) {
/* 229 */         localArrayList.add(localTextAnswer);
/*     */       }
/* 231 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegateId());
/* 232 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegateName());
/* 233 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegateMail());
/* 234 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegatePhone());
/* 235 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegateExtra1());
/* 236 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getDelegateExtra2());
/* 237 */       localArrayList.add(((DelegationChoiceQuestion)localObject).getObservations());
/* 238 */       localObject = new ValuedMultipleChoiceQuestionAnswer(localArrayList);
/*     */     }
/* 240 */     this._ballotAnswers.put(paramQuestion.getId(), localObject);
/*     */   }
/*     */ 
/*     */   public final void answerQuestion(String paramString, QuestionAnswer paramQuestionAnswer)
/*     */   {
/* 250 */     if (!containsQuestion(paramString)) {
/* 251 */       throw new IllegalArgumentException("The questionId :: " + paramString + " does not belong in this ballot.");
/*     */     }
/*     */     try
/*     */     {
/* 255 */       paramQuestionAnswer = paramQuestionAnswer == null ? null : (QuestionAnswer)paramQuestionAnswer.clone();
/*     */ 
/* 257 */       this._ballotAnswers.put(new String(paramString), paramQuestionAnswer);
/*     */ 
/* 261 */       return;
/*     */     }
/*     */     catch (CloneNotSupportedException paramQuestionAnswer)
/*     */     {
/* 259 */       _logger.error("Error cloning the answer to insert in the ballot.", paramQuestionAnswer);
/*     */     }
/*     */   }
/*     */ 
/*     */   public final List<Question> getBallotQuestions()
/*     */   {
/* 265 */     return this._ballotQuestions;
/*     */   }
/*     */ 
/*     */   public final Map<String, QuestionAnswer> getBallotAnswers() {
/* 269 */     return this._ballotAnswers;
/*     */   }
/*     */ 
/*     */   public final void clear()
/*     */   {
/* 307 */     this._ballotAnswers = new HashMap();
/* 308 */     for (Question question : this._ballotQuestions)
/* 309 */       addDefaultQuestionAnswer(question);
/*     */   }
/*     */ 
/*     */   public final boolean containsQuestion(String questionId)
/*     */   {
/*     */     Question q;
/* 319 */     (
/* 320 */       q = new GroupQuestion())
/* 320 */       .setId(questionId);
/* 321 */     return this._ballotQuestions.contains(q);
/*     */   }
/*     */ 
/*     */   public final Message getElectionName()
/*     */   {
/* 328 */     return this._electionName;
/*     */   }
/*     */ 
/*     */   public final void setElectionName(Message electionName) {
/* 332 */     this._electionName = electionName;
/*     */   }
/*     */ 
/*     */   public Object clone() throws CloneNotSupportedException
/*     */   {
/* 337 */     Ballot localBallot = (Ballot)super.clone();
/*     */     Object localObject2;
/*     */     Object localObject1;
/* 340 */     if (this._electionName != null) {
/* 341 */       localObject2 = (Message)this._electionName.clone(); (localObject1 = localBallot)._electionName = ((Message)localObject2);
/*     */     }
/* 343 */     if (this._alternateReceiptMessage != null) {
/* 344 */       localObject2 = (Message)this._alternateReceiptMessage.clone(); (localObject1 = localBallot)._alternateReceiptMessage = ((Message)localObject2);
/*     */     }
/*     */     Object localObject3;
/* 349 */     if (this._ballotQuestions != null) {
/* 350 */       localObject1 = new ArrayList();
/* 351 */       for (localObject2 = this._ballotQuestions.iterator(); ((Iterator)localObject2).hasNext(); ) { localObject3 = (Question)((Iterator)localObject2).next();
/* 352 */         ((List)localObject1).add((Question)((Question)localObject3).clone());
/*     */       }
/* 354 */       localObject2 = localObject1; (localObject1 = localBallot)._ballotQuestions = ((List)localObject2);
/*     */     }
/* 356 */     if (this._ballotAnswers != null)
/*     */     {
/* 358 */       localBallot.clear();
/* 359 */       for (localObject1 = this._ballotAnswers.entrySet().iterator(); ((Iterator)localObject1).hasNext(); )
/*     */       {
/* 361 */         localObject3 = (
/* 361 */           localObject2 = (Map.Entry)((Iterator)localObject1).next())
/* 361 */           .getValue() == null ? null : (QuestionAnswer)((QuestionAnswer)((Map.Entry)localObject2).getValue()).clone();
/*     */ 
/* 365 */         localBallot.answerQuestion(new String((String)((Map.Entry)localObject2).getKey()), (QuestionAnswer)localObject3);
/*     */       }
/*     */     }
/*     */ 
/* 369 */     return localBallot;
/*     */   }
/*     */ 
/*     */   public static URL stringToURL(String urlAsString)
/*     */   {
/* 381 */     if (urlAsString == null)
/* 382 */       return null;
/*     */     try
/*     */     {
/*     */       URL converted;
/* 386 */       return converted = new URL(urlAsString);
/*     */     }
/*     */     catch (MalformedURLException mue) {
/* 388 */       _logger.warn("The url :: " + urlAsString + " is not a proper URL.", mue);
/*     */     }
/* 390 */     return null;
/*     */   }
/*     */ 
/*     */   public final String getNextElectionId()
/*     */   {
/* 396 */     return this._nextElectionId;
/*     */   }
/*     */ 
/*     */   public final boolean hasNextElectionId() {
/* 400 */     return this._nextElectionId != null;
/*     */   }
/*     */ 
/*     */   public final void setNextElectionId(String nextElectionId) {
/* 404 */     this._nextElectionId = nextElectionId;
/*     */   }
/*     */ 
/*     */   public final Boolean getShowReceipt() {
/* 408 */     return this._showReceipt;
/*     */   }
/*     */ 
/*     */   public final void setShowReceipt(Boolean showReceipt) {
/* 412 */     this._showReceipt = showReceipt;
/*     */   }
/*     */ 
/*     */   public final Message getAlternateReceiptMessage() {
/* 416 */     return this._alternateReceiptMessage;
/*     */   }
/*     */ 
/*     */   public final void setAlternateReceiptMessage(Message alternateReceiptMessage)
/*     */   {
/* 421 */     this._alternateReceiptMessage = alternateReceiptMessage;
/*     */   }
/*     */ 
/*     */   public final String getRedirectExitURL() {
/* 425 */     return this._redirectExitURL;
/*     */   }
/*     */ 
/*     */   public final void setRedirectExitURL(String redirectExitURL) {
/* 429 */     this._redirectExitURL = redirectExitURL;
/*     */   }
/*     */ 
/*     */   public final boolean isDelegation()
/*     */   {
/* 455 */     this = this;
/*     */     Question localQuestion;
/* 455 */     for (this = this._ballotQuestions.iterator(); hasNext(); localQuestion = (Question)next());
/* 455 */     return (DelegationChoiceQuestion.class.isAssignableFrom(localQuestion.getClass()) ? (DelegationChoiceQuestion)localQuestion : null) != null;
/*     */   }
/*     */ 
/*     */   public final Map<String, Set<String>> getBallotErrors()
/*     */   {
/* 466 */     return this._ballotErrors;
/*     */   }
/*     */ 
/*     */   public final void cleanBallotErrors()
/*     */   {
/* 473 */     this._ballotErrors.clear();
/*     */   }
/*     */ 
/*     */   static
/*     */   {
/*  53 */     new StringBuilder().append("-").append(MessageType.VOTE.name()).toString();
/*     */ 
/*  56 */     new StringBuilder().append("-").append(MessageType.DELEGATION.name()).toString();
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.election.ballot.Ballot
 * JD-Core Version:    0.6.0
 */