/*     */ package com.scytl.common.domain.hibernate.entity.election;
/*     */ 
/*     */ import com.scytl.common.domain.OverVoteTypes;
/*     */ import com.scytl.common.domain.election.QuestionType;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.hibernate.annotations.Fetch;
/*     */ import org.hibernate.annotations.FetchMode;
/*     */ import org.hibernate.annotations.ForeignKey;
/*     */ import org.hibernate.annotations.IndexColumn;
/*     */ import org.hibernate.annotations.Proxy;
/*     */ 
/*     */ @Proxy(lazy=false)
/*     */ public class MultipleChoiceQuestion extends Question
/*     */   implements Cloneable
/*     */ {
/*     */   private Integer _minAnswers;
/*     */   private Integer _maxAnswers;
/*  56 */   private boolean _preferential = false;
/*     */ 
/*  58 */   private int _cumulativePoints = 0;
/*     */ 
/*  60 */   private OverVoteTypes _overvoteType = OverVoteTypes.NOT_ALLOW;
/*     */ 
/* 102 */   private List<Answer> _answers = new ArrayList();
/*     */ 
/*     */   public final OverVoteTypes getOvervoteType()
/*     */   {
/*  70 */     return this._overvoteType;
/*     */   }
/*     */ 
/*     */   public final void setOvervoteType(OverVoteTypes overvoteType)
/*     */   {
/*  78 */     this._overvoteType = overvoteType;
/*     */   }
/*     */ 
/*     */   public Object clone()
/*     */     throws CloneNotSupportedException
/*     */   {
/* 110 */     MultipleChoiceQuestion localMultipleChoiceQuestion = (MultipleChoiceQuestion)super.clone();
/*     */ 
/* 112 */     if (this._answers != null) {
/* 113 */       ArrayList localArrayList = new ArrayList();
/* 114 */       for (Answer localAnswer : this._answers) {
/* 115 */         localArrayList.add((Answer)localAnswer.clone());
/*     */       }
/* 117 */       localArrayList = localArrayList; (this = localMultipleChoiceQuestion)._answers = localArrayList;
/*     */     }
/* 119 */     return localMultipleChoiceQuestion;
/*     */   }
/*     */ 
/*     */   public MultipleChoiceQuestion()
/*     */   {
/* 142 */     this._minAnswers = Integer.valueOf(0);
/* 143 */     this._maxAnswers = Integer.valueOf(1);
/*     */   }
/*     */ 
/*     */   @ForeignKey(name="QUESTION_ANSWER_FK")
/*     */   @IndexColumn(name="ORDER_IN_QUESTION")
/*     */   @Fetch(FetchMode.JOIN)
/*     */   public final List<Answer> getAnswers()
/*     */   {
/* 161 */     return this._answers;
/*     */   }
/*     */ 
/*     */   public final Answer getAnswer(String paramString)
/*     */   {
/* 173 */     for (Answer localAnswer : this._answers) {
/* 174 */       if (paramString.equals(localAnswer.getId())) {
/* 175 */         return localAnswer;
/*     */       }
/* 177 */       if ((localAnswer instanceof ListAnswer))
/*     */       {
/* 179 */         if ((
/* 179 */           localAnswer = ((ListAnswer)localAnswer).getAnswer(paramString)) != null)
/*     */         {
/* 180 */           return localAnswer;
/*     */         }
/*     */       }
/*     */     }
/* 184 */     return null;
/*     */   }
/*     */ 
/*     */   public final List<Answer> getActiveAnswers()
/*     */   {
/* 216 */     ArrayList localArrayList = new ArrayList();
/* 217 */     this = this._answers.iterator();
/* 218 */     while (hasNext())
/*     */     {
/*     */       Answer localAnswer;
/* 220 */       if ((
/* 220 */         localAnswer = (Answer)next())
/* 220 */         .getStatus().equals(Integer.valueOf(0))) {
/* 221 */         localArrayList.add(localAnswer);
/*     */       }
/*     */     }
/* 224 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final List<Answer> getRegularAnswers()
/*     */   {
/* 235 */     ArrayList localArrayList = new ArrayList();
/* 236 */     this = this; for (this = this._answers.iterator(); hasNext(); )
/*     */     {
/*     */       Answer localAnswer;
/* 237 */       if (((
/* 237 */         localAnswer = (Answer)next())
/* 237 */         .getStatus().equals(Integer.valueOf(0))) && (!localAnswer.isBlank()) && (!localAnswer.isNuller()))
/*     */       {
/* 239 */         localArrayList.add(localAnswer);
/*     */       }
/*     */     }
/* 242 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final List<Answer> getDeepRegularAnswers()
/*     */   {
/* 253 */     ArrayList localArrayList = new ArrayList();
/* 254 */     for (this = this._answers.iterator(); hasNext(); )
/*     */     {
/*     */       Answer localAnswer;
/* 255 */       if (((
/* 255 */         localAnswer = (Answer)next())
/* 255 */         .getStatus().equals(Integer.valueOf(0))) && (!localAnswer.isBlank()) && (!localAnswer.isNuller()))
/*     */       {
/* 257 */         localArrayList.add(localAnswer);
/* 258 */         if ((localAnswer instanceof ListAnswer)) {
/* 259 */           localArrayList.addAll(((ListAnswer)localAnswer).getActiveAnswers());
/*     */         }
/*     */       }
/*     */     }
/*     */ 
/* 264 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final List<Answer> getNullerAnswers()
/*     */   {
/* 296 */     ArrayList localArrayList = new ArrayList();
/* 297 */     for (this = this._answers.iterator(); hasNext(); )
/*     */     {
/*     */       Answer localAnswer;
/* 298 */       if (((
/* 298 */         localAnswer = (Answer)next())
/* 298 */         .getStatus().equals(Integer.valueOf(0))) && (localAnswer.isNuller()))
/*     */       {
/* 300 */         localArrayList.add(localAnswer);
/*     */       }
/*     */     }
/* 303 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final List<Answer> getBlankAnswers()
/*     */   {
/* 314 */     ArrayList localArrayList = new ArrayList();
/* 315 */     for (this = this._answers.iterator(); hasNext(); )
/*     */     {
/*     */       Answer localAnswer;
/* 316 */       if (((
/* 316 */         localAnswer = (Answer)next())
/* 316 */         .getStatus().equals(Integer.valueOf(0))) && (localAnswer.isBlank()))
/*     */       {
/* 318 */         localArrayList.add(localAnswer);
/*     */       }
/*     */     }
/* 321 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final Integer getMaxAnswers()
/*     */   {
/* 357 */     return this._maxAnswers;
/*     */   }
/*     */ 
/*     */   public final void setMaxAnswers(Integer maxAnswers)
/*     */   {
/* 369 */     this._maxAnswers = maxAnswers;
/*     */   }
/*     */ 
/*     */   public final Integer getMinAnswers()
/*     */   {
/* 377 */     return this._minAnswers;
/*     */   }
/*     */ 
/*     */   public final void setMinAnswers(Integer minAnswers)
/*     */   {
/* 386 */     this._minAnswers = minAnswers;
/*     */   }
/*     */ 
/*     */   public final void setAnswers(List<Answer> answers)
/*     */   {
/* 394 */     this._answers = answers;
/*     */   }
/*     */ 
/*     */   public final QuestionType getQuestionType()
/*     */   {
/* 400 */     return QuestionType.MULTIPLE_CHOICE_QUESTION;
/*     */   }
/*     */ 
/*     */   public final boolean isPreferential()
/*     */   {
/* 428 */     return this._preferential;
/*     */   }
/*     */ 
/*     */   public final int getCumulativePoints()
/*     */   {
/* 436 */     return this._cumulativePoints;
/*     */   }
/*     */ 
/*     */   public final void setPreferential(boolean preferential)
/*     */   {
/* 444 */     this._preferential = true;
/*     */   }
/*     */ 
/*     */   public final void setCumulativePoints(int cumulativePoints)
/*     */   {
/* 452 */     this._cumulativePoints = cumulativePoints;
/*     */   }
/*     */ 
/*     */   public final boolean isCumulative()
/*     */   {
/* 463 */     return this._cumulativePoints > 0;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion
 * JD-Core Version:    0.6.0
 */