/*     */ package com.scytl.common.domain.hibernate.entity.election;
/*     */ 
/*     */ import B;
/*     */ import com.scytl.common.domain.election.AreaComparator;
/*     */ import com.scytl.common.domain.election.QuestionType;
/*     */ import com.scytl.common.domain.hibernate.entity.BaseObject;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.ArbitraryString;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import com.scytl.common.domain.i18n.MessageFactory;
/*     */ import java.util.List;
/*     */ import java.util.SortedSet;
/*     */ import java.util.TreeSet;
/*     */ import org.apache.commons.lang.builder.EqualsBuilder;
/*     */ import org.hibernate.annotations.Cache;
/*     */ import org.hibernate.annotations.CacheConcurrencyStrategy;
/*     */ import org.hibernate.annotations.Cascade;
/*     */ import org.hibernate.annotations.ForeignKey;
/*     */ import org.hibernate.annotations.Proxy;
/*     */ import org.hibernate.annotations.Table;
/*     */ 
/*     */ @Proxy(lazy=false)
/*     */ @Cache(usage=CacheConcurrencyStrategy.READ_WRITE)
/*     */ @Table(appliesTo="QUESTIONS", indexes={@org.hibernate.annotations.Index(name="QUESTIONS_ELECTION", columnNames={"ELECTION_ID"})})
/*     */ public abstract class Question extends BaseObject
/*     */   implements Cloneable
/*     */ {
/*     */   private Message _title;
/*     */   private Message _text;
/*     */   private Message _description;
/*     */   private Message _additionalInformation;
/*     */   private Message _customBlankVoteMessage;
/*     */   private SortedSet<Area> _areas;
/*     */   public static final Integer ACTIVE_QUESTION;
/*     */   public static final Integer CANCELLED_QUESTION;
/*     */ 
/*     */   public Question()
/*     */   {
/*  99 */     this._areas = new TreeSet(new AreaComparator());
/*     */ 
/* 130 */     Integer.valueOf(90);
/*     */ 
/* 135 */     Integer.valueOf(360);
/*     */ 
/* 140 */     Integer.valueOf(220);
/*     */   }
/*     */ 
/*     */   public Object clone()
/*     */     throws CloneNotSupportedException
/*     */   {
/* 153 */     Question localQuestion1 = (Question)super.clone();
/*     */     Question localQuestion2;
/* 154 */     if (this._additionalInformation != null) {
/* 155 */       localObject = (Message)this._additionalInformation.clone(); (localQuestion2 = localQuestion1)._additionalInformation = ((Message)localObject);
/*     */     }
/*     */ 
/* 160 */     Object localObject = this._areas; (localQuestion2 = localQuestion1)._areas = ((SortedSet)localObject);
/* 161 */     if (this._description != null) {
/* 162 */       localObject = (Message)this._description.clone(); (localQuestion2 = localQuestion1)._description = ((Message)localObject);
/*     */     }
/* 164 */     if (this._text != null) {
/* 165 */       localObject = (Message)this._text.clone(); (localQuestion2 = localQuestion1)._text = ((Message)localObject);
/*     */     }
/* 167 */     if (this._title != null) {
/* 168 */       localObject = (Message)this._title.clone(); (localQuestion2 = localQuestion1)._title = ((Message)localObject);
/*     */     }
/*     */ 
/* 171 */     return localQuestion1;
/*     */   }
/*     */ 
/*     */   @Cascade({org.hibernate.annotations.CascadeType.REPLICATE})
/*     */   @ForeignKey(name="QUESTION_TITLE_FK")
/*     */   public final Message getTitle()
/*     */   {
/* 198 */     return this._title;
/*     */   }
/*     */ 
/*     */   public final void setTitle(Message title)
/*     */   {
/* 207 */     this._title = title;
/*     */   }
/*     */ 
/*     */   @Cascade({org.hibernate.annotations.CascadeType.REPLICATE})
/*     */   @ForeignKey(name="QUESTION_TEXT_FK")
/*     */   public final Message getText()
/*     */   {
/* 218 */     return this._text;
/*     */   }
/*     */ 
/*     */   public final void setText(Message text)
/*     */   {
/* 245 */     this._text = text;
/*     */   }
/*     */ 
/*     */   public final void setDescription(Message description)
/*     */   {
/* 264 */     this._description = description;
/*     */   }
/*     */ 
/*     */   public final void setAdditionalInformation(Message additionalInformation)
/*     */   {
/* 284 */     this._additionalInformation = additionalInformation;
/*     */   }
/*     */ 
/*     */   @Cascade({org.hibernate.annotations.CascadeType.REPLICATE})
/*     */   @ForeignKey(name="QUESTION_BLANK_VOTE_MSG_FK")
/*     */   public final Message getCustomBlankVoteMessage()
/*     */   {
/* 345 */     return this._customBlankVoteMessage;
/*     */   }
/*     */ 
/*     */   public final void setCustomBlankVoteMessage(Message customBlankVoteMessage)
/*     */   {
/* 354 */     this._customBlankVoteMessage = customBlankVoteMessage;
/*     */   }
/*     */ 
/*     */   public final boolean hasCustomBlankVoteMessage()
/*     */   {
/* 359 */     Message localMessage = MessageFactory.createMessage(null);
/* 360 */     this = this; localMessage = localMessage; this = this._customBlankVoteMessage; localMessage = (Message)localMessage;
/*     */     Object localObject;
/*     */     ArbitraryString localArbitraryString;
/* 360 */     for (int i = 0; i < getArbitraryMessages().size(); i++) { localObject = localMessage.getArbitraryMessages().get(i); localArbitraryString = (ArbitraryString)getArbitraryMessages().get(i); localObject = (ArbitraryString)localObject; } return (!(!(localObject instanceof ArbitraryString) ? false : new EqualsBuilder().append(localArbitraryString.getValue(), ((ArbitraryString)localObject).getValue()).isEquals()) ? 0 : getArbitraryMessages().size() != localMessage.getArbitraryMessages().size() ? 0 : !(localMessage instanceof Message) ? 0 : 1) == 0;
/*     */   }
/*     */ 
/*     */   public final void addArea(Area paramArea)
/*     */   {
/* 388 */     this._areas.add(paramArea);
/*     */   }
/*     */ 
/*     */   public final void setImage(byte[] paramArrayOfByte)
/*     */   {
/* 458 */     if (paramArrayOfByte != null)
/* 459 */       paramArrayOfByte.clone();
/*     */   }
/*     */ 
/*     */   public abstract QuestionType getQuestionType();
/*     */ 
/*     */   static
/*     */   {
/*  67 */     Integer.valueOf(0);
/*     */ 
/*  69 */     Integer.valueOf(0);
/*     */ 
/*  71 */     Integer.valueOf(0);
/*     */ 
/* 142 */     ACTIVE_QUESTION = Integer.valueOf(0);
/*     */ 
/* 144 */     CANCELLED_QUESTION = Integer.valueOf(1);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.hibernate.entity.election.Question
 * JD-Core Version:    0.6.0
 */