/*     */ package com.scytl.common.domain.hibernate.entity.i18n;
/*     */ 
/*     */ import com.scytl.common.domain.hibernate.entity.BaseObject;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import org.apache.commons.lang.builder.EqualsBuilder;
/*     */ import org.apache.commons.lang.builder.HashCodeBuilder;
/*     */ import org.apache.commons.lang.builder.ToStringBuilder;
/*     */ import org.hibernate.annotations.Fetch;
/*     */ import org.hibernate.annotations.FetchMode;
/*     */ import org.hibernate.annotations.ForeignKey;
/*     */ import org.hibernate.annotations.IndexColumn;
/*     */ import org.hibernate.annotations.Proxy;
/*     */ 
/*     */ @Proxy(lazy=false)
/*     */ public final class Message extends BaseObject
/*     */   implements Cloneable
/*     */ {
/*     */   private String _reference;
/*  65 */   private List<ArbitraryString> _arbitraryMessages = new ArrayList();
/*     */ 
/*     */   @ForeignKey(name="MESSAGE_ARBITRARY_STRING_FK")
/*     */   @IndexColumn(name="INDEX_COL")
/*     */   @Fetch(FetchMode.JOIN)
/*     */   public final List<ArbitraryString> getArbitraryMessages()
/*     */   {
/*  98 */     return this._arbitraryMessages;
/*     */   }
/*     */ 
/*     */   public final void setArbitraryMessages(List<ArbitraryString> arbitrary) {
/* 102 */     this._arbitraryMessages = arbitrary;
/*     */   }
/*     */ 
/*     */   public final void setReference(String reference)
/*     */   {
/* 118 */     this._reference = reference;
/*     */   }
/*     */ 
/*     */   public final void putLocalizedMessage(Locale paramLocale, String paramString)
/*     */   {
/* 159 */     ArbitraryString localArbitraryString1 = getArbitraryMessage(paramLocale);
/* 160 */     ArbitraryString localArbitraryString2 = new ArbitraryString(paramLocale, paramString);
/* 161 */     if (localArbitraryString1 != null) {
/* 162 */       getArbitraryMessage(paramLocale).setValue(paramString); return;
/*     */     }
/* 164 */     this = this; this._arbitraryMessages.add(localArbitraryString2);
/*     */   }
/*     */ 
/*     */   private boolean hasLocalizedMessage(Locale paramLocale)
/*     */   {
/* 190 */     return getArbitraryMessage(paramLocale) != null;
/*     */   }
/*     */ 
/*     */   public final String getLocalizedMessage(Locale paramLocale)
/*     */   {
/* 207 */     String str1 = null;
/*     */ 
/* 209 */     String str2 = (
/* 209 */       paramLocale = paramLocale)
/* 209 */       .toString();
/*     */ 
/* 211 */     while ((str2.indexOf('_') != -1) && (!hasLocalizedMessage(paramLocale)))
/*     */     {
/* 215 */       str2 = (
/* 215 */         paramLocale = new Locale(str2.substring(0, str2.lastIndexOf('_'))))
/* 215 */         .toString();
/*     */     }
/* 217 */     if (hasLocalizedMessage(paramLocale)) {
/* 218 */       str1 = getArbitraryMessage(paramLocale).getValue();
/*     */     }
/* 220 */     return str1;
/*     */   }
/*     */ 
/*     */   private ArbitraryString getArbitraryMessage(Locale paramLocale)
/*     */   {
/* 239 */     Object localObject = this; if (this._arbitraryMessages != null) {
/* 240 */       localObject = this; for (this = this._arbitraryMessages.iterator(); hasNext(); ) {
/* 241 */         if (((
/* 241 */           localObject = (ArbitraryString)next()) != null) && 
/* 241 */           (paramLocale.equals(((ArbitraryString)localObject).getLocale())))
/*     */         {
/* 243 */           return localObject;
/*     */         }
/*     */       }
/*     */     }
/* 247 */     return (ArbitraryString)null;
/*     */   }
/*     */ 
/*     */   public final Object clone()
/*     */     throws CloneNotSupportedException
/*     */   {
/* 275 */     Message localMessage = (Message)super.clone();
/* 276 */     Object localObject = this; if (this._arbitraryMessages != null) {
/* 277 */       ArrayList localArrayList = new ArrayList();
/*     */ 
/* 279 */       localObject = this; for (this = this._arbitraryMessages.iterator(); hasNext(); ) { localObject = (ArbitraryString)next();
/* 280 */         localArrayList.add((ArbitraryString)((ArbitraryString)localObject).clone());
/*     */       }
/* 282 */       this = localArrayList; (localObject = localMessage)._arbitraryMessages = this;
/*     */     }
/* 284 */     return localMessage;
/*     */   }
/*     */ 
/*     */   public final String toString()
/*     */   {
/* 305 */     Message localMessage = this; this = this; return new ToStringBuilder(this).append("id", getId()).append("localizedMessages", this._arbitraryMessages).append("reference", this._reference).toString();
/*     */   }
/*     */ 
/*     */   public final boolean equals(Object object)
/*     */   {
/* 315 */     if (!(object instanceof Message)) {
/* 316 */       return false;
/*     */     }
/* 318 */     Message rhs = (Message)object;
/* 319 */     object = this; return new EqualsBuilder().appendSuper(super.equals(object)).append(new HashSet(this._arbitraryMessages), new HashSet((object = rhs)._arbitraryMessages)).append(this._reference, rhs._reference).isEquals();
/*     */   }
/*     */ 
/*     */   public final int hashCode()
/*     */   {
/* 364 */     Message localMessage = this; return new HashCodeBuilder(695440145, 173649029).appendSuper(super.hashCode()).append(this._arbitraryMessages).append(this._reference).toHashCode();
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.hibernate.entity.i18n.Message
 * JD-Core Version:    0.6.0
 */