/*     */ package com.scytl.common.domain.token;
/*     */ 
/*     */ import B;
/*     */ import java.util.Map;
/*     */ import java.util.TreeMap;
/*     */ import org.apache.commons.lang.builder.EqualsBuilder;
/*     */ import org.apache.commons.lang.builder.HashCodeBuilder;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public abstract class TokenMultiElection
/*     */   implements ComponentMonitor
/*     */ {
/*     */   private String _id;
/*  42 */   private boolean _debug = false;
/*     */   private String _creationDateTime;
/*     */   private String _electionId;
/*     */   private String _electionEventId;
/*     */   private String _institutionId;
/*     */   private byte[] _authTokenSignature;
/*     */   private String _authTokenSignatureString;
/*     */   private String _votingService;
/*     */   private String _canDecrypt;
/*     */   private String _x509Fingerprint;
/*     */   private String _username;
/*     */   private String _userRole;
/*     */   private String _timeout;
/*     */   private String _areaId;
/*  79 */   private Map<String, Map<String, String>> _elections = new TreeMap();
/*     */ 
/*  83 */   private Map<String, Boolean> _votedElections = new TreeMap();
/*     */ 
/*     */   public final String getSignedInfo()
/*     */   {
/* 110 */     return new TokenMultiElectionSerializer(this).getSignedInfo();
/*     */   }
/*     */ 
/*     */   public final String serializeAsURLParameter()
/*     */   {
/* 120 */     return new TokenMultiElectionSerializer(this).serializeAsURLParameter();
/*     */   }
/*     */ 
/*     */   public final String getId()
/*     */   {
/* 135 */     return this._id;
/*     */   }
/*     */ 
/*     */   public final void setId(String tokenId) {
/* 139 */     this._id = tokenId;
/*     */   }
/*     */ 
/*     */   public final String getCreationDateTime() {
/* 143 */     return this._creationDateTime;
/*     */   }
/*     */ 
/*     */   public final void setCreationDateTime(String paramString)
/*     */   {
/* 151 */     this._creationDateTime = paramString;
/* 152 */     Long.parseLong(paramString);
/*     */   }
/*     */ 
/*     */   public final String getInstitutionId() {
/* 156 */     return this._institutionId;
/*     */   }
/*     */ 
/*     */   public final void setInstitutionId(String institutionId) {
/* 160 */     this._institutionId = institutionId;
/*     */   }
/*     */ 
/*     */   public final String getUsername() {
/* 164 */     return this._username;
/*     */   }
/*     */ 
/*     */   public final void setUsername(String username) {
/* 168 */     this._username = username;
/*     */   }
/*     */ 
/*     */   public final String getUserRole() {
/* 172 */     return this._userRole;
/*     */   }
/*     */ 
/*     */   public final void setUserRole(String userRole) {
/* 176 */     this._userRole = userRole;
/*     */   }
/*     */ 
/*     */   public final String getVotingService() {
/* 180 */     return this._votingService;
/*     */   }
/*     */ 
/*     */   public final void setVotingService(String votingService) {
/* 184 */     this._votingService = votingService;
/*     */   }
/*     */ 
/*     */   public final String getCanDecrypt()
/*     */   {
/* 191 */     return this._canDecrypt;
/*     */   }
/*     */ 
/*     */   public final void setCanDecrypt(String canDecrypt) {
/* 195 */     this._canDecrypt = canDecrypt;
/*     */   }
/*     */ 
/*     */   public final boolean canDecrypt()
/*     */   {
/* 200 */     return "1".equals(this._canDecrypt);
/*     */   }
/*     */ 
/*     */   public final String getX509Fingerprint()
/*     */   {
/* 208 */     return this._x509Fingerprint;
/*     */   }
/*     */ 
/*     */   public final void setX509Fingerprint(String fingerprint) {
/* 212 */     this._x509Fingerprint = fingerprint;
/*     */   }
/*     */ 
/*     */   public final byte[] getAuthTokenSignature() {
/* 216 */     return cloneByteArray(this._authTokenSignature);
/*     */   }
/*     */ 
/*     */   public final void setAuthTokenSignature(byte[] paramArrayOfByte) {
/* 220 */     this._authTokenSignature = cloneByteArray(paramArrayOfByte);
/*     */   }
/*     */ 
/*     */   public final void setAuthTokenSignatureString(String authTokenSignatureString)
/*     */   {
/* 229 */     this._authTokenSignatureString = authTokenSignatureString;
/*     */   }
/*     */ 
/*     */   public final String getTimeout() {
/* 233 */     return this._timeout;
/*     */   }
/*     */ 
/*     */   public final void setTimeout(String paramString) {
/* 237 */     this._timeout = paramString;
/* 238 */     Long.parseLong(paramString);
/*     */   }
/*     */ 
/*     */   @Deprecated
/*     */   public final Map<String, Map<String, String>> getElections()
/*     */   {
/* 246 */     return this._elections;
/*     */   }
/*     */ 
/*     */   public final String getElectionId()
/*     */   {
/* 267 */     return this._electionId;
/*     */   }
/*     */ 
/*     */   public final void setElectionId(String electionId) {
/* 271 */     this._electionId = electionId;
/*     */   }
/*     */ 
/*     */   public final String getElectionEventId()
/*     */   {
/* 278 */     return this._electionEventId;
/*     */   }
/*     */ 
/*     */   public final void setElectionEventId(String electionEventId)
/*     */   {
/* 286 */     this._electionEventId = electionEventId;
/*     */   }
/*     */ 
/*     */   public final String getAreaId() {
/* 290 */     return this._areaId;
/*     */   }
/*     */ 
/*     */   public final void setAreaId(String areaId) {
/* 294 */     this._areaId = areaId;
/*     */   }
/*     */ 
/*     */   @Deprecated
/*     */   public final Map<String, Boolean> getVotedElections()
/*     */   {
/* 302 */     return this._votedElections;
/*     */   }
/*     */ 
/*     */   public String toString()
/*     */   {
/*     */     StringBuilder localStringBuilder;
/* 315 */     (
/* 316 */       localStringBuilder = new StringBuilder("Token [ "))
/* 316 */       .append("id=" + this._id);
/* 317 */     localStringBuilder.append(';');
/* 318 */     localStringBuilder.append("debug=" + false);
/* 319 */     localStringBuilder.append(';');
/* 320 */     localStringBuilder.append("creationDateTime=" + this._creationDateTime);
/* 321 */     localStringBuilder.append(';');
/* 322 */     localStringBuilder.append("electionId=" + this._electionId);
/* 323 */     localStringBuilder.append(';');
/* 324 */     localStringBuilder.append("electionEventId=" + this._electionEventId);
/* 325 */     localStringBuilder.append(';');
/* 326 */     localStringBuilder.append("institutionId=" + this._institutionId);
/* 327 */     localStringBuilder.append(';');
/* 328 */     if (this._authTokenSignature != null) {
/* 329 */       localStringBuilder.append("authTokenSignatureSize=").append(this._authTokenSignature.length).append(';');
/*     */     }
/*     */     else
/*     */     {
/* 333 */       localStringBuilder.append("authTokenSignature=;");
/*     */     }
/* 335 */     localStringBuilder.append("_authTokenSignatureString=" + this._authTokenSignatureString);
/*     */ 
/* 337 */     localStringBuilder.append(';');
/* 338 */     localStringBuilder.append("votingService=" + this._votingService);
/* 339 */     localStringBuilder.append(';');
/* 340 */     localStringBuilder.append("canDecrypt=" + this._canDecrypt);
/* 341 */     localStringBuilder.append(';');
/* 342 */     localStringBuilder.append("areaId=" + this._areaId);
/* 343 */     localStringBuilder.append(';');
/* 344 */     localStringBuilder.append("x509Fingerprint=" + this._x509Fingerprint);
/* 345 */     localStringBuilder.append(';');
/* 346 */     localStringBuilder.append("username=" + this._username);
/* 347 */     localStringBuilder.append(';');
/* 348 */     localStringBuilder.append("userRole=" + this._userRole);
/* 349 */     localStringBuilder.append(';');
/* 350 */     localStringBuilder.append("timeout=" + this._timeout);
/* 351 */     localStringBuilder.append(';');
/* 352 */     localStringBuilder.append("sessions=" + this._elections);
/* 353 */     localStringBuilder.append("votedSessions=" + this._votedElections);
/* 354 */     localStringBuilder.append("]");
/*     */ 
/* 356 */     return localStringBuilder.toString();
/*     */   }
/*     */ 
/*     */   public int hashCode()
/*     */   {
/* 375 */     TokenMultiElection localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; localTokenMultiElection = this; return new HashCodeBuilder().append(cloneByteArray(this._authTokenSignature)).append(this._areaId).append(this._canDecrypt).append(this._creationDateTime).append(this._electionEventId).append(this._electionId).append(this._id).append(this._institutionId).append(this._timeout).append(this._username).append(this._userRole).append(this._votingService).append(this._x509Fingerprint).hashCode();
/*     */   }
/*     */ 
/*     */   public boolean equals(Object obj)
/*     */   {
/* 391 */     if (!(obj instanceof TokenMultiElection)) {
/* 392 */       return super.equals(obj);
/*     */     }
/* 394 */     obj = (TokenMultiElection)obj;
/*     */     TokenMultiElection other;
/* 395 */     Object localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; localObject = this; return new EqualsBuilder().append(cloneByteArray(this._authTokenSignature), cloneByteArray((localObject = obj)._authTokenSignature)).append(this._areaId, (localObject = obj)._areaId).append(this._canDecrypt, (localObject = obj)._canDecrypt).append(this._creationDateTime, (localObject = obj)._creationDateTime).append(this._electionEventId, (localObject = obj)._electionEventId).append(this._electionId, (localObject = obj)._electionId).append(this._id, (localObject = obj)._id).append(this._institutionId, (localObject = obj)._institutionId).append(this._timeout, (localObject = obj)._timeout).append(this._username, (localObject = obj)._username).append(this._userRole, (localObject = obj)._userRole).append(this._votingService, (localObject = obj)._votingService).append(this._x509Fingerprint, (localObject = obj)._x509Fingerprint).isEquals();
/*     */   }
/*     */ 
/*     */   private static byte[] cloneByteArray(byte[] input)
/*     */   {
/* 413 */     byte[] result = null;
/* 414 */     if (input != null) {
/* 415 */       result = (byte[])input.clone();
/*     */     }
/* 417 */     return result;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.token.TokenMultiElection
 * JD-Core Version:    0.6.0
 */