/*     */ package com.scytl.common.domain.token;
/*     */ 
/*     */ import com.scytl.common.utils.EncodingHelper;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class TokenMultiElectionSerializer
/*     */ {
/*  31 */   private static final Log LOGGER = LogFactory.getLog(TokenMultiElectionSerializer.class);
/*     */   private final TokenMultiElection _token;
/*     */ 
/*     */   public TokenMultiElectionSerializer(TokenMultiElection token)
/*     */   {
/*  37 */     this._token = token;
/*     */   }
/*     */ 
/*     */   public final String getSignedInfo()
/*     */   {
/*     */     StringBuffer localStringBuffer;
/*  41 */     (
/*  43 */       localStringBuffer = new StringBuffer())
/*  43 */       .append(this._token.getUsername());
/*  44 */     localStringBuffer.append("-");
/*  45 */     localStringBuffer.append(this._token.getCreationDateTime());
/*  46 */     localStringBuffer.append("-");
/*  47 */     localStringBuffer.append(this._token.getTimeout());
/*  48 */     localStringBuffer.append("-");
/*  49 */     localStringBuffer.append(this._token.getId());
/*  50 */     localStringBuffer.append("-");
/*  51 */     localStringBuffer.append(this._token.getElectionId());
/*  52 */     localStringBuffer.append("-");
/*  53 */     localStringBuffer.append(this._token.getX509Fingerprint());
/*  54 */     localStringBuffer.append("-");
/*     */ 
/*  61 */     localStringBuffer.append(this._token.getUserRole());
/*  62 */     localStringBuffer.append("-");
/*  63 */     localStringBuffer.append(this._token.getCanDecrypt());
/*  64 */     localStringBuffer.append("-");
/*  65 */     localStringBuffer.append(this._token.getAreaId());
/*     */ 
/*  74 */     this = localStringBuffer.toString();
/*     */ 
/*  76 */     LOGGER.debug("Token SIGNED data: " + this);
/*     */ 
/*  88 */     return this;
/*     */   }
/*     */ 
/*     */   public final String serializeAsURLParameter()
/*     */   {
/* 221 */     return this = this._token.getId() + serializeSecurely(this._token.getCreationDateTime()) + serializeSecurely(this._token.getElectionId()) + serializeSecurely(this._token.getElectionEventId()) + serializeSecurely(this._token.getInstitutionId() == null ? null : EncodingHelper.getString(Base64.encodeBase64(EncodingHelper.getBytes(this._token.getInstitutionId())))) + serializeSecurely(this._token.getVotingService()) + serializeSecurely(this._token.getX509Fingerprint()) + "-" + (this._token.getUsername() == null ? "null" : recode(this._token.getUsername())) + serializeSecurely(this._token.getUserRole()) + serializeSecurely(this._token.getCanDecrypt()) + serializeSecurely(this._token.getAreaId()) + serializeSecurely(this._token.getTimeout()) + serializeSecurely(this._token.getAuthTokenSignature() == null ? null : EncodingHelper.getString(Base64.encodeBase64(this._token.getAuthTokenSignature()))) + "-" + getElectionsSerialized(";", true);
/*     */   }
/*     */ 
/*     */   private static String serializeSecurely(String item)
/*     */   {
/* 231 */     return "-" + (item == null ? "null" : item);
/*     */   }
/*     */ 
/*     */   private static String recode(String paramString)
/*     */   {
/* 239 */     return EncodingHelper.getString(Base64.encodeBase64(EncodingHelper.getBytes(paramString)));
/*     */   }
/*     */ 
/*     */   private String getElectionsSerialized(String paramString, boolean paramBoolean)
/*     */   {
/* 246 */     paramBoolean = new StringBuilder("");
/*     */     Object localObject1;
/* 250 */     if (((
/* 250 */       localObject1 = this._token.getElections()) == null) || 
/* 250 */       (((Map)localObject1).size() == 0)) {
/* 251 */       paramBoolean.append("null");
/*     */     } else {
/* 253 */       localObject1 = ((Map)localObject1).entrySet().iterator();
/* 254 */       while (((Iterator)localObject1).hasNext())
/*     */       {
/* 256 */         Object localObject3 = (String)(
/* 256 */           localObject2 = (Map.Entry)((Iterator)localObject1).next())
/* 256 */           .getKey();
/* 257 */         Object localObject4 = (Boolean)this._token.getVotedElections().get(localObject3);
/* 258 */         Object localObject2 = (Map)((Map.Entry)localObject2).getValue();
/*     */ 
/* 260 */         paramBoolean.append((String)localObject3).append(paramString).append(localObject4);
/*     */ 
/* 263 */         if (localObject2 != null) {
/* 264 */           for (localObject2 = ((Map)localObject2).entrySet().iterator(); ((Iterator)localObject2).hasNext(); )
/*     */           {
/* 266 */             localObject4 = (String)(
/* 266 */               localObject3 = (Map.Entry)((Iterator)localObject2).next())
/* 266 */               .getKey();
/* 267 */             localObject3 = (String)((Map.Entry)localObject3).getValue();
/* 268 */             paramBoolean.append(paramString).append((String)localObject4).append(paramString).append(recode((String)localObject3));
/*     */           }
/*     */ 
/*     */         }
/*     */ 
/* 273 */         paramBoolean.append(paramString).append("ENDELECTION");
/*     */ 
/* 278 */         if (((Iterator)localObject1).hasNext()) {
/* 279 */           paramBoolean.append(paramString);
/*     */         }
/*     */       }
/*     */     }
/* 283 */     return (String)(String)(String)(String)paramBoolean.toString();
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.domain.token.TokenMultiElectionSerializer
 * JD-Core Version:    0.6.0
 */