/*     */ package com.scytl.common.messages;
/*     */ 
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.io.IOException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.Set;
/*     */ import javax.xml.parsers.ParserConfigurationException;
/*     */ import javax.xml.xpath.XPathException;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.slf4j.LoggerFactory;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.InputSource;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.XMLReader;
/*     */ 
/*     */ public class MessageServer
/*     */   implements ContentHandler
/*     */ {
/*  35 */   public static final ComponentMonitor LOGGER$54f09f98 = LoggerFactory.getLogger$4ecaad6a(ReceiptMessageServer.class);
/*     */ 
/*  38 */   private final PathStack _path = new PathStack(10);
/*     */ 
/*  40 */   private final HashMap<String, String> _data = new HashMap(16);
/*     */ 
/*  43 */   private boolean _readValue = false;
/*     */ 
/*  45 */   private StringBuffer _buffer = null;
/*     */ 
/*  47 */   private final ArrayList<String> _attributes = new ArrayList();
/*     */ 
/*     */   public void parse(XMLReader reader, String xml)
/*     */     throws ParserConfigurationException, SAXException, IOException
/*     */   {
/*  64 */     reader.setContentHandler(this);
/*  65 */     reader.parse(new InputSource(new ByteArrayInputStream(xml.getBytes())));
/*     */   }
/*     */ 
/*     */   public void setDocumentLocator(Locator locator)
/*     */   {
/*     */   }
/*     */ 
/*     */   public void startDocument()
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void endDocument()
/*     */     throws SAXException
/*     */   {
/*  85 */     this._path.clear();
/*     */   }
/*     */ 
/*     */   public void startPrefixMapping(String prefix, String uri)
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void endPrefixMapping(String prefix)
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void startElement(String paramString1, String paramString2, String paramString3, Attributes paramAttributes)
/*     */     throws SAXException
/*     */   {
/* 109 */     this._path.push(paramString3);
/*     */ 
/* 111 */     if ((this._attributes.size() > 0) && (this._attributes.contains(paramString3)))
/*     */     {
/* 113 */       for (paramString1 = 0; paramString1 < paramAttributes.getLength(); paramString1++) {
/* 114 */         (
/* 115 */           paramString2 = new StringBuffer())
/* 115 */           .append(this._path.top());
/* 116 */         paramString2.append("/@");
/* 117 */         paramString2.append(paramAttributes.getQName(paramString1));
/* 118 */         if (this._data.containsKey(paramString2.toString())) {
/* 119 */           this._data.put(paramString2.toString(), paramAttributes.getValue(paramString1).trim());
/*     */         }
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 125 */     if (this._data.containsKey(this._path.top())) {
/* 126 */       this._readValue = true;
/* 127 */       this._buffer = new StringBuffer();
/*     */     }
/*     */   }
/*     */ 
/*     */   public void endElement(String paramString1, String paramString2, String paramString3)
/*     */     throws SAXException
/*     */   {
/* 138 */     if (this._readValue) {
/* 139 */       this._data.put(this._path.top(), this._buffer.toString().trim());
/* 140 */       this._readValue = false;
/* 141 */       this._buffer = null;
/*     */     }
/* 143 */     this._path.pop();
/*     */   }
/*     */ 
/*     */   public void characters(char[] paramArrayOfChar, int paramInt1, int paramInt2)
/*     */     throws SAXException
/*     */   {
/* 151 */     if ((this._readValue) && (this._buffer != null))
/*     */     {
/* 153 */       if ((
/* 153 */         paramArrayOfChar = new String(paramArrayOfChar, paramInt1, paramInt2))
/* 153 */         .length() > 0)
/* 154 */         this._buffer.append(paramArrayOfChar);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void ignorableWhitespace(char[] ch, int start, int length)
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void processingInstruction(String target, String data)
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void skippedEntity(String name)
/*     */     throws SAXException
/*     */   {
/*     */   }
/*     */ 
/*     */   protected final String getString(String string)
/*     */     throws XPathException
/*     */   {
/* 187 */     if (!this._data.keySet().contains(string)) {
/* 188 */       throw new XPathException("ER_XPATH_ERROR :: " + string + " not found.");
/*     */     }
/*     */ 
/* 191 */     return (String)this._data.get(string);
/*     */   }
/*     */ 
/*     */   public void clear()
/*     */   {
/* 199 */     this._attributes.clear();
/* 200 */     this._data.clear();
/*     */   }
/*     */ 
/*     */   public void add(String paramString)
/*     */   {
/* 209 */     if (paramString != null)
/* 210 */       this._data.put(paramString, null);
/*     */   }
/*     */ 
/*     */   public void addQNameCheckAttributes(String paramString)
/*     */   {
/* 218 */     this._attributes.add(paramString);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.messages.MessageServer
 * JD-Core Version:    0.6.0
 */