/*    */ package com.scytl.common.messages;
/*    */ 
/*    */ import java.security.InvalidKeyException;
/*    */ import java.security.NoSuchAlgorithmException;
/*    */ import java.security.PublicKey;
/*    */ import java.security.Signature;
/*    */ import java.security.SignatureException;
/*    */ import org.picocontainer.ComponentMonitor;
/*    */ import org.slf4j.LoggerFactory;
/*    */ 
/*    */ public class ReceiptVerifier
/*    */ {
/* 29 */   private static final ComponentMonitor LOGGER$54f09f98 = LoggerFactory.getLogger$4ecaad6a(ReceiptVerifier.class);
/*    */   private Signature _signature;
/*    */ 
/*    */   public ReceiptVerifier(PublicKey paramPublicKey)
/*    */   {
/*    */     try
/*    */     {
/* 36 */       this._signature = Signature.getInstance("SHA256withRSA");
/*    */ 
/* 39 */       this._signature.initVerify(paramPublicKey);
/*    */ 
/* 44 */       return;
/*    */     }
/*    */     catch (NoSuchAlgorithmException localNoSuchAlgorithmException)
/*    */     {
/* 41 */       this._signature = null;
/*    */ 
/* 44 */       return;
/*    */     }
/*    */     catch (InvalidKeyException localInvalidKeyException)
/*    */     {
/* 43 */       this._signature = null;
/*    */     }
/*    */   }
/*    */ 
/*    */   public synchronized boolean verify(byte[] paramArrayOfByte1, byte[] paramArrayOfByte2)
/*    */   {
/* 62 */     if (this._signature != null) {
/*    */       try
/*    */       {
/* 65 */         this._signature.update(paramArrayOfByte1);
/* 66 */         return this._signature.verify(paramArrayOfByte2);
/*    */       } catch (SignatureException this) {
/* 68 */         if (LOGGER$54f09f98.isDebugEnabled()) {
/* 69 */           LOGGER$54f09f98.debug("Unable to verify signature: " + getMessage());
/*    */         }
/*    */       }
/*    */     }
/*    */ 
/* 74 */     return false;
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.common.messages.ReceiptVerifier
 * JD-Core Version:    0.6.0
 */