/*     */ package com.scytl.crypto;
/*     */ 
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.Key;
/*     */ import java.security.KeyException;
/*     */ import java.security.KeyPairGenerator;
/*     */ import java.security.MessageDigest;
/*     */ import java.security.PrivateKey;
/*     */ import java.security.PublicKey;
/*     */ import java.security.SecureRandom;
/*     */ import java.security.Signature;
/*     */ import javax.crypto.Cipher;
/*     */ import javax.crypto.KeyGenerator;
/*     */ import javax.crypto.Mac;
/*     */ import javax.crypto.SecretKey;
/*     */ import javax.crypto.spec.IvParameterSpec;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class CryptographicAlgorithms
/*     */ {
/*  42 */   private static Log _logger = LogFactory.getLog(CryptographicAlgorithms.class);
/*     */   private KeyPairGenerator _keyPairGenerator;
/*     */   private KeyGenerator _keyGenerator;
/*     */   private SecureRandom _secureRandom;
/*     */ 
/*     */   public CryptographicAlgorithms()
/*     */     throws GeneralSecurityException
/*     */   {
/*  54 */     this = this;
/*     */     try { Cipher.getInstance("RSA/ECB/OAEPWITHSHA-256ANDMGF1PADDING"); int i = Cipher.getMaxAllowedKeyLength("RSA/ECB/OAEPWITHSHA-256ANDMGF1PADDING"); if (2048 > i) throw new KeyException("The maximum key length allowed for RSA/ECB/OAEPWITHSHA-256ANDMGF1PADDING is " + i + ". Needed at least " + 2048); MessageDigest.getInstance("SHA-256"); Mac.getInstance("HMACSHA256"); KeyPairGenerator.getInstance("RSA"); KeyGenerator.getInstance("AES"); Signature.getInstance("SHA256withRSA"); Cipher.getInstance("AES/CBC/PKCS5Padding"); } catch (GeneralSecurityException this) { _logger.error("The available providers do not support all of the necessary cryptographic algorithms.", this); throw this; } this._secureRandom = SecureRandom.getInstance("SHA1PRNG"); this._keyGenerator = KeyGenerator.getInstance("AES"); this._keyGenerator.init(128, this._secureRandom); this._keyPairGenerator = KeyPairGenerator.getInstance("RSA"); this._keyPairGenerator.initialize(2048, this._secureRandom);
/*     */   }
/*     */ 
/*     */   public static byte[] hash(byte[] what)
/*     */   {
/*     */     try
/*     */     {
/*     */       MessageDigest md;
/* 115 */       return (
/* 115 */         md = MessageDigest.getInstance("SHA-256"))
/* 115 */         .digest(what); } catch (GeneralSecurityException gse) {
/*     */     }
/* 117 */     throw new RuntimeException(gse);
/*     */   }
/*     */ 
/*     */   private byte[] encryption(int paramInt, byte[] paramArrayOfByte, Key paramKey, String paramString)
/*     */   {
/*     */     try
/*     */     {
/* 167 */       paramInt = Cipher.getInstance(paramString);
/* 168 */       paramString = null;
/* 169 */       if (((paramString = paramInt).getBlockSize() > 0 ? 1 : 0) != 0) {
/* 170 */         this = generateRandom(paramInt.getBlockSize());
/*     */ 
/* 182 */         paramInt.init(1, paramKey, new IvParameterSpec(this));
/* 183 */         paramString = packSymetricMsg(this, paramInt.doFinal(paramArrayOfByte));
/*     */       }
/*     */       else
/*     */       {
/* 189 */         paramInt.init(1, paramKey);
/* 190 */         paramString = paramInt.doFinal(paramArrayOfByte);
/*     */       }
/* 192 */       return paramString; } catch (GeneralSecurityException paramInt) {
/*     */     }
/* 194 */     throw new RuntimeException(paramInt);
/*     */   }
/*     */ 
/*     */   public final byte[] symmetricEncrypt(byte[] what, SecretKey key)
/*     */   {
/* 222 */     return encryption(1, what, key, "AES/CBC/PKCS5Padding");
/*     */   }
/*     */ 
/*     */   public final byte[] asymmetricEncrypt(byte[] what, PublicKey key)
/*     */   {
/* 234 */     return encryption(1, what, key, "RSA/ECB/OAEPWITHSHA-256ANDMGF1PADDING");
/*     */   }
/*     */ 
/*     */   public static byte[] sign(byte[] what, PrivateKey key)
/*     */   {
/*     */     try
/*     */     {
/*     */       Signature signature;
/* 272 */       (
/* 275 */         signature = Signature.getInstance("SHA256withRSA"))
/* 275 */         .initSign(key);
/* 276 */       signature.update(what);
/* 277 */       return signature.sign(); } catch (GeneralSecurityException gse) {
/*     */     }
/* 279 */     throw new RuntimeException(gse);
/*     */   }
/*     */ 
/*     */   public static boolean verify(byte[] paramArrayOfByte1, byte[] paramArrayOfByte2, PublicKey paramPublicKey)
/*     */   {
/*     */     try
/*     */     {
/*     */       Signature localSignature;
/* 297 */       (
/* 300 */         localSignature = Signature.getInstance("SHA256withRSA"))
/* 300 */         .initVerify(paramPublicKey);
/* 301 */       localSignature.update(paramArrayOfByte1);
/* 302 */       return localSignature.verify(paramArrayOfByte2); } catch (GeneralSecurityException localGeneralSecurityException) {
/*     */     }
/* 304 */     throw new RuntimeException(localGeneralSecurityException);
/*     */   }
/*     */ 
/*     */   public final SecretKey generateSymmetricKey()
/*     */   {
/* 313 */     return this._keyGenerator.generateKey();
/*     */   }
/*     */ 
/*     */   public final byte[] generateRandom(int length)
/*     */   {
/* 329 */     length = new byte[length];
/*     */     byte[] randomBytes;
/* 330 */     this._secureRandom.nextBytes(length);
/* 331 */     return length;
/*     */   }
/*     */ 
/*     */   private static byte[] packSymetricMsg(byte[] paramArrayOfByte1, byte[] paramArrayOfByte2)
/*     */   {
/* 370 */     byte[] arrayOfByte = new byte[paramArrayOfByte1.length + paramArrayOfByte2.length];
/* 371 */     for (int i = 0; i < paramArrayOfByte1.length; i++) {
/* 372 */       arrayOfByte[i] = paramArrayOfByte1[i];
/*     */     }
/* 374 */     i = paramArrayOfByte1.length;
/* 375 */     paramArrayOfByte1 = 0;
/* 376 */     for (; paramArrayOfByte1 < paramArrayOfByte2.length; paramArrayOfByte1++) {
/* 377 */       arrayOfByte[i] = paramArrayOfByte2[paramArrayOfByte1];
/*     */ 
/* 376 */       i++;
/*     */     }
/*     */ 
/* 379 */     return arrayOfByte;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.crypto.CryptographicAlgorithms
 * JD-Core Version:    0.6.0
 */