/*     */ package com.scytl.crypto;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.KeyStore;
/*     */ import java.security.KeyStore.PasswordProtection;
/*     */ import java.security.KeyStore.PrivateKeyEntry;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.PrivateKey;
/*     */ import java.security.cert.Certificate;
/*     */ import java.security.cert.CertificateEncodingException;
/*     */ import java.security.cert.CertificateException;
/*     */ import java.security.cert.CertificateFactory;
/*     */ import java.security.cert.X509Certificate;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.List;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class CryptographicFormats
/*     */ {
/*  39 */   private static Log _logger = LogFactory.getLog(CryptographicFormats.class);
/*     */ 
/*     */   public CryptographicFormats()
/*     */     throws GeneralSecurityException
/*     */   {
/*     */     try
/*     */     {
/*  49 */       CertificateFactory.getInstance("X.509"); KeyStore.getInstance("pkcs12");
/*     */ 
/*  56 */       return;
/*     */     }
/*     */     catch (GeneralSecurityException this)
/*     */     {
/*  51 */       _logger.error("The available providers do not support all of the necessary cryptographic formats.", this);
/*     */     }
/*     */ 
/*  55 */     throw this;
/*     */   }
/*     */ 
/*     */   public static Certificate readCertificate(InputStream is)
/*     */     throws CertificateException
/*     */   {
/*     */     CertificateFactory cf;
/*  73 */     return (
/*  73 */       cf = CertificateFactory.getInstance("X.509"))
/*  73 */       .generateCertificate(is);
/*     */   }
/*     */ 
/*     */   public static Collection<? extends Certificate> readCertificates(InputStream is)
/*     */     throws CertificateException
/*     */   {
/*     */     CertificateFactory cf;
/*  84 */     return (
/*  84 */       cf = CertificateFactory.getInstance("X.509"))
/*  84 */       .generateCertificates(is);
/*     */   }
/*     */ 
/*     */   public final String certificatesPEM(Certificate[] paramArrayOfCertificate)
/*     */     throws CertificateEncodingException
/*     */   {
/* 121 */     StringBuilder localStringBuilder = new StringBuilder();
/* 122 */     for (Object localObject1 : paramArrayOfCertificate) {
/* 123 */       Object localObject2 = localObject1; localObject1 = this; (localObject1 = new StringBuilder()).append("-----BEGIN CERTIFICATE-----\n"); ((StringBuilder)localObject1).append(new String(Base64.encodeBase64((localObject2 = localObject2).getEncoded(), true))); ((StringBuilder)localObject1).append("-----END CERTIFICATE-----"); localStringBuilder.append(((StringBuilder)localObject1).toString()).append("\n");
/*     */     }
/* 125 */     return (String)localStringBuilder.toString();
/*     */   }
/*     */ 
/*     */   public static KeyStore readKeyStore(InputStream is, char[] password)
/*     */     throws GeneralSecurityException, IOException
/*     */   {
/*     */     KeyStore ks;
/* 141 */     (
/* 143 */       ks = KeyStore.getInstance("pkcs12"))
/* 143 */       .load(is, password);
/* 144 */     return ks;
/*     */   }
/*     */ 
/*     */   public static PrivateKey getUserPrivateKey(KeyStore paramKeyStore, String paramString, char[] paramArrayOfChar)
/*     */     throws KeyStoreException
/*     */   {
/* 184 */     paramArrayOfChar = new KeyStore.PasswordProtection(paramArrayOfChar);
/*     */     try
/*     */     {
/* 190 */       return (
/* 190 */         paramKeyStore = (KeyStore.PrivateKeyEntry)paramKeyStore.getEntry(paramString, paramArrayOfChar))
/* 190 */         .getPrivateKey(); } catch (GeneralSecurityException paramKeyStore) {
/*     */     }
/* 192 */     throw new KeyStoreException("Malformed Keystore", paramKeyStore);
/*     */   }
/*     */ 
/*     */   public final X509Certificate[] getUserCertificateChain(KeyStore paramKeyStore, String paramString)
/*     */     throws KeyStoreException
/*     */   {
/*     */     try
/*     */     {
/* 237 */       this = paramKeyStore.getCertificateChain(paramString); paramKeyStore = new ArrayList(); paramString = this; int i = this.length; for (int j = 0; j < i; j++) { Object localObject = paramString[j]; paramKeyStore.add((X509Certificate)localObject); } return (X509Certificate[])paramKeyStore.toArray(new X509Certificate[this.length]);
/*     */     }
/*     */     catch (KeyStoreException this) {
/*     */     }
/* 241 */     throw new KeyStoreException("Malformed Keystore", this);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.crypto.CryptographicFormats
 * JD-Core Version:    0.6.0
 */