package com.scytl.crypto.signature;

import com.scytl.xml.DomHelper;
import java.io.InputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchAlgorithmException;
import java.security.PublicKey;
import javax.xml.crypto.dsig.XMLSignature;
import javax.xml.crypto.dsig.XMLSignatureFactory;
import javax.xml.crypto.dsig.dom.DOMValidateContext;
import javax.xml.crypto.dsig.keyinfo.KeyInfoFactory;
import org.jcp.xml.dsig.internal.dom.XMLDSigRI;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XmlSignature
{
  private XMLSignatureFactory _xmlSignatureFactory;
  private final DomHelper _dom = new DomHelper();

  public boolean verify(PublicKey paramPublicKey, InputStream paramInputStream, String paramString)
    throws XmlSignatureException
  {
    paramString = paramString;
    if ((paramInputStream = (paramInputStream = paramInputStream = this._dom.parse(paramInputStream)).getElementsByTagName(paramString)).getLength() != 1)
      throw new XmlSignatureException("Expected to find exactly one node :: " + paramString + ". Found :: " + paramInputStream.getLength());
    paramInputStream = paramInputStream.item(0);
    (paramPublicKey = new DOMValidateContext(paramPublicKey, paramInputStream.getChildNodes().item(0))).setBaseURI("");
    try
    {
      return (this = this._xmlSignatureFactory.unmarshalXMLSignature(paramPublicKey)).validate(paramPublicKey);
    }
    catch (javax.xml.crypto.MarshalException this)
    {
      throw new XmlSignatureException(this);
    }
    catch (javax.xml.crypto.dsig.XMLSignatureException this)
    {
    }
    throw new XmlSignatureException(this);
  }

  public XmlSignature()
    throws XmlSignatureException
  {
    this = this;
    try
    {
      XMLDSigRI localXMLDSigRI = new XMLDSigRI();
      this._xmlSignatureFactory = XMLSignatureFactory.getInstance("DOM", localXMLDSigRI);
      KeyInfoFactory.getInstance("DOM", localXMLDSigRI);
      this = this;
      this._xmlSignatureFactory.newDigestMethod("http://www.w3.org/2001/04/xmlenc#sha256", null);
      this._xmlSignatureFactory.newSignatureMethod("http://www.w3.org/2001/04/xmldsig-more#rsa-sha256", null);
      this._xmlSignatureFactory.newTransform("http://www.w3.org/2000/09/xmldsig#enveloped-signature", null);
      this._xmlSignatureFactory.newCanonicalizationMethod("http://www.w3.org/2001/10/xml-exc-c14n#", null);
      return;
    }
    catch (NoSuchAlgorithmException localNoSuchAlgorithmException)
    {
      throw new XmlSignatureException(localNoSuchAlgorithmException);
    }
    catch (InvalidAlgorithmParameterException localInvalidAlgorithmParameterException)
    {
    }
    throw new XmlSignatureException(localInvalidAlgorithmParameterException);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.crypto.signature.XmlSignature
 * JD-Core Version:    0.6.0
 */