/*     */ package com.scytl.internationalization;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collections;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.List<Ljava.util.Locale;>;
/*     */ import java.util.Locale;
/*     */ import java.util.Properties;
/*     */ import javax.naming.InitialContext;
/*     */ import javax.naming.NamingException;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class ConfigurationProperties
/*     */ {
/*  39 */   private static final Log LOGGER = LogFactory.getLog(ConfigurationProperties.class);
/*     */   private final Properties _properties;
/*     */   private final Locale _defaultLocale;
/*     */   private final List<Locale> _supportedLocales;
/*     */ 
/*     */   public ConfigurationProperties()
/*     */   {
/*  53 */     this(null);
/*     */   }
/*     */ 
/*     */   private ConfigurationProperties(String paramString) {
/*  57 */     paramString = null;
/*     */ 
/*  59 */     Object localObject1 = "/internationalization.properties";
/*     */     try {
/*  61 */       localObject2 = new InitialContext();
/*     */       try
/*     */       {
/*  65 */         paramString = (String)((InitialContext)localObject2).lookup("customer");
/*     */       } catch (NamingException localNamingException1) {
/*  67 */         paramString = (String)((InitialContext)localObject2).lookup("java:/env/customer");
/*     */       }
/*     */     }
/*     */     catch (NamingException localNamingException2)
/*     */     {
/*  72 */       LOGGER.warn("Error searching customer resource. Use default.");
/*     */     }
/*     */ 
/*  77 */     if ((paramString != null) && (paramString.length() > 0))
/*     */     {
/*  80 */       localObject3 = localObject1 = "/customers/" + paramString + "/internationalization.properties";
/*     */ 
/*  80 */       if (ConfigurationProperties.class.getResourceAsStream((String)localObject3) == null) {
/*  81 */         LOGGER.error("Resource file not found: " + (String)localObject1);
/*     */ 
/*  83 */         localObject1 = "/internationalization.properties";
/*     */       }
/*     */     }
/*     */ 
/*  87 */     Object localObject2 = new Properties();
/*  88 */     Object localObject3 = localObject1; paramString = ConfigurationProperties.class.getResourceAsStream((String)localObject3);
/*  89 */     localObject3 = "/override-internationalization.properties"; localObject1 = ConfigurationProperties.class.getResourceAsStream((String)localObject3);
/*     */     try {
/*  91 */       if (paramString == null) {
/*  92 */         throw new RuntimeException("Missing required resource :: /internationalization.properties");
/*     */       }
/*     */ 
/*  95 */       ((Properties)localObject2).load(paramString);
/*  96 */       if (localObject1 != null) {
/*  97 */         ((Properties)localObject2).load((InputStream)localObject1);
/*     */       }
/*  99 */       this._properties = ((Properties)localObject2);
/* 100 */       this._defaultLocale = initDefaultLocale();
/* 101 */       this._supportedLocales = Collections.unmodifiableList(initSupportedLocales());
/*     */ 
/* 106 */       if (paramString != null) {
/*     */         try {
/* 108 */           paramString.close();
/*     */         } catch (IOException this) {
/* 110 */           LOGGER.debug("Ignoring on finally block closing default configuration.", this);
/*     */         }
/*     */ 
/*     */       }
/*     */ 
/* 116 */       if (localObject1 != null)
/*     */         try {
/* 118 */           ((InputStream)localObject1).close();
/*     */ 
/* 124 */           return;
/*     */         }
/*     */         catch (IOException this)
/*     */         {
/* 120 */           LOGGER.debug("Ignoring on finally block closing optional configuration.", this);
/*     */ 
/* 124 */           return;
/*     */         }
/*     */     }
/*     */     catch (IOException localIOException)
/*     */     {
/* 104 */       throw new RuntimeException("Error reading properties file.");
/*     */     } finally {
/* 106 */       if (paramString != null) {
/*     */         try {
/* 108 */           paramString.close();
/*     */         } catch (IOException paramString) {
/* 110 */           LOGGER.debug("Ignoring on finally block closing default configuration.", paramString);
/*     */         }
/*     */ 
/*     */       }
/*     */ 
/* 116 */       if (localObject1 != null)
/*     */         try {
/* 118 */           ((InputStream)localObject1).close();
/*     */         } catch (IOException paramString) {
/* 120 */           LOGGER.debug("Ignoring on finally block closing optional configuration.", paramString);
/*     */         }
/*     */     }
/*     */   }
/*     */ 
/*     */   public ConfigurationProperties(Properties properties)
/*     */   {
/* 130 */     this._properties = properties;
/* 131 */     this._defaultLocale = initDefaultLocale();
/* 132 */     this._supportedLocales = Collections.unmodifiableList(initSupportedLocales());
/*     */   }
/*     */ 
/*     */   public final List<Locale> getSupportedLocales()
/*     */   {
/* 143 */     return this._supportedLocales;
/*     */   }
/*     */ 
/*     */   private List<Locale> initSupportedLocales() {
/* 147 */     Object localObject = (String)this._properties.get("language.supported");
/*     */     ArrayList localArrayList;
/* 151 */     this = this;
/*     */ 
/* 148 */     (
/* 151 */       localArrayList = new ArrayList())
/* 151 */       .add(this._defaultLocale);
/*     */ 
/* 153 */     if ((localObject != null) && (((String)localObject).trim().length() != 0))
/* 154 */       localArrayList.addAll(getLocales((String)localObject));
/*     */     else {
/* 156 */       LOGGER.warn("No available locales specified.");
/*     */     }
/*     */ 
/* 159 */     for (this = localArrayList.iterator(); hasNext(); ) { localObject = (Locale)next();
/* 160 */       if (Collections.frequency(localArrayList, localObject) > 1) {
/* 161 */         throw new RuntimeException("Repeated locales specified :: " + localArrayList);
/*     */       }
/*     */     }
/*     */ 
/* 165 */     return (List<Locale>)localArrayList;
/*     */   }
/*     */ 
/*     */   private static List<Locale> getLocales(String paramString)
/*     */   {
/* 183 */     paramString = paramString.split(",");
/*     */ 
/* 185 */     ArrayList localArrayList = new ArrayList();
/* 186 */     for (int i = 0; i < paramString.length; i++)
/*     */     {
/*     */       String str;
/* 188 */       if ((
/* 188 */         str = paramString[i].trim())
/* 188 */         .length() > 0) {
/* 189 */         localArrayList.add(new Locale(str));
/*     */       }
/*     */     }
/* 192 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public final Locale getDefaultLocale() {
/* 196 */     return this._defaultLocale;
/*     */   }
/*     */ 
/*     */   private Locale initDefaultLocale()
/*     */   {
/*     */     String defaultLanguage;
/* 202 */     if (((
/* 202 */       defaultLanguage = ((String)this._properties.get("language.default")).trim()) == null) || 
/* 202 */       (length() == 0)) {
/* 203 */       throw new RuntimeException("No default locale specified.");
/*     */     }
/* 205 */     return new Locale(this);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.internationalization.ConfigurationProperties
 * JD-Core Version:    0.6.0
 */