/*    */ package com.scytl.pnyx.client.cert.impl;
/*    */ 
/*    */ import com.scytl.pnyx.client.cert.CorporateCertificatePrincipalExtractor;
/*    */ import java.security.cert.X509Certificate;
/*    */ import javax.security.auth.x500.X500Principal;
/*    */ import org.bouncycastle.asn1.x509.X509Name;
/*    */ 
/*    */ public class AncertCertificatePrincipalExtractor extends SerialNumberCertificateParser
/*    */   implements CorporateCertificatePrincipalExtractor
/*    */ {
/*    */   public String getOrganizationId(X509Certificate paramX509Certificate)
/*    */   {
/* 43 */     if (isCNCR(this = new X509Name(paramX509Certificate.getSubjectX500Principal().toString())))
/*    */     {
/* 44 */       return getCif(DNUtils.getOrgUnit(this));
/* 45 */     }if (isCNC(this)) {
/* 46 */       return getCif(DNUtils.getCommonName(this));
/*    */     }
/* 48 */     return null;
/*    */   }
/*    */ 
/*    */   public String getUserName(X509Certificate paramX509Certificate)
/*    */   {
/*    */     X509Name localX509Name;
/* 58 */     if (isCNCR(localX509Name = new X509Name(paramX509Certificate.getSubjectX500Principal().toString())))
/*    */     {
/* 59 */       return super.getUserName(paramX509Certificate);
/* 60 */     }if (isCNC(localX509Name)) {
/* 61 */       if ((paramX509Certificate = (this = DNUtils.getCommonName(localX509Name)).indexOf("- NIF ")) < 0) throw new RuntimeException("NIF delimiter not found in string :: " + this); return substring(paramX509Certificate + "- NIF ".length(), paramX509Certificate + "- CIF ".length() + 9);
/*    */     }
/* 63 */     return null;
/*    */   }
/*    */ 
/*    */   private static boolean isCNC(X509Name name) {
/* 67 */     return "Certificado Notarial Corporativo".equals(DNUtils.getOrganization(name));
/*    */   }
/*    */ 
/*    */   private static boolean isCNCR(X509Name name) {
/* 71 */     return "Certificado Notarial Corporativo de Representacion".equals(DNUtils.getOrganization(name));
/*    */   }
/*    */ 
/*    */   private static String getCif(String name)
/*    */   {
/*    */     int start;
/* 76 */     if ((
/* 76 */       start = name.indexOf("- CIF ")) < 0)
/*    */     {
/* 77 */       throw new RuntimeException("CIF delimiter not found in string :: " + name);
/*    */     }
/*    */ 
/* 80 */     return name.substring(start + "- CIF ".length(), start + "- CIF ".length() + 9);
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.cert.impl.AncertCertificatePrincipalExtractor
 * JD-Core Version:    0.6.0
 */