/*    */ package com.scytl.pnyx.client.cert.impl;
/*    */ 
/*    */ import com.scytl.pnyx.client.cert.CorporateCertificatePrincipalExtractor;
/*    */ import java.security.cert.X509Certificate;
/*    */ import javax.security.auth.x500.X500Principal;
/*    */ import org.bouncycastle.asn1.DERObjectIdentifier;
/*    */ import org.bouncycastle.asn1.x509.X509Name;
/*    */ 
/*    */ public class CamerfirmaCertificatePrincipalExtractor extends SerialNumberCertificateParser
/*    */   implements CorporateCertificatePrincipalExtractor
/*    */ {
/* 27 */   private static final DERObjectIdentifier COMPANY_ID_NUMBER_OID = new DERObjectIdentifier("1.3.6.1.4.1.17326.30.3");
/*    */ 
/* 30 */   private static final DERObjectIdentifier COMPANY_ID_NUMBER_OID_AEAT = new DERObjectIdentifier("1.3.6.1.4.1.18838.1.1");
/*    */ 
/*    */   public String getOrganizationId(X509Certificate paramX509Certificate)
/*    */   {
/*    */     X509Name localX509Name;
/* 39 */     if (isPj(localX509Name = new X509Name(paramX509Certificate.getSubjectX500Principal().toString())))
/*    */     {
/* 40 */       return super.getUserName(paramX509Certificate);
/* 41 */     }if (isPfPr(localX509Name)) {
/* 42 */       return DNUtils.getDNPart(localX509Name, COMPANY_ID_NUMBER_OID).substring(2);
/*    */     }
/*    */ 
/* 45 */     return null;
/*    */   }
/*    */ 
/*    */   public String getUserName(X509Certificate paramX509Certificate)
/*    */   {
/*    */     X509Name localX509Name;
/* 55 */     if (isPfPr(localX509Name = new X509Name(paramX509Certificate.getSubjectX500Principal().toString())))
/*    */     {
/* 56 */       return super.getUserName(paramX509Certificate);
/* 57 */     }if (isPj(localX509Name)) {
/* 58 */       return DNUtils.getDNPart(localX509Name, COMPANY_ID_NUMBER_OID_AEAT);
/*    */     }
/* 60 */     return null;
/*    */   }
/*    */ 
/*    */   private static boolean isPfPr(X509Name paramX509Name)
/*    */   {
/* 65 */     return ((
/* 65 */       paramX509Name = DNUtils.getDNPart(paramX509Name, COMPANY_ID_NUMBER_OID)) != null) && 
/* 65 */       (paramX509Name.length() > 0);
/*    */   }
/*    */ 
/*    */   private static boolean isPj(X509Name paramX509Name)
/*    */   {
/* 71 */     return ((
/* 71 */       paramX509Name = DNUtils.getDNPart(paramX509Name, COMPANY_ID_NUMBER_OID_AEAT)) != null) && 
/* 71 */       (paramX509Name.length() > 0);
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.cert.impl.CamerfirmaCertificatePrincipalExtractor
 * JD-Core Version:    0.6.0
 */