/*     */ package com.scytl.pnyx.client.cert.impl;
/*     */ 
/*     */ import com.scytl.pnyx.client.cert.CertificatePrincipalExtractor;
/*     */ import com.scytl.pnyx.client.cert.CertificatePrincipalExtractorSelector;
/*     */ import com.scytl.pnyx.client.cert.IssuerDNCertificatePrincipalExtractorSelector;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.net.MalformedURLException;
/*     */ import java.net.URL;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.security.cert.Certificate;
/*     */ import java.util.HashMap;
/*     */ import java.util.InvalidPropertiesFormatException;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Properties;
/*     */ import java.util.Set;
/*     */ import javax.security.auth.x500.X500Principal;
/*     */ import org.apache.commons.io.IOUtils;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class PropertiesCertificateParserSelector
/*     */   implements CertificatePrincipalExtractorSelector
/*     */ {
/*  42 */   private static final Log LOGGER = LogFactory.getLog(PropertiesCertificateParserSelector.class);
/*     */ 
/*  45 */   private final IssuerDNCertificatePrincipalExtractorSelector _selector = new IssuerDNCertificatePrincipalExtractorSelector();
/*     */ 
/*     */   public PropertiesCertificateParserSelector(String paramString)
/*     */   {
/*  49 */     AccessController.doPrivileged(new PrivilegedAction(paramString)
/*     */     {
/*     */       public InputStream run()
/*     */       {
/*     */         InputStream localInputStream;
/*  54 */         if ((
/*  54 */           localInputStream = PropertiesCertificateParserSelector.class.getResourceAsStream(this.val$pathXml)) == null)
/*     */         {
/*     */           try
/*     */           {
/*  56 */             localInputStream = new URL(this.val$pathXml).openStream();
/*     */           } catch (MalformedURLException localMalformedURLException) {
/*  58 */             PropertiesCertificateParserSelector.LOGGER.debug(localMalformedURLException.getMessage());
/*     */           } catch (IOException localIOException) {
/*  60 */             PropertiesCertificateParserSelector.LOGGER.debug(localIOException.getMessage());
/*     */           }
/*     */         }
/*  63 */         PropertiesCertificateParserSelector.this.initProperties(localInputStream);
/*  64 */         return localInputStream;
/*     */       }
/*     */     });
/*     */   }
/*     */ 
/*     */   public PropertiesCertificateParserSelector(InputStream xmlIs) {
/*  71 */     initProperties(xmlIs);
/*     */   }
/*     */ 
/*     */   private void initProperties(InputStream paramInputStream) {
/*  75 */     Object localObject = new Properties();
/*  76 */     HashMap localHashMap = new HashMap();
/*     */     try
/*     */     {
/*  79 */       ((Properties)localObject).loadFromXML(paramInputStream);
/*  80 */       for (localObject = ((Properties)localObject).entrySet().iterator(); ((Iterator)localObject).hasNext(); ) { Map.Entry localEntry = (Map.Entry)((Iterator)localObject).next();
/*     */ 
/*  82 */         if ("default".equals(localEntry.getKey())) {
/*  83 */           this._selector.setDefaultCertificatePrincipalExtractor(buildInstance((String)localEntry.getValue())); continue;
/*     */         }
/*     */ 
/*  87 */         localHashMap.put(new X500Principal((String)localEntry.getKey()), buildInstance((String)localEntry.getValue())); }
/*     */ 
/*  92 */       this._selector.setCertificatePrincipalExtractors(localHashMap);
/*     */       return;
/*     */     } catch (InvalidPropertiesFormatException localInvalidPropertiesFormatException) {
/*  94 */       throw new RuntimeException("The xml properties format is incorrect.", localInvalidPropertiesFormatException);
/*     */     }
/*     */     catch (IOException localIOException) {
/*  97 */       throw new RuntimeException("Error accessing to the properties stream.", localIOException);
/*     */     }
/*     */     finally {
/* 100 */       IOUtils.closeQuietly(paramInputStream); } throw this;
/*     */   }
/*     */ 
/*     */   private static CertificatePrincipalExtractor buildInstance(String className)
/*     */   {
/*     */     try
/*     */     {
/* 107 */       return (CertificatePrincipalExtractor)Class.forName(className).newInstance();
/*     */     } catch (Exception e) {
/*     */     }
/* 110 */     throw new RuntimeException("Could not instantiate class of type :: " + className, e);
/*     */   }
/*     */ 
/*     */   public CertificatePrincipalExtractor searchPrincipalExtractor(Certificate certificate)
/*     */   {
/* 120 */     return this._selector.searchPrincipalExtractor(certificate);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.cert.impl.PropertiesCertificateParserSelector
 * JD-Core Version:    0.6.0
 */