package com.scytl.pnyx.client.communication.application;

import com.scytl.common.domain.MessageType;
import com.scytl.common.domain.election.ElectoralScope;
import com.scytl.common.domain.election.ballot.Ballot;
import com.scytl.pnyx.client.VoteReceipt;
import com.scytl.pnyx.client.communication.connector.ClientData;
import com.scytl.pnyx.client.state.LoginData;
import com.scytl.pnyx.protocol.PnyxProtocolException;
import java.security.PublicKey;
import java.security.cert.CertStore;
import org.picocontainer.ComponentMonitor;

public abstract interface ApplicationProtocol
{
  public abstract KeystoreAndToken doAuthenticate(LoginData paramLoginData, ElectoralScope paramElectoralScope)
    throws ApplicationProtocolException, PnyxProtocolException;

  public abstract CertStore doGetCertificates$1c0cd8ed(ComponentMonitor paramComponentMonitor)
    throws ApplicationProtocolException, PnyxProtocolException;

  public abstract ComponentMonitor doGetToken$3b16f5d5(LoginData paramLoginData, ElectoralScope paramElectoralScope)
    throws ApplicationProtocolException, PnyxProtocolException;

  public abstract Ballot doGetBallot$1abffdf5(ComponentMonitor paramComponentMonitor, PublicKey paramPublicKey, MessageType paramMessageType)
    throws ApplicationProtocolException, PnyxProtocolException;

  public abstract VoteReceipt doCastVote(ClientData paramClientData)
    throws ApplicationProtocolException, PnyxProtocolException;
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.ApplicationProtocol
 * JD-Core Version:    0.6.0
 */