/*    */ package com.scytl.pnyx.client.communication.application.message;
/*    */ 
/*    */ import com.scytl.common.domain.election.ElectoralScope;
/*    */ import com.scytl.common.domain.token.TokenParser;
/*    */ import com.scytl.common.messages.MessageConstants;
/*    */ import com.scytl.pnyx.client.SecurityException;
/*    */ import com.scytl.pnyx.client.communication.application.KeystoreAndToken;
/*    */ import com.scytl.pnyx.client.communication.application.message.helper.ServerErrorInterpreter;
/*    */ import com.scytl.pnyx.client.state.LoginData;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import java.io.IOException;
/*    */ import java.security.GeneralSecurityException;
/*    */ import java.security.KeyStore;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ 
/*    */ public abstract class AbstractAuthenticationMessage<T extends LoginData>
/*    */ {
/*    */   public Map<String, String> createMessage(T paramT, ElectoralScope paramElectoralScope)
/*    */     throws PnyxProtocolException
/*    */   {
/* 38 */     (
/* 39 */       this = new HashMap())
/* 39 */       .put("username", paramT.getUsername());
/* 40 */     put("password", new String(paramT.getPassword()));
/*    */ 
/* 43 */     if (paramElectoralScope.knowsTheElection()) {
/* 44 */       put("electionId", paramElectoralScope.getElectionId());
/*    */     }
/*    */ 
/* 47 */     if (paramElectoralScope.knowsTheElectionEvent()) {
/* 48 */       put("electionEventId", paramElectoralScope.getElectionEventId());
/*    */     }
/*    */ 
/* 51 */     if (paramElectoralScope.knowsTheInstitution()) {
/* 52 */       put("institutionId", paramElectoralScope.getInstitutionId());
/*    */     }
/*    */ 
/* 56 */     put("loginType", MessageConstants.fromLoginType(paramT.getLoginType()));
/*    */ 
/* 58 */     put("canDecrypt", paramT.canDecrypt() ? "1" : "0");
/*    */ 
/* 60 */     return this;
/*    */   }
/*    */ 
/*    */   public KeystoreAndToken parseResponse(Map<String, String> paramMap, T paramT)
/*    */     throws PnyxProtocolException
/*    */   {
/* 70 */     Map<String, String> localMap;
/* 70 */     if ((localMap = paramMap).keySet().contains("error")) { paramMap = ServerErrorInterpreter.serverErrorMessageToMessageKey$12e2b5b2(this = ((String)localMap.get("error")).trim()); throw new PnyxMessagesException(paramMap, this); }
/*    */     try {
/* 72 */       return new KeystoreAndToken(getKeyStore(paramMap, paramT), TokenParser.parseToken$efc91de((String)(localMap = paramMap).get("token")));
/*    */     }
/*    */     catch (GeneralSecurityException this) {
/* 75 */       throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_PARSING_FAILED, this);
/*    */     }
/*    */     catch (IOException localIOException) {
/* 78 */       if (((
/* 78 */         this = localIOException)
/* 78 */         .getCause() != null) && 
/* 79 */         ((getCause() instanceof GeneralSecurityException))) {
/* 80 */         throw new SecurityException(PnyxMessagesException.Key.SERVER_ERROR_UNKNOWN_USER_PASSWORD, this);
/*    */       }
/*    */ 
/*    */     }
/*    */ 
/* 85 */     throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_PARSING_FAILED, this);
/*    */   }
/*    */ 
/*    */   protected abstract KeyStore getKeyStore(Map<String, String> paramMap, T paramT)
/*    */     throws GeneralSecurityException, IOException;
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.AbstractAuthenticationMessage
 * JD-Core Version:    0.6.0
 */