/*    */ package com.scytl.pnyx.client.communication.application.message;
/*    */ 
/*    */ import com.scytl.common.domain.LoginType;
/*    */ import com.scytl.common.domain.election.ElectoralScope;
/*    */ import com.scytl.crypto.CryptographicAlgorithms;
/*    */ import com.scytl.crypto.CryptographicFormats;
/*    */ import com.scytl.pnyx.client.communication.application.KeystoreAndToken;
/*    */ import com.scytl.pnyx.client.state.LoginData;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import java.io.IOException;
/*    */ import java.security.GeneralSecurityException;
/*    */ import java.security.KeyStore;
/*    */ import java.util.Map;
/*    */ 
/*    */ public class AuthenticationMessageDelegator<T extends LoginData> extends AbstractAuthenticationMessage<T>
/*    */ {
/*    */   private final CryptographicAlgorithms _cryptographicAlgorithms;
/*    */   private final CryptographicFormats _cryptographicFormats;
/*    */ 
/*    */   public AuthenticationMessageDelegator(CryptographicAlgorithms ca, CryptographicFormats cf)
/*    */   {
/* 38 */     this._cryptographicAlgorithms = ca;
/* 39 */     this._cryptographicFormats = cf;
/*    */   }
/*    */ 
/*    */   public Map<String, String> createMessage(T loginData, ElectoralScope scope)
/*    */     throws PnyxProtocolException
/*    */   {
/* 45 */     return resolveInstance(loginData.getLoginType()).createMessage(loginData, scope);
/*    */   }
/*    */ 
/*    */   private AbstractAuthenticationMessage<T> resolveInstance(LoginType loginType)
/*    */   {
/* 55 */     switch (1.$SwitchMap$com$scytl$common$domain$LoginType[loginType.ordinal()]) {
/*    */     case 1:
/* 57 */       return new AdvancedAuthenticationMessage(this._cryptographicFormats);
/*    */     case 2:
/* 60 */       return new RecognizedAuthenticationMessage(this._cryptographicAlgorithms, this._cryptographicFormats);
/*    */     }
/*    */ 
/* 63 */     throw new IllegalArgumentException("Unknown type of LoginType :: " + loginType);
/*    */   }
/*    */ 
/*    */   public KeystoreAndToken parseResponse(Map<String, String> response, T loginData)
/*    */     throws PnyxProtocolException
/*    */   {
/* 72 */     return resolveInstance(loginData.getLoginType()).parseResponse(response, loginData);
/*    */   }
/*    */ 
/*    */   protected final KeyStore getKeyStore(Map<String, String> response, T loginData)
/*    */     throws GeneralSecurityException, IOException
/*    */   {
/* 84 */     return resolveInstance(loginData.getLoginType()).getKeyStore(response, loginData);
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.AuthenticationMessageDelegator
 * JD-Core Version:    0.6.0
 */