/*    */ package com.scytl.pnyx.client.communication.application.message;
/*    */ 
/*    */ import com.scytl.common.domain.MessageType;
/*    */ import com.scytl.common.domain.election.ballot.Ballot;
/*    */ import com.scytl.common.utils.EncodingHelper;
/*    */ import com.scytl.crypto.signature.XmlSignature;
/*    */ import com.scytl.crypto.signature.XmlSignatureException;
/*    */ import com.scytl.pnyx.client.SecurityException.Key;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import com.scytl.xml.marshalling.eml.model.BallotsStructure;
/*    */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*    */ import com.scytl.xml.marshalling.stax.eml.StaxItEmlBallotsDeserializer;
/*    */ import java.io.ByteArrayInputStream;
/*    */ import java.security.PublicKey;
/*    */ import java.util.Collection;
/*    */ import java.util.HashMap;
/*    */ import java.util.Iterator;
/*    */ import java.util.Map;
/*    */ import org.picocontainer.ComponentMonitor;
/*    */ 
/*    */ public class BallotMessage
/*    */ {
/*    */   public Map<String, String> createMessage$53a27e3a(ComponentMonitor paramComponentMonitor, MessageType paramMessageType)
/*    */     throws PnyxProtocolException
/*    */   {
/* 41 */     (
/* 42 */       this = new HashMap())
/* 42 */       .put("electionId", paramComponentMonitor.getElectionId());
/* 43 */     put("token", paramComponentMonitor.serializeAsURLParameter());
/*    */ 
/* 45 */     put("messageType", paramMessageType.name());
/* 46 */     return this;
/*    */   }
/*    */ 
/*    */   public Ballot parseResponse(String paramString, PublicKey paramPublicKey)
/*    */     throws PnyxProtocolException
/*    */   {
/* 59 */     this = new BallotsStructure();
/*    */     try { ByteArrayInputStream localByteArrayInputStream = new ByteArrayInputStream(EncodingHelper.getBytes(paramString));
/*    */       XmlSignature localXmlSignature;
/* 67 */       if (!(
/* 67 */         localXmlSignature = new XmlSignature())
/* 67 */         .verify(paramPublicKey, localByteArrayInputStream, "Seal")) {
/* 68 */         throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_INVALID_SIGNATURE);
/*    */       }
/*    */ 
/* 73 */       localByteArrayInputStream = new ByteArrayInputStream(EncodingHelper.getBytes(paramString));
/*    */ 
/* 75 */       new StaxItEmlBallotsDeserializer().deserializeToModel(localByteArrayInputStream, this);
/*    */     }
/*    */     catch (XmlSignatureException localXmlSignatureException)
/*    */     {
/* 79 */       throw new PnyxMessagesException(SecurityException.Key.XML_SIGNATURE_ERROR, localXmlSignatureException);
/*    */     }
/*    */     catch (DeserializationException localDeserializationException) {
/* 82 */       throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_PARSING_FAILED, localDeserializationException);
/*    */     }
/*    */ 
/* 86 */     return (Ballot)getBallots().iterator().next();
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.BallotMessage
 * JD-Core Version:    0.6.0
 */