/*    */ package com.scytl.pnyx.client.communication.application.message;
/*    */ 
/*    */ import com.scytl.common.domain.election.ElectoralScope;
/*    */ import com.scytl.crypto.CryptographicAlgorithms;
/*    */ import com.scytl.crypto.CryptographicFormats;
/*    */ import com.scytl.pnyx.client.SecurityException.Key;
/*    */ import com.scytl.pnyx.client.state.RecognizedLoginData;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import java.security.GeneralSecurityException;
/*    */ import java.security.PrivateKey;
/*    */ import java.security.cert.CertificateEncodingException;
/*    */ import java.util.Map;
/*    */ import java.util.Map<Ljava.lang.String;Ljava.lang.String;>;
/*    */ import org.apache.commons.codec.binary.Base64;
/*    */ 
/*    */ public class RecognizedAuthenticationMessage extends AbstractAuthenticationMessage<RecognizedLoginData>
/*    */ {
/*    */   private final CryptographicAlgorithms _cryptoAlgorithms;
/*    */   private final CryptographicFormats _cryptoFormats;
/*    */ 
/*    */   public RecognizedAuthenticationMessage(CryptographicAlgorithms ca, CryptographicFormats cf)
/*    */   {
/* 42 */     this._cryptoAlgorithms = ca;
/* 43 */     this._cryptoFormats = cf;
/*    */   }
/*    */ 
/*    */   public Map<String, String> createMessage(RecognizedLoginData paramRecognizedLoginData, ElectoralScope paramElectoralScope)
/*    */     throws PnyxProtocolException
/*    */   {
/* 50 */     paramElectoralScope = super.createMessage(paramRecognizedLoginData, paramElectoralScope);
/*    */     try
/*    */     {
/* 58 */       Object localObject = CryptographicFormats.getUserPrivateKey(paramRecognizedLoginData.getKeyStore(), paramRecognizedLoginData.getAlias(), paramRecognizedLoginData.getKeyStorePassword());
/*    */ 
/* 62 */       localObject = CryptographicAlgorithms.sign((paramRecognizedLoginData.getUsername() + new String(paramRecognizedLoginData.getPassword())).getBytes(), (PrivateKey)localObject);
/*    */ 
/* 67 */       paramRecognizedLoginData = this._cryptoFormats.getUserCertificateChain(paramRecognizedLoginData.getKeyStore(), paramRecognizedLoginData.getAlias());
/*    */     }
/*    */     catch (GeneralSecurityException localGeneralSecurityException)
/*    */     {
/* 72 */       throw new PnyxMessagesException(SecurityException.Key.XML_SIGNATURE_ERROR, localGeneralSecurityException);
/*    */     }
/*    */ 
/* 75 */     paramElectoralScope.put("usernameAndPasswordSignature", new String(Base64.encodeBase64(localGeneralSecurityException)));
/*    */     try
/*    */     {
/* 80 */       paramElectoralScope.put("recognizedCertificateChain", this._cryptoFormats.certificatesPEM(paramRecognizedLoginData));
/*    */     }
/*    */     catch (CertificateEncodingException localCertificateEncodingException) {
/* 83 */       throw new PnyxMessagesException(SecurityException.Key.XML_SIGNATURE_ERROR, localCertificateEncodingException);
/*    */     }
/*    */ 
/* 87 */     return (Map<String, String>)paramElectoralScope;
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.RecognizedAuthenticationMessage
 * JD-Core Version:    0.6.0
 */