/*     */ package com.scytl.pnyx.client.communication.application.message;
/*     */ 
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ballot.PnyxProtocolBallotSerializer;
/*     */ import com.scytl.common.domain.token.TokenMultiElection;
/*     */ import com.scytl.common.domain.token.TokenMultiElectionSerializer;
/*     */ import com.scytl.common.utils.EncodingHelper;
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.pnyx.client.SecurityException;
/*     */ import com.scytl.pnyx.client.communication.application.ClientDataManager;
/*     */ import com.scytl.pnyx.client.communication.application.message.helper.ElementOnlyFilter;
/*     */ import com.scytl.pnyx.client.communication.connector.ClientData;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.StringReader;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.PrivateKey;
/*     */ import java.security.PublicKey;
/*     */ import java.security.cert.X509Certificate;
/*     */ import java.util.Arrays;
/*     */ import java.util.List;
/*     */ import javax.crypto.SecretKey;
/*     */ import javax.xml.stream.XMLEventFactory;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLEventWriter;
/*     */ import javax.xml.stream.XMLInputFactory;
/*     */ import javax.xml.stream.XMLOutputFactory;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public final class SecureMessageHelper
/*     */ {
/*     */   public static final int BALLOT_IDENTIFIER_RANDOM_BYTES = 24;
/*  56 */   private static CryptographicAlgorithms _cryptoAlgorithms = null;
/*     */ 
/*  58 */   private static XMLOutputFactory _xOut = XMLOutputFactory.newInstance();
/*     */ 
/*  60 */   private static XMLInputFactory _xIn = XMLInputFactory.newInstance();
/*     */ 
/*  62 */   private static XMLEventFactory _xEventFactory = XMLEventFactory.newInstance();
/*     */ 
/*     */   public static String createVote(ClientDataManager paramClientDataManager, CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XMLStreamException, GeneralSecurityException, IOException, SecurityException
/*     */   {
/*  71 */     _cryptoAlgorithms = paramCryptographicAlgorithms;
/*     */ 
/*  73 */     paramCryptographicAlgorithms = new ByteArrayOutputStream();
/*     */     XMLEventWriter localXMLEventWriter;
/*  74 */     (
/*  77 */       localXMLEventWriter = _xOut.createXMLEventWriter(paramCryptographicAlgorithms, EncodingHelper.defaultEncoding()))
/*  77 */       .add(_xEventFactory.createStartDocument(EncodingHelper.defaultEncoding(), "1.0"));
/*     */ 
/*  79 */     localXMLEventWriter.add(_xEventFactory.createStartElement("", "", "message"));
/*     */ 
/*  82 */     Object localObject1 = paramClientDataManager; (paramClientDataManager = localXMLEventWriter).add(_xEventFactory.createStartElement("", "", "body")); Object localObject2 = localObject1; ClientDataManager localClientDataManager = paramClientDataManager; paramClientDataManager.add(_xEventFactory.createStartElement("", "", "envelope")); Object localObject3 = _cryptoAlgorithms.generateSymmetricKey(); localObject2.setSecureMessageSecretKey((SecretKey)localObject3); localClientDataManager.add(_xEventFactory.createStartElement("", "", "enc_key")); Object localObject5 = localObject2.getElectoralBoardPublicKey(); Object localObject4 = localObject2; Object localObject6 = _cryptoAlgorithms.asymmetricEncrypt(localObject4.getSecureMessageSecretKey().getEncoded(), (PublicKey)localObject5); localObject3 = localObject6 = new String(Base64.encodeBase64(localObject6)); localObject2.setElectoralBoardEncriptedSecretKey((String)localObject3); localClientDataManager.add(_xEventFactory.createCharacters((String)localObject3)); localClientDataManager.add(_xEventFactory.createEndElement("", "", "enc_key")); localClientDataManager.add(_xEventFactory.createStartElement("", "", "enc_data")); (localObject6 = localObject4 = localObject2).setBallotId(new String(Base64.encodeBase64(_cryptoAlgorithms.generateRandom(24)))); Object localObject7 = ((ClientDataManager)localObject6).getClientData().getToken$49262418(); Object localObject8 = new PnyxProtocolBallotSerializer().serialize$2df03795(((ClientDataManager)localObject6).getClientData().getTrustedBallot(), (ComponentMonitor)localObject7); localObject5 = (localObject7 = "<ballot_contents><ballot_id>" + ((ClientDataManager)localObject6).getBallotId() + "</ballot_id><vote><election_id>" + ((ComponentMonitor)localObject7).getElectionId() + "</election_id>" + "<vote_type>VOTE</vote_type>" + "<options>" + (String)localObject8 + "</options></vote><padding></padding>" + "</ballot_contents>").getBytes(); localObject3 = localObject6 = _cryptoAlgorithms.symmetricEncrypt(localObject5, localObject4.getSecureMessageSecretKey()); localObject2.setEncryptedBallotContent(new String(Base64.encodeBase64(localObject3))); localClientDataManager.add(_xEventFactory.createCharacters(localObject2.getEncryptedBallotContent())); localClientDataManager.add(_xEventFactory.createEndElement("", "", "enc_data")); localClientDataManager.add(_xEventFactory.createEndElement("", "", "envelope")); localObject2 = localObject1; localClientDataManager = paramClientDataManager; localObject3 = new Attribute[] { _xEventFactory.createAttribute("item", "VRR"), _xEventFactory.createAttribute("by", localObject2.getClientData().getLoginData().getUsername()) }; localClientDataManager.add(_xEventFactory.createStartElement("", "", "signed", Arrays.asList(localObject3).iterator(), null)); localObject4 = localObject2; localObject3 = localClientDataManager; localObject5 = createVRR(localObject4); localObject6 = localObject4.getUserPrivateKey(); localObject8 = localObject4; (localObject7 = new StringBuffer()).append(((ClientDataManager)localObject8).getClientData().getLoginData().getUsername()).append(";"); ((StringBuffer)localObject7).append(new String(Base64.encodeBase64(((ClientDataManager)localObject8).getUserCertificate().getEncoded()))).append(";"); ((StringBuffer)localObject7).append(getEnvId((ClientDataManager)localObject8)).append(";"); ((StringBuffer)localObject7).append(Long.toString(((ClientDataManager)localObject8).getTimestamp())).append(";"); ((StringBuffer)localObject7).append(getHashedBallotId((ClientDataManager)localObject8)).append(";"); ((StringBuffer)localObject7).append((localObject1 = localObject8).getMessageType().name()).append(";"); ((StringBuffer)localObject7).append(new TokenMultiElectionSerializer((TokenMultiElection)((ClientDataManager)localObject8).getClientData().getToken$49262418()).getSignedInfo()); localObject6 = CryptographicAlgorithms.sign(EncodingHelper.getBytes(((StringBuffer)localObject7).toString()), (PrivateKey)localObject6); ((XMLEventWriter)localObject3).add(_xEventFactory.createStartElement("", "", "signature")); localObject7 = new String(Base64.encodeBase64(localObject6)); localObject4.setSecureMessageSignature((String)localObject7); ((XMLEventWriter)localObject3).add(_xEventFactory.createCharacters((String)localObject7)); ((XMLEventWriter)localObject3).add(_xEventFactory.createEndElement("", "", "signature")); localObject3 = localObject5; localObject4 = localObject3; (localObject3 = localClientDataManager).add(_xEventFactory.createStartElement("", "", "data")); localObject5 = _xIn.createXMLEventReader(new StringReader(localObject4)); localObject6 = _xIn.createFilteredReader((XMLEventReader)localObject5, new ElementOnlyFilter()); ((XMLEventWriter)localObject3).add((XMLEventReader)localObject6); ((XMLEventWriter)localObject3).add(_xEventFactory.createEndElement("", "", "data")); localClientDataManager.add(_xEventFactory.createStartElement("", "", "x509_certificate")); localClientDataManager.add(_xEventFactory.createCharacters(new String(Base64.encodeBase64(localObject2.getUserCertificate().getEncoded())))); localClientDataManager.add(_xEventFactory.createEndElement("", "", "x509_certificate")); localClientDataManager.add(_xEventFactory.createEndElement("", "", "signed")); paramClientDataManager.add(_xEventFactory.createEndElement("", "", "body"));
/*  83 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "message"));
/*     */ 
/*  85 */     localXMLEventWriter.add(_xEventFactory.createEndDocument());
/*  86 */     localXMLEventWriter.flush();
/*  87 */     localXMLEventWriter.close();
/*  88 */     paramCryptographicAlgorithms.flush();
/*  89 */     paramCryptographicAlgorithms.close();
/*     */ 
/*  91 */     return (String)(String)(String)(String)(String)(String)new String(paramCryptographicAlgorithms.toByteArray());
/*     */   }
/*     */ 
/*     */   private static String createVRR(ClientDataManager paramClientDataManager)
/*     */     throws XMLStreamException, GeneralSecurityException, IOException
/*     */   {
/* 308 */     ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
/*     */     XMLEventWriter localXMLEventWriter;
/* 309 */     (
/* 312 */       localXMLEventWriter = _xOut.createXMLEventWriter(localByteArrayOutputStream, EncodingHelper.defaultEncoding()))
/* 312 */       .add(_xEventFactory.createStartElement("", "", "vrr"));
/*     */ 
/* 315 */     Object localObject1 = getEnvId(paramClientDataManager);
/*     */ 
/* 317 */     localXMLEventWriter.add(_xEventFactory.createStartElement("", "", "env_id"));
/*     */ 
/* 319 */     localXMLEventWriter.add(_xEventFactory.createCharacters((String)localObject1));
/* 320 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "env_id"));
/*     */ 
/* 322 */     localXMLEventWriter.add(_xEventFactory.createStartElement("", "", "timestamp"));
/*     */ 
/* 324 */     localXMLEventWriter.add(_xEventFactory.createCharacters(Long.toString(paramClientDataManager.getTimestamp())));
/*     */ 
/* 326 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "timestamp"));
/*     */ 
/* 329 */     localObject1 = getHashedBallotId(paramClientDataManager);
/* 330 */     localXMLEventWriter.add(_xEventFactory.createStartElement("", "", "hashed_ballot_id"));
/*     */ 
/* 332 */     localXMLEventWriter.add(_xEventFactory.createCharacters((String)localObject1));
/* 333 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "hashed_ballot_id"));
/*     */ 
/* 335 */     localXMLEventWriter.add(_xEventFactory.createStartElement("", "", "public_data"));
/*     */ 
/* 337 */     localObject1 = paramClientDataManager; localXMLEventWriter.add(_xEventFactory.createCharacters(paramClientDataManager.getMessageType().name()));
/*     */ 
/* 339 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "public_data"));
/*     */ 
/* 342 */     localObject1 = paramClientDataManager; paramClientDataManager = localXMLEventWriter; Object localObject2 = { _xEventFactory.createAttribute("item", "AUTH_TOKEN"), _xEventFactory.createAttribute("by", "AS") }; paramClientDataManager.add(_xEventFactory.createStartElement("", "", "signed", Arrays.asList(localObject2).iterator(), null)); paramClientDataManager.add(_xEventFactory.createStartElement("", "", "signature")); paramClientDataManager.add(_xEventFactory.createCharacters(new String(Base64.encodeBase64(((ClientDataManager)localObject1).getTokenData$49262418().getAuthTokenSignature())))); paramClientDataManager.add(_xEventFactory.createEndElement("", "", "signature")); paramClientDataManager.add(_xEventFactory.createStartElement("", "", "data")); localObject2 = (TokenMultiElection)((ClientDataManager)localObject1).getTokenData$49262418(); localObject1 = paramClientDataManager; paramClientDataManager.add(_xEventFactory.createStartElement("", "", "auth_token")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "login")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getUsername())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "login")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "timestamp")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getCreationDateTime())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "timestamp")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "timeout")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getTimeout() + "")); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "timeout")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "token_id")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getId())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "token_id")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "election_id")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getElectionId())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "election_id")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "x509_fingerprint")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getX509Fingerprint())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "x509_fingerprint")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "context")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "role")); ((XMLEventWriter)localObject1).add(_xEventFactory.createCharacters(((TokenMultiElection)localObject2).getUserRole())); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "role")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "canDecrypt", Arrays.asList(new Attribute[] { _xEventFactory.createAttribute("value", ((TokenMultiElection)localObject2).canDecrypt() ? "1" : "0") }).iterator(), null)); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "canDecrypt")); ((XMLEventWriter)localObject1).add(_xEventFactory.createStartElement("", "", "area", Arrays.asList(new Attribute[] { _xEventFactory.createAttribute("id", ((TokenMultiElection)localObject2).getAreaId()) }).iterator(), null)); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "area")); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "context")); ((XMLEventWriter)localObject1).add(_xEventFactory.createEndElement("", "", "auth_token")); paramClientDataManager.add(_xEventFactory.createEndElement("", "", "data")); paramClientDataManager.add(_xEventFactory.createEndElement("", "", "signed"));
/*     */ 
/* 344 */     localXMLEventWriter.add(_xEventFactory.createEndElement("", "", "vrr"));
/*     */ 
/* 347 */     localXMLEventWriter.flush();
/*     */     try {
/* 349 */       localByteArrayOutputStream.flush();
/*     */ 
/* 351 */       localByteArrayOutputStream.close(); } finally { localByteArrayOutputStream.close();
/*     */     }
/* 353 */     return (String)(String)new String(localByteArrayOutputStream.toByteArray());
/*     */   }
/*     */ 
/*     */   private static String getEnvId(ClientDataManager paramClientDataManager)
/*     */     throws GeneralSecurityException
/*     */   {
/* 365 */     String str1 = paramClientDataManager.getElectoralBoardEncriptedSecretKey();
/*     */ 
/* 368 */     String str2 = paramClientDataManager.getEncryptedBallotContent();
/* 369 */     paramClientDataManager = paramClientDataManager.getClientData().getToken$49262418().getElectionId();
/*     */ 
/* 373 */     paramClientDataManager = Base64.encodeBase64(CryptographicAlgorithms.hash(paramClientDataManager = (str1 + str2 + paramClientDataManager).getBytes()));
/*     */ 
/* 375 */     return paramClientDataManager = new String(paramClientDataManager);
/*     */   }
/*     */ 
/*     */   private static String getHashedBallotId(ClientDataManager paramClientDataManager)
/*     */   {
/* 389 */     return paramClientDataManager = new String(Base64.encodeBase64(CryptographicAlgorithms.hash(paramClientDataManager.getBallotId().getBytes())));
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.SecureMessageHelper
 * JD-Core Version:    0.6.0
 */