/*    */ package com.scytl.pnyx.client.communication.application.message;
/*    */ 
/*    */ import com.scytl.crypto.CryptographicAlgorithms;
/*    */ import com.scytl.pnyx.client.SecurityException;
/*    */ import com.scytl.pnyx.client.SecurityException.Key;
/*    */ import com.scytl.pnyx.client.VoteReceipt;
/*    */ import com.scytl.pnyx.client.communication.application.ClientDataManager;
/*    */ import com.scytl.pnyx.client.communication.application.message.helper.ReceiptReader;
/*    */ import com.scytl.pnyx.client.communication.connector.ClientData;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import javax.xml.stream.FactoryConfigurationError;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.picocontainer.ComponentMonitor;
/*    */ 
/*    */ public class SecureMessageMessage
/*    */ {
/*    */   private final CryptographicAlgorithms _cryptoAlgorithms;
/*    */ 
/*    */   public SecureMessageMessage(CryptographicAlgorithms cryptoAlgorithms)
/*    */   {
/* 38 */     this._cryptoAlgorithms = cryptoAlgorithms;
/*    */   }
/*    */ 
/*    */   public Map<String, String> createMessage(ClientDataManager paramClientDataManager)
/*    */     throws PnyxProtocolException
/*    */   {
/* 45 */     HashMap localHashMap = new HashMap();
/*    */     try {
/* 47 */       localHashMap.put("message", SecureMessageHelper.createVote(paramClientDataManager, this._cryptoAlgorithms));
/*    */ 
/* 49 */       localHashMap.put("token", paramClientDataManager.getClientData().getToken$49262418().serializeAsURLParameter());
/*    */     }
/*    */     catch (XMLStreamException this) {
/* 52 */       throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_GENERATION_FAILED, this);
/*    */     }
/*    */     catch (java.security.GeneralSecurityException this) {
/* 55 */       throw new SecurityException(SecurityException.Key.SECURE_MESSAGE_GENERATION, this);
/*    */     }
/*    */     catch (java.io.IOException this) {
/* 58 */       throw new SecurityException(PnyxMessagesException.Key.MESSAGE_GENERATION_FAILED, this);
/*    */     }
/*    */ 
/* 61 */     return localHashMap;
/*    */   }
/*    */ 
/*    */   public VoteReceipt parseResponse(String response, ClientDataManager clientDataMgr)
/*    */     throws PnyxProtocolException
/*    */   {
/*    */     try
/*    */     {
/*    */       ClientDataManager clientDataMgr;
/*    */       String response;
/* 72 */       return new ReceiptReader(response, clientDataMgr, this._cryptoAlgorithms).read();
/*    */     }
/*    */     catch (XMLStreamException e) {
/* 75 */       throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_PARSING_FAILED, e);
/*    */     } catch (FactoryConfigurationError e) {
/*    */     }
/* 78 */     throw new PnyxMessagesException(PnyxMessagesException.Key.MESSAGE_PARSING_FAILED, e);
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.SecureMessageMessage
 * JD-Core Version:    0.6.0
 */