/*     */ package com.scytl.pnyx.client.communication.application.message.helper;
/*     */ 
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.pnyx.client.ReceiptType;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.ClientDataManager;
/*     */ import com.scytl.pnyx.client.communication.application.message.PnyxMessagesException;
/*     */ import com.scytl.pnyx.client.communication.application.message.PnyxMessagesException.Key;
/*     */ import com.scytl.pnyx.client.communication.connector.ClientData;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.security.PublicKey;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.FactoryConfigurationError;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLInputFactory;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import javax.xml.stream.events.Characters;
/*     */ import javax.xml.stream.events.StartElement;
/*     */ import javax.xml.stream.events.XMLEvent;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class ReceiptReader
/*     */ {
/*     */   private final String _ballotIdentifier;
/*     */   private final String _electionIdentifier;
/*     */   private final String _username;
/*     */   private final String _secureMessageSignature;
/*     */   private final PublicKey _messageServerPublicKey;
/*     */   private final XMLEventReader _reader;
/*     */   private final String _timestamp;
/*  61 */   private CryptographicAlgorithms _cryptoAlgorithms = null;
/*     */ 
/*     */   public ReceiptReader(String paramString, ClientDataManager paramClientDataManager, CryptographicAlgorithms paramCryptographicAlgorithms)
/*     */     throws XMLStreamException, FactoryConfigurationError
/*     */   {
/*  67 */     this._ballotIdentifier = paramClientDataManager.getBallotId();
/*  68 */     this._electionIdentifier = paramClientDataManager.getClientData().getToken$49262418().getElectionId();
/*     */ 
/*  70 */     this._username = paramClientDataManager.getClientData().getLoginData().getUsername();
/*     */ 
/*  73 */     this._secureMessageSignature = paramClientDataManager.getSecureMessageSignature();
/*     */ 
/*  75 */     this._messageServerPublicKey = paramClientDataManager.getMessageServerPublicKey();
/*     */ 
/*  77 */     this._cryptoAlgorithms = paramCryptographicAlgorithms;
/*     */ 
/*  82 */     paramClientDataManager = paramString.indexOf("<timestamp>") + "<timestamp>".length();
/*     */ 
/*  84 */     paramCryptographicAlgorithms = paramString.indexOf("</timestamp>");
/*  85 */     this._timestamp = paramString.substring(paramClientDataManager, paramCryptographicAlgorithms);
/*     */ 
/*  87 */     paramString = new ByteArrayInputStream(paramString.getBytes());
/*     */ 
/*  89 */     this._reader = XMLInputFactory.newInstance().createXMLEventReader(paramString);
/*     */   }
/*     */ 
/*     */   public VoteReceipt read()
/*     */     throws XMLStreamException, PnyxMessagesException
/*     */   {
/* 103 */     Object localObject1 = this; locateStartElement("id"); localObject1 = ReceiptType.valueOf(localObject2 = ((ReceiptReader)localObject1).readAttrib("type"));
/* 104 */     Object localObject2 = localObject1; localObject1 = this; this = null; switch (1.$SwitchMap$com$scytl$pnyx$client$ReceiptType[localObject2.ordinal()]) { case 1:
/* 104 */       ((ReceiptReader)localObject1).locateStartElement("error"); this = ((ReceiptReader)localObject1).readAttrib("code"); localObject1 = ((ReceiptReader)localObject1).readTagCharacters("message"); if ("6070".equals(this)) throw new PnyxMessagesException(PnyxMessagesException.Key.INVALID_TOKEN, this + ": " + (String)localObject1); if ("7010".equals(this)) throw new PnyxMessagesException(PnyxMessagesException.Key.SERVER_ERROR_ELECTION_NOT_OPEN, this + ": " + (String)localObject1); throw new PnyxMessagesException(PnyxMessagesException.Key.SERVER_REPORTED_ERROR, this + ": " + (String)localObject1);
/*     */     case 2:
/* 104 */       this = "signature"; localObject2 = ((ReceiptReader)localObject1).readTagCharacters(this); String str = ((ReceiptReader)localObject1)._ballotIdentifier; this = (ReceiptReader)localObject1; this = this = new String(Base64.encodeBase64(CryptographicAlgorithms.hash(str.getBytes()))); if (!(this = CryptographicAlgorithms.verify((this = this + ";" + ((ReceiptReader)localObject1)._electionIdentifier + ";" + ((ReceiptReader)localObject1)._username + ";" + ((ReceiptReader)localObject1)._timestamp + ";" + ((ReceiptReader)localObject1)._secureMessageSignature).getBytes(), Base64.decodeBase64(((String)localObject2).getBytes()), ((ReceiptReader)localObject1)._messageServerPublicKey))) throw new PnyxMessagesException(PnyxMessagesException.Key.INVALID_RECEIPT, "The receipt signature cannot be verified."); (this = new VoteReceipt()).setBallotIdentifier(((ReceiptReader)localObject1)._ballotIdentifier); setControlCode((String)localObject2 + ((ReceiptReader)localObject1)._timestamp); } return (VoteReceipt)(VoteReceipt)this;
/*     */   }
/*     */ 
/*     */   private String readAttrib(String attributeName)
/*     */     throws XMLStreamException
/*     */   {
/*     */     String attributeName;
/*     */     String type;
/* 130 */     return type = (
/* 128 */       event = (StartElement)this._reader.nextEvent())
/* 128 */       .getAttributeByName(new QName(attributeName)).getValue();
/*     */   }
/*     */ 
/*     */   private String readTagCharacters(String paramString)
/*     */     throws XMLStreamException
/*     */   {
/* 220 */     locateStartElement(paramString);
/*     */ 
/* 222 */     this._reader.nextEvent();
/* 223 */     this = this; for (paramString = new StringBuffer(); this._reader.peek().isCharacters(); paramString.append(this._reader.nextEvent().asCharacters().getData()));
/* 223 */     return paramString.toString();
/*     */   }
/*     */ 
/*     */   private void locateStartElement(String paramString)
/*     */     throws XMLStreamException
/*     */   {
/* 233 */     int i = 0;
/* 234 */     while (i == 0) { canPeek();
/*     */       while (true) {
/* 236 */         canPeek(); if (this._reader.peek().isStartElement()) break;
/* 237 */         this._reader.nextEvent();
/*     */       }
/* 239 */       if (((StartElement)this._reader.peek()).getName().getLocalPart().equalsIgnoreCase(paramString))
/*     */       {
/* 241 */         i = 1; continue;
/*     */       }
/* 243 */       this._reader.nextEvent();
/*     */     }
/*     */   }
/*     */ 
/*     */   private boolean canPeek()
/*     */     throws XMLStreamException
/*     */   {
/* 254 */     if ((this._reader == null) || (this._reader.peek() == null)) {
/* 255 */       throw new XMLStreamException("EOF");
/*     */     }
/* 257 */     return true;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.application.message.helper.ReceiptReader
 * JD-Core Version:    0.6.0
 */