/*     */ package com.scytl.pnyx.client.communication.connector;
/*     */ 
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ElectoralScope;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.ballot.QuestionAnswer;
import com.scytl.common.domain.election.ballot.ValuedMultipleChoiceQuestionAnswer;
/*     */ import com.scytl.common.domain.token.TokenJCE;
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.pnyx.client.IllegalOperationException;
/*     */ //import com.scytl.pnyx.client.IllegalOperationException.Key;
/*     */ import com.scytl.pnyx.client.SecurityException;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.ApplicationProtocol;
/*     */ import com.scytl.pnyx.client.communication.application.ApplicationProtocolException;
/*     */ import com.scytl.pnyx.client.communication.application.ClientDataManager;
/*     */ import com.scytl.pnyx.client.communication.application.KeystoreAndToken;
/*     */ import com.scytl.pnyx.client.communication.application.message.PnyxMessagesException;
/*     */ //import com.scytl.pnyx.client.communication.application.message.PnyxMessagesException.Key;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*     */ import com.scytl.pnyx.client.validator.ValidatorException;
/*     */ import com.scytl.pnyx.client.validator.ValidatorException.BallotErrorKey;
/*     */ import com.scytl.pnyx.client.validator.ballot.BallotValidator;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import java.io.IOException;
/*     */ import java.net.URL;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.KeyStore;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.PublicKey;
/*     */ import java.security.cert.CertStore;
/*     */ import java.security.cert.Certificate;
/*     */ import java.util.Map;
import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public abstract class AbstractProtocolConnector
/*     */   implements ProtocolConnector
/*     */ {
/*     */   private final ClientData _clientData;
/*     */   private final ApplicationProtocol _applicationProtocol;
/*     */   private final PostCallback _postCallback;
/*     */ 
/*     */   public AbstractProtocolConnector(ClientData clientData, ApplicationProtocol applicationProtocol, PostCallback postCallback)
/*     */   {
/*  55 */     this._clientData = clientData;
/*  56 */     this._applicationProtocol = applicationProtocol;
/*  57 */     this._postCallback = postCallback;
/*     */   }
/*     */ 
/*     */   public void login(LoginData loginData, ElectoralScope scope) throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/*  62 */     login(loginData, scope, true);
/*     */   }
/*     */ 
/*     */   private void login(LoginData paramLoginData, ElectoralScope paramElectoralScope, boolean paramBoolean)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/*  74 */     if (paramBoolean) {
/*  75 */       this._postCallback.beforeLogin(paramLoginData.getUsername(), paramElectoralScope.getInstitutionId(), paramElectoralScope.getElectionEventId(), paramElectoralScope.getElectionId());
/*     */     }
/*     */ 
/*  80 */     this._clientData.setLoginData(paramLoginData);
/*  81 */     AbstractProtocolConnector localAbstractProtocolConnector = this; 
			  localAbstractProtocolConnector = this._applicationProtocol.doAuthenticate(paramLoginData, paramElectoralScope);
/*     */ 
/*  83 */     this._clientData.setToken$7c600462(paramLoginData.getToken$49262418());
/*  84 */     this._clientData.setUserKeyStore(paramLoginData.getKeyStore());
/*  85 */     if (paramBoolean) {
/*  86 */       localAbstractProtocolConnector = this; this._postCallback.afterLogin$7c600462(this._clientData.getToken$49262418());
/*     */     }
/*     */   }
/*     */ 
/*     */   public void pickElection(ElectoralScope paramElectoralScope)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/*  96 */     if (!paramElectoralScope.knowsTheElection()) {
/*  97 */       throw new IllegalOperationException(IllegalOperationException.Key.ELECTION_CANT_BE_NULL, "Picking an election requires the election to be known.");
/*     */     }
/*     */ 
/* 107 */     Object localObject = this; paramElectoralScope = (TokenJCE)this._applicationProtocol.doGetToken$3b16f5d5(this._clientData.getLoginData(), paramElectoralScope);
/*     */ 
/* 110 */     this._clientData.setToken$7c600462(paramElectoralScope);
/* 111 */     localObject = this; this._postCallback.afterPickElection(this._clientData.getLoginData().getUsername(), paramElectoralScope.getElectionId(), paramElectoralScope.getElectionEventId(), paramElectoralScope.getInstitutionId());
/*     */     try
/*     */     {
/* 120 */       PublicKey localPublicKey = this._clientData.getServerKeystore().getCertificate("authentication_server_x509").getPublicKey(); localObject = paramElectoralScope; boolean bool = false;
/*     */       byte[] arrayOfByte;
/* 120 */       if (((arrayOfByte = ((TokenJCE)localObject).getAuthTokenSignature()) != null) && (arrayOfByte.length > 0)) bool = CryptographicAlgorithms.verify(((TokenJCE)localObject).getSignedInfo().getBytes(), arrayOfByte, localPublicKey); if (!bool)
/*     */       {
/* 123 */         throw new SecurityException(PnyxMessagesException.Key.INVALID_TOKEN, paramElectoralScope.toString());
/*     */       }
/*     */     }
/*     */     catch (KeyStoreException localKeyStoreException) {
/* 127 */       (
/* 128 */         localObject = 
/* 131 */         localKeyStoreException).printStackTrace();
/* 129 */       throw new SecurityException(PnyxMessagesException.Key.INVALID_TOKEN, (Throwable)localObject);
/*     */     }
/*     */ 
/* 134 */     localObject = this; localObject = this._applicationProtocol.doGetCertificates$1c0cd8ed(this._clientData.getToken$49262418());
/*     */     try
/*     */     {
/* 139 */       this._clientData.setElectionKeyStore((CertStore)localObject);
/*     */ 
/* 148 */       return;
/*     */     }
/*     */     catch (GeneralSecurityException localGeneralSecurityException)
/*     */     {
/* 141 */       throw new SecurityException(PnyxMessagesException.Key.SERVER_ERROR_BAD_FORMED_CERTIFICATE_PATH, paramElectoralScope.toString());
/*     */     }
/*     */     catch (IOException localIOException) {
/*     */     }
/* 145 */     throw new SecurityException(PnyxMessagesException.Key.SERVER_ERROR_BAD_FORMED_CERTIFICATE_PATH, paramElectoralScope.toString());
/*     */   }
/*     */ 
/*     */   public void produceBallot(MessageType paramMessageType)
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 159 */     Object localObject = new ClientDataManager(this._clientData);
/* 160 */     this._clientData.getLoginData().setMessageType(paramMessageType);
/* 161 */     AbstractProtocolConnector localAbstractProtocolConnector = this; localObject = this._applicationProtocol.doGetBallot$1abffdf5(this._clientData.getToken$49262418(), ((ClientDataManager)localObject).getAdministrationBoardPublicKey(), paramMessageType);
/*     */ 
/* 164 */     this._clientData.setTrustedBallot((Ballot)localObject);
/* 165 */     localAbstractProtocolConnector = this; this._postCallback.afterProduceBallot$56546152(this._clientData.getToken$49262418(), (Ballot)localObject, paramMessageType);
/*     */   }
/*     */ 
/*     */   public void discardElection()
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/* 180 */     Ballot ballot = this._clientData.getTrustedBallot();
/*     */ 
/* 182 */     URL exitURL = null;
/* 183 */     if (ballot != null) {
/* 184 */       exitURL = Ballot.stringToURL(ballot.getRedirectExitURL());
/* 185 */       this._clientData.setTrustedBallot(null);
/*     */ 
/* 190 */       ElectoralScope newScope = new ElectoralScope(ballot.getInstitutionId(), null, ballot.getElectionEventId());
/*     */ 
/* 193 */       login(this._clientData.getLoginData(), newScope, false);
/*     */     }
/*     */ 
/* 197 */     this._postCallback.afterDiscardElection$3ceab681(exitURL, this._clientData.getToken$49262418());
/*     */   }
/*     */ 
/*     */   public void logout() throws PnyxProtocolException
/*     */   {
/* 202 */     Ballot ballot = this._clientData.getTrustedBallot();
/* 203 */     URL exitURL = null;
/* 204 */     if (ballot != null) {
/* 205 */       exitURL = Ballot.stringToURL(this._clientData.getTrustedBallot().getRedirectExitURL());
/*     */ 
/* 209 */       this._clientData.setTrustedBallot(null);
/*     */     }
/* 211 */     this._clientData.setServerKeystore(null);
/* 212 */     this._clientData.setUserKeyStore(null);
/* 213 */     this._clientData.setLoginData(null);
/* 214 */     this._clientData.setToken$7c600462(null);
/* 215 */     this = this; this._postCallback.afterLogout(exitURL);
/*     */   }
/*     */ 
/*     */   public void validateVote(Map<String, QuestionAnswer> paramMap) throws PnyxProtocolException
/*     */   {
/* 220 */     this._clientData.fillBallot(paramMap);
/*     */ 
/* 222 */     paramMap = new BallotValidator();
/*     */ 
/* 224 */     ErrorMessage localErrorMessage = new ErrorMessage();
/* 225 */     paramMap.validate(this._clientData.getTrustedBallot(), localErrorMessage);
/*     */ 
/* 227 */     if (localErrorMessage.hasErrors()) {
/* 228 */       throw new ValidatorException(ValidatorException.BallotErrorKey.BALLOT_ERRORS, this._clientData.getTrustedBallot(), localErrorMessage);
/*     */     }
/*     */ 
/* 233 */     paramMap = this; this._postCallback.validateVoteSummary(this._clientData.getTrustedBallot());
/*     */   }
/*     */ 
/*     */   public void discardVote()
/*     */   {
/* 242 */     String username = this._clientData.getLoginData().getUsername();
/* 243 */     String electionid = this._clientData.getToken$49262418().getElectionId();
/* 244 */     AbstractProtocolConnector localAbstractProtocolConnector = this; this._postCallback.beforeDiscardVote(username, electionid);
/* 245 */     this._clientData.getTrustedBallot().clear();
/*     */   }
/*     */ 
/*     */   public void castVote()
/*     */     throws ApplicationProtocolException, PnyxProtocolException
/*     */   {
/* 251 */     AbstractProtocolConnector localAbstractProtocolConnector = this; this._postCallback.beforeCastVote(this._clientData.getLoginData().getUsername(), this._clientData.getToken$49262418().getInstitutionId(), this._clientData.getToken$49262418().getElectionEventId(), this._clientData.getToken$49262418().getElectionId());
/*     */ 
/* 258 */     ClientData clientData = this._clientData;
/* 259 */     localAbstractProtocolConnector = this;
/*     */     VoteReceipt receipt;
/* 259 */     (
/* 260 */       receipt = this._applicationProtocol.doCastVote(clientData))
/* 260 */       .setElectionDetails(clientData.getTrustedBallot());
/*     */ 
/* 262 */     localAbstractProtocolConnector = this; this._postCallback.displayReceipt(receipt, this._clientData.getLoginData().getUsername(), this._clientData.getToken$49262418().getInstitutionId(), this._clientData.getToken$49262418().getElectionEventId(), this._clientData.getToken$49262418().getElectionId());
/*     */ 
/* 267 */     clientData.setToken$7c600462(null);
/*     */   }
/*     */ 
/*     */   public final void nextElection()
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/* 275 */     Object localObject = this._clientData.getTrustedBallot();
/* 276 */     MessageType localMessageType = this._clientData.getMessageType();
/* 277 */     if (((Ballot)localObject).hasNextElectionId()) {
/* 278 */       localObject = new ElectoralScope(((Ballot)localObject).getInstitutionId(), ((Ballot)localObject).getNextElectionId(), ((Ballot)localObject).getElectionEventId());
/*     */ 
/* 282 */       login(this._clientData.getLoginData(), (ElectoralScope)localObject, true);
/* 283 */       pickElection((ElectoralScope)localObject);
/* 284 */       produceBallot(localMessageType);
/* 285 */       return;
/* 286 */     }throw new PnyxMessagesException(PnyxMessagesException.Key.NO_NEXT_ELECTION, "No next electionId available.");
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.connector.AbstractProtocolConnector
 * JD-Core Version:    0.6.0
 */