/*     */ package com.scytl.pnyx.client.communication.connector;
/*     */ 
/*     */ import com.scytl.common.certificates.CertificateStoreHelper;
/*     */ import com.scytl.common.certificates.ServerCertificatesHelper;
/*     */ import com.scytl.common.client.certificatevalidator.ElectionEventCertificatesValidator;
/*     */ import com.scytl.common.domain.LoginType;
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.ballot.QuestionAnswer;
/*     */ import com.scytl.common.utils.consts.CertificateType;
/*     */ import com.scytl.pnyx.client.SecurityException;
/*     */ import com.scytl.pnyx.client.SecurityException.Key;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import java.io.IOException;
/*     */ import java.security.GeneralSecurityException;
/*     */ import java.security.KeyStore;
/*     */ import java.security.cert.CertStore;
/*     */ import java.security.cert.Certificate;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import javax.security.auth.x500.X500Principal;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class ClientData
/*     */ {
/*  45 */   private static Log _logger = LogFactory.getLog(ClientData.class);
/*     */   public static final String MESSAGE_SERVER_X509 = "message_server_x509";
/*     */   public static final String AUTHENTICATION_SERVER_X509 = "authentication_server_x509";
/*     */   public static final String ELECTORAL_BOARD_X509 = "electoral_board_x509";
/*     */   public static final String ADMINISTRATION_BOARD_X509 = "administration_board_x509";
/*     */   public static final String SCYTL_CA_X509 = "scytl_ca_509";
/*     */   private ComponentMonitor _token$17d52047;
/*     */   private ElectionEventCertificatesValidator _certificateValidator;
/*     */   private KeyStore _serverKeystore;
/*     */   private KeyStore _electionCertStore;
/*     */   private KeyStore _userKeyStore;
/*     */   private final LoginType _loginType;
/*     */   private Ballot _trustedBallot;
/*     */   private LoginData _loginData;
/*     */ 
/*     */   public ClientData(LoginType paramLoginType)
/*     */   {
/*  98 */     this._loginType = paramLoginType;
/*  99 */     this = this;
/*     */     try { paramLoginType = this; this._certificateValidator = new ElectionEventCertificatesValidator(); Certificate localCertificate = this._certificateValidator.getAuthServerCertificate(); this = this._certificateValidator.getMessageServerCertificate(); paramLoginType = this._certificateValidator.getPnyxApplicationCertificate();
/*     */       KeyStore localKeyStore;
/*  99 */       (localKeyStore = KeyStore.getInstance("JKS")).load(null); localKeyStore.setCertificateEntry("scytl_ca_509", paramLoginType); localKeyStore.setCertificateEntry("message_server_x509", this); localKeyStore.setCertificateEntry("authentication_server_x509", localCertificate); this._serverKeystore = localKeyStore; return; } catch (GeneralSecurityException localGeneralSecurityException) { _logger.error("Error initializing server certificates"); return; } catch (IOException localIOException) { _logger.error("Error reading certificates for initializing server certificates"); } 
/*     */   }
/*     */ 
/*     */   private boolean validateElectionCertificates(CertStore paramCertStore, String paramString) {
/*     */     int i;
/*     */     try {
/* 105 */       i = this._certificateValidator.validateElectionEventCertificate(paramCertStore, paramString, CertificateType.ADMINISTRATIONBOARD) != null ? 1 : 0;
/*     */     }
/*     */     catch (GeneralSecurityException localGeneralSecurityException1)
/*     */     {
/* 114 */       i = 0;
/*     */     }
/*     */     try {
/* 117 */       this = this._certificateValidator.validateElectionEventCertificate(paramCertStore, paramString, CertificateType.ELECTORALBOARD) != null ? 1 : 0;
/*     */     }
/*     */     catch (GeneralSecurityException localGeneralSecurityException2)
/*     */     {
/* 122 */       this = 0;
/*     */     }
/*     */ 
/* 125 */     return (i != 0) && (this != 0);
/*     */   }
/*     */ 
/*     */   public ComponentMonitor getToken$49262418()
/*     */   {
/* 183 */     return this._token$17d52047;
/*     */   }
/*     */ 
/*     */   public void setToken$7c600462(ComponentMonitor token)
/*     */   {
/* 191 */     this._token$17d52047 = token;
/*     */   }
/*     */ 
/*     */   public KeyStore getServerKeystore()
/*     */   {
/* 198 */     return this._serverKeystore;
/*     */   }
/*     */ 
/*     */   public void setServerKeystore(KeyStore serverKeystore)
/*     */   {
/* 206 */     this._serverKeystore = serverKeystore;
/*     */   }
/*     */ 
/*     */   public KeyStore getUserKeyStore() {
/* 210 */     return this._userKeyStore;
/*     */   }
/*     */ 
/*     */   public void setUserKeyStore(KeyStore userKeyStore) {
/* 214 */     this._userKeyStore = userKeyStore;
/*     */   }
/*     */ 
/*     */   public Ballot getTrustedBallot()
/*     */   {
/* 221 */     return this._trustedBallot;
/*     */   }
/*     */ 
/*     */   public void setTrustedBallot(Ballot paramBallot)
/*     */   {
/*     */     try
/*     */     {
/* 230 */       if (paramBallot != null) {
/* 231 */         this._trustedBallot = ((Ballot)paramBallot.clone());
/*     */       }
/*     */ 
/* 236 */       return;
/*     */     }
/*     */     catch (CloneNotSupportedException this)
/*     */     {
/* 234 */       _logger.error("Could not clone ballot before setting it.", this);
/*     */     }
/*     */   }
/*     */ 
/*     */   public LoginType getLoginType()
/*     */   {
/* 243 */     return this._loginType;
/*     */   }
/*     */ 
/*     */   public void fillBallot(Map<String, QuestionAnswer> paramMap)
/*     */     throws PnyxProtocolException
/*     */   {
/* 257 */     if (paramMap == null) {
/* 258 */       return;
/*     */     }
/* 260 */     for (Map.Entry localEntry : paramMap.entrySet()) {
/* 261 */       if (!this._trustedBallot.containsQuestion((String)localEntry.getKey())) {
/* 262 */         this._trustedBallot.clear();
/* 263 */         throw new SecurityException(SecurityException.Key.ILLEGAL_VOTE, "This question does not pertain to the voter ballot.");
/*     */       }
/*     */ 
/*     */       try
/*     */       {
/* 268 */         this._trustedBallot.answerQuestion(new String((String)localEntry.getKey()), localEntry.getValue() == null ? null : (QuestionAnswer)((QuestionAnswer)localEntry.getValue()).clone());
/*     */       }
/*     */       catch (CloneNotSupportedException localCloneNotSupportedException)
/*     */       {
/* 274 */         _logger.error("Could not fill the private ballot representation with the client's answers.", localCloneNotSupportedException);
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   public void setLoginData(LoginData loginData)
/*     */   {
/* 286 */     this._loginData = loginData;
/*     */   }
/*     */ 
/*     */   public LoginData getLoginData()
/*     */   {
/* 293 */     return this._loginData;
/*     */   }
/*     */ 
/*     */   public void setElectionKeyStore(CertStore paramCertStore)
/*     */     throws GeneralSecurityException, IOException
/*     */   {
/* 304 */     Object localObject1 = getToken$49262418().getElectionEventId();
/* 305 */     if (!validateElectionCertificates(paramCertStore, (String)localObject1))
/*     */     {
/* 307 */       throw new GeneralSecurityException("Election certificate chain is not valid.");
/*     */     }
/*     */ 
/* 311 */     this._electionCertStore = KeyStore.getInstance("JKS");
/* 312 */     this._electionCertStore.load(null);
/*     */ 
/* 314 */     Object localObject2 = ServerCertificatesHelper.findAdminBoardCertificatePrincipal(paramCertStore, (String)localObject1);
/*     */ 
/* 318 */     localObject2 = CertificateStoreHelper.getCertificate(paramCertStore, (X500Principal)localObject2);
/*     */ 
/* 322 */     localObject1 = ServerCertificatesHelper.findElectoralBoardCertificatePrincipal(paramCertStore, (String)localObject1);
/*     */ 
/* 327 */     paramCertStore = CertificateStoreHelper.getCertificate(paramCertStore, (X500Principal)localObject1);
/*     */ 
/* 331 */     this._electionCertStore.setCertificateEntry("administration_board_x509", (Certificate)localObject2);
/*     */ 
/* 333 */     this._electionCertStore.setCertificateEntry("electoral_board_x509", paramCertStore);
/*     */   }
/*     */ 
/*     */   public KeyStore getElectionKeyStore()
/*     */   {
/* 339 */     return this._electionCertStore;
/*     */   }
/*     */ 
/*     */   public MessageType getMessageType()
/*     */   {
/* 346 */     return this._loginData.getMessageType();
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.communication.connector.ClientData
 * JD-Core Version:    0.6.0
 */