/*     */ package com.scytl.pnyx.client.state;
/*     */ 
/*     */ import C;
/*     */ import com.scytl.common.domain.LoginType;
/*     */ import com.scytl.pnyx.client.cert.CertificatePrincipalExtractor;
/*     */ import com.scytl.pnyx.client.cert.CertificatePrincipalExtractorSelector;
/*     */ import com.scytl.pnyx.client.cert.CorporateCertificatePrincipalExtractor;
/*     */ import com.scytl.pnyx.client.cert.impl.PropertiesCertificateParserSelector;
/*     */ import java.security.KeyStore;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.cert.Certificate;
/*     */ import java.security.cert.X509Certificate;
/*     */ 
/*     */ public class RecognizedLoginData extends LoginData
/*     */ {
/*  29 */   public static final char[] DEFAULT_PASSWORD = "password".toCharArray();
/*     */   private final String _alias;
/*     */   private final KeyStore _keyStore;
/*  35 */   private final char[] _keyStorePassword = "".toCharArray();
/*     */   private final String _userName;
/*  39 */   private static final CertificatePrincipalExtractorSelector PARSER_SELECTOR = new PropertiesCertificateParserSelector("/propertiesCertificateParsers.xml");
/*     */ 
/*     */   public RecognizedLoginData(KeyStore keystore, String alias)
/*     */     throws KeyStoreException
/*     */   {
/*  52 */     this._alias = alias;
/*  53 */     this._keyStore = keystore;
/*  54 */     this._userName = extractUserNameFromCertificate(keystore.getCertificate(alias));
/*     */   }
/*     */ 
/*     */   public static String extractUserNameFromCertificate(Certificate certificate)
/*     */   {
/*  61 */     return PARSER_SELECTOR.searchPrincipalExtractor(certificate).getUserName((X509Certificate)certificate);
/*     */   }
/*     */ 
/*     */   public static String extractCifFromCertificate(Certificate certificate)
/*     */   {
/*     */     CertificatePrincipalExtractor extractor;
/*  69 */     if (((
/*  69 */       extractor = PARSER_SELECTOR.searchPrincipalExtractor(certificate)) instanceof CorporateCertificatePrincipalExtractor))
/*     */     {
/*  70 */       return ((CorporateCertificatePrincipalExtractor)extractor).getOrganizationId((X509Certificate)certificate);
/*     */     }
/*     */ 
/*  73 */     return "";
/*     */   }
/*     */ 
/*     */   public LoginType getLoginType()
/*     */   {
/*  81 */     return LoginType.RECOGNIZED;
/*     */   }
/*     */ 
/*     */   public boolean canDecrypt()
/*     */   {
/*  89 */     return false;
/*     */   }
/*     */ 
/*     */   public char[] getPin()
/*     */   {
/*  97 */     return getKeyStorePassword();
/*     */   }
/*     */ 
/*     */   public char[] getPassword()
/*     */   {
/* 105 */     return cloneCharArray(DEFAULT_PASSWORD);
/*     */   }
/*     */ 
/*     */   public String getUsername()
/*     */   {
/* 113 */     return this._userName;
/*     */   }
/*     */ 
/*     */   public String getAlias() {
/* 117 */     return this._alias;
/*     */   }
/*     */ 
/*     */   public KeyStore getKeyStore() {
/* 121 */     return this._keyStore;
/*     */   }
/*     */ 
/*     */   public char[] getKeyStorePassword() {
/* 125 */     return cloneCharArray(this._keyStorePassword);
/*     */   }
/*     */ 
/*     */   private static char[] cloneCharArray(char[] input) {
/* 129 */     char[] result = null;
/* 130 */     if (input != null) {
/* 131 */       result = (char[])input.clone();
/*     */     }
/* 133 */     return result;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.state.RecognizedLoginData
 * JD-Core Version:    0.6.0
 */