/*    */ package com.scytl.pnyx.client.state.automaton;
/*    */ 
/*    */ import com.scytl.common.domain.MessageType;
/*    */ import com.scytl.common.domain.election.ElectoralScope;
/*    */ import com.scytl.common.domain.election.ballot.QuestionAnswer;
/*    */ import com.scytl.pnyx.client.IllegalOperationException;
/*    */ import com.scytl.pnyx.client.IllegalOperationException.Key;
/*    */ import com.scytl.pnyx.client.communication.application.ApplicationProtocolException;
/*    */ import com.scytl.pnyx.client.communication.connector.ProtocolConnector;
/*    */ import com.scytl.pnyx.client.state.LoginData;
/*    */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*    */ import java.util.Map;
/*    */ 
/*    */ public abstract class AbstractState
/*    */   implements WizardState
/*    */ {
/*    */   private final ProtocolConnector _connector;
/*    */ 
/*    */   public AbstractState(ProtocolConnector connector)
/*    */   {
/* 33 */     this._connector = connector;
/*    */   }
/*    */ 
/*    */   public void login(LoginData loginData, ElectoralScope scope) throws ApplicationProtocolException, PnyxProtocolException
/*    */   {
/* 38 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void logout() throws PnyxProtocolException
/*    */   {
/* 43 */     this._connector.logout();
/*    */   }
/*    */ 
/*    */   public void discardElection() throws PnyxProtocolException, ApplicationProtocolException
/*    */   {
/* 48 */     this._connector.discardElection();
/*    */   }
/*    */ 
/*    */   public void pickElection(ElectoralScope scope) throws ApplicationProtocolException, PnyxProtocolException
/*    */   {
/* 53 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void produceBallot(MessageType messageType)
/*    */     throws ApplicationProtocolException, PnyxProtocolException
/*    */   {
/* 59 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void validateVote(Map<String, QuestionAnswer> vote)
/*    */     throws PnyxProtocolException
/*    */   {
/* 65 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void discardVote() throws PnyxProtocolException
/*    */   {
/* 70 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void castVote()
/*    */     throws ApplicationProtocolException, PnyxProtocolException
/*    */   {
/* 76 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   public void nextElection()
/*    */     throws PnyxProtocolException, ApplicationProtocolException
/*    */   {
/* 82 */     throw new IllegalOperationException(IllegalOperationException.Key.TRANSITION_NOT_ALLOWED);
/*    */   }
/*    */ 
/*    */   protected final ProtocolConnector getConnector()
/*    */   {
/* 87 */     return this._connector;
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.state.automaton.AbstractState
 * JD-Core Version:    0.6.0
 */