/*     */ package com.scytl.pnyx.client.validator;
/*     */ 
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class ValidatorException extends PnyxProtocolException
/*     */ {
/*     */   private Ballot _ballot;
/*     */   private ErrorMessage _errorMessage;
/*     */ 
/*     */   public ValidatorException(ComponentMonitor messageKey, Ballot ballot, ErrorMessage errors)
/*     */   {
/*  80 */     super(messageKey);
/*  81 */     this._ballot = ballot;
/*  82 */     this._errorMessage = errors;
/*     */   }
/*     */ 
/*     */   public ValidatorException(ComponentMonitor messageKey, String message, Throwable cause)
/*     */   {
/*  92 */     super(messageKey, message, cause);
/*     */   }
/*     */ 
/*     */   public ValidatorException(ComponentMonitor messageKey, String message)
/*     */   {
/* 101 */     super(messageKey, message);
/*     */   }
/*     */ 
/*     */   public ValidatorException(ComponentMonitor messageKey, Throwable cause)
/*     */   {
/* 110 */     super(messageKey, cause);
/*     */   }
/*     */ 
/*     */   public ValidatorException(ComponentMonitor messageKey)
/*     */   {
/* 117 */     super(messageKey);
/*     */   }
/*     */ 
/*     */   public Ballot getBallot() {
/* 121 */     return this._ballot;
/*     */   }
/*     */ 
/*     */   public ErrorMessage getErrorMessage() {
/* 125 */     return this._errorMessage;
/*     */   }
/*     */ 
/*     */   public static enum BallotErrorKey
/*     */     implements ComponentMonitor
/*     */   {
/*  24 */     BALLOT_ERRORS("ballot.errors", 0), 
/*     */ 
/*  26 */     INVALID_ANSWER_ID("ballot.invalid_answer_id", 0), 
/*     */ 
/*  28 */     TOO_MANY_ANSWERS("ballot.too_many_answers", 1), 
/*     */ 
/*  30 */     NOT_ENOUGH_ANSWERS("ballot.not_enough_answers", 1), 
/*     */ 
/*  32 */     ANSWER_TOO_SHORT("ballot.answer_too_short", 1), 
/*     */ 
/*  34 */     ANSWER_TOO_LONG("ballot.answer_too_long", 1), 
/*     */ 
/*  36 */     NOT_PARSEABLE_INTEGER("ballot.answer_not_integer", 1), 
/*     */ 
/*  38 */     NEGATIVE_VALUE("ballot.negative_value", 0), 
/*     */ 
/*  40 */     NOT_CORRELATIVE("ballot.not_correlative", 0), 
/*     */ 
/*  42 */     TOO_MANY_POINTS("ballot.too_many_points", 2), 
/*     */ 
/*  44 */     INNER_TOO_MANY_ANSWERS("ballot.inner_too_many_answers", 1), 
/*     */ 
/*  46 */     INNER_NOT_ENOUGH_ANSWERS("ballot.inner_not_enough_answers", 1), 
/*     */ 
/*  48 */     BLANK_HAS_ANSWERS("ballot.blank_has_answers", 0);
/*     */ 
/*     */     private final String _key;
/*     */     private final int _parameterSize;
/*     */ 
/*  55 */     private BallotErrorKey(String key, int parameterSize) { this._key = key;
/*  56 */       this._parameterSize = parameterSize; }
/*     */ 
/*     */     public final String getKey()
/*     */     {
/*  60 */       return this._key;
/*     */     }
/*     */ 
/*     */     public final int getParameterSize() {
/*  64 */       return this._parameterSize;
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.validator.ValidatorException
 * JD-Core Version:    0.6.0
 */