/*     */ package com.scytl.pnyx.client.validator.ballot;
/*     */ 
/*     */ import com.scytl.common.domain.OverVoteTypes;
/*     */ import com.scytl.common.domain.election.QuestionType;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.ballot.QuestionAnswer;
/*     */ import com.scytl.common.domain.election.ballot.TextQuestionAnswer;
/*     */ import com.scytl.common.domain.election.ballot.ValuedMultipleChoiceQuestionAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.DelegationChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.OpenTextQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.pnyx.client.validator.Error;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*     */ import com.scytl.pnyx.client.validator.Validator;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class BallotValidator
/*     */   implements Validator<Ballot>
/*     */ {
/*     */   public boolean supports(Class<Ballot> paramClass)
/*     */   {
/*  40 */     return Ballot.class.equals(paramClass);
/*     */   }
/*     */ 
/*     */   public void validate(Ballot paramBallot, ErrorMessage paramErrorMessage)
/*     */   {
/*  45 */     Object localObject1 = paramBallot.getBallotQuestions();
/*  46 */     paramBallot.cleanBallotErrors();
/*     */ 
/*  48 */     for (Question localQuestion : (List)localObject1) {
/*  49 */       localObject1 = (QuestionAnswer)paramBallot.getBallotAnswers().get(localQuestion.getId());
/*  50 */       Object localObject3 = paramErrorMessage; Object localObject2 = localObject1; localObject1 = localQuestion; switch (1.$SwitchMap$com$scytl$common$domain$election$QuestionType[localObject1.getQuestionType().ordinal()]) { case 1:
/*  50 */         localObject1 = (MultipleChoiceQuestion)localObject1; new ValuedMultipleChoiceQuestionValidator("ballotAnswers", (MultipleChoiceQuestion)localObject1).validate((ValuedMultipleChoiceQuestionAnswer)localObject2, (ErrorMessage)localObject3); break;
/*     */       case 2:
/*  50 */         new OpenTextQuestionValidator("ballotAnswers", (OpenTextQuestion)localObject1).validate((TextQuestionAnswer)localObject2, (ErrorMessage)localObject3); break;
/*     */       case 3:
/*  50 */         new DelegationChoiceQuestionValidator("ballotAnswers", (DelegationChoiceQuestion)localObject1).validate((ValuedMultipleChoiceQuestionAnswer)localObject2, (ErrorMessage)localObject3);
/*     */       case 4: }
/*  52 */       localObject3 = paramErrorMessage; localObject2 = localQuestion.getId(); localObject1 = this; localObject1 = new HashSet(); for (localObject3 = ((ErrorMessage)localObject3).iterator(); ((Iterator)localObject3).hasNext(); )
/*     */       {
/*  52 */         Error localError;
/*     */         String str;
/*  52 */         if ((str = (localError = (Error)((Iterator)localObject3).next()).getFieldName()).contains(buildLimitedQuestionId((String)localObject2))) ((Set)localObject1).add(localError.getErrorKey$564a8e04().getKey()); 
/*  52 */       }localObject1 = localObject1;
/*     */ 
/*  55 */       paramBallot.addBallotErros(localQuestion.getId(), (Set)localObject1);
/*     */ 
/*  58 */       if ((localQuestion.getQuestionType() == QuestionType.MULTIPLE_CHOICE_QUESTION) && 
/*  59 */         (((MultipleChoiceQuestion)localQuestion).getOvervoteType() == OverVoteTypes.ALLOW))
/*     */       {
/*  61 */         deleteErrorsByQuestion(localQuestion.getId(), paramErrorMessage);
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   private static String buildLimitedQuestionId(String questionId)
/*     */   {
/*  94 */     return "[" + questionId + "]";
/*     */   }
/*     */ 
/*     */   private void deleteErrorsByQuestion(String paramString, ErrorMessage paramErrorMessage)
/*     */   {
/* 107 */     this = paramErrorMessage.getErrorsAsList();
/*     */ 
/* 109 */     paramErrorMessage = new ArrayList();
/*     */ 
/* 112 */     for (Iterator localIterator = iterator(); localIterator.hasNext(); )
/*     */     {
/*     */       String str;
/* 115 */       if ((
/* 115 */         str = (
/* 114 */         localError = (Error)localIterator.next())
/* 114 */         .getFieldName())
/* 115 */         .contains(buildLimitedQuestionId(paramString)))
/* 116 */         paramErrorMessage.add(localError);
/*     */     }
/* 120 */     Error localError;
/* 120 */     for (localIterator = paramErrorMessage.iterator(); localIterator.hasNext(); ) { localError = (Error)localIterator.next();
/* 121 */       remove(localError);
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.validator.ballot.BallotValidator
 * JD-Core Version:    0.6.0
 */