/*    */ package com.scytl.pnyx.client.validator.ballot;
/*    */ 
/*    */ import com.scytl.common.domain.election.ballot.TextQuestionAnswer;
/*    */ import com.scytl.common.domain.hibernate.entity.election.OpenTextQuestion;
/*    */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*    */ import com.scytl.pnyx.client.validator.ValidatorException.BallotErrorKey;
/*    */ 
/*    */ public class OpenTextQuestionValidator extends QuestionValidator<TextQuestionAnswer, OpenTextQuestion>
/*    */ {
/*    */   public OpenTextQuestionValidator(String fieldPrefix, OpenTextQuestion question)
/*    */   {
/* 30 */     super(fieldPrefix, question);
/*    */   }
/*    */ 
/*    */   public boolean supports(Class<TextQuestionAnswer> paramClass)
/*    */   {
/* 35 */     return (super.supports(paramClass)) && (TextQuestionAnswer.class.equals(paramClass));
/*    */   }
/*    */ 
/*    */   public void validateQuestion(TextQuestionAnswer paramTextQuestionAnswer, ErrorMessage paramErrorMessage)
/*    */   {
/* 43 */     int i = ((OpenTextQuestion)getQuestion()).getMinAnswerCharacters().intValue();
/* 44 */     if (((paramTextQuestionAnswer.getText() == null) && (i > 0)) || ((paramTextQuestionAnswer.getText() != null) && (paramTextQuestionAnswer.getText().length() < i)))
/*    */     {
/* 47 */       paramErrorMessage.addError$53409bcd(getFieldName(), ValidatorException.BallotErrorKey.ANSWER_TOO_SHORT, new Object[] { Integer.valueOf(i) });
/*    */     }
/*    */ 
/* 51 */     i = ((OpenTextQuestion)getQuestion()).getMaxAnswerCharacters().intValue();
/* 52 */     if ((paramTextQuestionAnswer.getText() != null) && (paramTextQuestionAnswer.getText().length() > i))
/*    */     {
/* 54 */       paramErrorMessage.addError$53409bcd(getFieldName(), ValidatorException.BallotErrorKey.ANSWER_TOO_LONG, new Object[] { Integer.valueOf(i) });
/*    */     }
/*    */   }
/*    */ 
/*    */   private String getFieldName()
/*    */   {
/* 61 */     return getFieldPrefix().concat("[").concat(((OpenTextQuestion)getQuestion()).getId()).concat("].text");
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.validator.ballot.OpenTextQuestionValidator
 * JD-Core Version:    0.6.0
 */