/*     */ package com.scytl.pnyx.client.validator.ballot;
/*     */ 
/*     */ import com.scytl.common.domain.ListAnswerType;
/*     */ import com.scytl.common.domain.election.ballot.ValuedMultipleChoiceQuestionAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Answer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.ListAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.MultipleChoiceQuestion;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*     */ import com.scytl.pnyx.client.validator.ValidatorException.BallotErrorKey;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collections;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class ValuedMultipleChoiceQuestionValidator extends QuestionValidator<ValuedMultipleChoiceQuestionAnswer, MultipleChoiceQuestion>
/*     */ {
/*  35 */   private static Log _logger = LogFactory.getLog(ValuedMultipleChoiceQuestionValidator.class);
/*     */ 
/*     */   public ValuedMultipleChoiceQuestionValidator(String fieldPrefix, MultipleChoiceQuestion question)
/*     */   {
/*  41 */     super(fieldPrefix, question);
/*     */   }
/*     */ 
/*     */   private String getFieldName()
/*     */   {
/*  46 */     return getFieldPrefix().concat(buildFieldNameId(((MultipleChoiceQuestion)getQuestion()).getId())).concat(".answerIdValues");
/*     */   }
/*     */ 
/*     */   private String getFieldName(String paramString)
/*     */   {
/*  52 */     return getFieldName().concat(buildFieldNameId(paramString));
/*     */   }
/*     */ 
/*     */   private static String buildFieldNameId(String id) {
/*  56 */     return "[" + id + "]";
/*     */   }
/*     */ 
/*     */   private boolean validateQuestionExplicitNullifySelected(ValuedMultipleChoiceQuestionAnswer paramValuedMultipleChoiceQuestionAnswer)
/*     */   {
/* 247 */     int i = 0;
/* 248 */     for (Object localObject : ((MultipleChoiceQuestion)getQuestion()).getNullerAnswers())
/*     */     {
/* 251 */       if (((
/* 251 */         localObject = (String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject).getId())) != null) && 
/* 251 */         (((String)localObject).length() > 0)) {
/* 252 */         i = 1;
/* 253 */         break;
/*     */       }
/*     */     }
/*     */ 
/* 257 */     return i;
/*     */   }
/*     */ 
/*     */   private boolean validateQuestionExplicitBlankSelected(ValuedMultipleChoiceQuestionAnswer paramValuedMultipleChoiceQuestionAnswer)
/*     */   {
/* 262 */     int i = 0;
/*     */ 
/* 264 */     for (Object localObject : ((MultipleChoiceQuestion)getQuestion()).getBlankAnswers())
/*     */     {
/* 267 */       if (((
/* 267 */         localObject = (String)paramValuedMultipleChoiceQuestionAnswer.getAnswerIdValues().get(((Answer)localObject).getId())) != null) && 
/* 267 */         (((String)localObject).length() > 0)) {
/* 268 */         i = 1;
/* 269 */         break;
/*     */       }
/*     */     }
/* 272 */     return i;
/*     */   }
/*     */ 
/*     */   private static int countTopLevelAnswers(Map<String, String> paramMap, List<Answer> paramList)
/*     */   {
/* 286 */     int i = 0;
/* 287 */     for (Answer localAnswer : paramList) {
/* 288 */       if (paramMap.get(localAnswer.getId()) != null) {
/* 289 */         i++;
/*     */       }
/*     */     }
/* 292 */     return i;
/*     */   }
/*     */ 
/*     */   private int parseCheckPositiveInt(String paramString1, ErrorMessage paramErrorMessage, String paramString2)
/*     */   {
/* 297 */     int i = 0;
/*     */     try {
/* 299 */       i = Integer.parseInt(paramString1);
/*     */     } catch (NumberFormatException localNumberFormatException) {
/* 301 */       paramErrorMessage.addError$53409bcd(getFieldName(paramString2), ValidatorException.BallotErrorKey.NOT_PARSEABLE_INTEGER, new Object[] { paramString1 });
/*     */     }
/*     */ 
/* 304 */     if (i < 0) {
/* 305 */       paramErrorMessage.addError$76d17a(getFieldName(paramString2), ValidatorException.BallotErrorKey.NEGATIVE_VALUE);
/*     */     }
/*     */ 
/* 308 */     return i;
/*     */   }
/*     */ 
/*     */   private static List<Integer> valuesAsIntegers(List<String> paramList) {
/* 312 */     ArrayList localArrayList = new ArrayList();
/* 313 */     for (String str : paramList) {
/*     */       try {
/* 315 */         localArrayList.add(Integer.valueOf(str));
/*     */       } catch (NumberFormatException localNumberFormatException) {
/* 317 */         _logger.debug("Not an integer :: " + str);
/*     */       }
/*     */     }
/* 320 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   private void checkCorrelative(List<String> paramList, ErrorMessage paramErrorMessage)
/*     */   {
/* 326 */     Collections.sort(paramList = valuesAsIntegers(paramList));
/*     */ 
/* 327 */     int i = 1;
/* 328 */     for (int j = 1; (j <= paramList.size()) && (i != 0); j++)
/* 329 */       if (((Integer)paramList.get(j - 1)).intValue() != j) {
/* 330 */         if (i != 0) {
/* 331 */           paramErrorMessage.addError$76d17a(getFieldName(), ValidatorException.BallotErrorKey.NOT_CORRELATIVE);
/*     */         }
/*     */ 
/* 334 */         i = 0;
/*     */       }
/*     */   }
/*     */ 
/*     */   private void checkCumulativePoints(List<String> paramList, ErrorMessage paramErrorMessage)
/*     */   {
/* 341 */     paramList = valuesAsIntegers(paramList);
/* 342 */     int i = 0;
/* 343 */     for (paramList = paramList.iterator(); paramList.hasNext(); ) { int j = ((Integer)paramList.next()).intValue();
/* 344 */       i += j;
/*     */     }
/* 346 */     if (i > ((MultipleChoiceQuestion)getQuestion()).getCumulativePoints())
/* 347 */       paramErrorMessage.addError$53409bcd(getFieldName(), ValidatorException.BallotErrorKey.TOO_MANY_POINTS, new Object[] { Integer.valueOf(((MultipleChoiceQuestion)getQuestion()).getCumulativePoints()), Integer.valueOf(i) });
/*     */   }
/*     */ 
/*     */   private void properSemiOpenAnswers(List<Answer> paramList, List<String> paramList1, ErrorMessage paramErrorMessage)
/*     */   {
/* 369 */     for (paramList = paramList.iterator(); paramList.hasNext(); )
/*     */     {
/*     */       Object localObject;
/* 370 */       if (((
/* 370 */         localObject = (Answer)paramList.next()) instanceof ListAnswer))
/*     */       {
/* 371 */         localObject = (ListAnswer)localObject;
/*     */ 
/* 373 */         int i = 0;
/*     */ 
/* 375 */         if (((ListAnswer)localObject).getListType().equals(ListAnswerType.SEMI_OPEN_LIST))
/*     */         {
/* 378 */           for (Answer localAnswer : ((ListAnswer)localObject).getActiveAnswers())
/*     */           {
/* 381 */             boolean bool1 = paramList1.contains(localAnswer.getId());
/*     */ 
/* 383 */             boolean bool2 = paramList1.contains(((ListAnswer)localObject).getId());
/*     */ 
/* 386 */             if ((bool1) && (!bool2))
/*     */             {
/* 388 */               paramErrorMessage.addError$76d17a(getFieldName(), ValidatorException.BallotErrorKey.INVALID_ANSWER_ID); continue;
/*     */             }
/* 390 */             if ((bool1) && (bool2))
/*     */             {
/* 392 */               i++;
/*     */             }
/*     */           }
/*     */ 
/* 396 */           if (paramList1.contains(((ListAnswer)localObject).getId()))
/* 397 */             properSemiOpenAnswersCheckNum(paramErrorMessage, (ListAnswer)localObject, i);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   private void properSemiOpenAnswersCheckNum(ErrorMessage errors, ListAnswer listAnswer, int numInnerAnswers)
/*     */   {
/* 412 */     if (numInnerAnswers > listAnswer.getMaxListOptions().intValue()) {
/* 413 */       errors.addError$53409bcd(getFieldName(), ValidatorException.BallotErrorKey.INNER_TOO_MANY_ANSWERS, new Object[] { listAnswer.getMaxListOptions() });
/*     */     }
/*     */ 
/* 417 */     if (numInnerAnswers < listAnswer.getMinListOptions().intValue())
/* 418 */       errors.addError$53409bcd(getFieldName(), ValidatorException.BallotErrorKey.INNER_NOT_ENOUGH_ANSWERS, new Object[] { listAnswer.getMinListOptions() });
/*     */   }
/*     */ 
/*     */   private void properOpenListAnswers(List<Answer> paramList, List<String> paramList1, ErrorMessage paramErrorMessage)
/*     */   {
/* 439 */     for (paramList = paramList.iterator(); paramList.hasNext(); )
/*     */     {
/*     */       Object localObject;
/* 440 */       if (((
/* 440 */         localObject = (Answer)paramList.next()) instanceof ListAnswer))
/*     */       {
/* 441 */         localObject = (ListAnswer)localObject;
/* 442 */         int i = 0;
/* 443 */         if (((ListAnswer)localObject).getListType().equals(ListAnswerType.OPEN_LIST))
/*     */         {
/* 445 */           for (Answer localAnswer : ((ListAnswer)localObject).getActiveAnswers())
/*     */           {
/* 451 */             if (paramList1.contains(localAnswer.getId())) {
/* 452 */               i++;
/*     */             }
/*     */           }
/*     */ 
/* 456 */           properSemiOpenAnswersCheckNum(paramErrorMessage, (ListAnswer)localObject, i);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.pnyx.client.validator.ballot.ValuedMultipleChoiceQuestionValidator
 * JD-Core Version:    0.6.0
 */