/*     */ package com.scytl.print;
/*     */ 
/*     */ import java.awt.Dimension;
/*     */ import java.awt.Graphics;
/*     */ import java.awt.Graphics2D;
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.Shape;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.awt.print.PageFormat;
/*     */ import java.awt.print.Printable;
/*     */ import javax.swing.JEditorPane;
/*     */ import javax.swing.plaf.TextUI;
/*     */ import javax.swing.text.Document;
/*     */ import javax.swing.text.View;
/*     */ import javax.swing.text.html.HTMLDocument;
/*     */ 
/*     */ public final class PrintableDocument
/*     */   implements Printable
/*     */ {
/*  34 */   private int _currentPage = -1;
/*     */ 
/*  40 */   private final JEditorPane _jeditorPane = new JEditorPane();
/*     */ 
/*  45 */   private double _pageEndY = 0.0D;
/*     */ 
/*  50 */   private double _pageStartY = 0.0D;
/*     */ 
/*  56 */   private boolean _scaleWidthToFit = true;
/*     */ 
/*     */   public PrintableDocument(HTMLDocument htmlDocument)
/*     */   {
/*  62 */     this("text/html", htmlDocument);
/*     */   }
/*     */ 
/*     */   private PrintableDocument(String paramString, Document paramDocument)
/*     */   {
/*  87 */     if ((paramString == null) || (paramString.equals(""))) {
/*  88 */       throw new IllegalArgumentException("Mime type can't be null!");
/*     */     }
/*  90 */     if (paramDocument == null) {
/*  91 */       throw new IllegalArgumentException("Document can't be null!");
/*     */     }
/*  93 */     String str = paramString; paramString = this; this._jeditorPane.setContentType(str);
/*  94 */     this._jeditorPane.setDocument(paramDocument);
/*     */   }
/*     */ 
/*     */   public final int print(Graphics paramGraphics, PageFormat paramPageFormat, int paramInt)
/*     */   {
/* 157 */     double d = 1.0D;
/*     */ 
/* 161 */     paramGraphics = (Graphics2D)paramGraphics;
/*     */ 
/* 163 */     this._jeditorPane.setSize((int)paramPageFormat.getImageableWidth(), 2147483647);
/*     */ 
/* 165 */     this._jeditorPane.validate();
/*     */ 
/* 167 */     View localView = this._jeditorPane.getUI().getRootView(this._jeditorPane);
/*     */ 
/* 169 */     if ((this._scaleWidthToFit) && (this._jeditorPane.getMinimumSize().getWidth() > paramPageFormat.getImageableWidth()))
/*     */     {
/* 172 */       d = paramPageFormat.getImageableWidth() / this._jeditorPane.getMinimumSize().getWidth();
/*     */ 
/* 175 */       paramGraphics.scale(d, d);
/*     */     }
/*     */ 
/* 178 */     paramGraphics.setClip((int)(paramPageFormat.getImageableX() / d), (int)(paramPageFormat.getImageableY() / d), (int)(paramPageFormat.getImageableWidth() / d), (int)(paramPageFormat.getImageableHeight() / d));
/*     */ 
/* 183 */     if (paramInt > this._currentPage) {
/* 184 */       this._currentPage = paramInt;
/* 185 */       this._pageStartY += this._pageEndY;
/* 186 */       this._pageEndY = paramGraphics.getClipBounds().getHeight();
/*     */     }
/*     */ 
/* 189 */     paramGraphics.translate(paramGraphics.getClipBounds().getX(), paramGraphics.getClipBounds().getY());
/*     */ 
/* 192 */     paramPageFormat = new Rectangle(0, (int)(-this._pageStartY), (int)this._jeditorPane.getMinimumSize().getWidth(), (int)this._jeditorPane.getPreferredSize().getHeight());
/*     */ 
/* 197 */     if (printView(paramGraphics, paramPageFormat, localView)) {
/* 198 */       return 0;
/*     */     }
/* 200 */     this._pageStartY = 0.0D;
/* 201 */     this._pageEndY = 0.0D;
/* 202 */     this._currentPage = -1;
/* 203 */     return 1;
/*     */   }
/*     */ 
/*     */   private boolean printView(Graphics2D paramGraphics2D, Shape paramShape, View paramView)
/*     */   {
/* 232 */     int i = 0;
/* 233 */     Object localObject = paramGraphics2D.getClipBounds();
/*     */     boolean bool;
/* 237 */     if (paramView.getViewCount() > 0) {
/* 238 */       for (int j = 0; j < paramView.getViewCount(); j++)
/*     */       {
/* 240 */         if ((
/* 240 */           localObject = paramView.getChildAllocation(j, paramShape)) != null)
/*     */         {
/* 241 */           View localView = paramView.getView(j);
/* 242 */           bool = printView(paramGraphics2D, (Shape)localObject, localView);
/*     */         }
/*     */ 
/*     */       }
/*     */ 
/*     */     }
/* 248 */     else if (paramShape.getBounds().getMaxY() >= ((Rectangle)localObject).getY()) {
/* 249 */       bool = true;
/*     */ 
/* 251 */       if ((paramShape.getBounds().getHeight() > ((Rectangle)localObject).getHeight()) && (paramShape.intersects((Rectangle2D)localObject)))
/*     */       {
/* 254 */         paramView.paint(paramGraphics2D, paramShape);
/*     */       }
/* 257 */       else if (paramShape.getBounds().getY() >= ((Rectangle)localObject).getY())
/*     */       {
/* 259 */         if (paramShape.getBounds().getMaxY() <= ((Rectangle)localObject).getMaxY())
/*     */         {
/* 261 */           paramView.paint(paramGraphics2D, paramShape);
/*     */         }
/* 264 */         else if (paramShape.getBounds().getY() < this._pageEndY) {
/* 265 */           this._pageEndY = paramShape.getBounds().getY();
/*     */         }
/*     */ 
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 272 */     return bool;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.print.PrintableDocument
 * JD-Core Version:    0.6.0
 */