/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import com.scytl.ResourceCustomizer;
/*     */ import com.scytl.authentication.AuthenticationParametersTransform;
/*     */ import com.scytl.authentication.type.TransformType;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.messages.LocalizedBallotSummary;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Properties;
/*     */ import org.apache.commons.io.IOUtils;
/*     */ import org.apache.commons.lang.SystemUtils;
/*     */ 
/*     */ public class AppletProperties
/*     */ {
/*     */   public static final String ADVANCED_CERTIFICATE_ALLOWED = "advanced.certificate.allowed";
/*     */   public static final String RECOGNIZED_CERTIFICATE_ALLOWED = "recognized.certificate.allowed";
/*     */   public static final String DEFAULT_CERTIFICATE_TAB = "default.certificate.tab";
/*     */   public static final String BALLOT_SERIALIZER_CLASS = "ballot_serializer_class";
/*     */   public static final String LOGIN_TRANSFORM_CLASS = "login_transform_class";
/*     */   public static final String ADVANCED_CERTIFICATE = "advanced";
/*     */   public static final String RECOGNIZED_CERTIFICATE = "recognized";
/*     */   public static final String TAB_SEPARATOR = "-";
/*     */   public static final String PROPERTY_FALSE = "false";
/*  57 */   private List<String> _tabsSorted = null;
/*     */   private final Properties _properties;
/*     */   private final ResourceCustomizer _resourceCustomizer;
/*     */   private final String _transformType;
/*     */ 
/*     */   public AppletProperties(String paramString1, String paramString2, String paramString3)
/*     */   {
/*  70 */     this._resourceCustomizer = new ResourceCustomizer(paramString2);
/*  71 */     this._tabsSorted = validateTabNames(paramString1);
/*  72 */     paramString1 = loadProperties("/applet-config.properties");
/*  73 */     if ((this._tabsSorted != null) && (!this._tabsSorted.isEmpty())) {
/*  74 */       updateTabParameterProperties(paramString1);
/*     */     }
/*  76 */     this._properties = paramString1;
/*  77 */     this._transformType = paramString3;
/*     */   }
/*     */ 
/*     */   public void updateTabParameterProperties(Properties paramProperties)
/*     */   {
/*     */     Object localObject;
/*  86 */     (localObject = paramProperties).put("advanced.certificate.allowed", "false"); ((Properties)localObject).put("recognized.certificate.allowed", "false");
/*     */ 
/*  88 */     this = getTabsSorted().iterator();
/*  89 */     while (hasNext())
/*     */     {
/*  91 */       localObject = (String)next();
/*  92 */       boolean bool2 = "advanced".equals(localObject);
/*  93 */       boolean bool1 = "recognized".equals(localObject);
/*  94 */       if (bool2) {
/*  95 */         paramProperties.put("advanced.certificate.allowed", String.valueOf(bool2));
/*     */       }
/*     */ 
/*  98 */       if (bool1)
/*  99 */         paramProperties.put("recognized.certificate.allowed", String.valueOf(bool1));
/*     */     }
/*     */   }
/*     */ 
/*     */   private Properties loadProperties(String paramString)
/*     */   {
/* 116 */     Properties localProperties = new Properties();
/* 117 */     InputStream localInputStream = null;
/*     */     try {
/* 119 */       paramString = this._resourceCustomizer.getPathToUse(paramString); this = this; localInputStream = (InputStream)AccessController.doPrivileged(new PrivilegedAction(paramString)
/*     */       {
/*     */         public InputStream run()
/*     */         {
/* 169 */           return getClass().getResourceAsStream(this.val$fileName);
/*     */         }
/*     */       });
/* 122 */       localProperties.load(localInputStream);
/* 123 */       this = localProperties;
/*     */       return this;
/*     */     }
/*     */     catch (IOException localIOException)
/*     */     {
/* 125 */       throw new RuntimeException("Missing required configuration file");
/*     */     }
/*     */     finally {
/* 128 */       IOUtils.closeQuietly(localInputStream); } throw this;
/*     */   }
/*     */ 
/*     */   private static List<String> validateTabNames(String paramString)
/*     */   {
/* 140 */     ArrayList localArrayList = null;
/*     */ 
/* 142 */     if (paramString != null)
/*     */     {
/* 146 */       paramString = (
/* 146 */         localArrayList = new ArrayList(Arrays.asList(paramString.split("-"))))
/* 146 */         .iterator();
/*     */ 
/* 148 */       while (paramString.hasNext())
/*     */       {
/* 150 */         String str = (String)paramString.next();
/* 151 */         if (("advanced".equals(str)) || ("recognized".equals(str)))
/*     */           continue;
/* 153 */         paramString.remove();
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/* 158 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public boolean isAdvancedCertificateAllowed()
/*     */   {
/* 175 */     return isCertificateAllowed("advanced.certificate.allowed");
/*     */   }
/*     */ 
/*     */   public boolean isRecognizedCertificateAllowed() {
/* 179 */     return (isCertificateAllowed("recognized.certificate.allowed")) && (SystemUtils.isJavaVersionAtLeast(150));
/*     */   }
/*     */ 
/*     */   public boolean isCertificateAllowed(String type)
/*     */   {
/*     */     String type;
/* 187 */     return ((
/* 186 */       value = (String)this._properties.get(type)) != null) && 
/* 186 */       (Boolean.valueOf(value).booleanValue());
/*     */   }
/*     */ 
/*     */   public int getDefaultCertificateTab()
/*     */   {
/* 201 */     String value = (String)this._properties.get("default.certificate.tab");
/* 202 */     int preference = 0;
/* 203 */     if (value != null) {
/* 204 */       preference = Integer.valueOf(value).intValue();
/*     */     }
/* 206 */     if ((this._tabsSorted != null) && (this._tabsSorted.size() <= preference)) {
/* 207 */       preference = 0;
/*     */     }
/* 209 */     return preference;
/*     */   }
/*     */ 
/*     */   public List<String> getTabsSorted()
/*     */   {
/* 216 */     return this._tabsSorted;
/*     */   }
/*     */ 
/*     */   public AuthenticationParametersTransform getAuthenticationParametersTransform()
/*     */   {
/* 252 */     Object localObject1 = null;
/*     */     try {
/* 254 */       localObject1 = this; Object localObject2 = null; if (((AppletProperties)localObject1)._transformType != null) localObject2 = TransformType.getTransformInstance(((AppletProperties)localObject1)._transformType);
/* 255 */       if ((
/* 255 */         localObject1 = localObject2) == null)
/*     */       {
/* 256 */         localObject1 = this; localObject1 = (AuthenticationParametersTransform)(this = (this = Class.forName(localObject2 = this._properties.getProperty("login_transform_class"))).getConstructor(new Class[0])).newInstance(new Object[0]);
/*     */       }
/*     */     } catch (java.lang.Exception this) {
/* 259 */       throw new RuntimeException("Reflection exception", this);
/*     */     }
/*     */ 
/* 262 */     return (AuthenticationParametersTransform)(AuthenticationParametersTransform)localObject1;
/*     */   }
/*     */ 
/*     */   public LocalizedBallotSummary getLocalizedBallotSummary(Ballot paramBallot)
/*     */   {
/* 267 */     this = this._properties.getProperty("ballot_serializer_class");
/*     */     try
/*     */     {
/* 273 */       return (LocalizedBallotSummary)(
/* 273 */         this = (
/* 271 */         this = Class.forName(this))
/* 271 */         .getConstructor(new Class[] { Ballot.class }))
/* 273 */         .newInstance(new Object[] { paramBallot });
/*     */     } catch (java.lang.Exception this) {
/*     */     }
/* 276 */     throw new RuntimeException("Reflection exception", this);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.AppletProperties
 * JD-Core Version:    0.6.0
 */