/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import com.scytl.AbstractLocalizableException;
/*     */ import com.scytl.common.domain.MessageType;
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.url.UrlHelper;
/*     */ import com.scytl.pnyx.client.VoteReceipt;
/*     */ import com.scytl.pnyx.client.communication.application.ApplicationProtocolException;
/*     */ import com.scytl.pnyx.client.communication.connector.PostCallback;
/*     */ import com.scytl.pnyx.client.communication.transport.PnyxHTTPDestination;
/*     */ import com.scytl.pnyx.protocol.PnyxProtocolException;
/*     */ import java.applet.AppletContext;
/*     */ import java.net.URL;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Enumeration;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.bouncycastle.asn1.util.ASN1Dump;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ 
/*     */ public class AppletWithNewPortalCallback
/*     */   implements PostCallback
/*     */ {
/*  46 */   private static Log _logger = LogFactory.getLog(AppletWithNewPortalCallback.class);
/*     */   private final AppletContext _appletContext;
/*     */   private final String _chooseElectionAction;
/*     */   private final String _votingAction;
/*     */   private final String _friendlyErrorPage;
/*     */   private final Map<String, String> _initialAppletParameters;
/*  77 */   private final List<AfterLoginHandler> _afterLoginHandlers = new ArrayList();
/*     */ 
/*     */   public AppletWithNewPortalCallback(AppletContext paramAppletContext, PnyxHTTPDestination paramPnyxHTTPDestination)
/*     */     throws Exception
/*     */   {
/*  82 */     this._appletContext = paramAppletContext;
/*     */ 
/*  84 */     paramPnyxHTTPDestination.getLoginAction().toString();
/*  85 */     this._chooseElectionAction = paramPnyxHTTPDestination.getChooseElectionAction().toString();
/*     */ 
/*  87 */     this._votingAction = paramPnyxHTTPDestination.getVotingAction().toString();
/*  88 */     paramPnyxHTTPDestination.getThankYouPage().toString();
/*  89 */     this._friendlyErrorPage = paramPnyxHTTPDestination.getFriendlyErrorPage().toString();
/*     */ 
/*  91 */     this._initialAppletParameters = new HashMap(getApplet().getPnyxParameters());
/*     */   }
/*     */ 
/*     */   public void afterLogin$7c600462(ComponentMonitor token)
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/*     */     ComponentMonitor token;
/* 101 */     if ((token.getElectionId() == null) || (token.getElectionId().length() == 0) || (token.getElectionId().equals("null")))
/*     */     {
/* 104 */       chooseElection$7c600462(token);
/*     */     }
/* 106 */     for (this = this._afterLoginHandlers.iterator(); i$.hasNext(); )
/*     */     {
/*     */       AfterLoginHandler alh;
/* 106 */       (
/* 107 */         alh = (AfterLoginHandler)i$.next())
/* 107 */         .doAfterLogin$7c600462(token);
/*     */     }
/*     */   }
/*     */ 
/*     */   private void chooseElection$7c600462(ComponentMonitor paramComponentMonitor)
/*     */   {
/* 113 */     this._initialAppletParameters.put("j_username", paramComponentMonitor.getUsername());
/*     */ 
/* 115 */     showDocument(buildUrlWithTokenAndLanguage$6bebe3da(this._chooseElectionAction, paramComponentMonitor, null), "browser");
/*     */   }
/*     */ 
/*     */   private URL buildUrlWithTokenAndLanguage$6bebe3da(String paramString, ComponentMonitor paramComponentMonitor, MessageType paramMessageType)
/*     */   {
/*     */     HashMap localHashMap;
/* 122 */     (
/* 123 */       localHashMap = new HashMap())
/* 123 */       .put("token", paramComponentMonitor.serializeAsURLParameter());
/*     */ 
/* 125 */     localHashMap.put("siteLanguage", getApplet().getLocale().getLanguage());
/*     */ 
/* 127 */     localHashMap.put("messageType", paramMessageType == null ? MessageType.VOTE.name() : paramMessageType.name());
/*     */ 
/* 131 */     if (this._initialAppletParameters.containsKey("institutionId"))
/*     */     {
/* 133 */       localHashMap.put("institutionId", this._initialAppletParameters.get("institutionId"));
/*     */     }
/*     */ 
/* 136 */     return UrlHelper.encodeURL(paramString, localHashMap);
/*     */   }
/*     */ 
/*     */   public void afterDiscardElection$3ceab681(URL paramURL, ComponentMonitor paramComponentMonitor)
/*     */   {
/* 141 */     if (this._initialAppletParameters.containsKey("electionId"))
/*     */     {
/* 143 */       afterLogout(paramURL); return;
/*     */     }
/* 145 */     if (paramURL == null) {
/* 146 */       chooseElection$7c600462(paramComponentMonitor); return;
/*     */     }
/* 148 */     showDocument(clientLogoutUrl(paramURL), "_top");
/*     */   }
/*     */ 
/*     */   private URL clientLogoutUrl(URL paramURL)
/*     */   {
/*     */     HashMap localHashMap;
/* 155 */     (
/* 156 */       localHashMap = new HashMap())
/* 156 */       .put("spring-security-redirect", paramURL.toString());
/* 157 */     return UrlHelper.encodeURL(UrlHelper.getStringURL(getApplet().getCodeBase().toString() + "client_logout", null), localHashMap);
/*     */   }
/*     */ 
/*     */   public void displayFriendlyException$75168644(AbstractLocalizableException paramAbstractLocalizableException, ASN1Dump paramASN1Dump, Locale paramLocale)
/*     */   {
/*     */     HashMap localHashMap;
/* 165 */     (
/* 166 */       localHashMap = new HashMap())
/* 166 */       .put("errorMessage", paramAbstractLocalizableException.getLocalizedMessage$3aaec62c(paramASN1Dump, paramLocale));
/*     */ 
/* 168 */     showDocument(UrlHelper.encodeURL(this._friendlyErrorPage, localHashMap), "browser");
/*     */   }
/*     */ 
/*     */   public void afterLogout(URL afterLogoutURL)
/*     */   {
/* 176 */     afterLogoutURL = afterLogoutURL == null ? getApplet().getParentURL() : afterLogoutURL;
/*     */     URL finalURL;
/* 179 */     showDocument(clientLogoutUrl(afterLogoutURL), "_top");
/*     */   }
/*     */ 
/*     */   public void afterProduceBallot$56546152(ComponentMonitor paramComponentMonitor, Ballot paramBallot, MessageType paramMessageType)
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/* 189 */     paramComponentMonitor = buildUrlWithTokenAndLanguage$6bebe3da(this._votingAction, paramComponentMonitor, paramMessageType);
/*     */ 
/* 191 */     getApplet().setBallot(paramBallot);
/* 192 */     showDocument(paramComponentMonitor, "browser");
/*     */   }
/*     */ 
/*     */   public void displayReceipt(VoteReceipt receipt, String username, String institution, String electionEventId, String electionid)
/*     */   {
/* 202 */     getApplet().doScript("browser", "clearVote", new String[0]);
/* 203 */     getApplet().showReceipt(receipt);
/*     */   }
/*     */ 
/*     */   public void validateVoteSummary(Ballot ballot)
/*     */   {
/* 210 */     getApplet().confirmVote(ballot);
/*     */   }
/*     */ 
/*     */   private void showDocument(URL where, String target)
/*     */   {
/* 219 */     _logger.debug("Redirecting " + target + " frame to :: " + where);
/* 220 */     this._appletContext.showDocument(where, target);
/*     */   }
/*     */ 
/*     */   private PnyxClientApplet getApplet() {
/* 224 */     return (PnyxClientApplet)this._appletContext.getApplets().nextElement();
/*     */   }
/*     */ 
/*     */   public void beforeCastVote(String username, String institution, String electionEventId, String electionid)
/*     */   {
/*     */   }
/*     */ 
/*     */   public void beforeDiscardVote(String username, String electionname)
/*     */   {
/*     */   }
/*     */ 
/*     */   public void afterPickElection(String username, String institution, String electionEventId, String electionId)
/*     */   {
/*     */   }
/*     */ 
/*     */   public void beforeLogin(String username, String institutionId, String electionEventId, String electionId)
/*     */     throws PnyxProtocolException, ApplicationProtocolException
/*     */   {
/*     */   }
/*     */ 
/*     */   public void addCustomAfterLoginHandler(AfterLoginHandler paramAfterLoginHandler)
/*     */   {
/* 271 */     this._afterLoginHandlers.add(paramAfterLoginHandler);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.AppletWithNewPortalCallback
 * JD-Core Version:    0.6.0
 */