/*    */ package com.scytl.voting.applet;
/*    */ 
/*    */ import java.lang.reflect.Constructor;
/*    */ import java.security.KeyStore;
/*    */ import java.security.cert.Certificate;
/*    */ import java.util.Map;
/*    */ import org.apache.commons.lang.SystemUtils;
/*    */ import org.apache.commons.logging.Log;
/*    */ import org.apache.commons.logging.LogFactory;
/*    */ 
/*    */ public final class KeystoreHolder
/*    */ {
/* 27 */   private static Log _logger = LogFactory.getLog(KeystoreHolder.class);
/*    */ 
/* 29 */   private static final KeystoreHolder INSTANCE = new KeystoreHolder();
/*    */   private final KeyStoreHolderStrategy _strategy;
/*    */ 
/*    */   private KeystoreHolder()
/*    */   {
/*    */     Object localObject;
/* 35 */     if ((SystemUtils.IS_OS_WINDOWS) && (SystemUtils.isJavaVersionAtLeast(150)) && (KeystoreHolder.class.getResourceAsStream("/be/cardon/utils/cryptoapi4java.dll") != null))
/*    */     {
/* 39 */       localObject = "com.scytl.voting.applet.MSCardonKeyStoreStrategy";
/*    */     }
/* 41 */     else if ((SystemUtils.IS_OS_WINDOWS) && (SystemUtils.isJavaVersionAtLeast(160)))
/*    */     {
/* 43 */       localObject = "com.scytl.voting.applet.MSCAPIKeystoreStrategy";
/*    */     }
/*    */     else {
/* 46 */       localObject = "com.scytl.voting.applet.PKCS11KeyStoreStrategy";
/*    */     }
/*    */ 
/*    */     try
/*    */     {
/* 53 */       localObject = (
/* 53 */         localObject = Class.forName((String)localObject).asSubclass(KeyStoreHolderStrategy.class))
/* 53 */         .getConstructor(new Class[0]);
/*    */ 
/* 55 */       this._strategy = ((KeyStoreHolderStrategy)((Constructor)localObject).newInstance(new Object[0]));
/*    */ 
/* 58 */       return;
/*    */     }
/*    */     catch (Exception localException)
/*    */     {
/*    */     }
/* 57 */     throw new RuntimeException("Reflection exception", localException);
/*    */   }
/*    */ 
/*    */   public static KeystoreHolder getInstance()
/*    */   {
/* 62 */     return INSTANCE;
/*    */   }
/*    */ 
/*    */   public final KeyStore loadKeyStore() {
/* 66 */     return this._strategy.loadKeyStore();
/*    */   }
/*    */ 
/*    */   public final Map<String, Certificate> getUserCertificates()
/*    */   {
/* 73 */     return this._strategy.getUserCertificates();
/*    */   }
/*    */ 
/*    */   public final KeyStore getKeyStore()
/*    */   {
/* 80 */     _logger.debug("getKeystore");
/* 81 */     return this._strategy.getKeystore();
/*    */   }
/*    */ 
/*    */   public final void resetKeystore() {
/* 85 */     _logger.debug("resetKeystore");
/* 86 */     this._strategy.resetKeyStore();
/*    */   }
/*    */ 
/*    */   public final boolean isDone()
/*    */   {
/* 93 */     return this._strategy.isDone();
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.KeystoreHolder
 * JD-Core Version:    0.6.0
 */