/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.Properties;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class LanguageParameterProperties
/*     */ {
/*  25 */   private static final Log LOGGER = LogFactory.getLog(LanguageParameterProperties.class);
/*     */ 
/*  28 */   private Properties _customerProperties = null;
/*     */   public static final String DEFAULT_LANG = "language.default";
/*     */   public static final String SUPPORTED_LANG = "language.supported";
/*     */   public static final String PROPERTY_SEPARATOR = ",";
/*     */ 
/*     */   public Properties loadLangParameterProperties(String options)
/*     */   {
/*  43 */     LOGGER.debug("Load lang options : " + options);
/*  44 */     Properties langProperties = new Properties();
/*     */     List langOptions;
/*  46 */     if (((
/*  46 */       langOptions = setValidLangParameter(options)) != null) && 
/*  46 */       (!options.isEmpty())) {
/*  47 */       setDefaultProperties(langProperties, options);
/*  48 */       setSupportedProperties(langProperties, options);
/*     */     } else {
/*  50 */       langProperties = this._customerProperties;
/*     */     }
/*  52 */     return langProperties;
/*     */   }
/*     */ 
/*     */   public void setSupportedProperties(Properties paramProperties, List<String> paramList)
/*     */   {
/*  63 */     this = new StringBuffer();
/*  64 */     for (int i = 1; i < paramList.size(); i++) {
/*  65 */       append(((String)paramList.get(i)).toLowerCase()).append(",");
/*     */     }
/*     */ 
/*  68 */     if (length() > 0)
/*  69 */       paramProperties.put("language.supported", substring(0, length() - 1));
/*     */   }
/*     */ 
/*     */   public void setDefaultProperties(Properties paramProperties, List<String> paramList)
/*     */   {
/*  82 */     this = (String)paramList.get(0);
/*  83 */     paramProperties.put("language.default", toLowerCase());
/*     */   }
/*     */ 
/*     */   private List<String> readLanguagesFromCustomerProperties()
/*     */   {
/*  93 */     String str = (String)this._customerProperties.get("language.default");
/*     */ 
/*  95 */     this = (String)this._customerProperties.get("language.supported");
/*     */     ArrayList localArrayList;
/*  98 */     (
/*  99 */       localArrayList = new ArrayList())
/*  99 */       .add(str.trim().toUpperCase());
/* 100 */     this = split(",");
/* 101 */     for (int i = 0; i < this.length; i++) {
/* 102 */       localArrayList.add(this[i].trim().toUpperCase());
/*     */     }
/* 104 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public List<String> setValidLangParameter(String paramString)
/*     */   {
/* 114 */     ArrayList localArrayList = null;
/*     */ 
/* 116 */     if ((paramString != null) && (!paramString.equals(""))) {
/* 117 */       localArrayList = new ArrayList();
/*     */ 
/* 119 */       paramString = paramString.split("-");
/* 120 */       for (int i = 0; i < paramString.length; i++) {
/* 121 */         if (!readLanguagesFromCustomerProperties().contains(paramString[i]))
/*     */           continue;
/* 123 */         localArrayList.add(paramString[i]);
/*     */       }
/*     */     }
/*     */ 
/* 127 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   public void setCustomerProperties(Properties customerProperties)
/*     */   {
/* 135 */     this._customerProperties = customerProperties;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.LanguageParameterProperties
 * JD-Core Version:    0.6.0
 */