/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import com.scytl.voting.applet.view.thinlet.PKCS11Password;
/*     */ import java.io.InputStream;
/*     */ import java.security.AuthProvider;
/*     */ import java.security.KeyStore;
/*     */ import java.security.KeyStore.Builder;
/*     */ import java.security.KeyStore.CallbackHandlerProtection;
/*     */ import java.security.KeyStore.ProtectionParameter;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.Provider;
/*     */ import java.security.ProviderException;
/*     */ import java.security.Security;
/*     */ import java.util.Enumeration;
/*     */ import javax.security.auth.login.LoginException;
/*     */ import org.apache.commons.io.IOUtils;
/*     */ import org.apache.commons.lang.SystemUtils;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import sun.security.pkcs11.SunPKCS11;
/*     */ 
/*     */ public class PKCS11KeyStoreStrategy extends AbstractKeyStoreStrategy
/*     */ {
/*  49 */   private static Log _logger = LogFactory.getLog(PKCS11KeyStoreStrategy.class);
/*     */   private static KeyStore _keystore;
/*  59 */   private static final String[][] PKCS11_CONFIGURATIONS_WIN = { { "safesign", "C:/WINDOWS/system32/aetpkss1.dll" }, { "gemalto", "C:/Program Files/Gemalto/Classic Client/BIN/GCLIB.DLL" }, { "dnie", "C:/WINDOWS/system32/UsrPkcs11.dll" } };
/*     */ 
/*  66 */   private static final String[][] PKCS11_CONFIGURATIONS_LINUX = { { "gemalto", "/usr/lib/ClassicClient/libgclib.so" }, { "dnie", "/usr/lib/opensc-pkcs11.so" }, { "safesign", "/usr/lib/libaetpkss.so" } };
/*     */ 
/*  74 */   private static final String[][] PKCS11_CONFIGURATIONS_MACOSX = { { "dnie", "/Library/OpenSC/lib/opensc-pkcs11.so" }, { "safesign", "/usr/local/lib/libaetpkss.dylib" } };
/*     */ 
/*     */   public KeyStore loadKeyStore()
/*     */   {
/*  83 */     resetKeyStore();
/*  84 */     this = null;
/*  85 */     while (this == null) {
/*  86 */       PKCS11Password localPKCS11Password = new PKCS11Password();
/*     */       Provider localProvider;
/*  88 */       if ((
/*  88 */         localProvider = waitForToken()) == null)
/*     */         break;
/*  89 */       Security.addProvider(localProvider);
/*     */       try
/*     */       {
/*  93 */         this = loginToken(localPKCS11Password);
/*  94 */         if (localPKCS11Password.isCancelled())
/*  95 */           return this;
/*     */       }
/*     */       catch (NullPointerException localNullPointerException) {
/*  98 */         this = null;
/*     */       }
/*     */     }
/* 101 */     _keystore = this;
/* 102 */     return this;
/*     */   }
/*     */ 
/*     */   private static synchronized Provider waitForToken()
/*     */   {
/*     */     Object localObject1;
/* 107 */     if (SystemUtils.IS_OS_WINDOWS)
/*     */     {
/* 109 */       localObject1 = PKCS11_CONFIGURATIONS_WIN;
/* 110 */     } else if (SystemUtils.IS_OS_LINUX)
/* 111 */       localObject1 = PKCS11_CONFIGURATIONS_LINUX;
/* 112 */     else if (SystemUtils.IS_OS_MAC_OSX)
/* 113 */       localObject1 = PKCS11_CONFIGURATIONS_MACOSX;
/*     */     else {
/* 115 */       localObject1 = new String[0][];
/*     */     }
/* 117 */     SunPKCS11 localSunPKCS11 = null;
/* 118 */     int i = 0;
/* 119 */     while ((localSunPKCS11 == null) && (i != 1)) {
/* 120 */       Object localObject3 = localObject1; int j = localObject1.length; for (int k = 0; k < j; k++)
/*     */       {
/*     */         Object localObject4;
/* 121 */         Object localObject6 = localObject4[1]; Object localObject5 = (
/* 121 */           localObject4 = localObject3[k])[
/* 121 */           0]; localObject5 = IOUtils.toInputStream("name = ${name_placeholder}\nlibrary = ${library_placeholder}\nslotListIndex = 0\nshowInfo = true\ninsertionCheckInterval = 100\n".replace("${name_placeholder}", (CharSequence)localObject5).replace("${library_placeholder}", (CharSequence)localObject6));
/*     */         try
/*     */         {
/* 125 */           localSunPKCS11 = new SunPKCS11((InputStream)localObject5);
/*     */ 
/* 127 */           _logger.info(localSunPKCS11.getName());
/* 128 */           _logger.info(Double.valueOf(localSunPKCS11.getVersion()));
/* 129 */           _logger.info(localSunPKCS11.getInfo());
/* 130 */           localObject6 = localSunPKCS11;
/*     */           return localObject6;
/*     */         }
/*     */         catch (ProviderException localProviderException)
/*     */         {
/* 132 */           _logger.info("Cannot use configuration :: " + localObject4);
/* 133 */           _logger.error("Cannot access to the user keystore.", localProviderException);
/*     */         } finally {
/* 135 */           IOUtils.closeQuietly((InputStream)localObject5);
/*     */         }
/*     */       }
/* 138 */       if (localSunPKCS11 == null) {
/* 139 */         i = PKCS11Password.waitForTokenOptionPane();
/*     */       }
/*     */     }
/* 142 */     return (Provider)(Provider)(Provider)localSunPKCS11;
/*     */   }
/*     */ 
/*     */   private static synchronized KeyStore loginToken(PKCS11Password pkcs11Password)
/*     */   {
/* 153 */     KeyStore.ProtectionParameter pp = new KeyStore.CallbackHandlerProtection(pkcs11Password);
/*     */ 
/* 155 */     KeyStore.Builder builder = KeyStore.Builder.newInstance("PKCS11", null, pp);
/*     */ 
/* 157 */     while (!pkcs11Password.isCancelled()) {
/*     */       try {
/* 159 */         return builder.getKeyStore();
/*     */       } catch (KeyStoreException kse) {
/* 161 */         pkcs11Password.setLastError(kse);
/* 162 */         _logger.error("Cannot access to the user keystore.", kse);
/*     */       }
/*     */     }
/* 165 */     return null;
/*     */   }
/*     */ 
/*     */   public KeyStore getKeystore()
/*     */   {
/*     */     try
/*     */     {
/* 174 */       if ((_keystore == null) || (!_keystore.aliases().hasMoreElements()))
/*     */       {
/* 176 */         loadKeyStore();
/*     */       }
/*     */     } catch (KeyStoreException localKeyStoreException) {
/* 179 */       loadKeyStore();
/*     */     }
/* 181 */     return _keystore;
/*     */   }
/*     */ 
/*     */   public boolean isDone()
/*     */   {
/* 189 */     return _keystore != null;
/*     */   }
/*     */ 
/*     */   public void resetKeyStore()
/*     */   {
/* 199 */     super.resetKeyStore();
/* 200 */     if (_keystore != null)
/*     */     {
/*     */       Provider provider;
/* 202 */       if ((
/* 202 */         provider = _keystore.getProvider()) != null)
/*     */       {
/* 203 */         Security.removeProvider(getName());
/* 204 */         this = (AuthProvider)this;
/*     */         try
/*     */         {
/*     */           AuthProvider authProvider;
/* 206 */           authProvider.logout();
/*     */         }
/*     */         catch (LoginException le)
/*     */         {
/*     */           LoginException le;
/* 208 */           _logger.warn("Error logging out of AuthProvider", this);
/*     */         }
/*     */         catch (ProviderException pe)
/*     */         {
/*     */           ProviderException pe;
/* 210 */           _logger.warn("No token", this);
/*     */         }
/*     */       }
/* 213 */       _keystore = null;
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.PKCS11KeyStoreStrategy
 * JD-Core Version:    0.6.0
 */