/*     */ package com.scytl.voting.applet;
/*     */ 
/*     */ import com.scytl.ExtendedThinlet;
/*     */ import com.scytl.ExtendedThinlet<Lcom.scytl.voting.applet.PnyxClientApplet;>;
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.crypto.CryptographicFormats;
/*     */ import com.scytl.customer.CustomerProperties;
/*     */ import com.scytl.internationalization.LocaleProvider;
/*     */ import com.scytl.pnyx.client.communication.application.MessagesProtocol;
/*     */ import com.scytl.pnyx.client.communication.connector.PostCallback;
/*     */ import com.scytl.pnyx.client.communication.connector.ProtocolConnectorDelegator;
/*     */ import com.scytl.pnyx.client.communication.transport.AppletDestination;
/*     */ import com.scytl.pnyx.client.communication.transport.HTTPPostTransport;
/*     */ import com.scytl.pnyx.client.communication.transport.PnyxHTTPDestination;
/*     */ import com.scytl.pnyx.client.state.automaton.PnyxClientStateMachine;
/*     */ import com.scytl.voting.applet.view.thinlet.AlternateReceipt;
/*     */ import com.scytl.voting.applet.view.thinlet.ChooseRecognizedCertificate;
/*     */ import com.scytl.voting.applet.view.thinlet.ConfirmVote;
/*     */ import com.scytl.voting.applet.view.thinlet.Login;
/*     */ import com.scytl.voting.applet.view.thinlet.Receipt;
/*     */ import com.scytl.voting.applet.view.thinlet.VoteValidation;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.bouncycastle.asn1.util.ASN1Dump;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.picocontainer.PicoContainer;
/*     */ import org.picocontainer.alternatives.CachingPicoContainer;
/*     */ import org.picocontainer.defaults.ConstantParameter;
/*     */ 
/*     */ public class VotingAppletContext
/*     */ {
/*  47 */   private static Log _logger = LogFactory.getLog(VotingAppletContext.class);
/*     */   private PicoContainer _container;
/*     */   private final PnyxClientApplet _applet;
/*     */   private final ASN1Dump _messageSource$6b7050de;
/*     */ 
/*     */   public void init()
/*     */   {
/*     */     CachingPicoContainer localCachingPicoContainer;
/*  63 */     (
/*  66 */       localCachingPicoContainer = new CachingPicoContainer())
/*  66 */       .registerComponentImplementation$7caf752d(CryptographicAlgorithms.class);
/*     */ 
/*  68 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(CryptographicFormats.class);
/*     */ 
/*  72 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(PnyxClientStateMachine.class);
/*     */ 
/*  74 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(ProtocolConnectorDelegator.class);
/*     */ 
/*  76 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(MessagesProtocol.class);
/*     */ 
/*  78 */     Object localObject = new PnyxHTTPDestination(this._applet.getCodeBase());
/*     */ 
/*  80 */     localCachingPicoContainer.registerComponentInstance$c7595c8(AppletDestination.class, localObject);
/*     */ 
/*  82 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(HTTPPostTransport.class);
/*     */ 
/*  85 */     localCachingPicoContainer.registerComponentImplementation$7caf752d(AppletWithNewPortalCallback.class);
/*     */ 
/*  87 */     localCachingPicoContainer.registerComponentInstance$506b371c(this._applet.getAppletContext());
/*     */ 
/*  90 */     localObject = this._applet.getParameter("customer");
/*  91 */     String str = this._applet.getParameter("transformType");
/*     */     LanguageParameterProperties localLanguageParameterProperties;
/*  94 */     (
/*  96 */       localLanguageParameterProperties = new LanguageParameterProperties())
/*  96 */       .setCustomerProperties(CustomerProperties.loadCustomerProperties((String)localObject));
/*     */ 
/*  98 */     localCachingPicoContainer.registerComponentInstance$c7595c8(LocaleProvider.class, new LocaleProvider(localLanguageParameterProperties.loadLangParameterProperties(this._applet.getLangOptions())));
/*     */ 
/* 103 */     localCachingPicoContainer.registerComponentInstance$506b371c(this._applet);
/*     */ 
/* 105 */     localCachingPicoContainer.registerComponentInstance$c7595c8(AppletProperties.class, new AppletProperties(this._applet.getCertTab(), (String)localObject, str));
/*     */ 
/* 110 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("login", Login.class);
/*     */ 
/* 113 */     localCachingPicoContainer.registerComponentImplementation$bb03b8("delegationValidation", VoteValidation.class, new ComponentMonitor[] { new ConstantParameter(this._applet), new ConstantParameter(Boolean.valueOf(true)) });
/*     */ 
/* 118 */     localCachingPicoContainer.registerComponentImplementation$bb03b8("confirmDelegation", ConfirmVote.class, new ComponentMonitor[] { new ConstantParameter(this._applet), new ConstantParameter(Boolean.valueOf(true)) });
/*     */ 
/* 123 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("voteValidation", VoteValidation.class);
/*     */ 
/* 125 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("confirmVote", ConfirmVote.class);
/*     */ 
/* 127 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("receipt", Receipt.class);
/*     */ 
/* 129 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("alternate_receipt", AlternateReceipt.class);
/*     */ 
/* 132 */     localCachingPicoContainer.registerComponentImplementation$3cf7bc9("choose_certificate", ChooseRecognizedCertificate.class);
/*     */ 
/* 136 */     this._container = localCachingPicoContainer;
/*     */   }
/*     */ 
/*     */   public VotingAppletContext(PnyxClientApplet applet)
/*     */   {
/* 147 */     this._applet = applet;
/* 148 */     this._messageSource$6b7050de = new ASN1Dump(new String[] { this._applet.getParameter("customer"), "pnyx_client_messages", "com.scytl.voting.applet.view.thinlet.i18n.clientText" });
/*     */   }
/*     */ 
/*     */   public ComponentMonitor resolveView$7e748853(String viewName)
/*     */   {
/*     */     String viewName;
/* 166 */     if (((
/* 166 */       controller = this._container.getComponentInstance(viewName)) != null) && 
/* 166 */       ((controller instanceof ExtendedThinlet))) {
/* 167 */       return (ComponentMonitor)controller;
/*     */     }
/* 169 */     _logger.error("No controller found for view named :: " + viewName);
/*     */ 
/* 171 */     return null;
/*     */   }
/*     */ 
/*     */   public ExtendedThinlet<PnyxClientApplet> getShowingView()
/*     */   {
/*     */     String[] arrayOfString;
/* 188 */     for (Object localObject : arrayOfString = new String[] { "confirmVote", "confirmDelegation", "receipt", "alternate_receipt", "login", "voteValidation", "delegationValidation" })
/*     */     {
/* 191 */       if ((
/* 191 */         localObject = (ExtendedThinlet)resolveView$7e748853((String)localObject))
/* 191 */         .isShowing()) {
/* 192 */         return localObject;
/*     */       }
/*     */     }
/* 195 */     return (ExtendedThinlet<PnyxClientApplet>)null;
/*     */   }
/*     */ 
/*     */   public PnyxClientStateMachine getPnyxClient()
/*     */   {
/* 204 */     return (PnyxClientStateMachine)this._container.getComponentInstanceOfType(PnyxClientStateMachine.class);
/*     */   }
/*     */ 
/*     */   public PostCallback getPostCallback()
/*     */   {
/* 212 */     return (PostCallback)this._container.getComponentInstanceOfType(PostCallback.class);
/*     */   }
/*     */ 
/*     */   public AppletProperties getAppletProperties()
/*     */   {
/* 220 */     return (AppletProperties)this._container.getComponentInstanceOfType(AppletProperties.class);
/*     */   }
/*     */ 
/*     */   public ASN1Dump getMessageSource$3561bc63()
/*     */   {
/* 225 */     return this._messageSource$6b7050de;
/*     */   }
/*     */ 
/*     */   public void destroy()
/*     */   {
/* 232 */     this._container.dispose();
/* 233 */     this._container = null;
/*     */   }
/*     */ 
/*     */   public LocaleProvider getLocaleProvider()
/*     */   {
/* 240 */     return (LocaleProvider)this._container.getComponentInstanceOfType(LocaleProvider.class);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.VotingAppletContext
 * JD-Core Version:    0.6.0
 */