/*     */ package com.scytl.voting.applet.view.thinlet;
/*     */ 
/*     */ import com.scytl.crypto.CryptographicAlgorithms;
/*     */ import com.scytl.crypto.CryptographicFormats;
/*     */ import com.scytl.pnyx.client.state.RecognizedLoginData;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessageFormatter;
/*     */ import com.scytl.voting.applet.AppletProperties;
/*     */ import com.scytl.voting.applet.PnyxClientApplet;
/*     */ import java.security.KeyStore;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.Principal;
/*     */ import java.security.cert.CertificateEncodingException;
/*     */ import java.security.cert.X509Certificate;
/*     */ import java.text.DateFormat;
/*     */ import java.util.ResourceBundle;
/*     */ import org.apache.commons.codec.binary.Base64;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public class ChooseRecognizedCertificate extends RecognizedCertificateListSupport
/*     */ {
/*  45 */   private static Log _logger = LogFactory.getLog(ChooseRecognizedCertificate.class);
/*     */   private final CryptographicFormats _cf;
/*     */   private final CryptographicAlgorithms _ca;
/*     */ 
/*     */   public ChooseRecognizedCertificate(PnyxClientApplet applet, CryptographicFormats cf, CryptographicAlgorithms ca)
/*     */   {
/*  63 */     super(applet);
/*  64 */     this._cf = cf;
/*  65 */     this._ca = ca;
/*     */   }
/*     */ 
/*     */   protected final String getCurrentView()
/*     */   {
/*  73 */     return "/views/choose_certificate.xml";
/*     */   }
/*     */ 
/*     */   public void loadRecognizedCertificates(Object paramObject)
/*     */   {
/*  83 */     if (((PnyxClientApplet)this._applet).getAppletProperties().isRecognizedCertificateAllowed())
/*     */       try {
/*  85 */         populateRecognizedCertificatesList(paramObject, waitForKeystore(), null);
/*     */ 
/*  90 */         return;
/*     */       }
/*     */       catch (KeyStoreException paramObject)
/*     */       {
/*  88 */         displayError(getResourceBundle().getString("error.keystore"), paramObject);
/*     */       }
/*     */   }
/*     */ 
/*     */   public void cancel()
/*     */   {
/*  95 */     _logger.debug("CANCEL action");
/*  96 */     dispose();
/*     */   }
/*     */ 
/*     */   public void select() {
/* 100 */     _logger.debug("SELECT action");
/*     */ 
/* 102 */     ErrorMessage localErrorMessage = new ErrorMessage();
/* 103 */     clearError();
/*     */ 
/* 105 */     if (!isRecognizedCertificateSelected()) {
/* 106 */       localErrorMessage.addError$76d17a("login.recognized.certificate", ThinletErrorKey.KEY_ERROR_REQUIRED);
/*     */     }
/*     */ 
/* 109 */     if (localErrorMessage.hasErrors()) {
/* 110 */       displayError(ErrorMessageFormatter.formatErrors(localErrorMessage, getResourceBundle(), getResourceBundle()));
/*     */ 
/* 112 */       return;
/*     */     }
/*     */     try {
/* 115 */       localErrorMessage = new ErrorMessage();
/* 116 */       Object localObject1 = waitForKeystore().getCertificateChain(getSelectedRecognizedCertificateAlias());
/*     */ 
/* 120 */       localObject1 = this._cf.certificatesPEM(localObject1);
/* 121 */       ((PnyxClientApplet)this._applet).putKeyValue("certificateChain", (String)localObject1);
/*     */ 
/* 123 */       getCertificateData(((PnyxClientApplet)this._applet).getValue("ksEntryAlias"));
/*     */ 
/* 125 */       ((PnyxClientApplet)this._applet).doScript("browser", "selectCertificate", new String[] { "certificateChain" });
/*     */ 
/* 137 */       if (localErrorMessage.hasErrors()) {
/* 138 */         displayError(ErrorMessageFormatter.formatErrors(localErrorMessage, getResourceBundle(), getResourceBundle())); return;
/*     */       }
/*     */ 
/* 142 */       dispose();
/*     */ 
/* 144 */       return;
/*     */     }
/*     */     catch (KeyStoreException localKeyStoreException)
/*     */     {
/* 129 */       localErrorMessage.addError$76d17a("login.recognized.certificate", ThinletErrorKey.KEY_ERROR_REQUIRED);
/*     */ 
/* 137 */       if (localErrorMessage.hasErrors()) {
/* 138 */         displayError(ErrorMessageFormatter.formatErrors(localErrorMessage, getResourceBundle(), getResourceBundle())); return;
/*     */       }
/*     */ 
/* 142 */       dispose();
/*     */ 
/* 144 */       return;
/*     */     }
/*     */     catch (CertificateEncodingException localCertificateEncodingException)
/*     */     {
/* 132 */       _logger.fatal("The selected certificate cannot be parsed.", localCertificateEncodingException);
/*     */ 
/* 134 */       localErrorMessage.addError$76d17a("login.recognized.certificate", ThinletErrorKey.KEY_ERROR_REQUIRED);
/*     */ 
/* 137 */       if (localErrorMessage.hasErrors()) {
/* 138 */         displayError(ErrorMessageFormatter.formatErrors(localErrorMessage, getResourceBundle(), getResourceBundle())); return;
/*     */       }
/*     */ 
/* 142 */       dispose();
/*     */ 
/* 144 */       return;
/*     */     }
/*     */     finally
/*     */     {
/* 137 */       if (localErrorMessage.hasErrors()) {
/* 138 */         displayError(ErrorMessageFormatter.formatErrors(localErrorMessage, getResourceBundle(), getResourceBundle()));
/*     */       }
/*     */       else
/*     */       {
/* 142 */         dispose(); } 
/* 142 */     }throw localObject2;
/*     */   }
/*     */ 
/*     */   public void getCertificateData(String paramString)
/*     */   {
/* 149 */     Object localObject = null;
/*     */     try {
/* 151 */       localObject = waitForKeystore().getCertificateChain(paramString);
/*     */     }
/*     */     catch (KeyStoreException paramString) {
/* 154 */       _logger.info("Could not parse the certificate chain", paramString);
/*     */     }
/* 156 */     if ((localObject == null) || (localObject.length == 0)) {
/* 157 */       return;
/*     */     }
/* 159 */     paramString = (X509Certificate)localObject[0];
/*     */ 
/* 164 */     String str1 = (
/* 164 */       localObject = DateFormat.getDateTimeInstance(3, 3, getLocale()))
/* 164 */       .format(paramString.getNotBefore());
/* 165 */     localObject = ((DateFormat)localObject).format(paramString.getNotAfter());
/* 166 */     String str2 = paramString.getIssuerDN().getName();
/* 167 */     String str3 = paramString.getSubjectDN().getName();
/* 168 */     String str4 = RecognizedLoginData.extractUserNameFromCertificate(paramString);
/*     */ 
/* 171 */     paramString = RecognizedLoginData.extractCifFromCertificate(paramString);
/*     */ 
/* 173 */     ((PnyxClientApplet)this._applet).putKeyValue("notBefore", str1);
/* 174 */     ((PnyxClientApplet)this._applet).putKeyValue("notAfter", (String)localObject);
/* 175 */     ((PnyxClientApplet)this._applet).putKeyValue("issuer", str2);
/* 176 */     ((PnyxClientApplet)this._applet).putKeyValue("subject", str3);
/* 177 */     ((PnyxClientApplet)this._applet).putKeyValue("username", str4);
/* 178 */     ((PnyxClientApplet)this._applet).putKeyValue("cif", paramString);
/*     */   }
/*     */ 
/*     */   public String signData(String paramString1, String paramString2)
/*     */   {
/*     */     try {
/* 184 */       this = CryptographicFormats.getUserPrivateKey(waitForKeystore(), paramString1, null);
/*     */ 
/* 187 */       return new String(Base64.encodeBase64(CryptographicAlgorithms.sign(paramString2.getBytes(), this)));
/*     */     }
/*     */     catch (java.security.GeneralSecurityException this) {
/* 190 */       _logger.error("Could not sign the data.", this);
/* 191 */     }return null;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.view.thinlet.ChooseRecognizedCertificate
 * JD-Core Version:    0.6.0
 */