/*     */ package com.scytl.voting.applet.view.thinlet;
/*     */ 
/*     */ import com.scytl.AbstractLocalizableException;
/*     */ import com.scytl.authentication.AuthenticationParametersTransform;
/*     */ import com.scytl.pnyx.client.state.AdvancedLoginData;
/*     */ import com.scytl.pnyx.client.state.LoginData;
/*     */ import com.scytl.pnyx.client.state.RecognizedLoginData;
/*     */ import com.scytl.pnyx.client.state.WiredRecognizedLoginData;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessage;
/*     */ import com.scytl.pnyx.client.validator.ErrorMessageFormatter;
/*     */ import com.scytl.voting.applet.AppletProperties;
/*     */ import com.scytl.voting.applet.KeystoreHolder;
/*     */ import com.scytl.voting.applet.PnyxClientApplet;
/*     */ import java.awt.AWTEvent;
/*     */ import java.awt.event.FocusEvent;
/*     */ import java.awt.event.KeyEvent;
import java.lang.reflect.Method;
/*     */ import java.security.AccessController;
/*     */ import java.security.KeyStoreException;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.Arrays;
/*     */ import java.util.HashMap;
/*     */ import java.util.Hashtable;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Locale;
/*     */ import java.util.Map;
/*     */ import java.util.ResourceBundle;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
import org.bouncycastle.asn1.x500.X500Name;
import org.picocontainer.ComponentMonitor;
import org.picocontainer.PicoContainer;
import org.picocontainer.PicoInitializationException;
import org.picocontainer.PicoIntrospectionException;
import org.picocontainer.PicoRegistrationException;
import org.picocontainer.defaults.NotConcreteRegistrationException;

import thinlet.Thinlet;
/*     */ 
/*     */ public class Login extends RecognizedCertificateListSupport
/*     */ {
/*     */   public static final String LOGIN_TAB_SUFFIX = "LoginTab";
/*     */   public static final String COMBO_LANGUAGE = "comboLanguage";
/*     */   public static final String ADVANCED_USERNAME = "j_username";
/*     */   public static final String ADVANCED_PASSWORD = "password";
/*     */   public static final String PIN_FIELD = "pin";
/*     */   public static final String RECOGNIZED_TAB = "recognizedLoginTab";
/*     */   public static final String WARNING_MESSAGE_FIELD = "warningMessage";
/*  69 */   private static final String[] USER_INPUT_DATA = { "loginTypes", "comboLanguage", "j_username", "password", "pin" };
/*     */ 
/*  87 */   private static Log _logger = LogFactory.getLog(Login.class);
/*     */   private final AuthenticationParametersTransform _authenticationParametersTransform;
/*  91 */   private LoginData _loginData = null;
/*     */ 
/*  93 */   private int _loginAttempt = 0;
/*     */ 
/*     */   public Login(PnyxClientApplet applet) {
/*  96 */     super(applet);
/*     */     AuthenticationParametersTransform transform;
/*  97 */     (
/* 100 */       transform = applet.getAppletProperties().getAuthenticationParametersTransform())
/* 100 */       .setPasswordParameter("password");
/* 101 */     transform.setUsernameParameter("j_username");
/* 102 */     transform.setPinParameter("pin");
/* 103 */     this._authenticationParametersTransform = transform;
/*     */   }
/*     */ 
/*     */   public void loadLanguages(Object paramObject1, Object paramObject2)
/*     */   {
/*     */     List localList;
/* 118 */     if ((
/* 118 */       localList = ((PnyxClientApplet)this._applet).getAvailableLocales())
/* 118 */       .size() > 1) {
/* 119 */       
				if (paramObject1 != null) { 
					int i = 0; 
					for (Iterator iterator = localList.iterator(); iterator.hasNext(); i++) { 
						Locale localLocale = (Locale)iterator.next(); 
						Object localObject1 = Thinlet.create("choice");
/*     */           	String str;
/* 119 */           	if (localLocale.toString().equalsIgnoreCase("gl")) { 
							str = "Galego";
						} else { 
							str = localLocale.getDisplayLanguage(localLocale); 
							str = Character.toUpperCase(str.charAt(0)) + str.substring(1);
						} 
						Object[] arrayOfObject = (Object[])localObject1;
						Object localObject2 = new Hashtable();
						((Hashtable)localObject2).put("code", localLocale); 
						localObject2 = new Object[] { ":bind", localObject2, null };
						arrayOfObject[2] = localObject2;
						setString(localObject1, "text", str + "          ");
						setString(localObject1, "name", localLocale.toString());
						add(paramObject1, localObject1);
						if (!getLocale().getLanguage().equals(localLocale.getLanguage())) 
							continue;
						setInteger(paramObject1, "selected", i); 
					}
				}
/* 119 */       return;
/*     */     }
/* 121 */     setBoolean(paramObject1, "visible", false);
/* 122 */     setBoolean(paramObject2, "visible", false);
/*     */   }
/*     */ 
/*     */   public void supportedCertificates(Object paramObject1, Object paramObject2, Object paramObject3, Object paramObject4)
/*     */   {
/* 130 */     if (((PnyxClientApplet)this._applet).getAppletProperties().isAdvancedCertificateAllowed()) {
/* 131 */       setBoolean(paramObject2, "enabled", true);
/*     */     }
/*     */     else {
/* 134 */       setString(paramObject2, "text", "");
/*     */     }
/*     */ 
/* 137 */     if (((PnyxClientApplet)this._applet).getAppletProperties().isRecognizedCertificateAllowed()) {
/* 138 */       setBoolean(paramObject3, "enabled", true);
/*     */     }
/*     */     else {
/* 141 */       setString(paramObject3, "text", "");
/*     */     }
/*     */ 
/* 144 */     setInteger(paramObject1, "selected", ((PnyxClientApplet)this._applet).getAppletProperties().getDefaultCertificateTab());
/*     */ 
/* 147 */     paramObject2 = paramObject1;
			  if (paramObject2 == null)
				  _logger.debug("LoginTabbedPane not found");
			  if (((paramObject3 = ((PnyxClientApplet)this._applet).getAppletProperties().getTabsSorted()) != null) && (!((List)paramObject3).isEmpty())) { 
				  	Object[] arrayOfObject = this.getItems(paramObject2);
				  	this.removeAll(paramObject2);
			  		for (Object localObject = ((List)paramObject3).iterator(); ((Iterator)localObject).hasNext(); ) {
			  			paramObject3 = (String)((Iterator)localObject).next(); 
			  			paramObject3 = paramObject3 + "LoginTab"; 
			  			for (int i = 0; i < arrayOfObject.length; i++) { 
			  				if (!paramObject3.equals(this.getString(arrayOfObject[i], "name"))) 
			  					continue;
			  				this.add(paramObject2, arrayOfObject[i]);
			  			}
			  		}
/* 147 */       	Object localObject = Arrays.asList(this.getItems(paramObject2));
					for (int i = 0; i < arrayOfObject.length; i++) { 
						if (((List)localObject).contains(arrayOfObject[i])) 
							continue; 
						this.add(paramObject2, arrayOfObject[i]);
					}
/*     */     }
/* 149 */     if ((!((PnyxClientApplet)this._applet).getAppletProperties().isAdvancedCertificateAllowed()) || (!((PnyxClientApplet)this._applet).getAppletProperties().isRecognizedCertificateAllowed()))
/*     */     {
/* 151 */       setBoolean(paramObject4, "visible", false);
/*     */     }
/*     */   }
/*     */ 
/*     */   public void loadRecognizedCertificates(Object paramObject1, Object paramObject2, Object paramObject3)
/*     */   {
/* 163 */     if (((PnyxClientApplet)this._applet).getAppletProperties().isRecognizedCertificateAllowed())
/*     */       try {
/* 165 */         populateRecognizedCertificatesList(paramObject1, waitForKeystore(), paramObject3);
/*     */ 
/* 172 */         return;
/*     */       }
/*     */       catch (KeyStoreException e)
/*     */       {
/* 169 */         setBoolean(paramObject2, "enabled", false);
/* 170 */         displayError(getResourceBundle().getString("error.keystore"), e);
/*     */       }
/*     */   }
/*     */ 
/*     */   public void changeLanguage(Object languageCombo)
/*     */   {
/* 184 */     _logger.info("The current locale is :: " + getLocale());
/* 185 */     languageCombo = getSelectedItem(languageCombo);
/*     */     Object selItem;
/* 186 */     languageCombo = (Locale)getProperty(languageCombo, "code");
/*     */     Locale locale;
/* 187 */     setLocale((Locale)languageCombo);
/* 188 */     refresh();
/* 189 */     _logger.info("The locale changed to :: " + languageCombo);
/*     */   }
/*     */ 
/*     */   public void cancel()
/*     */   {
/* 197 */     _logger.debug("CANCEL action");
/* 198 */     dispose();
/*     */   }
/*     */ 
/*     */   public void login()
/*     */   {
/* 206 */     _logger.debug("LOGIN action");
/*     */ 
/* 208 */     Object localObject1 = this;
/*     */     Object localObject2;
/* 208 */     _logger.debug("LoginTabbedPane not found");
/*     */     String str1;
/* 208 */     // _logger.debug("Selected tabName is not xxxTabName, found :: " + str1);
			  localObject1 = 
					  ((str1 = ((Login)localObject1).getString(this /* ??? */, "name")) == null) || 
					  (!str1.endsWith("LoginTab"))
					  	? null
					  	: (localObject2 = getSelectedItem(((Login)localObject1).find("loginTypes"))) == null
					  		? null
					  		: str1.substring(0, str1.length() - "LoginTab".length());
/* 209 */     if ("advanced".equalsIgnoreCase((String)localObject1)) {
/* 210 */       _logger.debug("Advanced login");
/* 211 */       localObject1 = this; localObject2 = new ErrorMessage(); ((Login)localObject1).clearError(); if (((str1 = ((Login)localObject1).readInputText("j_username")) == null) || (str1.length() == 0)) ((ErrorMessage)localObject2).addError$76d17a("login.advanced.username", ThinletErrorKey.KEY_ERROR_REQUIRED);
/* 211 */       String str2;
/* 211 */       if (((str2 = ((Login)localObject1).readInputText("password")) == null) || (str2.length() == 0)) ((ErrorMessage)localObject2).addError$76d17a("login.advanced.password", ThinletErrorKey.KEY_ERROR_REQUIRED);
/* 211 */       String str3;
/* 211 */       if (((str3 = ((Login)localObject1).readInputText("pin")) == null) || (str3.length() == 0)) ((ErrorMessage)localObject2).addError$76d17a("login.advanced.pin", ThinletErrorKey.KEY_ERROR_REQUIRED); ((Login)localObject1).displayError(ErrorMessageFormatter.formatErrors((ErrorMessage)localObject2, ((Login)localObject1).getResourceBundle(), ((Login)localObject1).getResourceBundle())); ((Map)(localObject2 = new HashMap())).put("password", str2); ((Map)localObject2).put("j_username", str1); ((Map)localObject2).put("pin", str3); this._loginData = (((ErrorMessage)localObject2).hasErrors() ? null : new AdvancedLoginData(((Login)localObject1)._authenticationParametersTransform.transformedUsername((Map)localObject2), ((Login)localObject1)._authenticationParametersTransform.transformedPassword((Map)localObject2).toCharArray(), ((Login)localObject1)._authenticationParametersTransform.transformedPin((Map)localObject2).toCharArray(), ((PnyxClientApplet)((Login)localObject1)._applet).getCodeBase()));
/* 212 */     } else if ("recognized".equalsIgnoreCase((String)localObject1)) {
/* 213 */       _logger.debug("Recognized login");
/* 214 */       this._loginData = fillRecognizedLogin();
/*     */     } else {
/* 216 */       _logger.debug("Unknown login :: " + (String)localObject1);
/* 217 */       return;
/*     */     }
/* 219 */     if (this._loginData != null)
/*     */     {
/* 224 */       AccessController.doPrivileged(new PrivilegedAction()
/*     */       {
/*     */         public Boolean run()
/*     */         {
/*     */           try {
/* 229 */             ((PnyxClientApplet)Login.this._applet).login(Login.this._loginData);
/* 230 */             Login.this.dispose();
/*     */           } catch (AbstractLocalizableException ale) {
/* 232 */             if (/*Login.access$204(Login.this) >= 3*/ false) {
/* 233 */               Login.this.cancel();
/*     */             }
/* 235 */             Login.this.displayError(ale.getLocalizedMessage(Login.this.getResourceBundle()), ale);
/*     */           }
/*     */ 
/* 240 */           return Boolean.valueOf(true);
/*     */         } } );
/*     */     }
/*     */   }
/*     */ 
/*     */   private LoginData fillRecognizedLogin() {
/* 247 */     ErrorMessage errorMessage = new ErrorMessage();
/* 248 */     clearError();
/*     */ 
/* 250 */     if (!isRecognizedCertificateSelected()) {
/* 251 */       errorMessage.addError$76d17a("login.recognized.certificate", ThinletErrorKey.KEY_ERROR_REQUIRED);
/*     */     }
/*     */ 
/* 255 */     if (errorMessage.hasErrors()) {
/* 256 */       displayError(ErrorMessageFormatter.formatErrors(errorMessage, getResourceBundle(), getResourceBundle()));
/*     */ 
/* 258 */       return null;
/*     */     }
/* 260 */     RecognizedLoginData rld = null;
/*     */     try {
/* 262 */       rld = new WiredRecognizedLoginData(KeystoreHolder.getInstance().getKeyStore(), getSelectedRecognizedCertificateAlias());
/*     */     }
/*     */     catch (KeyStoreException localKeyStoreException)
/*     */     {
/* 267 */       errorMessage.addError$76d17a("login.recognized.certificate", ThinletErrorKey.KEY_ERROR_INCOMPLETE);
/*     */     }
/*     */ 
/* 270 */     return rld;
/*     */   }
/*     */ 
/*     */   protected final boolean setInitialFocus()
/*     */   {
/*     */     boolean setFocus;
/* 457 */     if (!(
/* 457 */       setFocus = requestFocus(find("j_username"))))
/*     */     {
/* 458 */       setFocus |= requestFocus(find("loginTypes"));
/*     */     }
/* 460 */     return setFocus;
/*     */   }
/*     */ 
/*     */   protected final String getCurrentView()
/*     */   {
/* 468 */     return "/views/login.xml";
/*     */   }
/*     */ 
/*     */   protected final String[] getUserInputData()
/*     */   {
/* 473 */     String[] retval = new String[USER_INPUT_DATA.length];
/*     */     String[] copy;
/* 474 */     System.arraycopy(USER_INPUT_DATA, 0, retval, 0, USER_INPUT_DATA.length);
/*     */ 
/* 476 */     return retval;
/*     */   }
/*     */ 
/*     */   public void detectCapsLock()
/*     */   {
/*     */     boolean bool;
/* 485 */     if ((
/* 485 */       bool = getCapsLockState()))
/*     */     {
/* 486 */       displayWarning(getResourceBundle().getString("login.capslock")); return;
/*     */     }
/* 488 */     clearWarning();
/*     */   }
/*     */ 
/*     */   protected void processEvent(AWTEvent paramAWTEvent)
/*     */   {
/* 496 */     super.processEvent(paramAWTEvent);
/* 497 */     if ((paramAWTEvent instanceof KeyEvent)) {
/* 498 */       switch (paramAWTEvent.getID())
/*     */       {
/*     */       case 401:
/*     */       case 402:
/* 502 */         detectCapsLock();
/* 503 */         return; } return;
/*     */     }
/*     */ 
/* 506 */     if ((paramAWTEvent instanceof FocusEvent))
/* 507 */       switch (paramAWTEvent.getID()) {
/*     */       case 1004:
/*     */       case 1005:
/* 510 */         clearWarning();
/*     */       }
/*     */   }
/*     */
@Override
public void lifecycleInvocationFailed(Method paramMethod, Object paramObject,
		RuntimeException paramRuntimeException) {
	// TODO Auto-generated method stub
	
}
@Override
public ComponentMonitor getLogger$424215df(String paramString) {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getKey() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public int getParameterSize() {
	// TODO Auto-generated method stub
	return 0;
}
@Override
public boolean isTraceEnabled() {
	// TODO Auto-generated method stub
	return false;
}
@Override
public void trace(String paramString) {
	// TODO Auto-generated method stub
	
}
@Override
public void trace(String paramString, Throwable paramThrowable) {
	// TODO Auto-generated method stub
	
}
@Override
public boolean isDebugEnabled() {
	// TODO Auto-generated method stub
	return false;
}
@Override
public void debug(String paramString) {
	// TODO Auto-generated method stub
	
}
@Override
public void debug(String paramString, Throwable paramThrowable) {
	// TODO Auto-generated method stub
	
}
@Override
public boolean isInfoEnabled() {
	// TODO Auto-generated method stub
	return false;
}
@Override
public void info(String paramString) {
	// TODO Auto-generated method stub
	
}
@Override
public void info(String paramString, Throwable paramThrowable) {
	// TODO Auto-generated method stub
	
}
@Override
public boolean isWarnEnabled() {
	// TODO Auto-generated method stub
	return false;
}
@Override
public void warn(String paramString) {
	// TODO Auto-generated method stub
	
}
@Override
public void warn(String paramString, Throwable paramThrowable) {
	// TODO Auto-generated method stub
	
}
@Override
public boolean isErrorEnabled() {
	// TODO Auto-generated method stub
	return false;
}
@Override
public void error(String paramString) {
	// TODO Auto-generated method stub
	
}
@Override
public void error(String paramString, Throwable paramThrowable) {
	// TODO Auto-generated method stub
	
}
@Override
public boolean areEqual(X500Name paramX500Name1, X500Name paramX500Name2) {
	// TODO Auto-generated method stub
	return false;
}
@Override
public int calculateHashCode(X500Name paramX500Name) {
	// TODO Auto-generated method stub
	return 0;
}
@Override
public String toString(X500Name paramX500Name) {
	// TODO Auto-generated method stub
	return null;
}
@Override
public ComponentMonitor createComponentAdapter$bb03b8(Object paramObject,
		Class paramClass, ComponentMonitor[] paramArrayOfComponentMonitor)
		throws PicoIntrospectionException, PicoRegistrationException,
		NotConcreteRegistrationException {
	// TODO Auto-generated method stub
	return null;
}
@Override
public Object resolveInstance$67bc1482(PicoContainer paramPicoContainer,
		ComponentMonitor paramComponentMonitor, Class paramClass) {
	// TODO Auto-generated method stub
	return null;
}
@Override
public boolean isResolvable$6c5a874c(PicoContainer paramPicoContainer,
		ComponentMonitor paramComponentMonitor, Class paramClass) {
	// TODO Auto-generated method stub
	return false;
}
@Override
public Object get() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public void set(Object paramObject) {
	// TODO Auto-generated method stub
	
}
@Override
public String serializeAsURLParameter() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getElectionId() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getElectionEventId() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getInstitutionId() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getUsername() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public String getAreaId() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public byte[] getAuthTokenSignature() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public Object getComponentKey() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public Class getComponentImplementation() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public Object getComponentInstance(PicoContainer paramPicoContainer)
		throws PicoInitializationException, PicoIntrospectionException {
	// TODO Auto-generated method stub
	return null;
} }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.voting.applet.view.thinlet.Login
 * JD-Core Version:    0.6.0
 */