/*     */ package com.scytl.xml.marshalling.stax;
/*     */ 
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import javax.xml.stream.FactoryConfigurationError;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLInputFactory;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.EndDocument;
/*     */ import javax.xml.stream.events.StartDocument;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public abstract class AbstractStaxItEntityDeserializer<T>
/*     */ {
/*  35 */   private static final Log LOGGER = LogFactory.getLog(AbstractStaxItEntityDeserializer.class);
/*     */ 
/*     */   public final void deserializeToModel(InputStream paramInputStream, T paramT)
/*     */     throws DeserializationException
/*     */   {
/*  41 */     StaxItDeserializationContext localStaxItDeserializationContext = buildDeserializer(paramInputStream);
/*     */     try
/*     */     {
/*     */       Object localObject;
/*  46 */       if (((
/*  46 */         localObject = localStaxItDeserializationContext.getReader().nextEvent()) instanceof StartDocument))
/*     */       {
/*  47 */         localObject = localStaxItDeserializationContext; if ((localObject = (localObject = (StartDocument)localObject).getCharacterEncodingScheme()) == null) throw new DeserializationException("Missing attribute 'encoding' on document header.");
/*     */ 
/*     */       }
/*     */       else
/*     */       {
/*  53 */         throw new DeserializationException("No <?xml ... > declaration was found. Is this an XML document?");
/*     */       }
/*     */ 
/*  58 */       deserialize(paramT, localStaxItDeserializationContext);
/*     */ 
/*  61 */       if (!((
/*  61 */         this = localStaxItDeserializationContext.getReader().nextEvent()) instanceof EndDocument))
/*     */       {
/*  62 */         LOGGER.warn("The parsing of the xml has finished but there are still some elements to be read, can't find the end of the document. Starting with:" + this);
/*     */       }
/*     */ 
/*     */       try
/*     */       {
/*  73 */         paramInputStream.close();
/*     */ 
/*  79 */         return;
/*     */       }
/*     */       catch (IOException localIOException)
/*     */       {
/*  75 */         LOGGER.error("An error has occurred while closing the input stream. It will be ignored.");
/*     */ 
/*  78 */         localIOException.printStackTrace();
/*     */ 
/*  80 */         return;
/*     */       }
/*     */     }
/*     */     catch (XMLStreamException localXMLStreamException)
/*     */     {
/*  68 */       throw new DeserializationException("An error has occurred while unmarshalling.", localXMLStreamException);
/*     */     }
/*     */     finally
/*     */     {
/*     */       try {
/*  73 */         paramInputStream.close();
/*     */       } catch (IOException paramInputStream) {
/*  75 */         LOGGER.error("An error has occurred while closing the input stream. It will be ignored.");
/*     */ 
/*  78 */         paramInputStream.printStackTrace();
/*     */       }
/*  79 */     }throw this;
/*     */   }
/*     */ 
/*     */   private static StaxItDeserializationContext buildDeserializer(InputStream paramInputStream)
/*     */     throws FactoryConfigurationError, DeserializationException
/*     */   {
/*  90 */     XMLInputFactory localXMLInputFactory = XMLInputFactory.newInstance();
/*  91 */     if (LOGGER.isDebugEnabled()) {
/*  92 */       LOGGER.debug("FACTORY: " + localXMLInputFactory);
/*     */     }
/*     */ 
/*     */     try
/*     */     {
/*  97 */       paramInputStream = localXMLInputFactory.createXMLEventReader(paramInputStream);
/*     */     } catch (XMLStreamException localXMLStreamException) {
/*  99 */       throw new DeserializationException("Can't create reader to do the unmarshalling.", localXMLStreamException);
/*     */     }
/*     */     StaxItDeserializationContext localStaxItDeserializationContext;
/* 103 */     (
/* 105 */       localStaxItDeserializationContext = new StaxItDeserializationContext())
/* 105 */       .setReader(paramInputStream);
/* 106 */     return localStaxItDeserializationContext;
/*     */   }
/*     */ 
/*     */   protected abstract void deserialize(T paramT, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException;
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.AbstractStaxItEntityDeserializer
 * JD-Core Version:    0.6.0
 */