/*     */ package com.scytl.xml.marshalling.stax;
/*     */ 
/*     */ import com.scytl.common.domain.OverVoteTypes;
/*     */ import com.scytl.common.domain.UnderVoteTypes;
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.EmlUtils;
/*     */ import com.scytl.xml.marshalling.eml.model.ContestBuilder;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import javax.xml.stream.events.Characters;
/*     */ import javax.xml.stream.events.EndElement;
/*     */ import javax.xml.stream.events.StartElement;
/*     */ import javax.xml.stream.events.XMLEvent;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ public abstract class StaxItElementDeserializer<T>
/*     */ {
/*  55 */   private static final Log LOGGER = LogFactory.getLog(StaxItElementDeserializer.class);
/*     */ 
/*     */   protected final StartElement requireElement(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 108 */     paramStaxItDeserializationContext = paramStaxItDeserializationContext; this = this; ignoreUntilNextTag(paramStaxItDeserializationContext); for (this = paramStaxItDeserializationContext.getReader().nextTag(); !isStartElement(); this = paramStaxItDeserializationContext.getReader().nextTag()) ignoreUntilNextTag(paramStaxItDeserializationContext); throw (paramStaxItDeserializationContext.getReader().hasNext() ? (StartElement)this : new DeserializationException("Already at end of file."));
/*     */   }
/*     */ 
/*     */   protected final String requireElementValue(QName waitedForElem, StaxItDeserializationContext ctx)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 127 */     return requireOptionalValue(waitedForElem, ctx, true);
/*     */   }
/*     */ 
/*     */   protected final String getElementValue(QName waitedForElem, StaxItDeserializationContext ctx)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 141 */     String value = null;
/* 142 */     if (nextEqualsQName(waitedForElem, ctx))
/*     */     {
/* 144 */       value = requireOptionalValue(waitedForElem, ctx, false);
/*     */     }
/* 146 */     return value;
/*     */   }
/*     */ 
/*     */   protected final String requireOptionalValue(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext, boolean paramBoolean)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 173 */     requireElement(paramQName, paramStaxItDeserializationContext);
/*     */ 
/* 175 */     paramBoolean = requireOptionalCharacters(paramStaxItDeserializationContext, paramBoolean);
/*     */ 
/* 178 */     ignoreUntilEndTag(paramQName, paramStaxItDeserializationContext);
/* 179 */     return paramBoolean;
/*     */   }
/*     */ 
/*     */   protected final String requireCharacters(StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/* 229 */     return requireOptionalCharacters(paramStaxItDeserializationContext, true);
/*     */   }
/*     */ 
/*     */   protected static String requireOptionalCharacters(StaxItDeserializationContext paramStaxItDeserializationContext, boolean paramBoolean)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/* 251 */     XMLEvent localXMLEvent = paramStaxItDeserializationContext.getReader().peek();
/* 252 */     String str = null;
/*     */ 
/* 254 */     if (localXMLEvent.isCharacters()) {
/* 255 */       paramBoolean = new StringBuffer();
/* 256 */       while (localXMLEvent.isCharacters()) {
/* 257 */         localXMLEvent = paramStaxItDeserializationContext.getReader().nextEvent();
/* 258 */         paramBoolean.append(((Characters)localXMLEvent).getData());
/* 259 */         localXMLEvent = paramStaxItDeserializationContext.getReader().peek();
/*     */       }
/* 261 */       str = paramBoolean.toString();
/*     */     }
/* 263 */     else if (paramBoolean) {
/* 264 */       throw new DeserializationException("Deserialization was waiting for a Characters event but it was:" + localXMLEvent.getClass());
/*     */     }
/*     */ 
/* 269 */     return str;
/*     */   }
/*     */ 
/*     */   protected final String requireElementAttribute(QName paramQName1, QName paramQName2, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 288 */     if ((
/* 288 */       this = (
/* 287 */       this = requireElement(paramQName1, paramStaxItDeserializationContext))
/* 287 */       .getAttributeByName(paramQName2)) == null)
/*     */     {
/* 289 */       throw new DeserializationException("Missing required attribute: " + paramQName2.getLocalPart() + " for qname: " + paramQName1.getLocalPart());
/*     */     }
/*     */ 
/* 293 */     return getValue();
/*     */   }
/*     */ 
/*     */   protected static String readAttrib(StartElement paramStartElement, QName paramQName)
/*     */   {
/* 325 */     if ((
/* 325 */       paramStartElement = paramStartElement.getAttributeByName(paramQName)) == null)
/* 325 */       return null; return paramStartElement.getValue();
/*     */   }
/*     */ 
/*     */   protected final boolean nextTagEqualsQName(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 346 */     ignoreUntilNextTag(paramStaxItDeserializationContext);
/* 347 */     return nextEqualsQName(paramQName, paramStaxItDeserializationContext);
/*     */   }
/*     */ 
/*     */   private static void ignoreUntilNextTag(StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/*     */     XMLEvent localXMLEvent;
/* 363 */     if ((
/* 363 */       localXMLEvent = paramStaxItDeserializationContext.getReader().peek()) != null) {
/*     */       do {
/* 364 */         if ((localXMLEvent.isStartElement()) || (localXMLEvent.isEndElement())) break;
/* 365 */         paramStaxItDeserializationContext.getReader().nextEvent();
/*     */       }
/* 367 */       while ((
/* 367 */         localXMLEvent = paramStaxItDeserializationContext.getReader().peek()) != null);
/*     */ 
/* 368 */       throw new DeserializationException("Already at end of file.");
/*     */     }
/*     */ 
/* 372 */     throw new DeserializationException("Already at end of file.");
/*     */   }
/*     */ 
/*     */   protected static EndElement ignoreUntilEndTag(StaxItDeserializationContext ctx)
/*     */     throws XMLStreamException
/*     */   {
/* 389 */     ctx = ctx.getReader();
/*     */     XMLEventReader r;
/* 390 */     while (!r.peek().isEndElement()) {
/* 391 */       XMLEvent e = ctx.nextEvent();
/* 392 */       if (LOGGER.isDebugEnabled()) {
/* 393 */         LOGGER.debug("Ignored:" + e);
/*     */       }
/*     */     }
/*     */ 
/* 397 */     return (EndElement)ctx.nextTag();
/*     */   }
/*     */ 
/*     */   protected final void ignoreNextIfExists(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/* 407 */     if (nextEqualsQName(paramQName, paramStaxItDeserializationContext))
/* 408 */       ignoreUntilEndTag(paramQName, paramStaxItDeserializationContext);
/*     */   }
/*     */ 
/*     */   protected final EndElement ignoreUntilEndTag(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException
/*     */   {
/* 428 */     while (!(
/* 428 */       this = ignoreUntilEndTag(paramStaxItDeserializationContext))
/* 428 */       .getName().equals(paramQName));
/* 429 */     return this;
/*     */   }
/*     */ 
/*     */   protected final boolean nextEqualsQName(QName paramQName, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 478 */     this = null;
/* 479 */     ignoreUntilNextTag(paramStaxItDeserializationContext);
/*     */ 
/* 482 */     switch ((
/* 482 */       paramStaxItDeserializationContext = (
/* 481 */       paramStaxItDeserializationContext = paramStaxItDeserializationContext.getReader())
/* 481 */       .peek())
/* 482 */       .getEventType()) {
/*     */     case 1:
/* 484 */       this = ((StartElement)paramStaxItDeserializationContext).getName();
/* 485 */       break;
/*     */     case 2:
/* 487 */       this = ((EndElement)paramStaxItDeserializationContext).getName();
/* 488 */     }paramStaxItDeserializationContext = 0;
/*     */ 
/* 493 */     if ((this != null) && (equals(paramQName))) {
/* 494 */       paramStaxItDeserializationContext = 1;
/*     */     }
/* 496 */     return paramStaxItDeserializationContext;
/*     */   }
/*     */ 
/*     */   protected String getValueConditionally(QName paramQName1, QName paramQName2, String paramString, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/*     */     String str;
/* 519 */     if (((
/* 519 */       str = requireElementAttribute(paramQName1, paramQName2, paramStaxItDeserializationContext)) != null) && 
/* 519 */       (str.equals(paramString)))
/*     */     {
/* 521 */       paramQName2 = requireOptionalCharacters(paramStaxItDeserializationContext, false);
/*     */     }
/* 523 */     else throw new DeserializationException("Received expected QName with unexpected attribute value. [QName=" + paramQName1.getLocalPart() + "[" + paramQName2.getLocalPart() + ":expected <" + paramString + "> but was <" + str + ">]]");
/*     */ 
/* 529 */     ignoreUntilEndTag(paramQName1, paramStaxItDeserializationContext);
/* 530 */     return paramQName2;
/*     */   }
/*     */ 
/*     */   protected final void parseCountMetrics(StaxItDeserializationContext paramStaxItDeserializationContext, ContestBuilder paramContestBuilder)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 543 */     while (nextEqualsQName(EmlQName.COUNT_METRIC, paramStaxItDeserializationContext))
/*     */     {
/* 547 */       if ((
/* 547 */         paramContestBuilder = requireElementAttribute(EmlQName.COUNT_METRIC, EmlQName.ATTRIB__TYPE, paramStaxItDeserializationContext))
/* 547 */         .equals("undervote")) {
/* 548 */         StaxItDeserializationContext localStaxItDeserializationContext = paramStaxItDeserializationContext; paramContestBuilder = this; EmlUtils.parseInt(requireOptionalCharacters(localStaxItDeserializationContext, true));
/*     */       }
/*     */ 
/* 551 */       ignoreUntilEndTag(paramStaxItDeserializationContext);
/*     */     }
/*     */   }
/*     */ 
/*     */   protected final void parseOverVoteType(StaxItDeserializationContext paramStaxItDeserializationContext, ContestBuilder paramContestBuilder)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 567 */     while (nextEqualsQName(EmlQName.OVER_VOTE_TYPE, paramStaxItDeserializationContext))
/*     */     {
/*     */       Object localObject;
/* 571 */       if ((
/* 571 */         localObject = requireElementAttribute(EmlQName.OVER_VOTE_TYPE, EmlQName.ATTRIB__TYPE, paramStaxItDeserializationContext))
/* 571 */         .equals("overvotetype")) {
/* 572 */         StaxItDeserializationContext localStaxItDeserializationContext = paramStaxItDeserializationContext; localObject = this; localObject = requireOptionalCharacters(localStaxItDeserializationContext, true);
/* 573 */         localObject = (OverVoteTypes)Enum.valueOf(OverVoteTypes.class, (String)localObject);
/*     */ 
/* 576 */         paramContestBuilder.setOvervotetype((OverVoteTypes)localObject);
/*     */       }
/* 578 */       ignoreUntilEndTag(paramStaxItDeserializationContext);
/*     */     }
/*     */   }
/*     */ 
/*     */   protected final void parseUnderVoteType(StaxItDeserializationContext paramStaxItDeserializationContext, ContestBuilder paramContestBuilder)
/*     */     throws XMLStreamException, DeserializationException
/*     */   {
/* 592 */     while (nextEqualsQName(EmlQName.UNDER_VOTE_TYPE, paramStaxItDeserializationContext))
/*     */     {
/*     */       Object localObject;
/* 596 */       if ((
/* 596 */         localObject = requireElementAttribute(EmlQName.UNDER_VOTE_TYPE, EmlQName.ATTRIB__TYPE, paramStaxItDeserializationContext))
/* 596 */         .equals("undervotetype")) {
/* 597 */         StaxItDeserializationContext localStaxItDeserializationContext = paramStaxItDeserializationContext; localObject = this; localObject = requireOptionalCharacters(localStaxItDeserializationContext, true);
/* 598 */         localObject = (UnderVoteTypes)Enum.valueOf(UnderVoteTypes.class, (String)localObject);
/*     */ 
/* 601 */         paramContestBuilder.setUndervotetype((UnderVoteTypes)localObject);
/*     */       }
/* 603 */       ignoreUntilEndTag(paramStaxItDeserializationContext);
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.StaxItElementDeserializer
 * JD-Core Version:    0.6.0
 */