/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlValues.MessageTypes;
/*     */ import com.scytl.xml.marshalling.eml.model.BallotIdentifier;
/*     */ import com.scytl.xml.marshalling.eml.model.ElectionIdentifier;
/*     */ import com.scytl.xml.marshalling.eml.model.ElectionIdentifierStructure;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*     */ import java.util.Map;
/*     */ import java.util.TreeMap;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.apache.commons.lang.StringUtils;
/*     */ 
/*     */ final class StaxItEmlBallot extends StaxItElementDeserializer<Ballot>
/*     */ {
/*  39 */   private static final StaxItEmlBallot INSTANCE = new StaxItEmlBallot();
/*     */ 
/*     */   public static StaxItEmlBallot getInstance()
/*     */   {
/*  45 */     return INSTANCE;
/*     */   }
/*     */ 
/*     */   public final void deserialize(Ballot paramBallot, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  56 */     requireElement(EmlQName.BALLOT, paramStaxItDeserializationContext);
/*  57 */     requireElement(EmlQName.ELECTION, paramStaxItDeserializationContext);
/*     */ 
/*  60 */     Object localObject1 = new ElectionIdentifier();
/*  61 */     StaxItEmlDeserializers.ELECTION_IDENTIFIER.deserialize((ElectionIdentifierStructure)localObject1, paramStaxItDeserializationContext);
/*     */ 
/*  63 */     paramBallot.setInstitutionId(((ElectionIdentifier)localObject1).getGroupId());
/*     */ 
/*  67 */     Object localObject2 = paramStaxItDeserializationContext; localObject1 = paramBallot; Object localObject3 = new TreeMap(); StaxItEmlDeserializers.DESCRIPTION.deserialize((Map)localObject3, (StaxItDeserializationContext)localObject2); ((Ballot)localObject1).setElectionName((Message)((Map)localObject3).get(ScytlValues.MessageTypes.TITLE)); localObject3 = new TreeMap(); StaxItEmlDeserializers.MESSAGES.deserialize((Map)localObject3, (StaxItDeserializationContext)localObject2); localObject2 = (Message)((Map)localObject3).get(ScytlValues.MessageTypes.ALTERNATE_RECEIPT_MESSAGE); ((Ballot)localObject1).setAlternateReceiptMessage((Message)localObject2);
/*     */ 
/*  70 */     while (nextTagEqualsQName(EmlQName.CONTEST, paramStaxItDeserializationContext)) {
/*  71 */       StaxItEmlDeserializers.BALLOT_CONTEST.deserialize(paramBallot, paramStaxItDeserializationContext);
/*     */     }
/*     */ 
/*  74 */     ignoreUntilEndTag(EmlQName.ELECTION, paramStaxItDeserializationContext);
/*     */ 
/*  77 */     localObject2 = paramStaxItDeserializationContext; localObject1 = paramBallot; localObject3 = new BallotIdentifier(); StaxItEmlDeserializers.BALLOT_IDENTIFIER.deserialize((ElectionIdentifierStructure)localObject3, (StaxItDeserializationContext)localObject2);
/*     */ 
/*  80 */     deserializeOthers(paramBallot, paramStaxItDeserializationContext);
/*     */ 
/*  82 */     ignoreUntilEndTag(EmlQName.BALLOT, paramStaxItDeserializationContext);
/*     */   }
/*     */ 
/*     */   private void deserializeOthers(Ballot paramBallot, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/* 123 */     int i = 1;
/* 124 */     while (i != 0) {
/* 125 */       if (nextEqualsQName(ScytlQName.REDIRECT_EXIT_URL, paramStaxItDeserializationContext))
/*     */       {
/* 127 */         paramBallot.setRedirectExitURL(requireOptionalValue(ScytlQName.REDIRECT_EXIT_URL, paramStaxItDeserializationContext, false)); continue;
/*     */       }
/* 129 */       if (nextEqualsQName(ScytlQName.REDIRECT_HELP_URL, paramStaxItDeserializationContext))
/*     */       {
/* 131 */         requireOptionalValue(ScytlQName.REDIRECT_HELP_URL, paramStaxItDeserializationContext, false); continue;
/*     */       }
/* 133 */       if (nextEqualsQName(ScytlQName.SHOW_RECEIPT, paramStaxItDeserializationContext))
/*     */       {
/* 135 */         paramBallot.setShowReceipt(Boolean.valueOf(requireElementValue(ScytlQName.SHOW_RECEIPT, paramStaxItDeserializationContext))); continue;
/*     */       }
/* 137 */       if (nextEqualsQName(ScytlQName.NEXT_ELECTION, paramStaxItDeserializationContext))
/*     */       {
/* 141 */         Object localObject = readAttrib(localObject = requireElement(ScytlQName.NEXT_ELECTION, paramStaxItDeserializationContext), 
/* 141 */           ScytlQName.ATTRIB__ID);
/*     */ 
/* 143 */         ignoreUntilEndTag(ScytlQName.NEXT_ELECTION, paramStaxItDeserializationContext);
/*     */ 
/* 149 */         if (!StringUtils.isBlank((String)localObject)) {
/* 150 */           paramBallot.setNextElectionId((String)localObject);
/*     */         }
/* 152 */         continue;
/* 153 */       }i = 0;
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlBallot
 * JD-Core Version:    0.6.0
 */