/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.common.domain.election.ballot.Ballot;
/*     */ import com.scytl.common.domain.election.ballot.BallotChannel;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.EmlUtils;
/*     */ import com.scytl.xml.marshalling.eml.model.ContestBuilder;
/*     */ import com.scytl.xml.marshalling.eml.model.TypedImage;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*     */ import java.util.HashMap;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import javax.xml.stream.events.StartElement;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ 
/*     */ final class StaxItEmlBallotContest extends StaxItElementDeserializer<Ballot>
/*     */ {
/*  46 */   private static final Log LOGGER = LogFactory.getLog(StaxItEmlBallotContest.class);
/*     */ 
/*  49 */   private static final StaxItEmlBallotContest INSTANCE = new StaxItEmlBallotContest();
/*     */ 
/*     */   public static StaxItEmlBallotContest getInstance()
/*     */   {
/*  53 */     return INSTANCE;
/*     */   }
/*     */ 
/*     */   public final void deserialize(Ballot paramBallot, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  68 */     ContestBuilder localContestBuilder = new ContestBuilder();
/*     */ 
/*  70 */     Object localObject1 = requireElementAttribute(EmlQName.CONTEST, EmlQName.ATTRIB__DISPLAY_ORDER, paramStaxItDeserializationContext);
/*     */ 
/*  73 */     localContestBuilder.setDisplayOrder((String)localObject1);
/*     */ 
/*  76 */     localObject1 = requireElementAttribute(EmlQName.CONTEST_IDENTIFIER, EmlQName.ATTRIB__ID, paramStaxItDeserializationContext);
/*     */ 
/*  79 */     localContestBuilder.setId((String)localObject1);
/*  80 */     ignoreUntilEndTag(paramStaxItDeserializationContext);
/*     */ 
/*  83 */     if (nextEqualsQName(EmlQName.VOTING_METHOD, paramStaxItDeserializationContext)) {
/*  84 */       localObject1 = requireElementValue(EmlQName.VOTING_METHOD, paramStaxItDeserializationContext);
/*     */ 
/*  86 */       localContestBuilder.setVotingMethod((String)localObject1);
/*     */     }
/*     */ 
/*  90 */     parseCountMetrics(paramStaxItDeserializationContext, localContestBuilder);
/*  91 */     parseUnderVoteType(paramStaxItDeserializationContext, localContestBuilder);
/*  92 */     parseOverVoteType(paramStaxItDeserializationContext, localContestBuilder);
/*     */ 
/*  95 */     localObject1 = requireElementValue(EmlQName.MAX_VOTES, paramStaxItDeserializationContext);
/*  96 */     localContestBuilder.setMaxVotes((String)localObject1);
/*     */ 
/*  99 */     if (nextEqualsQName(EmlQName.MIN_VOTES, paramStaxItDeserializationContext)) {
/* 100 */       localObject1 = requireElementValue(EmlQName.MIN_VOTES, paramStaxItDeserializationContext);
/* 101 */       localContestBuilder.setMinVotes((String)localObject1);
/*     */     }
/*     */ 
/* 105 */     if (nextEqualsQName(EmlQName.MAX_WRITE_IN, paramStaxItDeserializationContext)) {
/* 106 */       localObject1 = requireElementValue(EmlQName.MAX_WRITE_IN, paramStaxItDeserializationContext);
/*     */ 
/* 108 */       localContestBuilder.setMaxWriteIn((String)localObject1);
/*     */     }
/*     */ 
/* 112 */     if (nextEqualsQName(EmlQName.LOGO, paramStaxItDeserializationContext)) {
/* 113 */       localObject1 = new TypedImage();
/* 114 */       StaxItEmlDeserializers.LOGO.deserialize((TypedImage)localObject1, paramStaxItDeserializationContext);
/* 115 */       localContestBuilder.setImage(((TypedImage)localObject1).getImage());
/* 116 */       localContestBuilder.setImageType(((TypedImage)localObject1).getType());
/*     */     }
/*     */ 
/* 120 */     if (nextEqualsQName(EmlQName.ADDITIONAL_LOGO, paramStaxItDeserializationContext)) {
/* 121 */       localObject1 = new TypedImage();
/* 122 */       StaxItEmlDeserializers.ADDITIONAL_LOGO.deserialize((TypedImage)localObject1, paramStaxItDeserializationContext);
/* 123 */       localContestBuilder.setAdditionalImage(((TypedImage)localObject1).getImage());
/* 124 */       localContestBuilder.setAdditionalImageType(((TypedImage)localObject1).getType());
/*     */     }
/*     */ 
/* 128 */     StaxItDeserializationContext localStaxItDeserializationContext = paramStaxItDeserializationContext; Object localObject2 = paramBallot; localObject1 = this; Object localObject3 = (BallotChannel)EmlUtils.valueOf((localObject3 = (localObject3 = requireElement(EmlQName.BLOCKED, localStaxItDeserializationContext)).getAttributeByName(EmlQName.ATTRIB__CHANNEL)).getValue(), BallotChannel.class); if (((Ballot)localObject2).getChannel() != null) { if (!((Ballot)localObject2).getChannel().equals(localObject3)) LOGGER.warn("Former Ballot question channel was " + ((Ballot)localObject2).getChannel() + " but actual question channel is " + localObject3 + ". This last channel will be ignored!"); 
/*     */     } else ((Ballot)localObject2).setChannel((BallotChannel)localObject3); localObject2 = ((StaxItEmlBallotContest)localObject1).requireCharacters(localStaxItDeserializationContext); ((StaxItEmlBallotContest)localObject1).ignoreUntilEndTag(EmlQName.BLOCKED, localStaxItDeserializationContext); switch (StaxItEmlBallotContest.1.$SwitchMap$com$scytl$xml$marshalling$eml$model$YesNoType[((com.scytl.xml.marshalling.eml.model.YesNoType)EmlUtils.valueOf(localObject2, com.scytl.xml.marshalling.eml.model.YesNoType.class)).ordinal()]) { case 1:
/* 128 */       localObject2 = Question.ACTIVE_QUESTION.toString(); break;
/*     */     default:
/* 128 */       localObject2 = Question.CANCELLED_QUESTION.toString(); } localObject1 = localObject2;
/* 129 */     localContestBuilder.setStatus((String)localObject1);
/*     */ 
/* 132 */     if (nextEqualsQName(EmlQName.BALLOT_CHOICES, paramStaxItDeserializationContext)) {
/* 133 */       requireElement(EmlQName.BALLOT_CHOICES, paramStaxItDeserializationContext);
/* 134 */       localObject1 = new LinkedList();
/* 135 */       StaxItEmlDeserializers.CONTEST_ANSWERS.deserialize((List)localObject1, paramStaxItDeserializationContext);
/*     */ 
/* 137 */       localContestBuilder.addAnswers((List)localObject1);
/* 138 */       ignoreUntilEndTag(EmlQName.BALLOT_CHOICES, paramStaxItDeserializationContext);
/*     */     }
/*     */ 
/* 142 */     localObject1 = new HashMap();
/*     */ 
/* 144 */     StaxItEmlDeserializers.MESSAGES.deserialize((Map)localObject1, paramStaxItDeserializationContext);
/* 145 */     localContestBuilder.addMessages((Map)localObject1);
/*     */ 
/* 147 */     StaxItEmlDeserializers.CONTEST_OTHERS.deserialize(localContestBuilder, paramStaxItDeserializationContext);
/*     */ 
/* 149 */     ignoreUntilEndTag(EmlQName.CONTEST, paramStaxItDeserializationContext);
/*     */ 
/* 152 */     paramBallot.addQuestion(localContestBuilder.buildQuestion());
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlBallotContest
 * JD-Core Version:    0.6.0
 */