/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.common.domain.auth.data.Address;
/*     */ import com.scytl.common.domain.election.GenderType;
/*     */ import com.scytl.common.domain.election.ballot.Contact;
/*     */ import com.scytl.common.domain.hibernate.entity.i18n.Message;
/*     */ import com.scytl.common.domain.i18n.MessageFactory;
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.ScytlValues.MessageTypes;
/*     */ import com.scytl.xml.marshalling.eml.model.CandidateBuilder;
/*     */ import com.scytl.xml.marshalling.eml.model.TypedImage;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.scytl.model.AnswerOthers;
/*     */ import java.text.ParseException;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ 
/*     */ public final class StaxItEmlCandidate extends StaxItEmlAbstractAnswer<CandidateBuilder>
/*     */ {
/*  38 */   private static final StaxItEmlCandidate THE_ONE = new StaxItEmlCandidate();
/*     */ 
/*     */   public static StaxItEmlCandidate getInstance()
/*     */   {
/*  47 */     return THE_ONE;
/*     */   }
/*     */ 
/*     */   public final void deserialize(CandidateBuilder paramCandidateBuilder, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  55 */     consumeDisplayOrder(EmlQName.CANDIDATE, paramStaxItDeserializationContext);
/*     */ 
/*  57 */     Object localObject1 = requireElementAttribute(EmlQName.CANDIDATE_IDENTIFIER, EmlQName.ATTRIB__ID, paramStaxItDeserializationContext);
/*     */ 
/*  60 */     paramCandidateBuilder.setId((String)localObject1);
/*     */ 
/*  63 */     paramCandidateBuilder.setCandidateName(getElementValue(EmlQName.CANDIDATE_NAME, paramStaxItDeserializationContext));
/*     */ 
/*  65 */     ignoreUntilEndTag(EmlQName.CANDIDATE_IDENTIFIER, paramStaxItDeserializationContext);
/*     */     String str;
/*  69 */     if ((
/*  69 */       str = getElementValue(EmlQName.DATE_OF_BIRTH, paramStaxItDeserializationContext)) != null) {
/*     */       try
/*     */       {
/*  71 */         str = str; paramCandidateBuilder.setDateOfBirth(new MessageFactory(str).getDate());
/*     */       }
/*     */       catch (ParseException localParseException) {
/*  74 */         throw new DeserializationException("Can't parse date of birth for candidate " + (String)localObject1 + "!", localParseException);
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/*  82 */     if ((
/*  82 */       localObject2 = getElementValue(EmlQName.GENDER, paramStaxItDeserializationContext)) != null)
/*     */     {
/*  83 */       paramCandidateBuilder.setGender(GenderType.valueOf((String)localObject2));
/*     */     }
/*     */ 
/*  87 */     if (nextEqualsQName(EmlQName.QUALIFYING_ADDRESS, paramStaxItDeserializationContext)) {
/*  88 */       localObject1 = new Address();
/*  89 */       StaxItEmlDeserializers.QUALIFYING_ADDRESS.deserialize((Address)localObject1, paramStaxItDeserializationContext);
/*     */ 
/*  91 */       paramCandidateBuilder.setAddress(((Address)localObject1).getStreet());
/*     */     }
/*     */ 
/*  95 */     if (nextEqualsQName(EmlQName.CONTACT, paramStaxItDeserializationContext)) {
/*  96 */       localObject1 = new Contact();
/*  97 */       StaxItEmlDeserializers.CONTACT.deserialize((Contact)localObject1, paramStaxItDeserializationContext);
/*  98 */       paramCandidateBuilder.setEmail(((Contact)localObject1).getEmail());
/*     */     }
/*     */ 
/* 102 */     if (nextEqualsQName(EmlQName.LOGO, paramStaxItDeserializationContext)) {
/* 103 */       localObject1 = new TypedImage();
/* 104 */       StaxItEmlDeserializers.LOGO.deserialize((TypedImage)localObject1, paramStaxItDeserializationContext);
/* 105 */       paramCandidateBuilder.setTypedImage((TypedImage)localObject1);
/*     */     }
/*     */ 
/* 108 */     if (nextEqualsQName(EmlQName.ADDITIONAL_LOGO, paramStaxItDeserializationContext)) {
/* 109 */       localObject1 = new TypedImage();
/* 110 */       StaxItEmlDeserializers.ADDITIONAL_LOGO.deserialize((TypedImage)localObject1, paramStaxItDeserializationContext);
/* 111 */       paramCandidateBuilder.setAdditionalImage((TypedImage)localObject1);
/*     */     }
/*     */ 
/* 115 */     if (nextEqualsQName(EmlQName.PROFESSION, paramStaxItDeserializationContext)) {
/* 116 */       paramCandidateBuilder.setProfession(requireElementValue(EmlQName.PROFESSION, paramStaxItDeserializationContext));
/*     */     }
/*     */ 
/* 121 */     localObject1 = new HashMap();
/*     */ 
/* 123 */     if (nextEqualsQName(EmlQName.PROFILE, paramStaxItDeserializationContext)) {
/* 124 */       StaxItEmlDeserializers.PROFILE.deserialize((Map)localObject1, paramStaxItDeserializationContext);
/* 125 */       localObject2 = (Message)((Map)localObject1).get(ScytlValues.MessageTypes.TEXT);
/* 126 */       paramCandidateBuilder.setProfileText((Message)localObject2);
/* 127 */       ((Map)localObject1).clear();
/*     */     }
/*     */ 
/* 132 */     if (nextEqualsQName(EmlQName.ELECTION_STATEMENT, paramStaxItDeserializationContext)) {
/* 133 */       StaxItEmlDeserializers.ELECTION_STATEMENT.deserialize((Map)localObject1, paramStaxItDeserializationContext);
/*     */ 
/* 135 */       localObject2 = (Message)((Map)localObject1).get(ScytlValues.MessageTypes.CANDIDATE_NAME);
/*     */ 
/* 137 */       paramCandidateBuilder.setText((Message)localObject2);
/*     */     }
/*     */ 
/* 140 */     Object localObject2 = new AnswerOthers();
/* 141 */     deserializeCommonOther((AnswerOthers)localObject2, paramStaxItDeserializationContext);
/* 142 */     paramCandidateBuilder.setOthers((AnswerOthers)localObject2);
/*     */ 
/* 144 */     ignoreUntilEndTag(EmlQName.CANDIDATE, paramStaxItDeserializationContext);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlCandidate
 * JD-Core Version:    0.6.0
 */