/*     */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*     */ 
/*     */ import com.scytl.xml.marshalling.eml.EmlQName;
/*     */ import com.scytl.xml.marshalling.eml.EmlUtils;
/*     */ import com.scytl.xml.marshalling.eml.ScytlQName;
/*     */ import com.scytl.xml.marshalling.eml.model.ContestBuilder;
/*     */ import com.scytl.xml.marshalling.eml.model.TypedImage;
/*     */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*     */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*     */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ 
/*     */ final class StaxItEmlContestOthers extends StaxItElementDeserializer<ContestBuilder>
/*     */ {
/*  31 */   private static final StaxItEmlContestOthers INSTANCE = new StaxItEmlContestOthers();
/*     */ 
/*     */   public static StaxItEmlContestOthers getInstance()
/*     */   {
/*  38 */     return INSTANCE;
/*     */   }
/*     */ 
/*     */   public final void deserialize(ContestBuilder paramContestBuilder, StaxItDeserializationContext paramStaxItDeserializationContext)
/*     */     throws DeserializationException, XMLStreamException
/*     */   {
/*  50 */     Object localObject = requireElementValue(ScytlQName.QUESTION_TYPE, paramStaxItDeserializationContext);
/*  51 */     paramContestBuilder.setQuestionType((String)localObject);
/*     */ 
/*  53 */     localObject = requireElementValue(ScytlQName.STATUS, paramStaxItDeserializationContext);
/*  54 */     paramContestBuilder.setStatus((String)localObject);
/*     */ 
/*  57 */     while (nextEqualsQName(ScytlQName.ALIAS, paramStaxItDeserializationContext))
/*     */     {
/*  59 */       localObject = readAttrib(localObject = requireElement(ScytlQName.ALIAS, paramStaxItDeserializationContext), 
/*  59 */         ScytlQName.ATTRIB__SOURCE).replace("Area", "");
/*     */ 
/*  62 */       requireCharacters(paramStaxItDeserializationContext);
/*  63 */       paramContestBuilder.getArea((String)localObject);
/*     */ 
/*  65 */       ignoreUntilEndTag(ScytlQName.ALIAS, paramStaxItDeserializationContext);
/*     */     }
/*     */ 
/*  68 */     localObject = requireElementValue(ScytlQName.PAGE_BREAK, paramStaxItDeserializationContext);
/*  69 */     paramContestBuilder.setPageBreak((String)localObject);
/*     */ 
/*  71 */     localObject = requireElementValue(ScytlQName.VIEW_TYPE, paramStaxItDeserializationContext);
/*  72 */     paramContestBuilder.setViewType((String)localObject);
/*     */ 
/*  74 */     localObject = requireElementValue(ScytlQName.STYLE_NAME, paramStaxItDeserializationContext);
/*  75 */     paramContestBuilder.setStyleName((String)localObject);
/*     */ 
/*  77 */     if (nextEqualsQName(ScytlQName.NUMBER_OF_LINES, paramStaxItDeserializationContext)) {
/*  78 */       localObject = requireElementValue(ScytlQName.NUMBER_OF_LINES, paramStaxItDeserializationContext);
/*  79 */       paramContestBuilder.setNumberOfLines((String)localObject);
/*     */     }
/*     */ 
/*  82 */     if (nextEqualsQName(ScytlQName.MIN_WRITE_IN, paramStaxItDeserializationContext)) {
/*  83 */       localObject = requireElementValue(ScytlQName.MIN_WRITE_IN, paramStaxItDeserializationContext);
/*  84 */       paramContestBuilder.setMinWriteIn(Integer.valueOf((String)localObject));
/*     */     }
/*     */ 
/*  88 */     if (nextEqualsQName(EmlQName.LOGO, paramStaxItDeserializationContext)) {
/*  89 */       localObject = new TypedImage();
/*  90 */       StaxItEmlDeserializers.LOGO.deserialize((TypedImage)localObject, paramStaxItDeserializationContext);
/*  91 */       paramContestBuilder.setImage(((TypedImage)localObject).getImage());
/*  92 */       paramContestBuilder.setImageType(((TypedImage)localObject).getType());
/*     */     }
/*     */ 
/*  95 */     if (nextEqualsQName(EmlQName.ADDITIONAL_LOGO, paramStaxItDeserializationContext)) {
/*  96 */       localObject = new TypedImage();
/*  97 */       StaxItEmlDeserializers.ADDITIONAL_LOGO.deserialize((TypedImage)localObject, paramStaxItDeserializationContext);
/*  98 */       paramContestBuilder.setAdditionalImage(((TypedImage)localObject).getImage());
/*  99 */       paramContestBuilder.setAdditionalImageType(((TypedImage)localObject).getType());
/*     */     }
/*     */ 
/* 103 */     if (nextEqualsQName(ScytlQName.DEFAULT_CANDIDATE, paramStaxItDeserializationContext)) {
/* 104 */       localObject = requireElementAttribute(ScytlQName.DEFAULT_CANDIDATE, ScytlQName.ATTRIB__ID, paramStaxItDeserializationContext);
/*     */ 
/* 107 */       paramContestBuilder.setDefaultAnswerIndex((String)localObject);
/*     */     }
/*     */ 
/* 111 */     if (nextEqualsQName(ScytlQName.LISTS_HEADER_HEIGHT, paramStaxItDeserializationContext)) {
/* 112 */       localObject = requireElementValue(ScytlQName.LISTS_HEADER_HEIGHT, paramStaxItDeserializationContext);
/*     */ 
/* 114 */       paramContestBuilder.setListsHeaderHeight(Integer.valueOf(EmlUtils.parseInt((String)localObject)));
/*     */     }
/*     */ 
/* 118 */     if (nextEqualsQName(ScytlQName.LISTS_HEIGHT, paramStaxItDeserializationContext)) {
/* 119 */       localObject = requireElementValue(ScytlQName.LISTS_HEIGHT, paramStaxItDeserializationContext);
/*     */ 
/* 121 */       paramContestBuilder.setListsHeight(Integer.valueOf(EmlUtils.parseInt((String)localObject)));
/*     */     }
/*     */ 
/* 124 */     if (nextEqualsQName(ScytlQName.LISTS_WIDTH, paramStaxItDeserializationContext)) {
/* 125 */       localObject = requireElementValue(ScytlQName.LISTS_WIDTH, paramStaxItDeserializationContext);
/*     */ 
/* 127 */       paramContestBuilder.setListsWidth(Integer.valueOf(EmlUtils.parseInt((String)localObject)));
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlContestOthers
 * JD-Core Version:    0.6.0
 */