/*    */ package com.scytl.xml.marshalling.stax.eml.unmarshallers;
/*    */ 
/*    */ import com.scytl.xml.marshalling.eml.EmlQName;
/*    */ import com.scytl.xml.marshalling.eml.model.ElectionIdentifierStructure;
/*    */ import com.scytl.xml.marshalling.exception.DeserializationException;
/*    */ import com.scytl.xml.marshalling.stax.StaxItDeserializationContext;
/*    */ import com.scytl.xml.marshalling.stax.StaxItElementDeserializer;
/*    */ import javax.xml.namespace.QName;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ 
/*    */ final class StaxItEmlElectionIdentifierStructure extends StaxItElementDeserializer<ElectionIdentifierStructure>
/*    */ {
/* 29 */   private static final StaxItEmlElectionIdentifierStructure IDENTIFIER_FOR_ELECTION = new StaxItEmlElectionIdentifierStructure(EmlQName.ELECTION_IDENTIFIER, EmlQName.ELECTION_NAME, EmlQName.ELECTION_GROUP);
/*    */ 
/* 38 */   private static final StaxItEmlElectionIdentifierStructure IDENTIFIER_FOR_BALLOT = new StaxItEmlElectionIdentifierStructure(EmlQName.BALLOT_IDENTIFIER, EmlQName.BALLOT_NAME, null);
/*    */   private final QName _elementTag;
/*    */   private final QName _elementNameTag;
/*    */   private final QName _elementGroupTag;
/*    */ 
/*    */   public static StaxItEmlElectionIdentifierStructure getIdentifierForElection()
/*    */   {
/* 35 */     return IDENTIFIER_FOR_ELECTION;
/*    */   }
/*    */ 
/*    */   public static StaxItEmlElectionIdentifierStructure getIdentifierForBallot()
/*    */   {
/* 43 */     return IDENTIFIER_FOR_BALLOT;
/*    */   }
/*    */ 
/*    */   private StaxItEmlElectionIdentifierStructure(QName elementTag, QName elementNameTag, QName elementGroupTag)
/*    */   {
/* 57 */     this._elementTag = elementTag;
/* 58 */     this._elementNameTag = elementNameTag;
/* 59 */     this._elementGroupTag = elementGroupTag;
/*    */   }
/*    */ 
/*    */   public final void deserialize(ElectionIdentifierStructure paramElectionIdentifierStructure, StaxItDeserializationContext paramStaxItDeserializationContext)
/*    */     throws DeserializationException, XMLStreamException
/*    */   {
/* 71 */     String str = requireElementAttribute(this._elementTag, EmlQName.ATTRIB__ID, paramStaxItDeserializationContext);
/*    */ 
/* 75 */     paramElectionIdentifierStructure.setId(str);
/*    */ 
/* 78 */     if ((nextEqualsQName(this._elementNameTag, paramStaxItDeserializationContext)) && (this._elementNameTag != null))
/*    */     {
/* 80 */       str = requireElementValue(this._elementNameTag, paramStaxItDeserializationContext);
/* 81 */       paramElectionIdentifierStructure.setName(str);
/*    */     }
/*    */ 
/* 85 */     if ((nextEqualsQName(this._elementGroupTag, paramStaxItDeserializationContext)) && (this._elementGroupTag != null))
/*    */     {
/* 87 */       str = requireElementAttribute(this._elementGroupTag, EmlQName.ATTRIB__ID, paramStaxItDeserializationContext);
/*    */ 
/* 90 */       paramElectionIdentifierStructure.setGroupId(str);
/*    */     }
/*    */ 
/* 93 */     ignoreUntilEndTag(this._elementTag, paramStaxItDeserializationContext);
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     com.scytl.xml.marshalling.stax.eml.unmarshallers.StaxItEmlElectionIdentifierStructure
 * JD-Core Version:    0.6.0
 */