/*     */ package org.apache.commons.codec.binary;
/*     */ 
/*     */ import com.scytl.common.domain.hibernate.entity.election.Answer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.DelegationChoiceQuestion;
/*     */ import com.scytl.common.domain.hibernate.entity.election.ListAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.Question;
/*     */ import com.scytl.common.domain.hibernate.entity.election.TextAnswer;
/*     */ import com.scytl.common.domain.hibernate.entity.election.WriteInAnswer;
/*     */ import com.scytl.common.domain.i18n.MessageFactory;
/*     */ import com.scytl.common.domain.i18n.MessageInitializer;
/*     */ 
/*     */ public abstract class BaseNCodec
/*     */ {
/*     */   private final int unencodedBlockSize;
/*     */   private final int encodedBlockSize;
/*     */   protected final int lineLength;
/*     */   private final int chunkSeparatorLength;
/*     */   protected byte[] buffer;
/*     */   protected int pos;
/*     */   private int readPos;
/*     */   protected boolean eof;
/*     */   protected int currentLinePos;
/*     */   protected int modulus;
/*     */ 
/*     */   protected BaseNCodec(int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*     */   {
/*  75 */     this.unencodedBlockSize = 3;
/*     */ 
/* 138 */     this.encodedBlockSize = 4;
/* 139 */     this.lineLength = ((paramInt3 > 0) && (paramInt4 > 0) ? paramInt3 / 4 << 2 : 0);
/* 140 */     this.chunkSeparatorLength = paramInt4;
/*     */   }
/*     */ 
/*     */   protected final void ensureBufferSize(int paramInt)
/*     */   {
/* 189 */     if ((this.buffer == null) || (this.buffer.length < this.pos + paramInt)) {
/* 190 */       this = this; if (this.buffer == null) { this.buffer = new byte[8192]; this.pos = 0; this.readPos = 0; return; } paramInt = new byte[this.buffer.length << 1]; System.arraycopy(this.buffer, 0, paramInt, 0, this.buffer.length); this.buffer = paramInt;
/*     */     }
/*     */   }
/*     */ 
/*     */   private int readResults(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
/*     */   {
/* 207 */     if (this.buffer != null) {
/* 208 */       paramInt1 = this; paramInt1 = Math.min(this.buffer != null ? paramInt1.pos - paramInt1.readPos : 0, paramInt2);
/* 209 */       System.arraycopy(this.buffer, this.readPos, paramArrayOfByte, 0, paramInt1);
/* 210 */       this.readPos += paramInt1;
/* 211 */       if (this.readPos >= this.pos) {
/* 212 */         this.buffer = null;
/*     */       }
/* 214 */       return paramInt1;
/*     */     }
/* 216 */     if (this.eof) return -1; return 0;
/*     */   }
/*     */ 
/*     */   private void reset()
/*     */   {
/* 242 */     this.buffer = null;
/* 243 */     this.pos = 0;
/* 244 */     this.readPos = 0;
/* 245 */     this.currentLinePos = 0;
/* 246 */     this.modulus = 0;
/* 247 */     this.eof = false;
/*     */   }
/*     */ 
/*     */   public final byte[] decode(byte[] paramArrayOfByte)
/*     */   {
/* 317 */     reset();
/* 318 */     if ((paramArrayOfByte == null) || (paramArrayOfByte.length == 0)) {
/* 319 */       return paramArrayOfByte;
/*     */     }
/* 321 */     decode(paramArrayOfByte, 0, paramArrayOfByte.length);
/* 322 */     decode(paramArrayOfByte, 0, -1);
/* 323 */     paramArrayOfByte = new byte[this.pos];
/* 324 */     readResults(paramArrayOfByte, 0, paramArrayOfByte.length);
/* 325 */     return paramArrayOfByte;
/*     */   }
/*     */ 
/*     */   public final byte[] encode(byte[] paramArrayOfByte)
/*     */   {
/* 336 */     reset();
/* 337 */     if ((paramArrayOfByte == null) || (paramArrayOfByte.length == 0)) {
/* 338 */       return paramArrayOfByte;
/*     */     }
/* 340 */     encode(paramArrayOfByte, 0, paramArrayOfByte.length);
/* 341 */     encode(paramArrayOfByte, 0, -1);
/* 342 */     paramArrayOfByte = new byte[this.pos - this.readPos];
/* 343 */     readResults(paramArrayOfByte, 0, paramArrayOfByte.length);
/* 344 */     return paramArrayOfByte;
/*     */   }
/*     */ 
/*     */   abstract void encode(byte[] paramArrayOfByte, int paramInt1, int paramInt2);
/*     */ 
/*     */   abstract void decode(byte[] paramArrayOfByte, int paramInt1, int paramInt2);
/*     */ 
/*     */   protected abstract boolean isInAlphabet(byte paramByte);
/*     */ 
/*     */   protected final boolean containsAlphabetOrPad(byte[] paramArrayOfByte)
/*     */   {
/* 415 */     if (paramArrayOfByte == null) {
/* 416 */       return false;
/*     */     }
/* 418 */     for (byte b : paramArrayOfByte) {
/* 419 */       if ((61 == b) || (isInAlphabet(b))) {
/* 420 */         return true;
/*     */       }
/*     */     }
/* 423 */     return false;
/*     */   }
/*     */ 
/*     */   public final long getEncodedLength(byte[] pArray)
/*     */   {
/* 437 */     long len = (pArray.length + this.unencodedBlockSize - 1) / this.unencodedBlockSize * this.encodedBlockSize;
/* 438 */     if (this.lineLength > 0)
/*     */     {
/* 440 */       len += (len + this.lineLength - 1L) / this.lineLength * this.chunkSeparatorLength;
/*     */     }
/* 442 */     return len;
/*     */   }
/*     */ 
/*     */   private BaseNCodec()
/*     */   {
/*     */   }
/*     */ 
/*     */   public static <T extends Question> T createQuestion(Class<T> paramClass)
/*     */   {
/*     */     if (paramClass == null)
/*     */       return null;
/*     */     try
/*     */     {
/*     */       if (Question.class.isAssignableFrom(paramClass))
/*     */       {
/*     */         (paramClass = (Question)paramClass.newInstance()).setText(MessageFactory.createMessage("Question Text"));
/*     */         paramClass.setTitle(MessageFactory.createMessage("Question Title"));
/*     */         paramClass.setAdditionalInformation(MessageFactory.createMessage("Question Additional Information"));
/*     */         paramClass.setCustomBlankVoteMessage(MessageFactory.createMessage("Custom blank vote message"));
/*     */         if (DelegationChoiceQuestion.class.isAssignableFrom(paramClass.getClass()))
/*     */         {
/*     */           (localDelegationChoiceQuestion = localObject = (DelegationChoiceQuestion)paramClass).setText(MessageFactory.createMessage("Question Text"));
/*     */           MessageInitializer.initialize(localDelegationChoiceQuestion.getText(), "default.delegation.question.text", "domain");
/*     */           localDelegationChoiceQuestion.setTitle(MessageFactory.createMessage("Question Title"));
/*     */           MessageInitializer.initialize(localDelegationChoiceQuestion.getTitle(), "default.delegation.question.text", "domain");
/*     */           (localWriteInAnswer = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(localWriteInAnswer.getText(), "default.delegation.delegate.extra1", "domain");
/*     */           localDelegationChoiceQuestion.setDelegateExtra1(localWriteInAnswer);
/*     */           (localWriteInAnswer = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(localWriteInAnswer.getText(), "default.delegation.delegate.extra2", "domain");
/*     */           localDelegationChoiceQuestion.setDelegateExtra2(localWriteInAnswer);
/*     */           DelegationChoiceQuestion localDelegationChoiceQuestion = localDelegationChoiceQuestion;
/*     */           Object localObject = localObject;
/*     */           (localObject = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(((WriteInAnswer)localObject).getText(), "default.delegation.delegate.id", "domain");
/*     */           localDelegationChoiceQuestion.setDelegateId((WriteInAnswer)localObject);
/*     */           (localObject = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(((WriteInAnswer)localObject).getText(), "default.delegation.delegate.email", "domain");
/*     */           localDelegationChoiceQuestion.setDelegateMail((WriteInAnswer)localObject);
/*     */           (localObject = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(((WriteInAnswer)localObject).getText(), "default.delegation.delegate.name", "domain");
/*     */           localDelegationChoiceQuestion.setDelegateName((WriteInAnswer)localObject);
/*     */           (localObject = (WriteInAnswer)createAnswer(WriteInAnswer.class)).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(((WriteInAnswer)localObject).getText(), "default.delegation.delegate.phone", "domain");
/*     */           localDelegationChoiceQuestion.setDelegatePhone((WriteInAnswer)localObject);
/*     */           WriteInAnswer localWriteInAnswer = (WriteInAnswer)createAnswer(WriteInAnswer.class);
/*     */           ((WriteInAnswer)localObject).setMaxWriteIn(Integer.valueOf(1000));
/*     */           MessageInitializer.initialize(localWriteInAnswer.getText(), "default.delegation.delegate.observations", "domain");
/*     */           localDelegationChoiceQuestion.setObservations(localWriteInAnswer);
/*     */         }
/*     */         return paramClass;
/*     */       }
/*     */       throw new RuntimeException("Class " + paramClass.getName() + " does not extend Question");
/*     */     }
/*     */     catch (java.lang.InstantiationException paramClass)
/*     */     {
/*     */       throw new RuntimeException(paramClass);
/*     */     }
/*     */     catch (java.lang.IllegalAccessException paramClass)
/*     */     {
/*     */     }
/*     */     throw new RuntimeException(paramClass);
/*     */   }
/*     */ 
/*     */   public static <T extends Answer> T createAnswer(Class<T> paramClass)
/*     */   {
/*     */     if (paramClass == null)
/*     */       return null;
/*     */     try
/*     */     {
/*     */       if (Answer.class.isAssignableFrom(paramClass))
/*     */       {
/*     */         (paramClass = (Answer)paramClass.newInstance()).setText(MessageFactory.createMessage("Text Answer"));
/*     */         if (!ListAnswer.class.isAssignableFrom(paramClass.getClass()))
/*     */           if (TextAnswer.class.isAssignableFrom(paramClass.getClass()))
/*     */             ((TextAnswer)paramClass).setProfileText(MessageFactory.createMessage("Profile"));
/*     */           else if (WriteInAnswer.class.isAssignableFrom(paramClass.getClass()))
/*     */             MessageInitializer.initialize(paramClass.getText(), "default.writein.answer", "domain");
/*     */         return paramClass;
/*     */       }
/*     */       throw new RuntimeException("Class " + paramClass.getName() + " does not extend Answer");
/*     */     }
/*     */     catch (java.lang.InstantiationException paramClass)
/*     */     {
/*     */       throw new RuntimeException(paramClass);
/*     */     }
/*     */     catch (java.lang.IllegalAccessException paramClass)
/*     */     {
/*     */     }
/*     */     throw new RuntimeException(paramClass);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.apache.commons.codec.binary.BaseNCodec
 * JD-Core Version:    0.6.0
 */