/*     */ package org.apache.commons.lang;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ 
/*     */ public final class ClassUtils
/*     */ {
/*     */   private static Map primitiveWrapperMap;
/*     */   private static Map wrapperPrimitiveMap;
/*     */   private static Map abbreviationMap;
/*     */   private static Map reverseAbbreviationMap;
/*     */ 
/*     */   private static void addAbbreviation(String paramString1, String paramString2)
/*     */   {
/* 111 */     abbreviationMap.put(paramString1, paramString2);
/* 112 */     reverseAbbreviationMap.put(paramString2, paramString1);
/*     */   }
/*     */ 
/*     */   public static String getShortClassName(Class paramClass)
/*     */   {
/* 164 */     if (paramClass == null) {
/* 165 */       return "";
/*     */     }
/* 167 */     if ((paramClass = paramClass.getName()) == null) return ""; if (paramClass.length() == 0) return ""; int i = paramClass.lastIndexOf('.'); int j = paramClass.indexOf('$', i == -1 ? 0 : i + 1); paramClass = paramClass.substring(i + 1); if (j != -1) paramClass = paramClass.replace('$', '.'); return paramClass;
/*     */   }
/*     */ 
/*     */   static
/*     */   {
/*  52 */     String.valueOf('.');
/*     */ 
/*  62 */     String.valueOf('$');
/*     */ 
/*  67 */     (
/*  69 */       ClassUtils.primitiveWrapperMap = new HashMap())
/*  69 */       .put(Boolean.TYPE, Boolean.class);
/*  70 */     primitiveWrapperMap.put(Byte.TYPE, Byte.class);
/*  71 */     primitiveWrapperMap.put(Character.TYPE, Character.class);
/*  72 */     primitiveWrapperMap.put(Short.TYPE, Short.class);
/*  73 */     primitiveWrapperMap.put(Integer.TYPE, Integer.class);
/*  74 */     primitiveWrapperMap.put(Long.TYPE, Long.class);
/*  75 */     primitiveWrapperMap.put(Double.TYPE, Double.class);
/*  76 */     primitiveWrapperMap.put(Float.TYPE, Float.class);
/*  77 */     primitiveWrapperMap.put(Void.TYPE, Void.TYPE);
/*     */ 
/*  83 */     wrapperPrimitiveMap = new HashMap();
/*     */ 
/*  85 */     for (Iterator localIterator = primitiveWrapperMap.keySet().iterator(); localIterator.hasNext(); ) {
/*  86 */       Class localClass1 = (Class)localIterator.next();
/*  87 */       Class localClass2 = (Class)primitiveWrapperMap.get(localClass1);
/*  88 */       if (!localClass1.equals(localClass2)) {
/*  89 */         wrapperPrimitiveMap.put(localClass2, localClass1);
/*     */       }
/*     */ 
/*     */     }
/*     */ 
/*  97 */     abbreviationMap = new HashMap();
/*     */ 
/* 102 */     reverseAbbreviationMap = new HashMap();
/*     */ 
/* 119 */     addAbbreviation("int", "I");
/* 120 */     addAbbreviation("boolean", "Z");
/* 121 */     addAbbreviation("float", "F");
/* 122 */     addAbbreviation("long", "J");
/* 123 */     addAbbreviation("short", "S");
/* 124 */     addAbbreviation("byte", "B");
/* 125 */     addAbbreviation("double", "D");
/* 126 */     addAbbreviation("char", "C");
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.apache.commons.lang.ClassUtils
 * JD-Core Version:    0.6.0
 */