/*      */ package org.apache.commons.lang;
/*      */ 
/*      */ import java.io.PrintStream;
/*      */ 
/*      */ public final class SystemUtils
/*      */ {
/*      */   private static String JAVA_VERSION;
/*      */   public static final String LINE_SEPARATOR;
/*      */   private static String OS_NAME;
/*      */   private static String OS_VERSION;
/*      */   private static String JAVA_VERSION_TRIMMED;
/*      */   private static int JAVA_VERSION_INT;
/*      */   private static boolean IS_OS_AIX;
/*      */   private static boolean IS_OS_HP_UX;
/*      */   private static boolean IS_OS_IRIX;
/*      */   public static final boolean IS_OS_LINUX;
/*      */   public static final boolean IS_OS_MAC_OSX;
/*      */   private static boolean IS_OS_SOLARIS;
/*      */   private static boolean IS_OS_SUN_OS;
/*      */   public static final boolean IS_OS_WINDOWS;
/*      */ 
/*      */   private static float getJavaVersionAsFloat()
/*      */   {
/* 1130 */     if (JAVA_VERSION_TRIMMED == null) {
/* 1131 */       return 0.0F;
/*      */     }
/* 1133 */     String str = JAVA_VERSION_TRIMMED.substring(0, 3);
/* 1134 */     if (JAVA_VERSION_TRIMMED.length() >= 5)
/* 1135 */       str = str + JAVA_VERSION_TRIMMED.substring(4, 5);
/*      */     try
/*      */     {
/* 1138 */       return Float.parseFloat(str); } catch (Exception localException) {
/*      */     }
/* 1140 */     return 0.0F;
/*      */   }
/*      */ 
/*      */   private static int getJavaVersionAsInt()
/*      */   {
/* 1159 */     if (JAVA_VERSION_TRIMMED == null) {
/* 1160 */       return 0;
/*      */     }
/* 1162 */     String str = JAVA_VERSION_TRIMMED.substring(0, 1);
/* 1163 */     str = str + JAVA_VERSION_TRIMMED.substring(2, 3);
/* 1164 */     if (JAVA_VERSION_TRIMMED.length() >= 5)
/* 1165 */       str = str + JAVA_VERSION_TRIMMED.substring(4, 5);
/*      */     else
/* 1167 */       str = str + "0";
/*      */     try
/*      */     {
/* 1170 */       return Integer.parseInt(str); } catch (Exception localException) {
/*      */     }
/* 1172 */     return 0;
/*      */   }
/*      */ 
/*      */   private static boolean getJavaVersionMatches(String versionPrefix)
/*      */   {
/* 1200 */     if (JAVA_VERSION_TRIMMED == null) {
/* 1201 */       return false;
/*      */     }
/* 1203 */     return JAVA_VERSION_TRIMMED.startsWith(versionPrefix);
/*      */   }
/*      */ 
/*      */   private static boolean getOSMatches(String osNamePrefix)
/*      */   {
/* 1213 */     if (OS_NAME == null) {
/* 1214 */       return false;
/*      */     }
/* 1216 */     return OS_NAME.startsWith(osNamePrefix);
/*      */   }
/*      */ 
/*      */   private static boolean getOSMatches(String paramString1, String paramString2)
/*      */   {
/* 1227 */     if ((OS_NAME == null) || (OS_VERSION == null)) {
/* 1228 */       return false;
/*      */     }
/* 1230 */     return (OS_NAME.startsWith(paramString1)) && (OS_VERSION.startsWith(paramString2));
/*      */   }
/*      */ 
/*      */   private static String getSystemProperty(String property)
/*      */   {
/*      */     try
/*      */     {
/* 1246 */       return System.getProperty(property);
/*      */     }
/*      */     catch (SecurityException localSecurityException1)
/*      */     {
/*      */       SecurityException ex;
/* 1249 */       System.err.println("Caught a SecurityException reading the system property '" + property + "'; the SystemUtils property value will default to null.");
/*      */     }
/*      */ 
/* 1253 */     return null;
/*      */   }
/*      */ 
/*      */   public static boolean isJavaVersionAtLeast(int paramInt)
/*      */   {
/* 1289 */     return JAVA_VERSION_INT >= paramInt;
/*      */   }
/*      */ 
/*      */   static
/*      */   {
/*   87 */     getSystemProperty("awt.toolkit");
/*      */ 
/*  105 */     getSystemProperty("file.encoding");
/*      */ 
/*  122 */     getSystemProperty("file.separator");
/*      */ 
/*  138 */     getSystemProperty("java.awt.fonts");
/*      */ 
/*  154 */     getSystemProperty("java.awt.graphicsenv");
/*      */ 
/*  175 */     getSystemProperty("java.awt.headless");
/*      */ 
/*  191 */     getSystemProperty("java.awt.printerjob");
/*      */ 
/*  207 */     getSystemProperty("java.class.path");
/*      */ 
/*  224 */     getSystemProperty("java.class.version");
/*      */ 
/*  241 */     getSystemProperty("java.compiler");
/*      */ 
/*  258 */     getSystemProperty("java.endorsed.dirs");
/*      */ 
/*  275 */     getSystemProperty("java.ext.dirs");
/*      */ 
/*  291 */     getSystemProperty("java.home");
/*      */ 
/*  307 */     getSystemProperty("java.io.tmpdir");
/*      */ 
/*  324 */     getSystemProperty("java.library.path");
/*      */ 
/*  342 */     getSystemProperty("java.runtime.name");
/*      */ 
/*  360 */     getSystemProperty("java.runtime.version");
/*      */ 
/*  377 */     getSystemProperty("java.specification.name");
/*      */ 
/*  394 */     getSystemProperty("java.specification.vendor");
/*      */ 
/*  411 */     getSystemProperty("java.specification.version");
/*      */ 
/*  428 */     getSystemProperty("java.util.prefs.PreferencesFactory");
/*      */ 
/*  445 */     getSystemProperty("java.vendor");
/*      */ 
/*  461 */     getSystemProperty("java.vendor.url");
/*      */ 
/*  477 */     JAVA_VERSION = getSystemProperty("java.version");
/*      */ 
/*  495 */     getSystemProperty("java.vm.info");
/*      */ 
/*  512 */     getSystemProperty("java.vm.name");
/*      */ 
/*  529 */     getSystemProperty("java.vm.specification.name");
/*      */ 
/*  546 */     getSystemProperty("java.vm.specification.vendor");
/*      */ 
/*  563 */     getSystemProperty("java.vm.specification.version");
/*      */ 
/*  580 */     getSystemProperty("java.vm.vendor");
/*      */ 
/*  597 */     getSystemProperty("java.vm.version");
/*      */ 
/*  614 */     LINE_SEPARATOR = getSystemProperty("line.separator");
/*      */ 
/*  630 */     getSystemProperty("os.arch");
/*      */ 
/*  646 */     OS_NAME = getSystemProperty("os.name");
/*      */ 
/*  662 */     OS_VERSION = getSystemProperty("os.version");
/*      */ 
/*  679 */     getSystemProperty("path.separator");
/*      */ 
/*  698 */     if (getSystemProperty("user.country") == null) getSystemProperty("user.region"); else getSystemProperty("user.country");
/*      */ 
/*  717 */     getSystemProperty("user.dir");
/*      */ 
/*  733 */     getSystemProperty("user.home");
/*      */ 
/*  751 */     getSystemProperty("user.language");
/*      */ 
/*  767 */     getSystemProperty("user.name");
/*      */ 
/*  784 */     getSystemProperty("user.timezone");
/*      */ 
/*  798 */     if (JAVA_VERSION != null) { int j;
/*  798 */       for (int i = 0; i < JAVA_VERSION.length(); i++); } JAVA_VERSION_TRIMMED = ((j = JAVA_VERSION.charAt(i)) >= '0') && (j <= 57) ? JAVA_VERSION.substring(i) : null;
/*      */ 
/*  818 */     getJavaVersionAsFloat();
/*      */ 
/*  833 */     JAVA_VERSION_INT = getJavaVersionAsInt();
/*      */ 
/*  846 */     getJavaVersionMatches("1.1");
/*      */ 
/*  854 */     getJavaVersionMatches("1.2");
/*      */ 
/*  862 */     getJavaVersionMatches("1.3");
/*      */ 
/*  870 */     getJavaVersionMatches("1.4");
/*      */ 
/*  878 */     getJavaVersionMatches("1.5");
/*      */ 
/*  886 */     getJavaVersionMatches("1.6");
/*      */ 
/*  904 */     IS_OS_AIX = getOSMatches("AIX");
/*      */ 
/*  914 */     IS_OS_HP_UX = getOSMatches("HP-UX");
/*      */ 
/*  924 */     IS_OS_IRIX = getOSMatches("Irix");
/*      */ 
/*  934 */     IS_OS_LINUX = (getOSMatches("Linux")) || (getOSMatches("LINUX"));
/*      */ 
/*  944 */     getOSMatches("Mac");
/*      */ 
/*  954 */     IS_OS_MAC_OSX = getOSMatches("Mac OS X");
/*      */ 
/*  964 */     getOSMatches("OS/2");
/*      */ 
/*  974 */     IS_OS_SOLARIS = getOSMatches("Solaris");
/*      */ 
/*  984 */     IS_OS_SUN_OS = getOSMatches("SunOS");
/*      */ 
/*  995 */     IS_OS_WINDOWS = getOSMatches("Windows");
/*      */ 
/* 1017 */     getOSMatches("Windows", "5.0");
/*      */ 
/* 1027 */     getOSMatches("Windows 9", "4.0");
/*      */ 
/* 1038 */     getOSMatches("Windows 9", "4.1");
/*      */ 
/* 1049 */     getOSMatches("Windows", "4.9");
/*      */ 
/* 1060 */     getOSMatches("Windows NT");
/*      */ 
/* 1071 */     getOSMatches("Windows", "5.1");
/*      */ 
/* 1082 */     getOSMatches("Windows", "6.0");
/*      */   }
/*      */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.apache.commons.lang.SystemUtils
 * JD-Core Version:    0.6.0
 */