/*     */ package org.apache.commons.lang.builder;
/*     */ 
/*     */ import java.math.BigDecimal;
/*     */ 
/*     */ public final class EqualsBuilder
/*     */ {
/*  92 */   private boolean isEquals = true;
/*     */ 
/*     */   public final EqualsBuilder appendSuper(boolean superEquals)
/*     */   {
/* 350 */     if (!this.isEquals) {
/* 351 */       return this;
/*     */     }
/* 353 */     this.isEquals = superEquals;
/* 354 */     return this;
/*     */   }
/*     */ 
/*     */   public final EqualsBuilder append(Object paramObject1, Object paramObject2)
/*     */   {
/* 368 */     if (!this.isEquals) {
/* 369 */       return this;
/*     */     }
/* 371 */     if (paramObject1 == paramObject2) {
/* 372 */       return this;
/*     */     }
/* 374 */     if ((paramObject1 == null) || (paramObject2 == null)) {
/* 375 */       paramObject2 = 0; paramObject2 = this; this.isEquals = false;
/* 376 */       return this;
/*     */     }
/*     */     Object localObject1;
/* 379 */     if (!(
/* 379 */       localObject1 = paramObject1.getClass())
/* 379 */       .isArray()) {
/* 380 */       if ((paramObject1 instanceof BigDecimal)) {
/* 381 */         this.isEquals = (((BigDecimal)paramObject1).compareTo(paramObject2) == 0);
/*     */       }
/*     */       else
/* 384 */         this.isEquals = paramObject1.equals(paramObject2);
/*     */     }
/* 386 */     else if (paramObject1.getClass() != paramObject2.getClass())
/*     */     {
/* 388 */       paramObject2 = 0; paramObject2 = this; this.isEquals = false;
/*     */     }
/*     */     else
/*     */     {
/*     */       int i;
/* 392 */       if ((paramObject1 instanceof long[])) {
/* 393 */         localObject1 = (long[])paramObject2; paramObject2 = (long[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) paramObject1.append(paramObject2[i], localObject1[i]);  }
/*     */       }
/* 394 */       else if ((paramObject1 instanceof int[])) {
/* 395 */         localObject1 = (int[])paramObject2; paramObject2 = (int[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) paramObject1.append(paramObject2[i], localObject1[i]);
/*     */           }
/*     */       }
/*     */       else
/*     */       {
/*     */         int m;
/*     */         int j;
/*     */         Object localObject2;
/* 396 */         if ((paramObject1 instanceof short[])) {
/* 397 */           localObject1 = (short[])paramObject2; paramObject2 = (short[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) { m = localObject1[i]; j = paramObject2[i]; localObject2.isEquals = (j == m); } } 
/*     */         }
/* 398 */         else if ((paramObject1 instanceof char[])) {
/* 399 */           localObject1 = (char[])paramObject2; paramObject2 = (char[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) { m = localObject1[i]; j = paramObject2[i]; localObject2.isEquals = (j == m); } } 
/*     */         }
/* 400 */         else if ((paramObject1 instanceof byte[])) {
/* 401 */           append((byte[])paramObject1, (byte[])paramObject2);
/* 402 */         } else if ((paramObject1 instanceof double[])) {
/* 403 */           localObject1 = (double[])paramObject2; paramObject2 = (double[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) { double d2 = localObject1[i]; double d1 = paramObject2[i]; (!(localObject2 = paramObject1).isEquals ? localObject2 : localObject2.append(Double.doubleToLongBits(d1), Double.doubleToLongBits(d2))); } } 
/*     */         }
/* 404 */         else if ((paramObject1 instanceof float[])) {
/* 405 */           localObject1 = (float[])paramObject2; paramObject2 = (float[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) { float f2 = localObject1[i]; float f1 = paramObject2[i]; (!(localObject2 = paramObject1).isEquals ? localObject2 : localObject2.append(Float.floatToIntBits(f1), Float.floatToIntBits(f2))); } } 
/*     */         }
/* 406 */         else if ((paramObject1 instanceof boolean[])) {
/* 407 */           localObject1 = (boolean[])paramObject2; paramObject2 = (boolean[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) { int n = localObject1[i]; int k = paramObject2[i]; localObject2.isEquals = (k == n); } } 
/*     */         }
/*     */         else
/*     */         {
/* 410 */           localObject1 = (Object[])paramObject2; paramObject2 = (Object[])paramObject1; paramObject1 = this; if ((this.isEquals) && (paramObject2 != localObject1)) if ((paramObject2 == null) || (localObject1 == null)) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else if (paramObject2.length != localObject1.length) { paramObject2 = 0; (paramObject2 = paramObject1).isEquals = false; } else { for (i = 0; (i < paramObject2.length) && (paramObject1.isEquals); i++) paramObject1.append(paramObject2[i], localObject1[i]);  } 
/*     */         }
/*     */       }
/*     */     }
/* 412 */     return (EqualsBuilder)this;
/*     */   }
/*     */ 
/*     */   private EqualsBuilder append(long lhs, long rhs)
/*     */   {
/* 427 */     if (!this.isEquals) {
/* 428 */       return this;
/*     */     }
/* 430 */     this.isEquals = (lhs == rhs);
/* 431 */     return this;
/*     */   }
/*     */ 
/*     */   private EqualsBuilder append(int lhs, int rhs)
/*     */   {
/* 442 */     if (!this.isEquals) {
/* 443 */       return this;
/*     */     }
/* 445 */     this.isEquals = (lhs == rhs);
/* 446 */     return this;
/*     */   }
/*     */ 
/*     */   public final EqualsBuilder append(byte[] paramArrayOfByte1, byte[] paramArrayOfByte2)
/*     */   {
/* 715 */     if (!this.isEquals) {
/* 716 */       return this;
/*     */     }
/* 718 */     if (paramArrayOfByte1 == paramArrayOfByte2) {
/* 719 */       return this;
/*     */     }
/* 721 */     if ((paramArrayOfByte1 == null) || (paramArrayOfByte2 == null)) {
/* 722 */       paramArrayOfByte1 = 0; paramArrayOfByte1 = this; this.isEquals = false;
/* 723 */       return this;
/*     */     }
/* 725 */     if (paramArrayOfByte1.length != paramArrayOfByte2.length) {
/* 726 */       paramArrayOfByte1 = 0; paramArrayOfByte1 = this; this.isEquals = false;
/* 727 */       return this;
/*     */     }
/*     */     EqualsBuilder localEqualsBuilder;
/* 729 */     for (int i = 0; (i < paramArrayOfByte1.length) && (this.isEquals); i++) {
/* 730 */       int k = paramArrayOfByte2[i]; int j = paramArrayOfByte1[i]; localEqualsBuilder = this; localEqualsBuilder.isEquals = (j == k);
/*     */     }
/* 732 */     return this;
/*     */   }
/*     */ 
/*     */   public final boolean isEquals()
/*     */   {
/* 835 */     return this.isEquals;
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.apache.commons.lang.builder.EqualsBuilder
 * JD-Core Version:    0.6.0
 */