/*     */ package org.apache.commons.logging.impl;
/*     */ 
/*     */ import java.io.PrintStream;
/*     */ import java.util.Enumeration;
/*     */ import java.util.HashMap;
/*     */ import java.util.Hashtable;
/*     */ import java.util.Map;
/*     */ import java.util.Vector;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogConfigurationException;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.slf4j.LoggerFactory;
/*     */ import org.slf4j.spi.LocationAwareLogger;
/*     */ 
/*     */ public class SLF4JLogFactory extends LogFactory
/*     */ {
/*     */   private Map loggerMap;
/*     */   public static final String LOG_PROPERTY = "org.apache.commons.logging.Log";
/*  82 */   private Hashtable attributes = new Hashtable();
/*     */ 
/*     */   public SLF4JLogFactory()
/*     */   {
/*  66 */     this.loggerMap = new HashMap();
/*     */   }
/*     */ 
/*     */   public Object getAttribute(String name)
/*     */   {
/*  95 */     return this.attributes.get(name);
/*     */   }
/*     */ 
/*     */   public String[] getAttributeNames()
/*     */   {
/* 106 */     Vector localVector = new Vector();
/* 107 */     this = this.attributes.keys();
/* 108 */     while (hasMoreElements()) {
/* 109 */       localVector.addElement((String)nextElement());
/*     */     }
/* 111 */     this = new String[localVector.size()];
/* 112 */     for (int i = 0; i < this.length; i++) {
/* 113 */       this[i] = ((String)localVector.elementAt(i));
/*     */     }
/* 115 */     return this;
/*     */   }
/*     */ 
/*     */   public Log getInstance(Class clazz)
/*     */     throws LogConfigurationException
/*     */   {
/* 131 */     return getInstance(clazz.getName());
/*     */   }
/*     */ 
/*     */   public Log getInstance(String paramString)
/*     */     throws LogConfigurationException
/*     */   {
/*     */     Object localObject1;
/* 150 */     synchronized (this)
/*     */     {
/* 154 */       if ((
/* 154 */         localObject1 = (Log)this.loggerMap.get(paramString)) == null)
/*     */       {
/* 156 */         if (((
/* 156 */           localObject1 = LoggerFactory.getLogger$424215df(paramString)) instanceof LocationAwareLogger))
/*     */         {
/* 157 */           localObject1 = new SLF4JLocationAwareLog((LocationAwareLogger)localObject1);
/*     */         }
/* 159 */         else localObject1 = new SLF4JLog((ComponentMonitor)localObject1);
/*     */ 
/* 161 */         this.loggerMap.put(paramString, localObject1);
/*     */       }
/*     */     }
/* 164 */     return (Log)localObject1;
/*     */   }
/*     */ 
/*     */   public void release()
/*     */   {
/* 184 */     System.out.println("WARN: The method " + SLF4JLogFactory.class + "#release() was invoked.");
/*     */ 
/* 186 */     System.out.println("WARN: Please see http://www.slf4j.org/codes.html#release for an explanation.");
/*     */ 
/* 188 */     System.out.flush();
/*     */   }
/*     */ 
/*     */   public void removeAttribute(String paramString)
/*     */   {
/* 199 */     this.attributes.remove(paramString);
/*     */   }
/*     */ 
/*     */   public void setAttribute(String paramString, Object paramObject)
/*     */   {
/* 215 */     if (paramObject == null) {
/* 216 */       this.attributes.remove(paramString); return;
/*     */     }
/* 218 */     this.attributes.put(paramString, paramObject);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.apache.commons.logging.impl.SLF4JLogFactory
 * JD-Core Version:    0.6.0
 */