package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

public abstract class ASN1Encodable
  implements DEREncodable
{
  public final byte[] getEncoded()
    throws IOException
  {
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    ASN1OutputStream localASN1OutputStream;
    (localASN1OutputStream = new ASN1OutputStream(localByteArrayOutputStream)).writeObject(this);
    return localByteArrayOutputStream.toByteArray();
  }

  public final byte[] getEncoded(String paramString)
    throws IOException
  {
    if (paramString.equals("DER"))
    {
      paramString = new ByteArrayOutputStream();
      DEROutputStream localDEROutputStream;
      (localDEROutputStream = new DEROutputStream(paramString)).writeObject(this);
      return paramString.toByteArray();
    }
    return getEncoded();
  }

  public final byte[] getDEREncoded()
  {
    try
    {
      return getEncoded("DER");
    }
    catch (IOException localIOException)
    {
    }
    return null;
  }

  public int hashCode()
  {
    return toASN1Object().hashCode();
  }

  public boolean equals(Object paramObject)
  {
    if (this == paramObject)
      return true;
    if (!(paramObject instanceof DEREncodable))
      return false;
    paramObject = (DEREncodable)paramObject;
    return toASN1Object().equals(paramObject.getDERObject());
  }

  public final DERObject getDERObject()
  {
    return toASN1Object();
  }

  public abstract DERObject toASN1Object();
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ASN1Encodable
 * JD-Core Version:    0.6.0
 */