package org.bouncycastle.asn1;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import org.bouncycastle.util.Arrays;
import org.bouncycastle.util.encoders.Hex;

public abstract class ASN1OctetString extends ASN1Object
  implements ASN1SequenceParser
{
  byte[] string;

  public ASN1OctetString(byte[] paramArrayOfByte)
  {
    if (paramArrayOfByte == null)
      throw new NullPointerException("string cannot be null");
    this.string = paramArrayOfByte;
  }

  public final InputStream getOctetStream()
  {
    return new ByteArrayInputStream(this.string);
  }

  public byte[] getOctets()
  {
    return this.string;
  }

  public int hashCode()
  {
    return Arrays.hashCode(getOctets());
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof ASN1OctetString))
      return false;
    paramDERObject = (ASN1OctetString)paramDERObject;
    return Arrays.areEqual(this.string, paramDERObject.string);
  }

  public final DERObject getLoadedObject()
  {
    return getDERObject();
  }

  public String toString()
  {
    return "#" + new String(Hex.encode(this.string));
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ASN1OctetString
 * JD-Core Version:    0.6.0
 */