package org.bouncycastle.asn1;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public abstract class ASN1Sequence extends ASN1Object
{
  private Vector seq = new Vector();

  public static ASN1Sequence getInstance(Object paramObject)
  {
    if ((paramObject == null) || ((paramObject instanceof ASN1Sequence)))
      return (ASN1Sequence)paramObject;
    if ((paramObject instanceof byte[]))
      try
      {
        return getInstance(ASN1Object.fromByteArray((byte[])paramObject));
      }
      catch (IOException paramObject)
      {
        throw new IllegalArgumentException("failed to construct sequence from byte[]: " + paramObject.getMessage());
      }
    throw new IllegalArgumentException("unknown object in getInstance: " + paramObject.getClass().getName());
  }

  public Enumeration getObjects()
  {
    return this.seq.elements();
  }

  public DEREncodable getObjectAt(int paramInt)
  {
    return (DEREncodable)this.seq.elementAt(paramInt);
  }

  public int size()
  {
    return this.seq.size();
  }

  public int hashCode()
  {
    Enumeration localEnumeration = getObjects();
    DEREncodable localDEREncodable;
    for (this = size(); localEnumeration.hasMoreElements(); this = this *= 17 ^ localDEREncodable.hashCode())
      localDEREncodable = getNext(localEnumeration);
    return this;
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof ASN1Sequence))
      return false;
    paramDERObject = (ASN1Sequence)paramDERObject;
    if (size() != paramDERObject.size())
      return false;
    this = getObjects();
    paramDERObject = paramDERObject.getObjects();
    while (hasMoreElements())
    {
      Object localObject1 = getNext(this);
      Object localObject2 = getNext(paramDERObject);
      localObject1 = ((DEREncodable)localObject1).getDERObject();
      localObject2 = ((DEREncodable)localObject2).getDERObject();
      if ((localObject1 != localObject2) && (!((DERObject)localObject1).equals(localObject2)))
        return false;
    }
    return true;
  }

  private static DEREncodable getNext(Enumeration paramEnumeration)
  {
    if ((paramEnumeration = (DEREncodable)paramEnumeration.nextElement()) == null)
      return DERNull.INSTANCE;
    return paramEnumeration;
  }

  protected final void addObject(DEREncodable paramDEREncodable)
  {
    this.seq.addElement(paramDEREncodable);
  }

  public String toString()
  {
    return this.seq.toString();
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ASN1Sequence
 * JD-Core Version:    0.6.0
 */