package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public abstract class ASN1Set extends ASN1Object
{
  private Vector set = new Vector();

  public static ASN1Set getInstance(Object paramObject)
  {
    if ((paramObject == null) || ((paramObject instanceof ASN1Set)))
      return (ASN1Set)paramObject;
    throw new IllegalArgumentException("unknown object in getInstance: " + paramObject.getClass().getName());
  }

  public final Enumeration getObjects()
  {
    return this.set.elements();
  }

  public final DEREncodable getObjectAt(int paramInt)
  {
    return (DEREncodable)this.set.elementAt(paramInt);
  }

  public final int size()
  {
    return this.set.size();
  }

  public int hashCode()
  {
    Object localObject = this;
    Enumeration localEnumeration = this.set.elements();
    localObject = this;
    for (this = this.set.size(); localEnumeration.hasMoreElements(); this = this *= 17 ^ localObject.hashCode())
      localObject = getNext(localEnumeration);
    return this;
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof ASN1Set))
      return false;
    paramDERObject = (ASN1Set)paramDERObject;
    Object localObject1 = this;
    if (this.set.size() != (localObject1 = paramDERObject).set.size())
      return false;
    localObject1 = this;
    this = this.set.elements();
    paramDERObject = (localObject1 = paramDERObject).set.elements();
    while (hasMoreElements())
    {
      localObject1 = getNext(this);
      Object localObject2 = getNext(paramDERObject);
      localObject1 = ((DEREncodable)localObject1).getDERObject();
      localObject2 = ((DEREncodable)localObject2).getDERObject();
      if ((localObject1 != localObject2) && (!((DERObject)localObject1).equals(localObject2)))
        return false;
    }
    return true;
  }

  private static DEREncodable getNext(Enumeration paramEnumeration)
  {
    if ((paramEnumeration = (DEREncodable)paramEnumeration.nextElement()) == null)
      return DERNull.INSTANCE;
    return paramEnumeration;
  }

  private static byte[] getEncoded(DEREncodable paramDEREncodable)
  {
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    ASN1OutputStream localASN1OutputStream = new ASN1OutputStream(localByteArrayOutputStream);
    try
    {
      localASN1OutputStream.writeObject(paramDEREncodable);
    }
    catch (IOException localIOException)
    {
      throw new IllegalArgumentException("cannot encode object added to SET");
    }
    return localByteArrayOutputStream.toByteArray();
  }

  protected final void sort()
  {
    if (this.set.size() > 1)
    {
      int i = 1;
      int n;
      for (int k = this.set.size() - 1; i != 0; k = n)
      {
        int m = 0;
        n = 0;
        Object localObject2 = getEncoded((DEREncodable)this.set.elementAt(0));
        i = 0;
        while (m != k)
        {
          byte[] arrayOfByte1 = getEncoded((DEREncodable)this.set.elementAt(m + 1));
          byte[] arrayOfByte2 = arrayOfByte1;
          Object localObject3;
          int i1 = Math.min((localObject3 = localObject2).length, arrayOfByte2.length);
          for (int i2 = 0; i2 != i1; i2++);
          if ((i1 == localObject3.length ? 1 : localObject3[i2] != arrayOfByte2[i2] ? 0 : (localObject3[i2] & 0xFF) < (arrayOfByte2[i2] & 0xFF) ? 1 : 0) != 0)
          {
            localObject2 = arrayOfByte1;
          }
          else
          {
            Object localObject1 = this.set.elementAt(m);
            this.set.setElementAt(this.set.elementAt(m + 1), m);
            this.set.setElementAt(localObject1, m + 1);
            int j = 1;
            n = m;
          }
          m++;
        }
      }
    }
  }

  protected final void addObject(DEREncodable paramDEREncodable)
  {
    this.set.addElement(paramDEREncodable);
  }

  public String toString()
  {
    return this.set.toString();
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ASN1Set
 * JD-Core Version:    0.6.0
 */