package org.bouncycastle.asn1;

public abstract class ASN1TaggedObject extends ASN1Object
  implements ASN1SequenceParser
{
  int tagNo;
  boolean empty = false;
  boolean explicit = true;
  DEREncodable obj = null;

  public ASN1TaggedObject(int paramInt, DEREncodable paramDEREncodable)
  {
    this.explicit = true;
    this.tagNo = paramInt;
    this.obj = paramDEREncodable;
  }

  public ASN1TaggedObject(boolean paramBoolean, int paramInt, DEREncodable paramDEREncodable)
  {
    if ((paramDEREncodable instanceof ASN1Choice))
      this.explicit = true;
    else
      this.explicit = paramBoolean;
    this.tagNo = paramInt;
    this.obj = paramDEREncodable;
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof ASN1TaggedObject))
      return false;
    paramDERObject = (ASN1TaggedObject)paramDERObject;
    if ((this.tagNo != paramDERObject.tagNo) || (this.explicit != paramDERObject.explicit))
      return false;
    if (this.obj == null)
    {
      if (paramDERObject.obj != null)
        return false;
    }
    else if (!this.obj.getDERObject().equals(paramDERObject.obj.getDERObject()))
      return false;
    return true;
  }

  public int hashCode()
  {
    int i = this.tagNo;
    if (this.obj != null)
      i ^= this.obj.hashCode();
    return i;
  }

  public final int getTagNo()
  {
    return this.tagNo;
  }

  public final boolean isExplicit()
  {
    return this.explicit;
  }

  public final DERObject getObject()
  {
    if (this.obj != null)
      return this.obj.getDERObject();
    return null;
  }

  public final DERObject getLoadedObject()
  {
    return getDERObject();
  }

  public String toString()
  {
    return "[" + this.tagNo + "]" + this.obj;
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ASN1TaggedObject
 * JD-Core Version:    0.6.0
 */