package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public final class BERConstructedOctetString extends DEROctetString
{
  private Vector octs;

  private static byte[] toBytes(Vector paramVector)
  {
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    for (int i = 0; i != paramVector.size(); i++)
      try
      {
        DEROctetString localDEROctetString = (DEROctetString)paramVector.elementAt(i);
        localByteArrayOutputStream.write(localDEROctetString.getOctets());
      }
      catch (ClassCastException localClassCastException)
      {
        throw new IllegalArgumentException(paramVector.elementAt(i).getClass().getName() + " found in input should only contain DEROctetString");
      }
      catch (IOException localIOException)
      {
        throw new IllegalArgumentException("exception converting octets " + localIOException.toString());
      }
    return localByteArrayOutputStream.toByteArray();
  }

  public BERConstructedOctetString(byte[] paramArrayOfByte)
  {
    super(paramArrayOfByte);
  }

  public BERConstructedOctetString(Vector paramVector)
  {
    super(toBytes(paramVector));
    this.octs = paramVector;
  }

  public final byte[] getOctets()
  {
    return this.string;
  }

  public final Enumeration getObjects()
  {
    if (this.octs == null)
    {
      this = this;
      Vector localVector = new Vector();
      for (int i = 0; i < this.string.length; i += 1000)
      {
        int j;
        if (i + 1000 > this.string.length)
          j = this.string.length;
        else
          j = i + 1000;
        byte[] arrayOfByte = new byte[j - i];
        System.arraycopy(this.string, i, arrayOfByte, 0, arrayOfByte.length);
        localVector.addElement(new DEROctetString(arrayOfByte));
      }
      return localVector.elements();
    }
    return this.octs.elements();
  }

  public final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    if (((paramDEROutputStream instanceof ASN1OutputStream)) || ((paramDEROutputStream instanceof BEROutputStream)))
    {
      paramDEROutputStream.write(36);
      paramDEROutputStream.write(128);
      this = getObjects();
      while (hasMoreElements())
        paramDEROutputStream.writeObject(nextElement());
      paramDEROutputStream.write(0);
      paramDEROutputStream.write(0);
      return;
    }
    super.encode(paramDEROutputStream);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.BERConstructedOctetString
 * JD-Core Version:    0.6.0
 */