package org.bouncycastle.asn1;

import java.io.IOException;
import java.io.InputStream;
import org.bouncycastle.util.io.Streams;

public final class BEROctetStringParser
  implements ASN1SequenceParser
{
  private ASN1StreamParser _parser;

  BEROctetStringParser(ASN1StreamParser paramASN1StreamParser)
  {
    this._parser = paramASN1StreamParser;
  }

  public final InputStream getOctetStream()
  {
    return new ConstructedOctetStream(this._parser);
  }

  public final DERObject getLoadedObject()
    throws IOException
  {
    return new BERConstructedOctetString(Streams.readAll(getOctetStream()));
  }

  public final DERObject getDERObject()
  {
    try
    {
      return getLoadedObject();
    }
    catch (IOException this)
    {
    }
    throw new ASN1ParsingException("IOException converting stream to byte array: " + getMessage(), this);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.BEROctetStringParser
 * JD-Core Version:    0.6.0
 */