package org.bouncycastle.asn1;

import java.io.IOException;
import java.io.InputStream;

final class ConstructedOctetStream extends InputStream
{
  private final ASN1StreamParser _parser;
  private boolean _first = true;
  private InputStream _currentStream;

  ConstructedOctetStream(ASN1StreamParser paramASN1StreamParser)
  {
    this._parser = paramASN1StreamParser;
  }

  public final int read(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
    throws IOException
  {
    if (this._currentStream == null)
    {
      if (!this._first)
        return -1;
      ASN1SequenceParser localASN1SequenceParser1;
      if ((localASN1SequenceParser1 = (ASN1SequenceParser)this._parser.readObject()) == null)
        return -1;
      this._first = false;
      this._currentStream = localASN1SequenceParser1.getOctetStream();
    }
    int i = 0;
    while (true)
    {
      int j;
      if ((j = this._currentStream.read(paramArrayOfByte, paramInt1 + i, paramInt2 - i)) >= 0)
      {
        if (i += j == paramInt2)
          return i;
      }
      else
      {
        ASN1SequenceParser localASN1SequenceParser2;
        if ((localASN1SequenceParser2 = (ASN1SequenceParser)this._parser.readObject()) == null)
        {
          this._currentStream = null;
          if (i < 1)
            return -1;
          return i;
        }
        this._currentStream = localASN1SequenceParser2.getOctetStream();
      }
    }
  }

  public final int read()
    throws IOException
  {
    ASN1SequenceParser localASN1SequenceParser1;
    if (this._currentStream == null)
    {
      if (!this._first)
        return -1;
      if ((localASN1SequenceParser1 = (ASN1SequenceParser)this._parser.readObject()) == null)
        return -1;
      this._first = false;
    }
    ASN1SequenceParser localASN1SequenceParser2;
    for (this._currentStream = localASN1SequenceParser1.getOctetStream(); ; this._currentStream = localASN1SequenceParser2.getOctetStream())
    {
      int i;
      if ((i = this._currentStream.read()) >= 0)
        return i;
      if ((localASN1SequenceParser2 = (ASN1SequenceParser)this._parser.readObject()) != null)
        continue;
      this._currentStream = null;
      return -1;
    }
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.ConstructedOctetStream
 * JD-Core Version:    0.6.0
 */