package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Vector;
import org.bouncycastle.util.Arrays;

public class DERApplicationSpecific extends ASN1Object
{
  private final boolean isConstructed;
  private final int tag;
  private final byte[] octets;

  DERApplicationSpecific(boolean paramBoolean, int paramInt, byte[] paramArrayOfByte)
  {
    this.isConstructed = paramBoolean;
    this.tag = paramInt;
    this.octets = paramArrayOfByte;
  }

  public DERApplicationSpecific(int paramInt, ASN1EncodableVector paramASN1EncodableVector)
  {
    this.tag = paramInt;
    this.isConstructed = true;
    paramInt = new ByteArrayOutputStream();
    ASN1EncodableVector localASN1EncodableVector;
    for (int i = 0; i != (localASN1EncodableVector = paramASN1EncodableVector).v.size(); i++)
      try
      {
        paramInt.write(((ASN1Encodable)paramASN1EncodableVector.get(i)).getEncoded());
      }
      catch (IOException this)
      {
        throw new ASN1ParsingException("malformed object: " + this, this);
      }
    this.octets = paramInt.toByteArray();
  }

  public final boolean isConstructed()
  {
    return this.isConstructed;
  }

  public final byte[] getContents()
  {
    return this.octets;
  }

  public final int getApplicationTag()
  {
    return this.tag;
  }

  public final DERObject getObject(int paramInt)
    throws IOException
  {
    this = getEncoded();
    DERApplicationSpecific localDERApplicationSpecific = this;
    paramInt = 16;
    int i = localDERApplicationSpecific[0] & 0x1F;
    int j = 1;
    if (i == 31)
    {
      j++;
      if (((i = localDERApplicationSpecific[1] & 0xFF) & 0x7F) == 0)
        throw new ASN1ParsingException("corrupted stream - invalid high tag number found");
      while ((i >= 0) && ((i & 0x80) != 0))
        i = localDERApplicationSpecific[(j++)] & 0xFF;
    }
    byte[] arrayOfByte = new byte[localDERApplicationSpecific.length - j + 1];
    System.arraycopy(localDERApplicationSpecific, j, arrayOfByte, 1, arrayOfByte.length - 1);
    arrayOfByte[0] = (byte)paramInt;
    paramInt = arrayOfByte;
    if ((this[0] & 0x20) != 0)
    {
      int tmp121_120 = 0;
      int tmp121_119 = paramInt;
      tmp121_119[tmp121_120] = (byte)(tmp121_119[tmp121_120] | 0x20);
    }
    return new ASN1InputStream(paramInt).readObject();
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    int i = 64;
    if (this.isConstructed)
      i = 96;
    paramDEROutputStream.writeEncoded(i, this.tag, this.octets);
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERApplicationSpecific))
      return false;
    paramDERObject = (DERApplicationSpecific)paramDERObject;
    return (this.isConstructed == paramDERObject.isConstructed) && (this.tag == paramDERObject.tag) && (Arrays.areEqual(this.octets, paramDERObject.octets));
  }

  public int hashCode()
  {
    return (this.isConstructed ? 1 : 0) ^ this.tag ^ Arrays.hashCode(this.octets);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERApplicationSpecific
 * JD-Core Version:    0.6.0
 */