package org.bouncycastle.asn1;

import java.io.IOException;

public final class DERBMPString extends ASN1Object
  implements DERString
{
  private String string;

  public DERBMPString(byte[] paramArrayOfByte)
  {
    char[] arrayOfChar = new char[paramArrayOfByte.length / 2];
    for (int i = 0; i != arrayOfChar.length; i++)
      arrayOfChar[i] = (char)(paramArrayOfByte[(i * 2)] << 8 | paramArrayOfByte[(i * 2 + 1)] & 0xFF);
    this.string = new String(arrayOfChar);
  }

  public final String getString()
  {
    return this.string;
  }

  public final String toString()
  {
    return this.string;
  }

  public final int hashCode()
  {
    return getString().hashCode();
  }

  protected final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERBMPString))
      return false;
    paramDERObject = (DERBMPString)paramDERObject;
    return getString().equals(paramDERObject.getString());
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    byte[] arrayOfByte = new byte[(this = this.string.toCharArray()).length << 1];
    for (int i = 0; i != this.length; i++)
    {
      arrayOfByte[(i * 2)] = (byte)(this[i] >> '\b');
      arrayOfByte[(i * 2 + 1)] = (byte)this[i];
    }
    paramDEROutputStream.writeEncoded(30, arrayOfByte);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERBMPString
 * JD-Core Version:    0.6.0
 */