package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import org.bouncycastle.util.Arrays;

public final class DERBitString extends ASN1Object
  implements DERString
{
  private static final char[] table = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
  private byte[] data;
  private int padBits;

  private DERBitString(byte[] paramArrayOfByte, int paramInt)
  {
    this.data = paramArrayOfByte;
    this.padBits = paramInt;
  }

  public final byte[] getBytes()
  {
    return this.data;
  }

  public final int getPadBits()
  {
    return this.padBits;
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    DERBitString localDERBitString = this;
    byte[] arrayOfByte;
    localDERBitString = this;
    (arrayOfByte = new byte[this.data.length + 1])[0] = (byte)this.padBits;
    localDERBitString = this;
    System.arraycopy(this.data, 0, arrayOfByte, 1, arrayOfByte.length - 1);
    paramDEROutputStream.writeEncoded(3, arrayOfByte);
  }

  public final int hashCode()
  {
    return this.padBits ^ Arrays.hashCode(this.data);
  }

  protected final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERBitString))
      return false;
    paramDERObject = (DERBitString)paramDERObject;
    return (this.padBits == paramDERObject.padBits) && (Arrays.areEqual(this.data, paramDERObject.data));
  }

  public final String getString()
  {
    StringBuffer localStringBuffer = new StringBuffer("#");
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    ASN1OutputStream localASN1OutputStream = new ASN1OutputStream(localByteArrayOutputStream);
    try
    {
      localASN1OutputStream.writeObject(this);
    }
    catch (IOException localIOException)
    {
      throw new RuntimeException("internal error encoding BitString");
    }
    this = localByteArrayOutputStream.toByteArray();
    for (int i = 0; i != this.length; i++)
    {
      localStringBuffer.append(table[(this[i] >>> 4 & 0xF)]);
      localStringBuffer.append(table[(this[i] & 0xF)]);
    }
    return localStringBuffer.toString();
  }

  public final String toString()
  {
    return getString();
  }

  static DERBitString fromOctetString(byte[] paramArrayOfByte)
  {
    if (paramArrayOfByte.length < 1)
      throw new IllegalArgumentException("truncated BIT STRING detected");
    int i = paramArrayOfByte[0];
    byte[] arrayOfByte;
    if ((arrayOfByte = new byte[paramArrayOfByte.length - 1]).length != 0)
      System.arraycopy(paramArrayOfByte, 1, arrayOfByte, 0, paramArrayOfByte.length - 1);
    return new DERBitString(arrayOfByte, i);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERBitString
 * JD-Core Version:    0.6.0
 */