package org.bouncycastle.asn1;

import java.io.IOException;

public class DERBoolean extends ASN1Object
{
  private byte value;

  public DERBoolean(byte[] paramArrayOfByte)
  {
    if (paramArrayOfByte.length != 1)
      throw new IllegalArgumentException("byte value should have 1 byte in it");
    this.value = paramArrayOfByte[0];
  }

  public DERBoolean(boolean paramBoolean)
  {
    this.value = (paramBoolean ? -1 : 0);
  }

  public final boolean isTrue()
  {
    return this.value != 0;
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    byte[] arrayOfByte;
    (arrayOfByte = new byte[1])[0] = this.value;
    paramDEROutputStream.writeEncoded(1, arrayOfByte);
  }

  protected final boolean asn1Equals(DERObject paramDERObject)
  {
    if ((paramDERObject == null) || (!(paramDERObject instanceof DERBoolean)))
      return false;
    return this.value == ((DERBoolean)paramDERObject).value;
  }

  public int hashCode()
  {
    return this.value;
  }

  public String toString()
  {
    if (this.value != 0)
      return "TRUE";
    return "FALSE";
  }

  static
  {
    new DERBoolean(false);
    new DERBoolean(true);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERBoolean
 * JD-Core Version:    0.6.0
 */