package org.bouncycastle.asn1;

import java.io.IOException;
import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

public class DEREnumerated extends ASN1Object
{
  private byte[] bytes;

  public DEREnumerated(byte[] paramArrayOfByte)
  {
    this.bytes = paramArrayOfByte;
  }

  public final BigInteger getValue()
  {
    return new BigInteger(this.bytes);
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    paramDEROutputStream.writeEncoded(10, this.bytes);
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DEREnumerated))
      return false;
    paramDERObject = (DEREnumerated)paramDERObject;
    return Arrays.areEqual(this.bytes, paramDERObject.bytes);
  }

  public int hashCode()
  {
    return Arrays.hashCode(this.bytes);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DEREnumerated
 * JD-Core Version:    0.6.0
 */