package org.bouncycastle.asn1;

import java.io.IOException;

public final class DERExternalParser
  implements DEREncodable, InMemoryRepresentable
{
  private ASN1StreamParser _parser;

  public DERExternalParser(ASN1StreamParser paramASN1StreamParser)
  {
    this._parser = paramASN1StreamParser;
  }

  public final DERObject getLoadedObject()
    throws IOException
  {
    try
    {
      return new DERExternal(this._parser.readVector());
    }
    catch (IllegalArgumentException this)
    {
    }
    throw new ASN1Exception(getMessage(), this);
  }

  public final DERObject getDERObject()
  {
    try
    {
      return getLoadedObject();
    }
    catch (IOException this)
    {
      throw new ASN1ParsingException("unable to get DER object", this);
    }
    catch (IllegalArgumentException this)
    {
    }
    throw new ASN1ParsingException("unable to get DER object", this);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERExternalParser
 * JD-Core Version:    0.6.0
 */