package org.bouncycastle.asn1;

import java.io.IOException;
import java.math.BigInteger;
import org.bouncycastle.util.Arrays;

public class DERInteger extends ASN1Object
{
  private byte[] bytes;

  public DERInteger(byte[] paramArrayOfByte)
  {
    this.bytes = paramArrayOfByte;
  }

  public final BigInteger getValue()
  {
    return new BigInteger(this.bytes);
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    paramDEROutputStream.writeEncoded(2, this.bytes);
  }

  public int hashCode()
  {
    int i = 0;
    for (int j = 0; j != this.bytes.length; j++)
      i ^= (this.bytes[j] & 0xFF) << j % 4;
    return i;
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERInteger))
      return false;
    paramDERObject = (DERInteger)paramDERObject;
    return Arrays.areEqual(this.bytes, paramDERObject.bytes);
  }

  public String toString()
  {
    return getValue().toString();
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERInteger
 * JD-Core Version:    0.6.0
 */