package org.bouncycastle.asn1;

import com.scytl.common.certpath.CertPathHelper;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;

public class DERObjectIdentifier extends ASN1Object
{
  String identifier;

  DERObjectIdentifier(byte[] paramArrayOfByte)
  {
    StringBuffer localStringBuffer = new StringBuffer();
    long l = 0L;
    BigInteger localBigInteger = null;
    int i = 1;
    for (int j = 0; j != paramArrayOfByte.length; j++)
    {
      int k = paramArrayOfByte[j] & 0xFF;
      if (l < 36028797018963968L)
      {
        l = (l << 7) + (k & 0x7F);
        if ((k & 0x80) != 0)
          continue;
        if (i != 0)
        {
          switch ((int)l / 40)
          {
          case 0:
            localStringBuffer.append('0');
            break;
          case 1:
            localStringBuffer.append('1');
            l -= 40L;
            break;
          default:
            localStringBuffer.append('2');
            l -= 80L;
          }
          i = 0;
        }
        localStringBuffer.append('.');
        localStringBuffer.append(l);
        l = 0L;
      }
      else
      {
        if (localBigInteger == null)
          localBigInteger = BigInteger.valueOf(l);
        localBigInteger = (localBigInteger = localBigInteger.shiftLeft(7)).or(BigInteger.valueOf(k & 0x7F));
        if ((k & 0x80) != 0)
          continue;
        localStringBuffer.append('.');
        localStringBuffer.append(localBigInteger);
        localBigInteger = null;
        l = 0L;
      }
    }
    this.identifier = localStringBuffer.toString();
  }

  public DERObjectIdentifier(String paramString)
  {
    String str;
    int i = 0;
    for (int j = str.length() - 1; j >= 2; j--)
    {
      int k = str.charAt(j);
      if ((48 <= k) && (k <= 57))
      {
        i = 1;
      }
      else if (k == 46)
      {
        i = 0;
      }
      else
      {
        tmpTernaryOp = 0;
        break label124;
      }
    }
    if ((i == 0 ? 0 : ((i = str.charAt(0)) < '0') || (i > 50) ? 0 : ((str = paramString).length() < 3) || (str.charAt(1) != '.') ? 0 : i) == 0)
      label124: throw new IllegalArgumentException("string " + paramString + " not an OID");
    this.identifier = paramString;
  }

  public final String getId()
  {
    return this.identifier;
  }

  private static void writeField(OutputStream paramOutputStream, long paramLong)
    throws IOException
  {
    byte[] arrayOfByte = new byte[9];
    int i = 8;
    arrayOfByte[8] = (byte)((int)paramLong & 0x7F);
    while (paramLong >= 128L)
    {
      paramLong >>= 7;
      i--;
      arrayOfByte[i] = (byte)((int)paramLong & 0x7F | 0x80);
    }
    paramOutputStream.write(arrayOfByte, i, 9 - i);
  }

  private static void writeField(OutputStream paramOutputStream, BigInteger paramBigInteger)
    throws IOException
  {
    int i;
    if ((i = (paramBigInteger.bitLength() + 6) / 7) == 0)
    {
      paramOutputStream.write(0);
      return;
    }
    paramBigInteger = paramBigInteger;
    byte[] arrayOfByte = new byte[i];
    for (int j = i - 1; j >= 0; j--)
    {
      arrayOfByte[j] = (byte)(paramBigInteger.intValue() & 0x7F | 0x80);
      paramBigInteger = paramBigInteger.shiftRight(7);
    }
    int tmp70_69 = (i - 1);
    byte[] tmp70_66 = arrayOfByte;
    tmp70_66[tmp70_69] = (byte)(tmp70_66[tmp70_69] & 0x7F);
    paramOutputStream.write(arrayOfByte);
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    this = new CertPathHelper(this.identifier);
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    DEROutputStream localDEROutputStream = new DEROutputStream(localByteArrayOutputStream);
    writeField(localByteArrayOutputStream, Integer.parseInt(nextToken()) * 40 + Integer.parseInt(nextToken()));
    while (hasMoreTokens())
    {
      if ((localObject = nextToken()).length() < 18)
      {
        writeField(localByteArrayOutputStream, Long.parseLong((String)localObject));
        continue;
      }
      writeField(localByteArrayOutputStream, new BigInteger((String)localObject));
    }
    localDEROutputStream.close();
    Object localObject = localByteArrayOutputStream.toByteArray();
    paramDEROutputStream.writeEncoded(6, localObject);
  }

  public int hashCode()
  {
    return this.identifier.hashCode();
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERObjectIdentifier))
      return false;
    return this.identifier.equals(((DERObjectIdentifier)paramDERObject).identifier);
  }

  public String toString()
  {
    this = this;
    return this.identifier;
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERObjectIdentifier
 * JD-Core Version:    0.6.0
 */