package org.bouncycastle.asn1;

import java.io.IOException;
import java.io.InputStream;

public final class DEROctetStringParser
  implements ASN1SequenceParser
{
  private DefiniteLengthInputStream stream;

  DEROctetStringParser(DefiniteLengthInputStream paramDefiniteLengthInputStream)
  {
    this.stream = paramDefiniteLengthInputStream;
  }

  public final InputStream getOctetStream()
  {
    return this.stream;
  }

  public final DERObject getLoadedObject()
    throws IOException
  {
    return new DEROctetString(this.stream.toByteArray());
  }

  public final DERObject getDERObject()
  {
    try
    {
      return getLoadedObject();
    }
    catch (IOException this)
    {
    }
    throw new ASN1ParsingException("IOException converting stream to byte array: " + getMessage(), this);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DEROctetStringParser
 * JD-Core Version:    0.6.0
 */