package org.bouncycastle.asn1;

import java.io.IOException;

public final class DERPrintableString extends ASN1Object
  implements DERString
{
  private String string;

  public DERPrintableString(byte[] paramArrayOfByte)
  {
    char[] arrayOfChar = new char[paramArrayOfByte.length];
    for (int i = 0; i != arrayOfChar.length; i++)
      arrayOfChar[i] = (char)(paramArrayOfByte[i] & 0xFF);
    this.string = new String(arrayOfChar);
  }

  public DERPrintableString(String paramString)
  {
    this(paramString, false);
  }

  private DERPrintableString(String paramString, boolean paramBoolean)
  {
    this.string = paramString;
  }

  public final String getString()
  {
    return this.string;
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    this = this;
    paramDEROutputStream = new byte[(this = this.string.toCharArray()).length];
    int i = 0;
    if (i != this.length)
    {
      paramDEROutputStream[i] = (byte)this[i];
      i++;
      tmpTernaryOp = 19;
      while (true);
    }
  }

  public final int hashCode()
  {
    return getString().hashCode();
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERPrintableString))
      return false;
    paramDERObject = (DERPrintableString)paramDERObject;
    return getString().equals(paramDERObject.getString());
  }

  public final String toString()
  {
    return this.string;
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERPrintableString
 * JD-Core Version:    0.6.0
 */