package org.bouncycastle.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

public final class DERUniversalString extends ASN1Object
  implements DERString
{
  private static final char[] table = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
  private byte[] string;

  public DERUniversalString(byte[] paramArrayOfByte)
  {
    this.string = paramArrayOfByte;
  }

  public final String getString()
  {
    StringBuffer localStringBuffer = new StringBuffer("#");
    ByteArrayOutputStream localByteArrayOutputStream = new ByteArrayOutputStream();
    ASN1OutputStream localASN1OutputStream = new ASN1OutputStream(localByteArrayOutputStream);
    try
    {
      localASN1OutputStream.writeObject(this);
    }
    catch (IOException localIOException)
    {
      throw new RuntimeException("internal error encoding BitString");
    }
    this = localByteArrayOutputStream.toByteArray();
    for (int i = 0; i != this.length; i++)
    {
      localStringBuffer.append(table[(this[i] >>> 4 & 0xF)]);
      localStringBuffer.append(table[(this[i] & 0xF)]);
    }
    return localStringBuffer.toString();
  }

  public final String toString()
  {
    return getString();
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    this = this;
    paramDEROutputStream.writeEncoded(28, this.string);
  }

  final boolean asn1Equals(DERObject paramDERObject)
  {
    if (!(paramDERObject instanceof DERUniversalString))
      return false;
    return getString().equals(((DERUniversalString)paramDERObject).getString());
  }

  public final int hashCode()
  {
    return getString().hashCode();
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERUniversalString
 * JD-Core Version:    0.6.0
 */