package org.bouncycastle.asn1;

import java.io.IOException;
import org.bouncycastle.util.Arrays;

public final class DERUnknownTag extends DERObject
{
  private boolean isConstructed;
  private int tag;
  private byte[] data;

  public DERUnknownTag(boolean paramBoolean, int paramInt, byte[] paramArrayOfByte)
  {
    this.isConstructed = paramBoolean;
    this.tag = paramInt;
    this.data = paramArrayOfByte;
  }

  public final int getTag()
  {
    return this.tag;
  }

  public final byte[] getData()
  {
    return this.data;
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    paramDEROutputStream.writeEncoded(this.isConstructed ? 32 : 0, this.tag, this.data);
  }

  public final boolean equals(Object paramObject)
  {
    if (!(paramObject instanceof DERUnknownTag))
      return false;
    paramObject = (DERUnknownTag)paramObject;
    return (this.isConstructed == paramObject.isConstructed) && (this.tag == paramObject.tag) && (Arrays.areEqual(this.data, paramObject.data));
  }

  public final int hashCode()
  {
    return (this.isConstructed ? -1 : 0) ^ this.tag ^ Arrays.hashCode(this.data);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.DERUnknownTag
 * JD-Core Version:    0.6.0
 */