package org.bouncycastle.asn1;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;

final class IndefiniteLengthInputStream extends LimitedInputStream
{
  private int _b1;
  private int _b2;
  private boolean _eofReached = false;
  private boolean _eofOn00 = true;

  IndefiniteLengthInputStream(InputStream paramInputStream, int paramInt)
    throws IOException
  {
    super(paramInputStream, paramInt);
    this._b1 = paramInputStream.read();
    this._b2 = paramInputStream.read();
    if (this._b2 < 0)
      throw new EOFException();
    checkForEof();
  }

  final void setEofOn00(boolean paramBoolean)
  {
    this._eofOn00 = paramBoolean;
    checkForEof();
  }

  private boolean checkForEof()
  {
    if ((!this._eofReached) && (this._eofOn00) && (this._b1 == 0) && (this._b2 == 0))
    {
      this._eofReached = true;
      setParentEofDetect(true);
    }
    return this._eofReached;
  }

  public final int read(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
    throws IOException
  {
    if ((this._eofOn00) || (paramInt2 < 3))
      return super.read(paramArrayOfByte, paramInt1, paramInt2);
    if (this._eofReached)
      return -1;
    if ((paramInt2 = this._in.read(paramArrayOfByte, paramInt1 + 2, paramInt2 - 2)) < 0)
      throw new EOFException();
    paramArrayOfByte[paramInt1] = (byte)this._b1;
    paramArrayOfByte[(paramInt1 + 1)] = (byte)this._b2;
    this._b1 = this._in.read();
    this._b2 = this._in.read();
    if (this._b2 < 0)
      throw new EOFException();
    return paramInt2 + 2;
  }

  public final int read()
    throws IOException
  {
    if (checkForEof())
      return -1;
    int i;
    if ((i = this._in.read()) < 0)
      throw new EOFException();
    int j = this._b1;
    this._b1 = this._b2;
    this._b2 = i;
    return j;
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.IndefiniteLengthInputStream
 * JD-Core Version:    0.6.0
 */