package org.bouncycastle.asn1;

import java.util.Enumeration;

final class LazyDERConstructionEnumeration
  implements Enumeration
{
  private ASN1InputStream aIn;
  private Object nextObj;

  public LazyDERConstructionEnumeration(byte[] paramArrayOfByte)
  {
    this.aIn = new ASN1InputStream(paramArrayOfByte, true);
    this.nextObj = readObject();
  }

  public final boolean hasMoreElements()
  {
    return this.nextObj != null;
  }

  public final Object nextElement()
  {
    Object localObject = this.nextObj;
    this.nextObj = readObject();
    return localObject;
  }

  private Object readObject()
  {
    try
    {
      return this.aIn.readObject();
    }
    catch (java.io.IOException this)
    {
    }
    throw new ASN1ParsingException("malformed DER construction: " + this, this);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.LazyDERConstructionEnumeration
 * JD-Core Version:    0.6.0
 */