package org.bouncycastle.asn1;

import java.io.IOException;
import java.util.Enumeration;

public final class LazyDERSequence extends DERSequence
{
  private byte[] encoded;
  private boolean parsed = false;
  private int size = -1;

  LazyDERSequence(byte[] paramArrayOfByte)
    throws IOException
  {
    this.encoded = paramArrayOfByte;
  }

  public final synchronized DEREncodable getObjectAt(int paramInt)
  {
    if (!this.parsed)
    {
      LazyDERSequence localLazyDERSequence = this;
      LazyDERConstructionEnumeration localLazyDERConstructionEnumeration = new LazyDERConstructionEnumeration(localLazyDERSequence.encoded);
      while (localLazyDERConstructionEnumeration.hasMoreElements())
        localLazyDERSequence.addObject((DEREncodable)localLazyDERConstructionEnumeration.nextElement());
      localLazyDERSequence.parsed = true;
    }
    return super.getObjectAt(paramInt);
  }

  public final synchronized Enumeration getObjects()
  {
    if (this.parsed)
      return super.getObjects();
    return new LazyDERConstructionEnumeration(this.encoded);
  }

  public final int size()
  {
    if (this.size < 0)
    {
      LazyDERConstructionEnumeration localLazyDERConstructionEnumeration = new LazyDERConstructionEnumeration(this.encoded);
      this.size = 0;
      while (localLazyDERConstructionEnumeration.hasMoreElements())
      {
        localLazyDERConstructionEnumeration.nextElement();
        this.size += 1;
      }
    }
    return this.size;
  }

  final void encode(DEROutputStream paramDEROutputStream)
    throws IOException
  {
    paramDEROutputStream.writeEncoded(48, this.encoded);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.LazyDERSequence
 * JD-Core Version:    0.6.0
 */