package org.bouncycastle.asn1.x500;

import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Set;
import org.bouncycastle.asn1.DERObject;

public final class RDN extends ASN1Encodable
{
  private ASN1Set values;

  private RDN(ASN1Set paramASN1Set)
  {
    this.values = paramASN1Set;
  }

  public static RDN getInstance(Object paramObject)
  {
    if ((paramObject instanceof RDN))
      return (RDN)paramObject;
    if (paramObject != null)
      return new RDN(ASN1Set.getInstance(paramObject));
    return null;
  }

  public final boolean isMultiValued()
  {
    return this.values.size() > 1;
  }

  public final AttributeTypeAndValue getFirst()
  {
    if (this.values.size() == 0)
      return null;
    return AttributeTypeAndValue.getInstance(this.values.getObjectAt(0));
  }

  public final AttributeTypeAndValue[] getTypesAndValues()
  {
    AttributeTypeAndValue[] arrayOfAttributeTypeAndValue = new AttributeTypeAndValue[this.values.size()];
    for (int i = 0; i != arrayOfAttributeTypeAndValue.length; i++)
      arrayOfAttributeTypeAndValue[i] = AttributeTypeAndValue.getInstance(this.values.getObjectAt(i));
    return arrayOfAttributeTypeAndValue;
  }

  public final DERObject toASN1Object()
  {
    return this.values;
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.x500.RDN
 * JD-Core Version:    0.6.0
 */