package org.bouncycastle.asn1.x500;

import java.util.Enumeration;
import org.bouncycastle.asn1.ASN1Choice;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DEREncodable;
import org.bouncycastle.asn1.DERObject;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x500.style.BCStyle;
import org.picocontainer.ComponentMonitor;

public final class X500Name extends ASN1Encodable
  implements ASN1Choice
{
  private static ComponentMonitor defaultStyle$61882cee = BCStyle.INSTANCE$61882cee;
  private boolean isHashCodeCalculated;
  private int hashCodeValue;
  private ComponentMonitor style$61882cee;
  private RDN[] rdns;

  private X500Name(ASN1Sequence paramASN1Sequence)
  {
    this(defaultStyle$61882cee, paramASN1Sequence);
  }

  private X500Name(ComponentMonitor paramComponentMonitor, ASN1Sequence paramASN1Sequence)
  {
    this.style$61882cee = paramComponentMonitor;
    this.rdns = new RDN[paramASN1Sequence.size()];
    paramComponentMonitor = 0;
    paramASN1Sequence = paramASN1Sequence.getObjects();
    while (paramASN1Sequence.hasMoreElements())
      this.rdns[(paramComponentMonitor++)] = RDN.getInstance(paramASN1Sequence.nextElement());
  }

  public final RDN[] getRDNs()
  {
    RDN[] arrayOfRDN = new RDN[this.rdns.length];
    System.arraycopy(this.rdns, 0, arrayOfRDN, 0, arrayOfRDN.length);
    return arrayOfRDN;
  }

  public final DERObject toASN1Object()
  {
    return new DERSequence(this.rdns);
  }

  public final int hashCode()
  {
    if (this.isHashCodeCalculated)
      return this.hashCodeValue;
    this.isHashCodeCalculated = true;
    this.hashCodeValue = this.style$61882cee.calculateHashCode(this);
    return this.hashCodeValue;
  }

  public final boolean equals(Object paramObject)
  {
    if (paramObject == this)
      return true;
    if ((!(paramObject instanceof X500Name)) && (!(paramObject instanceof ASN1Sequence)))
      return false;
    DERObject localDERObject = ((DEREncodable)paramObject).getDERObject();
    if (getDERObject().equals(localDERObject))
      return true;
    try
    {
      return this.style$61882cee.areEqual(this, new X500Name(ASN1Sequence.getInstance(((DEREncodable)paramObject).getDERObject())));
    }
    catch (Exception localException)
    {
    }
    return false;
  }

  public final String toString()
  {
    return this.style$61882cee.toString(this);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.x500.X500Name
 * JD-Core Version:    0.6.0
 */