package org.bouncycastle.asn1.x500.style;

import java.util.Hashtable;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1Object;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.ASN1StreamParser;
import org.bouncycastle.asn1.ASN1String;
import org.bouncycastle.asn1.DERObject;
import org.bouncycastle.asn1.DERUniversalString;
import org.bouncycastle.asn1.x500.AttributeTypeAndValue;
import org.bouncycastle.util.encoders.Hex;

public final class IETFUtils
{
  public static void appendTypeAndValue(StringBuffer paramStringBuffer, AttributeTypeAndValue paramAttributeTypeAndValue, Hashtable paramHashtable)
  {
    if ((paramHashtable = (String)paramHashtable.get(paramAttributeTypeAndValue.getType())) != null)
      paramStringBuffer.append(paramHashtable);
    else
      paramStringBuffer.append(paramAttributeTypeAndValue.getType().getId());
    paramStringBuffer.append('=');
    paramStringBuffer.append(valueToString(paramAttributeTypeAndValue.getValue()));
  }

  public static String valueToString(ASN1Encodable paramASN1Encodable)
  {
    StringBuffer localStringBuffer = new StringBuffer();
    if (((paramASN1Encodable instanceof ASN1String)) && (!(paramASN1Encodable instanceof DERUniversalString)))
    {
      if (((paramASN1Encodable = ((ASN1String)paramASN1Encodable).getString()).length() > 0) && (paramASN1Encodable.charAt(0) == '#'))
        localStringBuffer.append("\\" + paramASN1Encodable);
      else
        localStringBuffer.append(paramASN1Encodable);
    }
    else
      localStringBuffer.append("#" + bytesToString(Hex.encode(paramASN1Encodable.getDERObject().getDEREncoded())));
    paramASN1Encodable = localStringBuffer.length();
    ASN1Encodable localASN1Encodable = 0;
    if ((localStringBuffer.length() >= 2) && (localStringBuffer.charAt(0) == '\\') && (localStringBuffer.charAt(1) == '#'))
      localASN1Encodable += 2;
    while (localASN1Encodable != paramASN1Encodable)
    {
      if ((localStringBuffer.charAt(localASN1Encodable) == ',') || (localStringBuffer.charAt(localASN1Encodable) == '"') || (localStringBuffer.charAt(localASN1Encodable) == '\\') || (localStringBuffer.charAt(localASN1Encodable) == '+') || (localStringBuffer.charAt(localASN1Encodable) == '=') || (localStringBuffer.charAt(localASN1Encodable) == '<') || (localStringBuffer.charAt(localASN1Encodable) == '>') || (localStringBuffer.charAt(localASN1Encodable) == ';'))
      {
        localStringBuffer.insert(localASN1Encodable, "\\");
        localASN1Encodable++;
        paramASN1Encodable++;
      }
      localASN1Encodable++;
    }
    return localStringBuffer.toString();
  }

  private static String bytesToString(byte[] paramArrayOfByte)
  {
    char[] arrayOfChar = new char[paramArrayOfByte.length];
    for (int i = 0; i != arrayOfChar.length; i++)
      arrayOfChar[i] = (char)(paramArrayOfByte[i] & 0xFF);
    return new String(arrayOfChar);
  }

  public static String canonicalize(String paramString)
  {
    if (((paramString = ASN1StreamParser.toLowerCase(paramString.trim())).length() > 0) && (paramString.charAt(0) == '#') && (((localObject = decodeObject(paramString)) instanceof ASN1String)))
      paramString = ASN1StreamParser.toLowerCase(((ASN1String)localObject).getString().trim());
    paramString = paramString;
    Object localObject = new StringBuffer();
    if (paramString.length() != 0)
    {
      char c1 = paramString.charAt(0);
      ((StringBuffer)localObject).append(c1);
      for (int i = 1; i < paramString.length(); i++)
      {
        char c2 = paramString.charAt(i);
        if ((c1 != ' ') || (c2 != ' '))
          ((StringBuffer)localObject).append(c2);
        c1 = c2;
      }
    }
    return (String)(paramString = ((StringBuffer)localObject).toString());
  }

  private static ASN1Object decodeObject(String paramString)
  {
    try
    {
      return ASN1Object.fromByteArray(Hex.decode(paramString.substring(1)));
    }
    catch (java.io.IOException paramString)
    {
    }
    throw new IllegalStateException("unknown encoding in name: " + paramString);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.x500.style.IETFUtils
 * JD-Core Version:    0.6.0
 */