package org.bouncycastle.asn1.x509;

import java.io.IOException;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1StreamParser;
import org.bouncycastle.asn1.DERGeneralizedTime;
import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERObject;
import org.bouncycastle.asn1.DERObjectIdentifier;
import org.bouncycastle.asn1.DERPrintableString;
import org.bouncycastle.asn1.DERUTF8String;

public final class X509DefaultEntryConverter extends X509NameEntryConverter
{
  public final DERObject getConvertedValue(DERObjectIdentifier paramDERObjectIdentifier, String paramString)
  {
    if ((paramString.length() != 0) && (paramString.charAt(0) == '#'))
      try
      {
        this = 1;
        paramString = new byte[((this = ASN1StreamParser.toLowerCase(this = paramString)).length() - 1) / 2];
        for (int i = 0; i != paramString.length; i++)
        {
          int j = charAt((i << 1) + 1);
          int k = charAt((i << 1) + 1 + 1);
          if (j < 97)
            paramString[i] = (byte)(j - 48 << 4);
          else
            paramString[i] = (byte)(j - 97 + 10 << 4);
          if (k < 97)
          {
            int tmp113_112 = i;
            String tmp113_111 = paramString;
            tmp113_111[tmp113_112] = (byte)(tmp113_111[tmp113_112] | (byte)(k - 48));
          }
          else
          {
            int tmp129_128 = i;
            String tmp129_127 = paramString;
            tmp129_127[tmp129_128] = (byte)(tmp129_127[tmp129_128] | (byte)(k - 97 + 10));
          }
        }
        ASN1InputStream localASN1InputStream;
        return (localASN1InputStream = new ASN1InputStream(paramString)).readObject();
      }
      catch (IOException localIOException)
      {
        throw new RuntimeException("can't recode value for oid " + paramDERObjectIdentifier.getId());
      }
    if ((paramString.length() != 0) && (paramString.charAt(0) == '\\'))
      paramString = paramString.substring(1);
    if ((paramDERObjectIdentifier.equals(X509Name.EmailAddress)) || (paramDERObjectIdentifier.equals(X509Name.DC)))
      return new DERIA5String(paramString);
    if (paramDERObjectIdentifier.equals(X509Name.DATE_OF_BIRTH))
      return new DERGeneralizedTime(paramString);
    if ((paramDERObjectIdentifier.equals(X509Name.C)) || (paramDERObjectIdentifier.equals(X509Name.SN)) || (paramDERObjectIdentifier.equals(X509Name.DN_QUALIFIER)) || (paramDERObjectIdentifier.equals(X509Name.TELEPHONE_NUMBER)))
      return new DERPrintableString(paramString);
    return new DERUTF8String(paramString);
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.x509.X509DefaultEntryConverter
 * JD-Core Version:    0.6.0
 */