package org.bouncycastle.asn1.x509;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.bouncycastle.asn1.ASN1Encodable;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1ObjectIdentifier;
import org.bouncycastle.asn1.DERBoolean;
import org.bouncycastle.asn1.DERObject;
import org.bouncycastle.asn1.DERSequence;

public final class X509Extensions extends ASN1Encodable
{

  /** @deprecated */
  public static final ASN1ObjectIdentifier ExtendedKeyUsage;

  public final DERObject toASN1Object()
  {
    this = new ASN1EncodableVector();
    Enumeration localEnumeration = null.elements();
    while (localEnumeration.hasMoreElements())
    {
      ASN1ObjectIdentifier localASN1ObjectIdentifier = (ASN1ObjectIdentifier)localEnumeration.nextElement();
      X509Extension localX509Extension = (X509Extension)null.get(localASN1ObjectIdentifier);
      ASN1EncodableVector localASN1EncodableVector;
      (localASN1EncodableVector = new ASN1EncodableVector()).add(localASN1ObjectIdentifier);
      if (localX509Extension.isCritical())
        localASN1EncodableVector.add(new DERBoolean(true));
      localASN1EncodableVector.add(localX509Extension.getValue());
      add(new DERSequence(localASN1EncodableVector));
    }
    return new DERSequence(this);
  }

  static
  {
    new ASN1ObjectIdentifier("2.5.29.9");
    new ASN1ObjectIdentifier("2.5.29.14");
    new ASN1ObjectIdentifier("2.5.29.15");
    new ASN1ObjectIdentifier("2.5.29.16");
    new ASN1ObjectIdentifier("2.5.29.17");
    new ASN1ObjectIdentifier("2.5.29.18");
    new ASN1ObjectIdentifier("2.5.29.19");
    new ASN1ObjectIdentifier("2.5.29.20");
    new ASN1ObjectIdentifier("2.5.29.21");
    new ASN1ObjectIdentifier("2.5.29.23");
    new ASN1ObjectIdentifier("2.5.29.24");
    new ASN1ObjectIdentifier("2.5.29.27");
    new ASN1ObjectIdentifier("2.5.29.28");
    new ASN1ObjectIdentifier("2.5.29.29");
    new ASN1ObjectIdentifier("2.5.29.30");
    new ASN1ObjectIdentifier("2.5.29.31");
    new ASN1ObjectIdentifier("2.5.29.32");
    new ASN1ObjectIdentifier("2.5.29.33");
    new ASN1ObjectIdentifier("2.5.29.35");
    new ASN1ObjectIdentifier("2.5.29.36");
    ExtendedKeyUsage = new ASN1ObjectIdentifier("2.5.29.37");
    new ASN1ObjectIdentifier("2.5.29.46");
    new ASN1ObjectIdentifier("2.5.29.54");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.1");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.11");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.12");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.2");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.3");
    new ASN1ObjectIdentifier("1.3.6.1.5.5.7.1.4");
    new ASN1ObjectIdentifier("2.5.29.56");
    new ASN1ObjectIdentifier("2.5.29.55");
  }
}

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.bouncycastle.asn1.x509.X509Extensions
 * JD-Core Version:    0.6.0
 */