/*     */ package org.picocontainer.defaults;
/*     */ 
/*     */ import java.io.Serializable;
/*     */ import java.lang.reflect.Array;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import java.util.SortedMap;
/*     */ import java.util.SortedSet;
/*     */ import java.util.TreeMap;
/*     */ import java.util.TreeSet;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.picocontainer.PicoContainer;
/*     */ import org.picocontainer.PicoInitializationException;
/*     */ import org.picocontainer.PicoIntrospectionException;
/*     */ 
/*     */ public final class CollectionComponentParameter
/*     */   implements Serializable, ComponentMonitor
/*     */ {
/*  47 */   private static final DefaultPicoContainer.1 mapFactory$700f0e1a = new DefaultPicoContainer.1();
/*     */ 
/*  52 */   public static final CollectionComponentParameter ARRAY = new CollectionComponentParameter();
/*     */ 
/*  57 */   public static final CollectionComponentParameter ARRAY_ALLOW_EMPTY = new CollectionComponentParameter(true);
/*     */   private final boolean emptyCollection;
/*     */   private final Class componentKeyType;
/*     */   private final Class componentValueType;
/*     */ 
/*     */   public CollectionComponentParameter()
/*     */   {
/*  68 */     this(false);
/*     */   }
/*     */ 
/*     */   private CollectionComponentParameter(boolean emptyCollection)
/*     */   {
/*  78 */     this(Void.TYPE, emptyCollection);
/*     */   }
/*     */ 
/*     */   private CollectionComponentParameter(Class componentValueType, boolean emptyCollection)
/*     */   {
/*  90 */     this(Object.class, componentValueType, emptyCollection);
/*     */   }
/*     */ 
/*     */   private CollectionComponentParameter(Class componentKeyType, Class componentValueType, boolean emptyCollection)
/*     */   {
/* 103 */     this.emptyCollection = emptyCollection;
/* 104 */     this.componentKeyType = componentKeyType;
/* 105 */     this.componentValueType = componentValueType;
/*     */   }
/*     */ 
/*     */   public final Object resolveInstance$67bc1482(PicoContainer paramPicoContainer, ComponentMonitor paramComponentMonitor, Class paramClass)
/*     */   {
/* 122 */     Object localObject = null;
/*     */     Class localClass;
/* 124 */     if ((
/* 124 */       localClass = getCollectionType(paramClass)) != null)
/*     */     {
/* 125 */       this = getMatchingComponentAdapters$726aec02(paramPicoContainer, paramComponentMonitor, this.componentKeyType, getValueType(paramClass));
/* 126 */       if (Array.class.isAssignableFrom(localClass)) {
/* 127 */         paramComponentMonitor = this; paramPicoContainer = paramClass; this = paramPicoContainer; paramPicoContainer = (Object[])Array.newInstance(paramPicoContainer.getComponentType(), paramComponentMonitor.size()); paramClass = 0; for (paramComponentMonitor = paramComponentMonitor.values().iterator(); paramComponentMonitor.hasNext(); paramClass++) { localObject = (ComponentMonitor)paramComponentMonitor.next(); paramPicoContainer[paramClass] = getComponentInstance(((ComponentMonitor)localObject).getComponentKey()); } localObject = paramPicoContainer;
/* 128 */       } else if (Map.class.isAssignableFrom(localClass)) {
/* 129 */         localObject = getMapInstance(paramPicoContainer, paramClass, this);
/* 130 */       } else if (Collection.class.isAssignableFrom(localClass)) {
/* 131 */         localObject = getCollectionInstance(paramPicoContainer, paramClass, this);
/*     */       } else {
/* 133 */         throw new PicoIntrospectionException(paramClass.getName() + " is not a collective type");
/*     */       }
/*     */     }
/* 136 */     return localObject;
/*     */   }
/*     */ 
/*     */   public final boolean isResolvable$6c5a874c(PicoContainer paramPicoContainer, ComponentMonitor paramComponentMonitor, Class paramClass)
/*     */   {
/* 152 */     Class localClass = getCollectionType(paramClass);
/* 153 */     paramClass = getValueType(paramClass);
/* 154 */     return (localClass != null) && ((this.emptyCollection) || (getMatchingComponentAdapters$726aec02(paramPicoContainer, paramComponentMonitor, this.componentKeyType, paramClass).size() > 0));
/*     */   }
/*     */ 
/*     */   private Map getMatchingComponentAdapters$726aec02(PicoContainer paramPicoContainer, ComponentMonitor paramComponentMonitor, Class paramClass1, Class paramClass2)
/*     */   {
/* 219 */     Map localMap = mapFactory$700f0e1a.newInstance();
/*     */ 
/* 221 */     if ((
/* 221 */       localObject = paramPicoContainer.getParent()) != null)
/*     */     {
/* 222 */       localMap.putAll(getMatchingComponentAdapters$726aec02((PicoContainer)localObject, paramComponentMonitor, paramClass1, paramClass2));
/*     */     }
/*     */ 
/* 225 */     for (this = (
/* 225 */       this = paramPicoContainer.getComponentAdapters())
/* 225 */       .iterator(); hasNext(); ) {
/* 226 */       localObject = (ComponentMonitor)next();
/* 227 */       localMap.remove(((ComponentMonitor)localObject).getComponentKey());
/*     */     }
/*     */ 
/* 230 */     for (Object localObject = (
/* 230 */       this = paramPicoContainer.getComponentAdaptersOfType(paramClass2))
/* 230 */       .iterator(); ((Iterator)localObject).hasNext(); )
/*     */     {
/* 232 */       paramPicoContainer = (
/* 232 */         this = (ComponentMonitor)((Iterator)localObject).next())
/* 232 */         .getComponentKey();
/* 233 */       if ((paramComponentMonitor == null) || (!paramPicoContainer.equals(paramComponentMonitor.getComponentKey())))
/* 234 */         if (paramClass1.isAssignableFrom(paramPicoContainer.getClass())) { paramClass2 = this; if ((this != null ? 1 : 0) != 0)
/*     */           {
/* 237 */             localMap.put(paramPicoContainer, this);
/*     */           } }
/*     */     }
/* 240 */     return (Map)localMap;
/*     */   }
/*     */ 
/*     */   private static Class getCollectionType(Class collectionType) {
/* 244 */     Class collectionClass = null;
/* 245 */     if (collectionType.isArray())
/* 246 */       collectionClass = Array.class;
/* 247 */     else if (Map.class.isAssignableFrom(collectionType))
/* 248 */       collectionClass = Map.class;
/* 249 */     else if (Collection.class.isAssignableFrom(collectionType)) {
/* 250 */       collectionClass = Collection.class;
/*     */     }
/* 252 */     return collectionClass;
/*     */   }
/*     */ 
/*     */   private Class getValueType(Class collectionType)
/*     */   {
/*     */     Class collectionType;
/* 256 */     this = this.componentValueType;
/* 257 */     if (collectionType.isArray()) {
/* 258 */       valueType = collectionType.getComponentType();
/*     */     }
/* 260 */     return valueType;
/*     */   }
/*     */ 
/*     */   private static Collection getCollectionInstance(PicoContainer paramPicoContainer, Class paramClass, Map paramMap)
/*     */   {
/* 276 */     if ((
/* 276 */       paramClass = paramClass)
/* 276 */       .isInterface())
/*     */     {
/* 278 */       if (List.class.isAssignableFrom(paramClass)) {
/* 279 */         paramClass = ArrayList.class;
/*     */       }
/* 284 */       else if (SortedSet.class.isAssignableFrom(paramClass))
/* 285 */         paramClass = TreeSet.class;
/* 286 */       else if (Set.class.isAssignableFrom(paramClass))
/* 287 */         paramClass = HashSet.class;
/* 288 */       else if (Collection.class.isAssignableFrom(paramClass))
/* 289 */         paramClass = ArrayList.class;
/*     */     }
/*     */     try
/*     */     {
/* 293 */       paramClass = (Collection)paramClass.newInstance();
/* 294 */       for (paramMap = paramMap.values().iterator(); paramMap.hasNext(); ) {
/* 295 */         ComponentMonitor localComponentMonitor = (ComponentMonitor)paramMap.next();
/* 296 */         paramClass.add(paramPicoContainer.getComponentInstance(localComponentMonitor.getComponentKey()));
/*     */       }
/* 298 */       return paramClass;
/*     */     }
/*     */     catch (java.lang.InstantiationException paramClass) {
/* 301 */       throw new PicoInitializationException(paramClass);
/*     */     }
/*     */     catch (java.lang.IllegalAccessException paramClass) {
/*     */     }
/* 305 */     throw new PicoInitializationException(paramClass);
/*     */   }
/*     */ 
/*     */   private static Map getMapInstance(PicoContainer paramPicoContainer, Class paramClass, Map paramMap)
/*     */   {
/* 312 */     if ((
/* 312 */       paramClass = paramClass)
/* 312 */       .isInterface())
/*     */     {
/* 314 */       if (SortedMap.class.isAssignableFrom(paramClass)) {
/* 315 */         paramClass = TreeMap.class;
/*     */       }
/* 318 */       else if (Map.class.isAssignableFrom(paramClass))
/* 319 */         paramClass = HashMap.class;
/*     */     }
/*     */     try
/*     */     {
/* 323 */       paramClass = (Map)paramClass.newInstance();
/* 324 */       for (paramMap = paramMap.entrySet().iterator(); paramMap.hasNext(); )
/*     */       {
/* 326 */         Object localObject = (
/* 326 */           localObject = (Map.Entry)paramMap.next())
/* 326 */           .getKey();
/* 327 */         paramClass.put(localObject, paramPicoContainer.getComponentInstance(localObject));
/*     */       }
/* 329 */       return paramClass;
/*     */     }
/*     */     catch (java.lang.InstantiationException paramClass) {
/* 332 */       throw new PicoInitializationException(paramClass);
/*     */     }
/*     */     catch (java.lang.IllegalAccessException paramClass) {
/*     */     }
/* 336 */     throw new PicoInitializationException(paramClass);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.picocontainer.defaults.CollectionComponentParameter
 * JD-Core Version:    0.6.0
 */