/*     */ package org.picocontainer.defaults;
/*     */ 
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collections;
/*     */ import java.util.Comparator;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ import java.util.Set;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.picocontainer.PicoContainer;
/*     */ import org.picocontainer.PicoInitializationException;
/*     */ import org.picocontainer.PicoIntrospectionException;
/*     */ import org.picocontainer.PicoRegistrationException;
/*     */ 
/*     */ public final class ConstructorInjectionComponentAdapter extends InstantiatingComponentAdapter
/*     */ {
/*     */   private transient List sortedMatchingConstructors;
/*     */   private transient Guard instantiationGuard;
/*     */ 
/*     */   public ConstructorInjectionComponentAdapter(Object componentKey, Class componentImplementation, ComponentMonitor[] parameters, boolean allowNonPublicClasses, ComponentMonitor monitor, LifecycleStrategy lifecycleStrategy)
/*     */     throws PicoRegistrationException, NotConcreteRegistrationException
/*     */   {
/*  75 */     super(componentKey, componentImplementation, parameters, allowNonPublicClasses, monitor, lifecycleStrategy);
/*     */   }
/*     */ 
/*     */   protected final Constructor getGreediestSatisfiableConstructor(PicoContainer paramPicoContainer)
/*     */     throws PicoIntrospectionException, UnsatisfiableDependenciesException, AmbiguousComponentResolutionException, PicoRegistrationException, NotConcreteRegistrationException
/*     */   {
/* 145 */     HashSet localHashSet1 = new HashSet();
/* 146 */     HashSet localHashSet2 = new HashSet();
/* 147 */     if (this.sortedMatchingConstructors == null) {
/* 148 */       this.sortedMatchingConstructors = getSortedMatchingConstructors();
/*     */     }
/* 150 */     Object localObject = null;
/* 151 */     int i = -1;
/* 152 */     Class localClass = null;
/* 153 */     for (int j = 0; j < this.sortedMatchingConstructors.size(); j++) {
/* 154 */       int k = 0;
/*     */       Constructor localConstructor;
/* 156 */       Class[] arrayOfClass = (
/* 156 */         localConstructor = (Constructor)this.sortedMatchingConstructors.get(j))
/* 156 */         .getParameterTypes();
/* 157 */       ComponentMonitor[] arrayOfComponentMonitor = this.parameters$33d50861 != null ? this.parameters$33d50861 : createDefaultParameters$72e93766(arrayOfClass);
/*     */ 
/* 160 */       for (int n = 0; n < arrayOfComponentMonitor.length; n++)
/*     */       {
/* 162 */         if (!arrayOfComponentMonitor[n].isResolvable$6c5a874c(paramPicoContainer, this, arrayOfClass[n])) {
/* 163 */           localHashSet2.add(Arrays.asList(arrayOfClass));
/*     */ 
/* 166 */           localClass = arrayOfClass[n];
/* 167 */           k = 1;
/* 168 */           break;
/*     */         }
/*     */       }
/* 171 */       if ((localObject != null) && (arrayOfClass.length != i)) {
/* 172 */         if (localHashSet1.isEmpty())
/*     */         {
/* 174 */           return localObject;
/*     */         }
/*     */ 
/* 177 */         localHashSet1.add(localConstructor);
/*     */       }
/* 179 */       else if ((k == 0) && (i == arrayOfClass.length))
/*     */       {
/* 181 */         localHashSet1.add(localConstructor);
/* 182 */         localHashSet1.add(localObject);
/* 183 */       } else if (k == 0) {
/* 184 */         localObject = localConstructor;
/* 185 */         i = arrayOfClass.length;
/*     */       }
/*     */     }
/* 188 */     if (!localHashSet1.isEmpty())
/* 189 */       throw new TooManySatisfiableConstructorsException(getComponentImplementation(), localHashSet1);
/* 190 */     if ((localObject == null) && (!localHashSet2.isEmpty()))
/* 191 */       throw new UnsatisfiableDependenciesException(this, localClass, localHashSet2, paramPicoContainer);
/* 192 */     if (localObject == null)
/*     */     {
/* 194 */       HashSet localHashSet3 = new HashSet();
/* 195 */       Constructor[] arrayOfConstructor = getConstructors();
/* 196 */       for (int m = 0; m < arrayOfConstructor.length; m++) {
/* 197 */         localHashSet3.add(arrayOfConstructor[m]);
/*     */       }
/* 199 */       throw new PicoInitializationException("Either do the specified parameters not match any of the following constructors: " + localHashSet3.toString() + " or the constructors were not accessible for '" + getComponentImplementation() + "'");
/*     */     }
/* 201 */     return localObject;
/*     */   }
/*     */ 
/*     */   public final Object getComponentInstance(PicoContainer container) throws PicoInitializationException, PicoIntrospectionException, PicoRegistrationException, NotConcreteRegistrationException {
/* 205 */     if (this.instantiationGuard == null) {
/* 206 */       this.instantiationGuard = new Guard() {
/*     */         public final Object run() {
/*     */           Object localObject1;
/*     */           try { localObject1 = ConstructorInjectionComponentAdapter.this.getGreediestSatisfiableConstructor(this.guardedContainer); } catch (AmbiguousComponentResolutionException localAmbiguousComponentResolutionException) {
/* 211 */             (
/* 212 */               localObject1 = 
/* 214 */               localAmbiguousComponentResolutionException).setComponent(ConstructorInjectionComponentAdapter.this.getComponentImplementation());
/* 213 */             throw ((Throwable)localObject1);
/*     */           }try {
/* 215 */             localObject2 = ConstructorInjectionComponentAdapter.this.getConstructorArguments(this.guardedContainer, (Constructor)localObject1);
/*     */ 
/* 218 */             System.currentTimeMillis();
/*     */ 
/* 220 */             this = ConstructorInjectionComponentAdapter.this.newInstance((Constructor)localObject1, localObject2);
/* 221 */             System.currentTimeMillis();
/* 222 */             return this;
/*     */           }
/*     */           catch (InvocationTargetException localInvocationTargetException)
/*     */           {
/*     */             Object localObject2;
/* 224 */             if (((
/* 224 */               localObject2 = localInvocationTargetException)
/* 224 */               .getTargetException() instanceof RuntimeException))
/*     */             {
/* 226 */               throw ((RuntimeException)((InvocationTargetException)localObject2).getTargetException());
/* 227 */             }if ((((InvocationTargetException)localObject2).getTargetException() instanceof Error)) {
/* 228 */               throw ((Error)((InvocationTargetException)localObject2).getTargetException());
/*     */             }
/* 230 */             throw new PicoInvocationTargetInitializationException(((InvocationTargetException)localObject2).getTargetException());
/*     */           }
/*     */           catch (InstantiationException localInstantiationException)
/*     */           {
/* 234 */             throw new PicoInitializationException("Should never get here");
/*     */           }
/*     */           catch (IllegalAccessException localIllegalAccessException)
/*     */           {
/*     */           }
/*     */ 
/* 240 */           throw new PicoInitializationException(localIllegalAccessException);
/*     */         }
/*     */ 
/*     */       };
/*     */     }
/*     */ 
/* 247 */     Guard.access$100(this.instantiationGuard, container);
/* 248 */     return this.instantiationGuard.observe(getComponentImplementation());
/*     */   }
/*     */ 
/*     */   protected final Object[] getConstructorArguments(PicoContainer paramPicoContainer, Constructor paramConstructor)
/*     */   {
/* 253 */     Object[] arrayOfObject = new Object[(
/* 253 */       paramConstructor = paramConstructor.getParameterTypes()).length];
/*     */ 
/* 254 */     ComponentMonitor[] arrayOfComponentMonitor = this.parameters$33d50861 != null ? this.parameters$33d50861 : createDefaultParameters$72e93766(paramConstructor);
/*     */ 
/* 256 */     for (int i = 0; i < arrayOfComponentMonitor.length; i++) {
/* 257 */       arrayOfObject[i] = arrayOfComponentMonitor[i].resolveInstance$67bc1482(paramPicoContainer, this, paramConstructor[i]);
/*     */     }
/* 259 */     return arrayOfObject;
/*     */   }
/*     */ 
/*     */   private List getSortedMatchingConstructors() {
/* 263 */     ArrayList localArrayList = new ArrayList();
/* 264 */     Constructor[] arrayOfConstructor = getConstructors();
/*     */ 
/* 266 */     for (int i = 0; i < arrayOfConstructor.length; i++) {
/* 267 */       Constructor localConstructor = arrayOfConstructor[i];
/* 268 */       if (((this.parameters$33d50861 == null) || (localConstructor.getParameterTypes().length == this.parameters$33d50861.length)) && ((this.allowNonPublicClasses) || ((localConstructor.getModifiers() & 0x1) != 0))) {
/* 269 */         localArrayList.add(localConstructor);
/*     */       }
/*     */     }
/*     */ 
/* 273 */     if (this.parameters$33d50861 == null)
/* 274 */       Collections.sort(localArrayList, new Comparator() {
/*     */         public final int compare(Object arg0, Object arg1) {
/* 276 */           return ((Constructor)arg1).getParameterTypes().length - ((Constructor)arg0).getParameterTypes().length;
/*     */         }
/*     */       });
/* 280 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   private Constructor[] getConstructors() {
/* 284 */     return (Constructor[])AccessController.doPrivileged(new PrivilegedAction() {
/*     */       public final Object run() {
/* 286 */         return ConstructorInjectionComponentAdapter.this.getComponentImplementation().getDeclaredConstructors();
/*     */       }
/*     */     });
/*     */   }
/*     */ 
/*     */   private static abstract class Guard extends ThreadLocalCyclicDependencyGuard
/*     */   {
/*     */     protected PicoContainer guardedContainer;
/*     */ 
/*     */     private Guard(byte paramByte)
/*     */     {
/*     */     }
/*     */ 
/*     */     Guard()
/*     */     {
/*  51 */       this(0);
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.picocontainer.defaults.ConstructorInjectionComponentAdapter
 * JD-Core Version:    0.6.0
 */