/*     */ package org.picocontainer.defaults;
/*     */ 
/*     */ import java.io.Serializable;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.picocontainer.LifecycleManager;
/*     */ import org.picocontainer.MutablePicoContainer;
/*     */ import org.picocontainer.PicoContainer;
/*     */ import org.picocontainer.monitors.DefaultComponentMonitor;
/*     */ 
/*     */ public final class DefaultPicoContainer
/*     */   implements Serializable, MutablePicoContainer, ComponentMonitorStrategy
/*     */ {
/*  67 */   private Map componentKeyToAdapterCache = new HashMap();
/*     */   private ComponentMonitor componentAdapterFactory$278d24ea;
/*     */   private PicoContainer parent;
/*  70 */   private Set children = new HashSet();
/*     */ 
/*  72 */   private List componentAdapters = new ArrayList();
/*     */ 
/*  74 */   private List orderedComponentAdapters = new ArrayList();
/*     */ 
/*  77 */   private boolean disposed = false;
/*     */   private LifecycleManager lifecycleManager;
/*     */   private LifecycleStrategy lifecycleStrategyForInstanceRegistrations;
/*     */ 
/*     */   public DefaultPicoContainer(ComponentMonitor componentAdapterFactory, PicoContainer parent)
/*     */   {
/* 100 */     this(componentAdapterFactory, new DefaultLifecycleStrategy(new DefaultComponentMonitor()), parent);
/*     */   }
/*     */ 
/*     */   private DefaultPicoContainer(ComponentMonitor paramComponentMonitor, LifecycleStrategy paramLifecycleStrategy, PicoContainer paramPicoContainer)
/*     */   {
/*  81 */     new HashSet();
/*     */ 
/*  83 */     this.lifecycleManager = new OrderedComponentAdapterLifecycleManager();
/*     */ 
/* 122 */     if (paramComponentMonitor == null) throw new NullPointerException("componentAdapterFactory");
/* 123 */     if (paramLifecycleStrategy == null) throw new NullPointerException("lifecycleStrategyForInstanceRegistrations");
/* 124 */     this.componentAdapterFactory$278d24ea = paramComponentMonitor;
/* 125 */     this.lifecycleStrategyForInstanceRegistrations = paramLifecycleStrategy;
/* 126 */     this.parent = (paramPicoContainer == null ? null : ImmutablePicoContainerProxyFactory.newProxyInstance(paramPicoContainer));
/*     */   }
/*     */ 
/*     */   public DefaultPicoContainer()
/*     */   {
/* 198 */     this(new DefaultComponentAdapterFactory(), null);
/*     */   }
/*     */ 
/*     */   public final Collection getComponentAdapters() {
/* 202 */     return Collections.unmodifiableList(this.componentAdapters);
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor getComponentAdapter$506b371c(Object componentKey)
/*     */   {
/*     */     ComponentMonitor adapter;
/* 207 */     if (((
/* 207 */       adapter = (ComponentMonitor)this.componentKeyToAdapterCache.get(componentKey)) == null) && 
/* 207 */       (this.parent != null)) {
/* 208 */       adapter = this.parent.getComponentAdapter$506b371c(componentKey);
/*     */     }
/* 210 */     return adapter;
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor getComponentAdapterOfType$7caf752d(Class paramClass)
/*     */   {
/*     */     Object localObject;
/* 216 */     if ((
/* 216 */       localObject = getComponentAdapter$506b371c(paramClass)) != null)
/*     */     {
/* 217 */       return localObject;
/*     */     }
/*     */ 
/* 222 */     if ((
/* 222 */       localObject = getComponentAdaptersOfType(paramClass))
/* 222 */       .size() == 1)
/* 223 */       return (ComponentMonitor)((List)localObject).get(0);
/* 224 */     if (((List)localObject).size() == 0) {
/* 225 */       if (this.parent != null) {
/* 226 */         return this.parent.getComponentAdapterOfType$7caf752d(paramClass);
/*     */       }
/* 228 */       return null;
/*     */     }
/*     */ 
/* 231 */     this = new Class[((List)localObject).size()];
/* 232 */     for (int i = 0; i < this.length; i++) {
/* 233 */       this[i] = ((ComponentMonitor)((List)localObject).get(i)).getComponentImplementation();
/*     */     }
/*     */ 
/* 236 */     throw new AmbiguousComponentResolutionException(paramClass, this);
/*     */   }
/*     */ 
/*     */   public final List getComponentAdaptersOfType(Class paramClass)
/*     */   {
/* 241 */     if (paramClass == null) {
/* 242 */       return Collections.EMPTY_LIST;
/*     */     }
/* 244 */     ArrayList localArrayList = new ArrayList();
/* 245 */     this = this; for (this = Collections.unmodifiableList(this.componentAdapters).iterator(); hasNext(); ) {
/* 246 */       ComponentMonitor localComponentMonitor = (ComponentMonitor)next();
/*     */ 
/* 248 */       if (paramClass.isAssignableFrom(localComponentMonitor.getComponentImplementation())) {
/* 249 */         localArrayList.add(localComponentMonitor);
/*     */       }
/*     */     }
/* 252 */     return localArrayList;
/*     */   }
/*     */ 
/*     */   private ComponentMonitor registerComponent$43c2bfe1(ComponentMonitor paramComponentMonitor)
/*     */   {
/* 261 */     Object localObject = paramComponentMonitor.getComponentKey();
/* 262 */     if (this.componentKeyToAdapterCache.containsKey(localObject)) {
/* 263 */       throw new DuplicateComponentKeyRegistrationException(localObject);
/*     */     }
/* 265 */     this.componentAdapters.add(paramComponentMonitor);
/* 266 */     this.componentKeyToAdapterCache.put(localObject, paramComponentMonitor);
/* 267 */     return paramComponentMonitor;
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor registerComponentInstance$506b371c(Object component)
/*     */   {
/* 282 */     return registerComponentInstance$c7595c8(component.getClass(), component);
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor registerComponentInstance$c7595c8(Object componentKey, Object componentInstance)
/*     */   {
/*     */     Object componentInstance;
/* 290 */     componentKey = new InstanceComponentAdapter(componentKey, componentInstance, this.lifecycleStrategyForInstanceRegistrations);
/* 291 */     return registerComponent$43c2bfe1(componentAdapter);
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor registerComponentImplementation$7caf752d(Class paramClass)
/*     */   {
/* 300 */     Class localClass = paramClass; paramClass = paramClass; this = this; return registerComponentImplementation$bb03b8(paramClass, localClass, null);
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor registerComponentImplementation$3cf7bc9(Object paramObject, Class paramClass)
/*     */   {
/* 309 */     return registerComponentImplementation$bb03b8(paramObject, paramClass, null);
/*     */   }
/*     */ 
/*     */   public final ComponentMonitor registerComponentImplementation$bb03b8(Object paramObject, Class paramClass, ComponentMonitor[] paramArrayOfComponentMonitor)
/*     */   {
/* 318 */     paramObject = this.componentAdapterFactory$278d24ea.createComponentAdapter$bb03b8(paramObject, paramClass, paramArrayOfComponentMonitor);
/* 319 */     return registerComponent$43c2bfe1(paramObject);
/*     */   }
/*     */ 
/*     */   public final Object getComponentInstance(Object componentKey)
/*     */   {
/*     */     ComponentMonitor componentAdapter;
/* 373 */     if ((
/* 373 */       componentAdapter = getComponentAdapter$506b371c(componentKey)) != null)
/*     */     {
/* 374 */       return getInstance$3444b082(componentKey);
/*     */     }
/* 376 */     return null;
/*     */   }
/*     */ 
/*     */   public final Object getComponentInstanceOfType(Class paramClass)
/*     */   {
/* 382 */     if ((
/* 382 */       paramClass = getComponentAdapterOfType$7caf752d(paramClass)) == null)
/* 382 */       return null; return getInstance$3444b082(paramClass);
/*     */   }
/*     */ 
/*     */   private Object getInstance$3444b082(ComponentMonitor paramComponentMonitor)
/*     */   {
/*     */     boolean bool;
/* 390 */     if ((
/* 390 */       bool = this.componentAdapters.contains(paramComponentMonitor)))
/*     */     {
/* 391 */       Object localObject = null;
/*     */       try {
/* 393 */         localObject = paramComponentMonitor.getComponentInstance(this);
/*     */       } catch (CyclicDependencyException localCyclicDependencyException) {
/* 395 */         if (this.parent != null)
/*     */         {
/* 397 */           if ((
/* 397 */             localObject = this.parent.getComponentInstance(paramComponentMonitor.getComponentKey())) != null)
/*     */           {
/* 398 */             return localObject;
/*     */           }
/*     */         }
/* 401 */         throw localCyclicDependencyException;
/*     */       }
/* 403 */       paramComponentMonitor = paramComponentMonitor; this = this; if (!this.orderedComponentAdapters.contains(paramComponentMonitor)) this.orderedComponentAdapters.add(paramComponentMonitor);
/*     */ 
/* 405 */       return localObject;
/* 406 */     }if (this.parent != null) {
/* 407 */       return this.parent.getComponentInstance(paramComponentMonitor.getComponentKey());
/*     */     }
/*     */ 
/* 410 */     return null;
/*     */   }
/*     */ 
/*     */   public final PicoContainer getParent()
/*     */   {
/* 415 */     return this.parent;
/*     */   }
/*     */ 
/*     */   public final void dispose()
/*     */   {
/* 517 */     if (this.disposed) throw new IllegalStateException("Already disposed");
/* 518 */     for (Iterator iterator = this.children.iterator(); iterator.hasNext(); )
/*     */     {
/*     */       PicoContainer child;
/* 519 */       (
/* 520 */         child = (PicoContainer)iterator.next())
/* 520 */         .dispose();
/*     */     }
/* 522 */     this.lifecycleManager.dispose(this);
/* 523 */     this.disposed = true;
/*     */   }
/*     */ 
/*     */   public final void changeMonitor(ComponentMonitor monitor)
/*     */   {
/* 573 */     if ((this.componentAdapterFactory$278d24ea instanceof ComponentMonitorStrategy)) {
/* 574 */       ((ComponentMonitorStrategy)this.componentAdapterFactory$278d24ea).changeMonitor(monitor);
/*     */     }
/* 576 */     for (Iterator i = this.componentAdapters.iterator(); i.hasNext(); )
/*     */     {
/*     */       Object adapter;
/* 578 */       if (((
/* 578 */         adapter = i.next()) instanceof ComponentMonitorStrategy))
/*     */       {
/* 579 */         ((ComponentMonitorStrategy)adapter).changeMonitor(monitor);
/*     */       }
/*     */     }
/* 582 */     for (Iterator i = this.children.iterator(); i.hasNext(); )
/*     */     {
/*     */       Object child;
/* 584 */       if (((
/* 584 */         child = i.next()) instanceof ComponentMonitorStrategy))
/*     */       {
/* 585 */         ((ComponentMonitorStrategy)child).changeMonitor(monitor);
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   private class OrderedComponentAdapterLifecycleManager
/*     */     implements Serializable, LifecycleManager
/*     */   {
/*     */     private final DefaultPicoContainer this$0;
/*     */ 
/*     */     private OrderedComponentAdapterLifecycleManager(byte arg2)
/*     */     {
/* 626 */       this.this$0 = this$1;
/*     */ 
/* 629 */       new ArrayList();
/*     */     }
/*     */ 
/*     */     public final void dispose(PicoContainer paramPicoContainer)
/*     */     {
/* 685 */       for (int i = (
/* 685 */         this = this.this$0.orderedComponentAdapters)
/* 685 */         .size() - 1; i >= 0; i--)
/*     */       {
/*     */         Object localObject;
/* 687 */         if (!((
/* 687 */           localObject = get(i)) instanceof LifecycleManager))
/*     */           continue;
/* 688 */         (
/* 689 */           localObject = (LifecycleManager)localObject)
/* 689 */           .dispose(paramPicoContainer);
/*     */       }
/*     */     }
/*     */ 
/*     */     OrderedComponentAdapterLifecycleManager()
/*     */     {
/* 626 */       this(0);
/*     */     }
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.picocontainer.defaults.DefaultPicoContainer
 * JD-Core Version:    0.6.0
 */