/*     */ package org.picocontainer.defaults;
/*     */ 
/*     */ import java.io.Serializable;
/*     */ import java.lang.reflect.Method;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.picocontainer.monitors.DefaultComponentMonitor;
/*     */ 
/*     */ public final class DelegatingComponentMonitor
/*     */   implements Serializable, ComponentMonitor, ComponentMonitorStrategy
/*     */ {
/*     */   private ComponentMonitor delegate;
/*     */ 
/*     */   private DelegatingComponentMonitor(ComponentMonitor paramComponentMonitor)
/*     */   {
/*  44 */     checkMonitor(paramComponentMonitor);
/*  45 */     this.delegate = paramComponentMonitor;
/*     */   }
/*     */ 
/*     */   public DelegatingComponentMonitor()
/*     */   {
/*  53 */     this(DefaultComponentMonitor.getInstance());
/*     */   }
/*     */ 
/*     */   public final void lifecycleInvocationFailed(Method method, Object instance, RuntimeException cause)
/*     */   {
/*  85 */     this.delegate.lifecycleInvocationFailed(method, instance, cause);
/*     */   }
/*     */ 
/*     */   public final void changeMonitor(ComponentMonitor paramComponentMonitor)
/*     */   {
/*  95 */     checkMonitor(paramComponentMonitor);
/*  96 */     if ((this.delegate instanceof ComponentMonitorStrategy)) {
/*  97 */       ((ComponentMonitorStrategy)this.delegate).changeMonitor(paramComponentMonitor);
/*  98 */       return;
/*  99 */     }this.delegate = paramComponentMonitor;
/*     */   }
/*     */ 
/*     */   private static void checkMonitor(ComponentMonitor monitor)
/*     */   {
/* 112 */     if (monitor == null)
/* 113 */       throw new NullPointerException("monitor");
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.picocontainer.defaults.DelegatingComponentMonitor
 * JD-Core Version:    0.6.0
 */