/*    */ package org.picocontainer.defaults;
/*    */ 
/*    */ import java.io.Serializable;
/*    */ import java.lang.reflect.InvocationHandler;
/*    */ import java.lang.reflect.Method;
/*    */ import java.lang.reflect.Proxy;
/*    */ import org.picocontainer.Disposable;
/*    */ import org.picocontainer.PicoContainer;
/*    */ import org.picocontainer.Startable;
/*    */ 
/*    */ public final class ImmutablePicoContainerProxyFactory
/*    */   implements Serializable, InvocationHandler
/*    */ {
/* 31 */   private static final Class[] interfaces = { PicoContainer.class };
/* 32 */   private static Method startMethod = null;
/* 33 */   private static Method stopMethod = null;
/* 34 */   private static Method disposeMethod = null;
/* 35 */   private static Method equalsMethod = null;
/*    */   private final PicoContainer pico;
/*    */ 
/*    */   private ImmutablePicoContainerProxyFactory(PicoContainer pico)
/*    */   {
/* 58 */     if (pico == null) {
/* 59 */       throw new NullPointerException();
/*    */     }
/* 61 */     this.pico = pico; } 
/*    */   // ERROR //
/*    */   public final Object invoke(Object paramObject, Method paramMethod, Object[] paramArrayOfObject) throws java.lang.Throwable { // Byte code:
/*    */     //   0: aload_2
/*    */     //   1: getstatic 37	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:startMethod	Ljava/lang/reflect/Method;
/*    */     //   4: invokevirtual 55	java/lang/reflect/Method:equals	(Ljava/lang/Object;)Z
/*    */     //   7: ifne +23 -> 30
/*    */     //   10: aload_2
/*    */     //   11: getstatic 38	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:stopMethod	Ljava/lang/reflect/Method;
/*    */     //   14: invokevirtual 55	java/lang/reflect/Method:equals	(Ljava/lang/Object;)Z
/*    */     //   17: ifne +13 -> 30
/*    */     //   20: aload_2
/*    */     //   21: getstatic 33	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:disposeMethod	Ljava/lang/reflect/Method;
/*    */     //   24: invokevirtual 55	java/lang/reflect/Method:equals	(Ljava/lang/Object;)Z
/*    */     //   27: ifeq +38 -> 65
/*    */     //   30: new 22	java/lang/UnsupportedOperationException
/*    */     //   33: dup
/*    */     //   34: new 20	java/lang/StringBuffer
/*    */     //   37: dup
/*    */     //   38: invokespecial 50	java/lang/StringBuffer:<init>	()V
/*    */     //   41: ldc 2
/*    */     //   43: invokevirtual 51	java/lang/StringBuffer:append	(Ljava/lang/String;)Ljava/lang/StringBuffer;
/*    */     //   46: aload_2
/*    */     //   47: invokevirtual 56	java/lang/reflect/Method:getName	()Ljava/lang/String;
/*    */     //   50: invokevirtual 51	java/lang/StringBuffer:append	(Ljava/lang/String;)Ljava/lang/StringBuffer;
/*    */     //   53: ldc 1
/*    */     //   55: invokevirtual 51	java/lang/StringBuffer:append	(Ljava/lang/String;)Ljava/lang/StringBuffer;
/*    */     //   58: invokevirtual 52	java/lang/StringBuffer:toString	()Ljava/lang/String;
/*    */     //   61: invokespecial 53	java/lang/UnsupportedOperationException:<init>	(Ljava/lang/String;)V
/*    */     //   64: athrow
/*    */     //   65: aload_2
/*    */     //   66: getstatic 34	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:equalsMethod	Ljava/lang/reflect/Method;
/*    */     //   69: invokevirtual 55	java/lang/reflect/Method:equals	(Ljava/lang/Object;)Z
/*    */     //   72: ifeq +35 -> 107
/*    */     //   75: new 12	java/lang/Boolean
/*    */     //   78: dup
/*    */     //   79: aload_3
/*    */     //   80: iconst_0
/*    */     //   81: aaload
/*    */     //   82: ifnull +20 -> 102
/*    */     //   85: aload_3
/*    */     //   86: iconst_0
/*    */     //   87: aaload
/*    */     //   88: aload_0
/*    */     //   89: getfield 36	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:pico	Lorg/picocontainer/PicoContainer;
/*    */     //   92: invokevirtual 49	java/lang/Object:equals	(Ljava/lang/Object;)Z
/*    */     //   95: ifeq +7 -> 102
/*    */     //   98: iconst_1
/*    */     //   99: goto +4 -> 103
/*    */     //   102: iconst_0
/*    */     //   103: invokespecial 39	java/lang/Boolean:<init>	(Z)V
/*    */     //   106: areturn
/*    */     //   107: aload_2
/*    */     //   108: aload_0
/*    */     //   109: getfield 36	org/picocontainer/defaults/ImmutablePicoContainerProxyFactory:pico	Lorg/picocontainer/PicoContainer;
/*    */     //   112: aload_3
/*    */     //   113: invokevirtual 57	java/lang/reflect/Method:invoke	(Ljava/lang/Object;[Ljava/lang/Object;)Ljava/lang/Object;
/*    */     //   116: areturn
/*    */     //   117: dup
/*    */     //   118: astore_0
/*    */     //   119: invokevirtual 54	java/lang/reflect/InvocationTargetException:getTargetException	()Ljava/lang/Throwable;
/*    */     //   122: athrow
/*    */     //
/*    */     // Exception table:
/*    */     //   from	to	target	type
/*    */     //   107	116	117	java/lang/reflect/InvocationTargetException } 
/* 90 */   public static PicoContainer newProxyInstance(PicoContainer pico) { return (PicoContainer)Proxy.newProxyInstance(PicoContainer.class.getClassLoader(), interfaces, new ImmutablePicoContainerProxyFactory(pico));
/*    */   }
/*    */ 
/*    */   static
/*    */   {
/*    */     try
/*    */     {
/* 39 */       startMethod = Startable.class.getMethod("start", new Class[0]);
/* 40 */       stopMethod = Startable.class.getMethod("stop", new Class[0]);
/* 41 */       disposeMethod = Disposable.class.getMethod("dispose", new Class[0]);
/* 42 */       equalsMethod = class$java$lang$Object.getMethod("equals", new Class[] { Object.class });
/*    */ 
/* 45 */       return;
/*    */     }
/*    */     catch (NoSuchMethodException localNoSuchMethodException)
/*    */     {
/*    */     }
/* 44 */     throw new InternalError(localNoSuchMethodException.getMessage());
/*    */   }
/*    */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.picocontainer.defaults.ImmutablePicoContainerProxyFactory
 * JD-Core Version:    0.6.0
 */