/*     */ package org.slf4j;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.net.URL;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Enumeration;
/*     */ import java.util.List;
/*     */ import org.picocontainer.ComponentMonitor;
/*     */ import org.slf4j.helpers.SubstituteLoggerFactory;
/*     */ import org.slf4j.helpers.Util;
/*     */ import org.slf4j.impl.StaticLoggerBinder;
/*     */ 
/*     */ public final class LoggerFactory
/*     */ {
/*  75 */   private static int INITIALIZATION_STATE = 0;
/*  76 */   private static int GET_SINGLETON_METHOD = 0;
/*  77 */   private static SubstituteLoggerFactory TEMP_FACTORY = new SubstituteLoggerFactory();
/*     */ 
/*  87 */   private static final String[] API_COMPATIBILITY_LIST = { "1.5.5", "1.5.6", "1.5.7", "1.5.8", "1.5.9", "1.5.10", "1.5.11" };
/*     */ 
/* 189 */   private static String STATIC_LOGGER_BINDER_PATH = "org/slf4j/impl/StaticLoggerBinder.class";
/*     */ 
/*     */   private static final void performInitialization()
/*     */   {
/*     */     try
/*     */     {
/* 112 */       getSingleton(); INITIALIZATION_STATE = 3;
/*     */       List localList;
/* 112 */       if ((localList = TEMP_FACTORY.getLoggerNameList()).size() != 0) { Util.reportFailure("The following loggers will not work becasue they were created"); Util.reportFailure("during the default configuration phase of the underlying logging system."); Util.reportFailure("See also http://www.slf4j.org/codes.html#substituteLogger"); for (int i = 0; i < localList.size(); i++)
/*     */         {
/*     */           String str2;
/* 112 */           Util.reportFailure(str2 = (String)localList.get(i));
/*     */         } }  } catch (NoClassDefFoundError localNoClassDefFoundError) {
/* 112 */       INITIALIZATION_STATE = 2;
/*     */       String str1;
/* 112 */       if (((str1 = localNoClassDefFoundError.getMessage()) != null) && (str1.indexOf("org/slf4j/impl/StaticLoggerBinder") != -1)) { Util.reportFailure("Failed to load class \"org.slf4j.impl.StaticLoggerBinder\"."); Util.reportFailure("See http://www.slf4j.org/codes.html#StaticLoggerBinder for further details."); } throw localNoClassDefFoundError; } catch (Exception localException) { INITIALIZATION_STATE = 2; getSingleton(); Util.reportFailure("Failed to instantiate logger [" + StaticLoggerBinder.getLoggerFactoryClassStr() + "]", localException); }
/* 113 */     versionSanityCheck();
/* 114 */     singleImplementationSanityCheck();
/*     */   }
/*     */ 
/*     */   private static final void versionSanityCheck()
/*     */   {
/*     */     try
/*     */     {
/* 161 */       String str = StaticLoggerBinder.REQUESTED_API_VERSION;
/*     */ 
/* 163 */       int i = 0;
/* 164 */       for (int j = 0; j < API_COMPATIBILITY_LIST.length; j++) {
/* 165 */         if (str.startsWith(API_COMPATIBILITY_LIST[j])) {
/* 166 */           i = 1;
/*     */         }
/*     */       }
/* 169 */       if (i == 0) {
/* 170 */         Util.reportFailure("The requested version " + str + " by your slf4j binding is not compatible with " + Arrays.asList(API_COMPATIBILITY_LIST).toString());
/*     */ 
/* 173 */         Util.reportFailure("See http://www.slf4j.org/codes.html#version_mismatch for further details.");
/*     */       }
/*     */ 
/* 184 */       return; } catch (NoSuchFieldError localNoSuchFieldError) { return;
/*     */     }
/*     */     catch (Throwable localThrowable)
/*     */     {
/* 182 */       Util.reportFailure("Unexpected problem occured during version sanity check", localThrowable);
/*     */     }
/*     */   }
/*     */ 
/*     */   private static void singleImplementationSanityCheck()
/*     */   {
/*     */     try
/*     */     {
/* 195 */       if ((
/* 195 */         localObject = LoggerFactory.class.getClassLoader()) == null)
/*     */       {
/* 197 */         return;
/*     */       }
/* 199 */       Object localObject = ((ClassLoader)localObject).getResources(STATIC_LOGGER_BINDER_PATH);
/*     */ 
/* 201 */       ArrayList localArrayList = new ArrayList();
/* 202 */       while (((Enumeration)localObject).hasMoreElements()) {
/* 203 */         URL localURL = (URL)((Enumeration)localObject).nextElement();
/* 204 */         localArrayList.add(localURL);
/*     */       }
/* 206 */       if (localArrayList.size() > 1) {
/* 207 */         Util.reportFailure("Class path contains multiple SLF4J bindings.");
/* 208 */         for (int i = 0; i < localArrayList.size(); i++) {
/* 209 */           Util.reportFailure("Found binding in [" + localArrayList.get(i) + "]");
/*     */         }
/*     */ 
/* 212 */         Util.reportFailure("See http://www.slf4j.org/codes.html#multiple_bindings for an explanation.");
/*     */       }
/*     */ 
/* 217 */       return;
/*     */     }
/*     */     catch (IOException localIOException)
/*     */     {
/* 216 */       Util.reportFailure("Error getting resources from path", localIOException);
/*     */     }
/*     */   }
/*     */ 
/*     */   private static final StaticLoggerBinder getSingleton() {
/* 221 */     if (GET_SINGLETON_METHOD == 1) {
/* 222 */       return StaticLoggerBinder.SINGLETON;
/*     */     }
/*     */ 
/* 225 */     if (GET_SINGLETON_METHOD == 2) {
/* 226 */       return StaticLoggerBinder.getSingleton();
/*     */     }
/*     */     try
/*     */     {
/* 230 */       StaticLoggerBinder singleton = StaticLoggerBinder.getSingleton();
/* 231 */       GET_SINGLETON_METHOD = 2;
/* 232 */       return singleton;
/*     */     }
/*     */     catch (NoSuchMethodError localNoSuchMethodError1)
/*     */     {
/*     */       NoSuchMethodError nsme;
/* 234 */       GET_SINGLETON_METHOD = 1;
/* 235 */     }return StaticLoggerBinder.SINGLETON;
/*     */   }
/*     */ 
/*     */   public static ComponentMonitor getLogger$424215df(String name)
/*     */   {
/* 248 */     if (INITIALIZATION_STATE == 0) { INITIALIZATION_STATE = 1; performInitialization(); } switch (INITIALIZATION_STATE) { case 3:
/* 248 */       tmpTernaryOp = getSingleton().getLoggerFactory$246c8768(); break;
/*     */     case 2:
/* 248 */       throw new IllegalStateException("org.slf4j.LoggerFactory could not be successfully initialized. See also http://www.slf4j.org/codes.html#unsuccessfulInit");
/*     */     case 1:
/* 248 */       tmpTernaryOp = TEMP_FACTORY; break;
/*     */     default:
/* 248 */       throw new IllegalStateException("Unreachable code");
/*     */     }
/*     */   }
/*     */ 
/*     */   public static ComponentMonitor getLogger$4ecaad6a(Class clazz)
/*     */   {
/* 261 */     return getLogger$424215df(clazz.getName());
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.slf4j.LoggerFactory
 * JD-Core Version:    0.6.0
 */