/*     */ package org.slf4j.impl;
/*     */ 
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.LogRecord;
/*     */ import java.util.logging.Logger;
/*     */ import org.slf4j.helpers.MarkerIgnoringBase;
/*     */ import org.slf4j.spi.LocationAwareLogger;
/*     */ 
/*     */ public final class JDK14LoggerAdapter extends MarkerIgnoringBase
/*     */   implements LocationAwareLogger
/*     */ {
/*     */   private Logger logger;
/* 591 */   private static String SELF = JDK14LoggerAdapter.class.getName();
/* 592 */   private static String SUPER = MarkerIgnoringBase.class.getName();
/*     */ 
/*     */   JDK14LoggerAdapter(Logger logger)
/*     */   {
/*  64 */     this.logger = logger;
/*  65 */     this.name = logger.getName();
/*     */   }
/*     */ 
/*     */   public final boolean isTraceEnabled()
/*     */   {
/*  74 */     return this.logger.isLoggable(Level.FINEST);
/*     */   }
/*     */ 
/*     */   public final void trace(String msg)
/*     */   {
/*  84 */     if (this.logger.isLoggable(Level.FINEST))
/*  85 */       log(SELF, Level.FINEST, msg, null);
/*     */   }
/*     */ 
/*     */   public final void trace(String msg, Throwable t)
/*     */   {
/* 163 */     if (this.logger.isLoggable(Level.FINEST))
/* 164 */       log(SELF, Level.FINEST, msg, t);
/*     */   }
/*     */ 
/*     */   public final boolean isDebugEnabled()
/*     */   {
/* 174 */     return this.logger.isLoggable(Level.FINE);
/*     */   }
/*     */ 
/*     */   public final void debug(String msg)
/*     */   {
/* 184 */     if (this.logger.isLoggable(Level.FINE))
/* 185 */       log(SELF, Level.FINE, msg, null);
/*     */   }
/*     */ 
/*     */   public final void debug(String msg, Throwable t)
/*     */   {
/* 262 */     if (this.logger.isLoggable(Level.FINE))
/* 263 */       log(SELF, Level.FINE, msg, t);
/*     */   }
/*     */ 
/*     */   public final boolean isInfoEnabled()
/*     */   {
/* 273 */     return this.logger.isLoggable(Level.INFO);
/*     */   }
/*     */ 
/*     */   public final void info(String msg)
/*     */   {
/* 283 */     if (this.logger.isLoggable(Level.INFO))
/* 284 */       log(SELF, Level.INFO, msg, null);
/*     */   }
/*     */ 
/*     */   public final void info(String msg, Throwable t)
/*     */   {
/* 362 */     if (this.logger.isLoggable(Level.INFO))
/* 363 */       log(SELF, Level.INFO, msg, t);
/*     */   }
/*     */ 
/*     */   public final boolean isWarnEnabled()
/*     */   {
/* 374 */     return this.logger.isLoggable(Level.WARNING);
/*     */   }
/*     */ 
/*     */   public final void warn(String msg)
/*     */   {
/* 384 */     if (this.logger.isLoggable(Level.WARNING))
/* 385 */       log(SELF, Level.WARNING, msg, null);
/*     */   }
/*     */ 
/*     */   public final void warn(String msg, Throwable t)
/*     */   {
/* 464 */     if (this.logger.isLoggable(Level.WARNING))
/* 465 */       log(SELF, Level.WARNING, msg, t);
/*     */   }
/*     */ 
/*     */   public final boolean isErrorEnabled()
/*     */   {
/* 475 */     return this.logger.isLoggable(Level.SEVERE);
/*     */   }
/*     */ 
/*     */   public final void error(String msg)
/*     */   {
/* 485 */     if (this.logger.isLoggable(Level.SEVERE))
/* 486 */       log(SELF, Level.SEVERE, msg, null);
/*     */   }
/*     */ 
/*     */   public final void error(String msg, Throwable t)
/*     */   {
/* 565 */     if (this.logger.isLoggable(Level.SEVERE))
/* 566 */       log(SELF, Level.SEVERE, msg, t);
/*     */   }
/*     */ 
/*     */   private void log(String paramString1, Level paramLevel, String paramString2, Throwable paramThrowable)
/*     */   {
/* 583 */     (
/* 584 */       paramLevel = new LogRecord(paramLevel, paramString2))
/* 584 */       .setLoggerName(getName());
/* 585 */     paramLevel.setThrown(paramThrowable);
/* 586 */     fillCallerData(paramString1, paramLevel);
/* 587 */     this.logger.log(paramLevel);
/*     */   }
/*     */ 
/*     */   private static void fillCallerData(String paramString, LogRecord paramLogRecord)
/*     */   {
/* 601 */     StackTraceElement[] arrayOfStackTraceElement = new Throwable().getStackTrace();
/*     */ 
/* 603 */     int i = -1;
/* 604 */     for (int j = 0; j < arrayOfStackTraceElement.length; j++)
/*     */     {
/*     */       String str2;
/* 606 */       if (((
/* 606 */         str2 = arrayOfStackTraceElement[j].getClassName())
/* 606 */         .equals(paramString)) || (str2.equals(SUPER))) {
/* 607 */         i = j;
/* 608 */         break;
/*     */       }
/*     */     }
/*     */ 
/* 612 */     j = -1;
/* 613 */     for (int k = i + 1; k < arrayOfStackTraceElement.length; k++)
/*     */     {
/*     */       String str1;
/* 615 */       if ((!(
/* 615 */         str1 = arrayOfStackTraceElement[k].getClassName())
/* 615 */         .equals(paramString)) && (!str1.equals(SUPER))) {
/* 616 */         j = k;
/* 617 */         break;
/*     */       }
/*     */     }
/*     */ 
/* 621 */     if (j != -1) {
/* 622 */       StackTraceElement localStackTraceElement = arrayOfStackTraceElement[j];
/*     */ 
/* 625 */       paramLogRecord.setSourceClassName(localStackTraceElement.getClassName());
/* 626 */       paramLogRecord.setSourceMethodName(localStackTraceElement.getMethodName());
/*     */     }
/*     */   }
/*     */ 
/*     */   public final void log$2d544f05(String paramString1, int paramInt, String paramString2, Throwable paramThrowable)
/*     */   {
/* 633 */     switch (paramInt) {
/*     */     case 0:
/* 635 */       paramInt = Level.FINEST;
/* 636 */       break;
/*     */     case 10:
/* 638 */       paramInt = Level.FINE;
/* 639 */       break;
/*     */     case 20:
/* 641 */       paramInt = Level.INFO;
/* 642 */       break;
/*     */     case 30:
/* 644 */       paramInt = Level.WARNING;
/* 645 */       break;
/*     */     case 40:
/* 647 */       paramInt = Level.SEVERE;
/* 648 */       break;
/*     */     default:
/* 650 */       throw new IllegalStateException("Level number " + paramInt + " is not recognized.");
/*     */     }
/*     */ 
/* 658 */     if (this.logger.isLoggable(paramInt))
/* 659 */       log(paramString1, paramInt, paramString2, paramThrowable);
/*     */   }
/*     */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     org.slf4j.impl.JDK14LoggerAdapter
 * JD-Core Version:    0.6.0
 */