/*      */ package thinlet;
/*      */ 
/*      */ import I;
/*      */ import java.awt.AWTEvent;
/*      */ import java.awt.Color;
/*      */ import java.awt.Component;
/*      */ import java.awt.Container;
/*      */ import java.awt.Cursor;
/*      */ import java.awt.Dimension;
/*      */ import java.awt.Font;
/*      */ import java.awt.FontMetrics;
/*      */ import java.awt.Graphics;
/*      */ import java.awt.Image;
/*      */ import java.awt.MediaTracker;
/*      */ import java.awt.Rectangle;
/*      */ import java.awt.Toolkit;
/*      */ import java.awt.datatransfer.Clipboard;
/*      */ import java.awt.datatransfer.DataFlavor;
/*      */ import java.awt.datatransfer.StringSelection;
/*      */ import java.awt.datatransfer.Transferable;
/*      */ import java.awt.event.InputEvent;
/*      */ import java.awt.event.KeyEvent;
/*      */ import java.awt.event.MouseEvent;
/*      */ import java.awt.image.MemoryImageSource;
/*      */ import java.io.BufferedReader;
/*      */ import java.io.IOException;
/*      */ import java.io.InputStream;
/*      */ import java.io.InputStreamReader;
/*      */ import java.io.PrintStream;
/*      */ import java.io.Reader;
/*      */ import java.io.Serializable;
/*      */ import java.io.UnsupportedEncodingException;
/*      */ import java.lang.reflect.Field;
/*      */ import java.lang.reflect.InvocationTargetException;
/*      */ import java.lang.reflect.Method;
/*      */ import java.net.MalformedURLException;
/*      */ import java.net.URL;
/*      */ import java.util.Hashtable;
/*      */ import java.util.ResourceBundle;
/*      */ import java.util.StringTokenizer;
/*      */ import java.util.Vector;
/*      */ 
/*      */ public class Thinlet extends Container
/*      */   implements Serializable, Runnable
/*      */ {
/*   75 */   private transient boolean _useRoundedButtons = false;
/*      */   private transient Font _font;
/*      */   private transient Color _cBg;
/*      */   private transient Color _cText;
/*      */   private transient Color _cTextbg;
/*      */   private transient Color _cBorder;
/*      */   private transient Color _cDisable;
/*      */   private transient Color _cHover;
/*      */   private transient Color _cPress;
/*      */   private transient Color _cFocus;
/*      */   private transient Color _cSelect;
/*   97 */   private final transient Color _cCtrl = null;
/*      */   private transient int _block;
/*      */   private transient Image _hgradient;
/*      */   private transient Image _vgradient;
/*      */   private transient Thread _timer;
/*      */   private transient long _watchdelay;
/*      */   private transient long _watch;
/*      */   private transient String _clipboard;
/*      */   private transient ResourceBundle _resourcebundle;
/*  119 */   private String findprefix = "";
/*      */   private transient long findtime;
/*  123 */   private final Object content = createImpl("desktop");
/*      */   private transient Object mouseinside;
/*      */   private transient Object insidepart;
/*      */   private transient Object mousepressed;
/*      */   private transient Object pressedpart;
/*      */   private transient int referencex;
/*      */   private transient int referencey;
/*      */   private transient int mousex;
/*      */   private transient int mousey;
/*      */   private transient Object focusowner;
/*      */   private transient boolean focusinside;
/*      */   private transient Object popupowner;
/*      */   private transient Object tooltipowner;
/*  151 */   private static long WHEEL_MASK = 0L;
/*      */ 
/*  153 */   private static int MOUSE_WHEEL = 0;
/*      */   private static Method wheelrotation;
/*      */   private static Method renderinghint;
/*      */   private static Object[] TXT_AA;
/*      */   private static Object[] G_AA;
/*      */   private static boolean _isFocusVisible;
/*  161 */   private static int evm = 0;
/*      */   private static Object[] _dtd;
/*      */ 
/*      */   public Thinlet()
/*      */   {
/*  197 */     setFont(new Font("SansSerif", 0, 12));
/*      */ 
/*  200 */     setColors(15132390, 0, 16777215, 9474192, 11579568, 15592941, 12171705, 9013658, 12961245);
/*      */ 
/*  204 */     if (MOUSE_WHEEL != 0) {
/*      */       try {
/*  206 */         getClass().getMethod("setFocusTraversalKeysEnabled", new Class[] { Boolean.TYPE }).invoke(this, new Object[] { Boolean.FALSE });
/*      */       }
/*      */       catch (Exception localException)
/*      */       {
/*      */       }
/*      */     }
/*      */ 
/*  213 */     enableEvents(0x3D | WHEEL_MASK);
/*      */ 
/*  218 */     _isFocusVisible = this = 1;
/*      */   }
/*      */ 
/*      */   public void setColors(int background, int text, int textbackground, int border, int disable, int hover, int press, int focus, int select)
/*      */   {
/*  256 */     this._cBg = new Color(background);
/*  257 */     this._cText = new Color(text);
/*  258 */     this._cTextbg = new Color(textbackground);
/*  259 */     this._cBorder = new Color(border);
/*  260 */     this._cDisable = new Color(disable);
/*  261 */     this._cHover = new Color(hover);
/*  262 */     this._cPress = new Color(press);
/*  263 */     this._cFocus = new Color(focus);
/*  264 */     this._cSelect = new Color(select);
/*  265 */     this._hgradient = null;
/*  266 */     this._vgradient = null;
/*  267 */     repaint();
/*      */   }
/*      */ 
/*      */   public void setUseRoundedButtons(boolean rb) {
/*  271 */     this._useRoundedButtons = rb;
/*      */   }
/*      */ 
/*      */   public void setFont(Font font)
/*      */   {
/*  285 */     this._block = getFontMetrics(font).getHeight();
/*  286 */     super.setFont(font);
/*  287 */     this._font = font;
/*  288 */     this._hgradient = null;
/*  289 */     this._vgradient = null;
/*  290 */     if (this.content != null)
/*  291 */       validate(this.content);
/*      */   }
/*      */ 
/*      */   private void doLayout(Object paramObject)
/*      */   {
/*  296 */     String str1 = getClass(paramObject);
/*  297 */     if ("combobox".equals(str1)) {
/*  298 */       if (getBoolean(paramObject, "editable", true)) {
/*  299 */         Image localImage = getIcon(paramObject, "icon", null);
/*  300 */         layoutField(paramObject, this._block, false, localImage != null ? localImage.getWidth(this) : 0);
/*      */ 
/*  302 */         return;
/*      */       }
/*      */       int j;
/*  306 */       if ((
/*  306 */         j = getInteger(paramObject, "selected", -1)) != 
/*  306 */         -1) {
/*  307 */         Object localObject2 = getItem(paramObject, j);
/*  308 */         set(paramObject, "text", get(localObject2, "text"));
/*      */ 
/*  310 */         set(paramObject, "icon", get(localObject2, "icon"));
/*      */       }
/*      */ 
/*  313 */       return;
/*  314 */     }if (("textfield".equals(str1)) || ("passwordfield".equals(str1)))
/*      */     {
/*  316 */       layoutField(paramObject, 0, "passwordfield".equals(str1), 0); return;
/*      */     }
/*      */     Object localObject1;
/*      */     int i1;
/*      */     boolean bool1;
/*      */     Object localObject8;
/*      */     int i19;
/*      */     int i20;
/*  318 */     if ("textarea".equals(str1)) {
/*  319 */       localObject1 = getString(paramObject, "text", "");
/*      */       int n;
/*  321 */       if ((
/*  321 */         n = getInteger(paramObject, "start", 0)) > 
/*  321 */         ((String)localObject1).length()) {
/*  322 */         setInteger(paramObject, "start", ((String)localObject1).length(), 0);
/*      */       }
/*      */ 
/*  326 */       if ((
/*  326 */         i1 = getInteger(paramObject, "end", 0)) > 
/*  326 */         ((String)localObject1).length())
/*  327 */         setInteger(paramObject, "end", i1 = ((String)localObject1).length(), 0);
/*      */       char[] arrayOfChar;
/*  332 */       if ((
/*  332 */         bool1 = getBoolean(paramObject, "wrap", false)))
/*      */       {
/*  334 */         localObject8 = getRectangle(paramObject, "bounds");
/*      */ 
/*  338 */         if ((
/*  338 */           arrayOfChar = getChars(paramObject, (String)localObject1, true, ((Rectangle)localObject8).width - 4, ((Rectangle)localObject8).height)) == null)
/*      */         {
/*  339 */           arrayOfChar = getChars(paramObject, (String)localObject1, true, ((Rectangle)localObject8).width - this._block - 4, 0);
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/*  344 */         arrayOfChar = getChars(paramObject, (String)localObject1, false, 0, 0);
/*      */       }
/*      */ 
/*  347 */       localObject8 = (Font)get(paramObject, "font");
/*  348 */       FontMetrics localFontMetrics = getFontMetrics(localObject8 != null ? localObject8 : this._font);
/*      */ 
/*  350 */       int i12 = 0;
/*  351 */       int i16 = 0;
/*  352 */       i19 = 0;
/*  353 */       i20 = 0;
/*  354 */       int i21 = 0; for (int i23 = 0; i23 <= arrayOfChar.length; i23++) {
/*  355 */         if ((i23 == arrayOfChar.length) || (arrayOfChar[i23] == '\n')) {
/*  356 */           i12 = Math.max(i12, localFontMetrics.charsWidth(arrayOfChar, i21, i23 - i21));
/*      */ 
/*  358 */           if ((i1 >= i21) && (i1 <= i23)) {
/*  359 */             i19 = localFontMetrics.charsWidth(arrayOfChar, i21, i1 - i21);
/*  360 */             i20 = i16;
/*      */           }
/*  362 */           i16 += localFontMetrics.getHeight();
/*  363 */           i21 = i23 + 1;
/*      */         }
/*      */       }
/*  366 */       layoutScroll(paramObject, i12 + 2, i16 - localFontMetrics.getLeading() + 2, 0, 0, 0, 0, getBoolean(paramObject, "border", true), 0);
/*      */ 
/*  369 */       scrollToVisible(paramObject, i19, i20, 2, localFontMetrics.getAscent() + localFontMetrics.getDescent() + 2);
/*      */ 
/*  371 */       return;
/*      */     }
/*      */     Object localObject3;
/*      */     int i6;
/*      */     int i10;
/*      */     int i13;
/*      */     int i17;
/*  371 */     if ("tabbedpane".equals(str1))
/*      */     {
/*  373 */       localObject1 = getRectangle(paramObject, "bounds");
/*  374 */       localObject3 = getString(paramObject, "placement", "top");
/*      */ 
/*  376 */       i1 = ("top".equals(localObject3)) || ("bottom".equals(localObject3)) ? 1 : 0;
/*      */ 
/*  379 */       bool1 = "stacked".equals(localObject3);
/*      */ 
/*  382 */       i6 = 0;
/*  383 */       i10 = 0;
/*      */ 
/*  386 */       for (Object localObject11 = get(paramObject, ":comp"); localObject11 != null; localObject11 = get(localObject11, ":next"))
/*      */       {
/*  388 */         if ((i6 == 0) && ((localObject8 = getRectangle(localObject11, "bounds")) != null))
/*      */         {
/*  390 */           i6 = i1 != 0 ? ((Rectangle)localObject8).x : ((Rectangle)localObject8).y;
/*      */         }
/*      */ 
/*  393 */         Dimension localDimension3 = getSize(localObject11, i1 != 0 ? 12 : bool1 ? 8 : 9, i1 != 0 ? 5 : bool1 ? 3 : 8);
/*      */ 
/*  396 */         setRectangle(localObject11, "bounds", i1 != 0 ? i6 : 0, i1 != 0 ? 0 : i6, bool1 ? ((Rectangle)localObject1).width : localDimension3.width, localDimension3.height);
/*      */ 
/*  399 */         if (bool1) {
/*  400 */           i6 += localDimension3.height;
/*      */         } else {
/*  402 */           i6 += (i1 != 0 ? localDimension3.width : localDimension3.height) - 3;
/*  403 */           i10 = Math.max(i10, i1 != 0 ? localDimension3.height : localDimension3.width);
/*      */         }
/*      */ 
/*      */       }
/*      */ 
/*  409 */       i13 = "left".equals(localObject3) ? i10 + 1 : 2;
/*  410 */       i17 = "top".equals(localObject3) ? i10 + 1 : 2;
/*  411 */       i19 = ((Rectangle)localObject1).width - ((i1 != 0) || (bool1) ? 4 : i10 + 3);
/*      */ 
/*  413 */       i20 = ((Rectangle)localObject1).height - (i1 != 0 ? i10 + 3 : bool1 ? i6 + 3 : 4);
/*      */ 
/*  416 */       for (Object localObject14 = get(paramObject, ":comp"); localObject14 != null; localObject14 = get(localObject14, ":next"))
/*      */       {
/*  418 */         Rectangle localRectangle4 = getRectangle(localObject14, "bounds");
/*  419 */         if (!bool1)
/*  420 */           if (i1 != 0) {
/*  421 */             if ("bottom".equals(localObject3)) {
/*  422 */               localRectangle4.y = (((Rectangle)localObject1).height - i10);
/*      */             }
/*  424 */             localRectangle4.height = i10;
/*      */           } else {
/*  426 */             if ("right".equals(localObject3)) {
/*  427 */               localRectangle4.x = (((Rectangle)localObject1).width - i10);
/*      */             }
/*  429 */             localRectangle4.width = i10;
/*      */           }
/*      */         Object localObject15;
/*  435 */         if (((
/*  435 */           localObject15 = get(localObject14, ":comp")) != null) && 
/*  435 */           (getBoolean(localObject15, "visible", true))) {
/*  436 */           setRectangle(localObject15, "bounds", i13 - localRectangle4.x, bool1 ? localRectangle4.height + 1 : i17 - localRectangle4.y, i19, i20);
/*      */ 
/*  438 */           doLayout(localObject15);
/*      */         }
/*      */       }
/*  441 */       checkOffset(paramObject);
/*  442 */       return;
/*      */     }
/*      */     int i;
/*      */     int i18;
/*      */     Object localObject12;
/*      */     Object localObject13;
/*  442 */     if (("panel".equals(str1)) || ("dialog".equals(str1)))
/*      */     {
/*  444 */       int k = getInteger(paramObject, "gap", 0);
/*  445 */       localObject3 = getGrid(paramObject);
/*  446 */       i1 = 0;
/*  447 */       bool1 = false;
/*  448 */       i6 = 0;
/*  449 */       int i8 = 0;
/*      */       int i3;
/*  450 */       if (localObject3 != null) {
/*  451 */         i1 = getInteger(paramObject, "top", 0);
/*  452 */         i3 = getInteger(paramObject, "left", 0);
/*  453 */         i10 = getInteger(paramObject, "bottom", 0);
/*  454 */         i13 = getInteger(paramObject, "right", 0);
/*      */ 
/*  456 */         i6 = i3 + getSum(localObject3[0], 0, localObject3[0].length, k, false) + i13;
/*      */ 
/*  459 */         i8 = i1 + getSum(localObject3[1], 0, localObject3[1].length, k, false) + i10;
/*      */       }
/*      */ 
/*  464 */       i10 = getSize(paramObject, 0, 0).height;
/*      */ 
/*  466 */       setInteger(paramObject, ":titleheight", i10, 0);
/*  467 */       boolean bool2 = getBoolean(paramObject, "scrollable", false);
/*      */ 
/*  472 */       i19 = (
/*  472 */         i17 = ("panel".equals(str1)) && (getBoolean(paramObject, "border", false)) ? 1 : 0) != 0
/*  472 */          ? 1 : 0;
/*      */       int i22;
/*  473 */       if (bool2) {
/*  474 */         if ("panel".equals(str1)) {
/*  475 */           i20 = i10 / 2;
/*  476 */           i22 = i10 > 0 ? i10 - i20 - i19 : 0;
/*      */ 
/*  478 */           bool2 = layoutScroll(paramObject, i6, i8, i20, 0, 0, 0, i17, i22);
/*      */         }
/*      */         else
/*      */         {
/*  482 */           bool2 = layoutScroll(paramObject, i6, i8, i10 + 3, 3, 3, 3, true, 0);
/*      */         }
/*      */ 
/*      */       }
/*      */ 
/*  488 */       if (!bool2) {
/*  489 */         set(paramObject, ":view", null);
/*  490 */         set(paramObject, ":port", null);
/*      */       }
/*      */ 
/*  493 */       if (localObject3 != null) {
/*  494 */         i20 = 0;
/*  495 */         i22 = 0;
/*      */         Rectangle localRectangle3;
/*      */         int i24;
/*      */         Object localObject16;
/*  496 */         if (bool2)
/*      */         {
/*  501 */           i24 = (
/*  501 */             localRectangle3 = getRectangle(paramObject, ":view")).width;
/*      */ 
/*  502 */           localObject16 = localRectangle3.height;
/*      */         }
/*      */         else
/*      */         {
/*  506 */           i24 = (
/*  506 */             localRectangle3 = getRectangle(paramObject, "bounds")).width;
/*      */ 
/*  507 */           localObject16 = localRectangle3.height;
/*  508 */           if ("panel".equals(str1)) {
/*  509 */             i20 = i19;
/*  510 */             i22 = Math.max(i19, i10);
/*  511 */             i24 -= i19 * 2;
/*  512 */             localObject16 -= i22 + i19;
/*      */           } else {
/*  514 */             i20 = 4;
/*  515 */             i22 = i10 + 4;
/*  516 */             i24 -= 8;
/*  517 */             localObject16 -= i22 + 4;
/*      */           }
/*      */         }
/*      */ 
/*  521 */         for (int i14 = 0; i14 < 2; i14++)
/*      */         {
/*  527 */           if ((
/*  527 */             i = i14 == 0 ? i24 - i6 : localObject16 - i8) == 0)
/*      */           {
/*      */             continue;
/*      */           }
/*      */ 
/*  531 */           if ((
/*  531 */             i10 = getSum(localObject3[(i14 + 2)], 0, localObject3[(i14 + 2)].length, 0, false)) > 0)
/*      */           {
/*  532 */             for (i18 = 0; i18 < localObject3[i14].length; i18++) {
/*  533 */               if (localObject3[(i14 + 2)][i18] != 0) {
/*  534 */                 localObject3[i14][i18] += i * localObject3[(i14 + 2)][i18] / i10;
/*      */               }
/*      */             }
/*      */           }
/*      */ 
/*      */         }
/*      */ 
/*  541 */         localObject12 = get(paramObject, ":comp");
/*  542 */         for (i = 0; localObject12 != null; localObject12 = get(localObject12, ":next"))
/*  543 */           if (getBoolean(localObject12, "visible", true)) {
/*  544 */             i10 = i20 + i3 + getSum(localObject3[0], 0, localObject3[4][i], k, true);
/*      */ 
/*  549 */             i18 = i22 + i1 + getSum(localObject3[1], 0, localObject3[5][i], k, true);
/*      */ 
/*  552 */             paramObject = getSum(localObject3[0], localObject3[4][i], localObject3[6][i], k, false);
/*      */ 
/*  554 */             i6 = getSum(localObject3[1], localObject3[5][i], localObject3[7][i], k, false);
/*      */ 
/*  556 */             String str3 = getString(localObject12, "halign", "fill");
/*      */ 
/*  558 */             localObject13 = getString(localObject12, "valign", "fill");
/*      */ 
/*  560 */             if ((!"fill".equals(str3)) || (!"fill".equals(localObject13)))
/*      */             {
/*  562 */               Dimension localDimension5 = getPreferredSize(localObject12);
/*  563 */               if (!"fill".equals(str3)) {
/*  564 */                 localObject16 = Math.max(0, paramObject - localDimension5.width);
/*  565 */                 if ("center".equals(str3))
/*  566 */                   i10 += localObject16 / 2;
/*  567 */                 else if ("right".equals(str3)) {
/*  568 */                   i10 += localObject16;
/*      */                 }
/*  570 */                 paramObject -= localObject16;
/*      */               }
/*  572 */               if (!"fill".equals(localObject13)) {
/*  573 */                 int i25 = Math.max(0, i6 - localDimension5.height);
/*  574 */                 if ("center".equals(localObject13))
/*  575 */                   i18 += i25 / 2;
/*  576 */                 else if ("bottom".equals(localObject13)) {
/*  577 */                   i18 += i25;
/*      */                 }
/*  579 */                 i6 -= i25;
/*      */               }
/*      */             }
/*  582 */             setRectangle(localObject12, "bounds", i10, i18, paramObject, i6);
/*  583 */             doLayout(localObject12);
/*  584 */             i++;
/*      */           }
/*      */       }
/*  587 */       return;
/*      */     }
/*      */     Rectangle localRectangle1;
/*  587 */     if ("desktop".equals(i)) {
/*  588 */       localRectangle1 = getRectangle(paramObject, "bounds");
/*  589 */       for (localObject3 = get(paramObject, ":comp"); localObject3 != null; localObject3 = get(localObject3, ":next"))
/*      */       {
/*  591 */         String str2 = getClass(localObject3);
/*  592 */         if ("dialog".equals(str2)) {
/*  593 */           Dimension localDimension1 = getPreferredSize(localObject3);
/*  594 */           if (get(localObject3, "bounds") == null) {
/*  595 */             setRectangle(localObject3, "bounds", Math.max(0, (localRectangle1.width - localDimension1.width) / 2), Math.max(0, (localRectangle1.height - localDimension1.height) / 2), Math.min(localDimension1.width, localRectangle1.width), Math.min(localDimension1.height, localRectangle1.height));
/*      */           }
/*      */ 
/*      */         }
/*  601 */         else if ((!":combolist".equals(str2)) && (!":popup".equals(str2)))
/*      */         {
/*  603 */           setRectangle(localObject3, "bounds", 0, 0, localRectangle1.width, localRectangle1.height);
/*      */         }
/*      */ 
/*  606 */         doLayout(localObject3);
/*      */       }
/*  608 */       return; } if ("spinbox".equals(i)) {
/*  609 */       layoutField(paramObject, this._block, false, 0); return;
/*      */     }
/*      */     Object localObject4;
/*      */     int i2;
/*      */     Object localObject7;
/*  610 */     if ("splitpane".equals(i)) {
/*  611 */       localRectangle1 = getRectangle(paramObject, "bounds");
/*  612 */       localObject4 = !"vertical".equals(get(paramObject, "orientation")) ? 1 : 0;
/*      */ 
/*  614 */       i2 = getInteger(paramObject, "divider", -1);
/*  615 */       int i4 = Math.max(0, (localObject4 != 0 ? localRectangle1.width : localRectangle1.height) - 5);
/*      */ 
/*  620 */       int i9 = ((
/*  620 */         localObject7 = get(paramObject, ":comp")) != null) && 
/*  620 */         (getBoolean(localObject7, "visible", true)) ? 1 : 0;
/*      */ 
/*  622 */       if (i2 == -1) {
/*  623 */         i10 = 0;
/*  624 */         if (i9 != 0) {
/*  625 */           localObject12 = getPreferredSize(localObject7);
/*  626 */           i10 = localObject4 != 0 ? ((Dimension)localObject12).width : ((Dimension)localObject12).height;
/*      */         }
/*  628 */         i2 = Math.min(i10, i4);
/*  629 */         setInteger(paramObject, "divider", i2, -1);
/*  630 */       } else if (i2 > i4) {
/*  631 */         setInteger(paramObject, "divider", i2 = i4, -1);
/*      */       }
/*      */ 
/*  634 */       if (i9 != 0) {
/*  635 */         setRectangle(localObject7, "bounds", 0, 0, localObject4 != 0 ? i2 : localRectangle1.width, localObject4 != 0 ? localRectangle1.height : i2);
/*      */ 
/*  638 */         doLayout(localObject7);
/*      */       }
/*      */       Object localObject10;
/*  641 */       if (((
/*  641 */         localObject10 = localObject7 != null ? get(localObject7, ":next") : null) != null) && 
/*  641 */         (getBoolean(localObject10, "visible", true))) {
/*  642 */         setRectangle(localObject10, "bounds", localObject4 != 0 ? i2 + 5 : 0, localObject4 != 0 ? 0 : i2 + 5, localObject4 != 0 ? localRectangle1.width - 5 - i2 : localRectangle1.width, localObject4 != 0 ? localRectangle1.height : localRectangle1.height - 5 - i2);
/*      */ 
/*  648 */         doLayout(localObject10);
/*      */       }
/*  650 */       return; } if (("list".equals(i)) || ("table".equals(i)) || ("tree".equals(i)))
/*      */     {
/*  652 */       int m = getBoolean(paramObject, "line", true) ? 1 : 0;
/*  653 */       localObject4 = 0;
/*  654 */       i2 = 0;
/*      */       int i11;
/*  655 */       if ("table".equals(i)) {
/*  656 */         Object localObject6 = get(paramObject, "header");
/*  657 */         localObject7 = null;
/*  658 */         if (localObject6 != null) {
/*  659 */           localObject7 = new int[getCount(localObject6)];
/*  660 */           localObject9 = get(localObject6, ":comp");
/*  661 */           for (i11 = 0; i11 < localObject7.length; i11++) {
/*  662 */             if (i11 != 0) {
/*  663 */               localObject9 = get(localObject9, ":next");
/*      */             }
/*  665 */             localObject7[i11] = getInteger(localObject9, "width", 80);
/*      */ 
/*  668 */             localObject4 += localObject7[i11];
/*  669 */             localObject12 = getSize(localObject9, 2, 2);
/*  670 */             i2 = Math.max(i2, ((Dimension)localObject12).height);
/*      */           }
/*      */         }
/*  673 */         set(paramObject, ":widths", localObject7);
/*      */       }
/*  675 */       int i5 = 0;
/*  676 */       int i7 = 0;
/*  677 */       for (Object localObject9 = get(paramObject, ":comp"); localObject9 != null; ) {
/*  678 */         i11 = 0;
/*  679 */         i18 = 0;
/*      */         int i15;
/*  681 */         if ("table".equals(i)) {
/*  682 */           localObject12 = localObject4;
/*  683 */           for (localObject13 = get(localObject9, ":comp"); localObject13 != null; localObject13 = get(localObject13, ":next"))
/*      */           {
/*  685 */             Dimension localDimension4 = getSize(localObject13, 2, 2);
/*  686 */             i18 = Math.max(i18, localDimension4.height);
/*      */           }
/*      */         } else {
/*  689 */           if ("tree".equals(i)) {
/*  690 */             i11 = (i7 + 1) * this._block;
/*      */           }
/*      */ 
/*  693 */           i15 = (
/*  693 */             localObject13 = getSize(localObject9, 6, 2)).width;
/*      */ 
/*  694 */           i18 = ((Dimension)localObject13).height;
/*  695 */           localObject4 = Math.max(localObject4, i11 + ((Dimension)localObject13).width);
/*      */         }
/*  697 */         setRectangle(localObject9, "bounds", i11, i5, i15, i18);
/*  698 */         i5 += i18 + m;
/*  699 */         if ("tree".equals(i))
/*      */         {
/*  701 */           if (((
/*  701 */             localObject13 = get(localObject9, ":comp")) != null) && 
/*  701 */             (getBoolean(localObject9, "expanded", true))) {
/*  702 */             i7++;
/*      */           }
/*      */           else {
/*  705 */             while (((localObject13 = get(localObject9, ":next")) == null) && (i7 > 0)) {
/*  706 */               localObject9 = getParent(localObject9);
/*  707 */               i7--;
/*      */             }
/*      */           }
/*  710 */           localObject9 = localObject13;
/*  711 */           continue;
/*  712 */         }localObject9 = get(localObject9, ":next");
/*      */       }
/*      */ 
/*  715 */       layoutScroll(paramObject, localObject4, i5 - m, i2, 0, 0, 0, true, 0);
/*      */ 
/*  717 */       return;
/*      */     }
/*      */     Rectangle localRectangle2;
/*  717 */     if ("menubar".equals(i)) {
/*  718 */       localRectangle2 = getRectangle(paramObject, "bounds");
/*  719 */       localObject4 = 0;
/*  720 */       for (Object localObject5 = get(paramObject, ":comp"); localObject5 != null; localObject5 = get(localObject5, ":next"))
/*      */       {
/*  722 */         Dimension localDimension2 = getSize(localObject5, 8, 4);
/*  723 */         setRectangle(localObject5, "bounds", localObject4, 0, localDimension2.width, localRectangle2.height);
/*  724 */         localObject4 += localDimension2.width;
/*      */       }
/*  726 */       return; } if ("bean".equals(i)) {
/*  727 */       localRectangle2 = getRectangle(paramObject, "bounds");
/*  728 */       ((Component)get(paramObject, "bean")).setBounds(localRectangle2);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void checkOffset(Object paramObject)
/*      */   {
/*  739 */     String str = getString(paramObject, "placement", "top");
/*      */ 
/*  741 */     int j = getInteger(paramObject, "selected", 0);
/*  742 */     int k = 0;
/*  743 */     if ("stacked".equals(str)) {
/*  744 */       i = 0;
/*  745 */       for (localObject1 = get(paramObject, ":comp"); localObject1 != null; localObject1 = get(localObject1, ":next"))
/*      */       {
/*      */         Rectangle localRectangle1;
/*  747 */         (
/*  748 */           localRectangle1 = getRectangle(localObject1, "bounds")).y = 
/*  748 */           i;
/*  749 */         i += localRectangle1.height;
/*  750 */         if (k == j) {
/*  751 */           i += getRectangle(get(localObject1, ":comp"), "bounds").height + 2;
/*      */         }
/*      */ 
/*  754 */         k++;
/*      */       }
/*  756 */       checkLocation(paramObject);
/*  757 */       return;
/*      */     }
/*  759 */     int i = ("top".equals(i)) || ("bottom".equals(i)) ? 1 : 0;
/*      */ 
/*  762 */     Object localObject1 = getRectangle(paramObject, "bounds");
/*  763 */     int n = i != 0 ? ((Rectangle)localObject1).width : ((Rectangle)localObject1).height;
/*  764 */     int m = 0;
/*  765 */     int i1 = 0;
/*  766 */     int i2 = 0;
/*  767 */     for (Object localObject2 = get(paramObject, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */     {
/*  769 */       Rectangle localRectangle2 = getRectangle(localObject2, "bounds");
/*  770 */       if (k == 0) {
/*  771 */         m = i != 0 ? localRectangle2.x : localRectangle2.y;
/*      */       }
/*  773 */       i1 = i != 0 ? localRectangle2.x + localRectangle2.width : localRectangle2.y + localRectangle2.height;
/*  774 */       if (k == j) {
/*  775 */         int i4 = (i != 0 ? localRectangle2.x : localRectangle2.y) - 6;
/*  776 */         int i3 = (i != 0 ? localRectangle2.x + localRectangle2.width : localRectangle2.y + localRectangle2.height) + 6;
/*      */ 
/*  778 */         if (i4 < 0)
/*  779 */           i2 = -i4;
/*  780 */         else if (i3 > n) {
/*  781 */           i2 = n - i3;
/*      */         }
/*      */       }
/*  784 */       k++;
/*      */     }
/*      */ 
/*  787 */     if ((
/*  787 */       i2 = Math.min(-m, Math.max(i2, n - i1))) != 0)
/*      */     {
/*  788 */       for (localObject2 = get(paramObject, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */       {
/*  790 */         Rectangle localRectangle3 = getRectangle(localObject2, "bounds");
/*  791 */         if (i != 0)
/*  792 */           localRectangle3.x += i2;
/*      */         else
/*  794 */           localRectangle3.y += i2;
/*      */         Object localObject3;
/*  798 */         if (((
/*  798 */           localObject3 = get(localObject2, ":comp")) != null) && 
/*  798 */           (getBoolean(localObject3, "visible", true))) {
/*  799 */           localRectangle3 = getRectangle(localObject3, "bounds");
/*  800 */           if (i != 0)
/*  801 */             localRectangle3.x -= i2;
/*      */           else {
/*  803 */             localRectangle3.y -= i2;
/*      */           }
/*      */         }
/*      */       }
/*  807 */       checkLocation(paramObject);
/*      */     }
/*      */   }
/*      */ 
/*      */   private char[] getChars(Object paramObject, String paramString, boolean paramBoolean, int paramInt1, int paramInt2)
/*      */   {
/*      */     char[] arrayOfChar;
/*  814 */     if (((
/*  814 */       arrayOfChar = (char[])get(paramObject, ":text")) == null) || 
/*  814 */       (arrayOfChar.length != paramString.length())) {
/*  815 */       arrayOfChar = paramString.toCharArray();
/*  816 */       set(paramObject, ":text", arrayOfChar);
/*      */     } else {
/*  818 */       paramString.getChars(0, arrayOfChar.length, arrayOfChar, 0);
/*      */     }
/*      */ 
/*  821 */     if (paramBoolean) {
/*  822 */       paramObject = (Font)get(paramObject, "font");
/*  823 */       this = getFontMetrics(paramObject != null ? paramObject : this._font);
/*      */ 
/*  825 */       paramObject = (paramInt2 - 4 + getLeading()) / getHeight();
/*  826 */       paramString = 0;
/*  827 */       paramBoolean = arrayOfChar.length;
/*  828 */       paramInt2 = 0;
/*  829 */       boolean bool1 = false; int i = -1; for (boolean bool2 = false; bool2 <= paramBoolean; bool2++)
/*      */       {
/*  832 */         if (((bool2 == paramBoolean) || (arrayOfChar[bool2] == '\n') || (arrayOfChar[bool2] == ' ')) && (i > bool1) && (charsWidth(arrayOfChar, bool1, bool2 - bool1) > paramInt1))
/*      */         {
/*  834 */           arrayOfChar[i] = '\n';
/*  835 */           bool2--;
/*      */         }
/*  837 */         else if ((bool2 == paramBoolean) || (arrayOfChar[bool2] == '\n'))
/*      */         {
/*  839 */           i = bool2;
/*  840 */           paramString = 0;
/*      */         } else {
/*  842 */           if ((arrayOfChar[bool2] == ' ') && ((paramString != 0) || (i > bool1))) {
/*  843 */             i = bool2;
/*      */           }
/*      */ 
/*  849 */           paramString = arrayOfChar[bool2] != ' ' ? 1 : 0;
/*  850 */           continue;
/*      */         }
/*  852 */         paramInt2++;
/*  853 */         if ((paramObject != 0) && (paramInt2 == paramObject)) {
/*  854 */           return null;
/*      */         }
/*  856 */         bool1 = i + 1;
/*      */       }
/*      */     }
/*  859 */     return arrayOfChar;
/*      */   }
/*      */ 
/*      */   private static String getAccelerator(Object paramObject)
/*      */   {
/*  885 */     if ((
/*  885 */       paramObject = get(paramObject, "accelerator")) != null)
/*      */     {
/*      */       long l;
/*  887 */       paramObject = (int)((
/*  887 */         l = ((Long)paramObject).longValue()) >> 
/*  887 */         32);
/*  888 */       int i = (int)(l & 0xFFFF);
/*  889 */       return KeyEvent.getKeyModifiersText(paramObject) + " " + KeyEvent.getKeyText(i);
/*      */     }
/*      */ 
/*  892 */     return null;
/*      */   }
/*      */ 
/*      */   private Object popupCombo(Object paramObject)
/*      */   {
/*  903 */     int i = 0; int j = 0; int k = 0; int m = 0;
/*  904 */     for (Object localObject1 = paramObject; localObject1 != this.content; localObject1 = getParent(localObject1))
/*      */     {
/*  906 */       Rectangle localRectangle1 = getRectangle(localObject1, "bounds");
/*  907 */       i += localRectangle1.x;
/*  908 */       j += localRectangle1.y;
/*      */       Rectangle localRectangle2;
/*  910 */       if ((
/*  910 */         localRectangle2 = getRectangle(localObject1, ":view")) != null)
/*      */       {
/*  911 */         i -= localRectangle2.x;
/*  912 */         j -= localRectangle2.y;
/*  913 */         localObject2 = getRectangle(localObject1, ":port");
/*  914 */         i += ((Rectangle)localObject2).x;
/*  915 */         j += ((Rectangle)localObject2).y;
/*      */       }
/*  917 */       if (localObject1 == paramObject) {
/*  918 */         k = localRectangle1.width;
/*  919 */         m = localRectangle1.height;
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/*  924 */     set(localObject1 = createImpl(":combolist"), 
/*  924 */       "combobox", paramObject);
/*  925 */     set(paramObject, ":combolist", localObject1);
/*      */ 
/*  927 */     this.popupowner = paramObject;
/*  928 */     insertItem(this.content, ":comp", localObject1, 0);
/*  929 */     set(localObject1, ":parent", this.content);
/*      */ 
/*  931 */     int n = 0;
/*  932 */     int i1 = 0;
/*  933 */     for (Object localObject2 = get(paramObject, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */     {
/*  935 */       Dimension localDimension = getSize(localObject2, 8, 4);
/*  936 */       setRectangle(localObject2, "bounds", 0, i1, localDimension.width, localDimension.height);
/*  937 */       n = Math.max(n, localDimension.width);
/*  938 */       i1 += localDimension.height;
/*      */     }
/*      */ 
/*  941 */     int i3 = getRectangle(this.content, "bounds").height - j - m - 1;
/*      */     int i2;
/*  946 */     if ((i1 + 2 > i3) && (j - 1 > i3))
/*      */     {
/*  948 */       i2 = Math.max(0, j - 1 - i1 - 2);
/*  949 */       i3 = Math.min(j - 1, i1 + 2);
/*      */     } else {
/*  951 */       i2 = j + m + 1;
/*  952 */       i3 = Math.min(i3, i1 + 2);
/*      */     }
/*  954 */     setRectangle(localObject1, "bounds", i, i2, k, i3);
/*      */ 
/*  956 */     layoutScroll(localObject1, n, i1, 0, 0, 0, 0, true, 0);
/*  957 */     repaint(localObject1);
/*      */ 
/*  959 */     i = getInteger(paramObject, "selected", -1);
/*  960 */     setInside(localObject1, i != -1 ? getItem(paramObject, i) : null, true);
/*      */ 
/*  962 */     return localObject1;
/*      */   }
/*      */ 
/*      */   private Object popupMenu(Object paramObject)
/*      */   {
/*  971 */     Object localObject1 = get(paramObject, ":popup");
/*  972 */     Object localObject2 = get(paramObject, "selected");
/*      */ 
/*  975 */     if (localObject1 != null) {
/*  976 */       if (get(localObject1, "menu") == localObject2) {
/*  977 */         return null;
/*      */       }
/*      */ 
/*  981 */       set(localObject1, "selected", null);
/*  982 */       set(localObject1, "menu", null);
/*  983 */       repaint(localObject1);
/*  984 */       removeItemImpl(this.content, localObject1);
/*  985 */       set(localObject1, ":parent", null);
/*  986 */       set(paramObject, ":popup", null);
/*  987 */       checkLocation(localObject1);
/*  988 */       popupMenu(localObject1);
/*      */     }
/*      */ 
/*  991 */     if ((localObject2 == null) || (!"menu".equals(getClass(localObject2))))
/*      */     {
/*  993 */       return null;
/*      */     }
/*      */ 
/*  998 */     set(localObject1 = createImpl(":popup"), 
/*  998 */       "menu", localObject2);
/*  999 */     set(paramObject, ":popup", localObject1);
/* 1000 */     insertItem(this.content, ":comp", localObject1, 0);
/* 1001 */     set(localObject1, ":parent", this.content);
/*      */ 
/* 1004 */     int i = 0; int j = 0; int k = 0; int m = 0;
/* 1005 */     for (Object localObject3 = paramObject; localObject3 != this.content; localObject3 = getParent(localObject3))
/*      */     {
/* 1007 */       Rectangle localRectangle1 = getRectangle(localObject3, "bounds");
/* 1008 */       i += localRectangle1.x;
/* 1009 */       j += localRectangle1.y;
/*      */       Rectangle localRectangle2;
/* 1011 */       if ((
/* 1011 */         localRectangle2 = getRectangle(localObject3, ":view")) != null)
/*      */       {
/* 1012 */         i -= localRectangle2.x;
/* 1013 */         j -= localRectangle2.y;
/* 1014 */         localRectangle2 = getRectangle(localObject3, ":port");
/* 1015 */         i += localRectangle2.x;
/* 1016 */         j += localRectangle2.y;
/*      */       }
/* 1018 */       if (localObject3 == paramObject) {
/* 1019 */         k = localRectangle1.width;
/* 1020 */         m = localRectangle1.height;
/*      */       }
/*      */     }
/*      */ 
/* 1024 */     localObject3 = getRectangle(localObject2, "bounds");
/*      */     boolean bool;
/* 1026 */     if ((
/* 1026 */       bool = "menubar".equals(getClass(paramObject))))
/*      */     {
/* 1027 */       this.popupowner = paramObject;
/*      */     }
/* 1029 */     popup(localObject2, localObject1, bool ? 'D' : 'R', bool ? i + ((Rectangle)localObject3).x : i, j + ((Rectangle)localObject3).y, bool ? ((Rectangle)localObject3).width : k, bool ? m : ((Rectangle)localObject3).height, bool ? 1 : 3);
/*      */ 
/* 1033 */     return localObject1;
/*      */   }
/*      */ 
/*      */   private void popup(Object paramObject1, Object paramObject2, char paramChar, int paramInt1, int paramInt2, int paramInt3, int paramInt4, int paramInt5)
/*      */   {
/* 1079 */     int i = 0;
/* 1080 */     int j = 0;
/* 1081 */     for (paramObject1 = get(paramObject1, ":comp"); paramObject1 != null; paramObject1 = get(paramObject1, ":next"))
/*      */     {
/* 1083 */       String str = getClass(paramObject1);
/* 1084 */       Dimension localDimension = "separator".equals(str) ? new Dimension(1, 1) : getSize(paramObject1, 8, 4);
/*      */ 
/* 1087 */       if ("checkboxmenuitem".equals(str)) {
/* 1088 */         localDimension.width = (localDimension.width + this._block + 3);
/* 1089 */         localDimension.height = Math.max(this._block, localDimension.height);
/* 1090 */       } else if ("menu".equals(str)) {
/* 1091 */         localDimension.width += this._block;
/*      */       }
/*      */ 
/* 1094 */       if ((
/* 1094 */         str = getAccelerator(paramObject1)) != null)
/*      */       {
/* 1095 */         localDimension.width += 4 + getFontMetrics(this._font).stringWidth(str);
/*      */       }
/*      */ 
/* 1102 */       setRectangle(paramObject1, "bounds", 1, j + 1, localDimension.width, localDimension.height);
/* 1103 */       i = Math.max(i, localDimension.width);
/* 1104 */       j += localDimension.height;
/*      */     }
/* 1106 */     i += 2;
/* 1107 */     j += 2;
/*      */ 
/* 1109 */     paramObject1 = getRectangle(this.content, "bounds");
/* 1110 */     if (paramChar == 'R') {
/* 1111 */       paramInt1 += ((paramInt1 + paramInt3 - paramInt5 + i > paramObject1.width) && (paramInt1 >= i - paramInt5) ? paramInt5 - i : paramInt3 - paramInt5);
/*      */ 
/* 1114 */       if ((paramInt2 + j > paramObject1.height) && (j <= paramInt2 + paramInt4))
/* 1115 */         paramInt2 -= j - paramInt4;
/*      */     }
/*      */     else {
/* 1118 */       int k = paramInt2 >= j - paramInt5 ? 1 : 0;
/* 1119 */       int m = paramObject1.height - paramInt2 - paramInt4 >= j - paramInt5 ? 1 : 0;
/*      */ 
/* 1121 */       if (k == 0) { if (m == 0) if ((m != 0) || ((paramChar == 'U' ? paramInt2 : k) == 0));  } else { tmpTernaryOp = (paramInt5 - j); break label404;
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void closeCombo(Object paramObject1, Object paramObject2, Object paramObject3)
/*      */   {
/* 1138 */     if ((paramObject3 != null) && (getBoolean(paramObject3, "enabled", true))) {
/* 1139 */       String str = getString(paramObject3, "text", "");
/* 1140 */       set(paramObject1, "text", str);
/* 1141 */       setInteger(paramObject1, "start", str.length(), 0);
/* 1142 */       setInteger(paramObject1, "end", 0, 0);
/* 1143 */       set(paramObject1, "icon", get(paramObject3, "icon"));
/* 1144 */       validate(paramObject1);
/* 1145 */       setInteger(paramObject1, "selected", getIndex(paramObject1, paramObject3), -1);
/*      */ 
/* 1147 */       invoke(paramObject1, paramObject3, "action");
/*      */     }
/* 1149 */     set(paramObject2, "combobox", null);
/* 1150 */     set(paramObject1, ":combolist", null);
/* 1151 */     removeItemImpl(this.content, paramObject2);
/* 1152 */     repaint(paramObject2);
/* 1153 */     set(paramObject2, ":parent", null);
/* 1154 */     this.popupowner = null;
/* 1155 */     checkLocation(paramObject2);
/*      */   }
/*      */ 
/*      */   private void closeup() {
/* 1159 */     if (this.popupowner != null) {
/* 1160 */       String str = getClass(this.popupowner);
/* 1161 */       if ("menubar".equals(str)) {
/* 1162 */         set(this.popupowner, "selected", null);
/* 1163 */         popupMenu(this.popupowner);
/* 1164 */         repaint(this.popupowner);
/* 1165 */       } else if ("combobox".equals(str)) {
/* 1166 */         closeCombo(this.popupowner, get(this.popupowner, ":combolist"), null);
/*      */       } else {
/* 1168 */         popupMenu(this.popupowner);
/*      */       }
/* 1170 */       this.popupowner = null;
/*      */     }
/*      */   }
/*      */ 
/*      */   private void hideTip()
/*      */   {
/* 1214 */     if (this.tooltipowner != null) {
/* 1215 */       Rectangle localRectangle = getRectangle(this.tooltipowner, ":tooltipbounds");
/*      */ 
/* 1217 */       set(this.tooltipowner, ":tooltipbounds", null);
/* 1218 */       this.tooltipowner = null;
/* 1219 */       repaint(localRectangle.x, localRectangle.y, localRectangle.width, localRectangle.height);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void layoutField(Object paramObject, int paramInt1, boolean paramBoolean, int paramInt2)
/*      */   {
/* 1225 */     paramInt1 = getRectangle(paramObject, "bounds").width - paramInt2 - paramInt1;
/* 1226 */     paramInt2 = getString(paramObject, "text", "");
/*      */     int i;
/* 1228 */     if ((
/* 1228 */       i = getInteger(paramObject, "start", 0)) > 
/* 1228 */       paramInt2.length()) {
/* 1229 */       setInteger(paramObject, "start", paramInt2.length(), 0);
/*      */     }
/*      */ 
/* 1233 */     if ((
/* 1233 */       i = getInteger(paramObject, "end", 0)) > 
/* 1233 */       paramInt2.length())
/* 1234 */       setInteger(paramObject, "end", i = paramInt2.length(), 0);
/*      */     int j;
/* 1237 */     Thinlet localThinlet = j = getInteger(paramObject, ":offset", 0);
/*      */ 
/* 1238 */     Font localFont = (Font)get(paramObject, "font");
/* 1239 */     this = getFontMetrics(localFont != null ? localFont : this._font);
/*      */ 
/* 1241 */     int n = paramBoolean ? charWidth('*') * paramInt2.length() : stringWidth(paramInt2);
/*      */ 
/* 1244 */     this = paramBoolean ? charWidth('*') * i : stringWidth(paramInt2.substring(0, i));
/*      */     int m;
/* 1247 */     if (n <= paramInt1 - 4)
/*      */     {
/* 1249 */       if ((
/* 1249 */         this = get(paramObject, "alignment")) == null)
/*      */       {
/* 1250 */         localThinlet = 0;
/*      */       }
/*      */       else {
/* 1253 */         localThinlet = n - paramInt1 + 4;
/* 1254 */         if ("center".equals(this))
/* 1255 */           localThinlet /= 2;
/*      */       }
/*      */     }
/*      */     else
/*      */     {
/*      */       int k;
/* 1259 */       if (localThinlet > this)
/* 1260 */         k = this;
/* 1261 */       else if (k < this - paramInt1 + 4) {
/* 1262 */         m = this - paramInt1 + 4;
/*      */       }
/* 1264 */       m = Math.max(0, Math.min(m, n - paramInt1 + 4));
/*      */     }
/* 1266 */     if (m != j)
/* 1267 */       setInteger(paramObject, ":offset", m, 0);
/*      */   }
/*      */ 
/*      */   private boolean layoutScroll(Object paramObject, int paramInt1, int paramInt2, int paramInt3, int paramInt4, int paramInt5, int paramInt6, boolean paramBoolean, int paramInt7)
/*      */   {
/* 1301 */     Rectangle localRectangle = getRectangle(paramObject, "bounds");
/* 1302 */     paramBoolean = paramBoolean;
/* 1303 */     int i = this._block + 1 - paramBoolean;
/* 1304 */     int j = localRectangle.width - paramInt4 - paramInt6 - paramBoolean * true;
/*      */ 
/* 1307 */     int k = localRectangle.height - paramInt3 - paramInt7 - paramInt5 - paramBoolean * true;
/*      */ 
/* 1310 */     int m = paramInt1 > j ? 1 : 0;
/*      */     int n;
/* 1315 */     if ((
/* 1315 */       n = paramInt2 > k - (m != 0 ? i : 0) ? 1 : 0) != 0)
/*      */     {
/* 1316 */       j -= i;
/*      */     }
/*      */ 
/* 1320 */     if ((
/* 1320 */       m = (m != 0) || ((n != 0) && (paramInt1 > j)) ? 1 : 0) != 0)
/*      */     {
/* 1321 */       k -= i;
/*      */     }
/*      */ 
/* 1325 */     setRectangle(paramObject, ":port", paramInt4 + paramBoolean, paramInt3 + paramBoolean + paramInt7, j, k);
/*      */ 
/* 1327 */     if (m != 0) {
/* 1328 */       setRectangle(paramObject, ":horizontal", paramInt4, localRectangle.height - paramInt5 - this._block - 1, localRectangle.width - paramInt4 - paramInt6 - (n != 0 ? this._block : 0), this._block + 1);
/*      */     }
/*      */     else
/*      */     {
/* 1332 */       set(paramObject, ":horizontal", null);
/*      */     }
/* 1334 */     if (n != 0) {
/* 1335 */       setRectangle(paramObject, ":vertical", localRectangle.width - paramInt6 - this._block - 1, paramInt3, this._block + 1, localRectangle.height - paramInt3 - paramInt5 - (m != 0 ? this._block : 0));
/*      */     }
/*      */     else
/*      */     {
/* 1339 */       set(paramObject, ":vertical", null);
/*      */     }
/*      */ 
/* 1342 */     paramInt1 = Math.max(paramInt1, j);
/* 1343 */     paramInt2 = Math.max(paramInt2, k);
/* 1344 */     paramInt3 = 0; paramInt4 = 0;
/*      */ 
/* 1346 */     if ((
/* 1346 */       paramInt5 = getRectangle(paramObject, ":view")) != null)
/*      */     {
/* 1347 */       paramInt3 = Math.max(0, Math.min(paramInt5.x, paramInt1 - j));
/*      */ 
/* 1349 */       paramInt4 = Math.max(0, Math.min(paramInt5.y, paramInt2 - k));
/*      */     }
/*      */ 
/* 1352 */     setRectangle(paramObject, ":view", paramInt3, paramInt4, paramInt1, paramInt2);
/*      */ 
/* 1354 */     return (n != 0) || (m != 0);
/*      */   }
/*      */ 
/*      */   private void scrollToVisible(Object paramObject, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 1359 */     Rectangle localRectangle1 = getRectangle(paramObject, ":view");
/* 1360 */     Rectangle localRectangle2 = getRectangle(paramObject, ":port");
/* 1361 */     paramInt1 = Math.max(paramInt1 + paramInt3 - localRectangle2.width, Math.min(localRectangle1.x, paramInt1));
/* 1362 */     paramInt2 = Math.max(paramInt2 + paramInt4 - localRectangle2.height, Math.min(localRectangle1.y, paramInt2));
/* 1363 */     if ((localRectangle1.x != paramInt1) || (localRectangle1.y != paramInt2)) {
/* 1364 */       repaint(paramObject);
/* 1365 */       localRectangle1.x = paramInt1;
/* 1366 */       localRectangle1.y = paramInt2;
/*      */     }
/*      */   }
/*      */ 
/*      */   public Dimension getPreferredSize()
/*      */   {
/* 1377 */     return getPreferredSize(this.content);
/*      */   }
/*      */ 
/*      */   private Dimension getPreferredSize(Object paramObject)
/*      */   {
/* 1384 */     int i = getInteger(paramObject, "width", 0);
/* 1385 */     int k = getInteger(paramObject, "height", 0);
/* 1386 */     if ((i > 0) && (k > 0)) {
/* 1387 */       return new Dimension(i, k);
/*      */     }
/* 1389 */     Object localObject1 = getClass(paramObject);
/* 1390 */     if ("label".equals(localObject1)) {
/* 1391 */       return getSize(paramObject, 0, 0);
/*      */     }
/* 1393 */     if (("button".equals(localObject1)) || ("togglebutton".equals(localObject1)))
/*      */     {
/* 1395 */       k = ("button".equals(localObject1)) && ("link".equals(get(paramObject, "type"))) ? 1 : 0;
/*      */ 
/* 1398 */       return getSize(paramObject, k != 0 ? 0 : 12, k != 0 ? 0 : 6);
/*      */     }
/*      */     Dimension localDimension1;
/* 1400 */     if ("checkbox".equals(localObject1)) {
/* 1401 */       (
/* 1402 */         localDimension1 = getSize(paramObject, 0, 0)).width = 
/* 1402 */         (localDimension1.width + this._block + 3);
/* 1403 */       localDimension1.height = Math.max(this._block, localDimension1.height);
/* 1404 */       return localDimension1;
/*      */     }
/*      */     Object localObject4;
/* 1406 */     if ("combobox".equals(localObject1)) {
/* 1407 */       if (getBoolean(paramObject, "editable", true)) {
/* 1408 */         localDimension1 = getFieldSize(paramObject);
/*      */ 
/* 1410 */         if ((
/* 1410 */           localObject1 = getIcon(paramObject, "icon", null)) != null)
/*      */         {
/* 1411 */           localDimension1.width += ((Image)localObject1).getWidth(this);
/* 1412 */           localDimension1.height = Math.max(localDimension1.height, ((Image)localObject1).getHeight(this) + 2);
/*      */         }
/*      */ 
/* 1415 */         localDimension1.width += this._block;
/* 1416 */         return localDimension1;
/*      */       }
/*      */ 
/* 1420 */       localDimension1 = getSize(paramObject, 4, 4);
/* 1421 */       for (localObject1 = get(paramObject, ":comp"); localObject1 != null; localObject1 = get(localObject1, ":next"))
/*      */       {
/* 1423 */         localObject4 = getSize(localObject1, 4, 4);
/* 1424 */         localDimension1.width = Math.max(((Dimension)localObject4).width, localDimension1.width);
/* 1425 */         localDimension1.height = Math.max(((Dimension)localObject4).height, localDimension1.height);
/*      */       }
/* 1427 */       localDimension1.width += this._block;
/* 1428 */       if (localDimension1.height == 4) {
/* 1429 */         localObject1 = (Font)get(paramObject, "font");
/*      */ 
/* 1431 */         localObject4 = getFontMetrics(localObject1 != null ? localObject1 : this._font);
/*      */ 
/* 1434 */         localDimension1.height = (((FontMetrics)localObject4).getAscent() + ((FontMetrics)localObject4).getDescent() + 4);
/*      */       }
/* 1436 */       return localDimension1;
/*      */     }
/*      */ 
/* 1439 */     if (("textfield".equals(localObject1)) || ("passwordfield".equals(localObject1)))
/*      */     {
/* 1441 */       return getFieldSize(paramObject);
/*      */     }
/*      */     int j;
/* 1443 */     if ("textarea".equals(localObject1)) {
/* 1444 */       int m = getInteger(paramObject, "columns", 0);
/* 1445 */       j = getInteger(paramObject, "rows", 0);
/* 1446 */       localObject4 = (Font)get(paramObject, "font");
/* 1447 */       FontMetrics localFontMetrics = getFontMetrics(localObject4 != null ? localObject4 : this._font);
/*      */ 
/* 1449 */       return new Dimension((m > 0 ? m * localFontMetrics.charWidth('e') + 2 : 76) + 2 + this._block, (j > 0 ? j * localFontMetrics.getHeight() - localFontMetrics.getLeading() + 2 : 76) + 2 + this._block);
/*      */     }
/*      */     Object localObject3;
/* 1455 */     if ("tabbedpane".equals(j)) {
/* 1456 */       localObject3 = getString(paramObject, "placement", "top");
/*      */ 
/* 1458 */       j = (!"left".equals(localObject3)) && (!"right".equals(localObject3)) ? 1 : 0;
/*      */ 
/* 1461 */       int i1 = 0;
/*      */ 
/* 1463 */       int i2 = 0;
/* 1464 */       int i3 = 0;
/* 1465 */       for (paramObject = get(paramObject, ":comp"); paramObject != null; paramObject = get(paramObject, ":next"))
/*      */       {
/* 1467 */         Object localObject7 = getSize(paramObject, 0, 0);
/* 1468 */         if ("stacked".equals(localObject3))
/* 1469 */           i1 += ((Dimension)localObject7).height + 3;
/*      */         else {
/* 1471 */           i1 = Math.max(i1, j != 0 ? ((Dimension)localObject7).height + 5 : ((Dimension)localObject7).width + 9);
/*      */         }
/*      */ 
/* 1477 */         if (((
/* 1477 */           localObject7 = get(paramObject, ":comp")) != null) && 
/* 1477 */           (getBoolean(localObject7, "visible", true))) {
/* 1478 */           localObject7 = getPreferredSize(localObject7);
/* 1479 */           i2 = Math.max(i2, ((Dimension)localObject7).width);
/* 1480 */           i3 = Math.max(i3, ((Dimension)localObject7).height);
/*      */         }
/*      */       }
/* 1483 */       return new Dimension(i2 + (j != 0 ? 4 : i1 + 3), i3 + (j != 0 ? i1 + 3 : 4));
/*      */     }
/*      */     Object localObject5;
/* 1487 */     if (("panel".equals(j)) || ("dialog".equals(j)))
/*      */     {
/* 1490 */       localObject3 = getSize(paramObject, 0, 0);
/*      */ 
/* 1492 */       if ("dialog".equals(j)) {
/* 1493 */         ((Dimension)localObject3).width = 8;
/* 1494 */         localObject3.height += 8;
/* 1495 */       } else if (getBoolean(paramObject, "border", false))
/*      */       {
/* 1497 */         ((Dimension)localObject3).width = 2;
/* 1498 */         localObject3.height += (((Dimension)localObject3).height > 0 ? 1 : 2);
/*      */       }
/*      */       else
/*      */       {
/* 1502 */         ((Dimension)localObject3).width = 0;
/*      */       }
/*      */ 
/* 1505 */       localObject3.width += getInteger(paramObject, "left", 0) + getInteger(paramObject, "right", 0);
/*      */ 
/* 1508 */       localObject3.height += getInteger(paramObject, "top", 0) + getInteger(paramObject, "bottom", 0);
/*      */ 
/* 1512 */       j = getInteger(paramObject, "gap", 0);
/*      */ 
/* 1514 */       if ((
/* 1514 */         localObject5 = getGrid(paramObject)) != null)
/*      */       {
/* 1515 */         localObject3.width += getSum(localObject5[0], 0, localObject5[0].length, j, false);
/*      */ 
/* 1517 */         localObject3.height += getSum(localObject5[1], 0, localObject5[1].length, j, false);
/*      */       }
/*      */ 
/* 1520 */       return localObject3;
/*      */     }
/*      */     Object localObject2;
/*      */     Object localObject6;
/* 1521 */     if ("desktop".equals(j)) {
/* 1522 */       localObject3 = new Dimension();
/* 1523 */       for (localObject2 = get(paramObject, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */       {
/* 1525 */         localObject5 = getClass(localObject2);
/* 1526 */         if (("dialog".equals(localObject5)) || (":popup".equals(localObject5)) || (":combolist".equals(localObject5)))
/*      */           continue;
/* 1528 */         localObject6 = getPreferredSize(localObject2);
/* 1529 */         ((Dimension)localObject3).width = Math.max(((Dimension)localObject6).width, ((Dimension)localObject3).width);
/* 1530 */         ((Dimension)localObject3).height = Math.max(((Dimension)localObject6).height, ((Dimension)localObject3).height);
/*      */       }
/*      */ 
/* 1533 */       return localObject3;
/*      */     }
/* 1535 */     if ("spinbox".equals(localObject2)) {
/* 1536 */       (
/* 1537 */         localObject3 = getFieldSize(paramObject)).width
/* 1537 */          += this._block;
/* 1538 */       return localObject3;
/*      */     }
/*      */     int n;
/* 1540 */     if ("progressbar".equals(localObject2)) {
/* 1541 */       n = !"vertical".equals(get(paramObject, "orientation")) ? 1 : 0;
/*      */ 
/* 1543 */       return new Dimension(n != 0 ? 76 : 6, n != 0 ? 6 : 76);
/*      */     }
/* 1545 */     if ("slider".equals(localObject2)) {
/* 1546 */       n = !"vertical".equals(get(paramObject, "orientation")) ? 1 : 0;
/*      */ 
/* 1548 */       return new Dimension(n != 0 ? 76 : 10, n != 0 ? 10 : 76);
/*      */     }
/*      */ 
/* 1551 */     if ("splitpane".equals(localObject2)) {
/* 1552 */       n = !"vertical".equals(get(paramObject, "orientation")) ? 1 : 0;
/*      */ 
/* 1555 */       localObject5 = ((
/* 1555 */         localObject2 = get(paramObject, ":comp")) == null) || 
/* 1555 */         (!getBoolean(localObject2, "visible", true)) ? new Dimension() : getPreferredSize(localObject2);
/*      */ 
/* 1559 */       if (((
/* 1559 */         localObject6 = get(localObject2, ":next")) != null) && 
/* 1559 */         (getBoolean(localObject6, "visible", true))) {
/* 1560 */         Dimension localDimension3 = getPreferredSize(localObject6);
/* 1561 */         ((Dimension)localObject5).width = (n != 0 ? ((Dimension)localObject5).width + localDimension3.width : Math.max(((Dimension)localObject5).width, localDimension3.width));
/*      */ 
/* 1564 */         ((Dimension)localObject5).height = (n != 0 ? Math.max(((Dimension)localObject5).height, localDimension3.height) : ((Dimension)localObject5).height + localDimension3.height);
/*      */       }
/*      */ 
/* 1568 */       if (n != 0)
/* 1569 */         localObject5.width += 5;
/*      */       else {
/* 1571 */         localObject5.height += 5;
/*      */       }
/* 1573 */       return localObject5;
/*      */     }
/* 1575 */     if (("list".equals(localObject2)) || ("table".equals(localObject2)) || ("tree".equals(localObject2)))
/*      */     {
/* 1577 */       return new Dimension(78 + this._block, 78 + this._block);
/*      */     }
/* 1579 */     if ("separator".equals(localObject2)) {
/* 1580 */       return new Dimension(1, 1);
/*      */     }
/* 1582 */     if ("menubar".equals(localObject2)) {
/* 1583 */       Dimension localDimension2 = new Dimension(0, 0);
/* 1584 */       for (localObject2 = get(paramObject, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */       {
/* 1586 */         localObject5 = getSize(localObject2, 8, 4);
/* 1587 */         localDimension2.width += ((Dimension)localObject5).width;
/* 1588 */         localDimension2.height = Math.max(localDimension2.height, ((Dimension)localObject5).height);
/*      */       }
/* 1590 */       return localDimension2;
/*      */     }
/* 1592 */     if ("bean".equals(localObject2)) {
/* 1593 */       return ((Component)get(paramObject, "bean")).getPreferredSize();
/*      */     }
/*      */ 
/* 1596 */     throw new IllegalArgumentException(localObject2);
/*      */   }
/*      */ 
/*      */   private int[][] getGrid(Object paramObject)
/*      */   {
/* 1616 */     int i = 0;
/* 1617 */     for (Object localObject1 = get(paramObject, ":comp"); localObject1 != null; localObject1 = get(localObject1, ":next"))
/*      */     {
/* 1619 */       if (getBoolean(localObject1, "visible", true)) {
/* 1620 */         i++;
/*      */       }
/*      */     }
/* 1623 */     if (i == 0)
/* 1624 */       return null;
/*      */     Object localObject2;
/* 1627 */     int j = (
/* 1627 */       localObject2 = getInteger(paramObject, "columns", 0)) != 0
/* 1627 */        ? localObject2 : i;
/* 1628 */     int k = localObject2 != 0 ? (i + localObject2 - 1) / localObject2 : 1;
/* 1629 */     int[][] arrayOfInt = { new int[j], new int[k], new int[j], new int[k], new int[i], new int[i], new int[i], new int[i] };
/*      */ 
/* 1634 */     int[] arrayOfInt1 = new int[j];
/* 1635 */     int[][] arrayOfInt2 = null;
/*      */ 
/* 1638 */     Thinlet localThinlet2 = 0;
/* 1639 */     int m = 0;
/* 1640 */     int n = 0;
/* 1641 */     Object localObject4 = 0;
/*      */     Object localObject5;
/*      */     Object localObject6;
/*      */     Thinlet localThinlet3;
/*      */     Object localObject7;
/* 1642 */     for (paramObject = get(paramObject, ":comp"); paramObject != null; paramObject = get(paramObject, ":next"))
/*      */     {
/* 1644 */       if (getBoolean(paramObject, "visible", true)) {
/* 1645 */         localObject5 = (localObject2 != 0) && (localObject2 < i) ? Math.min(getInteger(paramObject, "colspan", 1), localObject2) : 1;
/*      */ 
/* 1650 */         localObject6 = localObject2 != 1 ? getInteger(paramObject, "rowspan", 1) : 1;
/*      */ 
/* 1653 */         for (int i1 = 0; i1 < localObject5; i1++) {
/* 1654 */           if ((localObject2 != 0) && (m + localObject5 > localObject2)) {
/* 1655 */             m = 0;
/* 1656 */             n++;
/* 1657 */             i1 = -1;
/* 1658 */           } else if (arrayOfInt1[(m + i1)] > n) {
/* 1659 */             m += i1 + 1;
/* 1660 */             i1 = -1;
/*      */           }
/*      */         }
/* 1663 */         if (n + localObject6 > arrayOfInt[1].length) {
/* 1664 */           int[] arrayOfInt3 = new int[n + localObject6];
/* 1665 */           System.arraycopy(arrayOfInt[1], 0, arrayOfInt3, 0, arrayOfInt[1].length);
/*      */ 
/* 1667 */           arrayOfInt[1] = arrayOfInt3;
/* 1668 */           int[] arrayOfInt4 = new int[n + localObject6];
/* 1669 */           System.arraycopy(arrayOfInt[3], 0, arrayOfInt4, 0, arrayOfInt[3].length);
/*      */ 
/* 1671 */           arrayOfInt[3] = arrayOfInt4;
/*      */         }
/* 1673 */         for (localThinlet3 = 0; localThinlet3 < localObject5; localThinlet3++) {
/* 1674 */           arrayOfInt1[(m + localThinlet3)] = (n + localObject6);
/*      */         }
/*      */ 
/* 1677 */         localThinlet3 = getInteger(paramObject, "weightx", 0);
/* 1678 */         localObject7 = getInteger(paramObject, "weighty", 0);
/* 1679 */         Dimension localDimension = getPreferredSize(paramObject);
/*      */ 
/* 1681 */         if (localObject5 == 1) {
/* 1682 */           arrayOfInt[0][m] = Math.max(arrayOfInt[0][m], localDimension.width);
/* 1683 */           arrayOfInt[2][m] = Math.max(arrayOfInt[2][m], localThinlet3);
/*      */         } else {
/* 1685 */           if (arrayOfInt2 == null) {
/* 1686 */             arrayOfInt2 = new int[4][i];
/*      */           }
/* 1688 */           arrayOfInt2[0][localThinlet2] = localDimension.width;
/* 1689 */           arrayOfInt2[2][localThinlet2] = localThinlet3;
/* 1690 */           if ((localObject4 == 0) || (localObject5 < localObject4)) {
/* 1691 */             localObject4 = localObject5;
/*      */           }
/*      */         }
/* 1694 */         if (localObject6 == 1) {
/* 1695 */           arrayOfInt[1][n] = Math.max(arrayOfInt[1][n], localDimension.height);
/* 1696 */           arrayOfInt[3][n] = Math.max(arrayOfInt[3][n], localObject7);
/*      */         } else {
/* 1698 */           if (arrayOfInt2 == null) {
/* 1699 */             arrayOfInt2 = new int[4][i];
/*      */           }
/* 1701 */           arrayOfInt2[1][localThinlet2] = localDimension.height;
/* 1702 */           arrayOfInt2[3][localThinlet2] = localObject7;
/* 1703 */           if ((localObject4 == 0) || (localObject6 < localObject4)) {
/* 1704 */             localObject4 = localObject6;
/*      */           }
/*      */         }
/* 1707 */         arrayOfInt[4][localThinlet2] = m;
/* 1708 */         arrayOfInt[5][localThinlet2] = n;
/* 1709 */         arrayOfInt[6][localThinlet2] = localObject5;
/* 1710 */         arrayOfInt[7][localThinlet2] = localObject6;
/*      */ 
/* 1712 */         m += localObject5;
/* 1713 */         localThinlet2++;
/*      */       }
/*      */     }
/* 1716 */     while (localObject4 != 0) {
/* 1717 */       paramObject = localObject4;
/* 1718 */       localObject4 = 0;
/* 1719 */       for (localObject5 = 0; localObject5 < 2; localObject5++) {
/* 1720 */         for (localObject6 = 0; localObject6 < i; localObject6++) {
/* 1721 */           if (arrayOfInt[(localObject5 + 6)][localObject6] == paramObject) {
/* 1722 */             localThinlet3 = arrayOfInt[(localObject5 + 4)][localObject6];
/*      */ 
/* 1724 */             localObject7 = arrayOfInt2[(localObject5 + 2)][localObject6];
/* 1725 */             for (Object localObject8 = 0; (localObject7 > 0) && (localObject8 < paramObject); localObject8++)
/* 1726 */               localObject7 -= arrayOfInt[(localObject5 + 2)][(localThinlet3 + localObject8)];
/*      */             Thinlet localThinlet1;
/* 1728 */             if (localObject7 > 0) {
/* 1729 */               Thinlet localThinlet4 = arrayOfInt2[(localObject5 + 2)][localObject6] - localObject7;
/*      */               int i2;
/* 1730 */               for (this = 0; (localThinlet4 > 0) && (this < paramObject); this++)
/*      */               {
/* 1732 */                 if ((
/* 1732 */                   localObject2 = arrayOfInt[(localObject5 + 2)][(localThinlet3 + this)]) > 0)
/*      */                 {
/* 1733 */                   localThinlet1 = localObject2 * localObject7 / localThinlet4;
/*      */ 
/* 1735 */                   arrayOfInt[(localObject5 + 2)][(localThinlet3 + this)] += localThinlet1;
/*      */ 
/* 1737 */                   localObject7 -= localThinlet1;
/* 1738 */                   localThinlet4 -= localThinlet1;
/*      */                 }
/*      */               }
/* 1741 */               arrayOfInt[(localObject5 + 2)][(localThinlet3 + paramObject - 1)] += i2;
/*      */             }
/*      */ 
/* 1745 */             Thinlet localThinlet5 = arrayOfInt2[localObject5][localObject6];
/* 1746 */             this = 0;
/* 1747 */             for (localObject2 = 0; (localThinlet5 > 0) && (localObject2 < paramObject); localObject2++) {
/* 1748 */               localThinlet5 -= arrayOfInt[localObject5][(localThinlet3 + localObject2)];
/* 1749 */               this += arrayOfInt[(localObject5 + 2)][(localThinlet3 + localObject2)];
/*      */             }
/* 1751 */             if (localThinlet5 > 0)
/*      */             {
/*      */               int i3;
/* 1752 */               for (Object localObject3 = 0; (this > 0) && (localObject3 < paramObject); localObject3++)
/*      */               {
/* 1754 */                 if ((
/* 1754 */                   localThinlet1 = arrayOfInt[(localObject5 + 2)][(localThinlet3 + localObject3)]) > 0)
/*      */                 {
/* 1755 */                   localThinlet2 = localThinlet1 * localThinlet5 / this;
/*      */ 
/* 1757 */                   arrayOfInt[localObject5][(localThinlet3 + localObject3)] += localThinlet2;
/* 1758 */                   localThinlet5 -= localThinlet2;
/* 1759 */                   this -= localThinlet1;
/*      */                 }
/*      */               }
/* 1762 */               arrayOfInt[localObject5][(localThinlet3 + paramObject - 1)] += i3;
/*      */             }
/*      */           } else {
/* 1764 */             if ((arrayOfInt[(localObject5 + 6)][localObject6] <= paramObject) || ((localObject4 != 0) && (arrayOfInt[(localObject5 + 6)][localObject6] >= localObject4)))
/*      */               continue;
/* 1766 */             localObject4 = arrayOfInt[(localObject5 + 6)][localObject6];
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/* 1771 */     return arrayOfInt;
/*      */   }
/*      */ 
/*      */   private static int getSum(int[] paramArrayOfInt, int paramInt1, int paramInt2, int paramInt3, boolean paramBoolean)
/*      */   {
/* 1776 */     if (paramInt2 <= 0) {
/* 1777 */       return 0;
/*      */     }
/* 1779 */     int i = 0;
/* 1780 */     for (int j = 0; j < paramInt2; j++) {
/* 1781 */       i += paramArrayOfInt[(paramInt1 + j)];
/*      */     }
/* 1783 */     return i + (paramInt2 - (paramBoolean ? 0 : 1)) * paramInt3;
/*      */   }
/*      */ 
/*      */   private Dimension getFieldSize(Object paramObject) {
/* 1787 */     int i = getInteger(paramObject, "columns", 0);
/* 1788 */     paramObject = (Font)get(paramObject, "font");
/* 1789 */     this = getFontMetrics(paramObject != null ? paramObject : this._font);
/*      */ 
/* 1791 */     return new Dimension((i > 0 ? i * charWidth('e') : 76) + 4, getAscent() + getDescent() + 4);
/*      */   }
/*      */ 
/*      */   private Dimension getSize(Object paramObject, int paramInt1, int paramInt2)
/*      */   {
/* 1809 */     String str = getString(paramObject, "text", null);
/* 1810 */     int i = 0;
/* 1811 */     int j = 0;
/* 1812 */     if (str != null) {
/* 1813 */       localObject = (Font)get(paramObject, "font");
/*      */       FontMetrics localFontMetrics;
/* 1816 */       i = (
/* 1816 */         localFontMetrics = getFontMetrics(localObject != null ? localObject : this._font))
/* 1816 */         .stringWidth(str);
/* 1817 */       j = localFontMetrics.getAscent() + localFontMetrics.getDescent();
/*      */     }
/* 1819 */     Object localObject = getIcon(paramObject, "icon", null);
/* 1820 */     int k = 0;
/* 1821 */     paramObject = 0;
/* 1822 */     if (localObject != null) {
/* 1823 */       k = ((Image)localObject).getWidth(this);
/* 1824 */       paramObject = ((Image)localObject).getHeight(this);
/* 1825 */       if (str != null) {
/* 1826 */         k += 2;
/*      */       }
/*      */     }
/* 1829 */     return (Dimension)new Dimension(i + k + paramInt1, Math.max(j, paramObject) + paramInt2);
/*      */   }
/*      */ 
/*      */   public void update(Graphics g)
/*      */   {
/* 1837 */     paint(g);
/*      */   }
/*      */ 
/*      */   public void paint(Graphics paramGraphics)
/*      */   {
/* 1852 */     if (TXT_AA != null) {
/*      */       try {
/* 1854 */         if (renderinghint == null) {
/* 1855 */           renderinghint = paramGraphics.getClass().getMethod("setRenderingHint", new Class[] { TXT_AA[0].getClass().getSuperclass(), Object.class });
/*      */         }
/*      */ 
/* 1862 */         renderinghint.invoke(paramGraphics, TXT_AA);
/*      */ 
/* 1864 */         renderinghint.invoke(paramGraphics, G_AA);
/*      */       } catch (Exception localException) {
/* 1866 */         TXT_AA = null;
/*      */       }
/*      */     }
/*      */ 
/* 1870 */     paramGraphics.setFont(this._font);
/* 1871 */     if (this._hgradient == null) {
/* 1872 */       localObject = new int[2][this._block * this._block];
/* 1873 */       int i = this._cBg.getRed();
/* 1874 */       int j = this._cPress.getRed();
/* 1875 */       int k = this._cBg.getGreen();
/* 1876 */       int m = this._cPress.getGreen();
/* 1877 */       int n = this._cBg.getBlue();
/* 1878 */       int i1 = this._cPress.getBlue();
/* 1879 */       for (int i2 = 0; i2 < this._block; i2++) {
/* 1880 */         int i3 = i - (i - j) * i2 / this._block;
/* 1881 */         int i4 = k - (k - m) * i2 / this._block;
/* 1882 */         int i5 = n - (n - i1) * i2 / this._block;
/* 1883 */         i3 = 0xFF000000 | i3 << 16 | i4 << 8 | i5;
/* 1884 */         for (i4 = 0; i4 < this._block; i4++) {
/* 1885 */           localObject[0][(i2 * this._block + i4)] = i3;
/* 1886 */           localObject[1][(i4 * this._block + i2)] = i3;
/*      */         }
/*      */       }
/* 1889 */       this._hgradient = createImage(new MemoryImageSource(this._block, this._block, localObject[0], 0, this._block));
/*      */ 
/* 1892 */       this._vgradient = createImage(new MemoryImageSource(this._block, this._block, localObject[1], 0, this._block));
/*      */     }
/*      */ 
/* 1899 */     Object localObject = paramGraphics.getClipBounds();
/*      */ 
/* 1901 */     paint(paramGraphics, ((Rectangle)localObject).x, ((Rectangle)localObject).y, ((Rectangle)localObject).width, ((Rectangle)localObject).height, this.content, isEnabled());
/*      */   }
/*      */ 
/*      */   private void paint(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Object paramObject, boolean paramBoolean)
/*      */   {
/* 1921 */     if (!getBoolean(paramObject, "visible", true))
/* 1922 */       return;
/*      */     Rectangle localRectangle1;
/* 1925 */     if ((
/* 1925 */       localRectangle1 = getRectangle(paramObject, "bounds")) == null)
/*      */     {
/* 1926 */       return;
/*      */     }
/*      */ 
/* 1929 */     if (localRectangle1.width < 0) {
/* 1930 */       localRectangle1.width = Math.abs(localRectangle1.width);
/* 1931 */       doLayout(paramObject);
/*      */     }
/*      */ 
/* 1934 */     if ((paramInt1 + paramInt3 < localRectangle1.x) || (paramInt1 > localRectangle1.x + localRectangle1.width) || (paramInt2 + paramInt4 < localRectangle1.y) || (paramInt2 > localRectangle1.y + localRectangle1.height))
/*      */     {
/* 1938 */       return;
/*      */     }
/*      */ 
/* 1941 */     paramInt1 -= localRectangle1.x;
/* 1942 */     paramInt2 -= localRectangle1.y;
/* 1943 */     paramGraphics.translate(localRectangle1.x, localRectangle1.y);
/*      */ 
/* 1945 */     String str1 = getClass(paramObject);
/* 1946 */     boolean bool1 = this.mousepressed == paramObject;
/* 1947 */     boolean bool3 = (this.mouseinside == paramObject) && ((this.mousepressed == null) || (bool1));
/*      */ 
/* 1949 */     boolean bool4 = (this.focusinside) && (this.focusowner == paramObject);
/* 1950 */     paramBoolean = getBoolean(paramObject, "enabled", true);
/*      */ 
/* 1952 */     if ("label".equals(str1)) {
/* 1953 */       paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, false, false, false, false, 0, 0, 0, 0, false, paramBoolean ? 'e' : 'd', "left", true, false);
/*      */     }
/*      */     else
/*      */     {
/*      */       boolean bool5;
/*      */       char c;
/* 1957 */       if (("button".equals(str1)) || ("togglebutton".equals(str1)))
/*      */       {
/* 1959 */         bool5 = ("togglebutton".equals(str1)) && (getBoolean(paramObject, "selected", false));
/*      */         int n;
/* 1965 */         if ((
/* 1965 */           n = ("button".equals(str1)) && ("link".equals(get(paramObject, "type"))) ? 1 : 0) != 0)
/*      */         {
/* 1966 */           paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, false, false, false, false, 0, 0, 0, 0, bool4, paramBoolean ? 'l' : bool1 ? 'e' : 'd', "center", true, (paramBoolean) && (bool3 != bool1));
/*      */         }
/*      */         else
/*      */         {
/* 1972 */           c = paramBoolean ? 'g' : (bool1) || (bool5) ? 'p' : bool3 != bool1 ? 'h' : 'd';
/*      */ 
/* 1975 */           paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, true, true, true, true, 2, 5, 2, 5, bool4, c, "center", true, false);
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/*      */         Color localColor;
/*      */         Object localObject7;
/*      */         int i5;
/* 1984 */         if ("checkbox".equals(c)) {
/* 1985 */           paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, false, false, false, false, 0, this._block + 3, 0, 0, false, paramBoolean ? 'e' : 'd', "left", true, false);
/*      */ 
/* 1991 */           bool5 = getBoolean(paramObject, "selected", false);
/*      */ 
/* 1993 */           String str2 = getString(paramObject, "group", null);
/* 1994 */           localColor = paramBoolean ? this._cBorder : this._cDisable;
/* 1995 */           localObject7 = paramBoolean ? null : bool1 ? this._cPress : bool3 != bool1 ? this._cHover : this._cBg;
/*      */ 
/* 1998 */           i5 = (localRectangle1.height - this._block + 2) / 2;
/* 1999 */           if (str2 == null) {
/* 2000 */             paintRect(paramGraphics, 1, i5 + 1, this._block - 2, this._block - 2, localColor, (Color)localObject7, true, true, true, true, true);
/*      */           }
/*      */           else {
/* 2003 */             paramGraphics.setColor(localObject7 != null ? localObject7 : this._cBg);
/* 2004 */             paramGraphics.fillOval(1, i5 + 1, this._block - 3 + evm, this._block - 3 + evm);
/* 2005 */             paramGraphics.setColor(localColor);
/* 2006 */             paramGraphics.drawOval(1, i5 + 1, this._block - 3, this._block - 3);
/*      */           }
/* 2008 */           if (bool4) {
/* 2009 */             drawFocus(paramGraphics, 0, 0, localRectangle1.width - 1, localRectangle1.height - 1);
/*      */           }
/* 2011 */           if (((!bool5) && (bool3) && (bool1)) || ((bool5) && ((!bool3) || (!bool1))))
/*      */           {
/* 2013 */             paramGraphics.setColor(paramBoolean ? this._cText : this._cDisable);
/* 2014 */             if (str2 == null) {
/* 2015 */               paramGraphics.fillRect(3, i5 + this._block - 9, 2 + evm, 6 + evm);
/* 2016 */               paramGraphics.drawLine(3, i5 + this._block - 4, this._block - 4, i5 + 3);
/* 2017 */               paramGraphics.drawLine(4, i5 + this._block - 4, this._block - 4, i5 + 4); break label5320;
/*      */             }
/* 2019 */             paramGraphics.fillOval(5, i5 + 5, this._block - 10 + evm, this._block - 10 + evm);
/*      */ 
/* 2021 */             paramGraphics.drawOval(4, i5 + 4, this._block - 9, this._block - 9);
/*      */           }
/*      */         }
/* 2024 */         else if ("combobox".equals(localColor)) {
/* 2025 */           if (getBoolean(paramObject, "editable", true))
/*      */           {
/*      */             Image localImage;
/* 2027 */             int i1 = (
/* 2027 */               localImage = getIcon(paramObject, "icon", null)) != null
/* 2027 */                ? localImage.getWidth(this) : 0;
/* 2028 */             paintField(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramObject, localRectangle1.width - this._block, localRectangle1.height, bool4, paramBoolean, false, i1);
/*      */ 
/* 2031 */             if (localImage != null) {
/* 2032 */               paramGraphics.drawImage(localImage, 2, (localRectangle1.height - localImage.getHeight(this)) / 2, this);
/*      */             }
/*      */ 
/* 2035 */             paintArrow(paramGraphics, localRectangle1.width - this._block, 0, this._block, localRectangle1.height, 'S', paramBoolean, bool3, bool1, "down", true, false, true, true, true);
/*      */           }
/*      */           else
/*      */           {
/* 2039 */             paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, true, true, true, true, 1, 1, 1, 1 + this._block, bool4, paramBoolean ? 'g' : bool1 ? 'p' : bool3 != bool1 ? 'h' : 'd', "left", false, false);
/*      */ 
/* 2045 */             paramGraphics.setColor(paramBoolean ? this._cText : this._cDisable);
/* 2046 */             paintArrow(paramGraphics, localRectangle1.width - this._block, 0, this._block, localRectangle1.height, 'S');
/*      */           }
/*      */         }
/* 2049 */         else if (":combolist".equals(localColor)) {
/* 2050 */           paintScroll(paramObject, localColor, bool1, bool3, bool4, false, paramBoolean, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4);
/*      */         }
/* 2052 */         else if (("textfield".equals(localColor)) || ("passwordfield".equals(localColor)))
/*      */         {
/* 2054 */           paintField(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramObject, localRectangle1.width, localRectangle1.height, bool4, paramBoolean, "passwordfield".equals(localColor), 0);
/*      */         }
/* 2057 */         else if ("textarea".equals(localColor)) {
/* 2058 */           paintScroll(paramObject, localColor, bool1, bool3, bool4, true, paramBoolean, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4);
/*      */         }
/*      */         else
/*      */         {
/*      */           int k;
/*      */           int i;
/* 2060 */           if ("tabbedpane".equals(localColor)) {
/* 2061 */             k = 0;
/* 2062 */             Object localObject4 = null;
/* 2063 */             i = getInteger(paramObject, "selected", 0);
/* 2064 */             localObject7 = getString(paramObject, "placement", "top");
/*      */ 
/* 2066 */             i5 = ("top".equals(localObject7)) || ("bottom".equals(localObject7)) ? 1 : 0;
/*      */ 
/* 2070 */             int i6 = i5 != 0 ? 2 : (
/* 2070 */               bool1 = "stacked".equals(localObject7))
/* 2070 */                ? 0 : 1; int i7 = i5 != 0 ? 1 : bool1 ? 0 : 2;
/* 2071 */             int i8 = i6 * 2; int i9 = i7 * 2;
/*      */ 
/* 2073 */             int i10 = paramInt1; int i11 = paramInt2; int i12 = paramInt3; int i13 = paramInt4;
/*      */ 
/* 2075 */             paramInt1 = Math.max(0, paramInt1);
/* 2076 */             paramInt2 = Math.max(0, paramInt2);
/* 2077 */             paramInt3 = Math.min(localRectangle1.width, i10 + paramInt3) - paramInt1;
/* 2078 */             paramInt4 = Math.min(localRectangle1.height, i11 + paramInt4) - paramInt2;
/* 2079 */             paramGraphics.clipRect(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */ 
/* 2082 */             for (paramObject = get(paramObject, ":comp"); paramObject != null; paramObject = get(paramObject, ":next"))
/*      */             {
/* 2084 */               Rectangle localRectangle3 = getRectangle(paramObject, "bounds");
/* 2085 */               if (i != k) {
/* 2086 */                 int i15 = (bool3) && (this.mousepressed == null) && (this.insidepart == paramObject) ? 1 : 0;
/*      */ 
/* 2089 */                 int i17 = (paramBoolean) && (getBoolean(paramObject, "enabled", true)) ? 1 : 0;
/*      */ 
/* 2092 */                 paintBorderBackgroundIconAndText(paramObject, localRectangle3.x + i6, localRectangle3.y + i7, localRectangle3.width - i8, localRectangle3.height - i9, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, !"bottom".equals(localObject7), !"right".equals(localObject7), (!bool1) && (!"top".equals(localObject7)), !"left".equals(localObject7), 1, 3, 1, 3, false, i17 != 0 ? 'g' : i15 != 0 ? 'h' : 'd', "left", true, false);
/*      */               }
/*      */               else
/*      */               {
/* 2102 */                 localObject4 = paramObject;
/*      */ 
/* 2104 */                 paintBorderAndBackground(paramObject, "left".equals(localObject7) ? localRectangle3.width - 1 : 0, "top".equals(localObject7) ? localRectangle3.height - 1 : bool1 ? localRectangle3.y + localRectangle3.height - 1 : 0, (i5 != 0) || (bool1) ? localRectangle1.width : localRectangle1.width - localRectangle3.width + 1, i5 != 0 ? localRectangle1.height - localRectangle3.height + 1 : bool1 ? localRectangle1.height - localRectangle3.y - localRectangle3.height + 1 : localRectangle1.height, paramGraphics, true, true, true, true, paramBoolean ? 'e' : 'd');
/*      */                 Object localObject10;
/* 2117 */                 if (((
/* 2117 */                   localObject10 = get(localObject4, ":comp")) != null) && 
/* 2117 */                   (getBoolean(localObject10, "visible", true))) {
/* 2118 */                   paramInt1 -= localRectangle3.x;
/* 2119 */                   paramInt2 -= localRectangle3.y;
/* 2120 */                   paramGraphics.translate(localRectangle3.x, localRectangle3.y);
/*      */ 
/* 2123 */                   paint(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, localObject10, paramBoolean);
/*      */ 
/* 2125 */                   paramInt1 += localRectangle3.x;
/* 2126 */                   paramInt2 += localRectangle3.y;
/* 2127 */                   paramGraphics.translate(-localRectangle3.x, -localRectangle3.y);
/*      */                 }
/*      */               }
/* 2130 */               k++;
/*      */             }
/*      */ 
/* 2134 */             if (localObject4 != null) {
/* 2135 */               paramObject = getRectangle(localObject4, "bounds");
/*      */ 
/* 2137 */               int i14 = i5 != 0 ? 5 : bool1 ? 3 : 4;
/* 2138 */               int i16 = i5 != 0 ? 2 : bool1 ? 1 : 3;
/* 2139 */               paintBorderBackgroundIconAndText(localObject4, paramObject.x, paramObject.y, paramObject.width, paramObject.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, !"bottom".equals(localObject7), !"right".equals(localObject7), (!bool1) && (!"top".equals(localObject7)), !"left".equals(localObject7), i16, i14, i16, i14, bool4, paramBoolean ? 'b' : 'i', "left", true, false);
/*      */             }
/*      */ 
/* 2148 */             paramGraphics.setClip(i10, i11, i12, i13);
/*      */           }
/*      */           else
/*      */           {
/*      */             Object localObject5;
/* 2149 */             if (("panel".equals(i)) || ("dialog".equals(i)))
/*      */             {
/* 2151 */               k = getInteger(paramObject, ":titleheight", 0);
/* 2152 */               if ("dialog".equals(i)) {
/* 2153 */                 paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, k + 3, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, true, true, false, true, 1, 2, 1, 2, false, 'g', "left", false, false);
/*      */ 
/* 2157 */                 int i2 = localRectangle1.width - k - 1;
/* 2158 */                 if (getBoolean(paramObject, "closable", false)) {
/* 2159 */                   paint(paramObject, paramGraphics, i2, 3, k - 2, k - 2, 'c');
/*      */ 
/* 2161 */                   i2 -= k;
/*      */                 }
/* 2163 */                 if (getBoolean(paramObject, "maximizable", false)) {
/* 2164 */                   paint(paramObject, paramGraphics, i2, 3, k - 2, k - 2, 'm');
/*      */ 
/* 2166 */                   i2 -= k;
/*      */                 }
/* 2168 */                 if (getBoolean(paramObject, "iconifiable", false)) {
/* 2169 */                   paint(paramObject, paramGraphics, i2, 3, k - 2, k - 2, 'i');
/*      */                 }
/*      */ 
/* 2172 */                 paintRect(paramGraphics, 0, k + 3, localRectangle1.width, localRectangle1.height - 3 - k, this._cBorder, this._cPress, false, true, true, true, true);
/*      */ 
/* 2178 */                 paintBorderAndBackground(paramObject, 3, k + 3, localRectangle1.width - 6, localRectangle1.height - 6 - k, paramGraphics, true, true, true, true, 'b');
/*      */               }
/*      */               else
/*      */               {
/* 2182 */                 boolean bool6 = getBoolean(paramObject, "border", false);
/*      */ 
/* 2184 */                 paintBorderAndBackground(paramObject, 0, k / 2, localRectangle1.width, localRectangle1.height - k / 2, paramGraphics, bool6, bool6, bool6, bool6, paramBoolean ? 'e' : 'd');
/*      */ 
/* 2187 */                 paintBorderBackgroundIconAndText(paramObject, 0, 0, localRectangle1.width, k, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, false, false, false, false, 0, 3, 0, 3, false, paramBoolean ? 'x' : 'd', "left", false, false);
/*      */               }
/*      */ 
/* 2198 */               if (get(paramObject, ":port") != null) {
/* 2199 */                 paintScroll(paramObject, i, bool1, bool3, bool4, false, paramBoolean, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4);
/*      */               }
/*      */               else {
/* 2202 */                 for (localObject5 = get(paramObject, ":comp"); localObject5 != null; localObject5 = get(localObject5, ":next"))
/*      */                 {
/* 2204 */                   paint(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, localObject5, paramBoolean);
/*      */                 }
/*      */               }
/*      */             }
/* 2208 */             else if ("desktop".equals(i)) {
/* 2209 */               paintRect(paramGraphics, 0, 0, localRectangle1.width, localRectangle1.height, this._cBorder, this._cBg, false, false, false, false, true);
/*      */ 
/* 2211 */               paintReverse(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, get(paramObject, ":comp"), paramBoolean);
/*      */ 
/* 2215 */               if ((this.tooltipowner != null) && (paramObject == this.content)) {
/* 2216 */                 Rectangle localRectangle2 = getRectangle(this.tooltipowner, ":tooltipbounds");
/* 2217 */                 paintRect(paramGraphics, localRectangle2.x, localRectangle2.y, localRectangle2.width, localRectangle2.height, this._cBorder, this._cBg, true, true, true, true, true);
/*      */ 
/* 2219 */                 localObject5 = getString(this.tooltipowner, "tooltip", null);
/*      */ 
/* 2221 */                 paramGraphics.setColor(this._cText);
/* 2222 */                 paramGraphics.drawString((String)localObject5, localRectangle2.x + 2, localRectangle2.y + paramGraphics.getFontMetrics().getAscent() + 2);
/*      */               }
/*      */ 
/*      */             }
/* 2226 */             else if ("spinbox".equals(i)) {
/* 2227 */               paintField(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramObject, localRectangle1.width - this._block, localRectangle1.height, bool4, paramBoolean, false, 0);
/*      */ 
/* 2230 */               paintArrow(paramGraphics, localRectangle1.width - this._block, 0, this._block, localRectangle1.height / 2, 'N', paramBoolean, bool3, bool1, "up", true, false, false, true, true);
/*      */ 
/* 2233 */               paintArrow(paramGraphics, localRectangle1.width - this._block, localRectangle1.height / 2, this._block, localRectangle1.height - localRectangle1.height / 2, 'S', paramBoolean, bool3, bool1, "down", true, false, true, true, true);
/*      */             }
/*      */             else
/*      */             {
/*      */               int m;
/*      */               int i3;
/*      */               boolean bool7;
/* 2236 */               if ("progressbar".equals(i)) {
/* 2237 */                 m = getInteger(paramObject, "minimum", 0);
/* 2238 */                 i3 = getInteger(paramObject, "maximum", 100);
/*      */ 
/* 2240 */                 i = getInteger(paramObject, "value", 0);
/*      */ 
/* 2242 */                 bool7 = !"vertical".equals(get(paramObject, "orientation"));
/*      */ 
/* 2244 */                 i5 = (i - m) * ((bool7 ? localRectangle1.width : localRectangle1.height) - 1) / (i3 - m);
/*      */ 
/* 2248 */                 paintRect(paramGraphics, 0, 0, bool7 ? i5 : localRectangle1.width, bool7 ? localRectangle1.height : i5, paramBoolean ? this._cBorder : this._cDisable, this._cSelect, true, true, bool7, !bool7, true);
/*      */ 
/* 2252 */                 paintRect(paramGraphics, bool7 ? i5 : 0, bool7 ? 0 : i5, bool7 ? localRectangle1.width - i5 : localRectangle1.width, bool7 ? localRectangle1.height : localRectangle1.height - i5, paramBoolean ? this._cBorder : this._cDisable, this._cBg, true, true, true, true, true);
/*      */               }
/* 2257 */               else if ("slider".equals(i)) {
/* 2258 */                 if (bool4) {
/* 2259 */                   drawFocus(paramGraphics, 0, 0, localRectangle1.width - 1, localRectangle1.height - 1);
/*      */                 }
/* 2261 */                 m = getInteger(paramObject, "minimum", 0);
/* 2262 */                 i3 = getInteger(paramObject, "maximum", 100);
/*      */ 
/* 2264 */                 i = getInteger(paramObject, "value", 0);
/* 2265 */                 bool7 = !"vertical".equals(get(paramObject, "orientation"));
/*      */ 
/* 2267 */                 i5 = (i - m) * ((bool7 ? localRectangle1.width : localRectangle1.height) - this._block) / (i3 - m);
/*      */ 
/* 2271 */                 paintRect(paramGraphics, bool7 ? 0 : 3, bool7 ? 3 : 0, bool7 ? i5 : localRectangle1.width - 6, bool7 ? localRectangle1.height - 6 : i5, paramBoolean ? this._cBorder : this._cDisable, this._cBg, true, true, bool7, !bool7, true);
/*      */ 
/* 2276 */                 paintRect(paramGraphics, bool7 ? i5 : 0, bool7 ? 0 : i5, bool7 ? this._block : localRectangle1.width, bool7 ? localRectangle1.height : this._block, paramBoolean ? this._cBorder : this._cDisable, paramBoolean ? null : this._cBg, true, true, true, true, true);
/*      */ 
/* 2281 */                 paintRect(paramGraphics, bool7 ? this._block + i5 : 3, bool7 ? 3 : this._block + i5, localRectangle1.width - (bool7 ? this._block + i5 : 6), localRectangle1.height - (bool7 ? 6 : this._block + i5), paramBoolean ? this._cBorder : this._cDisable, this._cBg, bool7, !bool7, true, true, true);
/*      */               }
/*      */               else
/*      */               {
/*      */                 Object localObject2;
/* 2287 */                 if ("splitpane".equals(i)) {
/* 2288 */                   m = !"vertical".equals(get(paramObject, "orientation")) ? 1 : 0;
/*      */ 
/* 2290 */                   i3 = getInteger(paramObject, "divider", -1);
/* 2291 */                   paintRect(paramGraphics, m != 0 ? i3 : 0, m != 0 ? 0 : i3, m != 0 ? 5 : localRectangle1.width, m != 0 ? localRectangle1.height : 5, this._cBorder, this._cBg, false, false, false, false, true);
/*      */ 
/* 2295 */                   if (bool4) {
/* 2296 */                     if (m != 0)
/* 2297 */                       drawFocus(paramGraphics, i3, 0, 4, localRectangle1.height - 1);
/*      */                     else {
/* 2299 */                       drawFocus(paramGraphics, 0, i3, localRectangle1.width - 1, 4);
/*      */                     }
/*      */                   }
/* 2302 */                   paramGraphics.setColor(paramBoolean ? this._cBorder : this._cDisable);
/* 2303 */                   i = m != 0 ? localRectangle1.height : localRectangle1.width;
/* 2304 */                   int i4 = Math.max(0, i / 2 - 12);
/* 2305 */                   i5 = Math.min(i / 2 + 12, i - 1);
/* 2306 */                   for (int j = i3 + 1; j < i3 + 4; j += 2) {
/* 2307 */                     if (m != 0)
/* 2308 */                       paramGraphics.drawLine(j, i4, j, i5);
/*      */                     else {
/* 2310 */                       paramGraphics.drawLine(i4, j, i5, j);
/*      */                     }
/*      */                   }
/*      */ 
/* 2314 */                   if ((
/* 2314 */                     localObject2 = get(paramObject, ":comp")) != null)
/*      */                   {
/* 2315 */                     paint(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, localObject2, paramBoolean);
/*      */                     Object localObject9;
/* 2318 */                     if ((
/* 2318 */                       localObject9 = get(localObject2, ":next")) != null)
/*      */                     {
/* 2319 */                       paint(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, localObject9, paramBoolean);
/*      */                     }
/*      */                   }
/*      */                 }
/* 2323 */                 else if (("list".equals(i)) || ("table".equals(i)) || ("tree".equals(i)))
/*      */                 {
/* 2325 */                   paintScroll(paramObject, i, localObject2, bool3, bool4, (bool4) && (get(paramObject, ":comp") == null), paramBoolean, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4);
/*      */                 }
/* 2328 */                 else if ("separator".equals(i)) {
/* 2329 */                   paramGraphics.setColor(paramBoolean ? this._cBorder : this._cDisable);
/* 2330 */                   paramGraphics.fillRect(0, 0, localRectangle1.width + evm, localRectangle1.height + evm);
/*      */                 }
/*      */                 else
/*      */                 {
/*      */                   Object localObject3;
/*      */                   Object localObject1;
/*      */                   Object localObject8;
/*      */                   boolean bool2;
/*      */                   boolean bool8;
/* 2331 */                   if ("menubar".equals(i)) {
/* 2332 */                     localObject3 = get(paramObject, "selected");
/* 2333 */                     i3 = 0;
/* 2334 */                     for (localObject1 = get(paramObject, ":comp"); localObject1 != null; localObject1 = get(localObject1, ":next"))
/*      */                     {
/* 2336 */                       localObject8 = getRectangle(localObject1, "bounds");
/* 2337 */                       if (paramInt1 + paramInt3 <= ((Rectangle)localObject8).x) break;
/* 2338 */                       if (paramInt1 >= ((Rectangle)localObject8).x + ((Rectangle)localObject8).width) {
/*      */                         continue;
/*      */                       }
/* 2341 */                       i5 = (paramBoolean) && (getBoolean(localObject1, "enabled", true)) ? 1 : 0;
/*      */ 
/* 2345 */                       bool2 = localObject3 == localObject1;
/* 2346 */                       bool8 = (localObject3 == null) && (this.insidepart == localObject1);
/* 2347 */                       paintBorderBackgroundIconAndText(localObject1, ((Rectangle)localObject8).x, 0, ((Rectangle)localObject8).width, localRectangle1.height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, bool2, bool2, true, bool2, 1, 3, 1, 3, false, paramBoolean ? 'r' : i5 != 0 ? 'g' : bool8 ? 'h' : bool2 ? 's' : 'd', "left", true, false);
/*      */ 
/* 2355 */                       i3 = ((Rectangle)localObject8).x + ((Rectangle)localObject8).width;
/*      */                     }
/* 2357 */                     paintRect(paramGraphics, i3, 0, localRectangle1.width - i3, localRectangle1.height, paramBoolean ? this._cBorder : this._cDisable, paramBoolean ? null : this._cBg, false, false, true, false, true);
/*      */                   }
/* 2360 */                   else if (":popup".equals(localObject1)) {
/* 2361 */                     paintRect(paramGraphics, 0, 0, localRectangle1.width, localRectangle1.height, this._cBorder, this._cTextbg, true, true, true, true, true);
/*      */ 
/* 2363 */                     localObject3 = get(paramObject, "selected");
/* 2364 */                     Object localObject6 = get(get(paramObject, "menu"), ":comp");
/* 2365 */                     for (; localObject6 != null; localObject6 = get(localObject6, ":next"))
/*      */                     {
/* 2367 */                       localObject1 = getRectangle(localObject6, "bounds");
/* 2368 */                       if (paramInt2 + paramInt4 <= ((Rectangle)localObject1).y) break;
/* 2369 */                       if (paramInt2 >= ((Rectangle)localObject1).y + ((Rectangle)localObject1).height) {
/*      */                         continue;
/*      */                       }
/* 2372 */                       localObject8 = getClass(localObject6);
/*      */ 
/* 2375 */                       if ("separator".equals(localObject8)) {
/* 2376 */                         paramGraphics.setColor(this._cBorder);
/* 2377 */                         paramGraphics.fillRect(((Rectangle)localObject1).x, ((Rectangle)localObject1).y, localRectangle1.width - 2 + evm, ((Rectangle)localObject1).height + evm);
/*      */                       }
/*      */                       else {
/* 2380 */                         i5 = localObject3 == localObject6 ? 1 : 0;
/* 2381 */                         bool2 = getBoolean(localObject6, "enabled", true);
/*      */ 
/* 2383 */                         paintBorderBackgroundIconAndText(localObject6, ((Rectangle)localObject1).x, ((Rectangle)localObject1).y, localRectangle1.width - 2, ((Rectangle)localObject1).height, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, false, false, false, false, 2, "checkboxmenuitem".equals(localObject8) ? this._block + 7 : 4, 2, 4, false, bool2 ? 't' : i5 != 0 ? 's' : 'd', "left", true, false);
/*      */ 
/* 2391 */                         if ("checkboxmenuitem".equals(localObject8)) {
/* 2392 */                           bool8 = getBoolean(localObject6, "selected", false);
/*      */ 
/* 2394 */                           String str4 = getString(localObject6, "group", null);
/*      */ 
/* 2396 */                           paramGraphics.translate(((Rectangle)localObject1).x + 4, ((Rectangle)localObject1).y + 2);
/* 2397 */                           paramGraphics.setColor(bool2 ? this._cBorder : this._cDisable);
/* 2398 */                           if (str4 == null)
/* 2399 */                             paramGraphics.drawRect(1, 1, this._block - 3, this._block - 3);
/*      */                           else {
/* 2401 */                             paramGraphics.drawOval(1, 1, this._block - 3, this._block - 3);
/*      */                           }
/* 2403 */                           if (bool8) {
/* 2404 */                             paramGraphics.setColor(bool2 ? this._cText : this._cDisable);
/* 2405 */                             if (str4 == null) {
/* 2406 */                               paramGraphics.fillRect(3, this._block - 9, 2 + evm, 6 + evm);
/* 2407 */                               paramGraphics.drawLine(3, this._block - 4, this._block - 4, 3);
/* 2408 */                               paramGraphics.drawLine(4, this._block - 4, this._block - 4, 4);
/*      */                             } else {
/* 2410 */                               paramGraphics.fillOval(5, 5, this._block - 10 + evm, this._block - 10 + evm);
/*      */ 
/* 2412 */                               paramGraphics.drawOval(4, 4, this._block - 9, this._block - 9);
/*      */                             }
/*      */                           }
/* 2415 */                           paramGraphics.translate(-((Rectangle)localObject1).x - 4, -((Rectangle)localObject1).y - 2);
/*      */                         }
/* 2417 */                         if ("menu".equals(localObject8)) {
/* 2418 */                           paintArrow(paramGraphics, ((Rectangle)localObject1).x + localRectangle1.width - this._block, ((Rectangle)localObject1).y, this._block, ((Rectangle)localObject1).height, 'E');
/*      */                         }
/*      */                         else
/*      */                         {
/*      */                           String str3;
/* 2422 */                           if ((
/* 2422 */                             str3 = getAccelerator(localObject6)) != null)
/*      */                           {
/* 2423 */                             paramGraphics.drawString(str3, localRectangle1.width - 4 - getFontMetrics(this._font).stringWidth(str3), ((Rectangle)localObject1).y + 2 + 10);
/*      */                           }
/*      */ 
/*      */                         }
/*      */ 
/*      */                       }
/*      */ 
/*      */                     }
/*      */ 
/*      */                   }
/* 2433 */                   else if ("bean".equals(localObject1)) {
/* 2434 */                     paramGraphics.clipRect(0, 0, localRectangle1.width, localRectangle1.height);
/* 2435 */                     ((Component)get(paramObject, "bean")).paint(paramGraphics);
/* 2436 */                     paramGraphics.setClip(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */                   } else {
/* 2438 */                     throw new IllegalArgumentException((String)localObject1);
/*      */                   }
/*      */                 }
/*      */               }
/*      */             }
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/* 2440 */     label5320: paramGraphics.translate(-localRectangle1.x, -localRectangle1.y);
/*      */   }
/*      */ 
/*      */   private void paintReverse(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Object paramObject, boolean paramBoolean)
/*      */   {
/* 2448 */     if (paramObject != null) {
/* 2449 */       Rectangle localRectangle = getRectangle(paramObject, "bounds");
/* 2450 */       if ((paramInt1 < localRectangle.x) || (paramInt1 + paramInt3 > localRectangle.x + localRectangle.width) || (paramInt2 < localRectangle.y) || (paramInt2 + paramInt4 > localRectangle.y + localRectangle.height))
/*      */       {
/* 2454 */         paintReverse(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, get(paramObject, ":next"), paramBoolean);
/*      */       }
/*      */ 
/* 2457 */       paint(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramObject, paramBoolean);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void paintField(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Object paramObject, int paramInt5, int paramInt6, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, int paramInt7)
/*      */   {
/* 2467 */     boolean bool = getBoolean(paramObject, "editable", true);
/* 2468 */     paintRect(paramGraphics, 0, 0, paramInt5, paramInt6, paramBoolean2 ? this._cBorder : this._cDisable, bool ? getColor(paramObject, "background", this._cTextbg) : this._cBg, true, true, true, true, true);
/*      */ 
/* 2471 */     paramGraphics.clipRect(paramInt7 + 1, 1, paramInt5 - paramInt7 - 2, paramInt6 - 2);
/*      */ 
/* 2473 */     String str = getString(paramObject, "text", "");
/* 2474 */     int i = getInteger(paramObject, ":offset", -2);
/*      */     Font localFont;
/* 2476 */     if ((
/* 2476 */       localFont = (Font)get(paramObject, "font")) != null)
/*      */     {
/* 2477 */       paramGraphics.setFont(localFont);
/*      */     }
/* 2479 */     FontMetrics localFontMetrics = paramGraphics.getFontMetrics();
/*      */ 
/* 2481 */     int j = 0;
/*      */     int n;
/* 2482 */     if (paramBoolean1) {
/* 2483 */       k = getInteger(paramObject, "start", 0);
/* 2484 */       m = getInteger(paramObject, "end", 0);
/* 2485 */       j = paramBoolean3 ? localFontMetrics.charWidth('*') * m : localFontMetrics.stringWidth(str.substring(0, m));
/*      */ 
/* 2488 */       if (k != m) {
/* 2489 */         n = paramBoolean3 ? localFontMetrics.charWidth('*') * k : localFontMetrics.stringWidth(str.substring(0, k));
/*      */ 
/* 2492 */         paramGraphics.setColor(this._cSelect);
/* 2493 */         paramGraphics.fillRect(paramInt7 + 2 - i + Math.min(n, j), 1, Math.abs(j - n) + evm, paramInt6 - 2 + evm);
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/* 2498 */     if (paramBoolean1) {
/* 2499 */       paramGraphics.setColor(this._cFocus);
/* 2500 */       paramGraphics.fillRect(paramInt7 + 1 - i + j, 3, 1 + evm, paramInt6 - 5 + evm);
/*      */     }
/*      */ 
/* 2504 */     paramGraphics.setColor(paramBoolean2 ? getColor(paramObject, "foreground", this._cText) : this._cDisable);
/*      */ 
/* 2506 */     int k = paramInt7 + 2 - i;
/* 2507 */     int m = (paramInt6 + localFontMetrics.getAscent() - localFontMetrics.getDescent()) / 2;
/* 2508 */     if (paramBoolean3) {
/* 2509 */       n = localFontMetrics.charWidth('*');
/* 2510 */       for (paramObject = str.length(); paramObject > 0; paramObject--) {
/* 2511 */         paramGraphics.drawString("*", k, m);
/* 2512 */         k += n;
/*      */       }
/*      */     } else {
/* 2515 */       paramGraphics.drawString(str, k, m);
/*      */     }
/* 2517 */     if (localFont != null) {
/* 2518 */       paramGraphics.setFont(this._font);
/*      */     }
/* 2520 */     paramGraphics.setClip(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */ 
/* 2522 */     if (paramBoolean1)
/* 2523 */       drawFocus(paramGraphics, 1, 1, paramInt5 - 3, paramInt6 - 3);
/*      */   }
/*      */ 
/*      */   private static Color getColor(Object paramObject, String paramString, Color paramColor)
/*      */   {
/* 2530 */     if ((
/* 2530 */       paramObject = get(paramObject, paramString)) != null)
/* 2530 */       return (Color)paramObject; return paramColor;
/*      */   }
/*      */ 
/*      */   private void paintScroll(Object paramObject, String paramString, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4, boolean paramBoolean5, Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 2564 */     Rectangle localRectangle1 = getRectangle(paramObject, ":port");
/* 2565 */     Object localObject1 = getRectangle(paramObject, ":horizontal");
/*      */ 
/* 2567 */     Rectangle localRectangle2 = getRectangle(paramObject, ":vertical");
/*      */ 
/* 2569 */     Rectangle localRectangle3 = getRectangle(paramObject, ":view");
/*      */     int m;
/*      */     int i1;
/*      */     int i3;
/*      */     int i6;
/*      */     int i7;
/*      */     int i9;
/*      */     int i11;
/* 2571 */     if (localObject1 != null) {
/* 2572 */       j = ((Rectangle)localObject1).x;
/* 2573 */       k = ((Rectangle)localObject1).y;
/* 2574 */       m = ((Rectangle)localObject1).width;
/* 2575 */       i1 = ((Rectangle)localObject1).height;
/* 2576 */       paintArrow(paramGraphics, j, k, this._block, i1, 'W', paramBoolean5, paramBoolean2, paramBoolean1, "left", true, true, true, false, true);
/*      */ 
/* 2578 */       paintArrow(paramGraphics, j + m - this._block, k, this._block, i1, 'E', paramBoolean5, paramBoolean2, paramBoolean1, "right", true, false, true, true, true);
/*      */ 
/* 2583 */       if ((
/* 2583 */         i3 = m - 2 * this._block) < 
/* 2583 */         10) {
/* 2584 */         paintRect(paramGraphics, j + this._block, k, i3, i1, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, true, true, true, true, true);
/*      */       }
/*      */       else
/*      */       {
/* 2588 */         i5 = Math.max(i3 * localRectangle1.width / localRectangle3.width, 10);
/* 2589 */         i6 = localRectangle3.x * (i3 - i5) / (localRectangle3.width - localRectangle1.width);
/*      */ 
/* 2591 */         paintRect(paramGraphics, j + this._block, k, i6, i1, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, false, true, true, false, true);
/*      */ 
/* 2594 */         paintRect(paramGraphics, j + this._block + i6, k, i5, i1, paramBoolean5 ? this._cBorder : this._cDisable, paramBoolean5 ? null : this._cBg, true, true, true, true, true);
/*      */ 
/* 2597 */         i7 = Math.min(5, (i5 - 4) / 3);
/* 2598 */         paramGraphics.setColor(paramBoolean5 ? this._cBorder : this._cDisable);
/* 2599 */         i9 = j + this._block + i6 + (i5 + 2 - i7 * 3) / 2;
/* 2600 */         for (int i10 = 0; i10 < i7; i10++) {
/* 2601 */           paramGraphics.drawLine(i9 + i10 * 3, k + 3, i9 + i10 * 3, k + i1 - 5);
/*      */         }
/*      */ 
/* 2604 */         i11 = i3 - i6 - i5;
/* 2605 */         paintRect(paramGraphics, j + this._block + i6 + i5, k, i11, i1, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, false, false, true, true, true);
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/* 2611 */     if (localRectangle2 != null) {
/* 2612 */       j = localRectangle2.x;
/* 2613 */       k = localRectangle2.y;
/* 2614 */       m = localRectangle2.width;
/* 2615 */       i1 = localRectangle2.height;
/* 2616 */       paintArrow(paramGraphics, j, k, m, this._block, 'N', paramBoolean5, paramBoolean2, paramBoolean1, "up", true, true, false, true, false);
/*      */ 
/* 2618 */       paintArrow(paramGraphics, j, k + i1 - this._block, m, this._block, 'S', paramBoolean5, paramBoolean2, paramBoolean1, "down", false, true, true, true, false);
/*      */ 
/* 2623 */       if ((
/* 2623 */         i3 = i1 - 2 * this._block) < 
/* 2623 */         10) {
/* 2624 */         paintRect(paramGraphics, j, k + this._block, m, i3, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, true, true, true, true, false);
/*      */       }
/*      */       else
/*      */       {
/* 2628 */         i5 = Math.max(i3 * localRectangle1.height / localRectangle3.height, 10);
/* 2629 */         i6 = localRectangle3.y * (i3 - i5) / (localRectangle3.height - localRectangle1.height);
/*      */ 
/* 2631 */         paintRect(paramGraphics, j, k + this._block, m, i6, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, true, false, false, true, false);
/*      */ 
/* 2634 */         paintRect(paramGraphics, j, k + this._block + i6, m, i5, paramBoolean5 ? this._cBorder : this._cDisable, paramBoolean5 ? null : this._cBg, true, true, true, true, false);
/*      */ 
/* 2637 */         i7 = Math.min(5, (i5 - 4) / 3);
/* 2638 */         paramGraphics.setColor(paramBoolean5 ? this._cBorder : this._cDisable);
/* 2639 */         i9 = k + this._block + i6 + (i5 + 2 - i7 * 3) / 2;
/* 2640 */         for (i11 = 0; i11 < i7; i11++) {
/* 2641 */           paramGraphics.drawLine(j + 3, i9 + i11 * 3, j + m - 5, i9 + i11 * 3);
/*      */         }
/*      */ 
/* 2644 */         int i12 = i3 - i6 - i5;
/* 2645 */         paintRect(paramGraphics, j, k + this._block + i6 + i5, m, i12, paramBoolean5 ? this._cBorder : this._cDisable, this._cBg, false, false, true, true, false);
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/* 2651 */     int j = localObject1 != null ? 1 : 0;
/* 2652 */     int k = localRectangle2 != null ? 1 : 0;
/*      */     Object localObject6;
/* 2653 */     if ((!"panel".equals(paramString)) && (!"dialog".equals(paramString)) && ((!"textarea".equals(paramString)) || (getBoolean(paramObject, "border", true))))
/*      */     {
/* 2657 */       paintRect(paramGraphics, localRectangle1.x - 1, localRectangle1.y - 1, localRectangle1.width + (k != 0 ? 1 : 2), localRectangle1.height + (j != 0 ? 1 : 2), paramBoolean5 ? this._cBorder : this._cDisable, getColor(paramObject, "background", this._cTextbg), true, true, j == 0, k == 0, true);
/*      */ 
/* 2663 */       if ("table".equals(paramString))
/*      */       {
/*      */         Object localObject2;
/* 2665 */         if ((
/* 2665 */           localObject2 = get(paramObject, "header")) != null)
/*      */         {
/* 2666 */           int[] arrayOfInt = (int[])get(paramObject, ":widths");
/* 2667 */           Object localObject3 = get(localObject2, ":comp");
/* 2668 */           i5 = 0;
/* 2669 */           paramGraphics.clipRect(0, 0, localRectangle1.width + 2, localRectangle1.y);
/*      */ 
/* 2672 */           for (i6 = 0; i6 < arrayOfInt.length; i6++) {
/* 2673 */             if (i6 != 0) {
/* 2674 */               localObject3 = get(localObject3, ":next");
/*      */             }
/*      */ 
/* 2677 */             i9 = (
/* 2677 */               i7 = i6 == arrayOfInt.length - 1 ? 1 : 0) != 0
/* 2677 */                ? localRectangle3.width - i5 + 2 : arrayOfInt[i6];
/*      */ 
/* 2681 */             paintBorderBackgroundIconAndText(localObject3, i5 - localRectangle3.x, 0, i9, localRectangle1.y - 1, paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, true, true, false, i7, 1, 1, 0, 0, false, paramBoolean5 ? 'g' : 'd', "left", false, false);
/*      */ 
/* 2690 */             if ((
/* 2690 */               localObject6 = get(localObject3, "sort")) != null)
/*      */             {
/* 2691 */               paintArrow(paramGraphics, i5 - localRectangle3.x + i9 - this._block, 0, this._block, localRectangle1.y, "ascent".equals(localObject6) ? 'S' : 'N');
/*      */             }
/*      */ 
/* 2695 */             i5 += i9;
/*      */           }
/* 2697 */           paramGraphics.setClip(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */         }
/*      */       }
/*      */     }
/* 2701 */     int n = Math.max(paramInt1, localRectangle1.x);
/* 2702 */     int i2 = Math.min(paramInt1 + paramInt3, localRectangle1.x + localRectangle1.width);
/* 2703 */     int i4 = Math.max(paramInt2, localRectangle1.y);
/* 2704 */     int i5 = Math.min(paramInt2 + paramInt4, localRectangle1.y + localRectangle1.height);
/* 2705 */     if ((i2 > n) && (i5 > i4)) {
/* 2706 */       paramGraphics.clipRect(n, i4, i2 - n, i5 - i4);
/* 2707 */       paramGraphics.translate(localRectangle1.x - localRectangle3.x, localRectangle1.y - localRectangle3.y);
/*      */ 
/* 2709 */       i4 = localRectangle3.width; i2 = localRectangle1.width; n = i5 - i4; k = i2 - n; j = localRectangle3.y - localRectangle1.y + i4; int i = localRectangle3.x - localRectangle1.x + n; localObject1 = paramGraphics; paramBoolean5 = paramBoolean5; paramBoolean2 = paramBoolean3; paramBoolean1 = paramString; paramString = paramObject; paramObject = this;
/*      */       Object localObject4;
/*      */       Object localObject8;
/*      */       int i15;
/*      */       int i16;
/*      */       Object localObject9;
/*      */       int i17;
/*      */       int i18;
/*      */       int i19;
/* 2709 */       if ("textarea".equals(paramBoolean1)) { localObject4 = (char[])get(paramString, ":text"); i6 = paramBoolean2 ? getInteger(paramString, "start", 0) : 0; int i8 = paramBoolean2 ? getInteger(paramString, "end", 0) : 0; i2 = Math.min(i6, i8); i9 = Math.max(i6, i8); if ((localObject6 = (Font)get(paramString, "font")) != null) ((Graphics)localObject1).setFont((Font)localObject6); int i14 = (localObject8 = ((Graphics)localObject1).getFontMetrics()).getAscent(); i15 = ((FontMetrics)localObject8).getHeight(); i16 = 1; localObject9 = paramBoolean5 ? getColor(paramString, "foreground", paramObject._cText) : paramObject._cDisable; i17 = 0; for (i18 = 0; i18 <= localObject4.length; i18++) { if ((i18 != localObject4.length) && (localObject4[i18] != '\n')) continue; if (j + n <= i16) break; if (j < i16 + i15) { if ((paramBoolean2) && (i2 != i9) && (i9 >= i17) && (i2 <= i18)) { i19 = i2 > i18 ? i4 - 1 : i2 < i17 ? -1 : ((FontMetrics)localObject8).charsWidth(localObject4, i17, i2 - i17); int i20 = (i18 != -1) && (i9 > i18) ? i4 - 1 : ((FontMetrics)localObject8).charsWidth(localObject4, i17, i9 - i17); ((Graphics)localObject1).setColor(paramObject._cSelect); ((Graphics)localObject1).fillRect(i19 + 1, i16, i20 - i19 + evm, i15 + evm); } ((Graphics)localObject1).setColor((Color)localObject9); ((Graphics)localObject1).drawChars(localObject4, i17, i18 - i17, 1, i16 + i14); if ((paramBoolean2) && (i8 >= i17) && (i8 <= i18)) { i19 = ((FontMetrics)localObject8).charsWidth(localObject4, i17, i8 - i17); ((Graphics)localObject1).setColor(paramObject._cFocus); ((Graphics)localObject1).fillRect(i19, i16, 1 + evm, i15 + evm); }  }
/* 2709 */           i16 += i15; i17 = i18 + 1; } if (localObject6 != null) ((Graphics)localObject1).setFont(paramObject._font);
/*      */       }
/*      */       else
/*      */       {
/* 2709 */         Object localObject5;
/* 2709 */         if (":combolist".equals(paramBoolean1)) { localObject4 = get(paramString, ":lead"); for (localObject5 = get(get(paramString, "combobox"), ":comp"); localObject5 != null; localObject5 = get(localObject5, ":next")) { Rectangle localRectangle4 = getRectangle(localObject5, "bounds"); if (j + n <= localRectangle4.y) break; if (j >= localRectangle4.y + localRectangle4.height) continue; paramObject.paintBorderBackgroundIconAndText(localObject5, localRectangle4.x, localRectangle4.y, i2, localRectangle4.height, (Graphics)localObject1, i, j, k, n, false, false, false, false, 2, 4, 2, 4, false, getBoolean(localObject5, "enabled", true) ? 't' : localObject4 == localObject5 ? 's' : 'd', "left", false, false); } } else if (("panel".equals(paramBoolean1)) || ("dialog".equals(paramBoolean1))) { for (localObject4 = get(paramString, ":comp"); localObject4 != null; localObject4 = get(localObject4, ":next")) paramObject.paint((Graphics)localObject1, i, j, k, n, localObject4, paramBoolean5);  } else {
/* 2709 */           localObject4 = get(paramString, ":lead"); localObject5 = "table".equals(paramBoolean1) ? (int[])get(paramString, ":widths") : null;
/*      */           boolean bool1;
/* 2709 */           i2 = (bool1 = getBoolean(paramString, "line", true)) ? 1 : 0; i9 = ("tree".equals(paramBoolean1)) && (getBoolean(paramString, "angle", false)) ? 1 : 0;
/*      */           Object localObject7;
/* 2709 */           for (localObject6 = get(paramString, ":comp"); localObject6 != null; localObject7 = localObject8) { if ((paramBoolean2) && (localObject4 == null)) set(paramString, ":lead", localObject4 = localObject6); Rectangle localRectangle5 = getRectangle(localObject6, "bounds"); if (j + n <= localRectangle5.y) break; i15 = 0; i16 = 0; if (!"tree".equals(paramBoolean1)) localObject8 = get(localObject6, ":next"); else if ((i16 = ((i15 = (localObject8 = get(localObject6, ":comp")) != null ? 1 : 0) != 0) && (getBoolean(localObject6, "expanded", true)) ? 1 : 0) == 0) for (localObject9 = localObject6; (localObject9 != paramString) && ((localObject8 = get(localObject9, ":next")) == null); localObject9 = paramObject.getParent(localObject9)); if (j >= localRectangle5.y + localRectangle5.height + i2) { if (i9 == 0) continue; if ((localObject9 = get(localObject6, ":next")) != null) { ((Graphics)localObject1).setColor(paramObject._cBg); i17 = localRectangle5.x - paramObject._block / 2; ((Graphics)localObject1).drawLine(i17, localRectangle5.y, i17, getRectangle(localObject9, "bounds").y); }  } else {
/* 2709 */               boolean bool2 = getBoolean(localObject6, "selected", false); paramObject.paintRect((Graphics)localObject1, !"tree".equals(paramBoolean1) ? 0 : localRectangle5.x, localRectangle5.y, !"tree".equals(paramBoolean1) ? i4 : localRectangle5.width, localRectangle5.height, null, bool2 ? paramObject._cSelect : paramObject._cTextbg, false, false, false, false, true); if ((paramBoolean2) && (localObject4 == localObject6)) paramObject.drawFocus((Graphics)localObject1, !"tree".equals(paramBoolean1) ? 0 : localRectangle5.x, localRectangle5.y, (!"tree".equals(paramBoolean1) ? i4 : localRectangle5.width) - 1, localRectangle5.height - 1); if (bool1) { ((Graphics)localObject1).setColor(paramObject._cBg); ((Graphics)localObject1).drawLine(0, localRectangle5.y + localRectangle5.height, i4, localRectangle5.y + localRectangle5.height); } if (!"table".equals(paramBoolean1)) { i17 = (paramBoolean5) && (getBoolean(localObject6, "enabled", true)) ? 1 : 0; paramObject.paintBorderBackgroundIconAndText(localObject6, localRectangle5.x, localRectangle5.y, i4, localRectangle5.height, (Graphics)localObject1, i, j, k, n, false, false, false, false, 1, 3, 1, 3, false, i17 != 0 ? 'e' : 'd', "left", false, false); if ("tree".equals(paramBoolean1)) { i18 = localRectangle5.x - paramObject._block / 2; i19 = localRectangle5.y + (localRectangle5.height - 1) / 2; if (i9 != 0) { ((Graphics)localObject1).setColor(paramObject._cBg); ((Graphics)localObject1).drawLine(i18, localRectangle5.y, i18, i19); ((Graphics)localObject1).drawLine(i18, i19, localRectangle5.x - 1, i19);
/*      */                     Object localObject11;
/* 2709 */                     if ((localObject11 = get(localObject6, ":next")) != null) ((Graphics)localObject1).drawLine(i18, i19, i18, getRectangle(localObject11, "bounds").y);  }
/* 2709 */                   if (i15 != 0) { paramObject.paintRect((Graphics)localObject1, i18 - 4, i19 - 4, 9, 9, i17 != 0 ? paramObject._cBorder : paramObject._cDisable, i17 != 0 ? null : paramObject._cBg, true, true, true, true, true); ((Graphics)localObject1).setColor(i17 != 0 ? paramObject._cText : paramObject._cDisable); ((Graphics)localObject1).drawLine(i18 - 2, i19, i18 + 2, i19); if (i16 == 0) ((Graphics)localObject1).drawLine(i18, i19 - 2, i18, i19 + 2);  } } } else {
/* 2709 */                 i17 = 0; i18 = 0; for (Object localObject10 = get(localObject6, ":comp"); (localObject10 != null) && (i + k > i18); localObject10 = get(localObject10, ":next")) { int i21 = 80; if ((localObject5 != null) && (localObject5.length > i17)) i21 = i17 != localObject5.length - 1 ? localObject5[i17] : Math.max(80, i4 - i18); if (i < i18 + i21) { int i13 = (paramBoolean5) && (getBoolean(localObject10, "enabled", true)) ? 1 : 0; paramObject.paintBorderBackgroundIconAndText(localObject10, localRectangle5.x + i18, localRectangle5.y, i21, localRectangle5.height - 1, (Graphics)localObject1, i, j, k, n, false, false, false, false, 1, 1, 1, 1, false, i13 != 0 ? 'e' : 'd', "left", false, false); } i17++; i18 += i21; } 
/*      */               }
/*      */             } }
/*      */         }
/*      */       }
/* 2713 */       paramGraphics.translate(localRectangle3.x - localRectangle1.x, localRectangle3.y - localRectangle1.y);
/* 2714 */       paramGraphics.setClip(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */     }
/* 2716 */     if ((paramBoolean3) && (paramBoolean4))
/* 2717 */       drawFocus(paramGraphics, localRectangle1.x, localRectangle1.y, localRectangle1.width - 1, localRectangle1.height - 1);
/*      */   }
/*      */ 
/*      */   private void paintRect(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Color paramColor1, Color paramColor2, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4, boolean paramBoolean5)
/*      */   {
/* 2981 */     if ((paramInt3 <= 0) || (paramInt4 <= 0)) {
/* 2982 */       return;
/*      */     }
/* 2984 */     paramGraphics.setColor(paramColor1);
/* 2985 */     if (paramBoolean1) {
/* 2986 */       paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2, paramInt1, paramInt2);
/* 2987 */       paramInt2++;
/* 2988 */       paramInt4--;
/* 2989 */       if (paramInt4 <= 0) {
/* 2990 */         return;
/*      */       }
/*      */     }
/* 2993 */     if (paramBoolean2) {
/* 2994 */       paramGraphics.drawLine(paramInt1, paramInt2, paramInt1, paramInt2 + paramInt4 - 1);
/* 2995 */       paramInt1++;
/* 2996 */       paramInt3--;
/* 2997 */       if (paramInt3 <= 0) {
/* 2998 */         return;
/*      */       }
/*      */     }
/* 3001 */     if (paramBoolean3) {
/* 3002 */       paramGraphics.drawLine(paramInt1, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1);
/* 3003 */       paramInt4--;
/* 3004 */       if (paramInt4 <= 0) {
/* 3005 */         return;
/*      */       }
/*      */     }
/* 3008 */     if (paramBoolean4) {
/* 3009 */       paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1, paramInt2);
/* 3010 */       paramInt3--;
/* 3011 */       if (paramInt3 <= 0) {
/* 3012 */         return;
/*      */       }
/*      */     }
/*      */ 
/* 3016 */     if (paramColor2 == null) {
/* 3017 */       fill(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramBoolean5); return;
/*      */     }
/* 3019 */     paramGraphics.setColor(paramColor2);
/* 3020 */     paramGraphics.fillRect(paramInt1, paramInt2, paramInt3 + evm, paramInt4 + evm);
/*      */   }
/*      */ 
/*      */   private void fill(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, boolean paramBoolean)
/*      */   {
/* 3029 */     if (paramBoolean) {
/* 3030 */       if (paramInt4 > this._block) {
/* 3031 */         paramGraphics.setColor(this._cBg);
/* 3032 */         paramGraphics.fillRect(paramInt1, paramInt2, paramInt3 + evm, paramInt4 - this._block + evm);
/*      */       }
/* 3034 */       for (paramBoolean = false; paramBoolean < paramInt3; paramBoolean += this._block)
/* 3035 */         paramGraphics.drawImage(this._hgradient, paramInt1 + paramBoolean, paramInt4 > this._block ? paramInt2 + paramInt4 - this._block : paramInt2, paramInt1 + Math.min(paramBoolean + this._block, paramInt3) + evm, paramInt2 + paramInt4 + evm, 0, 0, Math.min(this._block, paramInt3 - paramBoolean) + evm, Math.min(this._block, paramInt4) + evm, null);
/* 3034 */       return;
/*      */     }
/*      */ 
/* 3042 */     if (paramInt3 > this._block) {
/* 3043 */       paramGraphics.setColor(this._cBg);
/* 3044 */       paramGraphics.fillRect(paramInt1, paramInt2, paramInt3 - this._block + evm, paramInt4 + evm);
/*      */     }
/* 3046 */     for (paramBoolean = false; paramBoolean < paramInt4; paramBoolean += this._block)
/* 3047 */       paramGraphics.drawImage(this._vgradient, paramInt3 > this._block ? paramInt1 + paramInt3 - this._block : paramInt1, paramInt2 + paramBoolean, paramInt1 + paramInt3 + evm, paramInt2 + Math.min(paramBoolean + this._block, paramInt4) + evm, 0, 0, Math.min(this._block, paramInt3) + evm, Math.min(this._block, paramInt4 - paramBoolean) + evm, null);
/*      */   }
/*      */ 
/*      */   private void paintArrow(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, char paramChar, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, String paramString, boolean paramBoolean4, boolean paramBoolean5, boolean paramBoolean6, boolean paramBoolean7, boolean paramBoolean8)
/*      */   {
/* 3062 */     paramBoolean2 = (paramBoolean2) && (this.insidepart == paramString);
/* 3063 */     paramBoolean3 = (paramBoolean3) && (this.pressedpart == paramString);
/* 3064 */     paintRect(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, paramBoolean1 ? this._cBorder : this._cDisable, paramBoolean1 ? null : paramBoolean3 ? this._cPress : paramBoolean2 != paramBoolean3 ? this._cHover : this._cBg, paramBoolean4, paramBoolean5, paramBoolean6, paramBoolean7, paramBoolean8);
/*      */ 
/* 3067 */     paramGraphics.setColor(paramBoolean1 ? this._cText : this._cDisable);
/* 3068 */     paintArrow(paramGraphics, paramInt1 + (paramBoolean5 ? 1 : 0), paramInt2 + (paramBoolean4 ? 1 : 0), paramInt3 - (paramBoolean5 ? 1 : 0) - (paramBoolean7 ? 1 : 0), paramInt4 - (paramBoolean4 ? 1 : 0) - (paramBoolean6 ? 1 : 0), paramChar);
/*      */   }
/*      */ 
/*      */   private static void paintArrow(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, char paramChar)
/*      */   {
/* 3075 */     paramInt1 = paramInt1 + paramInt3 / 2 - 2;
/* 3076 */     paramInt2 = paramInt2 + paramInt4 / 2 - 2;
/* 3077 */     for (paramInt3 = 0; paramInt3 < 4; paramInt3++)
/* 3078 */       if (paramChar == 'N')
/* 3079 */         paramGraphics.drawLine(paramInt1 + 1 - paramInt3, paramInt2 + paramInt3, paramInt1 + 1 + paramInt3, paramInt2 + paramInt3);
/* 3080 */       else if (paramChar == 'W')
/* 3081 */         paramGraphics.drawLine(paramInt1 + paramInt3, paramInt2 + 1 - paramInt3, paramInt1 + paramInt3, paramInt2 + 1 + paramInt3);
/* 3082 */       else if (paramChar == 'S') {
/* 3083 */         paramGraphics.drawLine(paramInt1 + 1 - paramInt3, paramInt2 + 4 - paramInt3, paramInt1 + 1 + paramInt3, paramInt2 + 4 - paramInt3);
/*      */       }
/*      */       else
/* 3086 */         paramGraphics.drawLine(paramInt1 + 4 - paramInt3, paramInt2 + 1 - paramInt3, paramInt1 + 4 - paramInt3, paramInt2 + 1 + paramInt3);
/*      */   }
/*      */ 
/*      */   private void paintBorderAndBackground(Object paramObject, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Graphics paramGraphics, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4, char paramChar)
/*      */   {
/* 3100 */     String str = getClass(paramObject);
/*      */ 
/* 3102 */     if ((paramInt3 <= 0) || (paramInt4 <= 0)) {
/* 3103 */       return;
/*      */     }
/*      */ 
/* 3107 */     Color localColor1 = (Color)get(paramObject, "background");
/* 3108 */     switch (paramChar) {
/*      */     case 'd':
/*      */     case 'e':
/*      */     case 'g':
/*      */     case 'l':
/*      */     case 'r':
/* 3114 */       break;
/*      */     case 'b':
/*      */     case 'i':
/*      */     case 'x':
/* 3118 */       if (localColor1 != null) break;
/* 3119 */       localColor1 = this._cBg; break;
/*      */     case 'h':
/* 3123 */       localColor1 = localColor1 != null ? localColor1.brighter() : this._cHover;
/*      */ 
/* 3125 */       break;
/*      */     case 'p':
/* 3127 */       localColor1 = localColor1 != null ? localColor1.darker() : this._cPress;
/*      */ 
/* 3129 */       break;
/*      */     case 't':
/* 3131 */       if (localColor1 != null) break;
/* 3132 */       localColor1 = this._cTextbg; break;
/*      */     case 's':
/* 3136 */       localColor1 = this._cSelect;
/* 3137 */       break;
/*      */     case 'c':
/*      */     case 'f':
/*      */     case 'j':
/*      */     case 'k':
/*      */     case 'm':
/*      */     case 'n':
/*      */     case 'o':
/*      */     case 'q':
/*      */     case 'u':
/*      */     case 'v':
/*      */     case 'w':
/*      */     default:
/* 3139 */       throw new IllegalArgumentException();
/*      */     }
/* 3141 */     if (((paramChar == 'g') || (paramChar == 'r')) && (localColor1 == null)) {
/* 3142 */       fill(paramGraphics, paramInt1, paramInt2, paramInt3, paramInt4, true);
/* 3143 */     } else if (localColor1 != null) {
/* 3144 */       paramGraphics.setColor(localColor1);
/* 3145 */       if (paramChar != 'x') {
/* 3146 */         if ((paramBoolean1) || (paramBoolean2) || (paramBoolean3) || (paramBoolean4)) {
/* 3147 */           paramGraphics.fillRect(paramInt1 + 1, paramInt2 + 1, paramInt3 + evm - 2, paramInt4 + evm - 2);
/*      */ 
/* 3152 */           if ((str.equals("button")) && (paramChar != 'h') && (paramChar != 'p') && (paramChar != 'd'))
/*      */           {
/* 3154 */             paramGraphics.setColor(localColor1.brighter());
/* 3155 */             paramGraphics.fillRect(paramInt1 + 1, paramInt2 + 1, paramInt3 + evm - 2, (paramInt4 + evm - 2) / 2);
/*      */           }
/*      */         }
/*      */         else {
/* 3159 */           paramGraphics.fillRect(paramInt1, paramInt2, paramInt3 + evm, paramInt4 + evm);
/*      */         }
/*      */       }
/*      */     }
/*      */ 
/* 3164 */     Color localColor2 = this._cBorder;
/* 3165 */     if ((this._useRoundedButtons) && (str.equals("button"))) {
/* 3166 */       localColor2 = localColor1;
/*      */     }
/*      */ 
/* 3169 */     paramGraphics.setColor((paramChar != 'd') && (paramChar != 'i') ? localColor2 : this._cDisable);
/*      */ 
/* 3173 */     if ((this._useRoundedButtons) && ((str.equals("button")) || (str.equals("combobox"))))
/*      */     {
/* 3179 */       if ((paramBoolean1) || (paramBoolean2) || (paramBoolean3) || (paramBoolean4))
/*      */       {
/* 3181 */         if (paramBoolean1) {
/* 3182 */           paramGraphics.drawLine(paramInt1 + paramInt3 - 1 - 3, paramInt2, paramInt1 + 3, paramInt2);
/* 3183 */           paramInt2++;
/* 3184 */           paramInt4--;
/* 3185 */           if (paramInt4 <= 0) {
/* 3186 */             return;
/*      */           }
/*      */         }
/* 3189 */         if (paramBoolean2) {
/* 3190 */           paramGraphics.drawLine(paramInt1, paramInt2 + 2, paramInt1, paramInt2 + paramInt4 - 1 - 3);
/* 3191 */           paramInt1++;
/* 3192 */           paramInt3--;
/* 3193 */           if (paramInt3 <= 0) {
/* 3194 */             return;
/*      */           }
/*      */         }
/* 3197 */         if (paramBoolean3) {
/* 3198 */           paramGraphics.drawLine(paramInt1 + 2, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1 - 3, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3200 */           paramInt4--;
/* 3201 */           if (paramInt4 <= 0) {
/* 3202 */             return;
/*      */           }
/*      */         }
/* 3205 */         if (paramBoolean4) {
/* 3206 */           paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1 - 2, paramInt1 + paramInt3 - 1, paramInt2 + 2);
/*      */ 
/* 3208 */           paramInt3--;
/* 3209 */           if (paramInt3 <= 0) {
/* 3210 */             return;
/*      */           }
/*      */         }
/*      */ 
/* 3214 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1 - 2, paramInt2, paramInt1 + paramInt3 - 1, paramInt2);
/* 3215 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + 1, paramInt1 + paramInt3 - 1, paramInt2 + 3);
/*      */ 
/* 3217 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1 - 2, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3219 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 3, paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3222 */         paramGraphics.drawLine(paramInt1 + 2, paramInt2 + paramInt4 - 1, paramInt1, paramInt2 + paramInt4 - 1);
/* 3223 */         paramGraphics.drawLine(paramInt1, paramInt2 + paramInt4 - 3, paramInt1, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3225 */         paramGraphics.drawLine(paramInt1 + 2, paramInt2, paramInt1, paramInt2);
/* 3226 */         paramGraphics.drawLine(paramInt1, paramInt2 + 1, paramInt1, paramInt2 + 3);
/*      */ 
/* 3229 */         if ("thick".equals(getString(paramObject, "borderType"))) {
/* 3230 */           paramGraphics.drawLine(paramInt1 + 3, paramInt2, paramInt1 + paramInt3 - 4, paramInt2);
/* 3231 */           paramGraphics.drawLine(paramInt1 + 3, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 4, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3234 */           paramGraphics.drawLine(paramInt1, paramInt2 + 3, paramInt1, paramInt2 + paramInt4 - 4);
/*      */ 
/* 3236 */           paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + 3, paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 4);
/*      */ 
/* 3239 */           paramGraphics.drawLine(paramInt1 + 1, paramInt2 + 1, paramInt1 + 1, paramInt2 + 1);
/* 3240 */           paramGraphics.drawLine(paramInt1 + 1, paramInt2 + paramInt4 - 2, paramInt1 + 1, paramInt2 + paramInt4 - 2);
/*      */ 
/* 3242 */           paramGraphics.drawLine(paramInt1 + paramInt3 - 2, paramInt2 + paramInt4 - 2, paramInt1 + paramInt3 - 2, paramInt2 + paramInt4 - 2);
/*      */ 
/* 3244 */           paramGraphics.drawLine(paramInt1 + paramInt3 - 2, paramInt2 + 1, paramInt1 + paramInt3 - 2, paramInt2 + 1); return;
/*      */         }
/*      */       }
/*      */ 
/*      */     }
/* 3249 */     else if ((paramBoolean1) || (paramBoolean2) || (paramBoolean3) || (paramBoolean4)) {
/* 3250 */       if (paramBoolean1) {
/* 3251 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2, paramInt1, paramInt2);
/* 3252 */         paramInt2++;
/* 3253 */         paramInt4--;
/* 3254 */         if (paramInt4 <= 0) {
/* 3255 */           return;
/*      */         }
/*      */       }
/* 3258 */       if (paramBoolean2) {
/* 3259 */         paramGraphics.drawLine(paramInt1, paramInt2, paramInt1, paramInt2 + paramInt4 - 1);
/* 3260 */         paramInt1++;
/* 3261 */         paramInt3--;
/* 3262 */         if (paramInt3 <= 0) {
/* 3263 */           return;
/*      */         }
/*      */       }
/* 3266 */       if (paramBoolean3) {
/* 3267 */         paramGraphics.drawLine(paramInt1, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1);
/*      */ 
/* 3269 */         paramInt4--;
/* 3270 */         if (paramInt4 <= 0) {
/* 3271 */           return;
/*      */         }
/*      */       }
/* 3274 */       if (paramBoolean4) {
/* 3275 */         paramGraphics.drawLine(paramInt1 + paramInt3 - 1, paramInt2 + paramInt4 - 1, paramInt1 + paramInt3 - 1, paramInt2);
/*      */ 
/* 3277 */         paramInt3--;
/* 3278 */         if (paramInt3 <= 0)
/* 3279 */           return;
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void paint(Object paramObject, Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, char paramChar)
/*      */   {
/* 3290 */     paintBorderAndBackground(paramObject, paramInt1, 3, paramInt3, paramInt4, paramGraphics, true, true, true, true, 'g');
/*      */ 
/* 3292 */     paramGraphics.setColor(Color.black);
/* 3293 */     switch (paramChar) {
/*      */     case 'c':
/* 3295 */       paramGraphics.drawLine(paramInt1 + 3, 7, paramInt1 + paramInt3 - 5, paramInt4 + 3 - 4);
/* 3296 */       paramGraphics.drawLine(paramInt1 + 3, 6, paramInt1 + paramInt3 - 4, paramInt4 + 3 - 4);
/* 3297 */       paramGraphics.drawLine(paramInt1 + 4, 6, paramInt1 + paramInt3 - 4, paramInt4 + 3 - 5);
/* 3298 */       paramGraphics.drawLine(paramInt1 + paramInt3 - 5, 6, paramInt1 + 3, paramInt4 + 3 - 5);
/* 3299 */       paramGraphics.drawLine(paramInt1 + paramInt3 - 4, 6, paramInt1 + 3, paramInt4 + 3 - 4);
/* 3300 */       paramGraphics.drawLine(paramInt1 + paramInt3 - 4, 7, paramInt1 + 4, paramInt4 + 3 - 4);
/* 3301 */       return;
/*      */     case 'm':
/* 3303 */       paramGraphics.drawRect(paramInt1 + 3, 6, paramInt3 - 7, paramInt4 - 7);
/* 3304 */       paramGraphics.drawLine(paramInt1 + 4, 7, paramInt1 + paramInt3 - 5, 7);
/* 3305 */       return;
/*      */     case 'i':
/* 3307 */       paramGraphics.fillRect(paramInt1 + 3, paramInt4 + 3 - 5, paramInt3 - 6, 2);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void paintBorderBackgroundIconAndText(Object paramObject, int paramInt1, int paramInt2, int paramInt3, int paramInt4, Graphics paramGraphics, int paramInt5, int paramInt6, int paramInt7, int paramInt8, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4, int paramInt9, int paramInt10, int paramInt11, int paramInt12, boolean paramBoolean5, char paramChar, String paramString, boolean paramBoolean6, boolean paramBoolean7)
/*      */   {
/* 3327 */     paintBorderAndBackground(paramObject, paramInt1, paramInt2, paramInt3, paramInt4, paramGraphics, paramBoolean1, paramBoolean2, paramBoolean3, paramBoolean4, paramChar);
/*      */ 
/* 3329 */     if (paramBoolean1) {
/* 3330 */       paramInt2++;
/* 3331 */       paramInt4--;
/*      */     }
/* 3333 */     if (paramBoolean2) {
/* 3334 */       paramInt1++;
/* 3335 */       paramInt3--;
/*      */     }
/* 3337 */     if (paramBoolean3) {
/* 3338 */       paramInt4--;
/*      */     }
/* 3340 */     if (paramBoolean4) {
/* 3341 */       paramInt3--;
/*      */     }
/* 3343 */     if ((paramInt3 <= 0) || (paramInt4 <= 0)) {
/* 3344 */       return;
/*      */     }
/*      */ 
/* 3347 */     if (paramBoolean5) {
/* 3348 */       drawFocus(paramGraphics, paramInt1 + 1, paramInt2 + 1, paramInt3 - 3, paramInt4 - 3);
/*      */     }
/*      */ 
/* 3351 */     paramBoolean1 = getString(paramObject, "text", null);
/*      */ 
/* 3353 */     paramBoolean2 = getIcon(paramObject, "icon", null);
/* 3354 */     if ((paramBoolean1 == null) && (paramBoolean2 == null)) {
/* 3355 */       return;
/*      */     }
/*      */ 
/* 3358 */     paramInt1 += paramInt10;
/* 3359 */     paramInt2 += paramInt9;
/* 3360 */     paramInt3 -= paramInt10 + paramInt12;
/* 3361 */     paramInt4 -= paramInt9 + paramInt11;
/*      */ 
/* 3363 */     paramString = getString(paramObject, "alignment", paramString);
/*      */ 
/* 3366 */     if ((
/* 3366 */       paramBoolean3 = paramBoolean1 != null ? (Font)get(paramObject, "font") : null) != null)
/*      */     {
/* 3367 */       paramGraphics.setFont(paramBoolean3);
/*      */     }
/*      */ 
/* 3370 */     paramBoolean4 = null;
/* 3371 */     paramInt9 = 0;
/* 3372 */     paramInt10 = 0;
/* 3373 */     paramInt11 = 0;
/* 3374 */     if (paramBoolean1 != null)
/*      */     {
/* 3376 */       paramInt9 = (
/* 3376 */         paramBoolean4 = paramGraphics.getFontMetrics())
/* 3376 */         .stringWidth(paramBoolean1);
/* 3377 */       paramInt11 = paramBoolean4.getAscent();
/* 3378 */       paramInt10 = paramBoolean4.getDescent() + paramInt11;
/*      */     }
/* 3380 */     paramInt12 = 0;
/* 3381 */     paramBoolean5 = false;
/* 3382 */     if (paramBoolean2 != null) {
/* 3383 */       paramInt12 = paramBoolean2.getWidth(this);
/* 3384 */       paramBoolean5 = paramBoolean2.getHeight(this);
/* 3385 */       if (paramBoolean1 != null) {
/* 3386 */         paramInt12 += 2;
/*      */       }
/*      */     }
/*      */ 
/* 3390 */     int i = (paramInt9 + paramInt12 > paramInt3) || (paramInt10 > paramInt4) || (paramBoolean5 > paramInt4) ? 1 : 0;
/* 3391 */     int j = paramInt1;
/* 3392 */     if ("center".equals(paramString))
/* 3393 */       j += (paramInt3 - paramInt9 - paramInt12) / 2;
/* 3394 */     else if ("right".equals(paramString)) {
/* 3395 */       j += paramInt3 - paramInt9 - paramInt12;
/*      */     }
/*      */ 
/* 3398 */     if (i != 0) {
/* 3399 */       paramGraphics.clipRect(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */     }
/* 3401 */     if (paramChar == 'x') {
/* 3402 */       paramGraphics.drawLine(j, paramInt2 + paramInt4 / 2, j + paramInt12 + paramInt9, paramInt2 + paramInt4 / 2);
/*      */     }
/* 3404 */     if (paramBoolean2 != null) {
/* 3405 */       paramGraphics.drawImage(paramBoolean2, j, paramInt2 + (paramInt4 - paramBoolean5) / 2, this);
/* 3406 */       j += paramInt12;
/*      */     }
/* 3408 */     if (paramBoolean1 != null)
/*      */     {
/* 3410 */       if ((
/* 3410 */         paramInt1 = (Color)get(paramObject, "foreground")) == null)
/*      */       {
/* 3411 */         paramInt1 = (paramChar != 'd') && (paramChar != 'r') ? this._cText : paramChar == 'l' ? Color.blue : this._cDisable;
/*      */       }
/*      */ 
/* 3416 */       paramGraphics.setColor(paramInt1);
/* 3417 */       paramInt1 = paramInt2 + (paramInt4 - paramInt10) / 2 + paramInt11;
/*      */ 
/* 3419 */       if (getClass(paramObject).equals("button")) {
/* 3420 */         paramGraphics.drawString(paramBoolean1, j, paramInt1 - 1);
/*      */       }
/*      */       else {
/* 3423 */         paramGraphics.drawString(paramBoolean1, j, paramInt1);
/*      */       }
/*      */ 
/* 3426 */       if (paramBoolean6)
/*      */       {
/* 3429 */         if (((
/* 3429 */           paramObject = getInteger(paramObject, "mnemonic", -1)) != 
/* 3429 */           -1) && (paramObject < paramBoolean1.length())) {
/* 3430 */           paramInt2 = j + paramBoolean4.stringWidth(paramBoolean1.substring(0, paramObject));
/*      */ 
/* 3432 */           paramGraphics.drawLine(paramInt2, paramInt1 + 1, paramInt2 + paramBoolean4.charWidth(paramBoolean1.charAt(paramObject)), paramInt1 + 1);
/*      */         }
/*      */       }
/*      */ 
/* 3436 */       if (paramBoolean7) {
/* 3437 */         paramGraphics.drawLine(j, paramInt1 + 1, j + paramInt9, paramInt1 + 1);
/*      */       }
/*      */     }
/* 3440 */     if (i != 0) {
/* 3441 */       paramGraphics.setClip(paramInt5, paramInt6, paramInt7, paramInt8);
/*      */     }
/*      */ 
/* 3444 */     if (paramBoolean3 != null)
/* 3445 */       paramGraphics.setFont(this._font);
/*      */   }
/*      */ 
/*      */   private void drawFocus(Graphics paramGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 3452 */     if (!_isFocusVisible) {
/* 3453 */       return;
/*      */     }
/* 3455 */     paramGraphics.setColor(this._cFocus);
/* 3456 */     this = paramInt1 + 1 - paramInt4 % 2;
/* 3457 */     for (int i = 0; i <= paramInt3; i += 2) {
/* 3458 */       paramGraphics.fillRect(paramInt1 + i, paramInt2, 1, 1);
/* 3459 */       paramGraphics.fillRect(this + i, paramInt2 + paramInt4, 1, 1);
/*      */     }
/* 3461 */     i = paramInt2 - paramInt3 % 2;
/* 3462 */     for (this = 2; this <= paramInt4; this += 2) {
/* 3463 */       paramGraphics.fillRect(paramInt1, paramInt2 + this, 1, 1);
/* 3464 */       paramGraphics.fillRect(paramInt1 + paramInt3, i + this, 1, 1);
/*      */     }
/*      */   }
/*      */ 
/*      */   public synchronized void run()
/*      */   {
/* 3473 */     while (this._timer == Thread.currentThread())
/*      */       try {
/* 3475 */         if (this._watch == 0L) {
/* 3476 */           wait(0L); continue;
/*      */         }
/* 3478 */         long l = System.currentTimeMillis();
/* 3479 */         if (this._watch > l) {
/* 3480 */           wait(this._watch - l); continue;
/*      */         }
/* 3482 */         this._watch = 0L;
/* 3483 */         if ((this._watchdelay == 300L) || (this._watchdelay == 60L)) {
/* 3484 */           if (processScroll(this.mousepressed, this.pressedpart)) {
/* 3485 */             setTimer(60L); continue;
/*      */           }
/* 3487 */         } else if ((this._watchdelay == 375L) || (this._watchdelay == 75L))
/*      */         {
/* 3489 */           if (processSpin(this.mousepressed, this.pressedpart)) {
/* 3490 */             setTimer(75L); continue;
/*      */           }
/* 3492 */         } else if (this._watchdelay == 750L) {
/* 3493 */           Thinlet localThinlet = this; String str = null; localThinlet.tooltipowner = null; Object localObject = getClass(localThinlet.mouseinside); if (("tabbedpane".equals(localObject)) || ("menubar".equals(localObject)) || (":popup".equals(localObject))) { if (localThinlet.insidepart != null) str = getString(localThinlet.insidepart, "tooltip", null); 
/* 3493 */           } else if ((":combolist".equals(localObject)) && ((localThinlet.insidepart instanceof Object[]))) str = getString(localThinlet.insidepart, "tooltip", null); if (str == null) str = getString(localThinlet.mouseinside, "tooltip", null); else localThinlet.tooltipowner = localThinlet.insidepart; if (str != null) { int i = (localObject = localThinlet.getFontMetrics(localThinlet._font)).stringWidth(str) + 4; int j = ((FontMetrics)localObject).getAscent() + ((FontMetrics)localObject).getDescent() + 4; if (localThinlet.tooltipowner == null) localThinlet.tooltipowner = localThinlet.mouseinside; Rectangle localRectangle = getRectangle(localThinlet.content, "bounds"); int m = Math.max(0, Math.min(localThinlet.mousex + 10, localRectangle.width - i)); int k = Math.max(0, Math.min(localThinlet.mousey + 10, localRectangle.height - j)); localThinlet.setRectangle(localThinlet.tooltipowner, ":tooltipbounds", m, k, i, j); localThinlet.repaint(m, k, i, j); }
/*      */         }
/*      */       }
/*      */       catch (InterruptedException localInterruptedException)
/*      */       {
/*      */       }
/*      */   }
/*      */ 
/*      */   private void setTimer(long arg1)
/*      */   {
/* 3503 */     this._watchdelay = ???;
/* 3504 */     if (??? == 0L) {
/* 3505 */       this._watch = 0L; return;
/*      */     }
/* 3507 */     long l = this._watch;
/* 3508 */     this._watch = (System.currentTimeMillis() + ???);
/* 3509 */     if (this._timer == null) {
/* 3510 */       this._timer = new Thread(this);
/* 3511 */       this._timer.setPriority(1);
/* 3512 */       this._timer.setDaemon(true);
/* 3513 */       this._timer.start();
/*      */     }
/* 3515 */     if ((l == 0L) || (this._watch < l))
/* 3516 */       synchronized (this) {
/* 3517 */         notify();
/* 3518 */         return;
/*      */       }
/*      */   }
/*      */ 
/*      */   public boolean isFocusTraversable()
/*      */   {
/* 3535 */     return true;
/*      */   }
/*      */ 
/*      */   protected void processEvent(AWTEvent paramAWTEvent)
/*      */   {
/*      */     int i;
/*      */     int m;
/*      */     boolean bool3;
/*      */     Object localObject1;
/*      */     int i1;
/*      */     int i2;
/*      */     int i3;
/* 3547 */     if (((
/* 3547 */       i = paramAWTEvent.getID()) == 
/* 3547 */       504) || (i == 503) || (i == 505) || (i == 501) || (i == 506) || (i == 502))
/*      */     {
/*      */       MouseEvent localMouseEvent;
/* 3553 */       int j = (
/* 3553 */         localMouseEvent = (MouseEvent)paramAWTEvent)
/* 3553 */         .getX();
/* 3554 */       paramAWTEvent = localMouseEvent.getY();
/* 3555 */       m = localMouseEvent.getClickCount();
/* 3556 */       boolean bool2 = localMouseEvent.isShiftDown();
/* 3557 */       bool3 = localMouseEvent.isControlDown();
/* 3558 */       boolean bool1 = (i == 501) && (localMouseEvent.isMetaDown());
/*      */ 
/* 3563 */       if (i == 504) {
/* 3564 */         if (this.mousepressed != null) break label815; findComponent(this.content, j, paramAWTEvent);
/*      */       }
/*      */       else
/*      */       {
/* 3570 */         if (i == 503) {
/* 3571 */           localObject1 = this.mouseinside;
/* 3572 */           localObject7 = this.insidepart;
/* 3573 */           findComponent(this.content, j, paramAWTEvent);
/* 3574 */           if ((localObject1 == this.mouseinside) && (localObject7 == this.insidepart)) {
/* 3575 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 503, this.mouseinside, this.insidepart); break label815;
/*      */           }
/*      */ 
/* 3579 */           handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 505, localObject1, localObject7);
/*      */ 
/* 3582 */           handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 504, this.mouseinside, this.insidepart);
/*      */ 
/* 3586 */           return; } if (localObject1 == 505) {
/* 3587 */           if (this.mousepressed != null) break label815; localObject1 = this.mouseinside;
/* 3589 */           localObject7 = this.insidepart;
/* 3590 */           this.mouseinside = (this.insidepart = null);
/* 3591 */           handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 505, localObject1, localObject7);
/*      */ 
/* 3594 */           return;
/* 3595 */         }if (localObject1 == 501) {
/* 3596 */           if (this.popupowner != null) {
/* 3597 */             localObject1 = getClass(this.mouseinside);
/* 3598 */             if ((this.popupowner != this.mouseinside) && (!":popup".equals(localObject1)) && (!":combolist".equals(localObject1)))
/*      */             {
/* 3601 */               closeup();
/*      */             }
/*      */           }
/* 3604 */           hideTip();
/* 3605 */           this.mousepressed = this.mouseinside;
/* 3606 */           this.pressedpart = this.insidepart;
/* 3607 */           handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 501, this.mousepressed, this.pressedpart); return;
/*      */         }
/*      */ 
/* 3610 */         if (localObject1 == 506) {
/* 3611 */           hideTip();
/* 3612 */           localObject1 = this.mouseinside;
/* 3613 */           localObject7 = this.insidepart;
/* 3614 */           findComponent(this.content, j, paramAWTEvent);
/* 3615 */           i1 = (localObject1 == this.mouseinside) && (localObject7 == this.insidepart) ? 1 : 0;
/*      */ 
/* 3617 */           i2 = (this.mousepressed == this.mouseinside) && (this.pressedpart == this.insidepart) ? 1 : 0;
/*      */ 
/* 3623 */           if (((
/* 3623 */             i3 = (this.mousepressed == localObject1) && (this.pressedpart == localObject7) ? 1 : 0) != 0) && 
/* 3623 */             (i2 == 0)) {
/* 3624 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 505, this.mousepressed, this.pressedpart);
/*      */           }
/* 3627 */           else if ((i1 == 0) && (this.popupowner != null) && (i3 == 0)) {
/* 3628 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 2001, localObject1, localObject7);
/*      */           }
/*      */ 
/* 3632 */           if ((i2 != 0) && (i3 == 0)) {
/* 3633 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 504, this.mousepressed, this.pressedpart);
/*      */           }
/* 3637 */           else if ((i1 == 0) && (this.popupowner != null) && (i2 == 0)) {
/* 3638 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 2000, this.mouseinside, this.insidepart);
/*      */           }
/*      */ 
/* 3642 */           if (i2 == i3) {
/* 3643 */             handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 506, this.mousepressed, this.pressedpart);
/*      */           }
/*      */ 
/* 3648 */           return; } if (localObject1 != 502) break label815; hideTip();
/* 3650 */         localObject1 = this.mousepressed;
/* 3651 */         Object localObject7 = this.pressedpart;
/* 3652 */         this.mousepressed = (this.pressedpart = null);
/* 3653 */         handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 502, localObject1, localObject7);
/*      */ 
/* 3656 */         if ((this.mouseinside == null) || ((localObject1 == this.mouseinside) && (localObject7 == this.insidepart))) break label815; 
/*      */       }
/* 3658 */       handleMouseEvent(j, paramAWTEvent, m, bool2, bool3, bool1, 504, this.mouseinside, this.insidepart);
/*      */ 
/* 3663 */       label815: return;
/*      */     }
/*      */     else
/*      */     {
/*      */       Object localObject2;
/* 3663 */       if (localObject1 == MOUSE_WHEEL)
/*      */       {
/* 3665 */         if ((
/* 3665 */           localObject2 = getRectangle(this.mouseinside, ":port")) != null)
/*      */         {
/* 3667 */           Rectangle localRectangle = getRectangle(this.mouseinside, "bounds");
/*      */           try
/*      */           {
/* 3670 */             if (wheelrotation == null) {
/* 3671 */               wheelrotation = paramAWTEvent.getClass().getMethod("getWheelRotation", new Class[] { null });
/*      */             }
/*      */ 
/* 3675 */             paramAWTEvent = ((Integer)wheelrotation.invoke(paramAWTEvent, new Object[] { null })).intValue();
/*      */ 
/* 3679 */             if (((Rectangle)localObject2).x + ((Rectangle)localObject2).width < localRectangle.width)
/*      */             {
/* 3681 */               processScroll(this.mouseinside, paramAWTEvent > 0 ? "down" : "up");
/*      */             }
/* 3686 */             else if (((Rectangle)localObject2).y + ((Rectangle)localObject2).height < localRectangle.height)
/*      */             {
/* 3689 */               processScroll(this.mouseinside, paramAWTEvent > 0 ? "right" : "left");
/*      */             }
/*      */           }
/*      */           catch (Exception localException1) {
/*      */           }
/*      */         }
/*      */         else {
/* 3696 */           return;
/*      */         } } else if ((localObject1 == 401) || (localObject1 == 400)) {
/* 3697 */         if ((this.focusinside) && ((this.popupowner != null) || (this.focusowner != null))) {
/* 3698 */           hideTip();
/*      */           int k;
/* 3704 */           m = (
/* 3704 */             paramAWTEvent = ((
/* 3701 */             k = (
/* 3700 */             localObject2 = (KeyEvent)paramAWTEvent)
/* 3700 */             .getKeyChar()) <= 
/* 3701 */             '\037') || ((k >= 127) && (k <= 159)) || (k >= 65535) || (((KeyEvent)localObject2).isControlDown()) ? 1 : 0) != 0
/* 3704 */              ? ((KeyEvent)localObject2).getKeyCode() : 0;
/*      */ 
/* 3706 */           if (paramAWTEvent == (localObject1 == 401 ? 1 : 0)) { i3 = m; i2 = paramAWTEvent != 0 ? 0 : k; i1 = ((KeyEvent)localObject2).getModifiers(); boolean bool4 = ((KeyEvent)localObject2).isControlDown(); bool3 = ((KeyEvent)localObject2).isShiftDown(); Object localObject3 = this.popupowner != null ? this.popupowner : this.focusowner; paramAWTEvent = this; String str2 = getClass(localObject3); if ((i2 == 32) || ((i3 == 10) && ("default".equals(get(localObject3, "type")))) || ((i3 == 27) && ("cancel".equals(get(localObject3, "type"))))) { paramAWTEvent.invoke(localObject3, null, "action"); paramAWTEvent.repaint(localObject3); if (i2 == 32) { paramAWTEvent.changeCheck(localObject3, true); paramAWTEvent.repaint(localObject3);
/*      */                 boolean bool5;
/* 3706 */                 setInteger(localObject3, "selected", -1, -1); if ((i2 == 32) || (i3 == 40)) { paramAWTEvent.popupCombo(localObject3);
/*      */                 }
/*      */                 else
/*      */                 {
/* 3706 */                   Object localObject13;
/* 3706 */                   if ((i3 == 38) || (i3 == 40) || (i3 == 33) || (i3 == 34) || (i3 == 36) || (i3 == 35)) { if ((localObject13 = paramAWTEvent.getListItem(localObject3, localObject11, i3, get(localObject11, ":lead"), false)) != null) paramAWTEvent.setInside(localObject11, localObject13, true); 
/* 3706 */                   } else if ((i3 == 10) || (i2 == 32)) paramAWTEvent.closeCombo(localObject3, localObject11, get(localObject11, ":lead")); else if (i3 == 27) paramAWTEvent.closeCombo(localObject3, localObject11, null); else if ((localObject13 = paramAWTEvent.findText((char)i2, localObject3, localObject11, false)) != null) paramAWTEvent.setInside(localObject11, localObject13, true); 
/* 3706 */                 }Object localObject11 = (char[])get(localObject3, ":text"); int i7 = getInteger(localObject3, "start", 0); String str4 = getInteger(localObject3, "end", 0); int i9 = i7; str2 = str4; for ((i3 != 36) || (bool4); (str2 > 0) && (localObject11[(str2 - 1)] != '\n'); str2--);
/*      */                 int i11;
/*      */                 Object localObject8;
/*      */                 int i4;
/* 3706 */                 if (!bool3) { int i10 = str2; break label2019; for ((i3 != 35) || (bool4); (str2 < localObject11.length) && (localObject11[str2] != '\n'); str2++);
/* 3706 */                   i11 = str2; break label2019; localObject8 = (Font)get(localObject3, "font"); i1 = (localObject8 = paramAWTEvent.getFontMetrics(localObject8 != null ? localObject8 : paramAWTEvent._font)).getHeight(); i2 = 0; i4 = 0; for (int i13 = 0; i13 < str4; i13++) { if ((localObject11[i13] != '\n') && (localObject11[i13] != '\t')) continue; i4 = i13 + 1; i2 += i1; } if (i3 == 38) { i2 -= i1; } else { i14 = getRectangle(localObject3, ":port").height; i2 += (i3 == 33 ? -i14 : i3 == 40 ? i1 : i14); } int i14 = ((FontMetrics)localObject8).charsWidth(localObject11, i4, str4 - i4); i4 = paramAWTEvent.getCaretLocation(localObject3, i14, i2, true, false); if (!bool3) i11 = i4;
/*      */                 }
/* 3706 */                 String str1;
/* 3706 */                 if ("tabbedpane".equals(i4)) { if ((i3 == 39) || (i3 == 40) || (i3 == 37) || (i3 == 38)) { String str3 = getInteger(localObject3, "selected", 0); i7 = (i3 == 39) || (i3 == 40) ? 1 : 0; str4 = str3; int i12 = i7 != 0 ? getItemCountImpl(localObject3, ":comp") : 0; i4 = i7 != 0 ? 1 : -1; for (str1 = str3 + i4; i7 != 0 ? str1 < i12 : str1 >= 0; str1 += i4) { if (!getBoolean(paramAWTEvent.getItem(localObject3, str1), "enabled", true)) continue; str4 = str1; break; } if (str4 != str3) { setInteger(localObject3, "selected", str4, 0); paramAWTEvent.checkOffset(localObject3); paramAWTEvent.repaint(localObject3); paramAWTEvent.invoke(localObject3, paramAWTEvent.getItem(localObject3, str4), "action"); }  } } else {
/* 3706 */                   paramAWTEvent.processSpin(localObject3, i3 == 38 ? "up" : "down");
/*      */                   int i6;
/* 3706 */                   if ("slider".equals(i4)) { i6 = getInteger(localObject3, "value", 0); i7 = 0; if ((i3 == 36) || (i3 == 37) || (i3 == 38) || (i3 == 33)) { i7 = getInteger(localObject3, "minimum", 0) - i6; if ((i3 == 37) || (i3 == 38)) i7 = Math.max(i7, -getInteger(localObject3, "unit", 5)); else if (i3 == 33) i7 = Math.max(i7, -getInteger(localObject3, "block", 25)); 
/* 3706 */                     } else if ((i3 == 35) || (i3 == 39) || (i3 == 40) || (i3 == 34)) { i7 = getInteger(localObject3, "maximum", 100) - i6; if ((i3 == 39) || (i3 == 40)) i7 = Math.min(i7, getInteger(localObject3, "unit", 5)); else if (i3 == 34) i7 = Math.min(i7, getInteger(localObject3, "block", 25));  }
/* 3706 */                     if (i7 != 0) { setInteger(localObject3, "value", i6 + i7, 0); paramAWTEvent.repaint(localObject3); paramAWTEvent.invoke(localObject3, null, "action");
/*      */                     }
/*      */                   }
/*      */                   else
/*      */                   {
/* 3706 */                     Object localObject16;
/*      */                     int i5;
/* 3706 */                     if ("splitpane".equals(i4)) { i6 = getInteger(localObject3, "divider", -1); i7 = 0; if (i3 == 36) { i7 = -i6; } else if ((i3 == 37) || (i3 == 38)) { i7 = Math.max(-10, -i6); } else if ((i3 == 35) || (i3 == 39) || (i3 == 40)) { int i8 = !"vertical".equals(get(localObject3, "orientation")) ? 1 : 0; localObject16 = getRectangle(localObject3, "bounds"); i7 = (i5 = (i8 != 0 ? ((Rectangle)localObject16).width : ((Rectangle)localObject16).height) - 5) - i6; if (i3 != 35) i7 = Math.min(i7, 10);  }
/* 3706 */                       if (i7 != 0) { setInteger(localObject3, "divider", i6 + i7, -1); paramAWTEvent.validate(localObject3); }  } else {
/* 3706 */                       if (i3 == 37) { setBoolean(localObject12, "expanded", false, true); paramAWTEvent.selectItem(localObject3, localObject12, true); paramAWTEvent.validate(localObject3); paramAWTEvent.invoke(localObject3, localObject12, "collapse"); paramAWTEvent.selectItem(localObject3, localObject14, true); paramAWTEvent.setLead(localObject3, localObject12, localObject14); } else if (getBoolean(localObject12, "expanded", true)) { paramAWTEvent.selectItem(localObject3, localObject14, true); paramAWTEvent.setLead(localObject3, localObject12, localObject14); } else { setBoolean(localObject12, "expanded", true, true); paramAWTEvent.selectItem(localObject3, localObject12, true); paramAWTEvent.validate(localObject3); paramAWTEvent.invoke(localObject3, localObject12, "expand"); } Object localObject12 = null; Object localObject14 = null; for (Object localObject15 = get(localObject3, ":popup"); localObject15 != null; localObject15 = get(localObject15, ":popup")) { localObject12 = localObject14; localObject14 = localObject15; } localObject16 = ((localObject15 = get(localObject14, "selected")) != null) || (localObject12 == null) ? localObject14 : localObject12; if ((localObject15 == null) && (localObject12 != null)) localObject15 = get(localObject12, "selected");
/* 3706 */                       Object localObject10;
/* 3706 */                       if ((i3 == 38) || (i3 == 40)) { if ((localObject10 = paramAWTEvent.getMenu(localObject16, localObject15, i3 == 40, true)) != null) { set(localObject16, "selected", null); paramAWTEvent.popupMenu(localObject16); set(localObject16, "selected", localObject10); paramAWTEvent.repaint(localObject16); } } else if (i3 == 37) { if (localObject12 != null) { localObject15 = get(localObject12, "selected"); set(localObject12, "selected", null); paramAWTEvent.popupMenu(localObject12); set(localObject12, "selected", localObject15); paramAWTEvent.repaint(localObject12); } else if ("menubar".equals(localObject10)) { if ((localObject10 = paramAWTEvent.getMenu(localObject3, get(localObject3, "selected"), false, false)) != null) { set(localObject3, "selected", localObject10); set(localObject6 = paramAWTEvent.popupMenu(localObject3), "selected", paramAWTEvent.getMenu(localObject6, null, true, true)); paramAWTEvent.repaint(localObject3); } } } else if (i3 == 39) { if ((localObject12 != null) && (localObject15 == null)) { set(localObject14, "selected", get(get(localObject14, "menu"), ":comp")); paramAWTEvent.repaint(localObject14); } else if ((localObject15 != null) && ("menu".equals(getClass(localObject15)))) { set(localObject10 = paramAWTEvent.popupMenu(localObject14), "selected", paramAWTEvent.getMenu(localObject10, null, true, true)); } else if ((localObject10 = paramAWTEvent.getMenu(localObject3, get(localObject3, "selected"), true, false)) != null) { set(localObject3, "selected", localObject10); set(localObject6 = paramAWTEvent.popupMenu(localObject3), "selected", paramAWTEvent.getMenu(localObject6, null, true, true)); paramAWTEvent.repaint(localObject3); } } else if ((i3 == 10) || (i2 == 32) || (i3 == 27)) { if ((i3 != 27) && (getBoolean(localObject15, "enabled", true))) if ((localObject15 != null) && ("checkboxmenuitem".equals(getClass(localObject15)))) paramAWTEvent.changeCheck(localObject15, false); else paramAWTEvent.invoke(localObject15, null, "action"); 
/* 3706 */                         paramAWTEvent.closeup(); } 
/*      */                     }
/*      */                   }
/*      */                 } } }
/* 3706 */             if ((("menubar".equals(i5)) || ("popupmenu".equals(i5)) ? 1 : "menubar".equals(localObject10) ? 0 : "tree".equals(i5) ? paramAWTEvent.processList(localObject3, str1, localObject8, i2, i3, true) : (i3 == 39) && ((localObject14 = get(localObject12 = get(localObject3, ":lead"), ":comp")) != null) ? 1 : (localObject14 = paramAWTEvent.getParent(localObject12)) != localObject3 ? 1 : (get(localObject12 = get(localObject3, ":lead"), ":comp") != null) && (getBoolean(localObject12, "expanded", true)) ? 1 : ("list".equals(i5)) || ("table".equals(i5)) ? paramAWTEvent.processList(localObject3, str1, localObject8, i2, i3, false) : "spinbox".equals(i4) ? paramAWTEvent.processField(localObject3, str1, localObject8, i1, i2, i3, false, false, true) : (i3 == 38) || (i3 == 40) ? 1 : "textarea".equals(str2) ? paramAWTEvent.changeField(localObject3, getString(localObject3, "text", ""), null, i11, i4, i7, str4) : !bool3 ? (i3 == 38) || (i3 == 33) || (i3 == 40) || (i3 == 34) ? i2 : paramAWTEvent.processField(localObject3, bool3, localObject8, i1, i2, i3, true, false, false) : ("textfield".equals(str2)) || ("passwordfield".equals(str2)) ? paramAWTEvent.processField(localObject3, bool3, bool4, i1, i2, i3, false, "passwordfield".equals(str2), false) : "combobox".equals(str2) ? 1 : !paramAWTEvent.processField(localObject3, bool3, bool4, i1, i2, i3, false, false, false) ? 0 : (localObject11 = get(localObject3, ":combolist")) == null ? 0 : ((bool5 = getBoolean(localObject3, "editable", true))) && (paramAWTEvent.processField(localObject3, bool3, bool4, i1, i2, i3, false, false, false)) ? 1 : ("checkbox".equals(str2)) || ("togglebutton".equals(str2)) ? 1 : "button".equals(str2) ? 1 : 0) != 0)
/*      */             {
/* 3711 */               ((KeyEvent)localObject2).consume(); return;
/*      */             }
/*      */           }
/*      */           label2019: Object localObject6;
/*      */           Object localObject5;
/* 3712 */           if ((m == 9) || ((m == 117) && ((((KeyEvent)localObject2).isAltDown()) || (((KeyEvent)localObject2).isControlDown()))))
/*      */           {
/* 3715 */             Object localObject4 = m == 117 ? 1 : 0;
/* 3716 */             if (!((KeyEvent)localObject2).isShiftDown()) { if (!setNextFocusable(this.focusowner, localObject4)) break label3793;  } else { localObject6 = localObject4; localObject5 = this.focusowner; paramAWTEvent = this; for (int n = 0; n < 2; n++)
/*      */               {
/* 3716 */                 Object localObject9;
/* 3716 */                 paramAWTEvent.setFocus(localObject9); } if (((localObject9 = paramAWTEvent.getPreviousFocusable(localObject5, null, true, false, n == 0, localObject6)) != null ? 0 : n == 0 ? 1 : 0) == 0) break label3793; }
/* 3718 */             ((KeyEvent)localObject2).consume(); break label3847;
/* 3719 */             label3793: if (MOUSE_WHEEL != 0) {
/* 3720 */               if (!((KeyEvent)localObject2).isShiftDown())
/* 3721 */                 transferFocus();
/*      */               else {
/*      */                 try {
/* 3724 */                   getClass().getMethod("transferFocusBackward", new Class[] { null }).invoke(this, new Object[] { null });
/*      */                 }
/*      */                 catch (Exception localException2)
/*      */                 {
/*      */                 }
/*      */               }
/*      */             }
/*      */ 
/* 3732 */             label3847: repaint(this.focusowner);
/* 3733 */             closeup();
/* 3734 */           } else if (m == 119) {
/* 3735 */             for (localObject5 = this.focusowner; localObject5 != null; localObject5 = getParent(localObject5))
/*      */             {
/* 3737 */               if (!"splitpane".equals(getClass(localObject5)))
/*      */                 continue;
/* 3739 */               setFocus(localObject5);
/* 3740 */               repaint(localObject5);
/* 3741 */               ((KeyEvent)localObject2).consume();
/* 3742 */               break label3971;
/*      */             }
/*      */           } else {
/* 3745 */             if ((localObject1 == 401) && ((k != 0) || (((KeyEvent)localObject2).isActionKey())) && (checkMnemonic(this.focusowner, true, null, ((KeyEvent)localObject2).getKeyCode(), ((KeyEvent)localObject2).getModifiers())))
/*      */             {
/* 3749 */               ((KeyEvent)localObject2).consume();
/*      */             }
/* 3751 */             label3971: return;
/*      */           }
/*      */         } } else {
/* 3752 */         if (localObject1 == 1005) {
/* 3753 */           this.focusinside = false;
/* 3754 */           if (this.focusowner != null) {
/* 3755 */             repaint(this.focusowner);
/*      */           }
/* 3757 */           closeup(); return;
/* 3758 */         }if (localObject1 == 1004) {
/* 3759 */           this.focusinside = true;
/* 3760 */           if (this.focusowner == null) {
/* 3761 */             setFocus(this.content); return;
/*      */           }
/* 3763 */           repaint(this.focusowner); return;
/*      */         }
/* 3765 */         if ((localObject1 == 101) || (localObject1 == 102))
/*      */         {
/* 3767 */           localObject2 = getSize();
/* 3768 */           setRectangle(this.content, "bounds", 0, 0, ((Dimension)localObject2).width, ((Dimension)localObject2).height);
/* 3769 */           validate(this.content);
/* 3770 */           closeup();
/* 3771 */           if (!this.focusinside)
/* 3772 */             requestFocus();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void checkLocation(Object paramObject)
/*      */   {
/* 3782 */     if (this.mouseinside == paramObject) {
/* 3783 */       findComponent(this.content, this.mousex, this.mousey);
/* 3784 */       handleMouseEvent(this.mousex, this.mousex, 1, false, false, false, 504, this.mouseinside, this.insidepart);
/*      */     }
/*      */   }
/*      */ 
/*      */   private boolean changeCheck(Object paramObject, boolean paramBoolean)
/*      */   {
/*      */     String str;
/* 4173 */     if ((
/* 4173 */       str = getString(paramObject, "group", null)) != null)
/*      */     {
/* 4174 */       if (getBoolean(paramObject, "selected", false)) {
/* 4175 */         return false;
/*      */       }
/* 4177 */       for (Object localObject = get(getParent(paramObject), ":comp"); localObject != null; localObject = get(localObject, ":next"))
/*      */       {
/* 4179 */         if (localObject == paramObject) {
/* 4180 */           setBoolean(paramObject, "selected", true); } else {
/* 4181 */           if ((!str.equals(get(localObject, "group"))) || (!getBoolean(localObject, "selected", false)))
/*      */             continue;
/* 4183 */           setBoolean(localObject, "selected", false);
/* 4184 */           if (paramBoolean)
/* 4185 */             repaint(localObject);
/*      */         }
/*      */       }
/*      */     }
/*      */     else {
/* 4190 */       setBoolean(paramObject, "selected", !getBoolean(paramObject, "selected", false), false);
/*      */     }
/*      */ 
/* 4193 */     invoke(paramObject, null, "action");
/* 4194 */     return true;
/*      */   }
/*      */ 
/*      */   private Object getMenu(Object paramObject1, Object paramObject2, boolean paramBoolean1, boolean paramBoolean2)
/*      */   {
/* 4211 */     this = null;
/*      */     Object localObject;
/* 4212 */     for (int i = 0; i < 2; i++) {
/* 4213 */       localObject = i == 0 ? get(paramObject2, ":next") : get(paramBoolean2 ? get(paramObject1, "menu") : paramObject1, ":comp");
/*      */ 
/* 4218 */       if (("separator".equals(getClass(localObject))) || (!getBoolean(localObject, "enabled", true)))
/*      */         continue;
/* 4220 */       if (paramBoolean1) {
/* 4221 */         return localObject;
/*      */       }
/* 4223 */       this = localObject;
/*      */     }
/*      */ 
/* 4227 */     return this;
/*      */   }
/*      */ 
/*      */   private boolean processField(Object paramObject, boolean paramBoolean1, boolean paramBoolean2, int paramInt1, int paramInt2, int paramInt3, boolean paramBoolean3, boolean paramBoolean4, boolean paramBoolean5)
/*      */   {
/* 4246 */     String str1 = getString(paramObject, "text", "");
/* 4247 */     int i = getInteger(paramObject, "start", 0);
/* 4248 */     int j = getInteger(paramObject, "end", 0);
/* 4249 */     boolean bool = getBoolean(paramObject, "editable", true);
/*      */ 
/* 4251 */     int k = i;
/* 4252 */     int m = j;
/* 4253 */     String str2 = null;
/* 4254 */     if ((bool) && (paramInt2 != 0) && (paramInt1 != 8))
/*      */     {
/* 4257 */       str2 = String.valueOf((char)paramInt2);
/* 4258 */     } else if ((bool) && (paramInt3 == 10)) {
/* 4259 */       if (paramBoolean3)
/* 4260 */         str2 = "\n";
/*      */       else
/* 4262 */         return invoke(paramObject, null, "perform");
/*      */     }
/* 4264 */     else if ((bool) && (paramInt3 == 8)) {
/* 4265 */       str2 = "";
/* 4266 */       if (i == j)
/* 4267 */         k--;
/*      */     }
/* 4269 */     else if (paramInt3 == 35) {
/* 4270 */       m = str1.length();
/* 4271 */       if (!paramBoolean1)
/* 4272 */         k = m;
/*      */     }
/* 4274 */     else if (paramInt3 == 36) {
/* 4275 */       m = 0;
/* 4276 */       if (!paramBoolean1)
/* 4277 */         k = 0;
/*      */     }
/* 4279 */     else if (paramInt3 == 37) {
/* 4280 */       if (paramBoolean2)
/* 4281 */         for (paramBoolean2 = false; paramBoolean2 < true; paramBoolean2++)
/*      */         {
/* 4283 */           while (m > 0) { if ((paramBoolean2) != Character.isLetterOrDigit(str1.charAt(m - 1)))
/*      */               break;
/* 4285 */             m--;
/*      */           }
/*      */         }
/*      */       else {
/* 4289 */         m--;
/*      */       }
/* 4291 */       if (!paramBoolean1)
/* 4292 */         k = m;
/*      */     }
/* 4294 */     else if (paramInt3 == 39) {
/* 4295 */       if (paramBoolean2)
/* 4296 */         for (paramBoolean2 = false; paramBoolean2 < true; paramBoolean2++)
/*      */         {
/* 4298 */           while (m < str1.length()) { if ((!paramBoolean2) != Character.isLetterOrDigit(str1.charAt(m)))
/*      */               break;
/* 4300 */             m++;
/*      */           }
/*      */         }
/*      */       else {
/* 4304 */         m++;
/*      */       }
/* 4306 */       if (!paramBoolean1)
/* 4307 */         k = m;
/*      */     }
/* 4309 */     else if ((bool) && (paramInt3 == 127)) {
/* 4310 */       str2 = "";
/* 4311 */       if (i == j)
/* 4312 */         m++;
/*      */     }
/* 4314 */     else if ((paramBoolean2) && ((paramInt3 == 65) || (paramInt3 == 191)))
/*      */     {
/* 4316 */       k = 0;
/* 4317 */       m = str1.length();
/* 4318 */     } else if ((paramBoolean2) && (paramInt3 == 220)) {
/* 4319 */       k = m = str1.length();
/* 4320 */     } else if (((bool) && (!paramBoolean4) && (paramBoolean2) && (paramInt3 == 88)) || ((!paramBoolean4) && (paramBoolean2) && (paramInt3 == 67)))
/*      */     {
/* 4323 */       if (i != j) {
/* 4324 */         this._clipboard = str1.substring(Math.min(i, j), Math.max(i, j));
/*      */         try
/*      */         {
/* 4328 */           getToolkit().getSystemClipboard().setContents(new StringSelection(this._clipboard), null);
/*      */         }
/*      */         catch (Exception paramBoolean2) {
/* 4331 */           System.err.println(paramBoolean2.getLocalizedMessage());
/*      */         }
/* 4333 */         if (paramInt3 == 88)
/* 4334 */           str2 = "";
/*      */         else
/* 4336 */           return true;
/*      */       }
/*      */     }
/* 4339 */     else if ((bool) && (paramBoolean2) && (paramInt3 == 86)) {
/*      */       try {
/* 4341 */         str2 = (String)getToolkit().getSystemClipboard().getContents(this).getTransferData(DataFlavor.stringFlavor);
/*      */       }
/*      */       catch (Exception localException)
/*      */       {
/* 4346 */         str2 = this._clipboard;
/*      */       }
/* 4348 */       if (str2 != null)
/*      */       {
/* 4350 */         str2 = filter(str2, paramBoolean3);
/*      */       }
/*      */     }
/* 4353 */     if ((paramBoolean5) && (str2 != null)) {
/* 4354 */       for (paramBoolean2 = str2.length() - 1; !paramBoolean2; paramBoolean2--) {
/* 4355 */         if (!Character.isDigit(str2.charAt(paramBoolean2))) {
/* 4356 */           return false;
/*      */         }
/*      */       }
/*      */     }
/* 4360 */     return changeField(paramObject, str1, str2, k, m, i, j);
/*      */   }
/*      */ 
/*      */   private static String filter(String paramString, boolean paramBoolean)
/*      */   {
/* 4370 */     StringBuffer localStringBuffer = new StringBuffer(paramString.length());
/* 4371 */     for (int i = 0; i < paramString.length(); i++)
/*      */     {
/*      */       int j;
/* 4373 */       if ((((
/* 4373 */         j = paramString.charAt(i)) <= 
/* 4373 */         '\037') || (j >= 127)) && ((j <= 159) || (j >= 65535)) && ((!paramBoolean) || (j != 10)))
/*      */         continue;
/* 4375 */       localStringBuffer.append(j);
/*      */     }
/*      */ 
/* 4378 */     if (localStringBuffer.length() != paramString.length()) return localStringBuffer.toString(); return paramString;
/*      */   }
/*      */ 
/*      */   private boolean changeField(Object paramObject, String paramString1, String paramString2, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 4402 */     paramInt1 = Math.max(0, Math.min(paramInt1, paramString1.length()));
/* 4403 */     paramInt2 = Math.max(0, Math.min(paramInt2, paramString1.length()));
/* 4404 */     if ((paramString2 == null) && (paramInt3 == paramInt1) && (paramInt4 == paramInt2)) {
/* 4405 */       return false;
/*      */     }
/* 4407 */     if (paramString2 != null) {
/* 4408 */       int i = Math.min(paramInt1, paramInt2);
/* 4409 */       set(paramObject, "text", paramString1.substring(0, i) + paramString2 + paramString1.substring(Math.max(paramInt1, paramInt2)));
/*      */ 
/* 4411 */       paramInt1 = paramInt2 = i + paramString2.length();
/* 4412 */       invoke(paramObject, null, "action");
/*      */     }
/* 4414 */     if (paramInt3 != paramInt1) {
/* 4415 */       setInteger(paramObject, "start", paramInt1, 0);
/*      */     }
/* 4417 */     if (paramInt4 != paramInt2) {
/* 4418 */       setInteger(paramObject, "end", paramInt2, 0);
/*      */     }
/* 4420 */     validate(paramObject);
/* 4421 */     invoke(paramObject, null, paramString2 != null ? "remove" : paramString2.length() > 0 ? "insert" : "caret");
/*      */ 
/* 4424 */     return true;
/*      */   }
/*      */ 
/*      */   private boolean processList(Object paramObject, boolean paramBoolean1, boolean paramBoolean2, int paramInt1, int paramInt2, boolean paramBoolean3)
/*      */   {
/* 4430 */     if ((paramInt2 == 38) || (paramInt2 == 40) || (paramInt2 == 33) || (paramInt2 == 34) || (paramInt2 == 36) || (paramInt2 == 35))
/*      */     {
/* 4435 */       paramInt1 = get(paramObject, ":lead");
/*      */ 
/* 4438 */       if ((
/* 4438 */         paramInt2 = getListItem(paramObject, paramObject, paramInt2, paramInt1, paramBoolean3)) != null)
/*      */       {
/* 4439 */         String str = getString(paramObject, "selection", "single");
/*      */ 
/* 4441 */         if ((paramBoolean1) && (!"single".equals(str)) && (paramInt1 != null))
/*      */         {
/* 4443 */           extend(paramObject, paramInt1, paramInt2, paramBoolean3);
/* 4444 */         } else if (!paramBoolean2) {
/* 4445 */           selectItem(paramObject, paramInt2, paramBoolean3);
/*      */         }
/* 4447 */         setLead(paramObject, paramInt1, paramInt2);
/* 4448 */         return true;
/*      */       }
/*      */     } else {
/* 4450 */       if (paramInt2 == 37)
/* 4451 */         return processScroll(paramObject, "left");
/* 4452 */       if (paramInt2 == 39)
/* 4453 */         return processScroll(paramObject, "right");
/* 4454 */       if (paramInt1 == 32) {
/* 4455 */         select(paramObject, get(paramObject, ":lead"), paramBoolean3, paramBoolean1, paramBoolean2);
/*      */ 
/* 4457 */         return true;
/* 4458 */       }if (paramBoolean2) {
/* 4459 */         if (((paramInt2 == 65) || (paramInt2 == 191)) && (!"single".equals(getString(paramObject, "selection", "single"))))
/*      */         {
/* 4464 */           selectAll(paramObject, true, paramBoolean3);
/* 4465 */           return true;
/* 4466 */         }if (paramInt2 == 220)
/*      */         {
/* 4468 */           selectAll(paramObject, false, paramBoolean3);
/* 4469 */           return true;
/*      */         }
/*      */ 
/*      */       }
/* 4474 */       else if ((
/* 4474 */         paramInt1 = findText((char)paramInt1, paramObject, paramObject, paramBoolean3)) != null)
/*      */       {
/* 4475 */         select(paramObject, paramInt1, paramBoolean3, false, false);
/* 4476 */         return true;
/*      */       }
/*      */     }
/* 4479 */     return false;
/*      */   }
/*      */ 
/*      */   private Object findText(char paramChar, Object paramObject1, Object paramObject2, boolean paramBoolean)
/*      */   {
/* 4498 */     if (paramChar != 0)
/*      */     {
/*      */       long l;
/* 4500 */       int j = (
/* 4500 */         l = System.currentTimeMillis()) > 
/* 4500 */         this.findtime + 1000L ? 1 : 0;
/*      */ 
/* 4503 */       this.findtime = l;
/* 4504 */       paramObject2 = get(paramObject2, ":lead");
/* 4505 */       for (; j < 2; j++)
/*      */       {
/* 4507 */         this.findprefix = (j == 0 ? this.findprefix + paramChar : String.valueOf(paramChar));
/*      */         Object localObject;
/* 4510 */         for (int i = 0; i < 2; i++)
/*      */         {
/* 4512 */           localObject = i == 0 ? getNextItem(paramObject1, paramObject2, paramBoolean) : j == 0 ? paramObject2 : get(paramObject1, ":comp");
/*      */ 
/* 4517 */           if (getString(localObject, "text", "").regionMatches(true, 0, this.findprefix, 0, this.findprefix.length()))
/*      */           {
/* 4522 */             return localObject;
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */ 
/* 4528 */     return null;
/*      */   }
/*      */ 
/*      */   private Object getListItem(Object paramObject1, Object paramObject2, int paramInt, Object paramObject3, boolean paramBoolean)
/*      */   {
/* 4534 */     Object localObject1 = null;
/*      */     Object localObject2;
/* 4535 */     if (paramInt == 38) {
/* 4536 */       for (localObject2 = get(paramObject1, ":comp"); localObject2 != paramObject3; localObject2 = getNextItem(paramObject1, localObject2, paramBoolean))
/*      */       {
/* 4538 */         localObject1 = localObject2;
/*      */       }
/* 4540 */     } else if (paramInt == 40) {
/* 4541 */       localObject1 = paramObject3 == null ? get(paramObject1, ":comp") : getNextItem(paramObject1, paramObject3, paramBoolean);
/*      */     }
/*      */     else
/*      */     {
/*      */       int i;
/* 4544 */       if ((paramInt == 33) || (paramInt == 34))
/*      */       {
/* 4546 */         localObject2 = getRectangle(paramObject2, ":view");
/* 4547 */         paramObject2 = getRectangle(paramObject2, ":port");
/* 4548 */         paramObject3 = paramObject3 != null ? getRectangle(paramObject3, "bounds") : null;
/*      */ 
/* 4550 */         i = paramInt == 33 ? ((Rectangle)localObject2).y : ((Rectangle)localObject2).y + paramObject2.height;
/*      */ 
/* 4553 */         if ((paramInt == 33) && (paramObject3 != null) && (paramObject3.y <= ((Rectangle)localObject2).y))
/*      */         {
/* 4555 */           i -= paramObject2.height;
/*      */         }
/* 4557 */         if ((paramInt == 34) && (paramObject3 != null) && (paramObject3.y + paramObject3.height >= ((Rectangle)localObject2).y + paramObject2.height))
/*      */         {
/* 4559 */           i += paramObject2.height;
/*      */         }
/* 4561 */         paramObject2 = get(paramObject1, ":comp"); } while (true) { if (paramObject2 != null)
/*      */         {
/* 4563 */           paramObject3 = getRectangle(paramObject2, "bounds");
/* 4564 */           if (paramInt == 33) {
/* 4565 */             localObject1 = paramObject2;
/* 4566 */             if (paramObject3.y + paramObject3.height > i)
/* 4567 */               break;
/*      */           }
/*      */           else {
/* 4570 */             if (paramObject3.y > i) break label299; localObject1 = paramObject2;
/*      */           }
/* 4561 */           paramObject2 = getNextItem(paramObject1, paramObject2, paramBoolean); continue;
/*      */         }
/*      */ 
/* 4576 */         label299: break; if (paramInt == 36) {
/* 4577 */           localObject1 = get(paramObject1, ":comp"); } else {
/* 4578 */           if (paramInt != 35) break;
/* 4579 */           for (localObject2 = paramObject3; localObject2 != null; localObject2 = getNextItem(paramObject1, localObject2, paramBoolean))
/*      */           {
/* 4581 */             localObject1 = localObject2;
/*      */           }
/*      */         } }
/*      */     }
/* 4584 */     return localObject1;
/*      */   }
/*      */ 
/*      */   private void selectAll(Object paramObject, boolean paramBoolean1, boolean paramBoolean2)
/*      */   {
/* 4599 */     int i = 0;
/* 4600 */     for (Object localObject = get(paramObject, ":comp"); localObject != null; localObject = getNextItem(paramObject, localObject, paramBoolean2))
/*      */     {
/* 4602 */       if (setBoolean(localObject, "selected", paramBoolean1, false)) {
/* 4603 */         repaint(paramObject, null, localObject);
/* 4604 */         i = 1;
/*      */       }
/*      */     }
/* 4607 */     set(paramObject, ":anchor", null);
/* 4608 */     if (i != 0)
/* 4609 */       invoke(paramObject, null, "action");
/*      */   }
/*      */ 
/*      */   private void selectItem(Object paramObject1, Object paramObject2, boolean paramBoolean)
/*      */   {
/* 4625 */     int i = 0;
/* 4626 */     for (Object localObject = get(paramObject1, ":comp"); localObject != null; localObject = getNextItem(paramObject1, localObject, paramBoolean))
/*      */     {
/* 4628 */       if (setBoolean(localObject, "selected", localObject == paramObject2, false)) {
/* 4629 */         repaint(paramObject1, null, localObject);
/* 4630 */         i = 1;
/*      */       }
/*      */     }
/* 4633 */     set(paramObject1, ":anchor", null);
/* 4634 */     if (i != 0)
/* 4635 */       invoke(paramObject1, paramObject2, "action");
/*      */   }
/*      */ 
/*      */   private void extend(Object paramObject1, Object paramObject2, Object paramObject3, boolean paramBoolean)
/*      */   {
/*      */     Object localObject1;
/* 4642 */     if ((
/* 4642 */       localObject1 = get(paramObject1, ":anchor")) == null)
/*      */     {
/* 4643 */       set(paramObject1, ":anchor", localObject1 = paramObject2);
/*      */     }
/* 4645 */     paramObject2 = 110;
/* 4646 */     int i = 0;
/* 4647 */     Object localObject2 = get(paramObject1, ":comp");
/* 4648 */     for (; localObject2 != null; localObject2 = getNextItem(paramObject1, localObject2, paramBoolean)) {
/* 4649 */       if (localObject2 == localObject1) {
/* 4650 */         paramObject2 = paramObject2 == 110 ? 121 : 114;
/*      */       }
/* 4652 */       if (localObject2 == paramObject3) {
/* 4653 */         paramObject2 = paramObject2 == 110 ? 121 : 114;
/*      */       }
/* 4655 */       if (setBoolean(localObject2, "selected", paramObject2 != 110, false))
/*      */       {
/* 4657 */         repaint(paramObject1, null, localObject2);
/* 4658 */         i = 1;
/*      */       }
/* 4660 */       if (paramObject2 == 114) {
/* 4661 */         paramObject2 = 110;
/*      */       }
/*      */     }
/* 4664 */     if (i != 0)
/* 4665 */       invoke(paramObject1, paramObject3, "action");
/*      */   }
/*      */ 
/*      */   private void setLead(Object paramObject1, Object paramObject2, Object paramObject3)
/*      */   {
/* 4681 */     if (paramObject2 != paramObject3) {
/* 4682 */       if (paramObject2 != null) {
/* 4683 */         repaint(paramObject1, null, paramObject2);
/*      */       }
/* 4685 */       set(paramObject1, ":lead", paramObject3);
/* 4686 */       repaint(paramObject1, null, paramObject3);
/*      */ 
/* 4688 */       paramObject2 = getRectangle(paramObject3, "bounds");
/* 4689 */       scrollToVisible(paramObject1, paramObject2.x, paramObject2.y, 0, paramObject2.height);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void setInside(Object paramObject1, Object paramObject2, boolean paramBoolean)
/*      */   {
/*      */     Object localObject;
/* 4706 */     if ((
/* 4706 */       localObject = get(paramObject1, ":lead")) != null)
/*      */     {
/* 4707 */       repaint(paramObject1, ":combolist", localObject);
/*      */     }
/* 4709 */     set(paramObject1, ":lead", paramObject2);
/* 4710 */     if (paramObject2 != null) {
/* 4711 */       repaint(paramObject1, ":combolist", paramObject2);
/* 4712 */       if (paramBoolean) {
/* 4713 */         paramObject2 = getRectangle(paramObject2, "bounds");
/* 4714 */         scrollToVisible(paramObject1, paramObject2.x, paramObject2.y, 0, paramObject2.height);
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void handleMouseEvent(int paramInt1, int paramInt2, int paramInt3, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, int paramInt4, Object paramObject1, Object paramObject2)
/*      */   {
/* 4729 */     if (paramInt4 == 504)
/* 4730 */       setTimer(750L);
/* 4731 */     else if (paramInt4 == 505) {
/* 4732 */       hideTip();
/*      */     }
/* 4734 */     if (!getBoolean(paramObject1, "enabled", true)) {
/* 4735 */       return;
/*      */     }
/* 4737 */     String str = getClass(paramObject1);
/*      */     Object localObject2;
/* 4738 */     if (("button".equals(str)) || ("checkbox".equals(str)) || ("togglebutton".equals(str)))
/*      */     {
/* 4741 */       if ((paramInt4 == 504) || (paramInt4 == 505) || (paramInt4 == 501) || (paramInt4 == 502))
/*      */       {
/* 4745 */         if (paramInt4 == 501) {
/* 4746 */           setFocus(paramObject1);
/*      */         }
/* 4748 */         if (("button".equals(str)) && ((this.mousepressed == null) || (this.mousepressed == paramObject1)) && ((paramInt4 == 504) || (paramInt4 == 505)) && ("link".equals(get(paramObject1, "type"))))
/*      */         {
/* 4752 */           setCursor(Cursor.getPredefinedCursor(paramInt4 == 504 ? 12 : 0));
/*      */         }
/* 4755 */         else if ((paramInt4 == 502) && (this.mouseinside == paramObject1))
/*      */         {
/* 4757 */           if (!"button".equals(str))
/* 4758 */             changeCheck(paramObject1, true);
/*      */           else {
/* 4760 */             invoke(paramObject1, null, "action");
/*      */           }
/*      */         }
/* 4763 */         repaint(paramObject1);
/*      */       }
/* 4765 */     } else if ("combobox".equals(str))
/*      */     {
/*      */       boolean bool;
/*      */       Object localObject3;
/* 4767 */       if (((
/* 4767 */         bool = getBoolean(paramObject1, "editable", true))) && 
/* 4767 */         (paramObject2 == null)) {
/* 4768 */         paramObject2 = (paramInt4 == 501) && ((localObject3 = getIcon(paramObject1, "icon", null)) != null) ? ((Image)localObject3).getWidth(this) : 0;
/*      */ 
/* 4774 */         processField(paramInt1, paramInt2, paramInt3, paramInt4, paramObject1, false, false, paramObject2, paramBoolean3);
/*      */       }
/* 4776 */       else if (!"icon".equals(paramObject2)) {
/* 4777 */         if (((paramInt4 == 504) || (paramInt4 == 505)) && (this.mousepressed == null))
/*      */         {
/* 4779 */           if (bool) {
/* 4780 */             repaint(paramObject1, "combobox", paramObject2); break label3330;
/*      */           }
/*      */ 
/* 4786 */           repaint(paramObject1); break label3330;
/*      */         }
/*      */ 
/* 4789 */         if (paramInt4 == 501)
/*      */         {
/* 4791 */           if ((
/* 4791 */             localObject3 = get(paramObject1, ":combolist")) == null)
/*      */           {
/* 4792 */             setFocus(paramObject1);
/* 4793 */             repaint(paramObject1);
/* 4794 */             popupCombo(paramObject1);
/*      */           } else {
/* 4796 */             closeCombo(paramObject1, localObject3, null);
/*      */ 
/* 4798 */             break label3330;
/*      */           } } else if (paramInt4 == 502) {
/* 4799 */           if (this.mouseinside != paramObject1) {
/* 4800 */             localObject3 = get(paramObject1, ":combolist");
/* 4801 */             closeCombo(paramObject1, localObject3, (this.mouseinside == localObject3) && ((this.insidepart instanceof Object[])) ? this.insidepart : null);
/*      */ 
/* 4807 */             break label3330;
/* 4808 */           }repaint(paramObject1);
/*      */         }
/*      */       }
/*      */     }
/* 4812 */     else if (":combolist".equals(str)) {
/* 4813 */       if (!processScroll(paramInt1, paramInt2, paramInt4, paramObject1, paramObject2)) {
/* 4814 */         if ((paramInt4 == 504) || (paramInt4 == 2000)) {
/* 4815 */           if (paramObject2 != null)
/* 4816 */             setInside(paramObject1, paramObject2, false);
/*      */         }
/* 4818 */         else if (paramInt4 == 502) {
/* 4819 */           closeCombo(get(paramObject1, "combobox"), paramObject1, paramObject2);
/*      */         }
/*      */       }
/*      */     }
/* 4823 */     else if (("textfield".equals(str)) || ("passwordfield".equals(str)))
/*      */     {
/* 4825 */       processField(paramInt1, paramInt2, paramInt3, paramInt4, paramObject1, false, "passwordfield".equals(str), 0, paramBoolean3);
/*      */     }
/* 4827 */     else if ("textarea".equals(str)) {
/* 4828 */       if (!processScroll(paramInt1, paramInt2, paramInt4, paramObject1, paramObject2)) {
/* 4829 */         processField(paramInt1, paramInt2, paramInt3, paramInt4, paramObject1, true, false, 0, paramBoolean3);
/*      */       }
/*      */     }
/* 4832 */     else if ("panel".equals(str)) {
/* 4833 */       processScroll(paramInt1, paramInt2, paramInt4, paramObject1, paramObject2);
/* 4834 */     } else if ("desktop".equals(str)) {
/* 4835 */       if ("modal".equals(paramObject2)) {
/* 4836 */         if (paramInt4 == 504) {
/* 4837 */           setCursor(Cursor.getPredefinedCursor(3));
/*      */         }
/* 4839 */         else if (paramInt4 == 505) {
/* 4840 */           setCursor(Cursor.getPredefinedCursor(0));
/*      */         }
/*      */       }
/*      */     }
/* 4844 */     else if ("spinbox".equals(str)) {
/* 4845 */       if (paramObject2 == null) {
/* 4846 */         processField(paramInt1, paramInt2, paramInt3, paramInt4, paramObject1, false, false, 0, paramBoolean3);
/*      */       }
/* 4849 */       else if ((paramInt4 == 504) || (paramInt4 == 505) || (paramInt4 == 501) || (paramInt4 == 502))
/*      */       {
/* 4853 */         if (paramInt4 == 501) {
/* 4854 */           setFocus(paramObject1);
/* 4855 */           if (processSpin(paramObject1, paramObject2)) {
/* 4856 */             setTimer(375L);
/*      */           }
/*      */ 
/*      */         }
/* 4860 */         else if (paramInt4 == 502) {
/* 4861 */           setTimer(0L);
/*      */         }
/*      */ 
/* 4864 */         repaint(paramObject1, str, paramObject2);
/*      */       }
/*      */     }
/*      */     else
/*      */     {
/*      */       Object localObject1;
/* 4867 */       if ("tabbedpane".equals(str)) {
/* 4868 */         if ((paramInt4 == 504) || (paramInt4 == 505))
/*      */         {
/* 4870 */           if ((paramObject2 != null) && (getBoolean(paramObject2, "enabled", true)) && (getInteger(paramObject1, "selected", 0) != getIndex(paramObject1, paramObject2)))
/*      */           {
/* 4874 */             repaint(paramObject1, "tabbedpane", paramObject2);
/*      */           }
/* 4876 */         } else if ((paramObject2 != null) && (paramInt4 == 501) && (getBoolean(paramObject2, "enabled", true)))
/*      */         {
/* 4878 */           localObject1 = getInteger(paramObject1, "selected", 0);
/*      */ 
/* 4880 */           Object localObject4 = getIndex(paramObject1, paramObject2);
/* 4881 */           if (localObject1 == localObject4) {
/* 4882 */             setFocus(paramObject1);
/* 4883 */             repaint(paramObject1, "tabbedpane", paramObject2);
/*      */           } else {
/* 4885 */             setInteger(paramObject1, "selected", localObject4, 0);
/*      */ 
/* 4888 */             setNextFocusable(paramObject1, false);
/* 4889 */             checkOffset(paramObject1);
/* 4890 */             repaint(paramObject1);
/* 4891 */             invoke(paramObject1, paramObject2, "action");
/*      */           }
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/*      */         Rectangle localRectangle;
/*      */         int m;
/* 4894 */         if ("slider".equals(str)) {
/* 4895 */           if ((paramInt4 == 501) || (paramInt4 == 506))
/*      */           {
/* 4897 */             if (paramInt4 == 501) {
/* 4898 */               setReference(paramObject1, this._block / 2, this._block / 2);
/* 4899 */               setFocus(paramObject1);
/*      */             }
/* 4901 */             localObject1 = getInteger(paramObject1, "minimum", 0);
/* 4902 */             Object localObject5 = getInteger(paramObject1, "maximum", 100);
/*      */ 
/* 4905 */             paramObject2 = getInteger(paramObject1, "value", 0);
/* 4906 */             localRectangle = getRectangle(paramObject1, "bounds");
/* 4907 */             m = !"vertical".equals(get(paramObject1, "orientation")) ? 1 : 0;
/*      */ 
/* 4910 */             paramInt3 = localObject1 + (m != 0 ? paramInt1 - this.referencex : paramInt2 - this.referencey) * (localObject5 - localObject1) / ((m != 0 ? localRectangle.width : localRectangle.height) - this._block);
/*      */ 
/* 4916 */             paramInt3 = Math.max(localObject1, Math.min(paramInt3, localObject5));
/* 4917 */             if (paramObject2 != paramInt3) {
/* 4918 */               setInteger(paramObject1, "value", paramInt3, 0);
/* 4919 */               invoke(paramObject1, null, "action");
/*      */             }
/* 4921 */             if ((paramObject2 != paramInt3) || (paramInt4 == 501))
/* 4922 */               repaint(paramObject1);
/*      */           }
/*      */         }
/*      */         else
/*      */         {
/*      */           int j;
/* 4925 */           if ("splitpane".equals(str)) {
/* 4926 */             if (paramInt4 == 501) {
/* 4927 */               setReference(paramObject1, 2, 2);
/* 4928 */             } else if (paramInt4 == 506) {
/* 4929 */               localObject1 = getInteger(paramObject1, "divider", -1);
/*      */ 
/* 4933 */               paramObject2 = (
/* 4933 */                 j = !"vertical".equals(get(paramObject1, "orientation")) ? 1 : 0) != 0
/* 4933 */                  ? paramInt1 - this.referencex : paramInt2 - this.referencey;
/* 4934 */               localRectangle = getRectangle(paramObject1, "bounds");
/* 4935 */               paramObject2 = Math.max(0, Math.min(paramObject2, Math.abs(j != 0 ? localRectangle.width : localRectangle.height) - 5));
/*      */ 
/* 4940 */               if (localObject1 != paramObject2) {
/* 4941 */                 setInteger(paramObject1, "divider", paramObject2, -1);
/* 4942 */                 validate(paramObject1);
/*      */               }
/* 4944 */             } else if ((paramInt4 == 504) && (this.mousepressed == null))
/*      */             {
/* 4946 */               int i = !"vertical".equals(get(paramObject1, "orientation")) ? 1 : 0;
/*      */ 
/* 4949 */               setCursor(Cursor.getPredefinedCursor(i != 0 ? 11 : 9));
/*      */             }
/* 4952 */             else if (((paramInt4 == 505) && (this.mousepressed == null)) || ((paramInt4 == 502) && (this.mouseinside != paramObject1)))
/*      */             {
/* 4955 */               setCursor(Cursor.getPredefinedCursor(0));
/*      */             }
/*      */           }
/* 4958 */           else if (("list".equals(str)) || ("table".equals(str)) || ("tree".equals(str)))
/*      */           {
/* 4960 */             if ((!processScroll(paramInt1, paramInt2, paramInt4, paramObject1, paramObject2)) && (
/* 4961 */               (paramInt4 == 501) || ((paramInt4 == 506) && (!paramBoolean1) && (!paramBoolean2))))
/*      */             {
/* 4965 */               localObject2 = getRectangle(paramObject1, ":port");
/* 4966 */               j = paramInt2 + ((Rectangle)localObject2).y - this.referencey;
/* 4967 */               paramObject2 = get(paramObject1, ":comp");
/*      */             } } else while (true) { if (paramObject2 != null) {
/* 4968 */                 localRectangle = getRectangle(paramObject2, "bounds");
/* 4969 */                 if (j < localRectangle.y + localRectangle.height) {
/* 4970 */                   if (paramInt4 == 506) {
/* 4971 */                     scrollToVisible(paramObject1, localRectangle.x, localRectangle.y, 0, localRectangle.height);
/*      */                   }
/* 4973 */                   else if ("tree".equals(str))
/*      */                   {
/* 4975 */                     if ((
/* 4975 */                       m = paramInt1 + ((Rectangle)localObject2).x - this.referencex) < 
/* 4975 */                       localRectangle.x) {
/* 4976 */                       if ((m < localRectangle.x - this._block) || (get(paramObject2, ":comp") == null)) break label2038;
/* 4978 */                       paramInt3 = getBoolean(paramObject2, "expanded", true);
/*      */ 
/* 4981 */                       setBoolean(paramObject2, "expanded", paramInt3 == 0, true);
/*      */ 
/* 4983 */                       selectItem(paramObject1, paramObject2, true);
/* 4984 */                       setLead(paramObject1, get(paramObject1, ":lead"), paramObject2);
/*      */ 
/* 4986 */                       setFocus(paramObject1);
/* 4987 */                       validate(paramObject1);
/* 4988 */                       invoke(paramObject1, paramObject2, paramInt3 != 0 ? "collapse" : "expand");
/*      */ 
/* 4991 */                       break;
/*      */                     }
/*      */                   }
/*      */ 
/* 4995 */                   if ((paramInt4 != 506) || (!getBoolean(paramObject2, "selected", false)))
/*      */                   {
/* 4998 */                     if ((paramInt4 != 506) && 
/* 4999 */                       (setFocus(paramObject1))) {
/* 5000 */                       repaint(paramObject1, str, paramObject2);
/*      */                     }
/*      */ 
/* 5003 */                     if ((!paramBoolean3) || (!getBoolean(paramObject2, "selected", false)))
/*      */                     {
/* 5009 */                       select(paramObject1, paramObject2, "tree".equals(str), paramBoolean1, paramBoolean2);
/*      */ 
/* 5012 */                       if (paramInt3 == 2) {
/* 5013 */                         invoke(paramObject1, paramObject2, "perform"); break;
/*      */                       }
/*      */                     }
/*      */                   }
/*      */                 }
/*      */                 else {
/* 5019 */                   paramObject2 = getNextItem(paramObject1, paramObject2, "tree".equals(str));
/*      */ 
/* 5022 */                   continue;
/*      */                 }
/* 5023 */               }label2038: break;
/*      */ 
/* 5025 */               if ("menubar".equals(str)) {
/* 5026 */                 localObject2 = get(paramObject1, "selected");
/* 5027 */                 if (((paramInt4 == 504) || (paramInt4 == 505)) && (paramObject2 != null) && (localObject2 == null) && (getBoolean(paramObject2, "enabled", true)))
/*      */                 {
/* 5031 */                   repaint(paramObject1, str, paramObject2);
/* 5032 */                 } else if ((paramObject2 != null) && (localObject2 == null ? paramInt4 == 501 : (paramInt4 == 504) || (paramInt4 == 2000)) && (getBoolean(paramObject2, "enabled", true)))
/*      */                 {
/* 5039 */                   set(paramObject1, "selected", paramObject2);
/* 5040 */                   popupMenu(paramObject1);
/* 5041 */                   repaint(paramObject1, str, paramObject2); } else {
/* 5042 */                   if ((paramInt4 != 501) || (localObject2 == null)) {
/* 5043 */                     if (paramInt4 != 502) break label2314;
/* 5045 */                     if ((paramObject2 == this.insidepart) || ((this.insidepart != null) && ((!(this.insidepart instanceof Object[])) || ("menu".equals(getClass(this.insidepart))))))
/*      */                       break label2314;
/* 5048 */                     if ((this.insidepart != null) && (getBoolean(this.insidepart, "enabled", true)))
/*      */                     {
/* 5050 */                       if ("checkboxmenuitem".equals(getClass(this.insidepart)))
/*      */                       {
/* 5052 */                         changeCheck(this.insidepart, false);
/*      */                       }
/* 5054 */                       else invoke(this.insidepart, null, "action");
/*      */                     }
/*      */                   }
/* 5057 */                   closeup();
/*      */                 }
/*      */               } else {
/* 5060 */                 label2314: if ((":popup".equals(str)) || ("popupmenu".equals(str)))
/*      */                 {
/* 5062 */                   if (((paramInt4 == 504) || (paramInt4 == 2000)) && (paramObject2 != null) && (getBoolean(paramObject2, "enabled", true)))
/*      */                   {
/* 5065 */                     set(paramObject1, "selected", paramObject2);
/* 5066 */                     popupMenu(paramObject1);
/* 5067 */                     repaint(paramObject1, str, paramObject2);
/* 5068 */                   } else if ((paramInt4 == 502) && ((paramObject2 != null) || ((this.insidepart != null) && ("popupmenu".equals(str)))))
/*      */                   {
/* 5071 */                     if ((this.insidepart != null) && ("menu".equals(getClass(this.insidepart))))
/*      */                       break;
/* 5073 */                     if ((this.insidepart != null) && (getBoolean(this.insidepart, "enabled", true)))
/*      */                     {
/* 5075 */                       if ("checkboxmenuitem".equals(getClass(this.insidepart)))
/*      */                       {
/* 5077 */                         changeCheck(this.insidepart, false);
/*      */                       }
/* 5079 */                       else invoke(this.insidepart, null, "action");
/*      */                     }
/*      */ 
/* 5082 */                     closeup();
/*      */                   } else {
/* 5084 */                     if (((paramInt4 != 505) && (paramInt4 != 2001)) || (paramObject2 == null) || (!getBoolean(paramObject2, "enabled", true))) {
/*      */                       break;
/*      */                     }
/* 5087 */                     if (!"menu".equals(getClass(paramObject2))) {
/* 5088 */                       set(paramObject1, "selected", null);
/*      */                     }
/* 5090 */                     repaint(paramObject1, str, paramObject2);
/*      */                   }
/*      */                 } else {
/* 5092 */                   if (!"dialog".equals(str)) break;
/* 5093 */                   if ("header".equals(paramObject2))
/*      */                   {
/*      */                     Object localObject6;
/* 5094 */                     if (paramInt4 == 501) {
/* 5095 */                       localObject2 = getRectangle(paramObject1, "bounds");
/* 5096 */                       this.referencex = (paramInt1 - ((Rectangle)localObject2).x);
/* 5097 */                       this.referencey = (paramInt2 - ((Rectangle)localObject2).y);
/*      */ 
/* 5099 */                       if (get(localObject6 = getParent(paramObject1), 
/* 5099 */                         ":comp") != paramObject1) {
/* 5100 */                         removeItemImpl(localObject6, paramObject1);
/* 5101 */                         insertItem(localObject6, ":comp", paramObject1, 0);
/* 5102 */                         set(paramObject1, ":parent", localObject6);
/* 5103 */                         repaint(paramObject1);
/* 5104 */                         setNextFocusable(paramObject1, false);
/*      */                       }
/*      */                     } else {
/* 5106 */                       if (paramInt4 != 506) break;
/* 5107 */                       localObject2 = getRectangle(paramObject1, "bounds");
/* 5108 */                       localObject6 = getRectangle(getParent(paramObject1), "bounds");
/*      */ 
/* 5110 */                       paramObject2 = Math.max(0, Math.min(paramInt1 - this.referencex, ((Rectangle)localObject6).width - ((Rectangle)localObject2).width));
/*      */ 
/* 5115 */                       int k = Math.max(0, Math.min(paramInt2 - this.referencey, ((Rectangle)localObject6).height - ((Rectangle)localObject2).height));
/*      */ 
/* 5120 */                       if ((((Rectangle)localObject2).x != paramObject2) || (((Rectangle)localObject2).y != k))
/*      */                       {
/* 5122 */                         repaint(paramObject1, Math.min(((Rectangle)localObject2).x, paramObject2), Math.min(((Rectangle)localObject2).y, k), ((Rectangle)localObject2).width + Math.abs(paramObject2 - ((Rectangle)localObject2).x), ((Rectangle)localObject2).height + Math.abs(k - ((Rectangle)localObject2).y));
/*      */ 
/* 5126 */                         ((Rectangle)localObject2).x = paramObject2;
/* 5127 */                         ((Rectangle)localObject2).y = k;
/*      */                       }
/*      */                     }
/*      */                   } else {
/* 5130 */                     if ((processScroll(paramInt1, paramInt2, paramInt4, paramObject1, paramObject2)) || (paramObject2 == null))
/*      */                       break;
/* 5132 */                     if (paramInt4 == 501) {
/* 5133 */                       this.referencex = paramInt1;
/* 5134 */                       this.referencey = paramInt2;
/* 5135 */                     } else if (paramInt4 == 506) {
/* 5136 */                       repaint(paramObject1);
/* 5137 */                       localObject2 = getRectangle(paramObject1, "bounds");
/* 5138 */                       if ((":nw".equals(paramObject2)) || (":n".equals(paramObject2)) || (":ne".equals(paramObject2)))
/*      */                       {
/* 5140 */                         localObject2.y += paramInt2 - this.referencey;
/* 5141 */                         localObject2.height -= paramInt2 - this.referencey;
/*      */                       }
/* 5143 */                       if ((":ne".equals(paramObject2)) || (":e".equals(paramObject2)) || (":se".equals(paramObject2)))
/*      */                       {
/* 5145 */                         localObject2.width += paramInt1 - this.referencex;
/*      */                       }
/* 5147 */                       if ((":sw".equals(paramObject2)) || (":s".equals(paramObject2)) || (":se".equals(paramObject2)))
/*      */                       {
/* 5149 */                         localObject2.height += paramInt2 - this.referencey;
/*      */                       }
/* 5151 */                       if ((":nw".equals(paramObject2)) || (":w".equals(paramObject2)) || (":sw".equals(paramObject2)))
/*      */                       {
/* 5153 */                         localObject2.x += paramInt1 - this.referencex;
/* 5154 */                         localObject2.width -= paramInt1 - this.referencex;
/*      */                       }
/* 5156 */                       this.referencex = paramInt1;
/* 5157 */                       this.referencey = paramInt2;
/* 5158 */                       doLayout(paramObject1);
/* 5159 */                       repaint(paramObject1);
/* 5160 */                     } else if (paramInt4 == 504) {
/* 5161 */                       setCursor(Cursor.getPredefinedCursor(":w".equals(paramObject2) ? 10 : ":sw".equals(paramObject2) ? 4 : ":s".equals(paramObject2) ? 9 : ":se".equals(paramObject2) ? 5 : ":e".equals(paramObject2) ? 11 : ":ne".equals(paramObject2) ? 7 : ":n".equals(paramObject2) ? 8 : 6));
/*      */                     }
/*      */                     else
/*      */                     {
/* 5173 */                       if (paramInt4 != 505) break;
/* 5174 */                       setCursor(Cursor.getPredefinedCursor(0));
/*      */                     }
/*      */                   }
/*      */                 }
/*      */               } } 
/*      */         }
/*      */       }
/*      */     }
/* 5180 */     label3330: if (paramBoolean3)
/*      */     {
/* 5182 */       if ((
/* 5182 */         localObject2 = get(paramObject1, "popupmenu")) != null)
/*      */       {
/* 5183 */         paramBoolean1 = paramInt2; paramInt3 = paramInt1; paramInt2 = (I)localObject2; paramInt1 = this; set(paramBoolean2 = createImpl(":popup"), "menu", paramInt2); set(paramInt2, ":popup", paramBoolean2); paramInt1.popupowner = paramInt2; insertItem(paramInt1.content, ":comp", paramBoolean2, 0); set(paramBoolean2, ":parent", paramInt1.content); paramInt1.popup(paramInt2, paramBoolean2, 'D', paramInt3, paramBoolean1, 0, 0, 0); paramInt1.invoke(paramInt2, null, "menushown");
/* 5184 */         this.mouseinside = (this.mousepressed = localObject2);
/* 5185 */         this.insidepart = (this.pressedpart = null);
/* 5186 */         setCursor(Cursor.getPredefinedCursor(0));
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void setReference(Object paramObject, int paramInt1, int paramInt2)
/*      */   {
/* 5204 */     this.referencex = paramInt1;
/* 5205 */     this.referencey = paramInt2;
/* 5206 */     for (; paramObject != null; paramObject = getParent(paramObject)) {
/* 5207 */       paramInt1 = getRectangle(paramObject, "bounds");
/* 5208 */       this.referencex += paramInt1.x;
/* 5209 */       this.referencey += paramInt1.y;
/*      */ 
/* 5212 */       if ((
/* 5212 */         paramInt1 = getRectangle(paramObject, ":port")) != null)
/*      */       {
/* 5213 */         paramInt2 = getRectangle(paramObject, ":view");
/* 5214 */         this.referencex -= paramInt2.x - paramInt1.x;
/* 5215 */         this.referencey -= paramInt2.y - paramInt1.y;
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private void select(Object paramObject1, Object paramObject2, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3)
/*      */   {
/* 5223 */     String str = getString(paramObject1, "selection", "single");
/* 5224 */     Object localObject = null;
/* 5225 */     if ((paramBoolean2) && (!"single".equals(str)) && ((localObject = get(paramObject1, ":lead")) != null))
/*      */     {
/* 5227 */       extend(paramObject1, localObject, paramObject2, paramBoolean1);
/*      */     }
/* 5229 */     else if ((paramBoolean3) && ("multiple".equals(str))) {
/* 5230 */       setBoolean(paramObject2, "selected", !getBoolean(paramObject2, "selected", false), false);
/*      */ 
/* 5232 */       repaint(paramObject1, null, paramObject2);
/* 5233 */       invoke(paramObject1, paramObject2, "action");
/* 5234 */       set(paramObject1, ":anchor", null);
/* 5235 */     } else if ((paramBoolean3) && (getBoolean(paramObject2, "selected", false)))
/*      */     {
/* 5237 */       for (paramBoolean2 = paramObject2; paramBoolean2 != null; paramBoolean2 = getNextItem(paramObject1, paramBoolean2, paramBoolean1))
/*      */       {
/* 5239 */         if (setBoolean(paramBoolean2, "selected", false, false)) {
/* 5240 */           repaint(paramObject1, null, paramBoolean2);
/*      */         }
/*      */       }
/* 5243 */       invoke(paramObject1, paramObject2, "action");
/* 5244 */       set(paramObject1, ":anchor", null);
/*      */     } else {
/* 5246 */       selectItem(paramObject1, paramObject2, paramBoolean1);
/*      */     }
/*      */ 
/* 5249 */     setLead(paramObject1, localObject != null ? localObject : get(paramObject1, ":lead"), paramObject2);
/*      */   }
/*      */ 
/*      */   private Object getNextItem(Object paramObject1, Object paramObject2, boolean paramBoolean)
/*      */   {
/* 5266 */     if (!paramBoolean) {
/* 5267 */       return get(paramObject2, ":next");
/*      */     }
/*      */ 
/* 5270 */     if (((
/* 5270 */       paramBoolean = get(paramObject2, ":comp")) == null) || 
/* 5270 */       (!getBoolean(paramObject2, "expanded", true)))
/*      */     {
/* 5272 */       while ((paramObject2 != paramObject1) && ((paramBoolean = get(paramObject2, ":next")) == null)) {
/* 5273 */         paramObject2 = getParent(paramObject2);
/*      */       }
/*      */     }
/* 5276 */     return paramBoolean;
/*      */   }
/*      */ 
/*      */   private void processField(int paramInt1, int paramInt2, int paramInt3, int paramInt4, Object paramObject, boolean paramBoolean1, boolean paramBoolean2, int paramInt5, boolean paramBoolean3)
/*      */   {
/* 5283 */     if (paramInt4 == 501)
/*      */     {
/* 5285 */       setReference(paramObject, paramInt5 + 2, 2);
/* 5286 */       paramInt1 -= this.referencex;
/* 5287 */       paramInt4 = 0;
/* 5288 */       if (!paramBoolean1) {
/* 5289 */         paramInt1 += getInteger(paramObject, ":offset", 0);
/*      */       } else {
/* 5291 */         paramInt4 = getRectangle(paramObject, ":port");
/* 5292 */         paramInt1 += paramInt4.x - 1;
/* 5293 */         paramInt4 = paramInt2 - this.referencey + paramInt4.y - 1;
/*      */       }
/* 5295 */       paramInt4 = getCaretLocation(paramObject, paramInt1, paramInt4, paramBoolean1, paramBoolean2);
/*      */ 
/* 5297 */       if (paramBoolean3) {
/* 5298 */         paramInt1 = getInteger(paramObject, "start", 0);
/* 5299 */         paramInt2 = getInteger(paramObject, "end", 0);
/* 5300 */         if ((paramInt4 >= Math.min(paramInt1, paramInt2)) && (paramInt4 <= Math.max(paramInt1, paramInt2)))
/*      */         {
/* 5302 */           return;
/*      */         }
/*      */       }
/* 5305 */       paramInt1 = paramInt4;
/* 5306 */       if (paramInt3 > 1) {
/* 5307 */         paramInt2 = getString(paramObject, "text", "");
/*      */ 
/* 5309 */         while ((paramInt4 > 0) && (paramInt3 == 2 ? Character.isLetterOrDigit(paramInt2.charAt(paramInt4 - 1)) : paramInt2.charAt(paramInt4 - 1) != '\n'))
/*      */         {
/* 5312 */           paramInt4--;
/*      */         }
/*      */ 
/* 5315 */         while ((paramInt1 < paramInt2.length()) && (paramInt3 == 2 ? Character.isLetterOrDigit(paramInt2.charAt(paramInt1)) : paramInt2.charAt(paramInt1) != '\n'))
/*      */         {
/* 5317 */           paramInt1++;
/*      */         }
/*      */       }
/* 5320 */       setInteger(paramObject, "start", paramInt4, 0);
/* 5321 */       setInteger(paramObject, "end", paramInt1, 0);
/* 5322 */       setFocus(paramObject);
/* 5323 */       validate(paramObject);
/* 5324 */       return; } if (paramInt4 == 506) {
/* 5325 */       paramInt1 -= this.referencex;
/* 5326 */       paramInt4 = 0;
/* 5327 */       if (!paramBoolean1) {
/* 5328 */         paramInt1 += getInteger(paramObject, ":offset", 0);
/*      */       } else {
/* 5330 */         paramInt4 = getRectangle(paramObject, ":port");
/* 5331 */         paramInt1 += paramInt4.x - 1;
/* 5332 */         paramInt4 = paramInt2 - this.referencey + paramInt4.y - 1;
/*      */       }
/*      */ 
/* 5336 */       if ((
/* 5336 */         paramInt4 = getCaretLocation(paramObject, paramInt1, paramInt4, paramBoolean1, paramBoolean2)) != 
/* 5336 */         getInteger(paramObject, "end", 0)) {
/* 5337 */         setInteger(paramObject, "end", paramInt4, 0);
/* 5338 */         validate(paramObject);
/*      */       }
/* 5340 */       return; } if ((paramInt4 == 504) && (this.mousepressed == null)) {
/* 5341 */       setCursor(Cursor.getPredefinedCursor(2)); return;
/* 5342 */     }if (((paramInt4 == 505) && (this.mousepressed == null)) || ((paramInt4 == 502) && ((this.mouseinside != paramObject) || (this.insidepart != null))))
/*      */     {
/* 5345 */       setCursor(Cursor.getPredefinedCursor(0));
/*      */     }
/*      */   }
/*      */ 
/*      */   private int getCaretLocation(Object paramObject, int paramInt1, int paramInt2, boolean paramBoolean1, boolean paramBoolean2)
/*      */   {
/* 5351 */     Font localFont = (Font)get(paramObject, "font");
/* 5352 */     this = getFontMetrics(localFont != null ? localFont : this._font);
/*      */ 
/* 5354 */     paramObject = paramBoolean1 ? (char[])get(paramObject, ":text") : getString(paramObject, "text", "").toCharArray();
/*      */ 
/* 5358 */     boolean bool = false;
/*      */     int i;
/* 5359 */     if (paramBoolean1) {
/* 5360 */       paramBoolean1 = getHeight();
/* 5361 */       for (i = 0; (paramInt2 >= paramBoolean1) && (i < paramObject.length); i++) {
/* 5362 */         if ((paramObject[i] == '\n') || (paramObject[i] == '\t')) {
/* 5363 */           bool = i + 1;
/* 5364 */           paramInt2 -= paramBoolean1;
/*      */         }
/*      */       }
/*      */     }
/* 5368 */     for (paramBoolean1 = bool; paramBoolean1 < paramObject.length; paramBoolean1++) {
/* 5369 */       if ((paramObject[paramBoolean1] == '\n') || (paramObject[paramBoolean1] == '\t')) {
/* 5370 */         return paramBoolean1;
/*      */       }
/* 5372 */       i = charWidth(paramBoolean2 ? '*' : paramObject[paramBoolean1]);
/* 5373 */       if (paramInt1 <= i / 2) {
/* 5374 */         return paramBoolean1;
/*      */       }
/* 5376 */       paramInt1 -= i;
/*      */     }
/* 5378 */     return paramObject.length;
/*      */   }
/*      */ 
/*      */   private boolean processScroll(int paramInt1, int paramInt2, int paramInt3, Object paramObject1, Object paramObject2)
/*      */   {
/* 5383 */     if (("up".equals(paramObject2)) || ("down".equals(paramObject2)) || ("left".equals(paramObject2)) || ("right".equals(paramObject2)))
/*      */     {
/* 5386 */       if ((paramInt3 == 504) || (paramInt3 == 505) || (paramInt3 == 501) || (paramInt3 == 502))
/*      */       {
/* 5390 */         if (paramInt3 == 501) {
/* 5391 */           if (processScroll(paramObject1, paramObject2)) {
/* 5392 */             setTimer(300L);
/* 5393 */             return true;
/*      */           }
/*      */         } else {
/* 5396 */           if (paramInt3 == 502) {
/* 5397 */             setTimer(0L);
/*      */           }
/* 5399 */           repaint(paramObject1, null, paramObject2);
/*      */         }
/*      */       }
/* 5402 */     } else if (("uptrack".equals(paramObject2)) || ("downtrack".equals(paramObject2)) || ("lefttrack".equals(paramObject2)) || ("righttrack".equals(paramObject2)))
/*      */     {
/* 5404 */       if (paramInt3 == 501) {
/* 5405 */         if (processScroll(paramObject1, paramObject2))
/* 5406 */           setTimer(300L);
/*      */       }
/* 5408 */       else if (paramInt3 == 502)
/* 5409 */         setTimer(0L);
/*      */     }
/* 5411 */     else if (("vknob".equals(paramObject2)) || ("hknob".equals(paramObject2)))
/*      */     {
/*      */       Rectangle localRectangle;
/* 5412 */       if (paramInt3 == 501) {
/* 5413 */         paramInt3 = getRectangle(paramObject1, ":port");
/* 5414 */         localRectangle = getRectangle(paramObject1, ":view");
/* 5415 */         if ("hknob".equals(paramObject2)) {
/* 5416 */           this.referencex = (paramInt1 - localRectangle.x * (paramInt3.width - 2 * this._block) / localRectangle.width);
/*      */         }
/*      */         else
/*      */         {
/* 5420 */           this.referencey = (paramInt2 - localRectangle.y * (paramInt3.height - 2 * this._block) / localRectangle.height);
/*      */         }
/*      */ 
/*      */       }
/* 5424 */       else if (paramInt3 == 506) {
/* 5425 */         paramInt3 = getRectangle(paramObject1, ":port");
/* 5426 */         localRectangle = getRectangle(paramObject1, ":view");
/* 5427 */         if ("hknob".equals(paramObject2)) {
/* 5428 */           paramInt1 = (paramInt1 - this.referencex) * localRectangle.width / (paramInt3.width - 2 * this._block);
/*      */ 
/* 5431 */           paramInt1 = Math.max(0, Math.min(paramInt1, localRectangle.width - paramInt3.width));
/*      */ 
/* 5434 */           if (localRectangle.x != paramInt1) {
/* 5435 */             localRectangle.x = paramInt1;
/* 5436 */             repaint(paramObject1, null, "horizontal");
/*      */           }
/*      */         } else {
/* 5439 */           paramInt1 = (paramInt2 - this.referencey) * localRectangle.height / (paramInt3.height - 2 * this._block);
/*      */ 
/* 5442 */           paramInt1 = Math.max(0, Math.min(paramInt1, localRectangle.height - paramInt3.height));
/*      */ 
/* 5445 */           if (localRectangle.y != paramInt1) {
/* 5446 */             localRectangle.y = paramInt1;
/* 5447 */             repaint(paramObject1, null, "vertical");
/*      */           }
/*      */         }
/*      */       }
/* 5451 */     } else if (!"corner".equals(paramObject2)) {
/* 5452 */       if (paramInt3 == 501)
/*      */       {
/* 5456 */         if ((
/* 5456 */           paramInt3 = getRectangle(paramObject1, ":port")) != null)
/*      */         {
/* 5457 */           setReference(paramObject1, paramInt3.x, paramInt3.y);
/*      */         }
/*      */       }
/* 5460 */       return false;
/*      */     }
/* 5462 */     return true;
/*      */   }
/*      */ 
/*      */   private boolean processScroll(Object paramObject1, Object paramObject2) {
/* 5466 */     Rectangle localRectangle1 = getRectangle(paramObject1, ":view");
/* 5467 */     Rectangle localRectangle2 = ("left".equals(paramObject2)) || ("up".equals(paramObject2)) ? null : getRectangle(paramObject1, ":port");
/*      */ 
/* 5470 */     int i = 0;
/* 5471 */     int j = 0;
/* 5472 */     if ("left".equals(paramObject2))
/* 5473 */       i = -10;
/* 5474 */     else if ("lefttrack".equals(paramObject2))
/* 5475 */       i = -localRectangle2.width;
/* 5476 */     else if ("right".equals(paramObject2))
/* 5477 */       i = 10;
/* 5478 */     else if ("righttrack".equals(paramObject2))
/* 5479 */       i = localRectangle2.width;
/* 5480 */     else if ("up".equals(paramObject2))
/* 5481 */       j = -10;
/* 5482 */     else if ("uptrack".equals(paramObject2))
/* 5483 */       j = -localRectangle2.height;
/* 5484 */     else if ("down".equals(paramObject2))
/* 5485 */       j = 10;
/* 5486 */     else if ("downtrack".equals(paramObject2)) {
/* 5487 */       j = localRectangle2.height;
/*      */     }
/* 5489 */     if (i != 0) {
/* 5490 */       i = i < 0 ? Math.max(-localRectangle1.x, i) : Math.min(i, localRectangle1.width - localRectangle2.width - localRectangle1.x);
/*      */     }
/* 5493 */     else if (j != 0) {
/* 5494 */       j = j < 0 ? Math.max(-localRectangle1.y, j) : Math.min(j, localRectangle1.height - localRectangle2.height - localRectangle1.y);
/*      */     }
/*      */     else
/*      */     {
/* 5498 */       return false;
/*      */     }
/* 5500 */     if ((i == 0) && (j == 0)) {
/* 5501 */       return false;
/*      */     }
/* 5503 */     localRectangle1.x += i;
/* 5504 */     localRectangle1.y += j;
/* 5505 */     repaint(paramObject1, null, i != 0 ? "horizontal" : "vertical");
/*      */ 
/* 5507 */     return ((!"left".equals(paramObject2)) && (!"lefttrack".equals(paramObject2))) || ((localRectangle1.x > 0) || (((!"right".equals(paramObject2)) && (!"righttrack".equals(paramObject2))) || ((localRectangle1.x < localRectangle1.width - localRectangle2.width) || (((!"up".equals(paramObject2)) && (!"uptrack".equals(paramObject2))) || ((localRectangle1.y > 0) || ((("down".equals(paramObject2)) || ("downtrack".equals(paramObject2))) && (localRectangle1.y < localRectangle1.height - localRectangle2.height)))))));
/*      */   }
/*      */ 
/*      */   private boolean processSpin(Object paramObject1, Object paramObject2)
/*      */   {
/* 5517 */     String str1 = getString(paramObject1, "text", "");
/*      */     try {
/* 5519 */       int i = Integer.parseInt(str1);
/* 5520 */       int j = getInteger(paramObject1, "step", 1);
/* 5521 */       if ("up".equals(paramObject2) ? i + j <= getInteger(paramObject1, "maximum", 2147483647) : i - j >= getInteger(paramObject1, "minimum", -2147483648))
/*      */       {
/* 5525 */         paramObject2 = String.valueOf("up".equals(paramObject2) ? i + j : i - j);
/*      */ 
/* 5528 */         Object localObject2 = paramObject2; String str2 = "text";
/*      */         Object localObject1;
/* 5528 */         set(localObject1 = paramObject1, str2, localObject2);
/* 5529 */         setInteger(paramObject1, "start", paramObject2.length(), 0);
/* 5530 */         setInteger(paramObject1, "end", 0, 0);
/* 5531 */         repaint(paramObject1, "spinbox", "text");
/* 5532 */         invoke(paramObject1, null, "action");
/* 5533 */         return true;
/*      */       }
/*      */     } catch (NumberFormatException localNumberFormatException) {
/*      */     }
/* 5537 */     return false;
/*      */   }
/*      */ 
/*      */   private boolean invoke(Object paramObject1, Object paramObject2, String paramString)
/*      */   {
/* 5559 */     if ((
/* 5559 */       paramObject1 = get(paramObject1, paramString)) != null)
/*      */     {
/* 5560 */       invokeImpl(paramObject1, paramObject2);
/* 5561 */       return true;
/*      */     }
/* 5563 */     return false;
/*      */   }
/*      */ 
/*      */   private void invokeImpl(Object paramObject1, Object paramObject2)
/*      */   {
/*      */     Object[] arrayOfObject;
/* 5570 */     if ((
/* 5570 */       arrayOfObject = (
/* 5568 */       paramObject1 = (Object[])paramObject1).length > 
/* 5568 */       2 ? new Object[(paramObject1.length - 2) / 3] : null) != null)
/*      */     {
/* 5571 */       for (int i = 0; i < arrayOfObject.length; i++) {
/* 5572 */         Object localObject1 = paramObject1[(2 + i * 3)];
/* 5573 */         if ("thinlet".equals(localObject1)) {
/* 5574 */           arrayOfObject[i] = this;
/* 5575 */         } else if ("constant".equals(localObject1)) {
/* 5576 */           arrayOfObject[i] = paramObject1[(2 + i * 3 + 1)];
/*      */         } else {
/* 5578 */           if ("item".equals(localObject1))
/* 5579 */             localObject1 = paramObject2;
/*      */           Object localObject2;
/* 5582 */           if ((
/* 5582 */             localObject2 = paramObject1[(2 + i * 3 + 1)]) == null)
/*      */           {
/* 5583 */             arrayOfObject[i] = localObject1;
/*      */           }
/*      */           else {
/* 5586 */             arrayOfObject[i] = (localObject1 != null ? get(localObject1, localObject2) : null);
/*      */ 
/* 5589 */             if (arrayOfObject[i] == null)
/* 5590 */               arrayOfObject[i] = paramObject1[(2 + i * 3 + 2)];
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */     try
/*      */     {
/* 5597 */       ((Method)paramObject1[1]).invoke(paramObject1[0], arrayOfObject);
/*      */ 
/* 5602 */       return;
/*      */     }
/*      */     catch (InvocationTargetException localInvocationTargetException)
/*      */     {
/* 5599 */       handleException(localInvocationTargetException.getTargetException());
/*      */ 
/* 5602 */       return;
/*      */     }
/*      */     catch (Throwable localThrowable)
/*      */     {
/* 5601 */       handleException(localThrowable);
/*      */     }
/*      */   }
/*      */ 
/*      */   protected void handleException(Throwable throwable)
/*      */   {
/* 5613 */     throwable.printStackTrace();
/*      */   }
/*      */ 
/*      */   private boolean findComponent(Object paramObject, int paramInt1, int paramInt2) {
/* 5617 */     if (paramObject == this.content) {
/* 5618 */       this.mouseinside = (this.insidepart = null);
/* 5619 */       this.mousex = paramInt1;
/* 5620 */       this.mousey = paramInt2;
/*      */     }
/* 5622 */     if (!getBoolean(paramObject, "visible", true))
/* 5623 */       return false;
/*      */     Rectangle localRectangle;
/* 5626 */     if (((
/* 5626 */       localRectangle = getRectangle(paramObject, "bounds")) == null) || 
/* 5626 */       (!localRectangle.contains(paramInt1, paramInt2))) {
/* 5627 */       return false;
/*      */     }
/* 5629 */     this.mouseinside = paramObject;
/* 5630 */     paramInt1 -= localRectangle.x;
/* 5631 */     paramInt2 -= localRectangle.y;
/* 5632 */     Object localObject2 = getClass(paramObject);
/*      */     Object localObject3;
/* 5634 */     if ("combobox".equals(localObject2)) {
/* 5635 */       if ((getBoolean(paramObject, "editable", true)) && (paramInt1 <= localRectangle.width - this._block))
/*      */       {
/* 5637 */         localObject3 = getIcon(paramObject, "icon", null);
/* 5638 */         this.insidepart = ((localObject3 != null) && (paramInt1 <= 2 + ((Image)localObject3).getWidth(this)) ? "icon" : null);
/*      */       }
/*      */       else
/*      */       {
/* 5642 */         this.insidepart = "down";
/*      */       }
/* 5644 */     } else if (":combolist".equals(localObject2)) {
/* 5645 */       if (!findScroll(paramObject, paramInt1, paramInt2)) {
/* 5646 */         paramInt2 += getRectangle(paramObject, ":view").y;
/* 5647 */         localObject3 = get(get(paramObject, "combobox"), ":comp");
/* 5648 */         for (; localObject3 != null; localObject3 = get(localObject3, ":next"))
/*      */         {
/* 5650 */           localRectangle = getRectangle(localObject3, "bounds");
/* 5651 */           if ((paramInt2 >= localRectangle.y) && (paramInt2 < localRectangle.y + localRectangle.height)) {
/* 5652 */             this.insidepart = localObject3;
/* 5653 */             break;
/*      */           }
/*      */         }
/*      */       }
/* 5657 */     } else if ("textarea".equals(localObject2)) {
/* 5658 */       findScroll(paramObject, paramInt1, paramInt2);
/*      */     }
/*      */     else
/*      */     {
/*      */       int i;
/* 5659 */       if ("tabbedpane".equals(localObject2)) {
/* 5660 */         int j = getInteger(paramObject, "selected", 0);
/* 5661 */         i = 0;
/* 5662 */         for (paramObject = get(paramObject, ":comp"); paramObject != null; paramObject = get(paramObject, ":next"))
/*      */         {
/* 5664 */           localObject2 = getRectangle(paramObject, "bounds");
/*      */           Object localObject5;
/* 5665 */           if ((i == j) && 
/* 5667 */             ((
/* 5667 */             localObject5 = get(paramObject, ":comp")) != null) && 
/* 5667 */             (findComponent(localObject5, paramInt1 - ((Rectangle)localObject2).x, paramInt2 - ((Rectangle)localObject2).y)))
/*      */             break;
/* 5669 */           if (((Rectangle)localObject2).contains(paramInt1, paramInt2))
/*      */           {
/* 5673 */             this.insidepart = paramObject;
/* 5674 */             break;
/*      */           }
/* 5676 */           i++;
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/*      */         Object localObject4;
/*      */         Object localObject1;
/* 5678 */         if (("panel".equals(localObject2)) || ("desktop".equals(localObject2)) || ("dialog".equals(localObject2)))
/*      */         {
/* 5681 */           if ("dialog".equals(localObject2))
/*      */           {
/*      */             boolean bool;
/* 5684 */             if (((
/* 5684 */               bool = getBoolean(paramObject, "resizable", false))) && 
/* 5684 */               (paramInt1 < 4)) {
/* 5685 */               this.insidepart = (paramInt2 >= i.height - this._block ? ":sw" : paramInt2 < this._block ? ":nw" : ":w");
/*      */             }
/* 5689 */             else if ((bool) && (paramInt2 < 4)) {
/* 5690 */               this.insidepart = (paramInt1 >= i.width - this._block ? ":ne" : paramInt1 < this._block ? ":nw" : ":n");
/*      */             }
/* 5694 */             else if ((bool) && (paramInt1 >= i.width - 4)) {
/* 5695 */               this.insidepart = (paramInt2 >= i.height - this._block ? ":se" : paramInt2 < this._block ? ":ne" : ":e");
/*      */             }
/* 5699 */             else if ((bool) && (paramInt2 >= i.height - 4)) {
/* 5700 */               this.insidepart = (paramInt1 >= i.width - this._block ? ":se" : paramInt1 < this._block ? ":sw" : ":s");
/*      */             }
/*      */             else
/*      */             {
/* 5705 */               i = getInteger(paramObject, ":titleheight", 0);
/*      */ 
/* 5707 */               if (paramInt2 < i + 4) {
/* 5708 */                 this.insidepart = "header";
/*      */               }
/*      */             }
/*      */           }
/* 5712 */           if ((this.insidepart == null) && (!findScroll(paramObject, paramInt1, paramInt2)))
/*      */           {
/* 5714 */             if ((
/* 5714 */               localObject4 = getRectangle(paramObject, ":port")) != null)
/*      */             {
/* 5715 */               localObject1 = getRectangle(paramObject, ":view");
/* 5716 */               paramInt1 += ((Rectangle)localObject1).x - ((Rectangle)localObject4).x;
/* 5717 */               paramInt2 += ((Rectangle)localObject1).y - ((Rectangle)localObject4).y;
/*      */             }
/* 5719 */             localObject1 = get(paramObject, ":comp");
/*      */           } } else { while (true) { if (localObject1 != null)
/*      */             {
/* 5721 */               if (!findComponent(localObject1, paramInt1, paramInt2)) {
/* 5722 */                 if (("desktop".equals(localObject2)) && (getBoolean(localObject1, "modal", false)))
/*      */                 {
/* 5726 */                   this.insidepart = "modal";
/* 5727 */                   break;
/*      */                 }
/* 5719 */                 localObject1 = get(localObject1, ":next"); continue;
/*      */               }
/*      */ 
/*      */             }
/*      */ 
/* 5731 */             break;
/* 5732 */             if ("spinbox".equals(localObject2)) {
/* 5733 */               this.insidepart = (paramInt2 <= ((Rectangle)localObject1).height / 2 ? "up" : paramInt1 <= ((Rectangle)localObject1).width - this._block ? null : "down");
/*      */             }
/* 5736 */             else if ("splitpane".equals(localObject2))
/*      */             {
/* 5738 */               if (((
/* 5738 */                 localObject4 = get(paramObject, ":comp")) != null) && 
/* 5739 */                 (!findComponent(localObject4, paramInt1, paramInt2)))
/*      */               {
/* 5741 */                 if ((
/* 5741 */                   localObject1 = get(localObject4, ":next")) != null)
/*      */                 {
/* 5742 */                   findComponent(localObject1, paramInt1, paramInt2);
/*      */                 }
/*      */               }
/*      */             }
/* 5746 */             else if ("list".equals(localObject2)) {
/* 5747 */               findScroll(paramObject, paramInt1, paramInt2);
/* 5748 */             } else if ("table".equals(localObject2)) {
/* 5749 */               if (findScroll(paramObject, paramInt1, paramInt2)) break;
/*      */             }
/* 5751 */             else if ("tree".equals(localObject2)) {
/* 5752 */               findScroll(paramObject, paramInt1, paramInt2);
/* 5753 */             } else if ("menubar".equals(localObject2)) {
/* 5754 */               for (localObject4 = get(paramObject, ":comp"); localObject4 != null; localObject4 = get(localObject4, ":next"))
/*      */               {
/* 5756 */                 localObject1 = getRectangle(localObject4, "bounds");
/* 5757 */                 if ((paramInt1 >= ((Rectangle)localObject1).x) && (paramInt1 < ((Rectangle)localObject1).x + ((Rectangle)localObject1).width)) {
/* 5758 */                   this.insidepart = localObject4;
/* 5759 */                   break;
/*      */                 }
/*      */               }
/*      */             } else {
/* 5762 */               if (!":popup".equals(localObject2)) break;
/* 5763 */               localObject4 = get(get(paramObject, "menu"), ":comp");
/* 5764 */               for (; localObject4 != null; localObject4 = get(localObject4, ":next"))
/*      */               {
/* 5766 */                 localObject1 = getRectangle(localObject4, "bounds");
/* 5767 */                 if ((paramInt2 >= ((Rectangle)localObject1).y) && (paramInt2 < ((Rectangle)localObject1).y + ((Rectangle)localObject1).height)) {
/* 5768 */                   this.insidepart = localObject4;
/* 5769 */                   break;
/*      */                 }
/*      */               }
/*      */             } } }
/*      */       }
/*      */     }
/* 5773 */     return true;
/*      */   }
/*      */ 
/*      */   private boolean findScroll(Object paramObject, int paramInt1, int paramInt2)
/*      */   {
/*      */     Rectangle localRectangle1;
/* 5790 */     if (((
/* 5790 */       localRectangle1 = getRectangle(paramObject, ":port")) == null) || 
/* 5790 */       (localRectangle1.contains(paramInt1, paramInt2))) {
/* 5791 */       return false;
/*      */     }
/* 5793 */     Rectangle localRectangle2 = getRectangle(paramObject, ":view");
/* 5794 */     Rectangle localRectangle3 = getRectangle(paramObject, ":horizontal");
/*      */ 
/* 5796 */     paramObject = getRectangle(paramObject, ":vertical");
/*      */ 
/* 5798 */     if ((localRectangle3 != null) && (localRectangle3.contains(paramInt1, paramInt2))) {
/* 5799 */       findScroll(paramInt1 - localRectangle3.x, localRectangle3.width, localRectangle1.width, localRectangle2.x, localRectangle2.width, true);
/*      */     }
/* 5801 */     else if ((paramObject != null) && (paramObject.contains(paramInt1, paramInt2))) {
/* 5802 */       findScroll(paramInt2 - paramObject.y, paramObject.height, localRectangle1.height, localRectangle2.y, localRectangle2.height, false);
/*      */     }
/*      */     else {
/* 5805 */       this.insidepart = "corner";
/*      */     }
/* 5807 */     return true;
/*      */   }
/*      */ 
/*      */   private void findScroll(int paramInt1, int paramInt2, int paramInt3, int paramInt4, int paramInt5, boolean paramBoolean)
/*      */   {
/* 5827 */     if (paramInt1 < this._block) {
/* 5828 */       this.insidepart = (paramBoolean ? "left" : "up"); return;
/* 5829 */     }if (paramInt1 > paramInt2 - this._block) {
/* 5830 */       this.insidepart = (paramBoolean ? "right" : "down"); return;
/*      */     }
/*      */ 
/* 5833 */     if ((
/* 5833 */       paramInt2 = paramInt2 - 2 * this._block) < 
/* 5833 */       10) {
/* 5834 */       this.insidepart = "corner";
/* 5835 */       return;
/*      */     }
/* 5837 */     int i = Math.max(paramInt2 * paramInt3 / paramInt5, 10);
/* 5838 */     paramInt2 = paramInt4 * (paramInt2 - i) / (paramInt5 - paramInt3);
/* 5839 */     if (paramInt1 < this._block + paramInt2) {
/* 5840 */       this.insidepart = (paramBoolean ? "lefttrack" : "uptrack"); return;
/* 5841 */     }if (paramInt1 < this._block + paramInt2 + i) {
/* 5842 */       this.insidepart = (paramBoolean ? "hknob" : "vknob"); return;
/*      */     }
/* 5844 */     this.insidepart = (paramBoolean ? "righttrack" : "downtrack");
/*      */   }
/*      */ 
/*      */   private void repaint(Object paramObject1, Object paramObject2, Object paramObject3)
/*      */   {
/* 5851 */     Rectangle localRectangle1 = getRectangle(paramObject1, "bounds");
/* 5852 */     if ("combobox".equals(paramObject2)) {
/* 5853 */       repaint(paramObject1, localRectangle1.x + localRectangle1.width - this._block, localRectangle1.y, this._block, localRectangle1.height); return;
/*      */     }
/*      */ 
/* 5857 */     if ("spinbox".equals(paramObject2)) {
/* 5858 */       if ("text".equals(paramObject3)) {
/* 5859 */         repaint(paramObject1, localRectangle1.x, localRectangle1.y, localRectangle1.width - this._block, localRectangle1.height); return;
/*      */       }
/* 5861 */       repaint(paramObject1, localRectangle1.x + localRectangle1.width - this._block, "up".equals(paramObject3) ? localRectangle1.y : localRectangle1.y + localRectangle1.height - localRectangle1.height / 2, this._block, localRectangle1.height / 2); return;
/*      */     }
/*      */     Rectangle localRectangle2;
/* 5869 */     if (("tabbedpane".equals(paramObject2)) || ("menubar".equals(paramObject2)) || (":popup".equals(paramObject2)))
/*      */     {
/* 5873 */       localRectangle2 = getRectangle(paramObject3, "bounds");
/* 5874 */       repaint(paramObject1, localRectangle1.x + localRectangle2.x, localRectangle1.y + localRectangle2.y, ":popup".equals(paramObject2) ? localRectangle1.width : localRectangle2.width, localRectangle2.height);
/*      */ 
/* 5876 */       return;
/*      */     }
/*      */ 
/* 5879 */     if (("left".equals(paramObject3)) || ("right".equals(paramObject3)))
/*      */     {
/* 5882 */       localRectangle2 = getRectangle(paramObject1, ":horizontal");
/*      */ 
/* 5884 */       repaint(paramObject1, localRectangle1.x + ("left".equals(paramObject3) ? localRectangle2.x : localRectangle2.x + localRectangle2.width - this._block), localRectangle1.y + localRectangle2.y, this._block, localRectangle2.height);
/*      */ 
/* 5887 */       return; } if (("up".equals(paramObject3)) || ("down".equals(paramObject3)))
/*      */     {
/* 5890 */       localRectangle2 = getRectangle(paramObject1, ":vertical");
/*      */ 
/* 5892 */       repaint(paramObject1, localRectangle1.x + localRectangle2.x, localRectangle1.y + ("up".equals(paramObject3) ? localRectangle2.y : localRectangle2.y + localRectangle2.height - this._block), localRectangle2.width, this._block);
/*      */ 
/* 5895 */       return; } if (("text".equals(paramObject3)) || ("horizontal".equals(paramObject3)) || ("vertical".equals(paramObject3)))
/*      */     {
/* 5898 */       localRectangle2 = getRectangle(paramObject1, ":port");
/*      */ 
/* 5900 */       repaint(paramObject1, localRectangle1.x + localRectangle2.x, localRectangle1.y + localRectangle2.y, localRectangle2.width, localRectangle2.height);
/*      */ 
/* 5902 */       if ("horizontal".equals(paramObject3)) {
/* 5903 */         paramObject2 = getRectangle(paramObject1, ":horizontal");
/*      */ 
/* 5905 */         repaint(paramObject1, localRectangle1.x + paramObject2.x, localRectangle1.y + paramObject2.y, paramObject2.width, paramObject2.height);
/* 5906 */         repaint(paramObject1, localRectangle1.x + paramObject2.x, localRectangle1.y, paramObject2.width, localRectangle2.y);
/*      */       }
/*      */       else {
/* 5909 */         if ("vertical".equals(paramObject3)) {
/* 5910 */           paramObject2 = getRectangle(paramObject1, ":vertical");
/*      */ 
/* 5912 */           repaint(paramObject1, localRectangle1.x + paramObject2.x, localRectangle1.y + paramObject2.y, paramObject2.width, paramObject2.height);
/*      */         }
/* 5914 */         return;
/*      */       } } else {
/* 5915 */       localRectangle2 = getRectangle(paramObject1, ":port");
/* 5916 */       paramObject2 = getRectangle(paramObject1, ":view");
/*      */ 
/* 5918 */       if (((
/* 5918 */         paramObject3 = getRectangle(paramObject3, "bounds")).y + 
/* 5918 */         paramObject3.height >= paramObject2.y) && (paramObject3.y <= paramObject2.y + localRectangle2.height))
/* 5919 */         repaint(paramObject1, localRectangle1.x + localRectangle2.x, localRectangle1.y + localRectangle2.y - paramObject2.y + paramObject3.y, localRectangle2.width, paramObject3.height);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void validate(Object paramObject)
/*      */   {
/* 5932 */     repaint(paramObject);
/*      */ 
/* 5934 */     if ((
/* 5934 */       this = getRectangle(paramObject, "bounds")) != null)
/*      */     {
/* 5935 */       this.width = (-1 * Math.abs(this.width));
/*      */     }
/*      */   }
/*      */ 
/*      */   public void repaint(Object paramObject)
/*      */   {
/*      */     Rectangle localRectangle;
/* 5947 */     if ((
/* 5947 */       localRectangle = getRectangle(paramObject, "bounds")) != null)
/*      */     {
/* 5948 */       repaint(paramObject, localRectangle.x, localRectangle.y, localRectangle.width, localRectangle.height);
/*      */     }
/*      */   }
/*      */ 
/*      */   private void repaint(Object paramObject, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 5964 */     while ((paramObject = getParent(paramObject)) != null) {
/* 5965 */       Rectangle localRectangle1 = getRectangle(paramObject, "bounds");
/* 5966 */       paramInt1 += localRectangle1.x;
/* 5967 */       paramInt2 += localRectangle1.y;
/*      */ 
/* 5969 */       if ((
/* 5969 */         localRectangle1 = getRectangle(paramObject, ":view")) != null)
/*      */       {
/* 5970 */         Rectangle localRectangle2 = getRectangle(paramObject, ":port");
/* 5971 */         paramInt1 += -localRectangle1.x + localRectangle2.x;
/* 5972 */         paramInt2 += -localRectangle1.y + localRectangle2.y;
/*      */       }
/*      */     }
/* 5975 */     repaint(paramInt1, paramInt2, paramInt3, paramInt4);
/*      */   }
/*      */ 
/*      */   public boolean requestFocus(Object paramObject)
/*      */   {
/* 5988 */     if (isFocusable(paramObject, true)) {
/* 5989 */       setFocus(paramObject);
/* 5990 */       repaint(paramObject);
/* 5991 */       return true;
/*      */     }
/* 5993 */     return false;
/*      */   }
/*      */ 
/*      */   private boolean setFocus(Object paramObject)
/*      */   {
/* 6005 */     if (!this.focusinside) {
/* 6006 */       requestFocus();
/*      */     }
/* 6008 */     if (this.focusowner != paramObject) {
/* 6009 */       Object localObject = this.focusowner;
/* 6010 */       if (this.focusowner != null) {
/* 6011 */         this.focusowner = null;
/* 6012 */         repaint(localObject);
/*      */ 
/* 6014 */         invoke(localObject, null, "focuslost");
/*      */       }
/* 6016 */       if (this.focusowner == null) {
/* 6017 */         this.focusowner = paramObject;
/*      */ 
/* 6019 */         invoke(paramObject, null, "focusgained");
/*      */       }
/* 6021 */       return true;
/*      */     }
/* 6023 */     return false;
/*      */   }
/*      */ 
/*      */   private boolean setNextFocusable(Object paramObject, boolean paramBoolean)
/*      */   {
/* 6032 */     int i = 1;
/*      */     Object localObject1;
/* 6033 */     for (Object localObject2 = paramObject; ; localObject2 = localObject1)
/*      */     {
/* 6036 */       if ((
/* 6036 */         localObject1 = get(localObject2, ":comp")) == null)
/*      */       {
/* 6037 */         localObject1 = get(localObject2, ":next");
/*      */       }
/*      */ 
/* 6041 */       while (localObject1 == null)
/*      */       {
/* 6045 */         if ((
/* 6045 */           localObject2 = getParent(localObject2)) == null)
/*      */         {
/* 6046 */           return false;
/*      */         }
/* 6048 */         if ((localObject2 == this.content) || (("dialog".equals(getClass(localObject2))) && ((!paramBoolean) || (getBoolean(localObject2, "modal", false)))))
/*      */         {
/* 6051 */           i = 0;
/*      */ 
/* 6053 */           localObject1 = localObject2; continue;
/*      */         }
/* 6055 */         localObject1 = get(localObject2, ":next");
/*      */       }
/*      */ 
/* 6058 */       if (localObject1 == paramObject) {
/* 6059 */         return false;
/*      */       }
/* 6061 */       if (isFocusable(localObject1, false)) {
/* 6062 */         setFocus(localObject1);
/* 6063 */         return i;
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private Object getPreviousFocusable(Object paramObject1, Object paramObject2, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4)
/*      */   {
/* 6099 */     Object localObject = null;
/* 6100 */     if ((paramObject1 != null) && (paramObject1 != paramObject2)) {
/* 6101 */       int i = (!"dialog".equals(getClass(paramObject1))) || ((paramBoolean4) && (!getBoolean(paramObject1, "modal", false))) ? 1 : 0;
/*      */ 
/* 6104 */       if ((!paramBoolean1) && (!paramBoolean2) && (i != 0)) {
/* 6105 */         localObject = getPreviousFocusable(get(paramObject1, ":next"), paramObject2, false, false, paramBoolean3, paramBoolean4);
/*      */       }
/*      */ 
/* 6109 */       if ((localObject == null) && (((paramBoolean2) && (paramBoolean3)) || ((!paramBoolean1) && (!paramBoolean2))))
/*      */       {
/* 6114 */         if (((
/* 6114 */           localObject = getPreviousFocusable(get(paramObject1, ":comp"), paramObject2, false, false, paramBoolean3, paramBoolean4)) == null) && 
/* 6114 */           (isFocusable(paramObject1, false))) {
/* 6115 */           localObject = paramObject1;
/*      */         }
/*      */       }
/* 6118 */       if ((localObject == null) && ((paramBoolean1) || (paramBoolean2)) && (i != 0)) {
/* 6119 */         localObject = getPreviousFocusable(getParent(paramObject1), paramObject1, false, true, paramBoolean3, paramBoolean4);
/*      */       }
/*      */ 
/* 6123 */       if ((localObject == null) && ((paramBoolean1) || (paramBoolean2)) && (!paramBoolean3) && (i != 0)) {
/* 6124 */         localObject = getPreviousFocusable(get(paramObject1, ":next"), paramObject2, false, false, paramBoolean3, paramBoolean4);
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/* 6129 */     return localObject;
/*      */   }
/*      */ 
/*      */   private boolean isFocusable(Object paramObject, boolean paramBoolean)
/*      */   {
/* 6144 */     String str = getClass(paramObject);
/* 6145 */     if (("button".equals(str)) || ("checkbox".equals(str)) || ("togglebutton".equals(str)) || ("combobox".equals(str)) || ("textfield".equals(str)) || ("passwordfield".equals(str)) || ("textarea".equals(str)) || ("spinbox".equals(str)) || ("slider".equals(str)) || ("list".equals(str)) || ("table".equals(str)) || ("tree".equals(str)) || ("tabbedpane".equals(str)) || ((paramBoolean) && ("splitpane".equals(str))))
/*      */     {
/* 6157 */       for (paramObject = paramObject; paramObject != null; )
/*      */       {
/* 6159 */         if ((!getBoolean(paramObject, "enabled", true)) || (!getBoolean(paramObject, "visible", true)))
/*      */         {
/* 6161 */           return false;
/*      */         }
/* 6163 */         paramBoolean = getParent(paramObject);
/*      */ 
/* 6165 */         if (("tab".equals(getClass(paramObject))) && (getItem(paramBoolean, getInteger(paramBoolean, "selected", 0)) != paramObject))
/*      */         {
/* 6168 */           return false;
/*      */         }
/* 6170 */         paramObject = paramBoolean;
/*      */       }
/* 6172 */       return true;
/*      */     }
/* 6174 */     return false;
/*      */   }
/*      */ 
/*      */   public static Object create(String paramString)
/*      */   {
/* 6189 */     for (int i = 0; i < _dtd.length; i += 3) {
/* 6190 */       if (_dtd[i].equals(paramString)) {
/* 6191 */         return createImpl((String)_dtd[i]);
/*      */       }
/*      */     }
/* 6194 */     throw new IllegalArgumentException("unknown " + paramString);
/*      */   }
/*      */ 
/*      */   public static String getClass(Object paramObject)
/*      */   {
/* 6205 */     return (String)get(paramObject, ":class");
/*      */   }
/*      */ 
/*      */   public Object getDesktop()
/*      */   {
/* 6214 */     return this.content;
/*      */   }
/*      */ 
/*      */   private static Object createImpl(String paramString) {
/* 6218 */     return new Object[] { ":class", paramString, null };
/*      */   }
/*      */ 
/*      */   private static boolean set(Object paramObject1, Object paramObject2, Object paramObject3)
/*      */   {
/* 6224 */     for (Object[] arrayOfObject = paramObject1 = (Object[])paramObject1
/* 6224 */       ; arrayOfObject != null; arrayOfObject = (Object[])arrayOfObject[2])
/*      */     {
/* 6226 */       if (arrayOfObject[0] == paramObject2) {
/* 6227 */         if (paramObject3 != null) {
/* 6228 */           paramObject1 = arrayOfObject[1];
/* 6229 */           arrayOfObject[1] = paramObject3;
/* 6230 */           return !paramObject3.equals(paramObject1);
/*      */         }
/* 6232 */         paramObject1[2] = arrayOfObject[2];
/* 6233 */         arrayOfObject[2] = null;
/* 6234 */         return true;
/*      */       }
/*      */ 
/* 6237 */       paramObject1 = arrayOfObject;
/*      */     }
/* 6239 */     if (paramObject3 != null) {
/* 6240 */       paramObject1[2] = { paramObject2, paramObject3, null };
/* 6241 */       return true;
/*      */     }
/* 6243 */     return false;
/*      */   }
/*      */ 
/*      */   private static Object get(Object paramObject1, Object paramObject2) {
/* 6247 */     for (paramObject1 = (Object[])paramObject1; paramObject1 != null; paramObject1 = (Object[])paramObject1[2])
/*      */     {
/* 6249 */       if (paramObject1[0] == paramObject2) {
/* 6250 */         return paramObject1[1];
/*      */       }
/*      */     }
/* 6253 */     return null;
/*      */   }
/*      */ 
/*      */   public int getCount(Object component)
/*      */   {
/* 6264 */     return getItemCountImpl(component, ":comp");
/*      */   }
/*      */ 
/*      */   public Object getParent(Object component)
/*      */   {
/* 6275 */     return get(component, ":parent");
/*      */   }
/*      */ 
/*      */   public int getSelectedIndex(Object paramObject)
/*      */   {
/* 6286 */     this = getClass(paramObject);
/* 6287 */     if (("combobox".equals(this)) || ("tabbedpane".equals(this)))
/*      */     {
/* 6289 */       return getInteger(paramObject, "selected", "combobox".equals(this) ? -1 : 0);
/*      */     }
/*      */ 
/* 6292 */     if (("list".equals(this)) || ("table".equals(this)) || ("tree".equals(this)))
/*      */     {
/* 6294 */       this = get(paramObject, ":comp");
/* 6295 */       for (paramObject = 0; this != null; paramObject++) {
/* 6296 */         if (getBoolean(this, "selected", false)) {
/* 6297 */           return paramObject;
/*      */         }
/* 6299 */         this = get(this, ":next");
/*      */       }
/* 6301 */       return -1;
/*      */     }
/* 6303 */     throw new IllegalArgumentException(this);
/*      */   }
/*      */ 
/*      */   public Object getSelectedItem(Object paramObject)
/*      */   {
/* 6314 */     String str = getClass(paramObject);
/* 6315 */     if (("combobox".equals(str)) || ("tabbedpane".equals(str)))
/*      */     {
/* 6320 */       int i;
/* 6320 */       if ((
/* 6320 */         i = getInteger(paramObject, "selected", "combobox".equals(str) ? -1 : 0)) != 
/* 6320 */         -1) return getItemImpl(paramObject, ":comp", i); return null;
/*      */     }
/*      */ 
/* 6323 */     if (("list".equals(str)) || ("table".equals(str)) || ("tree".equals(str)))
/*      */     {
/* 6325 */       for (Object localObject = findNextItem(paramObject, str, null); localObject != null; localObject = findNextItem(paramObject, str, localObject))
/*      */       {
/* 6327 */         if (getBoolean(localObject, "selected", false)) {
/* 6328 */           return localObject;
/*      */         }
/*      */       }
/* 6331 */       return null;
/*      */     }
/* 6333 */     throw new IllegalArgumentException(str);
/*      */   }
/*      */ 
/*      */   public Object[] getSelectedItems(Object paramObject)
/*      */   {
/* 6345 */     String str = getClass(paramObject);
/* 6346 */     Object localObject1 = new Object[0];
/* 6347 */     for (Object localObject2 = findNextItem(paramObject, str, null); localObject2 != null; localObject2 = findNextItem(paramObject, str, localObject2))
/*      */     {
/* 6349 */       if (getBoolean(localObject2, "selected", false)) {
/* 6350 */         Object[] arrayOfObject = new Object[localObject1.length + 1];
/* 6351 */         System.arraycopy(localObject1, 0, arrayOfObject, 0, localObject1.length);
/* 6352 */         arrayOfObject[localObject1.length] = localObject2;
/* 6353 */         localObject1 = arrayOfObject;
/*      */       }
/*      */     }
/* 6356 */     return (Object)localObject1;
/*      */   }
/*      */ 
/*      */   private Object findNextItem(Object paramObject1, String paramString, Object paramObject2)
/*      */   {
/* 6365 */     if (paramObject2 == null)
/* 6366 */       return get(paramObject1, ":comp");
/* 6367 */     if ("tree".equals(paramString))
/*      */     {
/* 6369 */       if (((
/* 6369 */         paramString = get(paramObject2, ":comp")) == null) || 
/* 6369 */         (!getBoolean(paramObject2, "expanded", true)))
/*      */       {
/* 6374 */         while ((paramObject2 != paramObject1) && ((paramString = get(paramObject2, ":next")) == null)) {
/* 6375 */           paramObject2 = getParent(paramObject2);
/*      */         }
/*      */       }
/* 6378 */       return paramString;
/*      */     }
/* 6380 */     return get(paramObject2, ":next");
/*      */   }
/*      */ 
/*      */   public void removeAll(Object paramObject)
/*      */   {
/* 6391 */     if (get(paramObject, ":comp") != null) {
/* 6392 */       set(paramObject, ":comp", null);
/* 6393 */       update(paramObject, "validate");
/*      */     }
/*      */   }
/*      */ 
/*      */   private static int getItemCountImpl(Object component, String key)
/*      */   {
/*      */     String key;
/* 6399 */     int i = 0;
/* 6400 */     for (component = get(component, key); comp != null; comp = get(comp, ":next"))
/*      */     {
/* 6402 */       i++;
/*      */     }
/* 6404 */     return i;
/*      */   }
/*      */ 
/*      */   public Object getItem(Object component, int index)
/*      */   {
/* 6418 */     return getItemImpl(component, ":comp", index);
/*      */   }
/*      */ 
/*      */   public Object[] getItems(Object paramObject)
/*      */   {
/* 6429 */     this = new Object[getItemCountImpl(paramObject, ":comp")];
/* 6430 */     paramObject = get(paramObject, ":comp");
/* 6431 */     for (int i = 0; i < this.length; i++) {
/* 6432 */       this[i] = paramObject;
/* 6433 */       paramObject = get(paramObject, ":next");
/*      */     }
/* 6435 */     return this;
/*      */   }
/*      */ 
/*      */   private static Object getItemImpl(Object paramObject1, Object paramObject2, int paramInt)
/*      */   {
/* 6443 */     int i = 0;
/* 6444 */     for (paramObject1 = get(paramObject1, paramObject2); paramObject1 != null; paramObject1 = get(paramObject1, ":next"))
/*      */     {
/* 6446 */       if (i == paramInt) {
/* 6447 */         return paramObject1;
/*      */       }
/* 6449 */       i++;
/*      */     }
/* 6451 */     return null;
/*      */   }
/*      */ 
/*      */   private static int getIndex(Object paramObject1, Object paramObject2) {
/* 6455 */     int i = 0;
/* 6456 */     for (paramObject1 = get(paramObject1, ":comp"); paramObject1 != null; paramObject1 = get(paramObject1, ":next"))
/*      */     {
/* 6458 */       if (paramObject2 == paramObject1) {
/* 6459 */         return i;
/*      */       }
/* 6461 */       i++;
/*      */     }
/* 6463 */     return -1;
/*      */   }
/*      */ 
/*      */   public void add(Object component)
/*      */   {
/* 6473 */     add(this.content, component, 0);
/*      */   }
/*      */ 
/*      */   public void add(Object parent, Object component)
/*      */   {
/* 6485 */     add(parent, component, -1);
/*      */   }
/*      */ 
/*      */   public void add(Object paramObject1, Object paramObject2, int paramInt)
/*      */   {
/* 6501 */     addImpl(paramObject1, paramObject2, paramInt);
/* 6502 */     update(paramObject2, "validate");
/* 6503 */     if (paramObject1 == this.content)
/* 6504 */       setNextFocusable(paramObject2, false);
/*      */   }
/*      */ 
/*      */   private static void insertItem(Object paramObject1, Object paramObject2, Object paramObject3, int paramInt)
/*      */   {
/* 6513 */     Object localObject = paramObject1; paramObject1 = get(paramObject1, paramObject2);
/* 6514 */     for (int i = 0; ; i++) {
/* 6515 */       if ((i == paramInt) || (paramObject1 == null)) {
/* 6516 */         set(localObject, paramObject2, paramObject3);
/* 6517 */         set(paramObject3, ":next", paramObject1);
/* 6518 */         return;
/*      */       }
/* 6520 */       localObject = paramObject1; paramObject1 = get(paramObject1, paramObject2 = ":next");
/*      */     }
/*      */   }
/*      */ 
/*      */   public void remove(Object paramObject)
/*      */   {
/* 6532 */     update(paramObject, "validate");
/* 6533 */     Object localObject1 = getParent(paramObject);
/* 6534 */     Object localObject2 = getClass(paramObject);
/* 6535 */     if (("popupmenu".equals(localObject2)) || ("header".equals(localObject2))) {
/* 6536 */       set(localObject1, localObject2, null); return;
/*      */     }
/* 6538 */     removeItemImpl(localObject1, paramObject);
/*      */ 
/* 6541 */     for (localObject2 = this.focusowner; localObject2 != null; localObject2 = getParent(localObject2))
/*      */     {
/* 6543 */       if (localObject2 == paramObject) {
/* 6544 */         setNextFocusable(localObject1, false);
/* 6545 */         return;
/*      */       }
/*      */     }
/*      */   }
/*      */ 
/*      */   private static void removeItemImpl(Object paramObject1, Object paramObject2)
/*      */   {
/* 6558 */     Object localObject1 = null;
/* 6559 */     for (Object localObject2 = get(paramObject1, ":comp"); localObject2 != null; )
/*      */     {
/*      */       Object localObject3;
/* 6561 */       if ((
/* 6561 */         localObject3 = get(localObject2, ":next")) == 
/* 6561 */         paramObject2) {
/* 6562 */         localObject1 = localObject2;
/* 6563 */         break;
/*      */       }
/* 6565 */       localObject2 = localObject3;
/*      */     }
/* 6567 */     set(localObject1 != null ? localObject1 : paramObject1, localObject1 != null ? ":next" : ":comp", get(paramObject2, ":next"));
/*      */ 
/* 6569 */     set(paramObject2, ":next", null);
/* 6570 */     set(paramObject2, ":parent", null);
/*      */   }
/*      */ 
/*      */   public Object find(String name)
/*      */   {
/* 6582 */     return find(this.content, name);
/*      */   }
/*      */ 
/*      */   public Object find(Object paramObject, String paramString)
/*      */   {
/* 6595 */     if (paramString.equals(get(paramObject, "name"))) {
/* 6596 */       return paramObject;
/*      */     }
/*      */ 
/* 6599 */     for (Object localObject2 = get(paramObject, ":comp"); localObject2 != null; )
/*      */     {
/* 6602 */       if ((localObject1 = find(localObject2, paramString)) != null)
/* 6603 */         return localObject1;
/* 6600 */       localObject2 = get(localObject2, ":next");
/*      */     }
/*      */     Object localObject1;
/* 6609 */     if (((
/* 6609 */       localObject2 = get(paramObject, "header")) != null) && 
/* 6609 */       ((localObject1 = find(localObject2, paramString)) != null)) {
/* 6610 */       return localObject1;
/*      */     }
/*      */ 
/* 6616 */     if (((
/* 6616 */       paramObject = get(paramObject, "popupmenu")) != null) && 
/* 6616 */       ((localObject1 = find(paramObject, paramString)) != null)) {
/* 6617 */       return localObject1;
/*      */     }
/* 6619 */     return null;
/*      */   }
/*      */ 
/*      */   private boolean checkMnemonic(Object paramObject1, boolean paramBoolean, Object paramObject2, int paramInt1, int paramInt2)
/*      */   {
/* 6641 */     if ((paramObject1 == null) || (!getBoolean(paramObject1, "visible", true)) || (!getBoolean(paramObject1, "enabled", true)))
/*      */     {
/* 6645 */       return false;
/*      */     }
/* 6647 */     String str = getClass(paramObject1);
/*      */     Object localObject1;
/* 6648 */     if ("label".equals(str)) {
/* 6649 */       if (hasMnemonic(paramObject1, paramInt1, paramInt2))
/*      */       {
/* 6651 */         if ((
/* 6651 */           localObject1 = get(paramObject1, "for")) != null)
/*      */         {
/* 6652 */           requestFocus(localObject1);
/* 6653 */           return true;
/*      */         }
/*      */       }
/* 6656 */     } else if ("button".equals(str)) {
/* 6657 */       if (((paramInt2 == 0) && (((paramInt1 == 10) && ("default".equals(get(paramObject1, "type")))) || ((paramInt1 == 27) && ("cancel".equals(get(paramObject1, "type")))))) || (hasMnemonic(paramObject1, paramInt1, paramInt2)))
/*      */       {
/* 6662 */         invoke(paramObject1, null, "action");
/* 6663 */         repaint(paramObject1);
/* 6664 */         return true;
/*      */       }
/* 6666 */     } else if (("checkbox".equals(str)) || ("togglebutton".equals(str)))
/*      */     {
/* 6668 */       if (hasMnemonic(paramObject1, paramInt1, paramInt2)) {
/* 6669 */         changeCheck(paramObject1, true);
/* 6670 */         repaint(paramObject1);
/* 6671 */         return true;
/*      */       }
/* 6673 */     } else if ("menubar".equals(str)) {
/* 6674 */       for (localObject1 = get(paramObject1, ":comp"); localObject1 != null; localObject1 = get(localObject1, ":next"))
/*      */       {
/* 6676 */         if ((!hasMnemonic(localObject1, paramInt1, paramInt2)) && ((paramInt2 != 0) || (paramInt1 != 121)))
/*      */           continue;
/* 6678 */         closeup();
/* 6679 */         set(paramObject1, "selected", localObject1);
/* 6680 */         popupMenu(paramObject1);
/* 6681 */         repaint(paramObject1, "menubar", localObject1);
/* 6682 */         return true;
/*      */       }
/*      */     }
/*      */     else
/*      */     {
/*      */       int j;
/* 6685 */       if (("menuitem".equals(str)) || ("checkboxmenuitem".equals(str)))
/*      */       {
/* 6687 */         int k = paramInt2; j = paramInt1;
/*      */         long l;
/* 6687 */         if (((localObject1 = get(localObject1 = paramObject1, "accelerator")) != null ? 0 : ((l = ((Long)localObject1).longValue()) >> 32 == k) && ((l & 0xFFFF) == j) ? 1 : 0) != 0)
/* 6688 */           invoke(paramObject1, null, "action");
/*      */       }
/* 6690 */       else if ("tabbedpane".equals(str)) {
/* 6691 */         int i = getInteger(paramObject1, "selected", 0);
/* 6692 */         j = 0;
/* 6693 */         for (Object localObject3 = get(paramObject1, ":comp"); localObject3 != null; localObject3 = get(localObject3, ":next"))
/*      */         {
/* 6695 */           if (hasMnemonic(localObject3, paramInt1, paramInt2)) {
/* 6696 */             if (i != j) {
/* 6697 */               setInteger(paramObject1, "selected", j, 0);
/* 6698 */               repaint(paramObject1);
/* 6699 */               invoke(paramObject1, getItem(paramObject1, j), "action");
/*      */             }
/*      */ 
/* 6702 */             return true;
/*      */           }
/* 6704 */           j++;
/*      */         }
/*      */ 
/* 6707 */         if (((
/* 6707 */           localObject3 = get(getItem(paramObject1, i), ":comp")) != null) && 
/* 6707 */           (localObject3 != paramObject2) && (checkMnemonic(localObject3, false, null, paramInt1, paramInt2)))
/*      */         {
/* 6709 */           return true;
/*      */         }
/*      */       }
/*      */     }
/* 6713 */     if (("panel".equals(str)) || ("desktop".equals(str)) || ("dialog".equals(str)) || ("splitpane".equals(str)) || ("menubar".equals(str)) || ("menu".equals(str)))
/*      */     {
/* 6719 */       for (Object localObject2 = get(paramObject1, ":comp"); localObject2 != null; localObject2 = get(localObject2, ":next"))
/*      */       {
/* 6721 */         if ((localObject2 != paramObject2) && (checkMnemonic(localObject2, false, null, paramInt1, paramInt2)))
/*      */         {
/* 6723 */           return true;
/*      */         }
/*      */       }
/*      */     }
/*      */ 
/* 6728 */     if ((paramBoolean) && ((!"dialog".equals(str)) || (!getBoolean(paramObject1, "modal", false))))
/*      */     {
/* 6731 */       if (checkMnemonic(getParent(paramObject1), true, "tab".equals(str) ? paramObject2 : paramObject1, paramInt1, paramInt2))
/*      */       {
/* 6734 */         return true;
/*      */       }
/*      */     }
/* 6737 */     return false;
/*      */   }
/*      */ 
/*      */   private boolean hasMnemonic(Object paramObject, int paramInt1, int paramInt2)
/*      */   {
/* 6748 */     if (paramInt2 == 8)
/*      */     {
/* 6750 */       if ((
/* 6750 */         this = getInteger(paramObject, "mnemonic", -1)) != 
/* 6750 */         -1)
/*      */       {
/* 6752 */         return ((
/* 6752 */           paramObject = getString(paramObject, "text", null)) != null) && 
/* 6752 */           (paramObject.length() > this) && (Character.toUpperCase(paramObject.charAt(this)) == paramInt1);
/*      */       }
/*      */ 
/*      */     }
/*      */ 
/* 6757 */     return false;
/*      */   }
/*      */ 
/*      */   public void putProperty(Object paramObject1, Object paramObject2, Object paramObject3)
/*      */   {
/* 6792 */     this = get(paramObject1, ":bind");
/* 6793 */     if (paramObject3 != null) {
/* 6794 */       if (this == null) {
/* 6795 */         set(paramObject1, ":bind", this = new Hashtable());
/*      */       }
/* 6797 */       ((Hashtable)this).put(paramObject2, paramObject3); return;
/* 6798 */     }if (this != null)
/* 6799 */       ((Hashtable)this).remove(paramObject2);
/*      */   }
/*      */ 
/*      */   public Object getProperty(Object paramObject1, Object paramObject2)
/*      */   {
/* 6815 */     if ((
/* 6815 */       this = get(paramObject1, ":bind")) != null)
/* 6815 */       return ((Hashtable)this).get(paramObject2); return null;
/*      */   }
/*      */ 
/*      */   public Object parse(String path)
/*      */     throws IOException
/*      */   {
/* 6831 */     return parse(path, this);
/*      */   }
/*      */ 
/*      */   public Object parse(String paramString, Object paramObject)
/*      */     throws IOException
/*      */   {
/* 6848 */     InputStream localInputStream = null;
/*      */     try
/*      */     {
/* 6851 */       if ((
/* 6851 */         localInputStream = getClass().getResourceAsStream(paramString)) == null)
/*      */         try
/*      */         {
/* 6853 */           localInputStream = new URL(paramString).openStream();
/*      */         }
/*      */         catch (MalformedURLException localMalformedURLException)
/*      */         {
/*      */         }
/*      */     }
/*      */     catch (Throwable localThrowable)
/*      */     {
/*      */     }
/* 6862 */     return parse(localInputStream, paramObject);
/*      */   }
/*      */ 
/*      */   public Object parse(InputStream inputstream)
/*      */     throws IOException
/*      */   {
/* 6874 */     return parse(inputstream, this);
/*      */   }
/*      */ 
/*      */   public Object parse(InputStream inputstream, Object handler)
/*      */     throws IOException
/*      */   {
/* 6889 */     return parse(inputstream, 'T', handler);
/*      */   }
/*      */ 
/*      */   public void setResourceBundle(ResourceBundle resourcebundle)
/*      */   {
/* 7014 */     this._resourcebundle = resourcebundle;
/*      */   }
/*      */ 
/*      */   private Object parse(InputStream paramInputStream, char paramChar, Object paramObject)
/*      */     throws IOException
/*      */   {
/* 7029 */     paramInputStream = new BufferedReader(new InputStreamReader(paramInputStream));
/*      */     try
/*      */     {
/* 7032 */       paramChar = null;
/* 7033 */       Object localObject1 = null;
/* 7034 */       Vector localVector = null;
/*      */ 
/* 7036 */       StringBuffer localStringBuffer1 = new StringBuffer();
/* 7037 */       for (int i = paramInputStream.read(); i != -1; )
/*      */       {
/* 7039 */         if (i == 60) {
/* 7040 */           if ((i = paramInputStream.read()) == 47) {
/* 7041 */             if ((localStringBuffer1.length() > 0) && (localStringBuffer1.charAt(localStringBuffer1.length() - 1) == ' '))
/*      */             {
/* 7043 */               localStringBuffer1.setLength(localStringBuffer1.length() - 1);
/*      */             }
/*      */ 
/* 7046 */             if (localStringBuffer1.length() > 0) {
/* 7047 */               localStringBuffer1.setLength(0);
/*      */             }
/*      */ 
/* 7055 */             String str2 = (String)paramChar[2];
/* 7056 */             for (int m = 0; m < str2.length(); m++)
/*      */             {
/* 7060 */               if (paramInputStream.read() != str2.charAt(m)) {
/* 7061 */                 throw new IllegalArgumentException(str2);
/*      */               }
/*      */             }
/* 7064 */             while (" \t\n\r".indexOf(i = paramInputStream.read()) != -1);
/* 7067 */             if (i != 62) {
/* 7068 */               throw new IllegalArgumentException();
/*      */             }
/* 7070 */             if (paramChar[0] == null)
/*      */             {
/* 7074 */               paramInputStream.close();
/* 7075 */               finishParse(localVector, localObject1, paramObject);
/* 7076 */               Object localObject2 = localObject1;
/*      */               return localObject2;
/*      */             }
/* 7078 */             i = paramInputStream.read();
/* 7079 */             localObject1 = paramChar[0];
/* 7080 */             paramChar = (Object[])paramChar[1];
/* 7081 */             continue; } if (i == 33) {
/* 7082 */             while (paramInputStream.read() != 62);
/* 7085 */             i = paramInputStream.read(); continue;
/*      */           }
/* 7087 */           localStringBuffer1.setLength(0);
/* 7088 */           int k = 0;
/*      */           int n;
/* 7089 */           while (">/ \t\n\r".indexOf(i) == -1)
/*      */           {
/* 7092 */             localStringBuffer1.append((char)i);
/* 7093 */             if ((localStringBuffer1.length() == 3) && (localStringBuffer1.charAt(0) == '!') && (localStringBuffer1.charAt(1) == '-') && (localStringBuffer1.charAt(2) == '-'))
/*      */             {
/* 7097 */               n = 0;
/*      */               while (true)
/*      */               {
/* 7100 */                 if ((
/* 7100 */                   i = paramInputStream.read()) == 
/* 7100 */                   45) {
/* 7101 */                   n++; continue;
/* 7102 */                 }if ((i == 62) && (n >= 2)) break;
/* 7103 */                 n = 0;
/*      */               }
/*      */ 
/* 7108 */               k = 1;
/*      */             }
/* 7110 */             i = paramInputStream.read();
/*      */           }
/* 7112 */           if (k == 0) {
/* 7113 */             if (localStringBuffer1.length() == 0)
/*      */             {
/* 7116 */               throw new IllegalArgumentException();
/*      */             }
/* 7118 */             n = localStringBuffer1.charAt(0) == '?' ? 1 : 0;
/*      */ 
/* 7120 */             String str3 = localStringBuffer1.toString();
/* 7121 */             if (n == 0) {
/* 7122 */               paramChar = new Object[] { localObject1, paramChar, str3 };
/*      */ 
/* 7124 */               Object localObject5 = str3; Object localObject3 = localObject1; localObject1 = this; localObject5 = create((String)localObject5); ((Thinlet)localObject1).addImpl(localObject3, localObject5, -1); localObject1 = localObject1 != null ? localObject5 : create(str3);
/*      */             }
/*      */ 
/* 7128 */             localStringBuffer1.setLength(0);
/*      */             while (true)
/*      */             {
/* 7142 */               int i1 = 0;
/* 7143 */               while (" \t\n\r".indexOf(i) != -1)
/*      */               {
/* 7145 */                 i = paramInputStream.read();
/* 7146 */                 i1 = 1;
/*      */               }
/* 7148 */               if ((n != 0) && (i == 63))
/*      */               {
/* 7150 */                 if (paramInputStream.read() == 62) break;
/* 7151 */                 throw new IllegalArgumentException();
/*      */               }
/*      */               else {
/* 7154 */                 if (i == 62)
/*      */                   break;
/*      */                 Object localObject4;
/* 7155 */                 if (i == 47)
/*      */                 {
/* 7161 */                   if (paramInputStream.read() != 62) {
/* 7162 */                     throw new IllegalArgumentException();
/*      */                   }
/*      */ 
/* 7165 */                   if (paramChar[0] == null)
/*      */                   {
/* 7172 */                     paramInputStream.close();
/* 7173 */                     finishParse(localVector, localObject1, paramObject);
/* 7174 */                     localObject4 = localObject1;
/*      */                     return localObject4;
/*      */                   }
/* 7176 */                   localObject1 = paramChar[0];
/* 7177 */                   paramChar = (Object[])paramChar[1]; } else {
/* 7178 */                   if (localObject4 != 0) {
/* 7179 */                     while ("= \t\n\r".indexOf(i) == -1)
/*      */                     {
/* 7183 */                       localStringBuffer1.append((char)i);
/* 7184 */                       i = paramInputStream.read();
/*      */                     }
/* 7186 */                     localObject4 = localStringBuffer1.toString();
/* 7187 */                     localStringBuffer1.setLength(0);
/* 7188 */                     while (" \t\n\r".indexOf(i) != -1) {
/* 7189 */                       i = paramInputStream.read();
/*      */                     }
/* 7191 */                     if (i != 61) {
/* 7192 */                       throw new IllegalArgumentException();
/*      */                     }
/*      */ 
/* 7195 */                     while (" \t\n\r".indexOf(i = paramInputStream.read()) != -1);
/* 7198 */                     int i2 = (char)i;
/* 7199 */                     if ((i != 34) && (i != 39)) {
/* 7200 */                       throw new IllegalArgumentException();
/*      */                     }
/* 7202 */                     while (i2 != (i = paramInputStream.read()))
/*      */                     {
/*      */                       String str1;
/* 7203 */                       if (i == 38) {
/* 7204 */                         StringBuffer localStringBuffer2 = new StringBuffer();
/*      */ 
/* 7206 */                         while (59 != (i = paramInputStream.read())) {
/* 7207 */                           localStringBuffer2.append((char)i);
/*      */                         }
/* 7209 */                         str1 = localStringBuffer2.toString();
/* 7210 */                         if ("lt".equals(str1)) {
/* 7211 */                           localStringBuffer1.append('<'); continue;
/* 7212 */                         }if ("gt".equals(str1)) {
/* 7213 */                           localStringBuffer1.append('>'); continue;
/* 7214 */                         }if ("amp".equals(str1)) {
/* 7215 */                           localStringBuffer1.append('&'); continue;
/* 7216 */                         }if ("quot".equals(str1)) {
/* 7217 */                           localStringBuffer1.append('"'); continue;
/* 7218 */                         }if ("apos".equals(str1)) {
/* 7219 */                           localStringBuffer1.append('\''); continue;
/* 7220 */                         }if (str1.startsWith("#")) {
/* 7221 */                           int i3 = str1.charAt(1) == 'x' ? 1 : 0;
/*      */ 
/* 7223 */                           localStringBuffer1.append((char)Integer.parseInt(str1.substring(i3 != 0 ? 2 : 1), i3 != 0 ? 16 : 10));
/*      */ 
/* 7228 */                           continue;
/* 7229 */                         }throw new IllegalArgumentException("unknown entity " + str1);
/*      */                       }
/*      */ 
/* 7233 */                       localStringBuffer1.append((char)str1);
/*      */                     }
/*      */ 
/* 7237 */                     if (n != 0) {
/* 7238 */                       if (("?xml".equals(str3)) && ("encoding".equals(localObject4)))
/*      */                         try
/*      */                         {
/* 7241 */                           String str4 = localStringBuffer1.toString();
/* 7242 */                           new String(new byte[0], 0, 0, str4);
/*      */ 
/* 7244 */                           new String(str4);
/*      */                         } catch (UnsupportedEncodingException localUnsupportedEncodingException) {
/* 7246 */                           System.err.println(localUnsupportedEncodingException.getMessage());
/*      */                         }
/*      */                     }
/*      */                     else {
/* 7250 */                       localVector = addAttribute$294bf8b9(localObject1, (String)localObject4, localStringBuffer1.toString(), localVector);
/*      */                     }
/*      */ 
/* 7255 */                     localStringBuffer1.setLength(0);
/*      */ 
/* 7267 */                     j = paramInputStream.read();
/* 7268 */                     continue;
/*      */                   }
/* 7270 */                   throw new IllegalArgumentException();
/*      */                 }
/*      */               }
/*      */             }
/* 7272 */             j = paramInputStream.read();
/* 7273 */             continue;
/*      */           }
/*      */         }
/*      */ 
/* 7277 */         if (" \t\n\r".indexOf(j) != -1) {
/* 7278 */           if ((localStringBuffer1.length() > 0) && (localStringBuffer1.charAt(localStringBuffer1.length() - 1) != ' '))
/*      */           {
/* 7280 */             localStringBuffer1.append(' ');
/*      */           }
/*      */         }
/* 7283 */         else localStringBuffer1.append((char)j);
/*      */ 
/* 7285 */         int j = paramInputStream.read();
/*      */       }
/*      */ 
/* 7288 */       throw new IllegalArgumentException();
/*      */     }
/*      */     finally {
/* 7291 */       paramInputStream.close(); } throw this;
/*      */   }
/*      */ 
/*      */   private void finishParse(Vector paramVector, Object paramObject1, Object paramObject2)
/*      */   {
/* 7304 */     if (paramVector != null)
/* 7305 */       for (int i = 0; i < paramVector.size(); i += 3) {
/* 7306 */         Object localObject1 = paramVector.elementAt(i);
/* 7307 */         Object[] arrayOfObject = (Object[])paramVector.elementAt(i + 1);
/* 7308 */         String str = (String)paramVector.elementAt(i + 2);
/*      */         Object localObject2;
/* 7310 */         if ("method".equals(arrayOfObject[0])) {
/* 7311 */           localObject2 = getMethod(localObject1, str, paramObject1, paramObject2);
/*      */ 
/* 7313 */           if ("init".equals(arrayOfObject[1]))
/* 7314 */             invokeImpl(localObject2, null);
/*      */           else {
/* 7316 */             set(localObject1, arrayOfObject[1], localObject2);
/*      */           }
/*      */         }
/*      */         else
/*      */         {
/* 7321 */           if ((
/* 7321 */             localObject2 = find(paramObject1, str)) == null)
/*      */           {
/* 7322 */             throw new IllegalArgumentException(str + " not found");
/*      */           }
/*      */ 
/* 7325 */           set(localObject1, arrayOfObject[1], localObject2);
/*      */         }
/*      */       }
/*      */   }
/*      */ 
/*      */   private void addImpl(Object paramObject1, Object paramObject2, int paramInt)
/*      */   {
/* 7341 */     String str1 = getClass(paramObject1);
/* 7342 */     String str2 = getClass(paramObject2);
/* 7343 */     if ((("combobox".equals(str1)) && ("choice".equals(str2))) || (("tabbedpane".equals(str1)) && ("tab".equals(str2))) || (("list".equals(str1)) && ("item".equals(str2))) || (("table".equals(str1)) && ("row".equals(str2))) || (("header".equals(str1)) && ("column".equals(str2))) || (("row".equals(str1)) && ("cell".equals(str2))) || (((!"tree".equals(str1)) && (!"node".equals(str1))) || (("node".equals(str2)) || (("menubar".equals(str1)) && ("menu".equals(str2))) || (((!"menu".equals(str1)) && (!"popupmenu".equals(str1))) || (("menu".equals(str2)) || ("menuitem".equals(str2)) || ("checkboxmenuitem".equals(str2)) || ("separator".equals(str2)) || ((("panel".equals(str1)) || ("desktop".equals(str1)) || ("splitpane".equals(str1)) || ("dialog".equals(str1)) || ("tab".equals(str1))) && (instance(str2, "component")) && (!"popupmenu".equals(str2))))))))
/*      */     {
/* 7373 */       insertItem(paramObject1, ":comp", paramObject2, paramInt);
/* 7374 */       set(paramObject2, ":parent", paramObject1); return;
/* 7375 */     }if ((("table".equals(str1)) && ("header".equals(str2))) || (("popupmenu".equals(str2)) && (instance(str1, "component"))))
/*      */     {
/* 7378 */       set(paramObject1, str2, paramObject2);
/* 7379 */       set(paramObject2, ":parent", paramObject1); return;
/*      */     }
/* 7381 */     throw new IllegalArgumentException(str2 + " add " + str1);
/*      */   }
/*      */ 
/*      */   private boolean instance(Object paramObject1, Object paramObject2)
/*      */   {
/* 7388 */     if (paramObject1 == paramObject2) {
/* 7389 */       return true;
/*      */     }
/* 7391 */     for (int i = 0; ; i += 3) { if (i >= _dtd.length) break label45; if (paramObject1 == _dtd[i]) {
/* 7393 */         paramObject1 = _dtd[(i + 1)]; this = this; break;
/*      */       }
/*      */     }
/* 7396 */     label45: return false;
/*      */   }
/*      */ 
/*      */   private Vector addAttribute$294bf8b9(Object paramObject, String paramString1, String paramString2, Vector paramVector)
/*      */     throws UnsupportedEncodingException
/*      */   {
/* 7415 */     if ((this._resourcebundle != null) && (paramString2.startsWith("i18n.")))
/* 7416 */       paramString2 = this._resourcebundle.getString(paramString2.substring(5));
/*      */     Object localObject;
/* 7421 */     paramString1 = (String)(
/* 7421 */       localObject = getDefinition(getClass(paramObject), paramString1, null))[
/* 7421 */       1];
/* 7422 */     if ("string".equals(localObject[0]))
/*      */     {
/* 7425 */       paramString1 = paramString2; paramObject = paramString1; set(this = paramObject, paramObject, paramString1);
/* 7426 */     } else if ("choice".equals(localObject[0])) {
/* 7427 */       localObject = (String[])localObject[3];
/* 7428 */       setChoice(paramObject, paramString1, paramString2, localObject, localObject[0]);
/* 7429 */     } else if ("boolean".equals(localObject[0])) {
/* 7430 */       if ("true".equals(paramString2)) {
/* 7431 */         if (localObject[3] == Boolean.FALSE)
/* 7432 */           set(paramObject, paramString1, Boolean.TRUE);
/*      */       }
/* 7434 */       else if ("false".equals(paramString2)) {
/* 7435 */         if (localObject[3] == Boolean.TRUE)
/* 7436 */           set(paramObject, paramString1, Boolean.FALSE);
/*      */       }
/*      */       else
/* 7439 */         throw new IllegalArgumentException(paramString2);
/*      */     }
/* 7441 */     else if ("integer".equals(localObject[0])) {
/* 7442 */       set(paramObject, paramString1, Integer.valueOf(paramString2));
/* 7443 */     } else if ("icon".equals(localObject[0])) {
/* 7444 */       set(paramObject, paramString1, getIcon(paramString2));
/* 7445 */     } else if (("method".equals(localObject[0])) || ("component".equals(localObject[0])))
/*      */     {
/* 7447 */       if (paramVector == null) {
/* 7448 */         paramVector = new Vector();
/*      */       }
/* 7450 */       paramVector.addElement(paramObject);
/* 7451 */       paramVector.addElement(localObject);
/* 7452 */       paramVector.addElement(paramString2);
/*      */     }
/*      */     else
/*      */     {
/*      */       int k;
/* 7453 */       if ("property".equals(localObject[0])) {
/* 7454 */         localObject = new StringTokenizer(paramString2, ";");
/* 7455 */         while (((StringTokenizer)localObject).hasMoreTokens())
/*      */         {
/*      */           String str1;
/* 7458 */           if ((
/* 7458 */             k = (
/* 7457 */             str1 = ((StringTokenizer)localObject).nextToken())
/* 7457 */             .indexOf('=')) == 
/* 7458 */             -1) {
/* 7459 */             throw new IllegalArgumentException(str1);
/*      */           }
/* 7461 */           putProperty(paramObject, new String(str1.substring(0, k)), new String(str1.substring(k + 1)));
/*      */         }
/*      */ 
/*      */       }
/* 7465 */       else if ("font".equals(localObject[0])) {
/* 7466 */         localObject = null;
/* 7467 */         int j = 0;
/* 7468 */         k = 0;
/* 7469 */         int m = 0;
/* 7470 */         paramString2 = new StringTokenizer(paramString2);
/* 7471 */         while (paramString2.hasMoreTokens()) {
/* 7472 */           String str2 = paramString2.nextToken();
/* 7473 */           if ("bold".equalsIgnoreCase(str2)) {
/* 7474 */             j = 1; continue;
/* 7475 */           }if ("italic".equalsIgnoreCase(str2)) {
/* 7476 */             k = 1; continue;
/*      */           }
/*      */           try {
/* 7479 */             m = Integer.parseInt(str2);
/*      */           } catch (NumberFormatException localNumberFormatException) {
/* 7481 */             localObject = (String)localObject + " " + str2;
/*      */           }
/*      */ 
/*      */         }
/*      */ 
/* 7487 */         if (localObject == null) {
/* 7488 */           localObject = this._font.getName();
/*      */         }
/* 7490 */         if (m == 0) {
/* 7491 */           m = this._font.getSize();
/*      */         }
/* 7493 */         set(paramObject, paramString1, new Font((String)localObject, (j != 0 ? 1 : 0) | (k != 0 ? 2 : 0), m));
/*      */       }
/*      */       else
/*      */       {
/*      */         int i;
/* 7495 */         if ("color".equals(localObject[0])) {
/* 7496 */           if (paramString2.startsWith("#"))
/*      */           {
/* 7498 */             i = Integer.parseInt(paramString2.substring(1), 16);
/* 7499 */           } else if (paramString2.startsWith("0x")) {
/* 7500 */             i = Integer.parseInt(paramString2.substring(2), 16);
/*      */           } else {
/* 7502 */             StringTokenizer localStringTokenizer = new StringTokenizer(paramString2, " \r\n\t,");
/*      */ 
/* 7504 */             i = 0xFF000000 | (Integer.parseInt(localStringTokenizer.nextToken()) & 0xFF) << 16 | (Integer.parseInt(localStringTokenizer.nextToken()) & 0xFF) << 8 | Integer.parseInt(localStringTokenizer.nextToken()) & 0xFF;
/*      */           }
/*      */ 
/* 7510 */           set(paramObject, paramString1, new Color(i));
/* 7511 */         } else if ("keystroke".equals(i[0])) {
/* 7512 */           setKeystrokeImpl(paramObject, paramString1, paramString2);
/*      */         }
/*      */         else
/*      */         {
/*      */           Component localComponent;
/* 7513 */           if ("bean".equals(i[0]))
/*      */             try {
/* 7515 */               localComponent = (Component)Class.forName(paramString2).newInstance();
/*      */ 
/* 7517 */               set(paramObject, paramString1, localComponent);
/*      */             } catch (Exception localException) {
/* 7519 */               throw new IllegalArgumentException(paramString2);
/*      */             }
/*      */           else
/* 7522 */             throw new IllegalArgumentException((String)localComponent[0]); 
/*      */         }
/*      */       }
/*      */     }
/* 7524 */     return (Vector)paramVector;
/*      */   }
/*      */ 
/*      */   private static Object[] getDefinition(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7532 */     Object localObject1 = paramObject;
/* 7533 */     label130: while (paramObject != null) {
/* 7534 */       for (int i = 0; ; i += 3) { if (i >= _dtd.length) break label130; if (_dtd[i] != paramObject)
/*      */           continue;
/* 7537 */         if ((
/* 7537 */           paramObject = (Object[][])_dtd[(i + 2)]) != null)
/*      */         {
/* 7538 */           paramObject = paramObject; int j = paramObject.length; for (int k = 0; k < j; k++)
/*      */           {
/*      */             Object localObject2;
/* 7539 */             if ((
/* 7539 */               localObject2 = paramObject[k])[
/* 7539 */               1].equals(paramString1)) {
/* 7540 */               if ((paramString2 != null) && (paramString2 != localObject2[0])) {
/* 7541 */                 throw new IllegalArgumentException(localObject2[0].toString());
/*      */               }
/*      */ 
/* 7544 */               return localObject2;
/*      */             }
/*      */           }
/*      */         }
/* 7548 */         paramObject = _dtd[(i + 1)];
/* 7549 */         break;
/*      */       }
/*      */     }
/*      */ 
/* 7553 */     throw new IllegalArgumentException("unknown " + paramString1 + " " + paramString2 + " for " + localObject1);
/*      */   }
/*      */ 
/*      */   public void setString(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7564 */     paramString1 = getDefinition(getClass(paramObject), paramString1, "string");
/*      */ 
/* 7566 */     String str2 = paramString2; String str1 = (String)paramString1[1]; if (set(paramString2 = paramObject, str1, str2))
/*      */     {
/* 7568 */       update(paramObject, paramString1[2]);
/*      */     }
/*      */   }
/*      */ 
/*      */   public String getString(Object paramObject, String paramString)
/*      */   {
/* 7576 */     return (String)get(paramObject, paramString, "string");
/*      */   }
/*      */ 
/*      */   public void setChoice(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7587 */     String[] arrayOfString = (String[])(
/* 7587 */       paramString1 = getDefinition(getClass(paramObject), paramString1, "choice"))[
/* 7587 */       3];
/* 7588 */     if (setChoice(paramObject, (String)paramString1[1], paramString2, arrayOfString, arrayOfString[0]))
/*      */     {
/* 7590 */       update(paramObject, paramString1[2]);
/*      */     }
/*      */   }
/*      */ 
/*      */   public String getChoice(Object paramObject, String paramString)
/*      */   {
/* 7598 */     this = getDefinition(getClass(paramObject), paramString, "choice");
/*      */ 
/* 7600 */     return getString(paramObject, (String)this[1], ((String[])this[3])[0]);
/*      */   }
/*      */ 
/*      */   public void setBoolean(Object paramObject, String paramString, boolean paramBoolean)
/*      */   {
/* 7609 */     paramString = getDefinition(getClass(paramObject), paramString, "boolean");
/*      */ 
/* 7611 */     if (setBoolean(paramObject, (String)paramString[1], paramBoolean, paramString[3] == Boolean.TRUE))
/*      */     {
/* 7613 */       update(paramObject, paramString[2]);
/*      */     }
/*      */   }
/*      */ 
/*      */   public boolean getBoolean(Object paramObject, String paramString)
/*      */   {
/* 7621 */     return get(paramObject, paramString, "boolean") == Boolean.TRUE;
/*      */   }
/*      */ 
/*      */   public void setInteger(Object paramObject, String paramString, int paramInt)
/*      */   {
/* 7629 */     paramString = getDefinition(getClass(paramObject), paramString, "integer");
/*      */ 
/* 7631 */     if (setInteger(paramObject, (String)paramString[1], paramInt, ((Integer)paramString[3]).intValue()))
/*      */     {
/* 7633 */       update(paramObject, paramString[2]);
/*      */     }
/*      */   }
/*      */ 
/*      */   public int getInteger(Object paramObject, String paramString)
/*      */   {
/* 7641 */     return ((Integer)get(paramObject, paramString, "integer")).intValue();
/*      */   }
/*      */ 
/*      */   public void setIcon(Object paramObject, String paramString, Image paramImage)
/*      */   {
/* 7650 */     paramString = getDefinition(getClass(paramObject), paramString, "icon");
/*      */ 
/* 7652 */     if (set(paramObject, paramString[1], paramImage))
/* 7653 */       update(paramObject, paramString[2]);
/*      */   }
/*      */ 
/*      */   public Image getIcon(Object component, String key)
/*      */   {
/* 7661 */     return (Image)get(component, key, "icon");
/*      */   }
/*      */ 
/*      */   public void setKeystroke(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7666 */     paramString1 = getDefinition(getClass(paramObject), paramString1, "keystroke");
/*      */ 
/* 7669 */     setKeystrokeImpl(paramObject, (String)paramString1[1], paramString2);
/* 7670 */     update(paramObject, paramString1[2]);
/*      */   }
/*      */ 
/*      */   public Component getComponent(Object component, String key)
/*      */   {
/* 7683 */     return (Component)get(component, key, "bean");
/*      */   }
/*      */ 
/*      */   public void setFont(Object component, Font font)
/*      */   {
/* 7691 */     setFont(component, "font", font);
/*      */   }
/*      */ 
/*      */   public void setFont(Object paramObject, String paramString, Font paramFont)
/*      */   {
/* 7705 */     paramString = getDefinition(getClass(paramObject), paramString, "font");
/*      */ 
/* 7707 */     if (set(paramObject, paramString[1], paramFont))
/* 7708 */       update(paramObject, paramString[2]);
/*      */   }
/*      */ 
/*      */   public Font getFont(Object component, String key)
/*      */   {
/* 7723 */     return (Font)get(component, key, "font");
/*      */   }
/*      */ 
/*      */   public void setColor(Object paramObject, String paramString, Color paramColor)
/*      */   {
/* 7744 */     paramString = getDefinition(getClass(paramObject), paramString, "color");
/*      */ 
/* 7746 */     if (set(paramObject, paramString[1], paramColor))
/* 7747 */       update(paramObject, paramString[2]);
/*      */   }
/*      */ 
/*      */   public Color getColor(Object paramObject, String paramString)
/*      */   {
/* 7763 */     return (Color)get(paramObject, paramString, "color");
/*      */   }
/*      */ 
/*      */   public void setComponent(Object paramObject, String paramString, Component paramComponent)
/*      */   {
/* 7778 */     paramString = getDefinition(getClass(paramObject), paramString, "bean");
/*      */ 
/* 7780 */     if (set(paramObject, paramString[1], paramComponent))
/* 7781 */       update(paramObject, paramString[2]);
/*      */   }
/*      */ 
/*      */   private static void setKeystrokeImpl(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7787 */     Object localObject = null;
/*      */     Long localLong;
/* 7788 */     if (paramString2 != null) {
/* 7789 */       String str = paramString2;
/*      */       try {
/* 7791 */         int i = 0; int j = 0;
/* 7792 */         paramString2 = new StringTokenizer(paramString2, " \r\n\t+");
/*      */ 
/* 7794 */         while (paramString2.hasMoreTokens()) {
/* 7795 */           str = paramString2.nextToken().toUpperCase();
/*      */           try {
/* 7797 */             j |= InputEvent.class.getField(str + "_MASK").getInt(null);
/*      */           }
/*      */           catch (Exception localException1)
/*      */           {
/* 7802 */             i = KeyEvent.class.getField("VK_" + str).getInt(null);
/*      */           }
/*      */ 
/*      */         }
/*      */ 
/* 7807 */         localLong = new Long(j << 32 | i);
/*      */       } catch (Exception localException2) {
/* 7809 */         throw new IllegalArgumentException(str);
/*      */       }
/*      */     }
/* 7812 */     set(paramObject, paramString1, localLong);
/*      */   }
/*      */ 
/*      */   public Object getWidget(Object paramObject, String paramString)
/*      */   {
/* 7818 */     if ("popupmenu".equals(paramString))
/* 7819 */       return get(paramObject, "popupmenu");
/* 7820 */     if ("header".equals(paramString)) {
/* 7821 */       return get(paramObject, "header");
/*      */     }
/* 7823 */     throw new IllegalArgumentException(paramString);
/*      */   }
/*      */ 
/*      */   private static Object get(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 7829 */     paramString1 = getDefinition(getClass(paramObject), paramString1, paramString2);
/*      */ 
/* 7832 */     if ((
/* 7832 */       paramObject = get(paramObject, paramString1[1])) != null)
/* 7832 */       return paramObject; return paramString1[3];
/*      */   }
/*      */ 
/*      */   public void setMethod(Object paramObject1, String paramString1, String paramString2, Object paramObject2, Object paramObject3)
/*      */   {
/* 7855 */     paramString1 = (String)getDefinition(getClass(paramObject1), paramString1, "method")[1];
/*      */ 
/* 7858 */     this = getMethod(paramObject1, paramString2, paramObject2, paramObject3);
/* 7859 */     set(paramObject1, paramString1, this);
/*      */   }
/*      */ 
/*      */   public Object[] getMethod(Object paramObject1, String paramString, Object paramObject2, Object paramObject3)
/*      */   {
/*      */     StringTokenizer localStringTokenizer;
/* 7878 */     String str1 = (
/* 7878 */       localStringTokenizer = new StringTokenizer(paramString, "(, \r\n\t)"))
/* 7878 */       .nextToken();
/* 7879 */     int i = localStringTokenizer.countTokens();
/* 7880 */     Object[] arrayOfObject = new Object[2 + i * 3];
/* 7881 */     Class[] arrayOfClass = i > 0 ? new Class[i] : null;
/* 7882 */     for (int j = 0; j < i; j++) {
/* 7883 */       String str2 = localStringTokenizer.nextToken();
/* 7884 */       if ("thinlet".equals(str2)) {
/* 7885 */         arrayOfObject[(2 + j * 3)] = "thinlet";
/* 7886 */         arrayOfClass[j] = Thinlet.class;
/* 7887 */       } else if ((str2.length() > 1) && (str2.charAt(0) == '\'') && (str2.charAt(str2.length() - 1) == '\''))
/*      */       {
/* 7891 */         arrayOfObject[(2 + j * 3)] = "constant";
/* 7892 */         arrayOfObject[(2 + j * 3 + 1)] = new String(str2.substring(1, str2.length() - 1));
/*      */ 
/* 7894 */         arrayOfClass[j] = String.class;
/*      */       }
/*      */       else
/*      */       {
/*      */         int k;
/* 7897 */         Object localObject1 = (
/* 7897 */           k = str2.indexOf('.')) == 
/* 7897 */           -1 ? str2 : str2.substring(0, k);
/*      */         Object localObject2;
/* 7898 */         if ("item".equals(localObject1))
/*      */         {
/* 7901 */           localObject1 = "item";
/* 7902 */           localObject2 = getClass(paramObject1);
/* 7903 */           if ("list".equals(localObject2))
/* 7904 */             localObject2 = "item";
/* 7905 */           else if ("tree".equals(localObject2))
/* 7906 */             localObject2 = "node";
/* 7907 */           else if ("table".equals(localObject2))
/* 7908 */             localObject2 = "row";
/* 7909 */           else if ("combobox".equals(localObject2))
/* 7910 */             localObject2 = "choice";
/* 7911 */           else if ("tabbedpane".equals(localObject2))
/* 7912 */             localObject2 = "tab";
/*      */           else {
/* 7914 */             throw new IllegalArgumentException((String)localObject2 + " has no item");
/*      */           }
/*      */         }
/* 7917 */         else if ("this".equals(localObject1))
/*      */         {
/* 7919 */           localObject2 = getClass(localObject1 = paramObject1);
/*      */         }
/* 7920 */         else if ((localObject1 = find(paramObject2, (String)localObject1)) != null)
/*      */         {
/* 7923 */           localObject2 = getClass(localObject1);
/*      */         } else {
/*      */           try {
/* 7926 */             if (str2.regionMatches(true, str2.length() - 1, "F", 0, 1))
/*      */             {
/* 7928 */               arrayOfObject[(2 + j * 3 + 1)] = Float.valueOf(str2.substring(0, str2.length() - 1));
/*      */ 
/* 7931 */               arrayOfClass[j] = Float.TYPE;
/* 7932 */             } else if (str2.regionMatches(true, str2.length() - 1, "L", 0, 1))
/*      */             {
/* 7934 */               arrayOfObject[(2 + j * 3 + 1)] = Long.valueOf(str2.substring(0, str2.length() - 1));
/*      */ 
/* 7937 */               arrayOfClass[j] = Long.TYPE;
/* 7938 */             } else if (k != -1) {
/* 7939 */               arrayOfObject[(2 + j * 3 + 1)] = Double.valueOf(str2);
/* 7940 */               arrayOfClass[j] = Double.TYPE;
/*      */             } else {
/* 7942 */               arrayOfObject[(2 + j * 3 + 1)] = Integer.valueOf(str2);
/* 7943 */               arrayOfClass[j] = Integer.TYPE;
/*      */             }
/* 7945 */             arrayOfObject[(2 + j * 3)] = "constant";
/*      */           }
/*      */           catch (NumberFormatException localNumberFormatException)
/*      */           {
/* 7950 */             throw new IllegalArgumentException("unknown " + str2);
/*      */           }
/*      */         }
/*      */ 
/* 7954 */         arrayOfObject[(2 + j * 3)] = localObject1;
/* 7955 */         if (k == -1) {
/* 7956 */           arrayOfClass[j] = Object.class;
/*      */         } else {
/* 7958 */           localObject2 = getDefinition(localObject2, str2.substring(k + 1), null);
/*      */ 
/* 7961 */           arrayOfObject[(2 + j * 3 + 1)] = localObject2[1];
/*      */ 
/* 7963 */           arrayOfObject[(2 + j * 3 + 2)] = localObject2[3];
/*      */ 
/* 7965 */           str2 = localObject2[0];
/* 7966 */           if (("string".equals(str2)) || ("choice".equals(str2)))
/*      */           {
/* 7968 */             arrayOfClass[j] = String.class;
/* 7969 */           } else if ("boolean".equals(str2))
/* 7970 */             arrayOfClass[j] = Boolean.TYPE;
/* 7971 */           else if ("integer".equals(str2))
/* 7972 */             arrayOfClass[j] = Integer.TYPE;
/* 7973 */           else if ("icon".equals(str2))
/* 7974 */             arrayOfClass[j] = Image.class;
/*      */           else {
/* 7976 */             throw new IllegalArgumentException((String)str2);
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */ 
/* 7982 */     arrayOfObject[0] = paramObject3;
/*      */     try {
/* 7984 */       arrayOfObject[1] = paramObject3.getClass().getMethod(str1, arrayOfClass);
/*      */ 
/* 7986 */       return arrayOfObject; } catch (Exception localException) {
/*      */     }
/* 7988 */     throw new IllegalArgumentException(paramString + " " + localException.getMessage());
/*      */   }
/*      */ 
/*      */   private void update(Object paramObject1, Object paramObject2)
/*      */   {
/* 7994 */     if ("parent".equals(paramObject2)) {
/* 7995 */       paramObject1 = getParent(paramObject1);
/* 7996 */       paramObject2 = "validate";
/*      */     }
/* 7998 */     int i = 1;
/* 7999 */     int j = 0;
/* 8000 */     int k = 0;
/* 8001 */     int m = 0;
/* 8002 */     int n = 0;
/* 8003 */     while ((paramObject1 != null) && 
/* 8004 */       (getBoolean(paramObject1, "visible", true)))
/*      */     {
/*      */       Object localObject;
/* 8005 */       if ("paint".equals(paramObject2))
/*      */       {
/* 8011 */         if ((
/* 8011 */           localObject = getRectangle(paramObject1, "bounds")) == null)
/*      */         {
/* 8012 */           return;
/*      */         }
/* 8014 */         if (i != 0) {
/* 8015 */           j = ((Rectangle)localObject).x;
/* 8016 */           k = ((Rectangle)localObject).y;
/* 8017 */           m = Math.abs(((Rectangle)localObject).width);
/* 8018 */           n = ((Rectangle)localObject).height;
/* 8019 */           i = 0;
/*      */         } else {
/* 8021 */           j += ((Rectangle)localObject).x;
/* 8022 */           k += ((Rectangle)localObject).y;
/*      */         }
/* 8024 */         if (paramObject1 == this.content) {
/* 8025 */           repaint(j, k, m, n);
/*      */         }
/*      */       }
/*      */ 
/* 8029 */       String str = getClass(localObject = getParent(paramObject1));
/*      */ 
/* 8030 */       if ("combobox".equals(str))
/* 8031 */         localObject = get(localObject, ":combolist");
/* 8032 */       else if ("menu".equals(str))
/* 8033 */         localObject = get(localObject, ":popup");
/* 8034 */       else if (("paint".equals(paramObject2)) && ("tabbedpane".equals(str)) && 
/* 8036 */           (getItem(localObject, getInteger(localObject, "selected", 0)) != paramObject1))
/*      */           break;
/* 8038 */       if (("layout".equals(paramObject2)) || (("validate".equals(paramObject2)) && (("list".equals(str)) || ("table".equals(str)) || ("tree".equals(str)) || ("dialog".equals(str)) || (localObject == this.content))))
/*      */       {
/* 8048 */         if ((
/* 8048 */           paramObject1 = getRectangle(localObject, "bounds")) == null)
/*      */         {
/* 8049 */           return;
/*      */         }
/* 8051 */         paramObject1.width = (-1 * Math.abs(paramObject1.width));
/* 8052 */         paramObject2 = "paint";
/*      */       }
/* 8054 */       paramObject1 = localObject;
/*      */     }
/*      */   }
/*      */ 
/*      */   private static String getString(Object paramObject, String paramString1, String paramString2)
/*      */   {
/* 8068 */     if ((
/* 8068 */       paramObject = get(paramObject, paramString1)) == null)
/* 8068 */       return paramString2; return (String)paramObject;
/*      */   }
/*      */ 
/*      */   private static boolean setChoice(Object paramObject, String paramString1, String paramString2, String[] paramArrayOfString, String paramString3)
/*      */   {
/* 8077 */     if (paramString2 == null) {
/* 8078 */       return set(paramObject, paramString1, paramString3);
/*      */     }
/* 8080 */     paramString3 = (paramArrayOfString = paramArrayOfString).length; for (String str1 = 0; str1 < paramString3; str1++) { String str2 = paramArrayOfString[str1];
/* 8081 */       if (paramString2.equals(str2)) {
/* 8082 */         return set(paramObject, paramString1, str2);
/*      */       }
/*      */     }
/* 8085 */     throw new IllegalArgumentException("unknown " + paramString2 + " for " + paramString1);
/*      */   }
/*      */ 
/*      */   protected static void setFocusVisible(boolean isFocusVisible)
/*      */   {
/* 8090 */     _isFocusVisible = isFocusVisible;
/*      */   }
/*      */ 
/*      */   private static Image getIcon(Object paramObject, String paramString, Image paramImage)
/*      */   {
/* 8096 */     if ((
/* 8096 */       paramObject = get(paramObject, paramString)) == null)
/* 8096 */       return null; return (Image)paramObject;
/*      */   }
/*      */ 
/*      */   private static boolean setBoolean(Object paramObject, String paramString, boolean paramBoolean1, boolean paramBoolean2)
/*      */   {
/* 8101 */     return set(paramObject, paramString, paramBoolean1 ? Boolean.TRUE : paramBoolean1 == paramBoolean2 ? null : Boolean.FALSE);
/*      */   }
/*      */ 
/*      */   private static boolean getBoolean(Object paramObject, String paramString, boolean paramBoolean)
/*      */   {
/* 8108 */     if ((
/* 8108 */       paramObject = get(paramObject, paramString)) == null)
/* 8108 */       return paramBoolean; return ((Boolean)paramObject).booleanValue();
/*      */   }
/*      */ 
/*      */   private static boolean setInteger(Object paramObject, String paramString, int paramInt1, int paramInt2)
/*      */   {
/* 8114 */     return set(paramObject, paramString, paramInt1 == paramInt2 ? null : new Integer(paramInt1));
/*      */   }
/*      */ 
/*      */   private static int getInteger(Object paramObject, String paramString, int paramInt)
/*      */   {
/* 8121 */     if ((
/* 8121 */       paramObject = get(paramObject, paramString)) == null)
/* 8121 */       return paramInt; return ((Integer)paramObject).intValue();
/*      */   }
/*      */ 
/*      */   private void setRectangle(Object paramObject, String paramString, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
/*      */   {
/* 8127 */     if ((
/* 8127 */       this = getRectangle(paramObject, paramString)) != null)
/*      */     {
/* 8128 */       this.x = paramInt1;
/* 8129 */       this.y = paramInt2;
/* 8130 */       this.width = paramInt3;
/* 8131 */       this.height = paramInt4; return;
/*      */     }
/* 8133 */     set(paramObject, paramString, new Rectangle(paramInt1, paramInt2, paramInt3, paramInt4));
/*      */   }
/*      */ 
/*      */   private static Rectangle getRectangle(Object component, String key)
/*      */   {
/* 8138 */     return (Rectangle)get(component, key);
/*      */   }
/*      */ 
/*      */   public Image getIcon(String path)
/*      */   {
/* 8152 */     return getIcon(path, true);
/*      */   }
/*      */ 
/*      */   public Image getIcon(String paramString, boolean paramBoolean)
/*      */   {
/* 8170 */     if ((paramString == null) || (paramString.length() == 0)) {
/* 8171 */       return null;
/*      */     }
/* 8173 */     Image localImage = null;
/*      */     try
/*      */     {
/*      */       URL localURL;
/* 8177 */       if ((
/* 8177 */         localURL = getClass().getResource(paramString)) != null)
/*      */       {
/* 8178 */         localImage = Toolkit.getDefaultToolkit().getImage(localURL);
/*      */       }
/*      */     }
/*      */     catch (Throwable localThrowable1)
/*      */     {
/*      */     }
/*      */     Object localObject;
/* 8182 */     if (localImage == null)
/*      */     {
/*      */       try
/*      */       {
/* 8186 */         if ((
/* 8186 */           localObject = getClass().getResourceAsStream(paramString)) != null)
/*      */         {
/* 8187 */           paramString = new byte[((InputStream)localObject).available()];
/* 8188 */           ((InputStream)localObject).read(paramString, 0, paramString.length);
/* 8189 */           localImage = getToolkit().createImage(paramString);
/* 8190 */           ((InputStream)localObject).close();
/*      */         } else {
/* 8192 */           localImage = Toolkit.getDefaultToolkit().getImage(new URL(paramString));
/*      */         }
/*      */       }
/*      */       catch (Throwable localThrowable2)
/*      */       {
/*      */       }
/*      */     }
/* 8199 */     if ((paramBoolean) && (localImage != null)) {
/* 8200 */       (
/* 8201 */         localObject = new MediaTracker(this))
/* 8201 */         .addImage(localImage, 1);
/*      */       try {
/* 8203 */         ((MediaTracker)localObject).waitForID(1, 5000L);
/*      */       }
/*      */       catch (InterruptedException localInterruptedException) {
/*      */       }
/*      */     }
/* 8208 */     return (Image)localImage;
/*      */   }
/*      */ 
/*      */   public boolean destroy()
/*      */   {
/* 8220 */     return true;
/*      */   }
/*      */ 
/*      */   static
/*      */   {
/*      */     try
/*      */     {
/*  164 */       WHEEL_MASK = AWTEvent.class.getField("MOUSE_WHEEL_EVENT_MASK").getLong(null);
/*      */ 
/*  167 */       MOUSE_WHEEL = MouseEvent.class.getField("MOUSE_WHEEL").getInt(null);
/*      */ 
/*  170 */       localObject = Class.forName("java.awt.RenderingHints");
/*  171 */       TXT_AA = new Object[] { ((Class)localObject).getField("KEY_TEXT_ANTIALIASING").get(null), ((Class)localObject).getField("VALUE_TEXT_ANTIALIAS_ON").get(null) };
/*      */ 
/*  177 */       G_AA = new Object[] { ((Class)localObject).getField("KEY_ANTIALIASING").get(null), ((Class)localObject).getField("VALUE_ANTIALIAS_ON").get(null) };
/*      */     }
/*      */     catch (Exception localException1)
/*      */     {
/*      */     }
/*      */ 
/*      */     try
/*      */     {
/*  188 */       if ((System.getProperty("java.vendor").indexOf("Insignia") != -1) && (System.getProperty("os.name").indexOf("Windows CE") == -1))
/*      */       {
/*  190 */         evm = -1;
/*      */       }
/*      */ 
/*      */     }
/*      */     catch (Exception localException2)
/*      */     {
/*      */     }
/*      */ 
/* 8225 */     Object localObject = Integer.valueOf(-1);
/* 8226 */     Integer localInteger1 = Integer.valueOf(0);
/* 8227 */     Integer localInteger2 = Integer.valueOf(1);
/* 8228 */     String[] arrayOfString1 = { "horizontal", "vertical" };
/*      */ 
/* 8230 */     String[] arrayOfString2 = { "left", "center", "right" };
/*      */ 
/* 8232 */     String[] arrayOfString3 = { "single", "interval", "multiple" };
/* 8233 */     _dtd = new Object[] { "component", null, { { "string", "name", null, null }, { "boolean", "enabled", "paint", Boolean.TRUE }, { "boolean", "visible", "parent", Boolean.TRUE }, { "string", "tooltip", null, null }, { "font", "font", "validate", null }, { "color", "foreground", "paint", null }, { "color", "background", "paint", null }, { "integer", "width", "validate", localInteger1 }, { "integer", "height", "validate", localInteger1 }, { "integer", "colspan", "validate", localInteger2 }, { "integer", "rowspan", "validate", localInteger2 }, { "integer", "weightx", "validate", localInteger1 }, { "integer", "weighty", "validate", localInteger1 }, { "choice", "halign", "validate", { "fill", "center", "left", "right" } }, { "choice", "valign", "validate", { "fill", "center", "top", "bottom" } }, { "property", "property", null, null }, { "method", "init" }, { "method", "focuslost" }, { "method", "focusgained" } }, "label", "component", { { "string", "text", "validate", null }, { "icon", "icon", "validate", null }, { "choice", "alignment", "validate", arrayOfString2 }, { "integer", "mnemonic", "paint", localObject }, { "component", "for", null, null } }, "button", "label", { { "choice", "alignment", "validate", { "center", "left", "right" } }, { "method", "action" }, { "string", "borderType", "thick", "thick" }, { "choice", "type", "paint", { "normal", "default", "cancel", "link" } } }, "checkbox", "label", { { "boolean", "selected", "paint", Boolean.FALSE }, { "string", "group", "paint", null }, { "method", "action" } }, "togglebutton", "checkbox", null, "combobox", "textfield", { { "icon", "icon", "validate", null }, { "string", "borderType", "thin", "thin" }, { "integer", "selected", "layout", localObject } }, "choice", null, { { "string", "name", null, null }, { "boolean", "enabled", "paint", Boolean.TRUE }, { "string", "text", "parent", null }, { "icon", "icon", "parent", null }, { "choice", "alignment", "parent", arrayOfString2 }, { "string", "tooltip", null, null }, { "font", "font", "validate", null }, { "color", "foreground", "paint", null }, { "color", "background", "paint", null }, { "property", "property", null, null } }, "textfield", "component", { { "string", "text", "layout", "" }, { "integer", "columns", "validate", localInteger1 }, { "boolean", "editable", "paint", Boolean.TRUE }, { "choice", "alignment", "validate", arrayOfString2 }, { "integer", "start", "layout", localInteger1 }, { "integer", "end", "layout", localInteger1 }, { "method", "action" }, { "method", "insert" }, { "method", "remove" }, { "method", "caret" }, { "method", "perform" } }, "passwordfield", "textfield", null, "textarea", "textfield", { { "integer", "rows", "validate", localInteger1 }, { "boolean", "border", "validate", Boolean.TRUE }, { "boolean", "wrap", "layout", Boolean.FALSE } }, "tabbedpane", "component", { { "choice", "placement", "validate", { "top", "left", "bottom", "right", "stacked" } }, { "integer", "selected", "paint", localInteger1 }, { "method", "action" } }, "tab", "choice", { { "integer", "mnemonic", "paint", localObject } }, "panel", "component", { { "integer", "columns", "validate", localInteger1 }, { "integer", "top", "validate", localInteger1 }, { "integer", "left", "validate", localInteger1 }, { "integer", "bottom", "validate", localInteger1 }, { "integer", "right", "validate", localInteger1 }, { "integer", "gap", "validate", localInteger1 }, { "string", "text", "validate", null }, { "icon", "icon", "validate", null }, { "boolean", "border", "validate", Boolean.FALSE }, { "boolean", "scrollable", "validate", Boolean.FALSE } }, "desktop", "component", null, "dialog", "panel", { { "boolean", "modal", null, Boolean.FALSE }, { "boolean", "resizable", null, Boolean.FALSE }, { "boolean", "closable", "paint", Boolean.FALSE }, { "boolean", "maximizable", "paint", Boolean.FALSE }, { "boolean", "iconifiable", "paint", Boolean.FALSE } }, "spinbox", "textfield", { { "integer", "minimum", null, new Integer(-2147483648) }, { "integer", "maximum", null, new Integer(2147483647) }, { "integer", "step", null, localInteger2 }, { "integer", "value", null, localInteger1 } }, "progressbar", "component", { { "choice", "orientation", "validate", arrayOfString1 }, { "integer", "minimum", "paint", localInteger1 }, { "integer", "maximum", "paint", Integer.valueOf(100) }, { "integer", "value", "paint", localInteger1 } }, "slider", "progressbar", { { "integer", "unit", null, new Integer(5) }, { "integer", "block", null, Integer.valueOf(25) }, { "method", "action" } }, "splitpane", "component", { { "choice", "orientation", "validate", arrayOfString1 }, { "integer", "divider", "layout", localObject } }, "list", "component", { { "choice", "selection", "paint", arrayOfString3 }, { "method", "action" }, { "method", "perform" }, { "boolean", "line", "validate", Boolean.TRUE } }, "item", "choice", { { "boolean", "selected", null, Boolean.FALSE } }, "table", "list", new Object[0][], "header", null, null, "column", "choice", { { "integer", "width", null, Integer.valueOf(80) }, { "choice", "sort", null, { "none", "ascent", "descent" } } }, "row", null, { { "boolean", "selected", null, Boolean.FALSE } }, "cell", "choice", null, "tree", "list", { { "boolean", "angle", null, Boolean.FALSE }, { "method", "expand" }, { "method", "collapse" } }, "node", "choice", { { "boolean", "selected", null, Boolean.FALSE }, { "boolean", "expanded", null, Boolean.TRUE } }, "separator", "component", null, "menubar", "component", null, "menu", "choice", { { "integer", "mnemonic", "paint", localObject } }, "menuitem", "choice", { { "keystroke", "accelerator", null, null }, { "method", "action" }, { "integer", "mnemonic", "paint", localObject } }, "checkboxmenuitem", "menuitem", { { "boolean", "selected", "paint", Boolean.FALSE }, { "string", "group", "paint", null } }, "popupmenu", "component", { { "method", "menushown" } }, "bean", "component", { { "bean", "bean", null, null } } };
/*      */   }
/*      */ }

/* Location:           /home/laurent/VOTE/voting-applet.jar
 * Qualified Name:     thinlet.Thinlet
 * JD-Core Version:    0.6.0
 */